/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/position","vs/editor/common/core/offsetRange","vs/base/common/arrays","vs/base/common/strings","vs/base/common/arraysFind","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/map","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/textLength","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/positionToOffset","vs/editor/common/core/textEdit","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],ue=function(W){for(var t=[],i=0,D=W.length;i<D;i++)t[i]=se[W[i]];return t};const $e=this,Ge=typeof global=="object"?global:{};var pe;(function(W){W.global=$e;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof W.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}W.Environment=t})(pe||(pe={}));var pe;(function(W){class t{constructor(c,p,g){this.type=c,this.detail=p,this.timestamp=g}}W.LoaderEvent=t;class i{constructor(c){this._events=[new t(1,"",c)]}record(c,p){this._events.push(new t(c,p,W.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}W.LoaderEventRecorder=i;class D{record(c,p){}getEvents(){return[]}}D.INSTANCE=new D,W.NullLoaderEventRecorder=D})(pe||(pe={}));var pe;(function(W){class t{static fileUriToFilePath(D,y){if(y=decodeURI(y).replace(/%23/g,"#"),D){if(/^file:\/\/\//.test(y))return y.substr(8);if(/^file:\/\//.test(y))return y.substr(5)}else if(/^file:\/\//.test(y))return y.substr(7);return y}static startsWith(D,y){return D.length>=y.length&&D.substr(0,y.length)===y}static endsWith(D,y){return D.length>=y.length&&D.substr(D.length-y.length)===y}static containsQueryString(D){return/^[^\#]*\?/gi.test(D)}static isAbsolutePath(D){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(D)}static forEachProperty(D,y){if(D){let c;for(c in D)D.hasOwnProperty(c)&&y(c,D[c])}}static isEmpty(D){let y=!0;return t.forEachProperty(D,()=>{y=!1}),y}static recursiveClone(D){if(!D||typeof D!="object"||D instanceof RegExp||!Array.isArray(D)&&Object.getPrototypeOf(D)!==Object.prototype)return D;let y=Array.isArray(D)?[]:{};return t.forEachProperty(D,(c,p)=>{p&&typeof p=="object"?y[c]=t.recursiveClone(p):y[c]=p}),y}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(D){return t.startsWith(D,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=W.global.performance&&typeof W.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?W.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,W.Utilities=t})(pe||(pe={}));var pe;(function(W){function t(y){if(y instanceof Error)return y;const c=new Error(y.message||String(y)||"Unknown Error");return y.stack&&(c.stack=y.stack),c}W.ensureError=t;class i{static validateConfigurationOptions(c){function p(g){if(g.phase==="loading"){console.error('Loading "'+g.moduleId+'" failed'),console.error(g),console.error("Here are the modules that depend on it:"),console.error(g.neededBy);return}if(g.phase==="factory"){console.error('The factory function of "'+g.moduleId+'" has thrown an exception'),console.error(g),console.error("Here are the modules that depend on it:"),console.error(g.neededBy);return}}if(c=c||{},typeof c.baseUrl!="string"&&(c.baseUrl=""),typeof c.isBuild!="boolean"&&(c.isBuild=!1),typeof c.paths!="object"&&(c.paths={}),typeof c.config!="object"&&(c.config={}),typeof c.catchError>"u"&&(c.catchError=!1),typeof c.recordStats>"u"&&(c.recordStats=!1),typeof c.urlArgs!="string"&&(c.urlArgs=""),typeof c.onError!="function"&&(c.onError=p),Array.isArray(c.ignoreDuplicateModules)||(c.ignoreDuplicateModules=[]),c.baseUrl.length>0&&(W.Utilities.endsWith(c.baseUrl,"/")||(c.baseUrl+="/")),typeof c.cspNonce!="string"&&(c.cspNonce=""),typeof c.preferScriptTags>"u"&&(c.preferScriptTags=!1),c.nodeCachedData&&typeof c.nodeCachedData=="object"&&(typeof c.nodeCachedData.seed!="string"&&(c.nodeCachedData.seed="seed"),(typeof c.nodeCachedData.writeDelay!="number"||c.nodeCachedData.writeDelay<0)&&(c.nodeCachedData.writeDelay=1e3*7),!c.nodeCachedData.path||typeof c.nodeCachedData.path!="string")){const g=t(new Error("INVALID cached data configuration, 'path' MUST be set"));g.phase="configuration",c.onError(g),c.nodeCachedData=void 0}return c}static mergeConfigurationOptions(c=null,p=null){let g=W.Utilities.recursiveClone(p||{});return W.Utilities.forEachProperty(c,(u,a)=>{u==="ignoreDuplicateModules"&&typeof g.ignoreDuplicateModules<"u"?g.ignoreDuplicateModules=g.ignoreDuplicateModules.concat(a):u==="paths"&&typeof g.paths<"u"?W.Utilities.forEachProperty(a,(o,E)=>g.paths[o]=E):u==="config"&&typeof g.config<"u"?W.Utilities.forEachProperty(a,(o,E)=>g.config[o]=E):g[u]=W.Utilities.recursiveClone(a)}),i.validateConfigurationOptions(g)}}W.ConfigurationOptionsUtil=i;class D{constructor(c,p){if(this._env=c,this.options=i.mergeConfigurationOptions(p),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let g=this.options.nodeRequire.main.filename,u=Math.max(g.lastIndexOf("/"),g.lastIndexOf("\\"));this.options.baseUrl=g.substring(0,u+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let c=0;c<this.options.ignoreDuplicateModules.length;c++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[c]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],W.Utilities.forEachProperty(this.options.paths,(c,p)=>{Array.isArray(p)?this.sortedPathsRules.push({from:c,to:p}):this.sortedPathsRules.push({from:c,to:[p]})}),this.sortedPathsRules.sort((c,p)=>p.from.length-c.from.length)}cloneAndMerge(c){return new D(this._env,i.mergeConfigurationOptions(c,this.options))}getOptionsLiteral(){return this.options}_applyPaths(c){let p;for(let g=0,u=this.sortedPathsRules.length;g<u;g++)if(p=this.sortedPathsRules[g],W.Utilities.startsWith(c,p.from)){let a=[];for(let o=0,E=p.to.length;o<E;o++)a.push(p.to[o]+c.substr(p.from.length));return a}return[c]}_addUrlArgsToUrl(c){return W.Utilities.containsQueryString(c)?c+"&"+this.options.urlArgs:c+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(c){return this.options.urlArgs?this._addUrlArgsToUrl(c):c}_addUrlArgsIfNecessaryToUrls(c){if(this.options.urlArgs)for(let p=0,g=c.length;p<g;p++)c[p]=this._addUrlArgsToUrl(c[p]);return c}moduleIdToPaths(c){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(c))return this.isBuild()?["empty:"]:["node|"+c];let p=c,g;if(!W.Utilities.endsWith(p,".js")&&!W.Utilities.isAbsolutePath(p)){g=this._applyPaths(p);for(let u=0,a=g.length;u<a;u++)this.isBuild()&&g[u]==="empty:"||(W.Utilities.isAbsolutePath(g[u])||(g[u]=this.options.baseUrl+g[u]),!W.Utilities.endsWith(g[u],".js")&&!W.Utilities.containsQueryString(g[u])&&(g[u]=g[u]+".js"))}else!W.Utilities.endsWith(p,".js")&&!W.Utilities.containsQueryString(p)&&(p=p+".js"),g=[p];return this._addUrlArgsIfNecessaryToUrls(g)}requireToUrl(c){let p=c;return W.Utilities.isAbsolutePath(p)||(p=this._applyPaths(p)[0],W.Utilities.isAbsolutePath(p)||(p=this.options.baseUrl+p)),this._addUrlArgsIfNecessaryToUrl(p)}isBuild(){return this.options.isBuild}shouldInvokeFactory(c){return!!(!this.options.isBuild||W.Utilities.isAnonymousModule(c)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[c])}isDuplicateMessageIgnoredFor(c){return this.ignoreDuplicateModulesMap.hasOwnProperty(c)}getConfigForModule(c){if(this.options.config)return this.options.config[c]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(c){this.options.onError(c)}}W.Configuration=D})(pe||(pe={}));var pe;(function(W){class t{constructor(a){this._env=a,this._scriptLoader=null,this._callbackMap={}}load(a,o,E,d){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new y;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=a.getConfig().getOptionsLiteral();e?this._scriptLoader=new i:this._scriptLoader=new c(this._env)}else this._env.isNode?this._scriptLoader=new c(this._env):this._scriptLoader=new i;let b={callback:E,errorback:d};if(this._callbackMap.hasOwnProperty(o)){this._callbackMap[o].push(b);return}this._callbackMap[o]=[b],this._scriptLoader.load(a,o,()=>this.triggerCallback(o),e=>this.triggerErrorback(o,e))}triggerCallback(a){let o=this._callbackMap[a];delete this._callbackMap[a];for(let E=0;E<o.length;E++)o[E].callback()}triggerErrorback(a,o){let E=this._callbackMap[a];delete this._callbackMap[a];for(let d=0;d<E.length;d++)E[d].errorback(o)}}class i{attachListeners(a,o,E){let d=()=>{a.removeEventListener("load",b),a.removeEventListener("error",e)},b=m=>{d(),o()},e=m=>{d(),E(m)};a.addEventListener("load",b),a.addEventListener("error",e)}load(a,o,E,d){if(/^node\|/.test(o)){let b=a.getConfig().getOptionsLiteral(),e=p(a.getRecorder(),b.nodeRequire||W.global.nodeRequire),m=o.split("|"),_=null;try{_=e(m[1])}catch(L){d(L);return}a.enqueueDefineAnonymousModule([],()=>_),E()}else{let b=document.createElement("script");b.setAttribute("async","async"),b.setAttribute("type","text/javascript"),this.attachListeners(b,E,d);const{trustedTypesPolicy:e}=a.getConfig().getOptionsLiteral();e&&(o=e.createScriptURL(o)),b.setAttribute("src",o);const{cspNonce:m}=a.getConfig().getOptionsLiteral();m&&b.setAttribute("nonce",m),document.getElementsByTagName("head")[0].appendChild(b)}}}function D(u){const{trustedTypesPolicy:a}=u.getConfig().getOptionsLiteral();try{return(a?self.eval(a.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class y{constructor(){this._cachedCanUseEval=null}_canUseEval(a){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=D(a)),this._cachedCanUseEval}load(a,o,E,d){if(/^node\|/.test(o)){const b=a.getConfig().getOptionsLiteral(),e=p(a.getRecorder(),b.nodeRequire||W.global.nodeRequire),m=o.split("|");let _=null;try{_=e(m[1])}catch(L){d(L);return}a.enqueueDefineAnonymousModule([],function(){return _}),E()}else{const{trustedTypesPolicy:b}=a.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(o)&&o.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(a)){fetch(o).then(m=>{if(m.status!==200)throw new Error(m.statusText);return m.text()}).then(m=>{m=`${m}
//# sourceURL=${o}`,(b?self.eval(b.createScript("",m)):new Function(m)).call(self),E()}).then(void 0,d);return}try{b&&(o=b.createScriptURL(o)),importScripts(o),E()}catch(m){d(m)}}}}class c{constructor(a){this._env=a,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(a){this._didInitialize||(this._didInitialize=!0,this._fs=a("fs"),this._vm=a("vm"),this._path=a("path"),this._crypto=a("crypto"))}_initNodeRequire(a,o){const{nodeCachedData:E}=o.getConfig().getOptionsLiteral();if(!E||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const d=this,b=a("module");function e(m){const _=m.constructor;let L=function(N){try{return m.require(N)}finally{}};return L.resolve=function(N,A){return _._resolveFilename(N,m,!1,A)},L.resolve.paths=function(N){return _._resolveLookupPaths(N,m)},L.main=process.mainModule,L.extensions=_._extensions,L.cache=_._cache,L}b.prototype._compile=function(m,_){const L=b.wrap(m.replace(/^#!.*/,"")),v=o.getRecorder(),N=d._getCachedDataPath(E,_),A={filename:_};let l;try{const M=d._fs.readFileSync(N);l=M.slice(0,16),A.cachedData=M.slice(16),v.record(60,N)}catch{v.record(61,N)}const n=new d._vm.Script(L,A),s=n.runInThisContext(A),h=d._path.dirname(_),f=e(this),w=[this.exports,f,this,_,h,process,Ge,Buffer],R=s.apply(this.exports,w);return d._handleCachedData(n,L,N,!A.cachedData,o),d._verifyCachedData(n,L,N,l,o),R}}load(a,o,E,d){const b=a.getConfig().getOptionsLiteral(),e=p(a.getRecorder(),b.nodeRequire||W.global.nodeRequire),m=b.nodeInstrumenter||function(L){return L};this._init(e),this._initNodeRequire(e,a);let _=a.getRecorder();if(/^node\|/.test(o)){let L=o.split("|"),v=null;try{v=e(L[1])}catch(N){d(N);return}a.enqueueDefineAnonymousModule([],()=>v),E()}else{o=W.Utilities.fileUriToFilePath(this._env.isWindows,o);const L=this._path.normalize(o),v=this._getElectronRendererScriptPathOrUri(L),N=!!b.nodeCachedData,A=N?this._getCachedDataPath(b.nodeCachedData,o):void 0;this._readSourceAndCachedData(L,A,_,(l,n,s,h)=>{if(l){d(l);return}let f;n.charCodeAt(0)===c._BOM?f=c._PREFIX+n.substring(1)+c._SUFFIX:f=c._PREFIX+n+c._SUFFIX,f=m(f,L);const w={filename:v,cachedData:s},R=this._createAndEvalScript(a,f,w,E,d);this._handleCachedData(R,f,A,N&&!s,a),this._verifyCachedData(R,f,A,h,a)})}}_createAndEvalScript(a,o,E,d,b){const e=a.getRecorder();e.record(31,E.filename);const m=new this._vm.Script(o,E),_=m.runInThisContext(E),L=a.getGlobalAMDDefineFunc();let v=!1;const N=function(){return v=!0,L.apply(null,arguments)};return N.amd=L.amd,_.call(W.global,a.getGlobalAMDRequireFunc(),N,E.filename,this._path.dirname(E.filename)),e.record(32,E.filename),v?d():b(new Error(`Didn't receive define call in ${E.filename}!`)),m}_getElectronRendererScriptPathOrUri(a){if(!this._env.isElectronRenderer)return a;let o=a.match(/^([a-z])\:(.*)/i);return o?`file:///${(o[1].toUpperCase()+":"+o[2]).replace(/\\/g,"/")}`:`file://${a}`}_getCachedDataPath(a,o){const E=this._crypto.createHash("md5").update(o,"utf8").update(a.seed,"utf8").update(process.arch,"").digest("hex"),d=this._path.basename(o).replace(/\.js$/,"");return this._path.join(a.path,`${d}-${E}.code`)}_handleCachedData(a,o,E,d,b){a.cachedDataRejected?this._fs.unlink(E,e=>{b.getRecorder().record(62,E),this._createAndWriteCachedData(a,o,E,b),e&&b.getConfig().onError(e)}):d&&this._createAndWriteCachedData(a,o,E,b)}_createAndWriteCachedData(a,o,E,d){let b=Math.ceil(d.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,m=0,_;const L=()=>{setTimeout(()=>{_||(_=this._crypto.createHash("md5").update(o,"utf8").digest());const v=a.createCachedData();if(!(v.length===0||v.length===e||m>=5)){if(v.length<e){L();return}e=v.length,this._fs.writeFile(E,Buffer.concat([_,v]),N=>{N&&d.getConfig().onError(N),d.getRecorder().record(63,E),L()})}},b*Math.pow(4,m++))};L()}_readSourceAndCachedData(a,o,E,d){if(!o)this._fs.readFile(a,{encoding:"utf8"},d);else{let b,e,m,_=2;const L=v=>{v?d(v):--_===0&&d(void 0,b,e,m)};this._fs.readFile(a,{encoding:"utf8"},(v,N)=>{b=N,L(v)}),this._fs.readFile(o,(v,N)=>{!v&&N&&N.length>0?(m=N.slice(0,16),e=N.slice(16),E.record(60,o)):E.record(61,o),L()})}}_verifyCachedData(a,o,E,d,b){d&&(a.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(o,"utf8").digest();d.equals(e)||(b.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${E}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(E,m=>{m&&b.getConfig().onError(m)}))},Math.ceil(5e3*(1+Math.random()))))}}c._BOM=65279,c._PREFIX="(function (require, define, __filename, __dirname) { ",c._SUFFIX=`
});`;function p(u,a){if(a.__$__isRecorded)return a;const o=function(d){u.record(33,d);try{return a(d)}finally{u.record(34,d)}};return o.__$__isRecorded=!0,o}W.ensureRecordedNodeRequire=p;function g(u){return new t(u)}W.createScriptLoader=g})(pe||(pe={}));var pe;(function(W){class t{constructor(u){let a=u.lastIndexOf("/");a!==-1?this.fromModulePath=u.substr(0,a+1):this.fromModulePath=""}static _normalizeModuleId(u){let a=u,o;for(o=/\/\.\//;o.test(a);)a=a.replace(o,"/");for(a=a.replace(/^\.\//g,""),o=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;o.test(a);)a=a.replace(o,"/");return a=a.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),a}resolveModule(u){let a=u;return W.Utilities.isAbsolutePath(a)||(W.Utilities.startsWith(a,"./")||W.Utilities.startsWith(a,"../"))&&(a=t._normalizeModuleId(this.fromModulePath+a)),a}}t.ROOT=new t(""),W.ModuleIdResolver=t;class i{constructor(u,a,o,E,d,b){this.id=u,this.strId=a,this.dependencies=o,this._callback=E,this._errorback=d,this.moduleIdResolver=b,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(u,a){try{return{returnedValue:u.apply(W.global,a),producedError:null}}catch(o){return{returnedValue:null,producedError:o}}}static _invokeFactory(u,a,o,E){return u.shouldInvokeFactory(a)?u.shouldCatchError()?this._safeInvokeFunction(o,E):{returnedValue:o.apply(W.global,E),producedError:null}:{returnedValue:null,producedError:null}}complete(u,a,o,E){this._isComplete=!0;let d=null;if(this._callback)if(typeof this._callback=="function"){u.record(21,this.strId);let b=i._invokeFactory(a,this.strId,this._callback,o);d=b.producedError,u.record(22,this.strId),!d&&typeof b.returnedValue<"u"&&(!this.exportsPassedIn||W.Utilities.isEmpty(this.exports))&&(this.exports=b.returnedValue)}else this.exports=this._callback;if(d){let b=W.ensureError(d);b.phase="factory",b.moduleId=this.strId,b.neededBy=E(this.id),this.error=b,a.onError(b)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(u){return this._isComplete=!0,this.error=u,this._errorback?(this._errorback(u),!0):!1}isComplete(){return this._isComplete}}W.Module=i;class D{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(u){let a=this._strModuleIdToIntModuleId.get(u);return typeof a>"u"&&(a=this._nextId++,this._strModuleIdToIntModuleId.set(u,a),this._intModuleIdToStrModuleId[a]=u),a}getStrModuleId(u){return this._intModuleIdToStrModuleId[u]}}class y{constructor(u){this.id=u}}y.EXPORTS=new y(0),y.MODULE=new y(1),y.REQUIRE=new y(2),W.RegularDependency=y;class c{constructor(u,a,o){this.id=u,this.pluginId=a,this.pluginParam=o}}W.PluginDependency=c;class p{constructor(u,a,o,E,d=0){this._env=u,this._scriptLoader=a,this._loaderAvailableTimestamp=d,this._defineFunc=o,this._requireFunc=E,this._moduleIdProvider=new D,this._config=new W.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new p(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(u,a){let o=b=>b.replace(/\\/g,"/"),E=o(u),d=a.split(/\n/);for(let b=0;b<d.length;b++){let e=d[b].match(/(.*):(\d+):(\d+)\)?$/);if(e){let m=e[1],_=e[2],L=e[3],v=Math.max(m.lastIndexOf(" ")+1,m.lastIndexOf("(")+1);if(m=m.substr(v),m=o(m),m===E){let N={line:parseInt(_,10),col:parseInt(L,10)};return N.line===1&&(N.col-=53),N}}}throw new Error("Could not correlate define call site for needle "+u)}getBuildInfo(){if(!this._config.isBuild())return null;let u=[],a=0;for(let o=0,E=this._modules2.length;o<E;o++){let d=this._modules2[o];if(!d)continue;let b=this._buildInfoPath[d.id]||null,e=this._buildInfoDefineStack[d.id]||null,m=this._buildInfoDependencies[d.id];u[a++]={id:d.strId,path:b,defineLocation:b&&e?p._findRelevantLocationInStack(b,e):null,dependencies:m,shim:null,exports:d.exports}}return u}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new W.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=W.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(u,a){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let o=null;this._config.isBuild()&&(o=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:o,dependencies:u,callback:a}}defineModule(u,a,o,E,d,b=new t(u)){let e=this._moduleIdProvider.getModuleId(u);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(u)||console.warn("Duplicate definition of module '"+u+"'");return}let m=new i(e,u,this._normalizeDependencies(a,b),o,E,b);this._modules2[e]=m,this._config.isBuild()&&(this._buildInfoDefineStack[e]=d,this._buildInfoDependencies[e]=(m.dependencies||[]).map(_=>this._moduleIdProvider.getStrModuleId(_.id))),this._resolve(m)}_normalizeDependency(u,a){if(u==="exports")return y.EXPORTS;if(u==="module")return y.MODULE;if(u==="require")return y.REQUIRE;let o=u.indexOf("!");if(o>=0){let E=a.resolveModule(u.substr(0,o)),d=a.resolveModule(u.substr(o+1)),b=this._moduleIdProvider.getModuleId(E+"!"+d),e=this._moduleIdProvider.getModuleId(E);return new c(b,e,d)}return new y(this._moduleIdProvider.getModuleId(a.resolveModule(u)))}_normalizeDependencies(u,a){let o=[],E=0;for(let d=0,b=u.length;d<b;d++)o[E++]=this._normalizeDependency(u[d],a);return o}_relativeRequire(u,a,o,E){if(typeof a=="string")return this.synchronousRequire(a,u);this.defineModule(W.Utilities.generateAnonymousModule(),a,o,E,null,u)}synchronousRequire(u,a=new t(u)){let o=this._normalizeDependency(u,a),E=this._modules2[o.id];if(!E)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This is the first mention of this module!");if(!E.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+u+"'. This module has not been resolved completely yet.");if(E.error)throw E.error;return E.exports}configure(u,a){let o=this._config.shouldRecordStats();a?this._config=new W.Configuration(this._env,u):this._config=this._config.cloneAndMerge(u),this._config.shouldRecordStats()&&!o&&(this._recorder=null)}getConfig(){return this._config}_onLoad(u){if(this._currentAnonymousDefineCall!==null){let a=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(u),a.dependencies,a.callback,null,a.stack)}}_createLoadError(u,a){let o=this._moduleIdProvider.getStrModuleId(u),E=(this._inverseDependencies2[u]||[]).map(b=>this._moduleIdProvider.getStrModuleId(b));const d=W.ensureError(a);return d.phase="loading",d.moduleId=o,d.neededBy=E,d}_onLoadError(u,a){const o=this._createLoadError(u,a);this._modules2[u]||(this._modules2[u]=new i(u,this._moduleIdProvider.getStrModuleId(u),[],()=>{},null,null));let E=[];for(let e=0,m=this._moduleIdProvider.getMaxModuleId();e<m;e++)E[e]=!1;let d=!1,b=[];for(b.push(u),E[u]=!0;b.length>0;){let e=b.shift(),m=this._modules2[e];m&&(d=m.onDependencyError(o)||d);let _=this._inverseDependencies2[e];if(_)for(let L=0,v=_.length;L<v;L++){let N=_[L];E[N]||(b.push(N),E[N]=!0)}}d||this._config.onError(o)}_hasDependencyPath(u,a){let o=this._modules2[u];if(!o)return!1;let E=[];for(let b=0,e=this._moduleIdProvider.getMaxModuleId();b<e;b++)E[b]=!1;let d=[];for(d.push(o),E[u]=!0;d.length>0;){let e=d.shift().dependencies;if(e)for(let m=0,_=e.length;m<_;m++){let L=e[m];if(L.id===a)return!0;let v=this._modules2[L.id];v&&!E[L.id]&&(E[L.id]=!0,d.push(v))}}return!1}_findCyclePath(u,a,o){if(u===a||o===50)return[u];let E=this._modules2[u];if(!E)return null;let d=E.dependencies;if(d)for(let b=0,e=d.length;b<e;b++){let m=this._findCyclePath(d[b].id,a,o+1);if(m!==null)return m.push(u),m}return null}_createRequire(u){let a=(o,E,d)=>this._relativeRequire(u,o,E,d);return a.toUrl=o=>this._config.requireToUrl(u.resolveModule(o)),a.getStats=()=>this.getLoaderEvents(),a.hasDependencyCycle=()=>this._hasDependencyCycle,a.config=(o,E=!1)=>{this.configure(o,E)},a.__$__nodeRequire=W.global.nodeRequire,a}_loadModule(u){if(this._modules2[u]||this._knownModules2[u])return;this._knownModules2[u]=!0;let a=this._moduleIdProvider.getStrModuleId(u),o=this._config.moduleIdToPaths(a),E=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(a.indexOf("/")===-1||E.test(a))&&o.push("node|"+a);let d=-1,b=e=>{if(d++,d>=o.length)this._onLoadError(u,e);else{let m=o[d],_=this.getRecorder();if(this._config.isBuild()&&m==="empty:"){this._buildInfoPath[u]=m,this.defineModule(this._moduleIdProvider.getStrModuleId(u),[],null,null,null),this._onLoad(u);return}_.record(10,m),this._scriptLoader.load(this,m,()=>{this._config.isBuild()&&(this._buildInfoPath[u]=m),_.record(11,m),this._onLoad(u)},L=>{_.record(12,m),b(L)})}};b(null)}_loadPluginDependency(u,a){if(this._modules2[a.id]||this._knownModules2[a.id])return;this._knownModules2[a.id]=!0;let o=E=>{this.defineModule(this._moduleIdProvider.getStrModuleId(a.id),[],E,null,null)};o.error=E=>{this._config.onError(this._createLoadError(a.id,E))},u.load(a.pluginParam,this._createRequire(t.ROOT),o,this._config.getOptionsLiteral())}_resolve(u){let a=u.dependencies;if(a)for(let o=0,E=a.length;o<E;o++){let d=a[o];if(d===y.EXPORTS){u.exportsPassedIn=!0,u.unresolvedDependenciesCount--;continue}if(d===y.MODULE){u.unresolvedDependenciesCount--;continue}if(d===y.REQUIRE){u.unresolvedDependenciesCount--;continue}let b=this._modules2[d.id];if(b&&b.isComplete()){if(b.error){u.onDependencyError(b.error);return}u.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(d.id,u.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(d.id)+"' and '"+this._moduleIdProvider.getStrModuleId(u.id)+"'. The cyclic path follows:");let e=this._findCyclePath(d.id,u.id,0)||[];e.reverse(),e.push(d.id),console.warn(e.map(m=>this._moduleIdProvider.getStrModuleId(m)).join(` => 
`)),u.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[d.id]=this._inverseDependencies2[d.id]||[],this._inverseDependencies2[d.id].push(u.id),d instanceof c){let e=this._modules2[d.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,d);continue}let m=this._inversePluginDependencies2.get(d.pluginId);m||(m=[],this._inversePluginDependencies2.set(d.pluginId,m)),m.push(d),this._loadModule(d.pluginId);continue}this._loadModule(d.id)}u.unresolvedDependenciesCount===0&&this._onModuleComplete(u)}_onModuleComplete(u){let a=this.getRecorder();if(u.isComplete())return;let o=u.dependencies,E=[];if(o)for(let m=0,_=o.length;m<_;m++){let L=o[m];if(L===y.EXPORTS){E[m]=u.exports;continue}if(L===y.MODULE){E[m]={id:u.strId,config:()=>this._config.getConfigForModule(u.strId)};continue}if(L===y.REQUIRE){E[m]=this._createRequire(u.moduleIdResolver);continue}let v=this._modules2[L.id];if(v){E[m]=v.exports;continue}E[m]=null}const d=m=>(this._inverseDependencies2[m]||[]).map(_=>this._moduleIdProvider.getStrModuleId(_));u.complete(a,this._config,E,d);let b=this._inverseDependencies2[u.id];if(this._inverseDependencies2[u.id]=null,b)for(let m=0,_=b.length;m<_;m++){let L=b[m],v=this._modules2[L];v.unresolvedDependenciesCount--,v.unresolvedDependenciesCount===0&&this._onModuleComplete(v)}let e=this._inversePluginDependencies2.get(u.id);if(e){this._inversePluginDependencies2.delete(u.id);for(let m=0,_=e.length;m<_;m++)this._loadPluginDependency(u.exports,e[m])}}}W.ModuleManager=p})(pe||(pe={}));var ie,pe;(function(W){const t=new W.Environment;let i=null;const D=function(g,u,a){typeof g!="string"&&(a=u,u=g,g=null),(typeof u!="object"||!Array.isArray(u))&&(a=u,u=null),u||(u=["require","exports","module"]),g?i.defineModule(g,u,a,null,null):i.enqueueDefineAnonymousModule(u,a)};D.amd={jQuery:!0};const y=function(g,u=!1){i.configure(g,u)},c=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){y(arguments[0]);return}if(typeof arguments[0]=="string")return i.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){i.defineModule(W.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};c.config=y,c.getConfig=function(){return i.getConfig().getOptionsLiteral()},c.reset=function(){i=i.reset()},c.getBuildInfo=function(){return i.getBuildInfo()},c.getStats=function(){return i.getLoaderEvents()},c.define=D;function p(){if(typeof W.global.require<"u"||typeof require<"u"){const g=W.global.require||require;if(typeof g=="function"&&typeof g.resolve=="function"){const u=W.ensureRecordedNodeRequire(i.getRecorder(),g);W.global.nodeRequire=u,c.nodeRequire=u,c.__$__nodeRequire=u}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=c:(t.isElectronRenderer||(W.global.define=D),W.global.require=c)}W.init=p,(typeof W.global.define!="function"||!W.global.define.amd)&&(i=new W.ModuleManager(t,W.createScriptLoader(t),D,c,W.Utilities.getHighPerformanceTimestamp()),typeof W.global.require<"u"&&typeof W.global.require!="function"&&c.config(W.global.require),ie=function(){return D.apply(null,arguments)},ie.amd=D.amd,typeof doNotInitLoader>"u"&&p())})(pe||(pe={})),ie(se[75],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=i;function i(g,u,a,o){if(o=o||{},(o["vs/css"]||{}).disabled){a({});return}const d=u.toUrl(g+".css");D(g,d,()=>{a({})},b=>{typeof a.error=="function"&&a.error("Could not find "+d+".")})}function D(g,u,a,o){if(y(g,u)){a();return}c(g,u,a,o)}function y(g,u){const a=window.document.getElementsByTagName("link");for(let o=0,E=a.length;o<E;o++){const d=a[o].getAttribute("data-name"),b=a[o].getAttribute("href");if(d===g||b===u)return!0}return!1}function c(g,u,a,o){const E=document.createElement("link");E.setAttribute("rel","stylesheet"),E.setAttribute("type","text/css"),E.setAttribute("data-name",g),p(g,E,a,o),E.setAttribute("href",u),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(E)}function p(g,u,a,o){const E=()=>{u.removeEventListener("load",d),u.removeEventListener("error",b)},d=e=>{E(),a()},b=e=>{E(),o(e)};u.addEventListener("load",d),u.addEventListener("error",b)}}),ie("vs/nls",["require","exports"],function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localize=o,t.localize2=E,t.getConfiguredDefaultLocale=d,t.setPseudoTranslation=b,t.create=e,t.load=m;let i=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const D="i-default";function y(_,L){let v;return L.length===0?v=_:v=_.replace(/\{(\d+)\}/g,(N,A)=>{const l=A[0],n=L[l];let s=N;return typeof n=="string"?s=n:(typeof n=="number"||typeof n=="boolean"||n===void 0||n===null)&&(s=String(n)),s}),i&&(v="\uFF3B"+v.replace(/[aouei]/g,"$&$&")+"\uFF3D"),v}function c(_,L){let v=_[L];return v||(v=_["*"],v)?v:null}function p(_){return _.charAt(_.length-1)==="/"?_:_+"/"}async function g(_,L,v){const N=p(_)+p(L)+"vscode/"+p(v),A=await fetch(N);if(A.ok)return await A.json();throw new Error(`${A.status} - ${A.statusText}`)}function u(_){return function(L,v){const N=Array.prototype.slice.call(arguments,2);return y(_[L],N)}}function a(_){return(L,v,...N)=>({value:y(_[L],N),original:y(v,N)})}function o(_,L,...v){return y(L,v)}function E(_,L,...v){const N=y(L,v);return{value:N,original:N}}function d(_){}function b(_){i=_}function e(_,L){return{localize:u(L[_]),localize2:a(L[_]),getConfiguredDefaultLocale:L.getConfiguredDefaultLocale??(v=>{})}}function m(_,L,v,N){const A=N["vs/nls"]??{};if(!_||_.length===0)return v({localize:o,localize2:E,getConfiguredDefaultLocale:()=>A.availableLanguages?.["*"]});const l=A.availableLanguages?c(A.availableLanguages,_):null,n=l===null||l===D;let s=".nls";n||(s=s+"."+l);const h=f=>{Array.isArray(f)?(f.localize=u(f),f.localize2=a(f)):(f.localize=u(f[_]),f.localize2=a(f[_])),f.getConfiguredDefaultLocale=()=>A.availableLanguages?.["*"],v(f)};typeof A.loadBundle=="function"?A.loadBundle(_,l,(f,w)=>{f?L([_+".nls"],h):h(w)}):A.translationServiceUrl&&!n?(async()=>{try{const f=await g(A.translationServiceUrl,l,_);return h(f)}catch(f){if(!l.includes("-"))return console.error(f),L([_+".nls"],h);try{const w=l.split("-")[0],R=await g(A.translationServiceUrl,w,_);return A.availableLanguages??={},A.availableLanguages["*"]=w,h(R)}catch(w){return console.error(w),L([_+".nls"],h)}}})():L([_+s],h,f=>{if(s===".nls"){console.error("Failed trying to load default language strings",f);return}console.error(`Failed to load message bundle for language ${l}. Falling back to the default language:`,f),L([_+".nls"],h)})}}),function(){const W=globalThis.MonacoEnvironment,t=W&&W.baseUrl?W.baseUrl:"../../../";function i(o,E){if(W?.createTrustedTypesPolicy)try{return W.createTrustedTypesPolicy(o,E)}catch(d){console.warn(d);return}try{return self.trustedTypes?.createPolicy(o,E)}catch(d){console.warn(d);return}}const D=i("amdLoader",{createScriptURL:o=>o,createScript:(o,...E)=>{const d=E.slice(0,-1).join(","),b=E.pop().toString();return`(function anonymous(${d}) { ${b}
})`}});function y(){try{return(D?globalThis.eval(D.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function c(){return new Promise((o,E)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return o();const d=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(d)&&d.substring(0,globalThis.origin.length)!==globalThis.origin)&&y()){fetch(d).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${d}`,(D?globalThis.eval(D.createScript("",e)):new Function(e)).call(globalThis),o()}).then(void 0,E);return}D?importScripts(D.createScriptURL(d)):importScripts(d),o()})}function p(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:D,amdModulesPattern:/^vs\//})}function g(o){c().then(()=>{p(),require([o],function(E){setTimeout(function(){const d=E.create((b,e)=>{globalThis.postMessage(b,e)},null);for(globalThis.onmessage=b=>d.onmessage(b.data,b.ports);a.length>0;){const b=a.shift();d.onmessage(b.data,b.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&p();let u=!0;const a=[];globalThis.onmessage=o=>{if(!u){a.push(o);return}u=!1,g(o.data)}}(),ie(se[8],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MonotonousArray=void 0,t.findLast=i,t.findLastIdx=D,t.findLastMonotonous=y,t.findLastIdxMonotonous=c,t.findFirstMonotonous=p,t.findFirstIdxMonotonousOrArrLen=g,t.findFirstIdxMonotonous=u,t.findFirstMax=o,t.findLastMax=E,t.findFirstMin=d,t.findMaxIdx=b,t.mapFindFirst=e;function i(m,_){const L=D(m,_);if(L!==-1)return m[L]}function D(m,_,L=m.length-1){for(let v=L;v>=0;v--){const N=m[v];if(_(N))return v}return-1}function y(m,_){const L=c(m,_);return L===-1?void 0:m[L]}function c(m,_,L=0,v=m.length){let N=L,A=v;for(;N<A;){const l=Math.floor((N+A)/2);_(m[l])?N=l+1:A=l}return N-1}function p(m,_){const L=g(m,_);return L===m.length?void 0:m[L]}function g(m,_,L=0,v=m.length){let N=L,A=v;for(;N<A;){const l=Math.floor((N+A)/2);_(m[l])?A=l:N=l+1}return N}function u(m,_,L=0,v=m.length){const N=g(m,_,L,v);return N===m.length?-1:N}class a{static{this.assertInvariants=!1}constructor(_){this._array=_,this._findLastMonotonousLastIdx=0}findLastMonotonous(_){if(a.assertInvariants){if(this._prevFindLastPredicate){for(const v of this._array)if(this._prevFindLastPredicate(v)&&!_(v))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=_}const L=c(this._array,_,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=L+1,L===-1?void 0:this._array[L]}}t.MonotonousArray=a;function o(m,_){if(m.length===0)return;let L=m[0];for(let v=1;v<m.length;v++){const N=m[v];_(N,L)>0&&(L=N)}return L}function E(m,_){if(m.length===0)return;let L=m[0];for(let v=1;v<m.length;v++){const N=m[v];_(N,L)>=0&&(L=N)}return L}function d(m,_){return o(m,(L,v)=>-_(L,v))}function b(m,_){if(m.length===0)return-1;let L=0;for(let v=1;v<m.length;v++){const N=m[v];_(N,m[L])>0&&(L=v)}return L}function e(m,_){for(const L of m){const v=_(L);if(v!==void 0)return v}}}),ie(se[36],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.groupBy=i,t.diffSets=D,t.diffMaps=y,t.intersection=c;function i(p,g){const u=Object.create(null);for(const a of p){const o=g(a);let E=u[o];E||(E=u[o]=[]),E.push(a)}return u}function D(p,g){const u=[],a=[];for(const o of p)g.has(o)||u.push(o);for(const o of g)p.has(o)||a.push(o);return{removed:u,added:a}}function y(p,g){const u=[],a=[];for(const[o,E]of p)g.has(o)||u.push(E);for(const[o,E]of g)p.has(o)||a.push(E);return{removed:u,added:a}}function c(p,g){const u=new Set;for(const a of g)p.has(a)&&u.add(a);return u}}),ie(se[37],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function i(g,u){const a=Math.pow(10,u);return Math.round(g*a)/a}class D{constructor(u,a,o,E=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,a))|0,this.b=Math.min(255,Math.max(0,o))|0,this.a=i(Math.max(Math.min(1,E),0),3)}static equals(u,a){return u.r===a.r&&u.g===a.g&&u.b===a.b&&u.a===a.a}}t.RGBA=D;class y{constructor(u,a,o,E){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=i(Math.max(Math.min(1,a),0),3),this.l=i(Math.max(Math.min(1,o),0),3),this.a=i(Math.max(Math.min(1,E),0),3)}static equals(u,a){return u.h===a.h&&u.s===a.s&&u.l===a.l&&u.a===a.a}static fromRGBA(u){const a=u.r/255,o=u.g/255,E=u.b/255,d=u.a,b=Math.max(a,o,E),e=Math.min(a,o,E);let m=0,_=0;const L=(e+b)/2,v=b-e;if(v>0){switch(_=Math.min(L<=.5?v/(2*L):v/(2-2*L),1),b){case a:m=(o-E)/v+(o<E?6:0);break;case o:m=(E-a)/v+2;break;case E:m=(a-o)/v+4;break}m*=60,m=Math.round(m)}return new y(m,_,L,d)}static _hue2rgb(u,a,o){return o<0&&(o+=1),o>1&&(o-=1),o<1/6?u+(a-u)*6*o:o<1/2?a:o<2/3?u+(a-u)*(2/3-o)*6:u}static toRGBA(u){const a=u.h/360,{s:o,l:E,a:d}=u;let b,e,m;if(o===0)b=e=m=E;else{const _=E<.5?E*(1+o):E+o-E*o,L=2*E-_;b=y._hue2rgb(L,_,a+1/3),e=y._hue2rgb(L,_,a),m=y._hue2rgb(L,_,a-1/3)}return new D(Math.round(b*255),Math.round(e*255),Math.round(m*255),d)}}t.HSLA=y;class c{constructor(u,a,o,E){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=i(Math.max(Math.min(1,a),0),3),this.v=i(Math.max(Math.min(1,o),0),3),this.a=i(Math.max(Math.min(1,E),0),3)}static equals(u,a){return u.h===a.h&&u.s===a.s&&u.v===a.v&&u.a===a.a}static fromRGBA(u){const a=u.r/255,o=u.g/255,E=u.b/255,d=Math.max(a,o,E),b=Math.min(a,o,E),e=d-b,m=d===0?0:e/d;let _;return e===0?_=0:d===a?_=((o-E)/e%6+6)%6:d===o?_=(E-a)/e+2:_=(a-o)/e+4,new c(Math.round(_*60),m,d,u.a)}static toRGBA(u){const{h:a,s:o,v:E,a:d}=u,b=E*o,e=b*(1-Math.abs(a/60%2-1)),m=E-b;let[_,L,v]=[0,0,0];return a<60?(_=b,L=e):a<120?(_=e,L=b):a<180?(L=b,v=e):a<240?(L=e,v=b):a<300?(_=e,v=b):a<=360&&(_=b,v=e),_=Math.round((_+m)*255),L=Math.round((L+m)*255),v=Math.round((v+m)*255),new D(_,L,v,d)}}t.HSVA=c;class p{static fromHex(u){return p.Format.CSS.parseHex(u)||p.red}static equals(u,a){return!u&&!a?!0:!u||!a?!1:u.equals(a)}get hsla(){return this._hsla?this._hsla:y.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:c.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof D)this.rgba=u;else if(u instanceof y)this._hsla=u,this.rgba=y.toRGBA(u);else if(u instanceof c)this._hsva=u,this.rgba=c.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&D.equals(this.rgba,u.rgba)&&y.equals(this.hsla,u.hsla)&&c.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=p._relativeLuminanceForComponent(this.rgba.r),a=p._relativeLuminanceForComponent(this.rgba.g),o=p._relativeLuminanceForComponent(this.rgba.b),E=.2126*u+.7152*a+.0722*o;return i(E,4)}static _relativeLuminanceForComponent(u){const a=u/255;return a<=.03928?a/12.92:Math.pow((a+.055)/1.055,2.4)}getContrastRatio(u){const a=this.getRelativeLuminance(),o=u.getRelativeLuminance();return a>o?(a+.05)/(o+.05):(o+.05)/(a+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const a=this.getRelativeLuminance(),o=u.getRelativeLuminance();return a>o}isDarkerThan(u){const a=this.getRelativeLuminance(),o=u.getRelativeLuminance();return a<o}lighten(u){return new p(new y(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new p(new y(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:a,g:o,b:E,a:d}=this.rgba;return new p(new D(a,o,E,d*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new p(new D(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const a=u.rgba,o=this.rgba.a,E=a.a,d=o+E*(1-o);if(d<1e-6)return p.transparent;const b=this.rgba.r*o/d+a.r*E*(1-o)/d,e=this.rgba.g*o/d+a.g*E*(1-o)/d,m=this.rgba.b*o/d+a.b*E*(1-o)/d;return new p(new D(b,e,m,d))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:a,g:o,b:E,a:d}=this.rgba;return new p(new D(u.rgba.r-d*(u.rgba.r-a),u.rgba.g-d*(u.rgba.g-o),u.rgba.b-d*(u.rgba.b-E),1))}flatten(...u){const a=u.reduceRight((o,E)=>p._flatten(E,o));return p._flatten(this,a)}static _flatten(u,a){const o=1-u.rgba.a;return new p(new D(o*a.rgba.r+u.rgba.a*u.rgba.r,o*a.rgba.g+u.rgba.a*u.rgba.g,o*a.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this._toString||(this._toString=p.Format.CSS.format(this)),this._toString}static getLighterColor(u,a,o){if(u.isLighterThan(a))return u;o=o||.5;const E=u.getRelativeLuminance(),d=a.getRelativeLuminance();return o=o*(d-E)/d,u.lighten(o)}static getDarkerColor(u,a,o){if(u.isDarkerThan(a))return u;o=o||.5;const E=u.getRelativeLuminance(),d=a.getRelativeLuminance();return o=o*(E-d)/E,u.darken(o)}static{this.white=new p(new D(255,255,255,1))}static{this.black=new p(new D(0,0,0,1))}static{this.red=new p(new D(255,0,0,1))}static{this.blue=new p(new D(0,0,255,1))}static{this.green=new p(new D(0,255,0,1))}static{this.cyan=new p(new D(0,255,255,1))}static{this.lightgrey=new p(new D(211,211,211,1))}static{this.transparent=new p(new D(0,0,0,0))}}t.Color=p,function(g){let u;(function(a){let o;(function(E){function d(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:g.Format.CSS.formatRGBA(n)}E.formatRGB=d;function b(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}E.formatRGBA=b;function e(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:g.Format.CSS.formatHSLA(n)}E.formatHSL=e;function m(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}E.formatHSLA=m;function _(n){const s=n.toString(16);return s.length!==2?"0"+s:s}function L(n){return`#${_(n.rgba.r)}${_(n.rgba.g)}${_(n.rgba.b)}`}E.formatHex=L;function v(n,s=!1){return s&&n.rgba.a===1?g.Format.CSS.formatHex(n):`#${_(n.rgba.r)}${_(n.rgba.g)}${_(n.rgba.b)}${_(Math.round(n.rgba.a*255))}`}E.formatHexA=v;function N(n){return n.isOpaque()?g.Format.CSS.formatHex(n):g.Format.CSS.formatRGBA(n)}E.format=N;function A(n){const s=n.length;if(s===0||n.charCodeAt(0)!==35)return null;if(s===7){const h=16*l(n.charCodeAt(1))+l(n.charCodeAt(2)),f=16*l(n.charCodeAt(3))+l(n.charCodeAt(4)),w=16*l(n.charCodeAt(5))+l(n.charCodeAt(6));return new g(new D(h,f,w,1))}if(s===9){const h=16*l(n.charCodeAt(1))+l(n.charCodeAt(2)),f=16*l(n.charCodeAt(3))+l(n.charCodeAt(4)),w=16*l(n.charCodeAt(5))+l(n.charCodeAt(6)),R=16*l(n.charCodeAt(7))+l(n.charCodeAt(8));return new g(new D(h,f,w,R/255))}if(s===4){const h=l(n.charCodeAt(1)),f=l(n.charCodeAt(2)),w=l(n.charCodeAt(3));return new g(new D(16*h+h,16*f+f,16*w+w))}if(s===5){const h=l(n.charCodeAt(1)),f=l(n.charCodeAt(2)),w=l(n.charCodeAt(3)),R=l(n.charCodeAt(4));return new g(new D(16*h+h,16*f+f,16*w+w,(16*R+R)/255))}return null}E.parseHex=A;function l(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(o=a.CSS||(a.CSS={}))})(u=g.Format||(g.Format={}))}(p||(t.Color=p={}))}),ie(se[38],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class i{constructor(y,c,p,g){this.originalStart=y,this.originalLength=c,this.modifiedStart=p,this.modifiedLength=g}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=i}),ie(se[3],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.ReadonlyError=t.CancellationError=t.errorHandler=t.ErrorHandler=void 0,t.setUnexpectedErrorHandler=D,t.isSigPipeError=y,t.onUnexpectedError=c,t.onUnexpectedExternalError=p,t.transformErrorForSerialization=g,t.isCancellationError=a,t.canceled=E,t.illegalArgument=d,t.illegalState=b,t.getErrorMessage=m;class i{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?N.isErrorNoTelemetry(n)?new N(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(s=>{s(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}t.ErrorHandler=i,t.errorHandler=new i;function D(l){t.errorHandler.setUnexpectedErrorHandler(l)}function y(l){if(!l||typeof l!="object")return!1;const n=l;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function c(l){a(l)||t.errorHandler.onUnexpectedError(l)}function p(l){a(l)||t.errorHandler.onUnexpectedExternalError(l)}function g(l){if(l instanceof Error){const{name:n,message:s}=l,h=l.stacktrace||l.stack;return{$isError:!0,name:n,message:s,stack:h,noTelemetry:N.isErrorNoTelemetry(l)}}return l}const u="Canceled";function a(l){return l instanceof o?!0:l instanceof Error&&l.name===u&&l.message===u}class o extends Error{constructor(){super(u),this.name=this.message}}t.CancellationError=o;function E(){const l=new Error(u);return l.name=l.message,l}function d(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}function b(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}class e extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}t.ReadonlyError=e;function m(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}class _ extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}t.NotImplementedError=_;class L extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}t.NotSupportedError=L;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=v;class N extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof N)return n;const s=new N;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}t.ErrorNoTelemetry=N;class A extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,A.prototype)}}t.BugIndicatingError=A}),ie(se[6],ue([0,1,3,8]),function(W,t,i,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Permutation=t.CallbackIterable=t.ArrayQueue=t.booleanComparator=t.numberComparator=t.CompareResult=void 0,t.tail=y,t.tail2=c,t.equals=p,t.removeFastWithoutKeepingOrder=g,t.binarySearch=u,t.binarySearch2=a,t.quickSelect=o,t.groupBy=E,t.groupAdjacentBy=d,t.forEachAdjacent=b,t.forEachWithNeighbors=e,t.sortedDiff=m,t.delta=_,t.top=L,t.topAsync=v,t.coalesce=A,t.coalesceInPlace=l,t.move=n,t.isFalsyOrEmpty=s,t.isNonEmptyArray=h,t.distinct=f,t.uniqueFilter=w,t.firstOrDefault=R,t.lastOrDefault=M,t.commonPrefixLength=S,t.flatten=F,t.range=C,t.index=I,t.insert=x,t.remove=O,t.arrayInsert=T,t.shuffle=H,t.pushToStart=J,t.pushToEnd=Y,t.pushMany=$,t.mapArrayOrNot=G,t.asArray=K,t.getRandomElement=ee,t.insertInto=P,t.splice=Q,t.compareBy=ve,t.tieBreakComparators=r,t.reverseOrder=qe;function y(B,z=0){return B[B.length-(1+z)]}function c(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}function p(B,z,V=(X,te)=>X===te){if(B===z)return!0;if(!B||!z||B.length!==z.length)return!1;for(let X=0,te=B.length;X<te;X++)if(!V(B[X],z[X]))return!1;return!0}function g(B,z){const V=B.length-1;z<V&&(B[z]=B[V]),B.pop()}function u(B,z,V){return a(B.length,X=>V(B[X],z))}function a(B,z){let V=0,X=B-1;for(;V<=X;){const te=(V+X)/2|0,fe=z(te);if(fe<0)V=te+1;else if(fe>0)X=te-1;else return te}return-(V+1)}function o(B,z,V){if(B=B|0,B>=z.length)throw new TypeError("invalid index");const X=z[Math.floor(z.length*Math.random())],te=[],fe=[],me=[];for(const re of z){const U=V(re,X);U<0?te.push(re):U>0?fe.push(re):me.push(re)}return B<te.length?o(B,te,V):B<te.length+me.length?me[0]:o(B-(te.length+me.length),fe,V)}function E(B,z){const V=[];let X;for(const te of B.slice(0).sort(z))!X||z(X[0],te)!==0?(X=[te],V.push(X)):X.push(te);return V}function*d(B,z){let V,X;for(const te of B)X!==void 0&&z(X,te)?V.push(te):(V&&(yield V),V=[te]),X=te;V&&(yield V)}function b(B,z){for(let V=0;V<=B.length;V++)z(V===0?void 0:B[V-1],V===B.length?void 0:B[V])}function e(B,z){for(let V=0;V<B.length;V++)z(V===0?void 0:B[V-1],B[V],V+1===B.length?void 0:B[V+1])}function m(B,z,V){const X=[];function te(re,U,ae){if(U===0&&ae.length===0)return;const ne=X[X.length-1];ne&&ne.start+ne.deleteCount===re?(ne.deleteCount+=U,ne.toInsert.push(...ae)):X.push({start:re,deleteCount:U,toInsert:ae})}let fe=0,me=0;for(;;){if(fe===B.length){te(fe,0,z.slice(me));break}if(me===z.length){te(fe,B.length-fe,[]);break}const re=B[fe],U=z[me],ae=V(re,U);ae===0?(fe+=1,me+=1):ae<0?(te(fe,1,[]),fe+=1):ae>0&&(te(fe,0,[U]),me+=1)}return X}function _(B,z,V){const X=m(B,z,V),te=[],fe=[];for(const me of X)te.push(...B.slice(me.start,me.start+me.deleteCount)),fe.push(...me.toInsert);return{removed:te,added:fe}}function L(B,z,V){if(V===0)return[];const X=B.slice(0,V).sort(z);return N(B,z,X,V,B.length),X}function v(B,z,V,X,te){return V===0?Promise.resolve([]):new Promise((fe,me)=>{(async()=>{const re=B.length,U=B.slice(0,V).sort(z);for(let ae=V,ne=Math.min(V+X,re);ae<re;ae=ne,ne=Math.min(ne+X,re)){if(ae>V&&await new Promise(oe=>setTimeout(oe)),te&&te.isCancellationRequested)throw new i.CancellationError;N(B,z,U,ae,ne)}return U})().then(fe,me)})}function N(B,z,V,X,te){for(const fe=V.length;X<te;X++){const me=B[X];if(z(me,V[fe-1])<0){V.pop();const re=(0,D.findFirstIdxMonotonousOrArrLen)(V,U=>z(me,U)<0);V.splice(re,0,me)}}}function A(B){return B.filter(z=>!!z)}function l(B){let z=0;for(let V=0;V<B.length;V++)B[V]&&(B[z]=B[V],z+=1);B.length=z}function n(B,z,V){B.splice(V,0,B.splice(z,1)[0])}function s(B){return!Array.isArray(B)||B.length===0}function h(B){return Array.isArray(B)&&B.length>0}function f(B,z=V=>V){const V=new Set;return B.filter(X=>{const te=z(X);return V.has(te)?!1:(V.add(te),!0)})}function w(B){const z=new Set;return V=>{const X=B(V);return z.has(X)?!1:(z.add(X),!0)}}function R(B,z){return B.length>0?B[0]:z}function M(B,z){return B.length>0?B[B.length-1]:z}function S(B,z,V=(X,te)=>X===te){let X=0;for(let te=0,fe=Math.min(B.length,z.length);te<fe&&V(B[te],z[te]);te++)X++;return X}function F(B){return[].concat(...B)}function C(B,z){let V=typeof z=="number"?B:0;typeof z=="number"?V=B:(V=0,z=B);const X=[];if(V<=z)for(let te=V;te<z;te++)X.push(te);else for(let te=V;te>z;te--)X.push(te);return X}function I(B,z,V){return B.reduce((X,te)=>(X[z(te)]=V?V(te):te,X),Object.create(null))}function x(B,z){return B.push(z),()=>O(B,z)}function O(B,z){const V=B.indexOf(z);if(V>-1)return B.splice(V,1),z}function T(B,z,V){const X=B.slice(0,z),te=B.slice(z);return X.concat(V,te)}function H(B,z){let V;if(typeof z=="number"){let X=z;V=()=>{const te=Math.sin(X++)*179426549;return te-Math.floor(te)}}else V=Math.random;for(let X=B.length-1;X>0;X-=1){const te=Math.floor(V()*(X+1)),fe=B[X];B[X]=B[te],B[te]=fe}}function J(B,z){const V=B.indexOf(z);V>-1&&(B.splice(V,1),B.unshift(z))}function Y(B,z){const V=B.indexOf(z);V>-1&&(B.splice(V,1),B.push(z))}function $(B,z){for(const V of z)B.push(V)}function G(B,z){return Array.isArray(B)?B.map(z):z(B)}function K(B){return Array.isArray(B)?B:[B]}function ee(B){return B[Math.floor(Math.random()*B.length)]}function P(B,z,V){const X=de(B,z),te=B.length,fe=V.length;B.length=te+fe;for(let me=te-1;me>=X;me--)B[me+fe]=B[me];for(let me=0;me<fe;me++)B[me+X]=V[me]}function Q(B,z,V,X){const te=de(B,z);let fe=B.splice(te,V);return fe===void 0&&(fe=[]),P(B,te,X),fe}function de(B,z){return z<0?Math.max(z+B.length,0):Math.min(z,B.length)}var he;(function(B){function z(fe){return fe<0}B.isLessThan=z;function V(fe){return fe<=0}B.isLessThanOrEqual=V;function X(fe){return fe>0}B.isGreaterThan=X;function te(fe){return fe===0}B.isNeitherLessOrGreaterThan=te,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(he||(t.CompareResult=he={}));function ve(B,z){return(V,X)=>z(B(V),B(X))}function r(...B){return(z,V)=>{for(const X of B){const te=X(z,V);if(!he.isNeitherLessOrGreaterThan(te))return te}return he.neitherLessOrGreaterThan}}const _e=(B,z)=>B-z;t.numberComparator=_e;const Re=(B,z)=>(0,t.numberComparator)(B?1:0,z?1:0);t.booleanComparator=Re;function qe(B){return(z,V)=>-B(z,V)}class ke{constructor(z){this.items=z,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(z){let V=this.firstIdx;for(;V<this.items.length&&z(this.items[V]);)V++;const X=V===this.firstIdx?null:this.items.slice(this.firstIdx,V);return this.firstIdx=V,X}takeFromEndWhile(z){let V=this.lastIdx;for(;V>=0&&z(this.items[V]);)V--;const X=V===this.lastIdx?null:this.items.slice(V+1,this.lastIdx+1);return this.lastIdx=V,X}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const z=this.items[this.firstIdx];return this.firstIdx++,z}removeLast(){const z=this.items[this.lastIdx];return this.lastIdx--,z}takeCount(z){const V=this.items.slice(this.firstIdx,this.firstIdx+z);return this.firstIdx+=z,V}}t.ArrayQueue=ke;class Se{static{this.empty=new Se(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(V=>(z(V),!0))}toArray(){const z=[];return this.iterate(V=>(z.push(V),!0)),z}filter(z){return new Se(V=>this.iterate(X=>z(X)?V(X):!0))}map(z){return new Se(V=>this.iterate(X=>V(z(X))))}some(z){let V=!1;return this.iterate(X=>(V=z(X),!V)),V}findFirst(z){let V;return this.iterate(X=>z(X)?(V=X,!1):!0),V}findLast(z){let V;return this.iterate(X=>(z(X)&&(V=X),!0)),V}findLastMaxBy(z){let V,X=!0;return this.iterate(te=>((X||he.isGreaterThan(z(te,V)))&&(X=!1,V=te),!0)),V}}t.CallbackIterable=Se;class Ce{constructor(z){this._indexMap=z}static createSortPermutation(z,V){const X=Array.from(z.keys()).sort((te,fe)=>V(z[te],z[fe]));return new Ce(X)}apply(z){return z.map((V,X)=>z[this._indexMap[X]])}inverse(){const z=this._indexMap.slice();for(let V=0;V<this._indexMap.length;V++)z[this._indexMap[V]]=V;return new Ce(z)}}t.Permutation=Ce}),ie(se[10],ue([0,1,3]),function(W,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=D,t.assertNever=y,t.assert=c,t.softAssert=p,t.assertFn=g,t.checkAdjacentItems=u;function D(a,o){if(!a)throw new Error(o?`Assertion failed (${o})`:"Assertion Failed")}function y(a,o="Unreachable"){throw new Error(o)}function c(a){if(!a)throw new i.BugIndicatingError("Assertion Failed")}function p(a){a||(0,i.onUnexpectedError)(new i.BugIndicatingError("Soft Assertion Failed"))}function g(a){if(!a()){debugger;a(),(0,i.onUnexpectedError)(new i.BugIndicatingError("Assertion Failed"))}}function u(a,o){let E=0;for(;E<a.length-1;){const d=a[E],b=a[E+1];if(!o(d,b))return!1;E++}return!0}}),ie(se[20],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSingleCallFunction=i;function i(D,y){const c=this;let p=!1,g;return function(){if(p)return g;if(p=!0,y)try{g=D.apply(c,arguments)}finally{y()}else g=D.apply(c,arguments);return g}}}),ie(se[21],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(D){function y(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}D.is=y;const c=Object.freeze([]);function p(){return c}D.empty=p;function*g(n){yield n}D.single=g;function u(n){return y(n)?n:g(n)}D.wrap=u;function a(n){return n||c}D.from=a;function*o(n){for(let s=n.length-1;s>=0;s--)yield n[s]}D.reverse=o;function E(n){return!n||n[Symbol.iterator]().next().done===!0}D.isEmpty=E;function d(n){return n[Symbol.iterator]().next().value}D.first=d;function b(n,s){for(const h of n)if(s(h))return!0;return!1}D.some=b;function e(n,s){for(const h of n)if(s(h))return h}D.find=e;function*m(n,s){for(const h of n)s(h)&&(yield h)}D.filter=m;function*_(n,s){let h=0;for(const f of n)yield s(f,h++)}D.map=_;function*L(...n){for(const s of n)yield*s}D.concat=L;function v(n,s,h){let f=h;for(const w of n)f=s(f,w);return f}D.reduce=v;function*N(n,s,h=n.length){for(s<0&&(s+=n.length),h<0?h+=n.length:h>n.length&&(h=n.length);s<h;s++)yield n[s]}D.slice=N;function A(n,s=Number.POSITIVE_INFINITY){const h=[];if(s===0)return[h,n];const f=n[Symbol.iterator]();for(let w=0;w<s;w++){const R=f.next();if(R.done)return[h,D.empty()];h.push(R.value)}return[h,{[Symbol.iterator](){return f}}]}D.consume=A;async function l(n){const s=[];for await(const h of n)s.push(h);return Promise.resolve(s)}D.asyncToArray=l})(i||(t.Iterable=i={}))}),ie(se[39],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0,t.KeyChord=b;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var D;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(D||(t.ScanCode=D={}));class y{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(m,_){this._keyCodeToStr[m]=_,this._strToKeyCode[_.toLowerCase()]=m}keyCodeToStr(m){return this._keyCodeToStr[m]}strToKeyCode(m){return this._strToKeyCode[m.toLowerCase()]||0}}const c=new y,p=new y,g=new y;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const u=[],a=Object.create(null),o=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>o[e]||0,toEnum:e=>a[e]||0,toString:e=>u[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",m=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],_=[],L=[];for(const v of m){const[N,A,l,n,s,h,f,w,R]=v;if(L[A]||(L[A]=!0,u[A]=l,a[l]=A,o[l.toLowerCase()]=A,N&&(t.IMMUTABLE_CODE_TO_KEY_CODE[A]=n,n!==0&&n!==3&&n!==5&&n!==4&&n!==6&&n!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[n]=A))),!_[n]){if(_[n]=!0,!s)throw new Error(`String representation missing for key code ${n} around scan code ${l}`);c.define(n,s),p.define(n,w||s),g.define(n,R||w||s)}h&&(t.EVENT_KEY_CODE_MAP[h]=n),f&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[f]=n)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var E;(function(e){function m(l){return c.keyCodeToStr(l)}e.toString=m;function _(l){return c.strToKeyCode(l)}e.fromString=_;function L(l){return p.keyCodeToStr(l)}e.toUserSettingsUS=L;function v(l){return g.keyCodeToStr(l)}e.toUserSettingsGeneral=v;function N(l){return p.strToKeyCode(l)||g.strToKeyCode(l)}e.fromUserSettings=N;function A(l){if(l>=98&&l<=113)return null;switch(l){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return c.keyCodeToStr(l)}e.toElectronAccelerator=A})(E||(t.KeyCodeUtils=E={}));var d;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(d||(t.KeyMod=d={}));function b(e,m){const _=(m&65535)<<16>>>0;return(e|_)>>>0}}),ie(se[40],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class i{constructor(y){this.executor=y,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(y){this._error=y}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}t.Lazy=i}),ie(se[22],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class i{static{this.Undefined=new i(void 0)}constructor(c){this.element=c,this.next=i.Undefined,this.prev=i.Undefined}}class D{constructor(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===i.Undefined}clear(){let c=this._first;for(;c!==i.Undefined;){const p=c.next;c.prev=i.Undefined,c.next=i.Undefined,c=p}this._first=i.Undefined,this._last=i.Undefined,this._size=0}unshift(c){return this._insert(c,!1)}push(c){return this._insert(c,!0)}_insert(c,p){const g=new i(c);if(this._first===i.Undefined)this._first=g,this._last=g;else if(p){const a=this._last;this._last=g,g.prev=a,a.next=g}else{const a=this._first;this._first=g,g.next=a,a.prev=g}this._size+=1;let u=!1;return()=>{u||(u=!0,this._remove(g))}}shift(){if(this._first!==i.Undefined){const c=this._first.element;return this._remove(this._first),c}}pop(){if(this._last!==i.Undefined){const c=this._last.element;return this._remove(this._last),c}}_remove(c){if(c.prev!==i.Undefined&&c.next!==i.Undefined){const p=c.prev;p.next=c.next,c.next.prev=p}else c.prev===i.Undefined&&c.next===i.Undefined?(this._first=i.Undefined,this._last=i.Undefined):c.next===i.Undefined?(this._last=this._last.prev,this._last.next=i.Undefined):c.prev===i.Undefined&&(this._first=this._first.next,this._first.prev=i.Undefined);this._size-=1}*[Symbol.iterator](){let c=this._first;for(;c!==i.Undefined;)yield c.element,c=c.next}}t.LinkedList=D}),ie(se[14],ue([0,1]),function(W,t){"use strict";var i,D,y;Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.BidirectionalMap=t.CounterSet=t.MRUCache=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=void 0,t.getOrSet=c,t.mapToString=p,t.setToString=g,t.mapsStrictEqualIgnoreOrder=A;function c(l,n,s){let h=l.get(n);return h===void 0&&(h=s,l.set(n,h)),h}function p(l){const n=[];return l.forEach((s,h)=>{n.push(`${h} => ${s}`)}),`Map(${l.size}) {${n.join(", ")}}`}function g(l){const n=[];return l.forEach(s=>{n.push(s)}),`Set(${l.size}) {${n.join(", ")}}`}class u{constructor(n,s){this.uri=n,this.value=s}}function a(l){return Array.isArray(l)}class o{static{this.defaultToKey=n=>n.toString()}constructor(n,s){if(this[i]="ResourceMap",n instanceof o)this.map=new Map(n.map),this.toKey=s??o.defaultToKey;else if(a(n)){this.map=new Map,this.toKey=s??o.defaultToKey;for(const[h,f]of n)this.set(h,f)}else this.map=new Map,this.toKey=n??o.defaultToKey}set(n,s){return this.map.set(this.toKey(n),new u(n,s)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s<"u"&&(n=n.bind(s));for(const[h,f]of this.map)n(f.value,f.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}t.ResourceMap=o;class E{constructor(n,s){this[D]="ResourceSet",!n||typeof n=="function"?this._map=new o(n):(this._map=new o(s),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,s){this._map.forEach((h,f)=>n.call(s,f,f,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=E;var d;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(d||(t.Touch=d={}));class b{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,s=0){const h=this._map.get(n);if(h)return s!==0&&this.touch(h,s),h.value}set(n,s,h=0){let f=this._map.get(n);if(f)f.value=s,h!==0&&this.touch(f,h);else{switch(f={key:n,value:s,next:void 0,previous:void 0},h){case 0:this.addItemLast(f);break;case 1:this.addItemFirst(f);break;case 2:this.addItemLast(f);break;default:this.addItemLast(f);break}this._map.set(n,f),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const h=this._state;let f=this._head;for(;f;){if(s?n.bind(s)(f.value,f.key,this):n(f.value,f.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const n=this,s=this._state;let h=this._head;const f={[Symbol.iterator](){return f},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(h){const w={value:h.key,done:!1};return h=h.next,w}else return{value:void 0,done:!0}}};return f}values(){const n=this,s=this._state;let h=this._head;const f={[Symbol.iterator](){return f},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(h){const w={value:h.value,done:!1};return h=h.next,w}else return{value:void 0,done:!0}}};return f}entries(){const n=this,s=this._state;let h=this._head;const f={[Symbol.iterator](){return f},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(h){const w={value:[h.key,h.value],done:!1};return h=h.next,w}else return{value:void 0,done:!0}}};return f}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,h=this.size;for(;s&&h>n;)this._map.delete(s.key),s=s.next,h--;this._head=s,this._size=h,s&&(s.previous=void 0),this._state++}trimNew(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._tail,h=this.size;for(;s&&h>n;)this._map.delete(s.key),s=s.previous,h--;this._tail=s,this._size=h,s&&(s.next=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,h=n.previous;if(!s||!h)throw new Error("Invalid list");s.previous=h,h.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const h=n.next,f=n.previous;n===this._tail?(f.next=void 0,this._tail=f):(h.previous=f,f.next=h),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const h=n.next,f=n.previous;n===this._head?(h.previous=void 0,this._head=h):(h.previous=f,f.next=h),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,h)=>{n.push([h,s])}),n}fromJSON(n){this.clear();for(const[s,h]of n)this.set(s,h)}}t.LinkedMap=b;class e extends b{constructor(n,s=1){super(),this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class m extends e{constructor(n,s=1){super(n,s)}trim(n){this.trimOld(n)}set(n,s){return super.set(n,s),this.checkTrim(),this}}t.LRUCache=m;class _ extends e{constructor(n,s=1){super(n,s)}trim(n){this.trimNew(n)}set(n,s){return this._limit<=this.size&&!this.has(n)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(n,s),this}}t.MRUCache=_;class L{constructor(){this.map=new Map}add(n){return this.map.set(n,(this.map.get(n)||0)+1),this}delete(n){let s=this.map.get(n)||0;return s===0?!1:(s--,s===0?this.map.delete(n):this.map.set(n,s),!0)}has(n){return this.map.has(n)}}t.CounterSet=L;class v{constructor(n){if(this._m1=new Map,this._m2=new Map,n)for(const[s,h]of n)this.set(s,h)}clear(){this._m1.clear(),this._m2.clear()}set(n,s){this._m1.set(n,s),this._m2.set(s,n)}get(n){return this._m1.get(n)}getKey(n){return this._m2.get(n)}delete(n){const s=this._m1.get(n);return s===void 0?!1:(this._m1.delete(n),this._m2.delete(s),!0)}forEach(n,s){this._m1.forEach((h,f)=>{n.call(s,h,f,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}t.BidirectionalMap=v;class N{constructor(){this.map=new Map}add(n,s){let h=this.map.get(n);h||(h=new Set,this.map.set(n,h)),h.add(s)}delete(n,s){const h=this.map.get(n);h&&(h.delete(s),h.size===0&&this.map.delete(n))}forEach(n,s){const h=this.map.get(n);h&&h.forEach(s)}get(n){const s=this.map.get(n);return s||new Set}}t.SetMap=N;function A(l,n){if(l===n)return!0;if(l.size!==n.size)return!1;for(const[s,h]of l)if(!n.has(s)||n.get(s)!==h)return!1;for(const[s]of n)if(!l.has(s))return!1;return!0}}),ie(se[11],ue([0,1,6,36,14,20,21]),function(W,t,i,D,y,c,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MandatoryMutableDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.DisposableTracker=void 0,t.setDisposableTracker=o,t.trackDisposable=E,t.markAsDisposed=d,t.markAsSingleton=m,t.isDisposable=_,t.dispose=L,t.disposeIfDisposable=v,t.combinedDisposable=N,t.toDisposable=A,t.disposeOnReturn=F;const g=!1;let u=null;class a{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(x){let O=this.livingDisposables.get(x);return O||(O={parent:null,source:null,isSingleton:!1,value:x,idx:a.idx++},this.livingDisposables.set(x,O)),O}trackDisposable(x){const O=this.getDisposableData(x);O.source||(O.source=new Error().stack)}setParent(x,O){const T=this.getDisposableData(x);T.parent=O}markAsDisposed(x){this.livingDisposables.delete(x)}markAsSingleton(x){this.getDisposableData(x).isSingleton=!0}getRootParent(x,O){const T=O.get(x);if(T)return T;const H=x.parent?this.getRootParent(this.getDisposableData(x.parent),O):x;return O.set(x,H),H}getTrackedDisposables(){const x=new Map;return[...this.livingDisposables.entries()].filter(([,T])=>T.source!==null&&!this.getRootParent(T,x).isSingleton).flatMap(([T])=>T)}computeLeakingDisposables(x=10,O){let T;if(O)T=O;else{const G=new Map,K=[...this.livingDisposables.values()].filter(P=>P.source!==null&&!this.getRootParent(P,G).isSingleton);if(K.length===0)return;const ee=new Set(K.map(P=>P.value));if(T=K.filter(P=>!(P.parent&&ee.has(P.parent))),T.length===0)throw new Error("There are cyclic diposable chains!")}if(!T)return;function H(G){function K(P,Q){for(;P.length>0&&Q.some(de=>typeof de=="string"?de===P[0]:P[0].match(de));)P.shift()}const ee=G.source.split(`
`).map(P=>P.trim().replace("at ","")).filter(P=>P!=="");return K(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const J=new y.SetMap;for(const G of T){const K=H(G);for(let ee=0;ee<=K.length;ee++)J.add(K.slice(0,ee).join(`
`),G)}T.sort((0,i.compareBy)(G=>G.idx,i.numberComparator));let Y="",$=0;for(const G of T.slice(0,x)){$++;const K=H(G),ee=[];for(let P=0;P<K.length;P++){let Q=K[P];Q=`(shared with ${J.get(K.slice(0,P+1).join(`
`)).size}/${T.length} leaks) at ${Q}`;const he=J.get(K.slice(0,P).join(`
`)),ve=(0,D.groupBy)([...he].map(r=>H(r)[P]),r=>r);delete ve[K[P]];for(const[r,_e]of Object.entries(ve))ee.unshift(`    - stacktraces of ${_e.length} other leaks continue with ${r}`);ee.unshift(Q)}Y+=`


==================== Leaking disposable ${$}/${T.length}: ${G.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return T.length>x&&(Y+=`


... and ${T.length-x} more leaking disposables

`),{leaks:T,details:Y}}}t.DisposableTracker=a;function o(I){u=I}if(g){const I="__is_disposable_tracked__";o(new class{trackDisposable(x){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{x[I]||console.log(O)},3e3)}setParent(x,O){if(x&&x!==n.None)try{x[I]=!0}catch{}}markAsDisposed(x){if(x&&x!==n.None)try{x[I]=!0}catch{}}markAsSingleton(x){}})}function E(I){return u?.trackDisposable(I),I}function d(I){u?.markAsDisposed(I)}function b(I,x){u?.setParent(I,x)}function e(I,x){if(u)for(const O of I)u.setParent(O,x)}function m(I){return u?.markAsSingleton(I),I}function _(I){return typeof I=="object"&&I!==null&&typeof I.dispose=="function"&&I.dispose.length===0}function L(I){if(p.Iterable.is(I)){const x=[];for(const O of I)if(O)try{O.dispose()}catch(T){x.push(T)}if(x.length===1)throw x[0];if(x.length>1)throw new AggregateError(x,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}function v(I){for(const x of I)_(x)&&x.dispose();return[]}function N(...I){const x=A(()=>L(I));return e(I,x),x}function A(I){const x=E({dispose:(0,c.createSingleCallFunction)(()=>{d(x),I()})});return x}class l{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,E(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{L(this._toDispose)}finally{this._toDispose.clear()}}add(x){if(!x)return x;if(x===this)throw new Error("Cannot register a disposable on itself!");return b(x,this),this._isDisposed?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(x),x}delete(x){if(x){if(x===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(x),x.dispose()}}deleteAndLeak(x){x&&this._toDispose.has(x)&&(this._toDispose.delete(x),b(x,null))}}t.DisposableStore=l;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new l,E(this),b(this._store,this)}dispose(){d(this),this._store.dispose()}_register(x){if(x===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(x)}}t.Disposable=n;class s{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(x){this._isDisposed||x===this._value||(this._value?.dispose(),x&&b(x,this),this._value=x)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,d(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const x=this._value;return this._value=void 0,x&&b(x,null),x}}t.MutableDisposable=s;class h{constructor(x){this._disposable=new s,this._isDisposed=!1,this._disposable.value=x}get value(){return this._disposable.value}set value(x){this._isDisposed||x===this._disposable.value||(this._disposable.value=x)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}t.MandatoryMutableDisposable=h;class f{constructor(x){this._disposable=x,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}t.RefCountedDisposable=f;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(x){let O=x;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,d(this))},this}}t.SafeDisposable=w;class R{constructor(){this.references=new Map}acquire(x,...O){let T=this.references.get(x);T||(T={counter:0,object:this.createReferencedObject(x,...O)},this.references.set(x,T));const{object:H}=T,J=(0,c.createSingleCallFunction)(()=>{--T.counter===0&&(this.destroyReferencedObject(x,T.object),this.references.delete(x))});return T.counter++,{object:H,dispose:J}}}t.ReferenceCollection=R;class M{constructor(x){this.referenceCollection=x}async acquire(x,...O){const T=this.referenceCollection.acquire(x,...O);try{return{object:await T.object,dispose:()=>T.dispose()}}catch(H){throw T.dispose(),H}}}t.AsyncReferenceCollection=M;class S{constructor(x){this.object=x}dispose(){}}t.ImmortalReference=S;function F(I){const x=new l;try{I(x)}finally{x.dispose()}}class C{constructor(){this._store=new Map,this._isDisposed=!1,E(this)}dispose(){d(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{L(this._store.values())}finally{this._store.clear()}}has(x){return this._store.has(x)}get size(){return this._store.size}get(x){return this._store.get(x)}set(x,O,T=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),T||this._store.get(x)?.dispose(),this._store.set(x,O)}deleteAndDispose(x){this._store.get(x)?.dispose(),this._store.delete(x)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}t.DisposableMap=C}),ie(se[23],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(c){return new D(c)}constructor(c){this._now=i&&c===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}t.StopWatch=D}),ie(se[12],ue([0,1,3,20,11,22,23]),function(W,t,i,D,y,c,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ValueWithChangeEvent=t.Relay=t.EventBufferer=t.DynamicListEventMultiplexer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.createEventDeliveryQueue=t.Emitter=t.EventProfiling=t.Event=void 0,t.setGlobalLeakWarningThreshold=b;const g=!1,u=!1,a=!1;var o;(function(O){O.None=()=>y.Disposable.None;function T(re){if(a){const{onDidAddListener:U}=re,ae=m.create();let ne=0;re.onDidAddListener=()=>{++ne===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ae.print()),U?.()}}}function H(re,U){return he(re,()=>{},0,void 0,!0,void 0,U)}O.defer=H;function J(re){return(U,ae=null,ne)=>{let oe=!1,ce;return ce=re(be=>{if(!oe)return ce?ce.dispose():oe=!0,U.call(ae,be)},null,ne),oe&&ce.dispose(),ce}}O.once=J;function Y(re,U,ae){return Q((ne,oe=null,ce)=>re(be=>ne.call(oe,U(be)),null,ce),ae)}O.map=Y;function $(re,U,ae){return Q((ne,oe=null,ce)=>re(be=>{U(be),ne.call(oe,be)},null,ce),ae)}O.forEach=$;function G(re,U,ae){return Q((ne,oe=null,ce)=>re(be=>U(be)&&ne.call(oe,be),null,ce),ae)}O.filter=G;function K(re){return re}O.signal=K;function ee(...re){return(U,ae=null,ne)=>{const oe=(0,y.combinedDisposable)(...re.map(ce=>ce(be=>U.call(ae,be))));return de(oe,ne)}}O.any=ee;function P(re,U,ae,ne){let oe=ae;return Y(re,ce=>(oe=U(oe,ce),oe),ne)}O.reduce=P;function Q(re,U){let ae;const ne={onWillAddFirstListener(){ae=re(oe.fire,oe)},onDidRemoveLastListener(){ae?.dispose()}};U||T(ne);const oe=new l(ne);return U?.add(oe),oe.event}function de(re,U){return U instanceof Array?U.push(re):U&&U.add(re),re}function he(re,U,ae=100,ne=!1,oe=!1,ce,be){let Le,we,Pe,Ae=0,Te;const We={leakWarningThreshold:ce,onWillAddFirstListener(){Le=re(He=>{Ae++,we=U(we,He),ne&&!Pe&&(Ie.fire(we),we=void 0),Te=()=>{const Ve=we;we=void 0,Pe=void 0,(!ne||Ae>1)&&Ie.fire(Ve),Ae=0},typeof ae=="number"?(clearTimeout(Pe),Pe=setTimeout(Te,ae)):Pe===void 0&&(Pe=0,queueMicrotask(Te))})},onWillRemoveListener(){oe&&Ae>0&&Te?.()},onDidRemoveLastListener(){Te=void 0,Le.dispose()}};be||T(We);const Ie=new l(We);return be?.add(Ie),Ie.event}O.debounce=he;function ve(re,U=0,ae){return O.debounce(re,(ne,oe)=>ne?(ne.push(oe),ne):[oe],U,void 0,!0,void 0,ae)}O.accumulate=ve;function r(re,U=(ne,oe)=>ne===oe,ae){let ne=!0,oe;return G(re,ce=>{const be=ne||!U(ce,oe);return ne=!1,oe=ce,be},ae)}O.latch=r;function _e(re,U,ae){return[O.filter(re,U,ae),O.filter(re,ne=>!U(ne),ae)]}O.split=_e;function Re(re,U=!1,ae=[],ne){let oe=ae.slice(),ce=re(we=>{oe?oe.push(we):Le.fire(we)});ne&&ne.add(ce);const be=()=>{oe?.forEach(we=>Le.fire(we)),oe=null},Le=new l({onWillAddFirstListener(){ce||(ce=re(we=>Le.fire(we)),ne&&ne.add(ce))},onDidAddFirstListener(){oe&&(U?setTimeout(be):be())},onDidRemoveLastListener(){ce&&ce.dispose(),ce=null}});return ne&&ne.add(Le),Le.event}O.buffer=Re;function qe(re,U){return(ne,oe,ce)=>{const be=U(new Se);return re(function(Le){const we=be.evaluate(Le);we!==ke&&ne.call(oe,we)},void 0,ce)}}O.chain=qe;const ke=Symbol("HaltChainable");class Se{constructor(){this.steps=[]}map(U){return this.steps.push(U),this}forEach(U){return this.steps.push(ae=>(U(ae),ae)),this}filter(U){return this.steps.push(ae=>U(ae)?ae:ke),this}reduce(U,ae){let ne=ae;return this.steps.push(oe=>(ne=U(ne,oe),ne)),this}latch(U=(ae,ne)=>ae===ne){let ae=!0,ne;return this.steps.push(oe=>{const ce=ae||!U(oe,ne);return ae=!1,ne=oe,ce?oe:ke}),this}evaluate(U){for(const ae of this.steps)if(U=ae(U),U===ke)break;return U}}function Ce(re,U,ae=ne=>ne){const ne=(...Le)=>be.fire(ae(...Le)),oe=()=>re.on(U,ne),ce=()=>re.removeListener(U,ne),be=new l({onWillAddFirstListener:oe,onDidRemoveLastListener:ce});return be.event}O.fromNodeEventEmitter=Ce;function B(re,U,ae=ne=>ne){const ne=(...Le)=>be.fire(ae(...Le)),oe=()=>re.addEventListener(U,ne),ce=()=>re.removeEventListener(U,ne),be=new l({onWillAddFirstListener:oe,onDidRemoveLastListener:ce});return be.event}O.fromDOMEventEmitter=B;function z(re){return new Promise(U=>J(re)(U))}O.toPromise=z;function V(re){const U=new l;return re.then(ae=>{U.fire(ae)},()=>{U.fire(void 0)}).finally(()=>{U.dispose()}),U.event}O.fromPromise=V;function X(re,U,ae){return U(ae),re(ne=>U(ne))}O.runAndSubscribe=X;class te{constructor(U,ae){this._observable=U,this._counter=0,this._hasChanged=!1;const ne={onWillAddFirstListener:()=>{U.addObserver(this)},onDidRemoveLastListener:()=>{U.removeObserver(this)}};ae||T(ne),this.emitter=new l(ne),ae&&ae.add(this.emitter)}beginUpdate(U){this._counter++}handlePossibleChange(U){}handleChange(U,ae){this._hasChanged=!0}endUpdate(U){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function fe(re,U){return new te(re,U).emitter.event}O.fromObservable=fe;function me(re){return(U,ae,ne)=>{let oe=0,ce=!1;const be={beginUpdate(){oe++},endUpdate(){oe--,oe===0&&(re.reportChanges(),ce&&(ce=!1,U.call(ae)))},handlePossibleChange(){},handleChange(){ce=!0}};re.addObserver(be),re.reportChanges();const Le={dispose(){re.removeObserver(be)}};return ne instanceof y.DisposableStore?ne.add(Le):Array.isArray(ne)&&ne.push(Le),Le}}O.fromObservableLight=me})(o||(t.Event=o={}));class E{static{this.all=new Set}static{this._idPool=0}constructor(T){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${T}_${E._idPool++}`,E.all.add(this)}start(T){this._stopWatch=new p.StopWatch,this.listenerCount=T}stop(){if(this._stopWatch){const T=this._stopWatch.elapsed();this.durations.push(T),this.elapsedOverall+=T,this.invocationCount+=1,this._stopWatch=void 0}}}t.EventProfiling=E;let d=-1;function b(O){const T=d;return d=O,{dispose(){d=T}}}class e{constructor(T,H=Math.random().toString(18).slice(2,5)){this.threshold=T,this.name=H,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(T,H){const J=this.threshold;if(J<=0||H<J)return;this._stacks||(this._stacks=new Map);const Y=this._stacks.get(T.value)||0;if(this._stacks.set(T.value,Y+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=J*.5;let $,G=0;for(const[K,ee]of this._stacks)(!$||G<ee)&&($=K,G=ee);console.warn(`[${this.name}] potential listener LEAK detected, having ${H} listeners already. MOST frequent listener (${G}):`),console.warn($)}return()=>{const $=this._stacks.get(T.value)||0;this._stacks.set(T.value,$-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(T){this.value=T}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let _=0;class L{constructor(T){this.value=T,this.id=_++}}const v=2,N=(O,T)=>{if(O instanceof L)T(O);else for(let H=0;H<O.length;H++){const J=O[H];J&&T(J)}},A=g?new FinalizationRegistry(O=>{typeof O=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(O))}):void 0;class l{constructor(T){this._size=0,this._options=T,this._leakageMon=d>0||this._options?.leakWarningThreshold?new e(this._options?.leakWarningThreshold??d):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(u){const T=this._listeners;queueMicrotask(()=>{N(T,H=>H.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(T,H,J)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),y.Disposable.None;if(this._disposed)return y.Disposable.None;H&&(T=T.bind(H));const Y=new L(T);let $,G;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(Y.stack=m.create(),$=this._leakageMon.check(Y.stack,this._size+1)),u&&(Y.stack=G??m.create()),this._listeners?this._listeners instanceof L?(this._deliveryQueue??=new s,this._listeners=[this._listeners,Y]):this._listeners.push(Y):(this._options?.onWillAddFirstListener?.(this),this._listeners=Y,this._options?.onDidAddFirstListener?.(this)),this._size++;const K=(0,y.toDisposable)(()=>{A?.unregister(K),$?.(),this._removeListener(Y)});if(J instanceof y.DisposableStore?J.add(K):Array.isArray(J)&&J.push(K),A){const ee=new Error().stack.split(`
`).slice(2).join(`
`).trim();A.register(K,ee,K)}return K},this._event}_removeListener(T){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const H=this._listeners,J=H.indexOf(T);if(J===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,H[J]=void 0;const Y=this._deliveryQueue.current===this;if(this._size*v<=H.length){let $=0;for(let G=0;G<H.length;G++)H[G]?H[$++]=H[G]:Y&&(this._deliveryQueue.end--,$<this._deliveryQueue.i&&this._deliveryQueue.i--);H.length=$}}_deliver(T,H){if(!T)return;const J=this._options?.onListenerError||i.onUnexpectedError;if(!J){T.value(H);return}try{T.value(H)}catch(Y){J(Y)}}_deliverQueue(T){const H=T.current._listeners;for(;T.i<T.end;)this._deliver(H[T.i++],T.value);T.reset()}fire(T){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof L)this._deliver(this._listeners,T);else{const H=this._deliveryQueue;H.enqueue(this,T,this._listeners.length),this._deliverQueue(H)}this._perfMon?.stop()}hasListeners(){return this._size>0}}t.Emitter=l;const n=()=>new s;t.createEventDeliveryQueue=n;class s{constructor(){this.i=-1,this.end=0}enqueue(T,H,J){this.i=0,this.end=J,this.current=T,this.value=H}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class h extends l{async fireAsync(T,H,J){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new c.LinkedList),N(this._listeners,Y=>this._asyncDeliveryQueue.push([Y.value,T]));this._asyncDeliveryQueue.size>0&&!H.isCancellationRequested;){const[Y,$]=this._asyncDeliveryQueue.shift(),G=[],K={...$,token:H,waitUntil:ee=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");J&&(ee=J(ee,Y)),G.push(ee)}};try{Y(K)}catch(ee){(0,i.onUnexpectedError)(ee);continue}Object.freeze(G),await Promise.allSettled(G).then(ee=>{for(const P of ee)P.status==="rejected"&&(0,i.onUnexpectedError)(P.reason)})}}}t.AsyncEmitter=h;class f extends l{get isPaused(){return this._isPaused!==0}constructor(T){super(T),this._isPaused=0,this._eventQueue=new c.LinkedList,this._mergeFn=T?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const T=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(T))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(T){this._size&&(this._isPaused!==0?this._eventQueue.push(T):super.fire(T))}}t.PauseableEmitter=f;class w extends f{constructor(T){super(T),this._delay=T.delay??100}fire(T){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(T)}}t.DebounceEmitter=w;class R extends l{constructor(T){super(T),this._queuedEvents=[],this._mergeFn=T?.merge}fire(T){this.hasListeners()&&(this._queuedEvents.push(T),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(H=>super.fire(H)),this._queuedEvents=[]}))}}t.MicrotaskEmitter=R;class M{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(T){const H={event:T,listener:null};this.events.push(H),this.hasListeners&&this.hook(H);const J=()=>{this.hasListeners&&this.unhook(H);const Y=this.events.indexOf(H);this.events.splice(Y,1)};return(0,y.toDisposable)((0,D.createSingleCallFunction)(J))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(T=>this.hook(T))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(T=>this.unhook(T))}hook(T){T.listener=T.event(H=>this.emitter.fire(H))}unhook(T){T.listener?.dispose(),T.listener=null}dispose(){this.emitter.dispose();for(const T of this.events)T.listener?.dispose();this.events=[]}}t.EventMultiplexer=M;class S{constructor(T,H,J,Y){this._store=new y.DisposableStore;const $=this._store.add(new M),G=this._store.add(new y.DisposableMap);function K(ee){G.set(ee,$.add(Y(ee)))}for(const ee of T)K(ee);this._store.add(H(ee=>{K(ee)})),this._store.add(J(ee=>{G.deleteAndDispose(ee)})),this.event=$.event}dispose(){this._store.dispose()}}t.DynamicListEventMultiplexer=S;class F{constructor(){this.buffers=[]}wrapEvent(T){return(H,J,Y)=>T($=>{const G=this.buffers[this.buffers.length-1];G?G.push(()=>H.call(J,$)):H.call(J,$)},void 0,Y)}bufferEvents(T){const H=[];this.buffers.push(H);const J=T();return this.buffers.pop(),H.forEach(Y=>Y()),J}}t.EventBufferer=F;class C{constructor(){this.listening=!1,this.inputEvent=o.None,this.inputEventListener=y.Disposable.None,this.emitter=new l({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(T){this.inputEvent=T,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=T(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=C;class I{static const(T){return new x(T)}constructor(T){this._value=T,this._onDidChange=new l,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(T){T!==this._value&&(this._value=T,this._onDidChange.fire(void 0))}}t.ValueWithChangeEvent=I;class x{constructor(T){this.value=T,this.onDidChange=o.None}}}),ie(se[24],ue([0,1,12]),function(W,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0,t.cancelOnDispose=g;const D=Object.freeze(function(u,a){const o=setTimeout(u.bind(a),0);return{dispose(){clearTimeout(o)}}});var y;(function(u){function a(o){return o===u.None||o===u.Cancelled||o instanceof c?!0:!o||typeof o!="object"?!1:typeof o.isCancellationRequested=="boolean"&&typeof o.onCancellationRequested=="function"}u.isCancellationToken=a,u.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),u.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(y||(t.CancellationToken=y={}));class c{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new i.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class p{constructor(a){this._token=void 0,this._parentListener=void 0,this._parentListener=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new c),this._token}cancel(){this._token?this._token instanceof c&&this._token.cancel():this._token=y.Cancelled}dispose(a=!1){a&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof c&&this._token.dispose():this._token=y.None}}t.CancellationTokenSource=p;function g(u){const a=new p;return u.add({dispose(){a.cancel()}}),a.token}}),ie(se[41],ue([0,1,24]),function(W,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0,t.identity=y;class D{constructor(u){this.task=u,this.result=null}get(){if(this.result)return this.result;const u=new i.CancellationTokenSource,a=this.task(u.token);return this.result={promise:a,dispose:()=>{this.result=null,u.cancel(),u.dispose()}},this.result}}t.Cache=D;function y(g){return g}class c{constructor(u,a){this.lastCache=void 0,this.lastArgKey=void 0,typeof u=="function"?(this._fn=u,this._computeKey=y):(this._fn=a,this._computeKey=u.getCacheKey)}get(u){const a=this._computeKey(u);return this.lastArgKey!==a&&(this.lastArgKey=a,this.lastCache=this._fn(u)),this.lastCache}}t.LRUCachedFunction=c;class p{get cachedValues(){return this._map}constructor(u,a){this._map=new Map,this._map2=new Map,typeof u=="function"?(this._fn=u,this._computeKey=y):(this._fn=a,this._computeKey=u.getCacheKey)}get(u){const a=this._computeKey(u);if(this._map2.has(a))return this._map2.get(a);const o=this._fn(u);return this._map.set(u,o),this._map2.set(a,o),o}}t.CachedFunction=p}),ie(se[7],ue([0,1,41,40]),function(W,t,i,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.GraphemeBreakType=t.UTF8_BOM_CHARACTER=t.UNUSUAL_LINE_TERMINATORS=t.GraphemeIterator=t.CodePointIterator=void 0,t.isFalsyOrWhitespace=y,t.format=p,t.format2=u,t.htmlAttributeEncodeValue=a,t.escape=o,t.escapeRegExpCharacters=E,t.count=d,t.truncate=b,t.truncateMiddle=e,t.trim=m,t.ltrim=_,t.rtrim=L,t.convertSimple2RegExpPattern=v,t.stripWildcards=N,t.createRegExp=A,t.regExpLeadsToEndlessLoop=l,t.splitLines=n,t.splitLinesIncludeSeparators=s,t.firstNonWhitespaceIndex=h,t.getLeadingWhitespace=f,t.lastNonWhitespaceIndex=w,t.replaceAsync=R,t.compare=M,t.compareSubstring=S,t.compareIgnoreCase=F,t.compareSubstringIgnoreCase=C,t.isAsciiDigit=I,t.isLowerAsciiLetter=x,t.isUpperAsciiLetter=O,t.equalsIgnoreCase=T,t.startsWithIgnoreCase=H,t.commonPrefixLength=J,t.commonSuffixLength=Y,t.isHighSurrogate=$,t.isLowSurrogate=G,t.computeCodePoint=K,t.getNextCodePoint=ee,t.nextCharLength=he,t.prevCharLength=ve,t.getCharContainingOffset=r,t.charCount=_e,t.containsRTL=ke,t.isBasicASCII=Ce,t.containsUnusualLineTerminators=B,t.isFullWidthCharacter=z,t.isEmojiImprecise=V,t.lcut=X,t.forAnsiStringParts=fe,t.removeAnsiEscapeCodes=me,t.startsWithUTF8BOM=re,t.stripUTF8BOM=U,t.fuzzyContains=ae,t.containsUppercaseCharacter=ne,t.uppercaseFirstLetter=oe,t.getNLines=ce,t.singleLetterHash=be,t.getGraphemeBreakType=Le,t.getLeftDeleteOffset=We;function y(k){return!k||typeof k!="string"?!0:k.trim().length===0}const c=/{(\d+)}/g;function p(k,...q){return q.length===0?k:k.replace(c,function(j,Z){const le=parseInt(Z,10);return isNaN(le)||le<0||le>=q.length?j:q[le]})}const g=/{([^}]+)}/g;function u(k,q){return Object.keys(q).length===0?k:k.replace(g,(j,Z)=>q[Z]??j)}function a(k){return k.replace(/[<>"'&]/g,q=>{switch(q){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return q})}function o(k){return k.replace(/[<>&]/g,function(q){switch(q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return q}})}function E(k){return k.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function d(k,q){let j=0;const Z=q.charCodeAt(0);for(let le=k.length-1;le>=0;le--)k.charCodeAt(le)===Z&&j++;return j}function b(k,q,j="\u2026"){return k.length<=q?k:`${k.substr(0,q)}${j}`}function e(k,q,j="\u2026"){if(k.length<=q)return k;const Z=Math.ceil(q/2)-j.length/2,le=Math.floor(q/2)-j.length/2;return`${k.substr(0,Z)}${j}${k.substr(k.length-le)}`}function m(k,q=" "){const j=_(k,q);return L(j,q)}function _(k,q){if(!k||!q)return k;const j=q.length;if(j===0||k.length===0)return k;let Z=0;for(;k.indexOf(q,Z)===Z;)Z=Z+j;return k.substring(Z)}function L(k,q){if(!k||!q)return k;const j=q.length,Z=k.length;if(j===0||Z===0)return k;let le=Z,ge=-1;for(;ge=k.lastIndexOf(q,le-1),!(ge===-1||ge+j!==le);){if(ge===0)return"";le=ge}return k.substring(0,le)}function v(k){return k.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function N(k){return k.replace(/\*/g,"")}function A(k,q,j={}){if(!k)throw new Error("Cannot create regex from empty string");q||(k=E(k)),j.wholeWord&&(/\B/.test(k.charAt(0))||(k="\\b"+k),/\B/.test(k.charAt(k.length-1))||(k=k+"\\b"));let Z="";return j.global&&(Z+="g"),j.matchCase||(Z+="i"),j.multiline&&(Z+="m"),j.unicode&&(Z+="u"),new RegExp(k,Z)}function l(k){return k.source==="^"||k.source==="^$"||k.source==="$"||k.source==="^\\s*$"?!1:!!(k.exec("")&&k.lastIndex===0)}function n(k){return k.split(/\r\n|\r|\n/)}function s(k){const q=[],j=k.split(/(\r\n|\r|\n)/);for(let Z=0;Z<Math.ceil(j.length/2);Z++)q.push(j[2*Z]+(j[2*Z+1]??""));return q}function h(k){for(let q=0,j=k.length;q<j;q++){const Z=k.charCodeAt(q);if(Z!==32&&Z!==9)return q}return-1}function f(k,q=0,j=k.length){for(let Z=q;Z<j;Z++){const le=k.charCodeAt(Z);if(le!==32&&le!==9)return k.substring(q,Z)}return k.substring(q,j)}function w(k,q=k.length-1){for(let j=q;j>=0;j--){const Z=k.charCodeAt(j);if(Z!==32&&Z!==9)return j}return-1}function R(k,q,j){const Z=[];let le=0;for(const ge of k.matchAll(q)){if(Z.push(k.slice(le,ge.index)),ge.index===void 0)throw new Error("match.index should be defined");le=ge.index+ge[0].length,Z.push(j(ge[0],...ge.slice(1),ge.index,k,ge.groups))}return Z.push(k.slice(le)),Promise.all(Z).then(ge=>ge.join(""))}function M(k,q){return k<q?-1:k>q?1:0}function S(k,q,j=0,Z=k.length,le=0,ge=q.length){for(;j<Z&&le<ge;j++,le++){const Me=k.charCodeAt(j),ye=q.charCodeAt(le);if(Me<ye)return-1;if(Me>ye)return 1}const Ne=Z-j,Fe=ge-le;return Ne<Fe?-1:Ne>Fe?1:0}function F(k,q){return C(k,q,0,k.length,0,q.length)}function C(k,q,j=0,Z=k.length,le=0,ge=q.length){for(;j<Z&&le<ge;j++,le++){let Me=k.charCodeAt(j),ye=q.charCodeAt(le);if(Me===ye)continue;if(Me>=128||ye>=128)return S(k.toLowerCase(),q.toLowerCase(),j,Z,le,ge);x(Me)&&(Me-=32),x(ye)&&(ye-=32);const Ee=Me-ye;if(Ee!==0)return Ee}const Ne=Z-j,Fe=ge-le;return Ne<Fe?-1:Ne>Fe?1:0}function I(k){return k>=48&&k<=57}function x(k){return k>=97&&k<=122}function O(k){return k>=65&&k<=90}function T(k,q){return k.length===q.length&&C(k,q)===0}function H(k,q){const j=q.length;return q.length>k.length?!1:C(k,q,0,j)===0}function J(k,q){const j=Math.min(k.length,q.length);let Z;for(Z=0;Z<j;Z++)if(k.charCodeAt(Z)!==q.charCodeAt(Z))return Z;return j}function Y(k,q){const j=Math.min(k.length,q.length);let Z;const le=k.length-1,ge=q.length-1;for(Z=0;Z<j;Z++)if(k.charCodeAt(le-Z)!==q.charCodeAt(ge-Z))return Z;return j}function $(k){return 55296<=k&&k<=56319}function G(k){return 56320<=k&&k<=57343}function K(k,q){return(k-55296<<10)+(q-56320)+65536}function ee(k,q,j){const Z=k.charCodeAt(j);if($(Z)&&j+1<q){const le=k.charCodeAt(j+1);if(G(le))return K(Z,le)}return Z}function P(k,q){const j=k.charCodeAt(q-1);if(G(j)&&q>1){const Z=k.charCodeAt(q-2);if($(Z))return K(Z,j)}return j}class Q{get offset(){return this._offset}constructor(q,j=0){this._str=q,this._len=q.length,this._offset=j}setOffset(q){this._offset=q}prevCodePoint(){const q=P(this._str,this._offset);return this._offset-=q>=65536?2:1,q}nextCodePoint(){const q=ee(this._str,this._len,this._offset);return this._offset+=q>=65536?2:1,q}eol(){return this._offset>=this._len}}t.CodePointIterator=Q;class de{get offset(){return this._iterator.offset}constructor(q,j=0){this._iterator=new Q(q,j)}nextGraphemeLength(){const q=Ae.getInstance(),j=this._iterator,Z=j.offset;let le=q.getGraphemeBreakType(j.nextCodePoint());for(;!j.eol();){const ge=j.offset,Ne=q.getGraphemeBreakType(j.nextCodePoint());if(we(le,Ne)){j.setOffset(ge);break}le=Ne}return j.offset-Z}prevGraphemeLength(){const q=Ae.getInstance(),j=this._iterator,Z=j.offset;let le=q.getGraphemeBreakType(j.prevCodePoint());for(;j.offset>0;){const ge=j.offset,Ne=q.getGraphemeBreakType(j.prevCodePoint());if(we(Ne,le)){j.setOffset(ge);break}le=Ne}return Z-j.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=de;function he(k,q){return new de(k,q).nextGraphemeLength()}function ve(k,q){return new de(k,q).prevGraphemeLength()}function r(k,q){q>0&&G(k.charCodeAt(q))&&q--;const j=q+he(k,q);return[j-ve(k,j),j]}function _e(k){const q=new de(k);let j=0;for(;!q.eol();)j++,q.nextGraphemeLength();return j}let Re;function qe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ke(k){return Re||(Re=qe()),Re.test(k)}const Se=/^[\t\n\r\x20-\x7E]*$/;function Ce(k){return Se.test(k)}t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function B(k){return t.UNUSUAL_LINE_TERMINATORS.test(k)}function z(k){return k>=11904&&k<=55215||k>=63744&&k<=64255||k>=65281&&k<=65374}function V(k){return k>=127462&&k<=127487||k===8986||k===8987||k===9200||k===9203||k>=9728&&k<=10175||k===11088||k===11093||k>=127744&&k<=128591||k>=128640&&k<=128764||k>=128992&&k<=129008||k>=129280&&k<=129535||k>=129648&&k<=129782}function X(k,q,j=""){const Z=k.trimStart();if(Z.length<q)return Z;const le=/\b/g;let ge=0;for(;le.test(Z)&&!(Z.length-le.lastIndex<q);)ge=le.lastIndex,le.lastIndex+=1;return ge===0?Z:j+Z.substring(ge).trimStart()}const te=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*fe(k){let q=0;for(const j of k.matchAll(te))q!==j.index&&(yield{isCode:!1,str:k.substring(q,j.index)}),yield{isCode:!0,str:j[0]},q=j.index+j[0].length;q!==k.length&&(yield{isCode:!1,str:k.substring(q)})}function me(k){return k&&(k=k.replace(te,"")),k}t.UTF8_BOM_CHARACTER="\uFEFF";function re(k){return!!(k&&k.length>0&&k.charCodeAt(0)===65279)}function U(k){return re(k)?k.substr(1):k}function ae(k,q){if(!k||!q||k.length<q.length)return!1;const j=q.length,Z=k.toLowerCase();let le=0,ge=-1;for(;le<j;){const Ne=Z.indexOf(q[le],ge+1);if(Ne<0)return!1;ge=Ne,le++}return!0}function ne(k,q=!1){return k?(q&&(k=k.replace(/\\./g,"")),k.toLowerCase()!==k):!1}function oe(k){return k.charAt(0).toUpperCase()+k.slice(1)}function ce(k,q=1){if(q===0)return"";let j=-1;do j=k.indexOf(`
`,j+1),q--;while(q>0&&j>=0);return j===-1?k:(k[j-1]==="\r"&&j--,k.substr(0,j))}function be(k){return k=k%(2*26),k<26?String.fromCharCode(97+k):String.fromCharCode(65+k-26)}function Le(k){return Ae.getInstance().getGraphemeBreakType(k)}function we(k,q){return k===0?q!==5&&q!==7:k===2&&q===3?!1:k===4||k===2||k===3||q===4||q===2||q===3?!0:!(k===8&&(q===8||q===9||q===11||q===12)||(k===11||k===9)&&(q===9||q===10)||(k===12||k===10)&&q===10||q===5||q===13||q===7||k===1||k===13&&q===14||k===6&&q===6)}var Pe;(function(k){k[k.Other=0]="Other",k[k.Prepend=1]="Prepend",k[k.CR=2]="CR",k[k.LF=3]="LF",k[k.Control=4]="Control",k[k.Extend=5]="Extend",k[k.Regional_Indicator=6]="Regional_Indicator",k[k.SpacingMark=7]="SpacingMark",k[k.L=8]="L",k[k.V=9]="V",k[k.T=10]="T",k[k.LV=11]="LV",k[k.LVT=12]="LVT",k[k.ZWJ=13]="ZWJ",k[k.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(t.GraphemeBreakType=Pe={}));class Ae{static{this._INSTANCE=null}static getInstance(){return Ae._INSTANCE||(Ae._INSTANCE=new Ae),Ae._INSTANCE}constructor(){this._data=Te()}getGraphemeBreakType(q){if(q<32)return q===10?3:q===13?2:4;if(q<127)return 0;const j=this._data,Z=j.length/3;let le=1;for(;le<=Z;)if(q<j[3*le])le=2*le;else if(q>j[3*le+1])le=2*le+1;else return j[3*le+2];return 0}}function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(k,q){if(k===0)return 0;const j=Ie(k,q);if(j!==void 0)return j;const Z=new Q(q,k);return Z.prevCodePoint(),Z.offset}function Ie(k,q){const j=new Q(q,k);let Z=j.prevCodePoint();for(;He(Z)||Z===65039||Z===8419;){if(j.offset===0)return;Z=j.prevCodePoint()}if(!V(Z))return;let le=j.offset;return le>0&&j.prevCodePoint()===8205&&(le=j.offset),le}function He(k){return 127995<=k&&k<=127999}var Ve;(function(k){k[k.zwj=8205]="zwj",k[k.emojiVariantSelector=65039]="emojiVariantSelector",k[k.enclosingKeyCap=8419]="enclosingKeyCap"})(Ve||(Ve={})),t.noBreakWhitespace="\xA0";class Oe{static{this.ambiguousCharacterData=new D.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new i.LRUCachedFunction({getCacheKey:JSON.stringify},q=>{function j(Ee){const xe=new Map;for(let De=0;De<Ee.length;De+=2)xe.set(Ee[De],Ee[De+1]);return xe}function Z(Ee,xe){const De=new Map(Ee);for(const[ze,je]of xe)De.set(ze,je);return De}function le(Ee,xe){if(!Ee)return xe;const De=new Map;for(const[ze,je]of Ee)xe.has(ze)&&De.set(ze,je);return De}const ge=this.ambiguousCharacterData.value;let Ne=q.filter(Ee=>!Ee.startsWith("_")&&Ee in ge);Ne.length===0&&(Ne=["_default"]);let Fe;for(const Ee of Ne){const xe=j(ge[Ee]);Fe=le(Fe,xe)}const Me=j(ge._common),ye=Z(Me,Fe);return new Oe(ye)})}static getInstance(q){return Oe.cache.get(Array.from(q))}static{this._locales=new D.Lazy(()=>Object.keys(Oe.ambiguousCharacterData.value).filter(q=>!q.startsWith("_")))}static getLocales(){return Oe._locales.value}constructor(q){this.confusableDictionary=q}isAmbiguous(q){return this.confusableDictionary.has(q)}getPrimaryConfusable(q){return this.confusableDictionary.get(q)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=Oe;class Be{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Be.getRawData())),this._data}static isInvisibleCharacter(q){return Be.getData().has(q)}static get codePoints(){return Be.getData()}}t.InvisibleCharacters=Be}),ie(se[42],ue([0,1,7]),function(W,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.Hasher=void 0,t.hash=D,t.doHash=y,t.numberHash=c,t.stringHash=g,t.toHexString=m;function D(L){return y(L,0)}function y(L,v){switch(typeof L){case"object":return L===null?c(349,v):Array.isArray(L)?u(L,v):a(L,v);case"string":return g(L,v);case"boolean":return p(L,v);case"number":return c(L,v);case"undefined":return c(937,v);default:return c(617,v)}}function c(L,v){return(v<<5)-v+L|0}function p(L,v){return c(L?433:863,v)}function g(L,v){v=c(149417,v);for(let N=0,A=L.length;N<A;N++)v=c(L.charCodeAt(N),v);return v}function u(L,v){return v=c(104579,v),L.reduce((N,A)=>y(A,N),v)}function a(L,v){return v=c(181387,v),Object.keys(L).sort().reduce((N,A)=>(N=g(A,N),y(L[A],N)),v)}class o{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=y(v,this._value),this._value}}t.Hasher=o;var E;(function(L){L[L.BLOCK_SIZE=64]="BLOCK_SIZE",L[L.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function d(L,v,N=32){const A=N-v,l=~((1<<A)-1);return(L<<v|(l&L)>>>A)>>>0}function b(L,v=0,N=L.byteLength,A=0){for(let l=0;l<N;l++)L[v+l]=A}function e(L,v,N="0"){for(;L.length<v;)L=N+L;return L}function m(L,v=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(N=>N.toString(16).padStart(2,"0")).join(""):e((L>>>0).toString(16),v/4)}class _{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const N=v.length;if(N===0)return;const A=this._buff;let l=this._buffLen,n=this._leftoverHighSurrogate,s,h;for(n!==0?(s=n,h=-1,n=0):(s=v.charCodeAt(0),h=0);;){let f=s;if(i.isHighSurrogate(s))if(h+1<N){const w=v.charCodeAt(h+1);i.isLowSurrogate(w)?(h++,f=i.computeCodePoint(s,w)):f=65533}else{n=s;break}else i.isLowSurrogate(s)&&(f=65533);if(l=this._push(A,l,f),h++,h<N)s=v.charCodeAt(h);else break}this._buffLen=l,this._leftoverHighSurrogate=n}_push(v,N,A){return A<128?v[N++]=A:A<2048?(v[N++]=192|(A&1984)>>>6,v[N++]=128|(A&63)>>>0):A<65536?(v[N++]=224|(A&61440)>>>12,v[N++]=128|(A&4032)>>>6,v[N++]=128|(A&63)>>>0):(v[N++]=240|(A&1835008)>>>18,v[N++]=128|(A&258048)>>>12,v[N++]=128|(A&4032)>>>6,v[N++]=128|(A&63)>>>0),N>=64&&(this._step(),N-=64,this._totalLen+=64,v[0]=v[64],v[1]=v[65],v[2]=v[66]),N}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=_._bigBlock32,N=this._buffDV;for(let M=0;M<64;M+=4)v.setUint32(M,N.getUint32(M,!1),!1);for(let M=64;M<320;M+=4)v.setUint32(M,d(v.getUint32(M-12,!1)^v.getUint32(M-32,!1)^v.getUint32(M-56,!1)^v.getUint32(M-64,!1),1),!1);let A=this._h0,l=this._h1,n=this._h2,s=this._h3,h=this._h4,f,w,R;for(let M=0;M<80;M++)M<20?(f=l&n|~l&s,w=1518500249):M<40?(f=l^n^s,w=1859775393):M<60?(f=l&n|l&s|n&s,w=2400959708):(f=l^n^s,w=3395469782),R=d(A,5)+f+h+w+v.getUint32(M*4,!1)&4294967295,h=s,s=n,n=d(l,30),l=A,A=R;this._h0=this._h0+A&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+h&4294967295}}t.StringSHA1=_}),ie(se[25],ue([0,1,38,42]),function(W,t,i,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.StringDiffSequence=void 0,t.stringDiff=c;class y{constructor(d){this.source=d}getElements(){const d=this.source,b=new Int32Array(d.length);for(let e=0,m=d.length;e<m;e++)b[e]=d.charCodeAt(e);return b}}t.StringDiffSequence=y;function c(E,d,b){return new o(new y(E),new y(d)).ComputeDiff(b).changes}class p{static Assert(d,b){if(!d)throw new Error(b)}}class g{static Copy(d,b,e,m,_){for(let L=0;L<_;L++)e[m+L]=d[b+L]}static Copy2(d,b,e,m,_){for(let L=0;L<_;L++)e[m+L]=d[b+L]}}var u;(function(E){E[E.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(u||(u={}));class a{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new i.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(d,b){this.m_originalStart=Math.min(this.m_originalStart,d),this.m_modifiedStart=Math.min(this.m_modifiedStart,b),this.m_originalCount++}AddModifiedElement(d,b){this.m_originalStart=Math.min(this.m_originalStart,d),this.m_modifiedStart=Math.min(this.m_modifiedStart,b),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class o{constructor(d,b,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=d,this._modifiedSequence=b;const[m,_,L]=o._getElements(d),[v,N,A]=o._getElements(b);this._hasStrings=L&&A,this._originalStringElements=m,this._originalElementsOrHash=_,this._modifiedStringElements=v,this._modifiedElementsOrHash=N,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(d){return d.length>0&&typeof d[0]=="string"}static _getElements(d){const b=d.getElements();if(o._isStringArray(b)){const e=new Int32Array(b.length);for(let m=0,_=b.length;m<_;m++)e[m]=(0,D.stringHash)(b[m],0);return[b,e,!0]}return b instanceof Int32Array?[[],b,!1]:[[],new Int32Array(b),!1]}ElementsAreEqual(d,b){return this._originalElementsOrHash[d]!==this._modifiedElementsOrHash[b]?!1:this._hasStrings?this._originalStringElements[d]===this._modifiedStringElements[b]:!0}ElementsAreStrictEqual(d,b){if(!this.ElementsAreEqual(d,b))return!1;const e=o._getStrictElement(this._originalSequence,d),m=o._getStrictElement(this._modifiedSequence,b);return e===m}static _getStrictElement(d,b){return typeof d.getStrictElement=="function"?d.getStrictElement(b):null}OriginalElementsAreEqual(d,b){return this._originalElementsOrHash[d]!==this._originalElementsOrHash[b]?!1:this._hasStrings?this._originalStringElements[d]===this._originalStringElements[b]:!0}ModifiedElementsAreEqual(d,b){return this._modifiedElementsOrHash[d]!==this._modifiedElementsOrHash[b]?!1:this._hasStrings?this._modifiedStringElements[d]===this._modifiedStringElements[b]:!0}ComputeDiff(d){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,d)}_ComputeDiff(d,b,e,m,_){const L=[!1];let v=this.ComputeDiffRecursive(d,b,e,m,L);return _&&(v=this.PrettifyChanges(v)),{quitEarly:L[0],changes:v}}ComputeDiffRecursive(d,b,e,m,_){for(_[0]=!1;d<=b&&e<=m&&this.ElementsAreEqual(d,e);)d++,e++;for(;b>=d&&m>=e&&this.ElementsAreEqual(b,m);)b--,m--;if(d>b||e>m){let n;return e<=m?(p.Assert(d===b+1,"originalStart should only be one more than originalEnd"),n=[new i.DiffChange(d,0,e,m-e+1)]):d<=b?(p.Assert(e===m+1,"modifiedStart should only be one more than modifiedEnd"),n=[new i.DiffChange(d,b-d+1,e,0)]):(p.Assert(d===b+1,"originalStart should only be one more than originalEnd"),p.Assert(e===m+1,"modifiedStart should only be one more than modifiedEnd"),n=[]),n}const L=[0],v=[0],N=this.ComputeRecursionPoint(d,b,e,m,L,v,_),A=L[0],l=v[0];if(N!==null)return N;if(!_[0]){const n=this.ComputeDiffRecursive(d,A,e,l,_);let s=[];return _[0]?s=[new i.DiffChange(A+1,b-(A+1)+1,l+1,m-(l+1)+1)]:s=this.ComputeDiffRecursive(A+1,b,l+1,m,_),this.ConcatenateChanges(n,s)}return[new i.DiffChange(d,b-d+1,e,m-e+1)]}WALKTRACE(d,b,e,m,_,L,v,N,A,l,n,s,h,f,w,R,M,S){let F=null,C=null,I=new a,x=b,O=e,T=h[0]-R[0]-m,H=-1073741824,J=this.m_forwardHistory.length-1;do{const Y=T+d;Y===x||Y<O&&A[Y-1]<A[Y+1]?(n=A[Y+1],f=n-T-m,n<H&&I.MarkNextChange(),H=n,I.AddModifiedElement(n+1,f),T=Y+1-d):(n=A[Y-1]+1,f=n-T-m,n<H&&I.MarkNextChange(),H=n-1,I.AddOriginalElement(n,f+1),T=Y-1-d),J>=0&&(A=this.m_forwardHistory[J],d=A[0],x=1,O=A.length-1)}while(--J>=-1);if(F=I.getReverseChanges(),S[0]){let Y=h[0]+1,$=R[0]+1;if(F!==null&&F.length>0){const G=F[F.length-1];Y=Math.max(Y,G.getOriginalEnd()),$=Math.max($,G.getModifiedEnd())}C=[new i.DiffChange(Y,s-Y+1,$,w-$+1)]}else{I=new a,x=L,O=v,T=h[0]-R[0]-N,H=1073741824,J=M?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const Y=T+_;Y===x||Y<O&&l[Y-1]>=l[Y+1]?(n=l[Y+1]-1,f=n-T-N,n>H&&I.MarkNextChange(),H=n+1,I.AddOriginalElement(n+1,f+1),T=Y+1-_):(n=l[Y-1],f=n-T-N,n>H&&I.MarkNextChange(),H=n,I.AddModifiedElement(n+1,f+1),T=Y-1-_),J>=0&&(l=this.m_reverseHistory[J],_=l[0],x=1,O=l.length-1)}while(--J>=-1);C=I.getChanges()}return this.ConcatenateChanges(F,C)}ComputeRecursionPoint(d,b,e,m,_,L,v){let N=0,A=0,l=0,n=0,s=0,h=0;d--,e--,_[0]=0,L[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const f=b-d+(m-e),w=f+1,R=new Int32Array(w),M=new Int32Array(w),S=m-e,F=b-d,C=d-e,I=b-m,O=(F-S)%2===0;R[S]=d,M[F]=b,v[0]=!1;for(let T=1;T<=f/2+1;T++){let H=0,J=0;l=this.ClipDiagonalBound(S-T,T,S,w),n=this.ClipDiagonalBound(S+T,T,S,w);for(let $=l;$<=n;$+=2){$===l||$<n&&R[$-1]<R[$+1]?N=R[$+1]:N=R[$-1]+1,A=N-($-S)-C;const G=N;for(;N<b&&A<m&&this.ElementsAreEqual(N+1,A+1);)N++,A++;if(R[$]=N,N+A>H+J&&(H=N,J=A),!O&&Math.abs($-F)<=T-1&&N>=M[$])return _[0]=N,L[0]=A,G<=M[$]&&1447>0&&T<=1448?this.WALKTRACE(S,l,n,C,F,s,h,I,R,M,N,b,_,A,m,L,O,v):null}const Y=(H-d+(J-e)-T)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(H,Y))return v[0]=!0,_[0]=H,L[0]=J,Y>0&&1447>0&&T<=1448?this.WALKTRACE(S,l,n,C,F,s,h,I,R,M,N,b,_,A,m,L,O,v):(d++,e++,[new i.DiffChange(d,b-d+1,e,m-e+1)]);s=this.ClipDiagonalBound(F-T,T,F,w),h=this.ClipDiagonalBound(F+T,T,F,w);for(let $=s;$<=h;$+=2){$===s||$<h&&M[$-1]>=M[$+1]?N=M[$+1]-1:N=M[$-1],A=N-($-F)-I;const G=N;for(;N>d&&A>e&&this.ElementsAreEqual(N,A);)N--,A--;if(M[$]=N,O&&Math.abs($-S)<=T&&N<=R[$])return _[0]=N,L[0]=A,G>=R[$]&&1447>0&&T<=1448?this.WALKTRACE(S,l,n,C,F,s,h,I,R,M,N,b,_,A,m,L,O,v):null}if(T<=1447){let $=new Int32Array(n-l+2);$[0]=S-l+1,g.Copy2(R,l,$,1,n-l+1),this.m_forwardHistory.push($),$=new Int32Array(h-s+2),$[0]=F-s+1,g.Copy2(M,s,$,1,h-s+1),this.m_reverseHistory.push($)}}return this.WALKTRACE(S,l,n,C,F,s,h,I,R,M,N,b,_,A,m,L,O,v)}PrettifyChanges(d){for(let b=0;b<d.length;b++){const e=d[b],m=b<d.length-1?d[b+1].originalStart:this._originalElementsOrHash.length,_=b<d.length-1?d[b+1].modifiedStart:this._modifiedElementsOrHash.length,L=e.originalLength>0,v=e.modifiedLength>0;for(;e.originalStart+e.originalLength<m&&e.modifiedStart+e.modifiedLength<_&&(!L||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!v||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const A=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!A)break;e.originalStart++,e.modifiedStart++}const N=[null];if(b<d.length-1&&this.ChangesOverlap(d[b],d[b+1],N)){d[b]=N[0],d.splice(b+1,1),b--;continue}}for(let b=d.length-1;b>=0;b--){const e=d[b];let m=0,_=0;if(b>0){const n=d[b-1];m=n.originalStart+n.originalLength,_=n.modifiedStart+n.modifiedLength}const L=e.originalLength>0,v=e.modifiedLength>0;let N=0,A=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let n=1;;n++){const s=e.originalStart-n,h=e.modifiedStart-n;if(s<m||h<_||L&&!this.OriginalElementsAreEqual(s,s+e.originalLength)||v&&!this.ModifiedElementsAreEqual(h,h+e.modifiedLength))break;const w=(s===m&&h===_?5:0)+this._boundaryScore(s,e.originalLength,h,e.modifiedLength);w>A&&(A=w,N=n)}e.originalStart-=N,e.modifiedStart-=N;const l=[null];if(b>0&&this.ChangesOverlap(d[b-1],d[b],l)){d[b-1]=l[0],d.splice(b,1),b++;continue}}if(this._hasStrings)for(let b=1,e=d.length;b<e;b++){const m=d[b-1],_=d[b],L=_.originalStart-m.originalStart-m.originalLength,v=m.originalStart,N=_.originalStart+_.originalLength,A=N-v,l=m.modifiedStart,n=_.modifiedStart+_.modifiedLength,s=n-l;if(L<5&&A<20&&s<20){const h=this._findBetterContiguousSequence(v,A,l,s,L);if(h){const[f,w]=h;(f!==m.originalStart+m.originalLength||w!==m.modifiedStart+m.modifiedLength)&&(m.originalLength=f-m.originalStart,m.modifiedLength=w-m.modifiedStart,_.originalStart=f+L,_.modifiedStart=w+L,_.originalLength=N-_.originalStart,_.modifiedLength=n-_.modifiedStart)}}}return d}_findBetterContiguousSequence(d,b,e,m,_){if(b<_||m<_)return null;const L=d+b-_+1,v=e+m-_+1;let N=0,A=0,l=0;for(let n=d;n<L;n++)for(let s=e;s<v;s++){const h=this._contiguousSequenceScore(n,s,_);h>0&&h>N&&(N=h,A=n,l=s)}return N>0?[A,l]:null}_contiguousSequenceScore(d,b,e){let m=0;for(let _=0;_<e;_++){if(!this.ElementsAreEqual(d+_,b+_))return 0;m+=this._originalStringElements[d+_].length}return m}_OriginalIsBoundary(d){return d<=0||d>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[d])}_OriginalRegionIsBoundary(d,b){if(this._OriginalIsBoundary(d)||this._OriginalIsBoundary(d-1))return!0;if(b>0){const e=d+b;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(d){return d<=0||d>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[d])}_ModifiedRegionIsBoundary(d,b){if(this._ModifiedIsBoundary(d)||this._ModifiedIsBoundary(d-1))return!0;if(b>0){const e=d+b;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(d,b,e,m){const _=this._OriginalRegionIsBoundary(d,b)?1:0,L=this._ModifiedRegionIsBoundary(e,m)?1:0;return _+L}ConcatenateChanges(d,b){const e=[];if(d.length===0||b.length===0)return b.length>0?b:d;if(this.ChangesOverlap(d[d.length-1],b[0],e)){const m=new Array(d.length+b.length-1);return g.Copy(d,0,m,0,d.length-1),m[d.length-1]=e[0],g.Copy(b,1,m,d.length,b.length-1),m}else{const m=new Array(d.length+b.length);return g.Copy(d,0,m,0,d.length),g.Copy(b,0,m,d.length,b.length),m}}ChangesOverlap(d,b,e){if(p.Assert(d.originalStart<=b.originalStart,"Left change is not less than or equal to right change"),p.Assert(d.modifiedStart<=b.modifiedStart,"Left change is not less than or equal to right change"),d.originalStart+d.originalLength>=b.originalStart||d.modifiedStart+d.modifiedLength>=b.modifiedStart){const m=d.originalStart;let _=d.originalLength;const L=d.modifiedStart;let v=d.modifiedLength;return d.originalStart+d.originalLength>=b.originalStart&&(_=b.originalStart+b.originalLength-d.originalStart),d.modifiedStart+d.modifiedLength>=b.modifiedStart&&(v=b.modifiedStart+b.modifiedLength-d.modifiedStart),e[0]=new i.DiffChange(m,_,L,v),!0}else return e[0]=null,!1}ClipDiagonalBound(d,b,e,m){if(d>=0&&d<m)return d;const _=e,L=m-e-1,v=b%2===0;if(d<0){const N=_%2===0;return v===N?0:1}else{const N=L%2===0;return v===N?m-1:m-2}}}t.LcsDiff=o}),ie(se[26],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isString=i,t.isStringArray=D,t.isObject=y,t.isTypedArray=c,t.isNumber=p,t.isIterable=g,t.isBoolean=u,t.isUndefined=a,t.isDefined=o,t.isUndefinedOrNull=E,t.assertType=d,t.assertIsDefined=b,t.assertAllDefined=e,t.isEmptyObject=_,t.isFunction=L,t.areFunctions=v,t.validateConstraints=N,t.validateConstraint=A;function i(l){return typeof l=="string"}function D(l){return Array.isArray(l)&&l.every(n=>i(n))}function y(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}function c(l){const n=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof n}function p(l){return typeof l=="number"&&!isNaN(l)}function g(l){return!!l&&typeof l[Symbol.iterator]=="function"}function u(l){return l===!0||l===!1}function a(l){return typeof l>"u"}function o(l){return!E(l)}function E(l){return a(l)||l===null}function d(l,n){if(!l)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function b(l){if(E(l))throw new Error("Assertion Failed: argument is undefined or null");return l}function e(...l){const n=[];for(let s=0;s<l.length;s++){const h=l[s];if(E(h))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(h)}return n}const m=Object.prototype.hasOwnProperty;function _(l){if(!y(l))return!1;for(const n in l)if(m.call(l,n))return!1;return!0}function L(l){return typeof l=="function"}function v(...l){return l.length>0&&l.every(L)}function N(l,n){const s=Math.min(l.length,n.length);for(let h=0;h<s;h++)A(l[h],n[h])}function A(l,n){if(i(n)){if(typeof l!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(L(n)){try{if(l instanceof n)return}catch{}if(!E(l)&&l.constructor===n||n.length===1&&n.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),ie(se[27],ue([0,1,26]),function(W,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.register=y,t.getCodiconFontCharacters=c;const D=Object.create(null);function y(p,g){if((0,i.isString)(g)){const u=D[g];if(u===void 0)throw new Error(`${p} references an unknown codicon: ${g}`);g=u}return D[p]=g,{id:p}}function c(){return D}}),ie(se[43],ue([0,1,27]),function(W,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.codiconsLibrary=void 0,t.codiconsLibrary={add:(0,i.register)("add",6e4),plus:(0,i.register)("plus",6e4),gistNew:(0,i.register)("gist-new",6e4),repoCreate:(0,i.register)("repo-create",6e4),lightbulb:(0,i.register)("lightbulb",60001),lightBulb:(0,i.register)("light-bulb",60001),repo:(0,i.register)("repo",60002),repoDelete:(0,i.register)("repo-delete",60002),gistFork:(0,i.register)("gist-fork",60003),repoForked:(0,i.register)("repo-forked",60003),gitPullRequest:(0,i.register)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.register)("git-pull-request-abandoned",60004),recordKeys:(0,i.register)("record-keys",60005),keyboard:(0,i.register)("keyboard",60005),tag:(0,i.register)("tag",60006),gitPullRequestLabel:(0,i.register)("git-pull-request-label",60006),tagAdd:(0,i.register)("tag-add",60006),tagRemove:(0,i.register)("tag-remove",60006),person:(0,i.register)("person",60007),personFollow:(0,i.register)("person-follow",60007),personOutline:(0,i.register)("person-outline",60007),personFilled:(0,i.register)("person-filled",60007),gitBranch:(0,i.register)("git-branch",60008),gitBranchCreate:(0,i.register)("git-branch-create",60008),gitBranchDelete:(0,i.register)("git-branch-delete",60008),sourceControl:(0,i.register)("source-control",60008),mirror:(0,i.register)("mirror",60009),mirrorPublic:(0,i.register)("mirror-public",60009),star:(0,i.register)("star",60010),starAdd:(0,i.register)("star-add",60010),starDelete:(0,i.register)("star-delete",60010),starEmpty:(0,i.register)("star-empty",60010),comment:(0,i.register)("comment",60011),commentAdd:(0,i.register)("comment-add",60011),alert:(0,i.register)("alert",60012),warning:(0,i.register)("warning",60012),search:(0,i.register)("search",60013),searchSave:(0,i.register)("search-save",60013),logOut:(0,i.register)("log-out",60014),signOut:(0,i.register)("sign-out",60014),logIn:(0,i.register)("log-in",60015),signIn:(0,i.register)("sign-in",60015),eye:(0,i.register)("eye",60016),eyeUnwatch:(0,i.register)("eye-unwatch",60016),eyeWatch:(0,i.register)("eye-watch",60016),circleFilled:(0,i.register)("circle-filled",60017),primitiveDot:(0,i.register)("primitive-dot",60017),closeDirty:(0,i.register)("close-dirty",60017),debugBreakpoint:(0,i.register)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.register)("debug-breakpoint-disabled",60017),debugHint:(0,i.register)("debug-hint",60017),terminalDecorationSuccess:(0,i.register)("terminal-decoration-success",60017),primitiveSquare:(0,i.register)("primitive-square",60018),edit:(0,i.register)("edit",60019),pencil:(0,i.register)("pencil",60019),info:(0,i.register)("info",60020),issueOpened:(0,i.register)("issue-opened",60020),gistPrivate:(0,i.register)("gist-private",60021),gitForkPrivate:(0,i.register)("git-fork-private",60021),lock:(0,i.register)("lock",60021),mirrorPrivate:(0,i.register)("mirror-private",60021),close:(0,i.register)("close",60022),removeClose:(0,i.register)("remove-close",60022),x:(0,i.register)("x",60022),repoSync:(0,i.register)("repo-sync",60023),sync:(0,i.register)("sync",60023),clone:(0,i.register)("clone",60024),desktopDownload:(0,i.register)("desktop-download",60024),beaker:(0,i.register)("beaker",60025),microscope:(0,i.register)("microscope",60025),vm:(0,i.register)("vm",60026),deviceDesktop:(0,i.register)("device-desktop",60026),file:(0,i.register)("file",60027),fileText:(0,i.register)("file-text",60027),more:(0,i.register)("more",60028),ellipsis:(0,i.register)("ellipsis",60028),kebabHorizontal:(0,i.register)("kebab-horizontal",60028),mailReply:(0,i.register)("mail-reply",60029),reply:(0,i.register)("reply",60029),organization:(0,i.register)("organization",60030),organizationFilled:(0,i.register)("organization-filled",60030),organizationOutline:(0,i.register)("organization-outline",60030),newFile:(0,i.register)("new-file",60031),fileAdd:(0,i.register)("file-add",60031),newFolder:(0,i.register)("new-folder",60032),fileDirectoryCreate:(0,i.register)("file-directory-create",60032),trash:(0,i.register)("trash",60033),trashcan:(0,i.register)("trashcan",60033),history:(0,i.register)("history",60034),clock:(0,i.register)("clock",60034),folder:(0,i.register)("folder",60035),fileDirectory:(0,i.register)("file-directory",60035),symbolFolder:(0,i.register)("symbol-folder",60035),logoGithub:(0,i.register)("logo-github",60036),markGithub:(0,i.register)("mark-github",60036),github:(0,i.register)("github",60036),terminal:(0,i.register)("terminal",60037),console:(0,i.register)("console",60037),repl:(0,i.register)("repl",60037),zap:(0,i.register)("zap",60038),symbolEvent:(0,i.register)("symbol-event",60038),error:(0,i.register)("error",60039),stop:(0,i.register)("stop",60039),variable:(0,i.register)("variable",60040),symbolVariable:(0,i.register)("symbol-variable",60040),array:(0,i.register)("array",60042),symbolArray:(0,i.register)("symbol-array",60042),symbolModule:(0,i.register)("symbol-module",60043),symbolPackage:(0,i.register)("symbol-package",60043),symbolNamespace:(0,i.register)("symbol-namespace",60043),symbolObject:(0,i.register)("symbol-object",60043),symbolMethod:(0,i.register)("symbol-method",60044),symbolFunction:(0,i.register)("symbol-function",60044),symbolConstructor:(0,i.register)("symbol-constructor",60044),symbolBoolean:(0,i.register)("symbol-boolean",60047),symbolNull:(0,i.register)("symbol-null",60047),symbolNumeric:(0,i.register)("symbol-numeric",60048),symbolNumber:(0,i.register)("symbol-number",60048),symbolStructure:(0,i.register)("symbol-structure",60049),symbolStruct:(0,i.register)("symbol-struct",60049),symbolParameter:(0,i.register)("symbol-parameter",60050),symbolTypeParameter:(0,i.register)("symbol-type-parameter",60050),symbolKey:(0,i.register)("symbol-key",60051),symbolText:(0,i.register)("symbol-text",60051),symbolReference:(0,i.register)("symbol-reference",60052),goToFile:(0,i.register)("go-to-file",60052),symbolEnum:(0,i.register)("symbol-enum",60053),symbolValue:(0,i.register)("symbol-value",60053),symbolRuler:(0,i.register)("symbol-ruler",60054),symbolUnit:(0,i.register)("symbol-unit",60054),activateBreakpoints:(0,i.register)("activate-breakpoints",60055),archive:(0,i.register)("archive",60056),arrowBoth:(0,i.register)("arrow-both",60057),arrowDown:(0,i.register)("arrow-down",60058),arrowLeft:(0,i.register)("arrow-left",60059),arrowRight:(0,i.register)("arrow-right",60060),arrowSmallDown:(0,i.register)("arrow-small-down",60061),arrowSmallLeft:(0,i.register)("arrow-small-left",60062),arrowSmallRight:(0,i.register)("arrow-small-right",60063),arrowSmallUp:(0,i.register)("arrow-small-up",60064),arrowUp:(0,i.register)("arrow-up",60065),bell:(0,i.register)("bell",60066),bold:(0,i.register)("bold",60067),book:(0,i.register)("book",60068),bookmark:(0,i.register)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.register)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.register)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.register)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.register)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.register)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.register)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.register)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.register)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.register)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.register)("briefcase",60076),broadcast:(0,i.register)("broadcast",60077),browser:(0,i.register)("browser",60078),bug:(0,i.register)("bug",60079),calendar:(0,i.register)("calendar",60080),caseSensitive:(0,i.register)("case-sensitive",60081),check:(0,i.register)("check",60082),checklist:(0,i.register)("checklist",60083),chevronDown:(0,i.register)("chevron-down",60084),chevronLeft:(0,i.register)("chevron-left",60085),chevronRight:(0,i.register)("chevron-right",60086),chevronUp:(0,i.register)("chevron-up",60087),chromeClose:(0,i.register)("chrome-close",60088),chromeMaximize:(0,i.register)("chrome-maximize",60089),chromeMinimize:(0,i.register)("chrome-minimize",60090),chromeRestore:(0,i.register)("chrome-restore",60091),circleOutline:(0,i.register)("circle-outline",60092),circle:(0,i.register)("circle",60092),debugBreakpointUnverified:(0,i.register)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.register)("terminal-decoration-incomplete",60092),circleSlash:(0,i.register)("circle-slash",60093),circuitBoard:(0,i.register)("circuit-board",60094),clearAll:(0,i.register)("clear-all",60095),clippy:(0,i.register)("clippy",60096),closeAll:(0,i.register)("close-all",60097),cloudDownload:(0,i.register)("cloud-download",60098),cloudUpload:(0,i.register)("cloud-upload",60099),code:(0,i.register)("code",60100),collapseAll:(0,i.register)("collapse-all",60101),colorMode:(0,i.register)("color-mode",60102),commentDiscussion:(0,i.register)("comment-discussion",60103),creditCard:(0,i.register)("credit-card",60105),dash:(0,i.register)("dash",60108),dashboard:(0,i.register)("dashboard",60109),database:(0,i.register)("database",60110),debugContinue:(0,i.register)("debug-continue",60111),debugDisconnect:(0,i.register)("debug-disconnect",60112),debugPause:(0,i.register)("debug-pause",60113),debugRestart:(0,i.register)("debug-restart",60114),debugStart:(0,i.register)("debug-start",60115),debugStepInto:(0,i.register)("debug-step-into",60116),debugStepOut:(0,i.register)("debug-step-out",60117),debugStepOver:(0,i.register)("debug-step-over",60118),debugStop:(0,i.register)("debug-stop",60119),debug:(0,i.register)("debug",60120),deviceCameraVideo:(0,i.register)("device-camera-video",60121),deviceCamera:(0,i.register)("device-camera",60122),deviceMobile:(0,i.register)("device-mobile",60123),diffAdded:(0,i.register)("diff-added",60124),diffIgnored:(0,i.register)("diff-ignored",60125),diffModified:(0,i.register)("diff-modified",60126),diffRemoved:(0,i.register)("diff-removed",60127),diffRenamed:(0,i.register)("diff-renamed",60128),diff:(0,i.register)("diff",60129),diffSidebyside:(0,i.register)("diff-sidebyside",60129),discard:(0,i.register)("discard",60130),editorLayout:(0,i.register)("editor-layout",60131),emptyWindow:(0,i.register)("empty-window",60132),exclude:(0,i.register)("exclude",60133),extensions:(0,i.register)("extensions",60134),eyeClosed:(0,i.register)("eye-closed",60135),fileBinary:(0,i.register)("file-binary",60136),fileCode:(0,i.register)("file-code",60137),fileMedia:(0,i.register)("file-media",60138),filePdf:(0,i.register)("file-pdf",60139),fileSubmodule:(0,i.register)("file-submodule",60140),fileSymlinkDirectory:(0,i.register)("file-symlink-directory",60141),fileSymlinkFile:(0,i.register)("file-symlink-file",60142),fileZip:(0,i.register)("file-zip",60143),files:(0,i.register)("files",60144),filter:(0,i.register)("filter",60145),flame:(0,i.register)("flame",60146),foldDown:(0,i.register)("fold-down",60147),foldUp:(0,i.register)("fold-up",60148),fold:(0,i.register)("fold",60149),folderActive:(0,i.register)("folder-active",60150),folderOpened:(0,i.register)("folder-opened",60151),gear:(0,i.register)("gear",60152),gift:(0,i.register)("gift",60153),gistSecret:(0,i.register)("gist-secret",60154),gist:(0,i.register)("gist",60155),gitCommit:(0,i.register)("git-commit",60156),gitCompare:(0,i.register)("git-compare",60157),compareChanges:(0,i.register)("compare-changes",60157),gitMerge:(0,i.register)("git-merge",60158),githubAction:(0,i.register)("github-action",60159),githubAlt:(0,i.register)("github-alt",60160),globe:(0,i.register)("globe",60161),grabber:(0,i.register)("grabber",60162),graph:(0,i.register)("graph",60163),gripper:(0,i.register)("gripper",60164),heart:(0,i.register)("heart",60165),home:(0,i.register)("home",60166),horizontalRule:(0,i.register)("horizontal-rule",60167),hubot:(0,i.register)("hubot",60168),inbox:(0,i.register)("inbox",60169),issueReopened:(0,i.register)("issue-reopened",60171),issues:(0,i.register)("issues",60172),italic:(0,i.register)("italic",60173),jersey:(0,i.register)("jersey",60174),json:(0,i.register)("json",60175),kebabVertical:(0,i.register)("kebab-vertical",60176),key:(0,i.register)("key",60177),law:(0,i.register)("law",60178),lightbulbAutofix:(0,i.register)("lightbulb-autofix",60179),linkExternal:(0,i.register)("link-external",60180),link:(0,i.register)("link",60181),listOrdered:(0,i.register)("list-ordered",60182),listUnordered:(0,i.register)("list-unordered",60183),liveShare:(0,i.register)("live-share",60184),loading:(0,i.register)("loading",60185),location:(0,i.register)("location",60186),mailRead:(0,i.register)("mail-read",60187),mail:(0,i.register)("mail",60188),markdown:(0,i.register)("markdown",60189),megaphone:(0,i.register)("megaphone",60190),mention:(0,i.register)("mention",60191),milestone:(0,i.register)("milestone",60192),gitPullRequestMilestone:(0,i.register)("git-pull-request-milestone",60192),mortarBoard:(0,i.register)("mortar-board",60193),move:(0,i.register)("move",60194),multipleWindows:(0,i.register)("multiple-windows",60195),mute:(0,i.register)("mute",60196),noNewline:(0,i.register)("no-newline",60197),note:(0,i.register)("note",60198),octoface:(0,i.register)("octoface",60199),openPreview:(0,i.register)("open-preview",60200),package:(0,i.register)("package",60201),paintcan:(0,i.register)("paintcan",60202),pin:(0,i.register)("pin",60203),play:(0,i.register)("play",60204),run:(0,i.register)("run",60204),plug:(0,i.register)("plug",60205),preserveCase:(0,i.register)("preserve-case",60206),preview:(0,i.register)("preview",60207),project:(0,i.register)("project",60208),pulse:(0,i.register)("pulse",60209),question:(0,i.register)("question",60210),quote:(0,i.register)("quote",60211),radioTower:(0,i.register)("radio-tower",60212),reactions:(0,i.register)("reactions",60213),references:(0,i.register)("references",60214),refresh:(0,i.register)("refresh",60215),regex:(0,i.register)("regex",60216),remoteExplorer:(0,i.register)("remote-explorer",60217),remote:(0,i.register)("remote",60218),remove:(0,i.register)("remove",60219),replaceAll:(0,i.register)("replace-all",60220),replace:(0,i.register)("replace",60221),repoClone:(0,i.register)("repo-clone",60222),repoForcePush:(0,i.register)("repo-force-push",60223),repoPull:(0,i.register)("repo-pull",60224),repoPush:(0,i.register)("repo-push",60225),report:(0,i.register)("report",60226),requestChanges:(0,i.register)("request-changes",60227),rocket:(0,i.register)("rocket",60228),rootFolderOpened:(0,i.register)("root-folder-opened",60229),rootFolder:(0,i.register)("root-folder",60230),rss:(0,i.register)("rss",60231),ruby:(0,i.register)("ruby",60232),saveAll:(0,i.register)("save-all",60233),saveAs:(0,i.register)("save-as",60234),save:(0,i.register)("save",60235),screenFull:(0,i.register)("screen-full",60236),screenNormal:(0,i.register)("screen-normal",60237),searchStop:(0,i.register)("search-stop",60238),server:(0,i.register)("server",60240),settingsGear:(0,i.register)("settings-gear",60241),settings:(0,i.register)("settings",60242),shield:(0,i.register)("shield",60243),smiley:(0,i.register)("smiley",60244),sortPrecedence:(0,i.register)("sort-precedence",60245),splitHorizontal:(0,i.register)("split-horizontal",60246),splitVertical:(0,i.register)("split-vertical",60247),squirrel:(0,i.register)("squirrel",60248),starFull:(0,i.register)("star-full",60249),starHalf:(0,i.register)("star-half",60250),symbolClass:(0,i.register)("symbol-class",60251),symbolColor:(0,i.register)("symbol-color",60252),symbolConstant:(0,i.register)("symbol-constant",60253),symbolEnumMember:(0,i.register)("symbol-enum-member",60254),symbolField:(0,i.register)("symbol-field",60255),symbolFile:(0,i.register)("symbol-file",60256),symbolInterface:(0,i.register)("symbol-interface",60257),symbolKeyword:(0,i.register)("symbol-keyword",60258),symbolMisc:(0,i.register)("symbol-misc",60259),symbolOperator:(0,i.register)("symbol-operator",60260),symbolProperty:(0,i.register)("symbol-property",60261),wrench:(0,i.register)("wrench",60261),wrenchSubaction:(0,i.register)("wrench-subaction",60261),symbolSnippet:(0,i.register)("symbol-snippet",60262),tasklist:(0,i.register)("tasklist",60263),telescope:(0,i.register)("telescope",60264),textSize:(0,i.register)("text-size",60265),threeBars:(0,i.register)("three-bars",60266),thumbsdown:(0,i.register)("thumbsdown",60267),thumbsup:(0,i.register)("thumbsup",60268),tools:(0,i.register)("tools",60269),triangleDown:(0,i.register)("triangle-down",60270),triangleLeft:(0,i.register)("triangle-left",60271),triangleRight:(0,i.register)("triangle-right",60272),triangleUp:(0,i.register)("triangle-up",60273),twitter:(0,i.register)("twitter",60274),unfold:(0,i.register)("unfold",60275),unlock:(0,i.register)("unlock",60276),unmute:(0,i.register)("unmute",60277),unverified:(0,i.register)("unverified",60278),verified:(0,i.register)("verified",60279),versions:(0,i.register)("versions",60280),vmActive:(0,i.register)("vm-active",60281),vmOutline:(0,i.register)("vm-outline",60282),vmRunning:(0,i.register)("vm-running",60283),watch:(0,i.register)("watch",60284),whitespace:(0,i.register)("whitespace",60285),wholeWord:(0,i.register)("whole-word",60286),window:(0,i.register)("window",60287),wordWrap:(0,i.register)("word-wrap",60288),zoomIn:(0,i.register)("zoom-in",60289),zoomOut:(0,i.register)("zoom-out",60290),listFilter:(0,i.register)("list-filter",60291),listFlat:(0,i.register)("list-flat",60292),listSelection:(0,i.register)("list-selection",60293),selection:(0,i.register)("selection",60293),listTree:(0,i.register)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.register)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.register)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.register)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.register)("debug-stackframe-active",60297),circleSmallFilled:(0,i.register)("circle-small-filled",60298),debugStackframeDot:(0,i.register)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.register)("terminal-decoration-mark",60298),debugStackframe:(0,i.register)("debug-stackframe",60299),debugStackframeFocused:(0,i.register)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.register)("debug-breakpoint-unsupported",60300),symbolString:(0,i.register)("symbol-string",60301),debugReverseContinue:(0,i.register)("debug-reverse-continue",60302),debugStepBack:(0,i.register)("debug-step-back",60303),debugRestartFrame:(0,i.register)("debug-restart-frame",60304),debugAlt:(0,i.register)("debug-alt",60305),callIncoming:(0,i.register)("call-incoming",60306),callOutgoing:(0,i.register)("call-outgoing",60307),menu:(0,i.register)("menu",60308),expandAll:(0,i.register)("expand-all",60309),feedback:(0,i.register)("feedback",60310),gitPullRequestReviewer:(0,i.register)("git-pull-request-reviewer",60310),groupByRefType:(0,i.register)("group-by-ref-type",60311),ungroupByRefType:(0,i.register)("ungroup-by-ref-type",60312),account:(0,i.register)("account",60313),gitPullRequestAssignee:(0,i.register)("git-pull-request-assignee",60313),bellDot:(0,i.register)("bell-dot",60314),debugConsole:(0,i.register)("debug-console",60315),library:(0,i.register)("library",60316),output:(0,i.register)("output",60317),runAll:(0,i.register)("run-all",60318),syncIgnored:(0,i.register)("sync-ignored",60319),pinned:(0,i.register)("pinned",60320),githubInverted:(0,i.register)("github-inverted",60321),serverProcess:(0,i.register)("server-process",60322),serverEnvironment:(0,i.register)("server-environment",60323),pass:(0,i.register)("pass",60324),issueClosed:(0,i.register)("issue-closed",60324),stopCircle:(0,i.register)("stop-circle",60325),playCircle:(0,i.register)("play-circle",60326),record:(0,i.register)("record",60327),debugAltSmall:(0,i.register)("debug-alt-small",60328),vmConnect:(0,i.register)("vm-connect",60329),cloud:(0,i.register)("cloud",60330),merge:(0,i.register)("merge",60331),export:(0,i.register)("export",60332),graphLeft:(0,i.register)("graph-left",60333),magnet:(0,i.register)("magnet",60334),notebook:(0,i.register)("notebook",60335),redo:(0,i.register)("redo",60336),checkAll:(0,i.register)("check-all",60337),pinnedDirty:(0,i.register)("pinned-dirty",60338),passFilled:(0,i.register)("pass-filled",60339),circleLargeFilled:(0,i.register)("circle-large-filled",60340),circleLarge:(0,i.register)("circle-large",60341),circleLargeOutline:(0,i.register)("circle-large-outline",60341),combine:(0,i.register)("combine",60342),gather:(0,i.register)("gather",60342),table:(0,i.register)("table",60343),variableGroup:(0,i.register)("variable-group",60344),typeHierarchy:(0,i.register)("type-hierarchy",60345),typeHierarchySub:(0,i.register)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.register)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.register)("git-pull-request-create",60348),runAbove:(0,i.register)("run-above",60349),runBelow:(0,i.register)("run-below",60350),notebookTemplate:(0,i.register)("notebook-template",60351),debugRerun:(0,i.register)("debug-rerun",60352),workspaceTrusted:(0,i.register)("workspace-trusted",60353),workspaceUntrusted:(0,i.register)("workspace-untrusted",60354),workspaceUnknown:(0,i.register)("workspace-unknown",60355),terminalCmd:(0,i.register)("terminal-cmd",60356),terminalDebian:(0,i.register)("terminal-debian",60357),terminalLinux:(0,i.register)("terminal-linux",60358),terminalPowershell:(0,i.register)("terminal-powershell",60359),terminalTmux:(0,i.register)("terminal-tmux",60360),terminalUbuntu:(0,i.register)("terminal-ubuntu",60361),terminalBash:(0,i.register)("terminal-bash",60362),arrowSwap:(0,i.register)("arrow-swap",60363),copy:(0,i.register)("copy",60364),personAdd:(0,i.register)("person-add",60365),filterFilled:(0,i.register)("filter-filled",60366),wand:(0,i.register)("wand",60367),debugLineByLine:(0,i.register)("debug-line-by-line",60368),inspect:(0,i.register)("inspect",60369),layers:(0,i.register)("layers",60370),layersDot:(0,i.register)("layers-dot",60371),layersActive:(0,i.register)("layers-active",60372),compass:(0,i.register)("compass",60373),compassDot:(0,i.register)("compass-dot",60374),compassActive:(0,i.register)("compass-active",60375),azure:(0,i.register)("azure",60376),issueDraft:(0,i.register)("issue-draft",60377),gitPullRequestClosed:(0,i.register)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.register)("git-pull-request-draft",60379),debugAll:(0,i.register)("debug-all",60380),debugCoverage:(0,i.register)("debug-coverage",60381),runErrors:(0,i.register)("run-errors",60382),folderLibrary:(0,i.register)("folder-library",60383),debugContinueSmall:(0,i.register)("debug-continue-small",60384),beakerStop:(0,i.register)("beaker-stop",60385),graphLine:(0,i.register)("graph-line",60386),graphScatter:(0,i.register)("graph-scatter",60387),pieChart:(0,i.register)("pie-chart",60388),bracket:(0,i.register)("bracket",60175),bracketDot:(0,i.register)("bracket-dot",60389),bracketError:(0,i.register)("bracket-error",60390),lockSmall:(0,i.register)("lock-small",60391),azureDevops:(0,i.register)("azure-devops",60392),verifiedFilled:(0,i.register)("verified-filled",60393),newline:(0,i.register)("newline",60394),layout:(0,i.register)("layout",60395),layoutActivitybarLeft:(0,i.register)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.register)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.register)("layout-panel-left",60398),layoutPanelCenter:(0,i.register)("layout-panel-center",60399),layoutPanelJustify:(0,i.register)("layout-panel-justify",60400),layoutPanelRight:(0,i.register)("layout-panel-right",60401),layoutPanel:(0,i.register)("layout-panel",60402),layoutSidebarLeft:(0,i.register)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.register)("layout-sidebar-right",60404),layoutStatusbar:(0,i.register)("layout-statusbar",60405),layoutMenubar:(0,i.register)("layout-menubar",60406),layoutCentered:(0,i.register)("layout-centered",60407),target:(0,i.register)("target",60408),indent:(0,i.register)("indent",60409),recordSmall:(0,i.register)("record-small",60410),errorSmall:(0,i.register)("error-small",60411),terminalDecorationError:(0,i.register)("terminal-decoration-error",60411),arrowCircleDown:(0,i.register)("arrow-circle-down",60412),arrowCircleLeft:(0,i.register)("arrow-circle-left",60413),arrowCircleRight:(0,i.register)("arrow-circle-right",60414),arrowCircleUp:(0,i.register)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.register)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.register)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.register)("layout-sidebar-left-off",60418),blank:(0,i.register)("blank",60419),heartFilled:(0,i.register)("heart-filled",60420),map:(0,i.register)("map",60421),mapHorizontal:(0,i.register)("map-horizontal",60421),foldHorizontal:(0,i.register)("fold-horizontal",60421),mapFilled:(0,i.register)("map-filled",60422),mapHorizontalFilled:(0,i.register)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.register)("fold-horizontal-filled",60422),circleSmall:(0,i.register)("circle-small",60423),bellSlash:(0,i.register)("bell-slash",60424),bellSlashDot:(0,i.register)("bell-slash-dot",60425),commentUnresolved:(0,i.register)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.register)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.register)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.register)("search-fuzzy",60429),commentDraft:(0,i.register)("comment-draft",60430),send:(0,i.register)("send",60431),sparkle:(0,i.register)("sparkle",60432),insert:(0,i.register)("insert",60433),mic:(0,i.register)("mic",60434),thumbsdownFilled:(0,i.register)("thumbsdown-filled",60435),thumbsupFilled:(0,i.register)("thumbsup-filled",60436),coffee:(0,i.register)("coffee",60437),snake:(0,i.register)("snake",60438),game:(0,i.register)("game",60439),vr:(0,i.register)("vr",60440),chip:(0,i.register)("chip",60441),piano:(0,i.register)("piano",60442),music:(0,i.register)("music",60443),micFilled:(0,i.register)("mic-filled",60444),repoFetch:(0,i.register)("repo-fetch",60445),copilot:(0,i.register)("copilot",60446),lightbulbSparkle:(0,i.register)("lightbulb-sparkle",60447),robot:(0,i.register)("robot",60448),sparkleFilled:(0,i.register)("sparkle-filled",60449),diffSingle:(0,i.register)("diff-single",60450),diffMultiple:(0,i.register)("diff-multiple",60451),surroundWith:(0,i.register)("surround-with",60452),share:(0,i.register)("share",60453),gitStash:(0,i.register)("git-stash",60454),gitStashApply:(0,i.register)("git-stash-apply",60455),gitStashPop:(0,i.register)("git-stash-pop",60456),vscode:(0,i.register)("vscode",60457),vscodeInsiders:(0,i.register)("vscode-insiders",60458),codeOss:(0,i.register)("code-oss",60459),runCoverage:(0,i.register)("run-coverage",60460),runAllCoverage:(0,i.register)("run-all-coverage",60461),coverage:(0,i.register)("coverage",60462),githubProject:(0,i.register)("github-project",60463),mapVertical:(0,i.register)("map-vertical",60464),foldVertical:(0,i.register)("fold-vertical",60464),mapVerticalFilled:(0,i.register)("map-vertical-filled",60465),foldVerticalFilled:(0,i.register)("fold-vertical-filled",60465),goToSearch:(0,i.register)("go-to-search",60466),percentage:(0,i.register)("percentage",60467),sortPercentage:(0,i.register)("sort-percentage",60467)}}),ie(se[44],ue([0,1,27,43]),function(W,t,i,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.codiconsDerived=void 0,t.getAllCodicons=y;function y(){return Object.values(t.Codicon)}t.codiconsDerived={dialogError:(0,i.register)("dialog-error","error"),dialogWarning:(0,i.register)("dialog-warning","warning"),dialogInfo:(0,i.register)("dialog-info","info"),dialogClose:(0,i.register)("dialog-close","close"),treeItemExpanded:(0,i.register)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.register)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.register)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.register)("tree-filter-clear","close"),treeItemLoading:(0,i.register)("tree-item-loading","loading"),menuSelection:(0,i.register)("menu-selection","check"),menuSubmenu:(0,i.register)("menu-submenu","chevron-right"),menuBarMore:(0,i.register)("menubar-more","more"),scrollbarButtonLeft:(0,i.register)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.register)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.register)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.register)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.register)("toolbar-more","more"),quickInputBack:(0,i.register)("quick-input-back","arrow-left"),dropDownButton:(0,i.register)("drop-down-button",60084),symbolCustomColor:(0,i.register)("symbol-customcolor",60252),exportIcon:(0,i.register)("export",60332),workspaceUnspecified:(0,i.register)("workspace-unspecified",60355),newLine:(0,i.register)("newline",60394),thumbsDownFilled:(0,i.register)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.register)("thumbsup-filled",60436),gitFetch:(0,i.register)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.register)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.register)("debug-breakpoint-pending",60377)},t.Codicon={...D.codiconsLibrary,...t.codiconsDerived}}),ie(se[15],ue([0,1,26]),function(W,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.deepClone=D,t.deepFreeze=y,t.cloneAndChange=p,t.mixin=u,t.equals=a,t.safeStringify=o,t.distinct=E,t.getCaseInsensitive=d,t.filter=b,t.getAllPropertyNames=e,t.getAllMethodNames=m,t.createProxyObject=_;function D(L){if(!L||typeof L!="object"||L instanceof RegExp)return L;const v=Array.isArray(L)?[]:{};return Object.entries(L).forEach(([N,A])=>{v[N]=A&&typeof A=="object"?D(A):A}),v}function y(L){if(!L||typeof L!="object")return L;const v=[L];for(;v.length>0;){const N=v.shift();Object.freeze(N);for(const A in N)if(c.call(N,A)){const l=N[A];typeof l=="object"&&!Object.isFrozen(l)&&!(0,i.isTypedArray)(l)&&v.push(l)}}return L}const c=Object.prototype.hasOwnProperty;function p(L,v){return g(L,v,new Set)}function g(L,v,N){if((0,i.isUndefinedOrNull)(L))return L;const A=v(L);if(typeof A<"u")return A;if(Array.isArray(L)){const l=[];for(const n of L)l.push(g(n,v,N));return l}if((0,i.isObject)(L)){if(N.has(L))throw new Error("Cannot clone recursive data-structure");N.add(L);const l={};for(const n in L)c.call(L,n)&&(l[n]=g(L[n],v,N));return N.delete(L),l}return L}function u(L,v,N=!0){return(0,i.isObject)(L)?((0,i.isObject)(v)&&Object.keys(v).forEach(A=>{A in L?N&&((0,i.isObject)(L[A])&&(0,i.isObject)(v[A])?u(L[A],v[A],N):L[A]=v[A]):L[A]=v[A]}),L):v}function a(L,v){if(L===v)return!0;if(L==null||v===null||v===void 0||typeof L!=typeof v||typeof L!="object"||Array.isArray(L)!==Array.isArray(v))return!1;let N,A;if(Array.isArray(L)){if(L.length!==v.length)return!1;for(N=0;N<L.length;N++)if(!a(L[N],v[N]))return!1}else{const l=[];for(A in L)l.push(A);l.sort();const n=[];for(A in v)n.push(A);if(n.sort(),!a(l,n))return!1;for(N=0;N<l.length;N++)if(!a(L[l[N]],v[l[N]]))return!1}return!0}function o(L){const v=new Set;return JSON.stringify(L,(N,A)=>{if((0,i.isObject)(A)||Array.isArray(A)){if(v.has(A))return"[Circular]";v.add(A)}return typeof A=="bigint"?`[BigInt ${A.toString()}]`:A})}function E(L,v){const N=Object.create(null);return!L||!v||Object.keys(v).forEach(l=>{const n=L[l],s=v[l];a(n,s)||(N[l]=s)}),N}function d(L,v){const N=v.toLowerCase(),A=Object.keys(L).find(l=>l.toLowerCase()===N);return A?L[A]:L[v]}function b(L,v){const N=Object.create(null);for(const[A,l]of Object.entries(L))v(A,l)&&(N[A]=l);return N}function e(L){let v=[];for(;Object.prototype!==L;)v=v.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return v}function m(L){const v=[];for(const N of e(L))typeof L[N]=="function"&&v.push(N);return v}function _(L,v){const N=l=>function(){const n=Array.prototype.slice.call(arguments,0);return v(l,n)},A={};for(const l of L)A[l]=N(l);return A}}),ie(se[28],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.toUint8=D,t.toUint32=y;var i;(function(c){c[c.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",c[c.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",c[c.MAX_UINT_8=255]="MAX_UINT_8",c[c.MAX_UINT_16=65535]="MAX_UINT_16",c[c.MAX_UINT_32=4294967295]="MAX_UINT_32",c[c.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(t.Constants=i={}));function D(c){return c<0?0:c>255?255:c|0}function y(c){return c<0?0:c>4294967295?4294967295:c|0}}),ie(se[29],ue([0,1,28]),function(W,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class D{constructor(g){const u=(0,i.toUint8)(g);this._defaultValue=u,this._asciiMap=D._createAsciiMap(u),this._map=new Map}static _createAsciiMap(g){const u=new Uint8Array(256);return u.fill(g),u}set(g,u){const a=(0,i.toUint8)(u);g>=0&&g<256?this._asciiMap[g]=a:this._map.set(g,a)}get(g){return g>=0&&g<256?this._asciiMap[g]:this._map.get(g)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}t.CharacterClassifier=D;var y;(function(p){p[p.False=0]="False",p[p.True=1]="True"})(y||(y={}));class c{constructor(){this._actual=new D(0)}add(g){this._actual.set(g,1)}has(g){return this._actual.get(g)===1}clear(){return this._actual.clear()}}t.CharacterSet=c}),ie(se[5],ue([0,1,3]),function(W,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OffsetRangeSet=t.OffsetRange=void 0;class D{static addRange(p,g){let u=0;for(;u<g.length&&g[u].endExclusive<p.start;)u++;let a=u;for(;a<g.length&&g[a].start<=p.endExclusive;)a++;if(u===a)g.splice(u,0,p);else{const o=Math.min(p.start,g[u].start),E=Math.max(p.endExclusive,g[a-1].endExclusive);g.splice(u,a-u,new D(o,E))}}static tryCreate(p,g){if(!(p>g))return new D(p,g)}static ofLength(p){return new D(0,p)}static ofStartAndLength(p,g){return new D(p,p+g)}constructor(p,g){if(this.start=p,this.endExclusive=g,p>g)throw new i.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(p){return new D(this.start+p,this.endExclusive+p)}deltaStart(p){return new D(this.start+p,this.endExclusive)}deltaEnd(p){return new D(this.start,this.endExclusive+p)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(p){return this.start===p.start&&this.endExclusive===p.endExclusive}containsRange(p){return this.start<=p.start&&p.endExclusive<=this.endExclusive}contains(p){return this.start<=p&&p<this.endExclusive}join(p){return new D(Math.min(this.start,p.start),Math.max(this.endExclusive,p.endExclusive))}intersect(p){const g=Math.max(this.start,p.start),u=Math.min(this.endExclusive,p.endExclusive);if(g<=u)return new D(g,u)}intersects(p){const g=Math.max(this.start,p.start),u=Math.min(this.endExclusive,p.endExclusive);return g<u}intersectsOrTouches(p){const g=Math.max(this.start,p.start),u=Math.min(this.endExclusive,p.endExclusive);return g<=u}isBefore(p){return this.endExclusive<=p.start}isAfter(p){return this.start>=p.endExclusive}slice(p){return p.slice(this.start,this.endExclusive)}substring(p){return p.substring(this.start,this.endExclusive)}clip(p){if(this.isEmpty)throw new i.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,p))}clipCyclic(p){if(this.isEmpty)throw new i.BugIndicatingError(`Invalid clipping range: ${this.toString()}`);return p<this.start?this.endExclusive-(this.start-p)%this.length:p>=this.endExclusive?this.start+(p-this.start)%this.length:p}map(p){const g=[];for(let u=this.start;u<this.endExclusive;u++)g.push(p(u));return g}forEach(p){for(let g=this.start;g<this.endExclusive;g++)p(g)}}t.OffsetRange=D;class y{constructor(){this._sortedRanges=[]}addRange(p){let g=0;for(;g<this._sortedRanges.length&&this._sortedRanges[g].endExclusive<p.start;)g++;let u=g;for(;u<this._sortedRanges.length&&this._sortedRanges[u].start<=p.endExclusive;)u++;if(g===u)this._sortedRanges.splice(g,0,p);else{const a=Math.min(p.start,this._sortedRanges[g].start),o=Math.max(p.endExclusive,this._sortedRanges[u-1].endExclusive);this._sortedRanges.splice(g,u-g,new D(a,o))}}toString(){return this._sortedRanges.map(p=>p.toString()).join(", ")}intersectsStrict(p){let g=0;for(;g<this._sortedRanges.length&&this._sortedRanges[g].endExclusive<=p.start;)g++;return g<this._sortedRanges.length&&this._sortedRanges[g].start<p.endExclusive}intersectWithRange(p){const g=new y;for(const u of this._sortedRanges){const a=u.intersect(p);a&&g.addRange(a)}return g}intersectWithRangeLength(p){return this.intersectWithRange(p).length}get length(){return this._sortedRanges.reduce((p,g)=>p+g.length,0)}}t.OffsetRangeSet=y}),ie(se[4],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class i{constructor(y,c){this.lineNumber=y,this.column=c}with(y=this.lineNumber,c=this.column){return y===this.lineNumber&&c===this.column?this:new i(y,c)}delta(y=0,c=0){return this.with(this.lineNumber+y,this.column+c)}equals(y){return i.equals(this,y)}static equals(y,c){return!y&&!c?!0:!!y&&!!c&&y.lineNumber===c.lineNumber&&y.column===c.column}isBefore(y){return i.isBefore(this,y)}static isBefore(y,c){return y.lineNumber<c.lineNumber?!0:c.lineNumber<y.lineNumber?!1:y.column<c.column}isBeforeOrEqual(y){return i.isBeforeOrEqual(this,y)}static isBeforeOrEqual(y,c){return y.lineNumber<c.lineNumber?!0:c.lineNumber<y.lineNumber?!1:y.column<=c.column}static compare(y,c){const p=y.lineNumber|0,g=c.lineNumber|0;if(p===g){const u=y.column|0,a=c.column|0;return u-a}return p-g}clone(){return new i(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(y){return new i(y.lineNumber,y.column)}static isIPosition(y){return y&&typeof y.lineNumber=="number"&&typeof y.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.Position=i}),ie(se[2],ue([0,1,4]),function(W,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class D{constructor(c,p,g,u){c>g||c===g&&p>u?(this.startLineNumber=g,this.startColumn=u,this.endLineNumber=c,this.endColumn=p):(this.startLineNumber=c,this.startColumn=p,this.endLineNumber=g,this.endColumn=u)}isEmpty(){return D.isEmpty(this)}static isEmpty(c){return c.startLineNumber===c.endLineNumber&&c.startColumn===c.endColumn}containsPosition(c){return D.containsPosition(this,c)}static containsPosition(c,p){return!(p.lineNumber<c.startLineNumber||p.lineNumber>c.endLineNumber||p.lineNumber===c.startLineNumber&&p.column<c.startColumn||p.lineNumber===c.endLineNumber&&p.column>c.endColumn)}static strictContainsPosition(c,p){return!(p.lineNumber<c.startLineNumber||p.lineNumber>c.endLineNumber||p.lineNumber===c.startLineNumber&&p.column<=c.startColumn||p.lineNumber===c.endLineNumber&&p.column>=c.endColumn)}containsRange(c){return D.containsRange(this,c)}static containsRange(c,p){return!(p.startLineNumber<c.startLineNumber||p.endLineNumber<c.startLineNumber||p.startLineNumber>c.endLineNumber||p.endLineNumber>c.endLineNumber||p.startLineNumber===c.startLineNumber&&p.startColumn<c.startColumn||p.endLineNumber===c.endLineNumber&&p.endColumn>c.endColumn)}strictContainsRange(c){return D.strictContainsRange(this,c)}static strictContainsRange(c,p){return!(p.startLineNumber<c.startLineNumber||p.endLineNumber<c.startLineNumber||p.startLineNumber>c.endLineNumber||p.endLineNumber>c.endLineNumber||p.startLineNumber===c.startLineNumber&&p.startColumn<=c.startColumn||p.endLineNumber===c.endLineNumber&&p.endColumn>=c.endColumn)}plusRange(c){return D.plusRange(this,c)}static plusRange(c,p){let g,u,a,o;return p.startLineNumber<c.startLineNumber?(g=p.startLineNumber,u=p.startColumn):p.startLineNumber===c.startLineNumber?(g=p.startLineNumber,u=Math.min(p.startColumn,c.startColumn)):(g=c.startLineNumber,u=c.startColumn),p.endLineNumber>c.endLineNumber?(a=p.endLineNumber,o=p.endColumn):p.endLineNumber===c.endLineNumber?(a=p.endLineNumber,o=Math.max(p.endColumn,c.endColumn)):(a=c.endLineNumber,o=c.endColumn),new D(g,u,a,o)}intersectRanges(c){return D.intersectRanges(this,c)}static intersectRanges(c,p){let g=c.startLineNumber,u=c.startColumn,a=c.endLineNumber,o=c.endColumn;const E=p.startLineNumber,d=p.startColumn,b=p.endLineNumber,e=p.endColumn;return g<E?(g=E,u=d):g===E&&(u=Math.max(u,d)),a>b?(a=b,o=e):a===b&&(o=Math.min(o,e)),g>a||g===a&&u>o?null:new D(g,u,a,o)}equalsRange(c){return D.equalsRange(this,c)}static equalsRange(c,p){return!c&&!p?!0:!!c&&!!p&&c.startLineNumber===p.startLineNumber&&c.startColumn===p.startColumn&&c.endLineNumber===p.endLineNumber&&c.endColumn===p.endColumn}getEndPosition(){return D.getEndPosition(this)}static getEndPosition(c){return new i.Position(c.endLineNumber,c.endColumn)}getStartPosition(){return D.getStartPosition(this)}static getStartPosition(c){return new i.Position(c.startLineNumber,c.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(c,p){return new D(this.startLineNumber,this.startColumn,c,p)}setStartPosition(c,p){return new D(c,p,this.endLineNumber,this.endColumn)}collapseToStart(){return D.collapseToStart(this)}static collapseToStart(c){return new D(c.startLineNumber,c.startColumn,c.startLineNumber,c.startColumn)}collapseToEnd(){return D.collapseToEnd(this)}static collapseToEnd(c){return new D(c.endLineNumber,c.endColumn,c.endLineNumber,c.endColumn)}delta(c){return new D(this.startLineNumber+c,this.startColumn,this.endLineNumber+c,this.endColumn)}static fromPositions(c,p=c){return new D(c.lineNumber,c.column,p.lineNumber,p.column)}static lift(c){return c?new D(c.startLineNumber,c.startColumn,c.endLineNumber,c.endColumn):null}static isIRange(c){return c&&typeof c.startLineNumber=="number"&&typeof c.startColumn=="number"&&typeof c.endLineNumber=="number"&&typeof c.endColumn=="number"}static areIntersectingOrTouching(c,p){return!(c.endLineNumber<p.startLineNumber||c.endLineNumber===p.startLineNumber&&c.endColumn<p.startColumn||p.endLineNumber<c.startLineNumber||p.endLineNumber===c.startLineNumber&&p.endColumn<c.startColumn)}static areIntersecting(c,p){return!(c.endLineNumber<p.startLineNumber||c.endLineNumber===p.startLineNumber&&c.endColumn<=p.startColumn||p.endLineNumber<c.startLineNumber||p.endLineNumber===c.startLineNumber&&p.endColumn<=c.startColumn)}static compareRangesUsingStarts(c,p){if(c&&p){const a=c.startLineNumber|0,o=p.startLineNumber|0;if(a===o){const E=c.startColumn|0,d=p.startColumn|0;if(E===d){const b=c.endLineNumber|0,e=p.endLineNumber|0;if(b===e){const m=c.endColumn|0,_=p.endColumn|0;return m-_}return b-e}return E-d}return a-o}return(c?1:0)-(p?1:0)}static compareRangesUsingEnds(c,p){return c.endLineNumber===p.endLineNumber?c.endColumn===p.endColumn?c.startLineNumber===p.startLineNumber?c.startColumn-p.startColumn:c.startLineNumber-p.startLineNumber:c.endColumn-p.endColumn:c.endLineNumber-p.endLineNumber}static spansMultipleLines(c){return c.endLineNumber>c.startLineNumber}toJSON(){return this}}t.Range=D}),ie(se[45],ue([0,1,2]),function(W,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditOperation=void 0;class D{static insert(c,p){return{range:new i.Range(c.lineNumber,c.column,c.lineNumber,c.column),text:p,forceMoveMarkers:!0}}static delete(c){return{range:c,text:null}}static replace(c,p){return{range:c,text:p}}static replaceMove(c,p){return{range:c,text:p,forceMoveMarkers:!0}}}t.EditOperation=D}),ie(se[13],ue([0,1,3,5,2,8]),function(W,t,i,D,y,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRangeSet=t.LineRange=void 0;class p{static fromRange(a){return new p(a.startLineNumber,a.endLineNumber)}static fromRangeInclusive(a){return new p(a.startLineNumber,a.endLineNumber+1)}static subtract(a,o){return o?a.startLineNumber<o.startLineNumber&&o.endLineNumberExclusive<a.endLineNumberExclusive?[new p(a.startLineNumber,o.startLineNumber),new p(o.endLineNumberExclusive,a.endLineNumberExclusive)]:o.startLineNumber<=a.startLineNumber&&a.endLineNumberExclusive<=o.endLineNumberExclusive?[]:o.endLineNumberExclusive<a.endLineNumberExclusive?[new p(Math.max(o.endLineNumberExclusive,a.startLineNumber),a.endLineNumberExclusive)]:[new p(a.startLineNumber,Math.min(o.startLineNumber,a.endLineNumberExclusive))]:[a]}static joinMany(a){if(a.length===0)return[];let o=new g(a[0].slice());for(let E=1;E<a.length;E++)o=o.getUnion(new g(a[E].slice()));return o.ranges}static join(a){if(a.length===0)throw new i.BugIndicatingError("lineRanges cannot be empty");let o=a[0].startLineNumber,E=a[0].endLineNumberExclusive;for(let d=1;d<a.length;d++)o=Math.min(o,a[d].startLineNumber),E=Math.max(E,a[d].endLineNumberExclusive);return new p(o,E)}static ofLength(a,o){return new p(a,a+o)}static deserialize(a){return new p(a[0],a[1])}static invert(a,o){if(a.isEmpty)return[];const E=[];return a.startLineNumber>1&&E.push(new p(1,a.startLineNumber)),a.endLineNumberExclusive<o.getLineCount()+1&&E.push(new p(a.endLineNumberExclusive,o.getLineCount()+1)),E.filter(d=>!d.isEmpty)}static asRange(a,o){return a.isEmpty?new y.Range(a.startLineNumber,1,a.startLineNumber,o.getLineLength(a.startLineNumber)):new y.Range(a.startLineNumber,1,a.endLineNumberExclusive-1,o.getLineLength(a.endLineNumberExclusive-1))}constructor(a,o){if(a>o)throw new i.BugIndicatingError(`startLineNumber ${a} cannot be after endLineNumberExclusive ${o}`);this.startLineNumber=a,this.endLineNumberExclusive=o}contains(a){return this.startLineNumber<=a&&a<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(a){return new p(this.startLineNumber+a,this.endLineNumberExclusive+a)}deltaLength(a){return new p(this.startLineNumber,this.endLineNumberExclusive+a)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(a){return new p(Math.min(this.startLineNumber,a.startLineNumber),Math.max(this.endLineNumberExclusive,a.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(a){const o=Math.max(this.startLineNumber,a.startLineNumber),E=Math.min(this.endLineNumberExclusive,a.endLineNumberExclusive);if(o<=E)return new p(o,E)}intersectsStrict(a){return this.startLineNumber<a.endLineNumberExclusive&&a.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(a){return this.startLineNumber<=a.endLineNumberExclusive&&a.startLineNumber<=this.endLineNumberExclusive}equals(a){return this.startLineNumber===a.startLineNumber&&this.endLineNumberExclusive===a.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new y.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new y.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(a){const o=[];for(let E=this.startLineNumber;E<this.endLineNumberExclusive;E++)o.push(a(E));return o}forEach(a){for(let o=this.startLineNumber;o<this.endLineNumberExclusive;o++)a(o)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(a){return this.startLineNumber<=a&&a<this.endLineNumberExclusive}toOffsetRange(){return new D.OffsetRange(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.LineRange=p;class g{constructor(a=[]){this._normalizedRanges=a}get ranges(){return this._normalizedRanges}addRange(a){if(a.length===0)return;const o=(0,c.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,d=>d.endLineNumberExclusive>=a.startLineNumber),E=(0,c.findLastIdxMonotonous)(this._normalizedRanges,d=>d.startLineNumber<=a.endLineNumberExclusive)+1;if(o===E)this._normalizedRanges.splice(o,0,a);else if(o===E-1){const d=this._normalizedRanges[o];this._normalizedRanges[o]=d.join(a)}else{const d=this._normalizedRanges[o].join(this._normalizedRanges[E-1]).join(a);this._normalizedRanges.splice(o,E-o,d)}}contains(a){const o=(0,c.findLastMonotonous)(this._normalizedRanges,E=>E.startLineNumber<=a);return!!o&&o.endLineNumberExclusive>a}intersects(a){const o=(0,c.findLastMonotonous)(this._normalizedRanges,E=>E.startLineNumber<a.endLineNumberExclusive);return!!o&&o.endLineNumberExclusive>a.startLineNumber}getUnion(a){if(this._normalizedRanges.length===0)return a;if(a._normalizedRanges.length===0)return this;const o=[];let E=0,d=0,b=null;for(;E<this._normalizedRanges.length||d<a._normalizedRanges.length;){let e=null;if(E<this._normalizedRanges.length&&d<a._normalizedRanges.length){const m=this._normalizedRanges[E],_=a._normalizedRanges[d];m.startLineNumber<_.startLineNumber?(e=m,E++):(e=_,d++)}else E<this._normalizedRanges.length?(e=this._normalizedRanges[E],E++):(e=a._normalizedRanges[d],d++);b===null?b=e:b.endLineNumberExclusive>=e.startLineNumber?b=new p(b.startLineNumber,Math.max(b.endLineNumberExclusive,e.endLineNumberExclusive)):(o.push(b),b=e)}return b!==null&&o.push(b),new g(o)}subtractFrom(a){const o=(0,c.findFirstIdxMonotonousOrArrLen)(this._normalizedRanges,e=>e.endLineNumberExclusive>=a.startLineNumber),E=(0,c.findLastIdxMonotonous)(this._normalizedRanges,e=>e.startLineNumber<=a.endLineNumberExclusive)+1;if(o===E)return new g([a]);const d=[];let b=a.startLineNumber;for(let e=o;e<E;e++){const m=this._normalizedRanges[e];m.startLineNumber>b&&d.push(new p(b,m.startLineNumber)),b=m.endLineNumberExclusive}return b<a.endLineNumberExclusive&&d.push(new p(b,a.endLineNumberExclusive)),new g(d)}toString(){return this._normalizedRanges.map(a=>a.toString()).join(", ")}getIntersection(a){const o=[];let E=0,d=0;for(;E<this._normalizedRanges.length&&d<a._normalizedRanges.length;){const b=this._normalizedRanges[E],e=a._normalizedRanges[d],m=b.intersect(e);m&&!m.isEmpty&&o.push(m),b.endLineNumberExclusive<e.endLineNumberExclusive?E++:d++}return new g(o)}getWithDelta(a){return new g(this._normalizedRanges.map(o=>o.delta(a)))}}t.LineRangeSet=g}),ie(se[46],ue([0,1,4,2]),function(W,t,i,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0;var y;(function(p){p[p.LTR=0]="LTR",p[p.RTL=1]="RTL"})(y||(t.SelectionDirection=y={}));class c extends D.Range{constructor(g,u,a,o){super(g,u,a,o),this.selectionStartLineNumber=g,this.selectionStartColumn=u,this.positionLineNumber=a,this.positionColumn=o}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(g){return c.selectionsEqual(this,g)}static selectionsEqual(g,u){return g.selectionStartLineNumber===u.selectionStartLineNumber&&g.selectionStartColumn===u.selectionStartColumn&&g.positionLineNumber===u.positionLineNumber&&g.positionColumn===u.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(g,u){return this.getDirection()===0?new c(this.startLineNumber,this.startColumn,g,u):new c(g,u,this.startLineNumber,this.startColumn)}getPosition(){return new i.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new i.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(g,u){return this.getDirection()===0?new c(g,u,this.endLineNumber,this.endColumn):new c(this.endLineNumber,this.endColumn,g,u)}static fromPositions(g,u=g){return new c(g.lineNumber,g.column,u.lineNumber,u.column)}static fromRange(g,u){return u===0?new c(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn):new c(g.endLineNumber,g.endColumn,g.startLineNumber,g.startColumn)}static liftSelection(g){return new c(g.selectionStartLineNumber,g.selectionStartColumn,g.positionLineNumber,g.positionColumn)}static selectionsArrEqual(g,u){if(g&&!u||!g&&u)return!1;if(!g&&!u)return!0;if(g.length!==u.length)return!1;for(let a=0,o=g.length;a<o;a++)if(!this.selectionsEqual(g[a],u[a]))return!1;return!0}static isISelection(g){return g&&typeof g.selectionStartLineNumber=="number"&&typeof g.selectionStartColumn=="number"&&typeof g.positionLineNumber=="number"&&typeof g.positionColumn=="number"}static createWithDirection(g,u,a,o,E){return E===0?new c(g,u,a,o):new c(a,o,g,u)}}t.Selection=c}),ie(se[30],ue([0,1,4,2]),function(W,t,i,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TextLength=void 0;class y{static{this.zero=new y(0,0)}static lengthDiffNonNegative(p,g){return g.isLessThan(p)?y.zero:p.lineCount===g.lineCount?new y(0,g.columnCount-p.columnCount):new y(g.lineCount-p.lineCount,g.columnCount)}static betweenPositions(p,g){return p.lineNumber===g.lineNumber?new y(0,g.column-p.column):new y(g.lineNumber-p.lineNumber,g.column-1)}static ofRange(p){return y.betweenPositions(p.getStartPosition(),p.getEndPosition())}static ofText(p){let g=0,u=0;for(const a of p)a===`
`?(g++,u=0):u++;return new y(g,u)}constructor(p,g){this.lineCount=p,this.columnCount=g}isZero(){return this.lineCount===0&&this.columnCount===0}isLessThan(p){return this.lineCount!==p.lineCount?this.lineCount<p.lineCount:this.columnCount<p.columnCount}isGreaterThan(p){return this.lineCount!==p.lineCount?this.lineCount>p.lineCount:this.columnCount>p.columnCount}isGreaterThanOrEqualTo(p){return this.lineCount!==p.lineCount?this.lineCount>p.lineCount:this.columnCount>=p.columnCount}equals(p){return this.lineCount===p.lineCount&&this.columnCount===p.columnCount}compare(p){return this.lineCount!==p.lineCount?this.lineCount-p.lineCount:this.columnCount-p.columnCount}add(p){return p.lineCount===0?new y(this.lineCount,this.columnCount+p.columnCount):new y(this.lineCount+p.lineCount,p.columnCount)}createRange(p){return this.lineCount===0?new D.Range(p.lineNumber,p.column,p.lineNumber,p.column+this.columnCount):new D.Range(p.lineNumber,p.column,p.lineNumber+this.lineCount,this.columnCount+1)}toRange(){return new D.Range(1,1,this.lineCount+1,this.columnCount+1)}addToPosition(p){return this.lineCount===0?new i.Position(p.lineNumber,p.column+this.columnCount):new i.Position(p.lineNumber+this.lineCount,this.columnCount+1)}toString(){return`${this.lineCount},${this.columnCount}`}}t.TextLength=y}),ie(se[47],ue([0,1,8,5,4,2,30]),function(W,t,i,D,y,c,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PositionOffsetTransformer=void 0;class g{constructor(a){this.text=a,this.lineStartOffsetByLineIdx=[],this.lineStartOffsetByLineIdx.push(0);for(let o=0;o<a.length;o++)a.charAt(o)===`
`&&this.lineStartOffsetByLineIdx.push(o+1)}getOffset(a){return this.lineStartOffsetByLineIdx[a.lineNumber-1]+a.column-1}getOffsetRange(a){return new D.OffsetRange(this.getOffset(a.getStartPosition()),this.getOffset(a.getEndPosition()))}getPosition(a){const o=(0,i.findLastIdxMonotonous)(this.lineStartOffsetByLineIdx,b=>b<=a),E=o+1,d=a-this.lineStartOffsetByLineIdx[o]+1;return new y.Position(E,d)}getRange(a){return c.Range.fromPositions(this.getPosition(a.start),this.getPosition(a.endExclusive))}getTextLength(a){return p.TextLength.ofRange(this.getRange(a))}get textLength(){const a=this.lineStartOffsetByLineIdx.length-1;return new p.TextLength(a,this.text.length-this.lineStartOffsetByLineIdx[a])}}t.PositionOffsetTransformer=g}),ie(se[48],ue([0,1,10,3,4,47,2,30]),function(W,t,i,D,y,c,p,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringText=t.LineBasedText=t.AbstractText=t.SingleTextEdit=t.TextEdit=void 0;class u{static single(m,_){return new u([new a(m,_)])}constructor(m){this.edits=m,(0,i.assertFn)(()=>(0,i.checkAdjacentItems)(m,(_,L)=>_.range.getEndPosition().isBeforeOrEqual(L.range.getStartPosition())))}normalize(){const m=[];for(const _ of this.edits)if(m.length>0&&m[m.length-1].range.getEndPosition().equals(_.range.getStartPosition())){const L=m[m.length-1];m[m.length-1]=new a(L.range.plusRange(_.range),L.text+_.text)}else _.isEmpty||m.push(_);return new u(m)}mapPosition(m){let _=0,L=0,v=0;for(const N of this.edits){const A=N.range.getStartPosition(),l=N.range.getEndPosition();if(m.isBeforeOrEqual(A))break;const n=g.TextLength.ofText(N.text);if(m.isBefore(l)){const s=new y.Position(A.lineNumber+_,A.column+(A.lineNumber+_===L?v:0)),h=n.addToPosition(s);return o(s,h)}_+=n.lineCount-(N.range.endLineNumber-N.range.startLineNumber),n.lineCount===0?l.lineNumber!==A.lineNumber?v+=n.columnCount-(l.column-1):v+=n.columnCount-(l.column-A.column):v=n.columnCount,L=l.lineNumber+_}return new y.Position(m.lineNumber+_,m.column+(m.lineNumber+_===L?v:0))}mapRange(m){function _(A){return A instanceof y.Position?A:A.getStartPosition()}function L(A){return A instanceof y.Position?A:A.getEndPosition()}const v=_(this.mapPosition(m.getStartPosition())),N=L(this.mapPosition(m.getEndPosition()));return o(v,N)}inverseMapPosition(m,_){return this.inverse(_).mapPosition(m)}inverseMapRange(m,_){return this.inverse(_).mapRange(m)}apply(m){let _="",L=new y.Position(1,1);for(const N of this.edits){const A=N.range,l=A.getStartPosition(),n=A.getEndPosition(),s=o(L,l);s.isEmpty()||(_+=m.getValueOfRange(s)),_+=N.text,L=n}const v=o(L,m.endPositionExclusive);return v.isEmpty()||(_+=m.getValueOfRange(v)),_}applyToString(m){const _=new b(m);return this.apply(_)}inverse(m){const _=this.getNewRanges();return new u(this.edits.map((L,v)=>new a(_[v],m.getValueOfRange(L.range))))}getNewRanges(){const m=[];let _=0,L=0,v=0;for(const N of this.edits){const A=g.TextLength.ofText(N.text),l=y.Position.lift({lineNumber:N.range.startLineNumber+L,column:N.range.startColumn+(N.range.startLineNumber===_?v:0)}),n=A.createRange(l);m.push(n),L=n.endLineNumber-N.range.endLineNumber,v=n.endColumn-N.range.endColumn,_=N.range.endLineNumber}return m}}t.TextEdit=u;class a{constructor(m,_){this.range=m,this.text=_}get isEmpty(){return this.range.isEmpty()&&this.text.length===0}static equals(m,_){return m.range.equalsRange(_.range)&&m.text===_.text}toSingleEditOperation(){return{range:this.range,text:this.text}}}t.SingleTextEdit=a;function o(e,m){if(e.lineNumber===m.lineNumber&&e.column===Number.MAX_SAFE_INTEGER)return p.Range.fromPositions(m,m);if(!e.isBeforeOrEqual(m))throw new D.BugIndicatingError("start must be before end");return new p.Range(e.lineNumber,e.column,m.lineNumber,m.column)}class E{get endPositionExclusive(){return this.length.addToPosition(new y.Position(1,1))}getValue(){return this.getValueOfRange(this.length.toRange())}}t.AbstractText=E;class d extends E{constructor(m,_){(0,i.assert)(_>=1),super(),this._getLineContent=m,this._lineCount=_}getValueOfRange(m){if(m.startLineNumber===m.endLineNumber)return this._getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);let _=this._getLineContent(m.startLineNumber).substring(m.startColumn-1);for(let L=m.startLineNumber+1;L<m.endLineNumber;L++)_+=`
`+this._getLineContent(L);return _+=`
`+this._getLineContent(m.endLineNumber).substring(0,m.endColumn-1),_}get length(){const m=this._getLineContent(this._lineCount);return new g.TextLength(this._lineCount-1,m.length)}}t.LineBasedText=d;class b extends E{constructor(m){super(),this.value=m,this._t=new c.PositionOffsetTransformer(this.value)}getValueOfRange(m){return this._t.getOffsetRange(m).substring(this.value)}get length(){return this._t.textLength}}t.StringText=b}),ie(se[49],ue([0,1,14,29]),function(W,t,i,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WordCharacterClassifier=t.WordCharacterClass=void 0,t.getMapForWordSeparators=g;var y;(function(u){u[u.Regular=0]="Regular",u[u.Whitespace=1]="Whitespace",u[u.WordSeparator=2]="WordSeparator"})(y||(t.WordCharacterClass=y={}));class c extends D.CharacterClassifier{constructor(a,o){super(0),this._segmenter=null,this._cachedLine=null,this._cachedSegments=[],this.intlSegmenterLocales=o,this.intlSegmenterLocales.length>0?this._segmenter=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this._segmenter=null;for(let E=0,d=a.length;E<d;E++)this.set(a.charCodeAt(E),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(a,o){let E=null;for(const d of this._getIntlSegmenterWordsOnLine(a)){if(d.index>o)break;E=d}return E}findNextIntlWordAtOrAfterOffset(a,o){for(const E of this._getIntlSegmenterWordsOnLine(a))if(!(E.index<o))return E;return null}_getIntlSegmenterWordsOnLine(a){return this._segmenter?this._cachedLine===a?this._cachedSegments:(this._cachedLine=a,this._cachedSegments=this._filterWordSegments(this._segmenter.segment(a)),this._cachedSegments):[]}_filterWordSegments(a){const o=[];for(const E of a)this._isWordLike(E)&&o.push(E);return o}_isWordLike(a){return!!a.isWordLike}}t.WordCharacterClassifier=c;const p=new i.LRUCache(10);function g(u,a){const o=`${u}/${a.join(",")}`;let E=p.get(o);return E||(E=new c(u,a),p.set(o,E)),E}}),ie(se[31],ue([0,1,21,11,22]),function(W,t,i,D,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.ensureValidWordDefinition=p,t.setDefaultGetWordAtTextConfig=u,t.getWordAtText=a,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function c(E=""){let d="(-?\\d*\\.\\d\\w*)|([^";for(const b of t.USUAL_WORD_SEPARATORS)E.indexOf(b)>=0||(d+="\\"+b);return d+="\\s]+)",new RegExp(d,"g")}t.DEFAULT_WORD_REGEXP=c();function p(E){let d=t.DEFAULT_WORD_REGEXP;if(E&&E instanceof RegExp)if(E.global)d=E;else{let b="g";E.ignoreCase&&(b+="i"),E.multiline&&(b+="m"),E.unicode&&(b+="u"),d=new RegExp(E.source,b)}return d.lastIndex=0,d}const g=new y.LinkedList;g.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function u(E){const d=g.unshift(E);return(0,D.toDisposable)(d)}function a(E,d,b,e,m){if(d=p(d),m||(m=i.Iterable.first(g)),b.length>m.maxLen){let A=E-m.maxLen/2;return A<0?A=0:e+=A,b=b.substring(A,E+m.maxLen/2),a(E,d,b,e,m)}const _=Date.now(),L=E-1-e;let v=-1,N=null;for(let A=1;!(Date.now()-_>=m.timeBudget);A++){const l=L-m.windowSize*A;d.lastIndex=Math.max(0,l);const n=o(d,b,L,v);if(!n&&N||(N=n,l<=0))break;v=l}if(N){const A={word:N[0],startColumn:e+1+N.index,endColumn:e+1+N.index+N[0].length};return d.lastIndex=0,A}return null}function o(E,d,b,e){let m;for(;m=E.exec(d);){const _=m.index||0;if(_<=b&&E.lastIndex>=b)return m;if(e>0&&_>e)return null}return null}}),ie(se[9],ue([0,1,6,3,5]),function(W,t,i,D,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DateTimeout=t.InfiniteTimeout=t.OffsetPair=t.SequenceDiff=t.DiffAlgorithmResult=void 0;class c{static trivial(E,d){return new c([new p(y.OffsetRange.ofLength(E.length),y.OffsetRange.ofLength(d.length))],!1)}static trivialTimedOut(E,d){return new c([new p(y.OffsetRange.ofLength(E.length),y.OffsetRange.ofLength(d.length))],!0)}constructor(E,d){this.diffs=E,this.hitTimeout=d}}t.DiffAlgorithmResult=c;class p{static invert(E,d){const b=[];return(0,i.forEachAdjacent)(E,(e,m)=>{b.push(p.fromOffsetPairs(e?e.getEndExclusives():g.zero,m?m.getStarts():new g(d,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+d)))}),b}static fromOffsetPairs(E,d){return new p(new y.OffsetRange(E.offset1,d.offset1),new y.OffsetRange(E.offset2,d.offset2))}constructor(E,d){this.seq1Range=E,this.seq2Range=d}swap(){return new p(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(E){return new p(this.seq1Range.join(E.seq1Range),this.seq2Range.join(E.seq2Range))}delta(E){return E===0?this:new p(this.seq1Range.delta(E),this.seq2Range.delta(E))}deltaStart(E){return E===0?this:new p(this.seq1Range.deltaStart(E),this.seq2Range.deltaStart(E))}deltaEnd(E){return E===0?this:new p(this.seq1Range.deltaEnd(E),this.seq2Range.deltaEnd(E))}intersectsOrTouches(E){return this.seq1Range.intersectsOrTouches(E.seq1Range)||this.seq2Range.intersectsOrTouches(E.seq2Range)}intersect(E){const d=this.seq1Range.intersect(E.seq1Range),b=this.seq2Range.intersect(E.seq2Range);if(!(!d||!b))return new p(d,b)}getStarts(){return new g(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new g(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.SequenceDiff=p;class g{static{this.zero=new g(0,0)}static{this.max=new g(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(E,d){this.offset1=E,this.offset2=d}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(E){return E===0?this:new g(this.offset1+E,this.offset2+E)}equals(E){return this.offset1===E.offset1&&this.offset2===E.offset2}}t.OffsetPair=g;class u{static{this.instance=new u}isValid(){return!0}}t.InfiniteTimeout=u;class a{constructor(E){if(this.timeout=E,this.startTime=Date.now(),this.valid=!0,E<=0)throw new D.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}disable(){this.timeout=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.valid=!0}}t.DateTimeout=a}),ie(se[32],ue([0,1,5,9]),function(W,t,i,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MyersDiffAlgorithm=void 0;class y{compute(a,o,E=D.InfiniteTimeout.instance){if(a.length===0||o.length===0)return D.DiffAlgorithmResult.trivial(a,o);const d=a,b=o;function e(s,h){for(;s<d.length&&h<b.length&&d.getElement(s)===b.getElement(h);)s++,h++;return s}let m=0;const _=new p;_.set(0,e(0,0));const L=new g;L.set(0,_.get(0)===0?null:new c(null,0,0,_.get(0)));let v=0;e:for(;;){if(m++,!E.isValid())return D.DiffAlgorithmResult.trivialTimedOut(d,b);const s=-Math.min(m,b.length+m%2),h=Math.min(m,d.length+m%2);for(v=s;v<=h;v+=2){let f=0;const w=v===h?-1:_.get(v+1),R=v===s?-1:_.get(v-1)+1;f++;const M=Math.min(Math.max(w,R),d.length),S=M-v;if(f++,M>d.length||S>b.length)continue;const F=e(M,S);_.set(v,F);const C=M===w?L.get(v+1):L.get(v-1);if(L.set(v,F!==M?new c(C,M,S,F-M):C),_.get(v)===d.length&&_.get(v)-v===b.length)break e}}let N=L.get(v);const A=[];let l=d.length,n=b.length;for(;;){const s=N?N.x+N.length:0,h=N?N.y+N.length:0;if((s!==l||h!==n)&&A.push(new D.SequenceDiff(new i.OffsetRange(s,l),new i.OffsetRange(h,n))),!N)break;l=N.x,n=N.y,N=N.prev}return A.reverse(),new D.DiffAlgorithmResult(A,!1)}}t.MyersDiffAlgorithm=y;class c{constructor(a,o,E,d){this.prev=a,this.x=o,this.y=E,this.length=d}}class p{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(a){return a<0?(a=-a-1,this.negativeArr[a]):this.positiveArr[a]}set(a,o){if(a<0){if(a=-a-1,a>=this.negativeArr.length){const E=this.negativeArr;this.negativeArr=new Int32Array(E.length*2),this.negativeArr.set(E)}this.negativeArr[a]=o}else{if(a>=this.positiveArr.length){const E=this.positiveArr;this.positiveArr=new Int32Array(E.length*2),this.positiveArr.set(E)}this.positiveArr[a]=o}}}class g{constructor(){this.positiveArr=[],this.negativeArr=[]}get(a){return a<0?(a=-a-1,this.negativeArr[a]):this.positiveArr[a]}set(a,o){a<0?(a=-a-1,this.negativeArr[a]=o):this.positiveArr[a]=o}}}),ie(se[50],ue([0,1,6,5,9]),function(W,t,i,D,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.optimizeSequenceDiffs=c,t.removeShortMatches=a,t.extendDiffsToEntireWordIfAppropriate=o,t.removeVeryShortMatchingLinesBetweenDiffs=d,t.removeVeryShortMatchingTextBetweenLongDiffs=b;function c(e,m,_){let L=_;return L=p(e,m,L),L=p(e,m,L),L=g(e,m,L),L}function p(e,m,_){if(_.length===0)return _;const L=[];L.push(_[0]);for(let N=1;N<_.length;N++){const A=L[L.length-1];let l=_[N];if(l.seq1Range.isEmpty||l.seq2Range.isEmpty){const n=l.seq1Range.start-A.seq1Range.endExclusive;let s;for(s=1;s<=n&&!(e.getElement(l.seq1Range.start-s)!==e.getElement(l.seq1Range.endExclusive-s)||m.getElement(l.seq2Range.start-s)!==m.getElement(l.seq2Range.endExclusive-s));s++);if(s--,s===n){L[L.length-1]=new y.SequenceDiff(new D.OffsetRange(A.seq1Range.start,l.seq1Range.endExclusive-n),new D.OffsetRange(A.seq2Range.start,l.seq2Range.endExclusive-n));continue}l=l.delta(-s)}L.push(l)}const v=[];for(let N=0;N<L.length-1;N++){const A=L[N+1];let l=L[N];if(l.seq1Range.isEmpty||l.seq2Range.isEmpty){const n=A.seq1Range.start-l.seq1Range.endExclusive;let s;for(s=0;s<n&&!(!e.isStronglyEqual(l.seq1Range.start+s,l.seq1Range.endExclusive+s)||!m.isStronglyEqual(l.seq2Range.start+s,l.seq2Range.endExclusive+s));s++);if(s===n){L[N+1]=new y.SequenceDiff(new D.OffsetRange(l.seq1Range.start+n,A.seq1Range.endExclusive),new D.OffsetRange(l.seq2Range.start+n,A.seq2Range.endExclusive));continue}s>0&&(l=l.delta(s))}v.push(l)}return L.length>0&&v.push(L[L.length-1]),v}function g(e,m,_){if(!e.getBoundaryScore||!m.getBoundaryScore)return _;for(let L=0;L<_.length;L++){const v=L>0?_[L-1]:void 0,N=_[L],A=L+1<_.length?_[L+1]:void 0,l=new D.OffsetRange(v?v.seq1Range.endExclusive+1:0,A?A.seq1Range.start-1:e.length),n=new D.OffsetRange(v?v.seq2Range.endExclusive+1:0,A?A.seq2Range.start-1:m.length);N.seq1Range.isEmpty?_[L]=u(N,e,m,l,n):N.seq2Range.isEmpty&&(_[L]=u(N.swap(),m,e,n,l).swap())}return _}function u(e,m,_,L,v){let A=1;for(;e.seq1Range.start-A>=L.start&&e.seq2Range.start-A>=v.start&&_.isStronglyEqual(e.seq2Range.start-A,e.seq2Range.endExclusive-A)&&A<100;)A++;A--;let l=0;for(;e.seq1Range.start+l<L.endExclusive&&e.seq2Range.endExclusive+l<v.endExclusive&&_.isStronglyEqual(e.seq2Range.start+l,e.seq2Range.endExclusive+l)&&l<100;)l++;if(A===0&&l===0)return e;let n=0,s=-1;for(let h=-A;h<=l;h++){const f=e.seq2Range.start+h,w=e.seq2Range.endExclusive+h,R=e.seq1Range.start+h,M=m.getBoundaryScore(R)+_.getBoundaryScore(f)+_.getBoundaryScore(w);M>s&&(s=M,n=h)}return e.delta(n)}function a(e,m,_){const L=[];for(const v of _){const N=L[L.length-1];if(!N){L.push(v);continue}v.seq1Range.start-N.seq1Range.endExclusive<=2||v.seq2Range.start-N.seq2Range.endExclusive<=2?L[L.length-1]=new y.SequenceDiff(N.seq1Range.join(v.seq1Range),N.seq2Range.join(v.seq2Range)):L.push(v)}return L}function o(e,m,_){const L=y.SequenceDiff.invert(_,e.length),v=[];let N=new y.OffsetPair(0,0);function A(n,s){if(n.offset1<N.offset1||n.offset2<N.offset2)return;const h=e.findWordContaining(n.offset1),f=m.findWordContaining(n.offset2);if(!h||!f)return;let w=new y.SequenceDiff(h,f);const R=w.intersect(s);let M=R.seq1Range.length,S=R.seq2Range.length;for(;L.length>0;){const F=L[0];if(!(F.seq1Range.intersects(w.seq1Range)||F.seq2Range.intersects(w.seq2Range)))break;const I=e.findWordContaining(F.seq1Range.start),x=m.findWordContaining(F.seq2Range.start),O=new y.SequenceDiff(I,x),T=O.intersect(F);if(M+=T.seq1Range.length,S+=T.seq2Range.length,w=w.join(O),w.seq1Range.endExclusive>=F.seq1Range.endExclusive)L.shift();else break}M+S<(w.seq1Range.length+w.seq2Range.length)*2/3&&v.push(w),N=w.getEndExclusives()}for(;L.length>0;){const n=L.shift();n.seq1Range.isEmpty||(A(n.getStarts(),n),A(n.getEndExclusives().delta(-1),n))}return E(_,v)}function E(e,m){const _=[];for(;e.length>0||m.length>0;){const L=e[0],v=m[0];let N;L&&(!v||L.seq1Range.start<v.seq1Range.start)?N=e.shift():N=m.shift(),_.length>0&&_[_.length-1].seq1Range.endExclusive>=N.seq1Range.start?_[_.length-1]=_[_.length-1].join(N):_.push(N)}return _}function d(e,m,_){let L=_;if(L.length===0)return L;let v=0,N;do{N=!1;const A=[L[0]];for(let l=1;l<L.length;l++){let h=function(w,R){const M=new D.OffsetRange(s.seq1Range.endExclusive,n.seq1Range.start);return e.getText(M).replace(/\s/g,"").length<=4&&(w.seq1Range.length+w.seq2Range.length>5||R.seq1Range.length+R.seq2Range.length>5)};const n=L[l],s=A[A.length-1];h(s,n)?(N=!0,A[A.length-1]=A[A.length-1].join(n)):A.push(n)}L=A}while(v++<10&&N);return L}function b(e,m,_){let L=_;if(L.length===0)return L;let v=0,N;do{N=!1;const l=[L[0]];for(let n=1;n<L.length;n++){let f=function(R,M){const S=new D.OffsetRange(h.seq1Range.endExclusive,s.seq1Range.start);if(e.countLinesIn(S)>5||S.length>500)return!1;const C=e.getText(S).trim();if(C.length>20||C.split(/\r\n|\r|\n/).length>1)return!1;const I=e.countLinesIn(R.seq1Range),x=R.seq1Range.length,O=m.countLinesIn(R.seq2Range),T=R.seq2Range.length,H=e.countLinesIn(M.seq1Range),J=M.seq1Range.length,Y=m.countLinesIn(M.seq2Range),$=M.seq2Range.length,G=2*40+50;function K(ee){return Math.min(ee,G)}return Math.pow(Math.pow(K(I*40+x),1.5)+Math.pow(K(O*40+T),1.5),1.5)+Math.pow(Math.pow(K(H*40+J),1.5)+Math.pow(K(Y*40+$),1.5),1.5)>(G**1.5)**1.5*1.3};const s=L[n],h=l[l.length-1];f(h,s)?(N=!0,l[l.length-1]=l[l.length-1].join(s)):l.push(s)}L=l}while(v++<10&&N);const A=[];return(0,i.forEachWithNeighbors)(L,(l,n,s)=>{let h=n;function f(C){return C.length>0&&C.trim().length<=3&&n.seq1Range.length+n.seq2Range.length>100}const w=e.extendToFullLines(n.seq1Range),R=e.getText(new D.OffsetRange(w.start,n.seq1Range.start));f(R)&&(h=h.deltaStart(-R.length));const M=e.getText(new D.OffsetRange(n.seq1Range.endExclusive,w.endExclusive));f(M)&&(h=h.deltaEnd(M.length));const S=y.SequenceDiff.fromOffsetPairs(l?l.getEndExclusives():y.OffsetPair.zero,s?s.getStarts():y.OffsetPair.max),F=h.intersect(S);A.length>0&&F.getStarts().equals(A[A.length-1].getEndExclusives())?A[A.length-1]=A[A.length-1].join(F):A.push(F)}),A}}),ie(se[51],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineSequence=void 0;class i{constructor(c,p){this.trimmedHash=c,this.lines=p}getElement(c){return this.trimmedHash[c]}get length(){return this.trimmedHash.length}getBoundaryScore(c){const p=c===0?0:D(this.lines[c-1]),g=c===this.lines.length?0:D(this.lines[c]);return 1e3-(p+g)}getText(c){return this.lines.slice(c.start,c.endExclusive).join(`
`)}isStronglyEqual(c,p){return this.lines[c]===this.lines[p]}}t.LineSequence=i;function D(y){let c=0;for(;c<y.length&&(y.charCodeAt(c)===32||y.charCodeAt(c)===9);)c++;return c}}),ie(se[16],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRangeFragment=t.Array2D=void 0,t.isSpace=D;class i{constructor(p,g){this.width=p,this.height=g,this.array=[],this.array=new Array(p*g)}get(p,g){return this.array[p+g*this.width]}set(p,g,u){this.array[p+g*this.width]=u}}t.Array2D=i;function D(c){return c===32||c===9}class y{static{this.chrKeys=new Map}static getKey(p){let g=this.chrKeys.get(p);return g===void 0&&(g=this.chrKeys.size,this.chrKeys.set(p,g)),g}constructor(p,g,u){this.range=p,this.lines=g,this.source=u,this.histogram=[];let a=0;for(let o=p.startLineNumber-1;o<p.endLineNumberExclusive-1;o++){const E=g[o];for(let b=0;b<E.length;b++){a++;const e=E[b],m=y.getKey(e);this.histogram[m]=(this.histogram[m]||0)+1}a++;const d=y.getKey(`
`);this.histogram[d]=(this.histogram[d]||0)+1}this.totalCount=a}computeSimilarity(p){let g=0;const u=Math.max(this.histogram.length,p.histogram.length);for(let a=0;a<u;a++)g+=Math.abs((this.histogram[a]??0)-(p.histogram[a]??0));return 1-g/(this.totalCount+p.totalCount)}}t.LineRangeFragment=y}),ie(se[52],ue([0,1,5,9,16]),function(W,t,i,D,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DynamicProgrammingDiffing=void 0;class c{compute(g,u,a=D.InfiniteTimeout.instance,o){if(g.length===0||u.length===0)return D.DiffAlgorithmResult.trivial(g,u);const E=new y.Array2D(g.length,u.length),d=new y.Array2D(g.length,u.length),b=new y.Array2D(g.length,u.length);for(let A=0;A<g.length;A++)for(let l=0;l<u.length;l++){if(!a.isValid())return D.DiffAlgorithmResult.trivialTimedOut(g,u);const n=A===0?0:E.get(A-1,l),s=l===0?0:E.get(A,l-1);let h;g.getElement(A)===u.getElement(l)?(A===0||l===0?h=0:h=E.get(A-1,l-1),A>0&&l>0&&d.get(A-1,l-1)===3&&(h+=b.get(A-1,l-1)),h+=o?o(A,l):1):h=-1;const f=Math.max(n,s,h);if(f===h){const w=A>0&&l>0?b.get(A-1,l-1):0;b.set(A,l,w+1),d.set(A,l,3)}else f===n?(b.set(A,l,0),d.set(A,l,1)):f===s&&(b.set(A,l,0),d.set(A,l,2));E.set(A,l,f)}const e=[];let m=g.length,_=u.length;function L(A,l){(A+1!==m||l+1!==_)&&e.push(new D.SequenceDiff(new i.OffsetRange(A+1,m),new i.OffsetRange(l+1,_))),m=A,_=l}let v=g.length-1,N=u.length-1;for(;v>=0&&N>=0;)d.get(v,N)===3?(L(v,N),v--,N--):d.get(v,N)===1?v--:N--;return L(-1,-1),e.reverse(),new D.DiffAlgorithmResult(e,!1)}}t.DynamicProgrammingDiffing=c}),ie(se[33],ue([0,1,8,5,4,2,16]),function(W,t,i,D,y,c,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinesSliceCharSequence=void 0;class g{constructor(e,m,_){this.lines=e,this.considerWhitespaceChanges=_,this.elements=[],this.firstCharOffsetByLine=[],this.additionalOffsetByLine=[];let L=!1;m.start>0&&m.endExclusive>=e.length&&(m=new D.OffsetRange(m.start-1,m.endExclusive),L=!0),this.lineRange=m,this.firstCharOffsetByLine[0]=0;for(let v=this.lineRange.start;v<this.lineRange.endExclusive;v++){let N=e[v],A=0;if(L)A=N.length,N="",L=!1;else if(!_){const l=N.trimStart();A=N.length-l.length,N=l.trimEnd()}this.additionalOffsetByLine.push(A);for(let l=0;l<N.length;l++)this.elements.push(N.charCodeAt(l));v<e.length-1&&(this.elements.push(10),this.firstCharOffsetByLine[v-this.lineRange.start+1]=this.elements.length)}this.additionalOffsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new D.OffsetRange(0,this.length))}getText(e){return this.elements.slice(e.start,e.endExclusive).map(m=>String.fromCharCode(m)).join("")}getElement(e){return this.elements[e]}get length(){return this.elements.length}getBoundaryScore(e){const m=d(e>0?this.elements[e-1]:-1),_=d(e<this.elements.length?this.elements[e]:-1);if(m===7&&_===8)return 0;if(m===8)return 150;let L=0;return m!==_&&(L+=10,m===0&&_===1&&(L+=1)),L+=E(m),L+=E(_),L}translateOffset(e){if(this.lineRange.isEmpty)return new y.Position(this.lineRange.start+1,1);const m=(0,i.findLastIdxMonotonous)(this.firstCharOffsetByLine,_=>_<=e);return new y.Position(this.lineRange.start+m+1,e-this.firstCharOffsetByLine[m]+this.additionalOffsetByLine[m]+1)}translateRange(e){return c.Range.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.elements.length||!u(this.elements[e]))return;let m=e;for(;m>0&&u(this.elements[m-1]);)m--;let _=e;for(;_<this.elements.length&&u(this.elements[_]);)_++;return new D.OffsetRange(m,_)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,m){return this.elements[e]===this.elements[m]}extendToFullLines(e){const m=(0,i.findLastMonotonous)(this.firstCharOffsetByLine,L=>L<=e.start)??0,_=(0,i.findFirstMonotonous)(this.firstCharOffsetByLine,L=>e.endExclusive<=L)??this.elements.length;return new D.OffsetRange(m,_)}}t.LinesSliceCharSequence=g;function u(b){return b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57}var a;(function(b){b[b.WordLower=0]="WordLower",b[b.WordUpper=1]="WordUpper",b[b.WordNumber=2]="WordNumber",b[b.End=3]="End",b[b.Other=4]="Other",b[b.Separator=5]="Separator",b[b.Space=6]="Space",b[b.LineBreakCR=7]="LineBreakCR",b[b.LineBreakLF=8]="LineBreakLF"})(a||(a={}));const o={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function E(b){return o[b]}function d(b){return b===10?8:b===13?7:(0,p.isSpace)(b)?6:b>=97&&b<=122?0:b>=65&&b<=90?1:b>=48&&b<=57?2:b===-1?3:b===44||b===59?5:4}}),ie(se[34],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MovedText=t.LinesDiff=void 0;class i{constructor(c,p,g){this.changes=c,this.moves=p,this.hitTimeout=g}}t.LinesDiff=i;class D{constructor(c,p){this.lineRangeMapping=c,this.changes=p}flip(){return new D(this.lineRangeMapping.flip(),this.changes.map(c=>c.flip()))}}t.MovedText=D}),ie(se[17],ue([0,1,3,13,2,48]),function(W,t,i,D,y,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMapping=t.DetailedLineRangeMapping=t.LineRangeMapping=void 0;class p{static inverse(o,E,d){const b=[];let e=1,m=1;for(const L of o){const v=new p(new D.LineRange(e,L.original.startLineNumber),new D.LineRange(m,L.modified.startLineNumber));v.modified.isEmpty||b.push(v),e=L.original.endLineNumberExclusive,m=L.modified.endLineNumberExclusive}const _=new p(new D.LineRange(e,E+1),new D.LineRange(m,d+1));return _.modified.isEmpty||b.push(_),b}static clip(o,E,d){const b=[];for(const e of o){const m=e.original.intersect(E),_=e.modified.intersect(d);m&&!m.isEmpty&&_&&!_.isEmpty&&b.push(new p(m,_))}return b}constructor(o,E){this.original=o,this.modified=E}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new p(this.modified,this.original)}join(o){return new p(this.original.join(o.original),this.modified.join(o.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}toRangeMapping(){const o=this.original.toInclusiveRange(),E=this.modified.toInclusiveRange();if(o&&E)return new u(o,E);if(this.original.startLineNumber===1||this.modified.startLineNumber===1){if(!(this.modified.startLineNumber===1&&this.original.startLineNumber===1))throw new i.BugIndicatingError("not a valid diff");return new u(new y.Range(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new y.Range(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1))}else return new u(new y.Range(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),new y.Range(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER))}}t.LineRangeMapping=p;class g extends p{static fromRangeMappings(o){const E=D.LineRange.join(o.map(b=>D.LineRange.fromRangeInclusive(b.originalRange))),d=D.LineRange.join(o.map(b=>D.LineRange.fromRangeInclusive(b.modifiedRange)));return new g(E,d,o)}constructor(o,E,d){super(o,E),this.innerChanges=d}flip(){return new g(this.modified,this.original,this.innerChanges?.map(o=>o.flip()))}withInnerChangesFromLineRanges(){return new g(this.original,this.modified,[this.toRangeMapping()])}}t.DetailedLineRangeMapping=g;class u{constructor(o,E){this.originalRange=o,this.modifiedRange=E}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new u(this.modifiedRange,this.originalRange)}toTextEdit(o){const E=o.getValueOfRange(this.modifiedRange);return new c.SingleTextEdit(this.originalRange,E)}}t.RangeMapping=u}),ie(se[53],ue([0,1,9,17,6,8,14,13,5,33,16,32]),function(W,t,i,D,y,c,p,g,u,a,o,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeMovedLines=d;function d(N,A,l,n,s,h){let{moves:f,excludedChanges:w}=e(N,A,l,h);if(!h.isValid())return[];const R=N.filter(S=>!w.has(S)),M=m(R,n,s,A,l,h);return(0,y.pushMany)(f,M),f=L(f),f=f.filter(S=>{const F=S.original.toOffsetRange().slice(A).map(I=>I.trim());return F.join(`
`).length>=15&&b(F,I=>I.length>=2)>=2}),f=v(N,f),f}function b(N,A){let l=0;for(const n of N)A(n)&&l++;return l}function e(N,A,l,n){const s=[],h=N.filter(R=>R.modified.isEmpty&&R.original.length>=3).map(R=>new o.LineRangeFragment(R.original,A,R)),f=new Set(N.filter(R=>R.original.isEmpty&&R.modified.length>=3).map(R=>new o.LineRangeFragment(R.modified,l,R))),w=new Set;for(const R of h){let M=-1,S;for(const F of f){const C=R.computeSimilarity(F);C>M&&(M=C,S=F)}if(M>.9&&S&&(f.delete(S),s.push(new D.LineRangeMapping(R.range,S.range)),w.add(R.source),w.add(S.source)),!n.isValid())return{moves:s,excludedChanges:w}}return{moves:s,excludedChanges:w}}function m(N,A,l,n,s,h){const f=[],w=new p.SetMap;for(const C of N)for(let I=C.original.startLineNumber;I<C.original.endLineNumberExclusive-2;I++){const x=`${A[I-1]}:${A[I+1-1]}:${A[I+2-1]}`;w.add(x,{range:new g.LineRange(I,I+3)})}const R=[];N.sort((0,y.compareBy)(C=>C.modified.startLineNumber,y.numberComparator));for(const C of N){let I=[];for(let x=C.modified.startLineNumber;x<C.modified.endLineNumberExclusive-2;x++){const O=`${l[x-1]}:${l[x+1-1]}:${l[x+2-1]}`,T=new g.LineRange(x,x+3),H=[];w.forEach(O,({range:J})=>{for(const $ of I)if($.originalLineRange.endLineNumberExclusive+1===J.endLineNumberExclusive&&$.modifiedLineRange.endLineNumberExclusive+1===T.endLineNumberExclusive){$.originalLineRange=new g.LineRange($.originalLineRange.startLineNumber,J.endLineNumberExclusive),$.modifiedLineRange=new g.LineRange($.modifiedLineRange.startLineNumber,T.endLineNumberExclusive),H.push($);return}const Y={modifiedLineRange:T,originalLineRange:J};R.push(Y),H.push(Y)}),I=H}if(!h.isValid())return[]}R.sort((0,y.reverseOrder)((0,y.compareBy)(C=>C.modifiedLineRange.length,y.numberComparator)));const M=new g.LineRangeSet,S=new g.LineRangeSet;for(const C of R){const I=C.modifiedLineRange.startLineNumber-C.originalLineRange.startLineNumber,x=M.subtractFrom(C.modifiedLineRange),O=S.subtractFrom(C.originalLineRange).getWithDelta(I),T=x.getIntersection(O);for(const H of T.ranges){if(H.length<3)continue;const J=H,Y=H.delta(-I);f.push(new D.LineRangeMapping(Y,J)),M.addRange(J),S.addRange(Y)}}f.sort((0,y.compareBy)(C=>C.original.startLineNumber,y.numberComparator));const F=new c.MonotonousArray(N);for(let C=0;C<f.length;C++){const I=f[C],x=F.findLastMonotonous(K=>K.original.startLineNumber<=I.original.startLineNumber),O=(0,c.findLastMonotonous)(N,K=>K.modified.startLineNumber<=I.modified.startLineNumber),T=Math.max(I.original.startLineNumber-x.original.startLineNumber,I.modified.startLineNumber-O.modified.startLineNumber),H=F.findLastMonotonous(K=>K.original.startLineNumber<I.original.endLineNumberExclusive),J=(0,c.findLastMonotonous)(N,K=>K.modified.startLineNumber<I.modified.endLineNumberExclusive),Y=Math.max(H.original.endLineNumberExclusive-I.original.endLineNumberExclusive,J.modified.endLineNumberExclusive-I.modified.endLineNumberExclusive);let $;for($=0;$<T;$++){const K=I.original.startLineNumber-$-1,ee=I.modified.startLineNumber-$-1;if(K>n.length||ee>s.length||M.contains(ee)||S.contains(K)||!_(n[K-1],s[ee-1],h))break}$>0&&(S.addRange(new g.LineRange(I.original.startLineNumber-$,I.original.startLineNumber)),M.addRange(new g.LineRange(I.modified.startLineNumber-$,I.modified.startLineNumber)));let G;for(G=0;G<Y;G++){const K=I.original.endLineNumberExclusive+G,ee=I.modified.endLineNumberExclusive+G;if(K>n.length||ee>s.length||M.contains(ee)||S.contains(K)||!_(n[K-1],s[ee-1],h))break}G>0&&(S.addRange(new g.LineRange(I.original.endLineNumberExclusive,I.original.endLineNumberExclusive+G)),M.addRange(new g.LineRange(I.modified.endLineNumberExclusive,I.modified.endLineNumberExclusive+G))),($>0||G>0)&&(f[C]=new D.LineRangeMapping(new g.LineRange(I.original.startLineNumber-$,I.original.endLineNumberExclusive+G),new g.LineRange(I.modified.startLineNumber-$,I.modified.endLineNumberExclusive+G)))}return f}function _(N,A,l){if(N.trim()===A.trim())return!0;if(N.length>300&&A.length>300)return!1;const s=new E.MyersDiffAlgorithm().compute(new a.LinesSliceCharSequence([N],new u.OffsetRange(0,1),!1),new a.LinesSliceCharSequence([A],new u.OffsetRange(0,1),!1),l);let h=0;const f=i.SequenceDiff.invert(s.diffs,N.length);for(const S of f)S.seq1Range.forEach(F=>{(0,o.isSpace)(N.charCodeAt(F))||h++});function w(S){let F=0;for(let C=0;C<N.length;C++)(0,o.isSpace)(S.charCodeAt(C))||F++;return F}const R=w(N.length>A.length?N:A);return h/R>.6&&R>10}function L(N){if(N.length===0)return N;N.sort((0,y.compareBy)(l=>l.original.startLineNumber,y.numberComparator));const A=[N[0]];for(let l=1;l<N.length;l++){const n=A[A.length-1],s=N[l],h=s.original.startLineNumber-n.original.endLineNumberExclusive,f=s.modified.startLineNumber-n.modified.endLineNumberExclusive;if(h>=0&&f>=0&&h+f<=2){A[A.length-1]=n.join(s);continue}A.push(s)}return A}function v(N,A){const l=new c.MonotonousArray(N);return A=A.filter(n=>{const s=l.findLastMonotonous(w=>w.original.startLineNumber<n.original.endLineNumberExclusive)||new D.LineRangeMapping(new g.LineRange(1,1),new g.LineRange(1,1)),h=(0,c.findLastMonotonous)(N,w=>w.modified.startLineNumber<n.modified.endLineNumberExclusive);return s!==h}),A}}),ie(se[54],ue([0,1,6,10,13,5,2,9,52,32,53,50,51,33,34,17]),function(W,t,i,D,y,c,p,g,u,a,o,E,d,b,e,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DefaultLinesDiffComputer=void 0,t.lineRangeMappingFromRangeMappings=L,t.getLineRangeMapping=v;class _{constructor(){this.dynamicProgrammingDiffing=new u.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new a.MyersDiffAlgorithm}computeDiff(A,l,n){if(A.length<=1&&(0,i.equals)(A,l,(G,K)=>G===K))return new e.LinesDiff([],[],!1);if(A.length===1&&A[0].length===0||l.length===1&&l[0].length===0)return new e.LinesDiff([new m.DetailedLineRangeMapping(new y.LineRange(1,A.length+1),new y.LineRange(1,l.length+1),[new m.RangeMapping(new p.Range(1,1,A.length,A[A.length-1].length+1),new p.Range(1,1,l.length,l[l.length-1].length+1))])],[],!1);const s=n.maxComputationTimeMs===0?g.InfiniteTimeout.instance:new g.DateTimeout(n.maxComputationTimeMs),h=!n.ignoreTrimWhitespace,f=new Map;function w(G){let K=f.get(G);return K===void 0&&(K=f.size,f.set(G,K)),K}const R=A.map(G=>w(G.trim())),M=l.map(G=>w(G.trim())),S=new d.LineSequence(R,A),F=new d.LineSequence(M,l),C=S.length+F.length<1700?this.dynamicProgrammingDiffing.compute(S,F,s,(G,K)=>A[G]===l[K]?l[K].length===0?.1:1+Math.log(1+l[K].length):.99):this.myersDiffingAlgorithm.compute(S,F);let I=C.diffs,x=C.hitTimeout;I=(0,E.optimizeSequenceDiffs)(S,F,I),I=(0,E.removeVeryShortMatchingLinesBetweenDiffs)(S,F,I);const O=[],T=G=>{if(h)for(let K=0;K<G;K++){const ee=H+K,P=J+K;if(A[ee]!==l[P]){const Q=this.refineDiff(A,l,new g.SequenceDiff(new c.OffsetRange(ee,ee+1),new c.OffsetRange(P,P+1)),s,h);for(const de of Q.mappings)O.push(de);Q.hitTimeout&&(x=!0)}}};let H=0,J=0;for(const G of I){(0,D.assertFn)(()=>G.seq1Range.start-H===G.seq2Range.start-J);const K=G.seq1Range.start-H;T(K),H=G.seq1Range.endExclusive,J=G.seq2Range.endExclusive;const ee=this.refineDiff(A,l,G,s,h);ee.hitTimeout&&(x=!0);for(const P of ee.mappings)O.push(P)}T(A.length-H);const Y=L(O,A,l);let $=[];return n.computeMoves&&($=this.computeMoves(Y,A,l,R,M,s,h)),(0,D.assertFn)(()=>{function G(ee,P){if(ee.lineNumber<1||ee.lineNumber>P.length)return!1;const Q=P[ee.lineNumber-1];return!(ee.column<1||ee.column>Q.length+1)}function K(ee,P){return!(ee.startLineNumber<1||ee.startLineNumber>P.length+1||ee.endLineNumberExclusive<1||ee.endLineNumberExclusive>P.length+1)}for(const ee of Y){if(!ee.innerChanges)return!1;for(const P of ee.innerChanges)if(!(G(P.modifiedRange.getStartPosition(),l)&&G(P.modifiedRange.getEndPosition(),l)&&G(P.originalRange.getStartPosition(),A)&&G(P.originalRange.getEndPosition(),A)))return!1;if(!K(ee.modified,l)||!K(ee.original,A))return!1}return!0}),new e.LinesDiff(Y,$,x)}computeMoves(A,l,n,s,h,f,w){return(0,o.computeMovedLines)(A,l,n,s,h,f).map(S=>{const F=this.refineDiff(l,n,new g.SequenceDiff(S.original.toOffsetRange(),S.modified.toOffsetRange()),f,w),C=L(F.mappings,l,n,!0);return new e.MovedText(S,C)})}refineDiff(A,l,n,s,h){const f=new b.LinesSliceCharSequence(A,n.seq1Range,h),w=new b.LinesSliceCharSequence(l,n.seq2Range,h),R=f.length+w.length<500?this.dynamicProgrammingDiffing.compute(f,w,s):this.myersDiffingAlgorithm.compute(f,w,s);let M=R.diffs;return M=(0,E.optimizeSequenceDiffs)(f,w,M),M=(0,E.extendDiffsToEntireWordIfAppropriate)(f,w,M),M=(0,E.removeShortMatches)(f,w,M),M=(0,E.removeVeryShortMatchingTextBetweenLongDiffs)(f,w,M),{mappings:M.map(F=>new m.RangeMapping(f.translateRange(F.seq1Range),w.translateRange(F.seq2Range))),hitTimeout:R.hitTimeout}}}t.DefaultLinesDiffComputer=_;function L(N,A,l,n=!1){const s=[];for(const h of(0,i.groupAdjacentBy)(N.map(f=>v(f,A,l)),(f,w)=>f.original.overlapOrTouch(w.original)||f.modified.overlapOrTouch(w.modified))){const f=h[0],w=h[h.length-1];s.push(new m.DetailedLineRangeMapping(f.original.join(w.original),f.modified.join(w.modified),h.map(R=>R.innerChanges[0])))}return(0,D.assertFn)(()=>!n&&s.length>0&&(s[0].modified.startLineNumber!==s[0].original.startLineNumber||l.length-s[s.length-1].modified.endLineNumberExclusive!==A.length-s[s.length-1].original.endLineNumberExclusive)?!1:(0,D.checkAdjacentItems)(s,(h,f)=>f.original.startLineNumber-h.original.endLineNumberExclusive===f.modified.startLineNumber-h.modified.endLineNumberExclusive&&h.original.endLineNumberExclusive<f.original.startLineNumber&&h.modified.endLineNumberExclusive<f.modified.startLineNumber)),s}function v(N,A,l){let n=0,s=0;N.modifiedRange.endColumn===1&&N.originalRange.endColumn===1&&N.originalRange.startLineNumber+n<=N.originalRange.endLineNumber&&N.modifiedRange.startLineNumber+n<=N.modifiedRange.endLineNumber&&(s=-1),N.modifiedRange.startColumn-1>=l[N.modifiedRange.startLineNumber-1].length&&N.originalRange.startColumn-1>=A[N.originalRange.startLineNumber-1].length&&N.originalRange.startLineNumber<=N.originalRange.endLineNumber+s&&N.modifiedRange.startLineNumber<=N.modifiedRange.endLineNumber+s&&(n=1);const h=new y.LineRange(N.originalRange.startLineNumber+n,N.originalRange.endLineNumber+1+s),f=new y.LineRange(N.modifiedRange.startLineNumber+n,N.modifiedRange.endLineNumber+1+s);return new m.DetailedLineRangeMapping(h,f,[N])}}),ie(se[35],ue([0,1,25,34,17,7,2,10,13]),function(W,t,i,D,y,c,p,g,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=t.LegacyLinesDiffComputer=void 0;const a=3;class o{computeDiff(n,s,h){const w=new L(n,s,{maxComputationTime:h.maxComputationTimeMs,shouldIgnoreTrimWhitespace:h.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),R=[];let M=null;for(const S of w.changes){let F;S.originalEndLineNumber===0?F=new u.LineRange(S.originalStartLineNumber+1,S.originalStartLineNumber+1):F=new u.LineRange(S.originalStartLineNumber,S.originalEndLineNumber+1);let C;S.modifiedEndLineNumber===0?C=new u.LineRange(S.modifiedStartLineNumber+1,S.modifiedStartLineNumber+1):C=new u.LineRange(S.modifiedStartLineNumber,S.modifiedEndLineNumber+1);let I=new y.DetailedLineRangeMapping(F,C,S.charChanges?.map(x=>new y.RangeMapping(new p.Range(x.originalStartLineNumber,x.originalStartColumn,x.originalEndLineNumber,x.originalEndColumn),new p.Range(x.modifiedStartLineNumber,x.modifiedStartColumn,x.modifiedEndLineNumber,x.modifiedEndColumn))));M&&(M.modified.endLineNumberExclusive===I.modified.startLineNumber||M.original.endLineNumberExclusive===I.original.startLineNumber)&&(I=new y.DetailedLineRangeMapping(M.original.join(I.original),M.modified.join(I.modified),M.innerChanges&&I.innerChanges?M.innerChanges.concat(I.innerChanges):void 0),R.pop()),R.push(I),M=I}return(0,g.assertFn)(()=>(0,g.checkAdjacentItems)(R,(S,F)=>F.original.startLineNumber-S.original.endLineNumberExclusive===F.modified.startLineNumber-S.modified.endLineNumberExclusive&&S.original.endLineNumberExclusive<F.original.startLineNumber&&S.modified.endLineNumberExclusive<F.modified.startLineNumber)),new D.LinesDiff(R,[],w.quitEarly)}}t.LegacyLinesDiffComputer=o;function E(l,n,s,h){return new i.LcsDiff(l,n,s).ComputeDiff(h)}class d{constructor(n){const s=[],h=[];for(let f=0,w=n.length;f<w;f++)s[f]=v(n[f],1),h[f]=N(n[f],1);this.lines=n,this._startColumns=s,this._endColumns=h}getElements(){const n=[];for(let s=0,h=this.lines.length;s<h;s++)n[s]=this.lines[s].substring(this._startColumns[s]-1,this._endColumns[s]-1);return n}getStrictElement(n){return this.lines[n]}getStartLineNumber(n){return n+1}getEndLineNumber(n){return n+1}createCharSequence(n,s,h){const f=[],w=[],R=[];let M=0;for(let S=s;S<=h;S++){const F=this.lines[S],C=n?this._startColumns[S]:1,I=n?this._endColumns[S]:F.length+1;for(let x=C;x<I;x++)f[M]=F.charCodeAt(x-1),w[M]=S+1,R[M]=x,M++;!n&&S<h&&(f[M]=10,w[M]=S+1,R[M]=F.length+1,M++)}return new b(f,w,R)}}class b{constructor(n,s,h){this._charCodes=n,this._lineNumbers=s,this._columns=h}toString(){return"["+this._charCodes.map((n,s)=>(n===10?"\\n":String.fromCharCode(n))+`-(${this._lineNumbers[s]},${this._columns[s]})`).join(", ")+"]"}_assertIndex(n,s){if(n<0||n>=s.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(n){return n>0&&n===this._lineNumbers.length?this.getEndLineNumber(n-1):(this._assertIndex(n,this._lineNumbers),this._lineNumbers[n])}getEndLineNumber(n){return n===-1?this.getStartLineNumber(n+1):(this._assertIndex(n,this._lineNumbers),this._charCodes[n]===10?this._lineNumbers[n]+1:this._lineNumbers[n])}getStartColumn(n){return n>0&&n===this._columns.length?this.getEndColumn(n-1):(this._assertIndex(n,this._columns),this._columns[n])}getEndColumn(n){return n===-1?this.getStartColumn(n+1):(this._assertIndex(n,this._columns),this._charCodes[n]===10?1:this._columns[n]+1)}}class e{constructor(n,s,h,f,w,R,M,S){this.originalStartLineNumber=n,this.originalStartColumn=s,this.originalEndLineNumber=h,this.originalEndColumn=f,this.modifiedStartLineNumber=w,this.modifiedStartColumn=R,this.modifiedEndLineNumber=M,this.modifiedEndColumn=S}static createFromDiffChange(n,s,h){const f=s.getStartLineNumber(n.originalStart),w=s.getStartColumn(n.originalStart),R=s.getEndLineNumber(n.originalStart+n.originalLength-1),M=s.getEndColumn(n.originalStart+n.originalLength-1),S=h.getStartLineNumber(n.modifiedStart),F=h.getStartColumn(n.modifiedStart),C=h.getEndLineNumber(n.modifiedStart+n.modifiedLength-1),I=h.getEndColumn(n.modifiedStart+n.modifiedLength-1);return new e(f,w,R,M,S,F,C,I)}}function m(l){if(l.length<=1)return l;const n=[l[0]];let s=n[0];for(let h=1,f=l.length;h<f;h++){const w=l[h],R=w.originalStart-(s.originalStart+s.originalLength),M=w.modifiedStart-(s.modifiedStart+s.modifiedLength);Math.min(R,M)<a?(s.originalLength=w.originalStart+w.originalLength-s.originalStart,s.modifiedLength=w.modifiedStart+w.modifiedLength-s.modifiedStart):(n.push(w),s=w)}return n}class _{constructor(n,s,h,f,w){this.originalStartLineNumber=n,this.originalEndLineNumber=s,this.modifiedStartLineNumber=h,this.modifiedEndLineNumber=f,this.charChanges=w}static createFromDiffResult(n,s,h,f,w,R,M){let S,F,C,I,x;if(s.originalLength===0?(S=h.getStartLineNumber(s.originalStart)-1,F=0):(S=h.getStartLineNumber(s.originalStart),F=h.getEndLineNumber(s.originalStart+s.originalLength-1)),s.modifiedLength===0?(C=f.getStartLineNumber(s.modifiedStart)-1,I=0):(C=f.getStartLineNumber(s.modifiedStart),I=f.getEndLineNumber(s.modifiedStart+s.modifiedLength-1)),R&&s.originalLength>0&&s.originalLength<20&&s.modifiedLength>0&&s.modifiedLength<20&&w()){const O=h.createCharSequence(n,s.originalStart,s.originalStart+s.originalLength-1),T=f.createCharSequence(n,s.modifiedStart,s.modifiedStart+s.modifiedLength-1);if(O.getElements().length>0&&T.getElements().length>0){let H=E(O,T,w,!0).changes;M&&(H=m(H)),x=[];for(let J=0,Y=H.length;J<Y;J++)x.push(e.createFromDiffChange(H[J],O,T))}}return new _(S,F,C,I,x)}}class L{constructor(n,s,h){this.shouldComputeCharChanges=h.shouldComputeCharChanges,this.shouldPostProcessCharChanges=h.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=h.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=h.shouldMakePrettyDiff,this.originalLines=n,this.modifiedLines=s,this.original=new d(n),this.modified=new d(s),this.continueLineDiff=A(h.maxComputationTime),this.continueCharDiff=A(h.maxComputationTime===0?0:Math.min(h.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const n=E(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),s=n.changes,h=n.quitEarly;if(this.shouldIgnoreTrimWhitespace){const M=[];for(let S=0,F=s.length;S<F;S++)M.push(_.createFromDiffResult(this.shouldIgnoreTrimWhitespace,s[S],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:h,changes:M}}const f=[];let w=0,R=0;for(let M=-1,S=s.length;M<S;M++){const F=M+1<S?s[M+1]:null,C=F?F.originalStart:this.originalLines.length,I=F?F.modifiedStart:this.modifiedLines.length;for(;w<C&&R<I;){const x=this.originalLines[w],O=this.modifiedLines[R];if(x!==O){{let T=v(x,1),H=v(O,1);for(;T>1&&H>1;){const J=x.charCodeAt(T-2),Y=O.charCodeAt(H-2);if(J!==Y)break;T--,H--}(T>1||H>1)&&this._pushTrimWhitespaceCharChange(f,w+1,1,T,R+1,1,H)}{let T=N(x,1),H=N(O,1);const J=x.length+1,Y=O.length+1;for(;T<J&&H<Y;){const $=x.charCodeAt(T-1),G=x.charCodeAt(H-1);if($!==G)break;T++,H++}(T<J||H<Y)&&this._pushTrimWhitespaceCharChange(f,w+1,T,J,R+1,H,Y)}}w++,R++}F&&(f.push(_.createFromDiffResult(this.shouldIgnoreTrimWhitespace,F,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),w+=F.originalLength,R+=F.modifiedLength)}return{quitEarly:h,changes:f}}_pushTrimWhitespaceCharChange(n,s,h,f,w,R,M){if(this._mergeTrimWhitespaceCharChange(n,s,h,f,w,R,M))return;let S;this.shouldComputeCharChanges&&(S=[new e(s,h,s,f,w,R,w,M)]),n.push(new _(s,s,w,w,S))}_mergeTrimWhitespaceCharChange(n,s,h,f,w,R,M){const S=n.length;if(S===0)return!1;const F=n[S-1];return F.originalEndLineNumber===0||F.modifiedEndLineNumber===0?!1:F.originalEndLineNumber===s&&F.modifiedEndLineNumber===w?(this.shouldComputeCharChanges&&F.charChanges&&F.charChanges.push(new e(s,h,s,f,w,R,w,M)),!0):F.originalEndLineNumber+1===s&&F.modifiedEndLineNumber+1===w?(F.originalEndLineNumber=s,F.modifiedEndLineNumber=w,this.shouldComputeCharChanges&&F.charChanges&&F.charChanges.push(new e(s,h,s,f,w,R,w,M)),!0):!1}}t.DiffComputer=L;function v(l,n){const s=c.firstNonWhitespaceIndex(l);return s===-1?n:s+1}function N(l,n){const s=c.lastNonWhitespaceIndex(l);return s===-1?n:s+2}function A(l){if(l===0)return()=>!0;const n=Date.now();return()=>Date.now()-n<l}}),ie(se[55],ue([0,1,35,54]),function(W,t,i,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.linesDiffComputers=void 0,t.linesDiffComputers={getLegacy:()=>new i.LegacyLinesDiffComputer,getDefault:()=>new D.DefaultLinesDiffComputer}}),ie(se[56],ue([0,1,37]),function(W,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeDefaultDocumentColors=E;function D(d){const b=[];for(const e of d){const m=Number(e);(m||m===0&&e.replace(/\s/g,"")!=="")&&b.push(m)}return b}function y(d,b,e,m){return{red:d/255,blue:e/255,green:b/255,alpha:m}}function c(d,b){const e=b.index,m=b[0].length;if(!e)return;const _=d.positionAt(e);return{startLineNumber:_.lineNumber,startColumn:_.column,endLineNumber:_.lineNumber,endColumn:_.column+m}}function p(d,b){if(!d)return;const e=i.Color.Format.CSS.parseHex(b);if(e)return{range:d,color:y(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function g(d,b,e){if(!d||b.length!==1)return;const _=b[0].values(),L=D(_);return{range:d,color:y(L[0],L[1],L[2],e?L[3]:1)}}function u(d,b,e){if(!d||b.length!==1)return;const _=b[0].values(),L=D(_),v=new i.Color(new i.HSLA(L[0],L[1]/100,L[2]/100,e?L[3]:1));return{range:d,color:y(v.rgba.r,v.rgba.g,v.rgba.b,v.rgba.a)}}function a(d,b){return typeof d=="string"?[...d.matchAll(b)]:d.findMatches(b)}function o(d){const b=[],m=a(d,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(m.length>0)for(const _ of m){const L=_.filter(l=>l!==void 0),v=L[1],N=L[2];if(!N)continue;let A;if(v==="rgb"){const l=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;A=g(c(d,_),a(N,l),!1)}else if(v==="rgba"){const l=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;A=g(c(d,_),a(N,l),!0)}else if(v==="hsl"){const l=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;A=u(c(d,_),a(N,l),!1)}else if(v==="hsla"){const l=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;A=u(c(d,_),a(N,l),!0)}else v==="#"&&(A=p(c(d,_),v+N));A&&b.push(A)}return b}function E(d){return!d||typeof d.getValue!="function"||typeof d.positionAt!="function"?[]:o(d)}}),ie(se[57],ue([0,1,29]),function(W,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkComputer=t.StateMachine=t.State=void 0,t.computeLinks=d;var D;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(D||(t.State=D={}));class y{constructor(e,m,_){const L=new Uint8Array(e*m);for(let v=0,N=e*m;v<N;v++)L[v]=_;this._data=L,this.rows=e,this.cols=m}get(e,m){return this._data[e*this.cols+m]}set(e,m,_){this._data[e*this.cols+m]=_}}class c{constructor(e){let m=0,_=0;for(let v=0,N=e.length;v<N;v++){const[A,l,n]=e[v];l>m&&(m=l),A>_&&(_=A),n>_&&(_=n)}m++,_++;const L=new y(_,m,0);for(let v=0,N=e.length;v<N;v++){const[A,l,n]=e[v];L.set(A,l,n)}this._states=L,this._maxCharCode=m}nextState(e,m){return m<0||m>=this._maxCharCode?0:this._states.get(e,m)}}t.StateMachine=c;let p=null;function g(){return p===null&&(p=new c([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),p}var u;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(u||(u={}));let a=null;function o(){if(a===null){a=new i.CharacterClassifier(0);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let m=0;m<b.length;m++)a.set(b.charCodeAt(m),1);const e=".,;:";for(let m=0;m<e.length;m++)a.set(e.charCodeAt(m),2)}return a}class E{static _createLink(e,m,_,L,v){let N=v-1;do{const A=m.charCodeAt(N);if(e.get(A)!==2)break;N--}while(N>L);if(L>0){const A=m.charCodeAt(L-1),l=m.charCodeAt(N);(A===40&&l===41||A===91&&l===93||A===123&&l===125)&&N--}return{range:{startLineNumber:_,startColumn:L+1,endLineNumber:_,endColumn:N+2},url:m.substring(L,N+1)}}static computeLinks(e,m=g()){const _=o(),L=[];for(let v=1,N=e.getLineCount();v<=N;v++){const A=e.getLineContent(v),l=A.length;let n=0,s=0,h=0,f=1,w=!1,R=!1,M=!1,S=!1;for(;n<l;){let F=!1;const C=A.charCodeAt(n);if(f===13){let I;switch(C){case 40:w=!0,I=0;break;case 41:I=w?0:1;break;case 91:M=!0,R=!0,I=0;break;case 93:M=!1,I=R?0:1;break;case 123:S=!0,I=0;break;case 125:I=S?0:1;break;case 39:case 34:case 96:h===C?I=1:h===39||h===34||h===96?I=0:I=1;break;case 42:I=h===42?1:0;break;case 124:I=h===124?1:0;break;case 32:I=M?0:1;break;default:I=_.get(C)}I===1&&(L.push(E._createLink(_,A,v,s,n)),F=!0)}else if(f===12){let I;C===91?(R=!0,I=0):I=_.get(C),I===1?F=!0:f=13}else f=m.nextState(f,C),f===0&&(F=!0);F&&(f=1,w=!1,R=!1,S=!1,s=n+1,h=C),n++}f===13&&L.push(E._createLink(_,A,v,s,l))}return L}}t.LinkComputer=E;function d(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:E.computeLinks(b)}}),ie(se[58],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class i{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new i}navigateValueSet(y,c,p,g,u){if(y&&c){const a=this.doNavigateValueSet(c,u);if(a)return{range:y,value:a}}if(p&&g){const a=this.doNavigateValueSet(g,u);if(a)return{range:p,value:a}}return null}doNavigateValueSet(y,c){const p=this.numberReplace(y,c);return p!==null?p:this.textReplace(y,c)}numberReplace(y,c){const p=Math.pow(10,y.length-(y.lastIndexOf(".")+1));let g=Number(y);const u=parseFloat(y);return!isNaN(g)&&!isNaN(u)&&g===u?g===0&&!c?null:(g=Math.floor(g*p),g+=c?p:-p,String(g/p)):null}textReplace(y,c){return this.valueSetsReplace(this._defaultValueSet,y,c)}valueSetsReplace(y,c,p){let g=null;for(let u=0,a=y.length;g===null&&u<a;u++)g=this.valueSetReplace(y[u],c,p);return g}valueSetReplace(y,c,p){let g=y.indexOf(c);return g>=0?(g+=p?1:-1,g<0?g=y.length-1:g%=y.length,y[g]):null}}t.BasicInplaceReplace=i}),ie(se[59],ue([0,1,15]),function(W,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ApplyEditsResult=t.SearchData=t.ValidAnnotatedEditOperation=t.ModelConstants=t.PositionAffinity=t.TrackedRangeStickiness=t.FindMatch=t.TextModelResolvedOptions=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapSectionHeaderStyle=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0,t.isITextSnapshot=e,t.shouldSynchronizeModel=A;var D;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=4]="Right",l[l.Full=7]="Full"})(D||(t.OverviewRulerLane=D={}));var y;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=3]="Right"})(y||(t.GlyphMarginLane=y={}));var c;(function(l){l[l.Inline=1]="Inline",l[l.Gutter=2]="Gutter"})(c||(t.MinimapPosition=c={}));var p;(function(l){l[l.Normal=1]="Normal",l[l.Underlined=2]="Underlined"})(p||(t.MinimapSectionHeaderStyle=p={}));var g;(function(l){l[l.Both=0]="Both",l[l.Right=1]="Right",l[l.Left=2]="Left",l[l.None=3]="None"})(g||(t.InjectedTextCursorStops=g={}));var u;(function(l){l[l.TextDefined=0]="TextDefined",l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(u||(t.EndOfLinePreference=u={}));var a;(function(l){l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(a||(t.DefaultEndOfLine=a={}));var o;(function(l){l[l.LF=0]="LF",l[l.CRLF=1]="CRLF"})(o||(t.EndOfLineSequence=o={}));class E{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(n){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,n.tabSize|0),n.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,n.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!n.insertSpaces,this.defaultEOL=n.defaultEOL|0,this.trimAutoWhitespace=!!n.trimAutoWhitespace,this.bracketPairColorizationOptions=n.bracketPairColorizationOptions}equals(n){return this.tabSize===n.tabSize&&this._indentSizeIsTabSize===n._indentSizeIsTabSize&&this.indentSize===n.indentSize&&this.insertSpaces===n.insertSpaces&&this.defaultEOL===n.defaultEOL&&this.trimAutoWhitespace===n.trimAutoWhitespace&&(0,i.equals)(this.bracketPairColorizationOptions,n.bracketPairColorizationOptions)}createChangeEvent(n){return{tabSize:this.tabSize!==n.tabSize,indentSize:this.indentSize!==n.indentSize,insertSpaces:this.insertSpaces!==n.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==n.trimAutoWhitespace}}}t.TextModelResolvedOptions=E;class d{constructor(n,s){this._findMatchBrand=void 0,this.range=n,this.matches=s}}t.FindMatch=d;var b;(function(l){l[l.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",l[l.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",l[l.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",l[l.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(t.TrackedRangeStickiness=b={}));function e(l){return l&&typeof l.read=="function"}var m;(function(l){l[l.Left=0]="Left",l[l.Right=1]="Right",l[l.None=2]="None",l[l.LeftOfInjectedText=3]="LeftOfInjectedText",l[l.RightOfInjectedText=4]="RightOfInjectedText"})(m||(t.PositionAffinity=m={}));var _;(function(l){l[l.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(_||(t.ModelConstants=_={}));class L{constructor(n,s,h,f,w,R){this.identifier=n,this.range=s,this.text=h,this.forceMoveMarkers=f,this.isAutoWhitespaceEdit=w,this._isTracked=R}}t.ValidAnnotatedEditOperation=L;class v{constructor(n,s,h){this.regex=n,this.wordSeparators=s,this.simpleSearch=h}}t.SearchData=v;class N{constructor(n,s,h){this.reverseEdits=n,this.changes=s,this.trimAutoWhitespaceLineNumbers=h}}t.ApplyEditsResult=N;function A(l){return!l.isTooLargeForSyncing()&&!l.isForSimpleWidget}}),ie(se[60],ue([0,1,6,28]),function(W,t,i,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0;class y{constructor(u){this.values=u,this.prefixSum=new Uint32Array(u.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(u,a){u=(0,D.toUint32)(u);const o=this.values,E=this.prefixSum,d=a.length;return d===0?!1:(this.values=new Uint32Array(o.length+d),this.values.set(o.subarray(0,u),0),this.values.set(o.subarray(u),u+d),this.values.set(a,u),u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(E.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(u,a){return u=(0,D.toUint32)(u),a=(0,D.toUint32)(a),this.values[u]===a?!1:(this.values[u]=a,u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),!0)}removeValues(u,a){u=(0,D.toUint32)(u),a=(0,D.toUint32)(a);const o=this.values,E=this.prefixSum;if(u>=o.length)return!1;const d=o.length-u;return a>=d&&(a=d),a===0?!1:(this.values=new Uint32Array(o.length-a),this.values.set(o.subarray(0,u),0),this.values.set(o.subarray(u+a),u),this.prefixSum=new Uint32Array(this.values.length),u-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=u-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(E.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(u){return u<0?0:(u=(0,D.toUint32)(u),this._getPrefixSum(u))}_getPrefixSum(u){if(u<=this.prefixSumValidIndex[0])return this.prefixSum[u];let a=this.prefixSumValidIndex[0]+1;a===0&&(this.prefixSum[0]=this.values[0],a++),u>=this.values.length&&(u=this.values.length-1);for(let o=a;o<=u;o++)this.prefixSum[o]=this.prefixSum[o-1]+this.values[o];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],u),this.prefixSum[u]}getIndexOf(u){u=Math.floor(u),this.getTotalSum();let a=0,o=this.values.length-1,E=0,d=0,b=0;for(;a<=o;)if(E=a+(o-a)/2|0,d=this.prefixSum[E],b=d-this.values[E],u<b)o=E-1;else if(u>=d)a=E+1;else break;return new p(E,u-b)}}t.PrefixSumComputer=y;class c{constructor(u){this._values=u,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(u){return this._ensureValid(),u===0?0:this._prefixSum[u-1]}getIndexOf(u){this._ensureValid();const a=this._indexBySum[u],o=a>0?this._prefixSum[a-1]:0;return new p(a,u-o)}removeValues(u,a){this._values.splice(u,a),this._invalidate(u)}insertValues(u,a){this._values=(0,i.arrayInsert)(this._values,u,a),this._invalidate(u)}_invalidate(u){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,u-1)}_ensureValid(){if(!this._isValid){for(let u=this._validEndIndex+1,a=this._values.length;u<a;u++){const o=this._values[u],E=u>0?this._prefixSum[u-1]:0;this._prefixSum[u]=E+o;for(let d=0;d<o;d++)this._indexBySum[E+d]=u}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(u,a){this._values[u]!==a&&(this._values[u]=a,this._invalidate(u))}}t.ConstantTimePrefixSumComputer=c;class p{constructor(u,a){this.index=u,this.remainder=a,this._prefixSumIndexOfResultBrand=void 0,this.index=u,this.remainder=a}}t.PrefixSumIndexOfResult=p}),ie(se[61],ue([0,1,7,4,60]),function(W,t,i,D,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0;class c{constructor(g,u,a,o){this._uri=g,this._lines=u,this._eol=a,this._versionId=o,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(g){g.eol&&g.eol!==this._eol&&(this._eol=g.eol,this._lineStarts=null);const u=g.changes;for(const a of u)this._acceptDeleteRange(a.range),this._acceptInsertText(new D.Position(a.range.startLineNumber,a.range.startColumn),a.text);this._versionId=g.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const g=this._eol.length,u=this._lines.length,a=new Uint32Array(u);for(let o=0;o<u;o++)a[o]=this._lines[o].length+g;this._lineStarts=new y.PrefixSumComputer(a)}}_setLineText(g,u){this._lines[g]=u,this._lineStarts&&this._lineStarts.setValue(g,this._lines[g].length+this._eol.length)}_acceptDeleteRange(g){if(g.startLineNumber===g.endLineNumber){if(g.startColumn===g.endColumn)return;this._setLineText(g.startLineNumber-1,this._lines[g.startLineNumber-1].substring(0,g.startColumn-1)+this._lines[g.startLineNumber-1].substring(g.endColumn-1));return}this._setLineText(g.startLineNumber-1,this._lines[g.startLineNumber-1].substring(0,g.startColumn-1)+this._lines[g.endLineNumber-1].substring(g.endColumn-1)),this._lines.splice(g.startLineNumber,g.endLineNumber-g.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(g.startLineNumber,g.endLineNumber-g.startLineNumber)}_acceptInsertText(g,u){if(u.length===0)return;const a=(0,i.splitLines)(u);if(a.length===1){this._setLineText(g.lineNumber-1,this._lines[g.lineNumber-1].substring(0,g.column-1)+a[0]+this._lines[g.lineNumber-1].substring(g.column-1));return}a[a.length-1]+=this._lines[g.lineNumber-1].substring(g.column-1),this._setLineText(g.lineNumber-1,this._lines[g.lineNumber-1].substring(0,g.column-1)+a[0]);const o=new Uint32Array(a.length-1);for(let E=1;E<a.length;E++)this._lines.splice(g.lineNumber+E-1,0,a[E]),o[E-1]=a[E].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(g.lineNumber,o)}}t.MirrorTextModel=c}),ie(se[62],ue([0,1,7,49,4,2,59]),function(W,t,i,D,y,c,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.TextModelSearch=t.SearchParams=void 0,t.isMultilineRegexSource=a,t.createFindMatch=o,t.isValidMatch=m;const g=999;class u{constructor(v,N,A,l){this.searchString=v,this.isRegex=N,this.matchCase=A,this.wordSeparators=l}parseSearchRequest(){if(this.searchString==="")return null;let v;this.isRegex?v=a(this.searchString):v=this.searchString.indexOf(`
`)>=0;let N=null;try{N=i.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:v,global:!0,unicode:!0})}catch{return null}if(!N)return null;let A=!this.isRegex&&!v;return A&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(A=this.matchCase),new p.SearchData(N,this.wordSeparators?(0,D.getMapForWordSeparators)(this.wordSeparators,[]):null,A?this.searchString:null)}}t.SearchParams=u;function a(L){if(!L||L.length===0)return!1;for(let v=0,N=L.length;v<N;v++){const A=L.charCodeAt(v);if(A===10)return!0;if(A===92){if(v++,v>=N)break;const l=L.charCodeAt(v);if(l===110||l===114||l===87)return!0}}return!1}function o(L,v,N){if(!N)return new p.FindMatch(L,null);const A=[];for(let l=0,n=v.length;l<n;l++)A[l]=v[l];return new p.FindMatch(L,A)}class E{constructor(v){const N=[];let A=0;for(let l=0,n=v.length;l<n;l++)v.charCodeAt(l)===10&&(N[A++]=l);this._lineFeedsOffsets=N}findLineFeedCountBeforeOffset(v){const N=this._lineFeedsOffsets;let A=0,l=N.length-1;if(l===-1||v<=N[0])return 0;for(;A<l;){const n=A+((l-A)/2>>0);N[n]>=v?l=n-1:N[n+1]>=v?(A=n,l=n):A=n+1}return A+1}}class d{static findMatches(v,N,A,l,n){const s=N.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(v,A,new _(s.wordSeparators,s.regex),l,n):this._doFindMatchesLineByLine(v,A,s,l,n):[]}static _getMultilineMatchRange(v,N,A,l,n,s){let h,f=0;l?(f=l.findLineFeedCountBeforeOffset(n),h=N+n+f):h=N+n;let w;if(l){const F=l.findLineFeedCountBeforeOffset(n+s.length)-f;w=h+s.length+F}else w=h+s.length;const R=v.getPositionAt(h),M=v.getPositionAt(w);return new c.Range(R.lineNumber,R.column,M.lineNumber,M.column)}static _doFindMatchesMultiline(v,N,A,l,n){const s=v.getOffsetAt(N.getStartPosition()),h=v.getValueInRange(N,1),f=v.getEOL()===`\r
`?new E(h):null,w=[];let R=0,M;for(A.reset(0);M=A.next(h);)if(w[R++]=o(this._getMultilineMatchRange(v,s,h,f,M.index,M[0]),M,l),R>=n)return w;return w}static _doFindMatchesLineByLine(v,N,A,l,n){const s=[];let h=0;if(N.startLineNumber===N.endLineNumber){const w=v.getLineContent(N.startLineNumber).substring(N.startColumn-1,N.endColumn-1);return h=this._findMatchesInLine(A,w,N.startLineNumber,N.startColumn-1,h,s,l,n),s}const f=v.getLineContent(N.startLineNumber).substring(N.startColumn-1);h=this._findMatchesInLine(A,f,N.startLineNumber,N.startColumn-1,h,s,l,n);for(let w=N.startLineNumber+1;w<N.endLineNumber&&h<n;w++)h=this._findMatchesInLine(A,v.getLineContent(w),w,0,h,s,l,n);if(h<n){const w=v.getLineContent(N.endLineNumber).substring(0,N.endColumn-1);h=this._findMatchesInLine(A,w,N.endLineNumber,0,h,s,l,n)}return s}static _findMatchesInLine(v,N,A,l,n,s,h,f){const w=v.wordSeparators;if(!h&&v.simpleSearch){const S=v.simpleSearch,F=S.length,C=N.length;let I=-F;for(;(I=N.indexOf(S,I+F))!==-1;)if((!w||m(w,N,C,I,F))&&(s[n++]=new p.FindMatch(new c.Range(A,I+1+l,A,I+1+F+l),null),n>=f))return n;return n}const R=new _(v.wordSeparators,v.regex);let M;R.reset(0);do if(M=R.next(N),M&&(s[n++]=o(new c.Range(A,M.index+1+l,A,M.index+1+M[0].length+l),M,h),n>=f))return n;while(M);return n}static findNextMatch(v,N,A,l){const n=N.parseSearchRequest();if(!n)return null;const s=new _(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(v,A,s,l):this._doFindNextMatchLineByLine(v,A,s,l)}static _doFindNextMatchMultiline(v,N,A,l){const n=new y.Position(N.lineNumber,1),s=v.getOffsetAt(n),h=v.getLineCount(),f=v.getValueInRange(new c.Range(n.lineNumber,n.column,h,v.getLineMaxColumn(h)),1),w=v.getEOL()===`\r
`?new E(f):null;A.reset(N.column-1);const R=A.next(f);return R?o(this._getMultilineMatchRange(v,s,f,w,R.index,R[0]),R,l):N.lineNumber!==1||N.column!==1?this._doFindNextMatchMultiline(v,new y.Position(1,1),A,l):null}static _doFindNextMatchLineByLine(v,N,A,l){const n=v.getLineCount(),s=N.lineNumber,h=v.getLineContent(s),f=this._findFirstMatchInLine(A,h,s,N.column,l);if(f)return f;for(let w=1;w<=n;w++){const R=(s+w-1)%n,M=v.getLineContent(R+1),S=this._findFirstMatchInLine(A,M,R+1,1,l);if(S)return S}return null}static _findFirstMatchInLine(v,N,A,l,n){v.reset(l-1);const s=v.next(N);return s?o(new c.Range(A,s.index+1,A,s.index+1+s[0].length),s,n):null}static findPreviousMatch(v,N,A,l){const n=N.parseSearchRequest();if(!n)return null;const s=new _(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(v,A,s,l):this._doFindPreviousMatchLineByLine(v,A,s,l)}static _doFindPreviousMatchMultiline(v,N,A,l){const n=this._doFindMatchesMultiline(v,new c.Range(1,1,N.lineNumber,N.column),A,l,10*g);if(n.length>0)return n[n.length-1];const s=v.getLineCount();return N.lineNumber!==s||N.column!==v.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(v,new y.Position(s,v.getLineMaxColumn(s)),A,l):null}static _doFindPreviousMatchLineByLine(v,N,A,l){const n=v.getLineCount(),s=N.lineNumber,h=v.getLineContent(s).substring(0,N.column-1),f=this._findLastMatchInLine(A,h,s,l);if(f)return f;for(let w=1;w<=n;w++){const R=(n+s-w-1)%n,M=v.getLineContent(R+1),S=this._findLastMatchInLine(A,M,R+1,l);if(S)return S}return null}static _findLastMatchInLine(v,N,A,l){let n=null,s;for(v.reset(0);s=v.next(N);)n=o(new c.Range(A,s.index+1,A,s.index+1+s[0].length),s,l);return n}}t.TextModelSearch=d;function b(L,v,N,A,l){if(A===0)return!0;const n=v.charCodeAt(A-1);if(L.get(n)!==0||n===13||n===10)return!0;if(l>0){const s=v.charCodeAt(A);if(L.get(s)!==0)return!0}return!1}function e(L,v,N,A,l){if(A+l===N)return!0;const n=v.charCodeAt(A+l);if(L.get(n)!==0||n===13||n===10)return!0;if(l>0){const s=v.charCodeAt(A+l-1);if(L.get(s)!==0)return!0}return!1}function m(L,v,N,A,l){return b(L,v,N,A,l)&&e(L,v,N,A,l)}class _{constructor(v,N){this._wordSeparators=v,this._searchRegex=N,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(v){this._searchRegex.lastIndex=v,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(v){const N=v.length;let A;do{if(this._prevMatchStartIndex+this._prevMatchLength===N||(A=this._searchRegex.exec(v),!A))return null;const l=A.index,n=A[0].length;if(l===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){i.getNextCodePoint(v,N,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=l,this._prevMatchLength=n,!this._wordSeparators||m(this._wordSeparators,v,N,l,n))return A}while(A);return null}}t.Searcher=_}),ie(se[63],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.findSectionHeaders=y;const i=/\bMARK:\s*(.*)$/d,D=/^-+|-+$/g;function y(a,o){let E=[];if(o.findRegionSectionHeaders&&o.foldingRules?.markers){const d=c(a,o);E=E.concat(d)}if(o.findMarkSectionHeaders){const d=p(a);E=E.concat(d)}return E}function c(a,o){const E=[],d=a.getLineCount();for(let b=1;b<=d;b++){const e=a.getLineContent(b),m=e.match(o.foldingRules.markers.start);if(m){const _={startLineNumber:b,startColumn:m[0].length+1,endLineNumber:b,endColumn:e.length+1};if(_.endColumn>_.startColumn){const L={range:_,...u(e.substring(m[0].length)),shouldBeInComments:!1};(L.text||L.hasSeparatorLine)&&E.push(L)}}}return E}function p(a){const o=[],E=a.getLineCount();for(let d=1;d<=E;d++){const b=a.getLineContent(d);g(b,d,o)}return o}function g(a,o,E){i.lastIndex=0;const d=i.exec(a);if(d){const b=d.indices[1][0]+1,e=d.indices[1][1]+1,m={startLineNumber:o,startColumn:b,endLineNumber:o,endColumn:e};if(m.endColumn>m.startColumn){const _={range:m,...u(d[1]),shouldBeInComments:!0};(_.text||_.hasSeparatorLine)&&E.push(_)}}}function u(a){a=a.trim();const o=a.startsWith("-");return a=a.replace(D,""),{text:a,hasSeparatorLine:o}}}),ie(se[64],ue([0,1,2,62,7,10,31]),function(W,t,i,D,y,c,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.UnicodeTextModelHighlighter=void 0;class g{static computeUnicodeHighlights(e,m,_){const L=_?_.startLineNumber:1,v=_?_.endLineNumber:e.getLineCount(),N=new o(m),A=N.getCandidateCodePoints();let l;A==="allNonBasicAscii"?l=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):l=new RegExp(`${u(Array.from(A))}`,"g");const n=new D.Searcher(null,l),s=[];let h=!1,f,w=0,R=0,M=0;e:for(let S=L,F=v;S<=F;S++){const C=e.getLineContent(S),I=C.length;n.reset(0);do if(f=n.next(C),f){let x=f.index,O=f.index+f[0].length;if(x>0){const Y=C.charCodeAt(x-1);y.isHighSurrogate(Y)&&x--}if(O+1<I){const Y=C.charCodeAt(O-1);y.isHighSurrogate(Y)&&O++}const T=C.substring(x,O);let H=(0,p.getWordAtText)(x+1,p.DEFAULT_WORD_REGEXP,C,0);H&&H.endColumn<=x+1&&(H=null);const J=N.shouldHighlightNonBasicASCII(T,H?H.word:null);if(J!==0){if(J===3?w++:J===2?R++:J===1?M++:(0,c.assertNever)(J),s.length>=1e3){h=!0;break e}s.push(new i.Range(S,x+1,S,O+1))}}while(f)}return{ranges:s,hasMore:h,ambiguousCharacterCount:w,invisibleCharacterCount:R,nonBasicAsciiCharacterCount:M}}static computeUnicodeHighlightReason(e,m){const _=new o(m);switch(_.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const v=e.codePointAt(0),N=_.ambiguousCharacters.getPrimaryConfusable(v),A=y.AmbiguousCharacters.getLocales().filter(l=>!y.AmbiguousCharacters.getInstance(new Set([...m.allowedLocales,l])).isAmbiguous(v));return{kind:0,confusableWith:String.fromCodePoint(N),notAmbiguousInLocales:A}}case 1:return{kind:2}}}}t.UnicodeTextModelHighlighter=g;function u(b,e){return`[${y.escapeRegExpCharacters(b.map(_=>String.fromCodePoint(_)).join(""))}]`}var a;(function(b){b[b.Ambiguous=0]="Ambiguous",b[b.Invisible=1]="Invisible",b[b.NonBasicAscii=2]="NonBasicAscii"})(a||(t.UnicodeHighlighterReasonKind=a={}));class o{constructor(e){this.options=e,this.allowedCodePoints=new Set(e.allowedCodePoints),this.ambiguousCharacters=y.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.options.invisibleCharacters)for(const m of y.InvisibleCharacters.codePoints)E(String.fromCodePoint(m))||e.add(m);if(this.options.ambiguousCharacters)for(const m of this.ambiguousCharacters.getConfusableCodePoints())e.add(m);for(const m of this.allowedCodePoints)e.delete(m);return e}shouldHighlightNonBasicASCII(e,m){const _=e.codePointAt(0);if(this.allowedCodePoints.has(_))return 0;if(this.options.nonBasicASCII)return 1;let L=!1,v=!1;if(m)for(const N of m){const A=N.codePointAt(0),l=y.isBasicASCII(N);L=L||l,!l&&!this.ambiguousCharacters.isAmbiguous(A)&&!y.InvisibleCharacters.isInvisibleCharacter(A)&&(v=!0)}return!L&&v?0:this.options.invisibleCharacters&&!E(e)&&y.InvisibleCharacters.isInvisibleCharacter(_)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(_)?3:0}}function E(b){return b===" "||b===`
`||b==="	"}var d;(function(b){b[b.None=0]="None",b[b.NonBasicASCII=1]="NonBasicASCII",b[b.Invisible=2]="Invisible",b[b.Ambiguous=3]="Ambiguous"})(d||(d={}))}),ie(se[65],ue([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.PartialAcceptTriggerKind=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.NewSymbolNameTriggerKind=t.NewSymbolNameTag=t.MouseTargetType=t.MinimapSectionHeaderStyle=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineEditTriggerKind=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.HoverVerbosityAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var i;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(i||(t.AccessibilitySupport=i={}));var D;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(D||(t.CodeActionTriggerType=D={}));var y;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(y||(t.CompletionItemInsertTextRule=y={}));var c;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(c||(t.CompletionItemKind=c={}));var p;(function(r){r[r.Deprecated=1]="Deprecated"})(p||(t.CompletionItemTag=p={}));var g;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g||(t.CompletionTriggerKind=g={}));var u;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(u||(t.ContentWidgetPositionPreference=u={}));var a;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(a||(t.CursorChangeReason=a={}));var o;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(o||(t.DefaultEndOfLine=o={}));var E;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(E||(t.DocumentHighlightKind=E={}));var d;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(d||(t.EditorAutoIndentStrategy=d={}));var b;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.ariaRequired=5]="ariaRequired",r[r.autoClosingBrackets=6]="autoClosingBrackets",r[r.autoClosingComments=7]="autoClosingComments",r[r.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",r[r.autoClosingDelete=9]="autoClosingDelete",r[r.autoClosingOvertype=10]="autoClosingOvertype",r[r.autoClosingQuotes=11]="autoClosingQuotes",r[r.autoIndent=12]="autoIndent",r[r.automaticLayout=13]="automaticLayout",r[r.autoSurround=14]="autoSurround",r[r.bracketPairColorization=15]="bracketPairColorization",r[r.guides=16]="guides",r[r.codeLens=17]="codeLens",r[r.codeLensFontFamily=18]="codeLensFontFamily",r[r.codeLensFontSize=19]="codeLensFontSize",r[r.colorDecorators=20]="colorDecorators",r[r.colorDecoratorsLimit=21]="colorDecoratorsLimit",r[r.columnSelection=22]="columnSelection",r[r.comments=23]="comments",r[r.contextmenu=24]="contextmenu",r[r.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",r[r.cursorBlinking=26]="cursorBlinking",r[r.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",r[r.cursorStyle=28]="cursorStyle",r[r.cursorSurroundingLines=29]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",r[r.cursorWidth=31]="cursorWidth",r[r.disableLayerHinting=32]="disableLayerHinting",r[r.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",r[r.domReadOnly=34]="domReadOnly",r[r.dragAndDrop=35]="dragAndDrop",r[r.dropIntoEditor=36]="dropIntoEditor",r[r.emptySelectionClipboard=37]="emptySelectionClipboard",r[r.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",r[r.extraEditorClassName=39]="extraEditorClassName",r[r.fastScrollSensitivity=40]="fastScrollSensitivity",r[r.find=41]="find",r[r.fixedOverflowWidgets=42]="fixedOverflowWidgets",r[r.folding=43]="folding",r[r.foldingStrategy=44]="foldingStrategy",r[r.foldingHighlight=45]="foldingHighlight",r[r.foldingImportsByDefault=46]="foldingImportsByDefault",r[r.foldingMaximumRegions=47]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=49]="fontFamily",r[r.fontInfo=50]="fontInfo",r[r.fontLigatures=51]="fontLigatures",r[r.fontSize=52]="fontSize",r[r.fontWeight=53]="fontWeight",r[r.fontVariations=54]="fontVariations",r[r.formatOnPaste=55]="formatOnPaste",r[r.formatOnType=56]="formatOnType",r[r.glyphMargin=57]="glyphMargin",r[r.gotoLocation=58]="gotoLocation",r[r.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",r[r.hover=60]="hover",r[r.inDiffEditor=61]="inDiffEditor",r[r.inlineSuggest=62]="inlineSuggest",r[r.inlineEdit=63]="inlineEdit",r[r.letterSpacing=64]="letterSpacing",r[r.lightbulb=65]="lightbulb",r[r.lineDecorationsWidth=66]="lineDecorationsWidth",r[r.lineHeight=67]="lineHeight",r[r.lineNumbers=68]="lineNumbers",r[r.lineNumbersMinChars=69]="lineNumbersMinChars",r[r.linkedEditing=70]="linkedEditing",r[r.links=71]="links",r[r.matchBrackets=72]="matchBrackets",r[r.minimap=73]="minimap",r[r.mouseStyle=74]="mouseStyle",r[r.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=76]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",r[r.multiCursorModifier=78]="multiCursorModifier",r[r.multiCursorPaste=79]="multiCursorPaste",r[r.multiCursorLimit=80]="multiCursorLimit",r[r.occurrencesHighlight=81]="occurrencesHighlight",r[r.overviewRulerBorder=82]="overviewRulerBorder",r[r.overviewRulerLanes=83]="overviewRulerLanes",r[r.padding=84]="padding",r[r.pasteAs=85]="pasteAs",r[r.parameterHints=86]="parameterHints",r[r.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",r[r.quickSuggestions=89]="quickSuggestions",r[r.quickSuggestionsDelay=90]="quickSuggestionsDelay",r[r.readOnly=91]="readOnly",r[r.readOnlyMessage=92]="readOnlyMessage",r[r.renameOnType=93]="renameOnType",r[r.renderControlCharacters=94]="renderControlCharacters",r[r.renderFinalNewline=95]="renderFinalNewline",r[r.renderLineHighlight=96]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=98]="renderValidationDecorations",r[r.renderWhitespace=99]="renderWhitespace",r[r.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",r[r.roundedSelection=101]="roundedSelection",r[r.rulers=102]="rulers",r[r.scrollbar=103]="scrollbar",r[r.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=105]="scrollBeyondLastLine",r[r.scrollPredominantAxis=106]="scrollPredominantAxis",r[r.selectionClipboard=107]="selectionClipboard",r[r.selectionHighlight=108]="selectionHighlight",r[r.selectOnLineNumbers=109]="selectOnLineNumbers",r[r.showFoldingControls=110]="showFoldingControls",r[r.showUnused=111]="showUnused",r[r.snippetSuggestions=112]="snippetSuggestions",r[r.smartSelect=113]="smartSelect",r[r.smoothScrolling=114]="smoothScrolling",r[r.stickyScroll=115]="stickyScroll",r[r.stickyTabStops=116]="stickyTabStops",r[r.stopRenderingLineAfter=117]="stopRenderingLineAfter",r[r.suggest=118]="suggest",r[r.suggestFontSize=119]="suggestFontSize",r[r.suggestLineHeight=120]="suggestLineHeight",r[r.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",r[r.suggestSelection=122]="suggestSelection",r[r.tabCompletion=123]="tabCompletion",r[r.tabIndex=124]="tabIndex",r[r.unicodeHighlighting=125]="unicodeHighlighting",r[r.unusualLineTerminators=126]="unusualLineTerminators",r[r.useShadowDOM=127]="useShadowDOM",r[r.useTabStops=128]="useTabStops",r[r.wordBreak=129]="wordBreak",r[r.wordSegmenterLocales=130]="wordSegmenterLocales",r[r.wordSeparators=131]="wordSeparators",r[r.wordWrap=132]="wordWrap",r[r.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=135]="wordWrapColumn",r[r.wordWrapOverride1=136]="wordWrapOverride1",r[r.wordWrapOverride2=137]="wordWrapOverride2",r[r.wrappingIndent=138]="wrappingIndent",r[r.wrappingStrategy=139]="wrappingStrategy",r[r.showDeprecated=140]="showDeprecated",r[r.inlayHints=141]="inlayHints",r[r.editorClassName=142]="editorClassName",r[r.pixelRatio=143]="pixelRatio",r[r.tabFocusMode=144]="tabFocusMode",r[r.layoutInfo=145]="layoutInfo",r[r.wrappingInfo=146]="wrappingInfo",r[r.defaultColorDecorators=147]="defaultColorDecorators",r[r.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",r[r.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(b||(t.EditorOption=b={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var m;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(m||(t.EndOfLineSequence=m={}));var _;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(_||(t.GlyphMarginLane=_={}));var L;(function(r){r[r.Increase=0]="Increase",r[r.Decrease=1]="Decrease"})(L||(t.HoverVerbosityAction=L={}));var v;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(v||(t.IndentAction=v={}));var N;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(N||(t.InjectedTextCursorStops=N={}));var A;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(A||(t.InlayHintKind=A={}));var l;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(l||(t.InlineCompletionTriggerKind=l={}));var n;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(n||(t.InlineEditTriggerKind=n={}));var s;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.F20=78]="F20",r[r.F21=79]="F21",r[r.F22=80]="F22",r[r.F23=81]="F23",r[r.F24=82]="F24",r[r.NumLock=83]="NumLock",r[r.ScrollLock=84]="ScrollLock",r[r.Semicolon=85]="Semicolon",r[r.Equal=86]="Equal",r[r.Comma=87]="Comma",r[r.Minus=88]="Minus",r[r.Period=89]="Period",r[r.Slash=90]="Slash",r[r.Backquote=91]="Backquote",r[r.BracketLeft=92]="BracketLeft",r[r.Backslash=93]="Backslash",r[r.BracketRight=94]="BracketRight",r[r.Quote=95]="Quote",r[r.OEM_8=96]="OEM_8",r[r.IntlBackslash=97]="IntlBackslash",r[r.Numpad0=98]="Numpad0",r[r.Numpad1=99]="Numpad1",r[r.Numpad2=100]="Numpad2",r[r.Numpad3=101]="Numpad3",r[r.Numpad4=102]="Numpad4",r[r.Numpad5=103]="Numpad5",r[r.Numpad6=104]="Numpad6",r[r.Numpad7=105]="Numpad7",r[r.Numpad8=106]="Numpad8",r[r.Numpad9=107]="Numpad9",r[r.NumpadMultiply=108]="NumpadMultiply",r[r.NumpadAdd=109]="NumpadAdd",r[r.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=111]="NumpadSubtract",r[r.NumpadDecimal=112]="NumpadDecimal",r[r.NumpadDivide=113]="NumpadDivide",r[r.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",r[r.ABNT_C1=115]="ABNT_C1",r[r.ABNT_C2=116]="ABNT_C2",r[r.AudioVolumeMute=117]="AudioVolumeMute",r[r.AudioVolumeUp=118]="AudioVolumeUp",r[r.AudioVolumeDown=119]="AudioVolumeDown",r[r.BrowserSearch=120]="BrowserSearch",r[r.BrowserHome=121]="BrowserHome",r[r.BrowserBack=122]="BrowserBack",r[r.BrowserForward=123]="BrowserForward",r[r.MediaTrackNext=124]="MediaTrackNext",r[r.MediaTrackPrevious=125]="MediaTrackPrevious",r[r.MediaStop=126]="MediaStop",r[r.MediaPlayPause=127]="MediaPlayPause",r[r.LaunchMediaPlayer=128]="LaunchMediaPlayer",r[r.LaunchMail=129]="LaunchMail",r[r.LaunchApp2=130]="LaunchApp2",r[r.Clear=131]="Clear",r[r.MAX_VALUE=132]="MAX_VALUE"})(s||(t.KeyCode=s={}));var h;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(h||(t.MarkerSeverity=h={}));var f;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(f||(t.MarkerTag=f={}));var w;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(w||(t.MinimapPosition=w={}));var R;(function(r){r[r.Normal=1]="Normal",r[r.Underlined=2]="Underlined"})(R||(t.MinimapSectionHeaderStyle=R={}));var M;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(M||(t.MouseTargetType=M={}));var S;(function(r){r[r.AIGenerated=1]="AIGenerated"})(S||(t.NewSymbolNameTag=S={}));var F;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(F||(t.NewSymbolNameTriggerKind=F={}));var C;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(C||(t.OverlayWidgetPositionPreference=C={}));var I;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(I||(t.OverviewRulerLane=I={}));var x;(function(r){r[r.Word=0]="Word",r[r.Line=1]="Line",r[r.Suggest=2]="Suggest"})(x||(t.PartialAcceptTriggerKind=x={}));var O;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(O||(t.PositionAffinity=O={}));var T;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(T||(t.RenderLineNumbersType=T={}));var H;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(H||(t.RenderMinimap=H={}));var J;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(J||(t.ScrollType=J={}));var Y;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(Y||(t.ScrollbarVisibility=Y={}));var $;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})($||(t.SelectionDirection=$={}));var G;(function(r){r.Off="off",r.OnCode="onCode",r.On="on"})(G||(t.ShowLightbulbIconMode=G={}));var K;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(K||(t.SignatureHelpTriggerKind=K={}));var ee;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(ee||(t.SymbolKind=ee={}));var P;(function(r){r[r.Deprecated=1]="Deprecated"})(P||(t.SymbolTag=P={}));var Q;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(Q||(t.TextEditorCursorBlinkingStyle=Q={}));var de;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(de||(t.TextEditorCursorStyle=de={}));var he;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(he||(t.TrackedRangeStickiness=he={}));var ve;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(ve||(t.WrappingIndent=ve={}))}),ie(se[66],ue([0,1,12,11]),function(W,t,i,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=void 0;class y{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(g){this._onDidChange.fire({changedLanguages:g,changedColorMap:!1})}register(g,u){return this._tokenizationSupports.set(g,u),this.handleChange([g]),(0,D.toDisposable)(()=>{this._tokenizationSupports.get(g)===u&&(this._tokenizationSupports.delete(g),this.handleChange([g]))})}get(g){return this._tokenizationSupports.get(g)||null}registerFactory(g,u){this._factories.get(g)?.dispose();const a=new c(this,g,u);return this._factories.set(g,a),(0,D.toDisposable)(()=>{const o=this._factories.get(g);!o||o!==a||(this._factories.delete(g),o.dispose())})}async getOrCreate(g){const u=this.get(g);if(u)return u;const a=this._factories.get(g);return!a||a.isResolved?null:(await a.resolve(),this.get(g))}isResolved(g){if(this.get(g))return!0;const a=this._factories.get(g);return!!(!a||a.isResolved)}setColorMap(g){this._colorMap=g,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}t.TokenizationRegistry=y;class c extends D.Disposable{get isResolved(){return this._isResolved}constructor(g,u,a){super(),this._registry=g,this._languageId=u,this._factory=a,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const g=await this._factory.tokenizationSupport;this._isResolved=!0,g&&!this._isDisposed&&this._register(this._registry.register(this._languageId,g))}}}),ie(se[67],ue([68,69]),function(W,t){return W.create("vs/base/common/platform",t)}),ie(se[18],ue([0,1,67]),function(W,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.webWorkerOrigin=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.Platform=t.LANGUAGE_DEFAULT=void 0,t.PlatformToString=s,t.isLittleEndian=S,t.isBigSurOrNewer=F,t.LANGUAGE_DEFAULT="en";let D=!1,y=!1,c=!1,p=!1,g=!1,u=!1,a=!1,o=!1,E=!1,d=!1,b,e=t.LANGUAGE_DEFAULT,m=t.LANGUAGE_DEFAULT,_,L;const v=globalThis;let N;typeof v.vscode<"u"&&typeof v.vscode.process<"u"?N=v.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(N=process);const A=typeof N?.versions?.electron=="string",l=A&&N?.type==="renderer";if(typeof N=="object"){D=N.platform==="win32",y=N.platform==="darwin",c=N.platform==="linux",p=c&&!!N.env.SNAP&&!!N.env.SNAP_REVISION,a=A,E=!!N.env.CI||!!N.env.BUILD_ARTIFACTSTAGINGDIRECTORY,b=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const C=N.env.VSCODE_NLS_CONFIG;if(C)try{const I=JSON.parse(C),x=I.availableLanguages["*"];b=I.locale,m=I.osLocale,e=x||t.LANGUAGE_DEFAULT,_=I._translationsConfigFile}catch{}g=!0}else typeof navigator=="object"&&!l?(L=navigator.userAgent,D=L.indexOf("Windows")>=0,y=L.indexOf("Macintosh")>=0,o=(L.indexOf("Macintosh")>=0||L.indexOf("iPad")>=0||L.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,c=L.indexOf("Linux")>=0,d=L?.indexOf("Mobi")>=0,u=!0,b=i.getConfiguredDefaultLocale(i.localize(0,null))||t.LANGUAGE_DEFAULT,e=b,m=navigator.language):console.error("Unable to resolve platform.");var n;(function(C){C[C.Web=0]="Web",C[C.Mac=1]="Mac",C[C.Linux=2]="Linux",C[C.Windows=3]="Windows"})(n||(t.Platform=n={}));function s(C){switch(C){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let h=0;y?h=1:D?h=3:c&&(h=2),t.isWindows=D,t.isMacintosh=y,t.isLinux=c,t.isLinuxSnap=p,t.isNative=g,t.isElectron=a,t.isWeb=u,t.isWebWorker=u&&typeof v.importScripts=="function",t.webWorkerOrigin=t.isWebWorker?v.origin:void 0,t.isIOS=o,t.isMobile=d,t.isCI=E,t.platform=h,t.userAgent=L,t.language=e;var f;(function(C){function I(){return t.language}C.value=I;function x(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}C.isDefaultVariant=x;function O(){return t.language==="en"}C.isDefault=O})(f||(t.Language=f={})),t.locale=b,t.platformLocale=m,t.translationsConfigFile=_,t.setTimeout0IsFaster=typeof v.postMessage=="function"&&!v.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const C=[];v.addEventListener("message",x=>{if(x.data&&x.data.vscodeScheduleAsyncWork)for(let O=0,T=C.length;O<T;O++){const H=C[O];if(H.id===x.data.vscodeScheduleAsyncWork){C.splice(O,1),H.callback();return}}});let I=0;return x=>{const O=++I;C.push({id:O,callback:x}),v.postMessage({vscodeScheduleAsyncWork:O},"*")}}return C=>setTimeout(C)})();var w;(function(C){C[C.Windows=1]="Windows",C[C.Macintosh=2]="Macintosh",C[C.Linux=3]="Linux"})(w||(t.OperatingSystem=w={})),t.OS=y||o?2:D?1:3;let R=!0,M=!1;function S(){if(!M){M=!0;const C=new Uint8Array(2);C[0]=1,C[1]=2,R=new Uint16Array(C.buffer)[0]===513}return R}t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0);function F(C){return parseFloat(C)>=20}}),ie(se[70],ue([0,1,18]),function(W,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let D;const y=globalThis.vscode;if(typeof y<"u"&&typeof y.process<"u"){const c=y.process;D={get platform(){return c.platform},get arch(){return c.arch},get env(){return c.env},cwd(){return c.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return i.isWindows?"win32":i.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=D.cwd,t.env=D.env,t.platform=D.platform,t.arch=D.arch}),ie(se[71],ue([0,1,70]),function(W,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const D=65,y=97,c=90,p=122,g=46,u=47,a=92,o=58,E=63;class d extends Error{constructor(s,h,f){let w;typeof h=="string"&&h.indexOf("not ")===0?(w="must not be",h=h.replace(/^not /,"")):w="must be";const R=s.indexOf(".")!==-1?"property":"argument";let M=`The "${s}" ${R} ${w} of type ${h}`;M+=`. Received type ${typeof f}`,super(M),this.code="ERR_INVALID_ARG_TYPE"}}function b(n,s){if(n===null||typeof n!="object")throw new d(s,"Object",n)}function e(n,s){if(typeof n!="string")throw new d(s,"string",n)}const m=i.platform==="win32";function _(n){return n===u||n===a}function L(n){return n===u}function v(n){return n>=D&&n<=c||n>=y&&n<=p}function N(n,s,h,f){let w="",R=0,M=-1,S=0,F=0;for(let C=0;C<=n.length;++C){if(C<n.length)F=n.charCodeAt(C);else{if(f(F))break;F=u}if(f(F)){if(!(M===C-1||S===1))if(S===2){if(w.length<2||R!==2||w.charCodeAt(w.length-1)!==g||w.charCodeAt(w.length-2)!==g){if(w.length>2){const I=w.lastIndexOf(h);I===-1?(w="",R=0):(w=w.slice(0,I),R=w.length-1-w.lastIndexOf(h)),M=C,S=0;continue}else if(w.length!==0){w="",R=0,M=C,S=0;continue}}s&&(w+=w.length>0?`${h}..`:"..",R=2)}else w.length>0?w+=`${h}${n.slice(M+1,C)}`:w=n.slice(M+1,C),R=C-M-1;M=C,S=0}else F===g&&S!==-1?++S:S=-1}return w}function A(n,s){b(s,"pathObject");const h=s.dir||s.root,f=s.base||`${s.name||""}${s.ext||""}`;return h?h===s.root?`${h}${f}`:`${h}${n}${f}`:f}t.win32={resolve(...n){let s="",h="",f=!1;for(let w=n.length-1;w>=-1;w--){let R;if(w>=0){if(R=n[w],e(R,"path"),R.length===0)continue}else s.length===0?R=i.cwd():(R=i.env[`=${s}`]||i.cwd(),(R===void 0||R.slice(0,2).toLowerCase()!==s.toLowerCase()&&R.charCodeAt(2)===a)&&(R=`${s}\\`));const M=R.length;let S=0,F="",C=!1;const I=R.charCodeAt(0);if(M===1)_(I)&&(S=1,C=!0);else if(_(I))if(C=!0,_(R.charCodeAt(1))){let x=2,O=x;for(;x<M&&!_(R.charCodeAt(x));)x++;if(x<M&&x!==O){const T=R.slice(O,x);for(O=x;x<M&&_(R.charCodeAt(x));)x++;if(x<M&&x!==O){for(O=x;x<M&&!_(R.charCodeAt(x));)x++;(x===M||x!==O)&&(F=`\\\\${T}\\${R.slice(O,x)}`,S=x)}}}else S=1;else v(I)&&R.charCodeAt(1)===o&&(F=R.slice(0,2),S=2,M>2&&_(R.charCodeAt(2))&&(C=!0,S=3));if(F.length>0)if(s.length>0){if(F.toLowerCase()!==s.toLowerCase())continue}else s=F;if(f){if(s.length>0)break}else if(h=`${R.slice(S)}\\${h}`,f=C,C&&s.length>0)break}return h=N(h,!f,"\\",_),f?`${s}\\${h}`:`${s}${h}`||"."},normalize(n){e(n,"path");const s=n.length;if(s===0)return".";let h=0,f,w=!1;const R=n.charCodeAt(0);if(s===1)return L(R)?"\\":n;if(_(R))if(w=!0,_(n.charCodeAt(1))){let S=2,F=S;for(;S<s&&!_(n.charCodeAt(S));)S++;if(S<s&&S!==F){const C=n.slice(F,S);for(F=S;S<s&&_(n.charCodeAt(S));)S++;if(S<s&&S!==F){for(F=S;S<s&&!_(n.charCodeAt(S));)S++;if(S===s)return`\\\\${C}\\${n.slice(F)}\\`;S!==F&&(f=`\\\\${C}\\${n.slice(F,S)}`,h=S)}}}else h=1;else v(R)&&n.charCodeAt(1)===o&&(f=n.slice(0,2),h=2,s>2&&_(n.charCodeAt(2))&&(w=!0,h=3));let M=h<s?N(n.slice(h),!w,"\\",_):"";return M.length===0&&!w&&(M="."),M.length>0&&_(n.charCodeAt(s-1))&&(M+="\\"),f===void 0?w?`\\${M}`:M:w?`${f}\\${M}`:`${f}${M}`},isAbsolute(n){e(n,"path");const s=n.length;if(s===0)return!1;const h=n.charCodeAt(0);return _(h)||s>2&&v(h)&&n.charCodeAt(1)===o&&_(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let s,h;for(let R=0;R<n.length;++R){const M=n[R];e(M,"path"),M.length>0&&(s===void 0?s=h=M:s+=`\\${M}`)}if(s===void 0)return".";let f=!0,w=0;if(typeof h=="string"&&_(h.charCodeAt(0))){++w;const R=h.length;R>1&&_(h.charCodeAt(1))&&(++w,R>2&&(_(h.charCodeAt(2))?++w:f=!1))}if(f){for(;w<s.length&&_(s.charCodeAt(w));)w++;w>=2&&(s=`\\${s.slice(w)}`)}return t.win32.normalize(s)},relative(n,s){if(e(n,"from"),e(s,"to"),n===s)return"";const h=t.win32.resolve(n),f=t.win32.resolve(s);if(h===f||(n=h.toLowerCase(),s=f.toLowerCase(),n===s))return"";let w=0;for(;w<n.length&&n.charCodeAt(w)===a;)w++;let R=n.length;for(;R-1>w&&n.charCodeAt(R-1)===a;)R--;const M=R-w;let S=0;for(;S<s.length&&s.charCodeAt(S)===a;)S++;let F=s.length;for(;F-1>S&&s.charCodeAt(F-1)===a;)F--;const C=F-S,I=M<C?M:C;let x=-1,O=0;for(;O<I;O++){const H=n.charCodeAt(w+O);if(H!==s.charCodeAt(S+O))break;H===a&&(x=O)}if(O!==I){if(x===-1)return f}else{if(C>I){if(s.charCodeAt(S+O)===a)return f.slice(S+O+1);if(O===2)return f.slice(S+O)}M>I&&(n.charCodeAt(w+O)===a?x=O:O===2&&(x=3)),x===-1&&(x=0)}let T="";for(O=w+x+1;O<=R;++O)(O===R||n.charCodeAt(O)===a)&&(T+=T.length===0?"..":"\\..");return S+=x,T.length>0?`${T}${f.slice(S,F)}`:(f.charCodeAt(S)===a&&++S,f.slice(S,F))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const s=t.win32.resolve(n);if(s.length<=2)return n;if(s.charCodeAt(0)===a){if(s.charCodeAt(1)===a){const h=s.charCodeAt(2);if(h!==E&&h!==g)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(v(s.charCodeAt(0))&&s.charCodeAt(1)===o&&s.charCodeAt(2)===a)return`\\\\?\\${s}`;return n},dirname(n){e(n,"path");const s=n.length;if(s===0)return".";let h=-1,f=0;const w=n.charCodeAt(0);if(s===1)return _(w)?n:".";if(_(w)){if(h=f=1,_(n.charCodeAt(1))){let S=2,F=S;for(;S<s&&!_(n.charCodeAt(S));)S++;if(S<s&&S!==F){for(F=S;S<s&&_(n.charCodeAt(S));)S++;if(S<s&&S!==F){for(F=S;S<s&&!_(n.charCodeAt(S));)S++;if(S===s)return n;S!==F&&(h=f=S+1)}}}}else v(w)&&n.charCodeAt(1)===o&&(h=s>2&&_(n.charCodeAt(2))?3:2,f=h);let R=-1,M=!0;for(let S=s-1;S>=f;--S)if(_(n.charCodeAt(S))){if(!M){R=S;break}}else M=!1;if(R===-1){if(h===-1)return".";R=h}return n.slice(0,R)},basename(n,s){s!==void 0&&e(s,"ext"),e(n,"path");let h=0,f=-1,w=!0,R;if(n.length>=2&&v(n.charCodeAt(0))&&n.charCodeAt(1)===o&&(h=2),s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let M=s.length-1,S=-1;for(R=n.length-1;R>=h;--R){const F=n.charCodeAt(R);if(_(F)){if(!w){h=R+1;break}}else S===-1&&(w=!1,S=R+1),M>=0&&(F===s.charCodeAt(M)?--M===-1&&(f=R):(M=-1,f=S))}return h===f?f=S:f===-1&&(f=n.length),n.slice(h,f)}for(R=n.length-1;R>=h;--R)if(_(n.charCodeAt(R))){if(!w){h=R+1;break}}else f===-1&&(w=!1,f=R+1);return f===-1?"":n.slice(h,f)},extname(n){e(n,"path");let s=0,h=-1,f=0,w=-1,R=!0,M=0;n.length>=2&&n.charCodeAt(1)===o&&v(n.charCodeAt(0))&&(s=f=2);for(let S=n.length-1;S>=s;--S){const F=n.charCodeAt(S);if(_(F)){if(!R){f=S+1;break}continue}w===-1&&(R=!1,w=S+1),F===g?h===-1?h=S:M!==1&&(M=1):h!==-1&&(M=-1)}return h===-1||w===-1||M===0||M===1&&h===w-1&&h===f+1?"":n.slice(h,w)},format:A.bind(null,"\\"),parse(n){e(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const h=n.length;let f=0,w=n.charCodeAt(0);if(h===1)return _(w)?(s.root=s.dir=n,s):(s.base=s.name=n,s);if(_(w)){if(f=1,_(n.charCodeAt(1))){let x=2,O=x;for(;x<h&&!_(n.charCodeAt(x));)x++;if(x<h&&x!==O){for(O=x;x<h&&_(n.charCodeAt(x));)x++;if(x<h&&x!==O){for(O=x;x<h&&!_(n.charCodeAt(x));)x++;x===h?f=x:x!==O&&(f=x+1)}}}}else if(v(w)&&n.charCodeAt(1)===o){if(h<=2)return s.root=s.dir=n,s;if(f=2,_(n.charCodeAt(2))){if(h===3)return s.root=s.dir=n,s;f=3}}f>0&&(s.root=n.slice(0,f));let R=-1,M=f,S=-1,F=!0,C=n.length-1,I=0;for(;C>=f;--C){if(w=n.charCodeAt(C),_(w)){if(!F){M=C+1;break}continue}S===-1&&(F=!1,S=C+1),w===g?R===-1?R=C:I!==1&&(I=1):R!==-1&&(I=-1)}return S!==-1&&(R===-1||I===0||I===1&&R===S-1&&R===M+1?s.base=s.name=n.slice(M,S):(s.name=n.slice(M,R),s.base=n.slice(M,S),s.ext=n.slice(R,S))),M>0&&M!==f?s.dir=n.slice(0,M-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(m){const n=/\\/g;return()=>{const s=i.cwd().replace(n,"/");return s.slice(s.indexOf("/"))}}return()=>i.cwd()})();t.posix={resolve(...n){let s="",h=!1;for(let f=n.length-1;f>=-1&&!h;f--){const w=f>=0?n[f]:l();e(w,"path"),w.length!==0&&(s=`${w}/${s}`,h=w.charCodeAt(0)===u)}return s=N(s,!h,"/",L),h?`/${s}`:s.length>0?s:"."},normalize(n){if(e(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===u,h=n.charCodeAt(n.length-1)===u;return n=N(n,!s,"/",L),n.length===0?s?"/":h?"./":".":(h&&(n+="/"),s?`/${n}`:n)},isAbsolute(n){return e(n,"path"),n.length>0&&n.charCodeAt(0)===u},join(...n){if(n.length===0)return".";let s;for(let h=0;h<n.length;++h){const f=n[h];e(f,"path"),f.length>0&&(s===void 0?s=f:s+=`/${f}`)}return s===void 0?".":t.posix.normalize(s)},relative(n,s){if(e(n,"from"),e(s,"to"),n===s||(n=t.posix.resolve(n),s=t.posix.resolve(s),n===s))return"";const h=1,f=n.length,w=f-h,R=1,M=s.length-R,S=w<M?w:M;let F=-1,C=0;for(;C<S;C++){const x=n.charCodeAt(h+C);if(x!==s.charCodeAt(R+C))break;x===u&&(F=C)}if(C===S)if(M>S){if(s.charCodeAt(R+C)===u)return s.slice(R+C+1);if(C===0)return s.slice(R+C)}else w>S&&(n.charCodeAt(h+C)===u?F=C:C===0&&(F=0));let I="";for(C=h+F+1;C<=f;++C)(C===f||n.charCodeAt(C)===u)&&(I+=I.length===0?"..":"/..");return`${I}${s.slice(R+F)}`},toNamespacedPath(n){return n},dirname(n){if(e(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===u;let h=-1,f=!0;for(let w=n.length-1;w>=1;--w)if(n.charCodeAt(w)===u){if(!f){h=w;break}}else f=!1;return h===-1?s?"/":".":s&&h===1?"//":n.slice(0,h)},basename(n,s){s!==void 0&&e(s,"ext"),e(n,"path");let h=0,f=-1,w=!0,R;if(s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let M=s.length-1,S=-1;for(R=n.length-1;R>=0;--R){const F=n.charCodeAt(R);if(F===u){if(!w){h=R+1;break}}else S===-1&&(w=!1,S=R+1),M>=0&&(F===s.charCodeAt(M)?--M===-1&&(f=R):(M=-1,f=S))}return h===f?f=S:f===-1&&(f=n.length),n.slice(h,f)}for(R=n.length-1;R>=0;--R)if(n.charCodeAt(R)===u){if(!w){h=R+1;break}}else f===-1&&(w=!1,f=R+1);return f===-1?"":n.slice(h,f)},extname(n){e(n,"path");let s=-1,h=0,f=-1,w=!0,R=0;for(let M=n.length-1;M>=0;--M){const S=n.charCodeAt(M);if(S===u){if(!w){h=M+1;break}continue}f===-1&&(w=!1,f=M+1),S===g?s===-1?s=M:R!==1&&(R=1):s!==-1&&(R=-1)}return s===-1||f===-1||R===0||R===1&&s===f-1&&s===h+1?"":n.slice(s,f)},format:A.bind(null,"/"),parse(n){e(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const h=n.charCodeAt(0)===u;let f;h?(s.root="/",f=1):f=0;let w=-1,R=0,M=-1,S=!0,F=n.length-1,C=0;for(;F>=f;--F){const I=n.charCodeAt(F);if(I===u){if(!S){R=F+1;break}continue}M===-1&&(S=!1,M=F+1),I===g?w===-1?w=F:C!==1&&(C=1):w!==-1&&(C=-1)}if(M!==-1){const I=R===0&&h?1:R;w===-1||C===0||C===1&&w===M-1&&w===R+1?s.base=s.name=n.slice(I,M):(s.name=n.slice(I,w),s.base=n.slice(I,M),s.ext=n.slice(w,M))}return R>0?s.dir=n.slice(0,R-1):h&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=m?t.win32.normalize:t.posix.normalize,t.isAbsolute=m?t.win32.isAbsolute:t.posix.isAbsolute,t.join=m?t.win32.join:t.posix.join,t.resolve=m?t.win32.resolve:t.posix.resolve,t.relative=m?t.win32.relative:t.posix.relative,t.dirname=m?t.win32.dirname:t.posix.dirname,t.basename=m?t.win32.basename:t.posix.basename,t.extname=m?t.win32.extname:t.posix.extname,t.format=m?t.win32.format:t.posix.format,t.parse=m?t.win32.parse:t.posix.parse,t.toNamespacedPath=m?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=m?t.win32.sep:t.posix.sep,t.delimiter=m?t.win32.delimiter:t.posix.delimiter}),ie(se[19],ue([0,1,71,18]),function(W,t,i,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.isUriComponents=e,t.uriToFsPath=A;const y=/^\w[\w\d+.-]*$/,c=/^\//,p=/^\/\//;function g(f,w){if(!f.scheme&&w)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${f.authority}", path: "${f.path}", query: "${f.query}", fragment: "${f.fragment}"}`);if(f.scheme&&!y.test(f.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(f.path){if(f.authority){if(!c.test(f.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(f.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(f,w){return!f&&!w?"file":f}function a(f,w){switch(f){case"https":case"http":case"file":w?w[0]!==E&&(w=E+w):w=E;break}return w}const o="",E="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{static isUri(w){return w instanceof b?!0:w?typeof w.authority=="string"&&typeof w.fragment=="string"&&typeof w.path=="string"&&typeof w.query=="string"&&typeof w.scheme=="string"&&typeof w.fsPath=="string"&&typeof w.with=="function"&&typeof w.toString=="function":!1}constructor(w,R,M,S,F,C=!1){typeof w=="object"?(this.scheme=w.scheme||o,this.authority=w.authority||o,this.path=w.path||o,this.query=w.query||o,this.fragment=w.fragment||o):(this.scheme=u(w,C),this.authority=R||o,this.path=a(this.scheme,M||o),this.query=S||o,this.fragment=F||o,g(this,C))}get fsPath(){return A(this,!1)}with(w){if(!w)return this;let{scheme:R,authority:M,path:S,query:F,fragment:C}=w;return R===void 0?R=this.scheme:R===null&&(R=o),M===void 0?M=this.authority:M===null&&(M=o),S===void 0?S=this.path:S===null&&(S=o),F===void 0?F=this.query:F===null&&(F=o),C===void 0?C=this.fragment:C===null&&(C=o),R===this.scheme&&M===this.authority&&S===this.path&&F===this.query&&C===this.fragment?this:new _(R,M,S,F,C)}static parse(w,R=!1){const M=d.exec(w);return M?new _(M[2]||o,h(M[4]||o),h(M[5]||o),h(M[7]||o),h(M[9]||o),R):new _(o,o,o,o,o)}static file(w){let R=o;if(D.isWindows&&(w=w.replace(/\\/g,E)),w[0]===E&&w[1]===E){const M=w.indexOf(E,2);M===-1?(R=w.substring(2),w=E):(R=w.substring(2,M),w=w.substring(M)||E)}return new _("file",R,w,o,o)}static from(w,R){return new _(w.scheme,w.authority,w.path,w.query,w.fragment,R)}static joinPath(w,...R){if(!w.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return D.isWindows&&w.scheme==="file"?M=b.file(i.win32.join(A(w,!0),...R)).path:M=i.posix.join(w.path,...R),w.with({path:M})}toString(w=!1){return l(this,w)}toJSON(){return this}static revive(w){if(w){if(w instanceof b)return w;{const R=new _(w);return R._formatted=w.external??null,R._fsPath=w._sep===m?w.fsPath??null:null,R}}else return w}}t.URI=b;function e(f){return!f||typeof f!="object"?!1:typeof f.scheme=="string"&&(typeof f.authority=="string"||typeof f.authority>"u")&&(typeof f.path=="string"||typeof f.path>"u")&&(typeof f.query=="string"||typeof f.query>"u")&&(typeof f.fragment=="string"||typeof f.fragment>"u")}const m=D.isWindows?1:void 0;class _ extends b{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=A(this,!1)),this._fsPath}toString(w=!1){return w?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const w={$mid:1};return this._fsPath&&(w.fsPath=this._fsPath,w._sep=m),this._formatted&&(w.external=this._formatted),this.path&&(w.path=this.path),this.scheme&&(w.scheme=this.scheme),this.authority&&(w.authority=this.authority),this.query&&(w.query=this.query),this.fragment&&(w.fragment=this.fragment),w}}const L={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function v(f,w,R){let M,S=-1;for(let F=0;F<f.length;F++){const C=f.charCodeAt(F);if(C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57||C===45||C===46||C===95||C===126||w&&C===47||R&&C===91||R&&C===93||R&&C===58)S!==-1&&(M+=encodeURIComponent(f.substring(S,F)),S=-1),M!==void 0&&(M+=f.charAt(F));else{M===void 0&&(M=f.substr(0,F));const I=L[C];I!==void 0?(S!==-1&&(M+=encodeURIComponent(f.substring(S,F)),S=-1),M+=I):S===-1&&(S=F)}}return S!==-1&&(M+=encodeURIComponent(f.substring(S))),M!==void 0?M:f}function N(f){let w;for(let R=0;R<f.length;R++){const M=f.charCodeAt(R);M===35||M===63?(w===void 0&&(w=f.substr(0,R)),w+=L[M]):w!==void 0&&(w+=f[R])}return w!==void 0?w:f}function A(f,w){let R;return f.authority&&f.path.length>1&&f.scheme==="file"?R=`//${f.authority}${f.path}`:f.path.charCodeAt(0)===47&&(f.path.charCodeAt(1)>=65&&f.path.charCodeAt(1)<=90||f.path.charCodeAt(1)>=97&&f.path.charCodeAt(1)<=122)&&f.path.charCodeAt(2)===58?w?R=f.path.substr(1):R=f.path[1].toLowerCase()+f.path.substr(2):R=f.path,D.isWindows&&(R=R.replace(/\//g,"\\")),R}function l(f,w){const R=w?N:v;let M="",{scheme:S,authority:F,path:C,query:I,fragment:x}=f;if(S&&(M+=S,M+=":"),(F||S==="file")&&(M+=E,M+=E),F){let O=F.indexOf("@");if(O!==-1){const T=F.substr(0,O);F=F.substr(O+1),O=T.lastIndexOf(":"),O===-1?M+=R(T,!1,!1):(M+=R(T.substr(0,O),!1,!1),M+=":",M+=R(T.substr(O+1),!1,!0)),M+="@"}F=F.toLowerCase(),O=F.lastIndexOf(":"),O===-1?M+=R(F,!1,!0):(M+=R(F.substr(0,O),!1,!0),M+=F.substr(O))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const O=C.charCodeAt(1);O>=65&&O<=90&&(C=`/${String.fromCharCode(O+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const O=C.charCodeAt(0);O>=65&&O<=90&&(C=`${String.fromCharCode(O+32)}:${C.substr(2)}`)}M+=R(C,!0,!1)}return I&&(M+="?",M+=R(I,!1,!1)),x&&(M+="#",M+=w?x:v(x,!1,!1)),M}function n(f){try{return decodeURIComponent(f)}catch{return f.length>3?f.substr(0,3)+n(f.substr(3)):f}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(f){return f.match(s)?f.replace(s,w=>n(w)):f}}),ie(se[76],ue([0,1,3,12,11,15,18,7]),function(W,t,i,D,y,c,p,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SimpleWorkerServer=t.SimpleWorkerClient=void 0,t.logOnceWebWorkerWarning=o,t.create=s;const u="$initialize";let a=!1;function o(h){p.isWeb&&(a||(a=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(h.message))}var E;(function(h){h[h.Request=0]="Request",h[h.Reply=1]="Reply",h[h.SubscribeEvent=2]="SubscribeEvent",h[h.Event=3]="Event",h[h.UnsubscribeEvent=4]="UnsubscribeEvent"})(E||(E={}));class d{constructor(f,w,R,M){this.vsWorker=f,this.req=w,this.method=R,this.args=M,this.type=0}}class b{constructor(f,w,R,M){this.vsWorker=f,this.seq=w,this.res=R,this.err=M,this.type=1}}class e{constructor(f,w,R,M){this.vsWorker=f,this.req=w,this.eventName=R,this.arg=M,this.type=2}}class m{constructor(f,w,R){this.vsWorker=f,this.req=w,this.event=R,this.type=3}}class _{constructor(f,w){this.vsWorker=f,this.req=w,this.type=4}}class L{constructor(f){this._workerId=-1,this._handler=f,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(f){this._workerId=f}sendMessage(f,w){const R=String(++this._lastSentReq);return new Promise((M,S)=>{this._pendingReplies[R]={resolve:M,reject:S},this._send(new d(this._workerId,R,f,w))})}listen(f,w){let R=null;const M=new D.Emitter({onWillAddFirstListener:()=>{R=String(++this._lastSentReq),this._pendingEmitters.set(R,M),this._send(new e(this._workerId,R,f,w))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(R),this._send(new _(this._workerId,R)),R=null}});return M.event}handleMessage(f){!f||!f.vsWorker||this._workerId!==-1&&f.vsWorker!==this._workerId||this._handleMessage(f)}_handleMessage(f){switch(f.type){case 1:return this._handleReplyMessage(f);case 0:return this._handleRequestMessage(f);case 2:return this._handleSubscribeEventMessage(f);case 3:return this._handleEventMessage(f);case 4:return this._handleUnsubscribeEventMessage(f)}}_handleReplyMessage(f){if(!this._pendingReplies[f.seq]){console.warn("Got reply to unknown seq");return}const w=this._pendingReplies[f.seq];if(delete this._pendingReplies[f.seq],f.err){let R=f.err;f.err.$isError&&(R=new Error,R.name=f.err.name,R.message=f.err.message,R.stack=f.err.stack),w.reject(R);return}w.resolve(f.res)}_handleRequestMessage(f){const w=f.req;this._handler.handleMessage(f.method,f.args).then(M=>{this._send(new b(this._workerId,w,M,void 0))},M=>{M.detail instanceof Error&&(M.detail=(0,i.transformErrorForSerialization)(M.detail)),this._send(new b(this._workerId,w,void 0,(0,i.transformErrorForSerialization)(M)))})}_handleSubscribeEventMessage(f){const w=f.req,R=this._handler.handleEvent(f.eventName,f.arg)(M=>{this._send(new m(this._workerId,w,M))});this._pendingEvents.set(w,R)}_handleEventMessage(f){if(!this._pendingEmitters.has(f.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(f.req).fire(f.event)}_handleUnsubscribeEventMessage(f){if(!this._pendingEvents.has(f.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(f.req).dispose(),this._pendingEvents.delete(f.req)}_send(f){const w=[];if(f.type===0)for(let R=0;R<f.args.length;R++)f.args[R]instanceof ArrayBuffer&&w.push(f.args[R]);else f.type===1&&f.res instanceof ArrayBuffer&&w.push(f.res);this._handler.sendMessage(f,w)}}class v extends y.Disposable{constructor(f,w,R){super();let M=null;this._worker=this._register(f.create("vs/base/common/worker/simpleWorker",O=>{this._protocol.handleMessage(O)},O=>{M?.(O)})),this._protocol=new L({sendMessage:(O,T)=>{this._worker.postMessage(O,T)},handleMessage:(O,T)=>{if(typeof R[O]!="function")return Promise.reject(new Error("Missing method "+O+" on main thread host."));try{return Promise.resolve(R[O].apply(R,T))}catch(H){return Promise.reject(H)}},handleEvent:(O,T)=>{if(A(O)){const H=R[O].call(R,T);if(typeof H!="function")throw new Error(`Missing dynamic event ${O} on main thread host.`);return H}if(N(O)){const H=R[O];if(typeof H!="function")throw new Error(`Missing event ${O} on main thread host.`);return H}throw new Error(`Malformed event name ${O}`)}}),this._protocol.setWorkerId(this._worker.getId());let S=null;const F=globalThis.require;typeof F<"u"&&typeof F.getConfig=="function"?S=F.getConfig():typeof globalThis.requirejs<"u"&&(S=globalThis.requirejs.s.contexts._.config);const C=(0,c.getAllMethodNames)(R);this._onModuleLoaded=this._protocol.sendMessage(u,[this._worker.getId(),JSON.parse(JSON.stringify(S)),w,C]);const I=(O,T)=>this._request(O,T),x=(O,T)=>this._protocol.listen(O,T);this._lazyProxy=new Promise((O,T)=>{M=T,this._onModuleLoaded.then(H=>{O(l(H,I,x))},H=>{T(H),this._onError("Worker failed to load "+w,H)})})}getProxyObject(){return this._lazyProxy}_request(f,w){return new Promise((R,M)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(f,w).then(R,M)},M)})}_onError(f,w){console.error(f),console.info(w)}}t.SimpleWorkerClient=v;function N(h){return h[0]==="o"&&h[1]==="n"&&g.isUpperAsciiLetter(h.charCodeAt(2))}function A(h){return/^onDynamic/.test(h)&&g.isUpperAsciiLetter(h.charCodeAt(9))}function l(h,f,w){const R=F=>function(){const C=Array.prototype.slice.call(arguments,0);return f(F,C)},M=F=>function(C){return w(F,C)},S={};for(const F of h){if(A(F)){S[F]=M(F);continue}if(N(F)){S[F]=w(F,void 0);continue}S[F]=R(F)}return S}class n{constructor(f,w){this._requestHandlerFactory=w,this._requestHandler=null,this._protocol=new L({sendMessage:(R,M)=>{f(R,M)},handleMessage:(R,M)=>this._handleMessage(R,M),handleEvent:(R,M)=>this._handleEvent(R,M)})}onmessage(f){this._protocol.handleMessage(f)}_handleMessage(f,w){if(f===u)return this.initialize(w[0],w[1],w[2],w[3]);if(!this._requestHandler||typeof this._requestHandler[f]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+f));try{return Promise.resolve(this._requestHandler[f].apply(this._requestHandler,w))}catch(R){return Promise.reject(R)}}_handleEvent(f,w){if(!this._requestHandler)throw new Error("Missing requestHandler");if(A(f)){const R=this._requestHandler[f].call(this._requestHandler,w);if(typeof R!="function")throw new Error(`Missing dynamic event ${f} on request handler.`);return R}if(N(f)){const R=this._requestHandler[f];if(typeof R!="function")throw new Error(`Missing event ${f} on request handler.`);return R}throw new Error(`Malformed event name ${f}`)}initialize(f,w,R,M){this._protocol.setWorkerId(f);const C=l(M,(I,x)=>this._protocol.sendMessage(I,x),(I,x)=>this._protocol.listen(I,x));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(C),Promise.resolve((0,c.getAllMethodNames)(this._requestHandler))):(w&&(typeof w.baseUrl<"u"&&delete w.baseUrl,typeof w.paths<"u"&&typeof w.paths.vs<"u"&&delete w.paths.vs,typeof w.trustedTypesPolicy<"u"&&delete w.trustedTypesPolicy,w.catchError=!0,globalThis.require.config(w)),new Promise((I,x)=>{(globalThis.require||W)([R],T=>{if(this._requestHandler=T.create(C),!this._requestHandler){x(new Error("No RequestHandler!"));return}I((0,c.getAllMethodNames)(this._requestHandler))},x)}))}}t.SimpleWorkerServer=n;function s(h){return new n(h,null)}}),ie(se[72],ue([68,69]),function(W,t){return W.create("vs/editor/common/languages",t)}),ie(se[73],ue([0,1,44,19,45,2,66,72]),function(W,t,i,D,y,c,p,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineEditTriggerKind=t.ExternalUriOpenerPriority=t.TokenizationRegistry=t.LazyTokenizationSupport=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadApplicability=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.NewSymbolNameTriggerKind=t.NewSymbolNameTag=t.FoldingRangeKind=t.TextEdit=t.SymbolKinds=t.SymbolTag=t.symbolKindNames=t.SymbolKind=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.DocumentPasteTriggerKind=t.CodeActionTriggerType=t.SelectedSuggestionInfo=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.PartialAcceptTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.HoverVerbosityAction=t.EncodedTokenizationResult=t.TokenizationResult=t.Token=void 0,t.isLocationLink=h,t.getAriaLabelForSymbol=w;class u{constructor(Q,de,he){this.offset=Q,this.type=de,this.language=he,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.Token=u;class a{constructor(Q,de){this.tokens=Q,this.endState=de,this._tokenizationResultBrand=void 0}}t.TokenizationResult=a;class o{constructor(Q,de){this.tokens=Q,this.endState=de,this._encodedTokenizationResultBrand=void 0}}t.EncodedTokenizationResult=o;var E;(function(P){P[P.Increase=0]="Increase",P[P.Decrease=1]="Decrease"})(E||(t.HoverVerbosityAction=E={}));var d;(function(P){P[P.Method=0]="Method",P[P.Function=1]="Function",P[P.Constructor=2]="Constructor",P[P.Field=3]="Field",P[P.Variable=4]="Variable",P[P.Class=5]="Class",P[P.Struct=6]="Struct",P[P.Interface=7]="Interface",P[P.Module=8]="Module",P[P.Property=9]="Property",P[P.Event=10]="Event",P[P.Operator=11]="Operator",P[P.Unit=12]="Unit",P[P.Value=13]="Value",P[P.Constant=14]="Constant",P[P.Enum=15]="Enum",P[P.EnumMember=16]="EnumMember",P[P.Keyword=17]="Keyword",P[P.Text=18]="Text",P[P.Color=19]="Color",P[P.File=20]="File",P[P.Reference=21]="Reference",P[P.Customcolor=22]="Customcolor",P[P.Folder=23]="Folder",P[P.TypeParameter=24]="TypeParameter",P[P.User=25]="User",P[P.Issue=26]="Issue",P[P.Snippet=27]="Snippet"})(d||(t.CompletionItemKind=d={}));var b;(function(P){const Q=new Map;Q.set(0,i.Codicon.symbolMethod),Q.set(1,i.Codicon.symbolFunction),Q.set(2,i.Codicon.symbolConstructor),Q.set(3,i.Codicon.symbolField),Q.set(4,i.Codicon.symbolVariable),Q.set(5,i.Codicon.symbolClass),Q.set(6,i.Codicon.symbolStruct),Q.set(7,i.Codicon.symbolInterface),Q.set(8,i.Codicon.symbolModule),Q.set(9,i.Codicon.symbolProperty),Q.set(10,i.Codicon.symbolEvent),Q.set(11,i.Codicon.symbolOperator),Q.set(12,i.Codicon.symbolUnit),Q.set(13,i.Codicon.symbolValue),Q.set(15,i.Codicon.symbolEnum),Q.set(14,i.Codicon.symbolConstant),Q.set(15,i.Codicon.symbolEnum),Q.set(16,i.Codicon.symbolEnumMember),Q.set(17,i.Codicon.symbolKeyword),Q.set(27,i.Codicon.symbolSnippet),Q.set(18,i.Codicon.symbolText),Q.set(19,i.Codicon.symbolColor),Q.set(20,i.Codicon.symbolFile),Q.set(21,i.Codicon.symbolReference),Q.set(22,i.Codicon.symbolCustomColor),Q.set(23,i.Codicon.symbolFolder),Q.set(24,i.Codicon.symbolTypeParameter),Q.set(25,i.Codicon.account),Q.set(26,i.Codicon.issues);function de(r){let _e=Q.get(r);return _e||(console.info("No codicon found for CompletionItemKind "+r),_e=i.Codicon.symbolProperty),_e}P.toIcon=de;const he=new Map;he.set("method",0),he.set("function",1),he.set("constructor",2),he.set("field",3),he.set("variable",4),he.set("class",5),he.set("struct",6),he.set("interface",7),he.set("module",8),he.set("property",9),he.set("event",10),he.set("operator",11),he.set("unit",12),he.set("value",13),he.set("constant",14),he.set("enum",15),he.set("enum-member",16),he.set("enumMember",16),he.set("keyword",17),he.set("snippet",27),he.set("text",18),he.set("color",19),he.set("file",20),he.set("reference",21),he.set("customcolor",22),he.set("folder",23),he.set("type-parameter",24),he.set("typeParameter",24),he.set("account",25),he.set("issue",26);function ve(r,_e){let Re=he.get(r);return typeof Re>"u"&&!_e&&(Re=9),Re}P.fromString=ve})(b||(t.CompletionItemKinds=b={}));var e;(function(P){P[P.Deprecated=1]="Deprecated"})(e||(t.CompletionItemTag=e={}));var m;(function(P){P[P.None=0]="None",P[P.KeepWhitespace=1]="KeepWhitespace",P[P.InsertAsSnippet=4]="InsertAsSnippet"})(m||(t.CompletionItemInsertTextRule=m={}));var _;(function(P){P[P.Word=0]="Word",P[P.Line=1]="Line",P[P.Suggest=2]="Suggest"})(_||(t.PartialAcceptTriggerKind=_={}));var L;(function(P){P[P.Invoke=0]="Invoke",P[P.TriggerCharacter=1]="TriggerCharacter",P[P.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(L||(t.CompletionTriggerKind=L={}));var v;(function(P){P[P.Automatic=0]="Automatic",P[P.Explicit=1]="Explicit"})(v||(t.InlineCompletionTriggerKind=v={}));class N{constructor(Q,de,he,ve){this.range=Q,this.text=de,this.completionKind=he,this.isSnippetText=ve}equals(Q){return c.Range.lift(this.range).equalsRange(Q.range)&&this.text===Q.text&&this.completionKind===Q.completionKind&&this.isSnippetText===Q.isSnippetText}}t.SelectedSuggestionInfo=N;var A;(function(P){P[P.Invoke=1]="Invoke",P[P.Auto=2]="Auto"})(A||(t.CodeActionTriggerType=A={}));var l;(function(P){P[P.Automatic=0]="Automatic",P[P.PasteAs=1]="PasteAs"})(l||(t.DocumentPasteTriggerKind=l={}));var n;(function(P){P[P.Invoke=1]="Invoke",P[P.TriggerCharacter=2]="TriggerCharacter",P[P.ContentChange=3]="ContentChange"})(n||(t.SignatureHelpTriggerKind=n={}));var s;(function(P){P[P.Text=0]="Text",P[P.Read=1]="Read",P[P.Write=2]="Write"})(s||(t.DocumentHighlightKind=s={}));function h(P){return P&&D.URI.isUri(P.uri)&&c.Range.isIRange(P.range)&&(c.Range.isIRange(P.originSelectionRange)||c.Range.isIRange(P.targetSelectionRange))}var f;(function(P){P[P.File=0]="File",P[P.Module=1]="Module",P[P.Namespace=2]="Namespace",P[P.Package=3]="Package",P[P.Class=4]="Class",P[P.Method=5]="Method",P[P.Property=6]="Property",P[P.Field=7]="Field",P[P.Constructor=8]="Constructor",P[P.Enum=9]="Enum",P[P.Interface=10]="Interface",P[P.Function=11]="Function",P[P.Variable=12]="Variable",P[P.Constant=13]="Constant",P[P.String=14]="String",P[P.Number=15]="Number",P[P.Boolean=16]="Boolean",P[P.Array=17]="Array",P[P.Object=18]="Object",P[P.Key=19]="Key",P[P.Null=20]="Null",P[P.EnumMember=21]="EnumMember",P[P.Struct=22]="Struct",P[P.Event=23]="Event",P[P.Operator=24]="Operator",P[P.TypeParameter=25]="TypeParameter"})(f||(t.SymbolKind=f={})),t.symbolKindNames={17:(0,g.localize)(0,null),16:(0,g.localize)(1,null),4:(0,g.localize)(2,null),13:(0,g.localize)(3,null),8:(0,g.localize)(4,null),9:(0,g.localize)(5,null),21:(0,g.localize)(6,null),23:(0,g.localize)(7,null),7:(0,g.localize)(8,null),0:(0,g.localize)(9,null),11:(0,g.localize)(10,null),10:(0,g.localize)(11,null),19:(0,g.localize)(12,null),5:(0,g.localize)(13,null),1:(0,g.localize)(14,null),2:(0,g.localize)(15,null),20:(0,g.localize)(16,null),15:(0,g.localize)(17,null),18:(0,g.localize)(18,null),24:(0,g.localize)(19,null),3:(0,g.localize)(20,null),6:(0,g.localize)(21,null),14:(0,g.localize)(22,null),22:(0,g.localize)(23,null),25:(0,g.localize)(24,null),12:(0,g.localize)(25,null)};function w(P,Q){return(0,g.localize)(26,null,P,t.symbolKindNames[Q])}var R;(function(P){P[P.Deprecated=1]="Deprecated"})(R||(t.SymbolTag=R={}));var M;(function(P){const Q=new Map;Q.set(0,i.Codicon.symbolFile),Q.set(1,i.Codicon.symbolModule),Q.set(2,i.Codicon.symbolNamespace),Q.set(3,i.Codicon.symbolPackage),Q.set(4,i.Codicon.symbolClass),Q.set(5,i.Codicon.symbolMethod),Q.set(6,i.Codicon.symbolProperty),Q.set(7,i.Codicon.symbolField),Q.set(8,i.Codicon.symbolConstructor),Q.set(9,i.Codicon.symbolEnum),Q.set(10,i.Codicon.symbolInterface),Q.set(11,i.Codicon.symbolFunction),Q.set(12,i.Codicon.symbolVariable),Q.set(13,i.Codicon.symbolConstant),Q.set(14,i.Codicon.symbolString),Q.set(15,i.Codicon.symbolNumber),Q.set(16,i.Codicon.symbolBoolean),Q.set(17,i.Codicon.symbolArray),Q.set(18,i.Codicon.symbolObject),Q.set(19,i.Codicon.symbolKey),Q.set(20,i.Codicon.symbolNull),Q.set(21,i.Codicon.symbolEnumMember),Q.set(22,i.Codicon.symbolStruct),Q.set(23,i.Codicon.symbolEvent),Q.set(24,i.Codicon.symbolOperator),Q.set(25,i.Codicon.symbolTypeParameter);function de(he){let ve=Q.get(he);return ve||(console.info("No codicon found for SymbolKind "+he),ve=i.Codicon.symbolProperty),ve}P.toIcon=de})(M||(t.SymbolKinds=M={}));class S{static asEditOperation(Q){return y.EditOperation.replace(c.Range.lift(Q.range),Q.text)}}t.TextEdit=S;class F{static{this.Comment=new F("comment")}static{this.Imports=new F("imports")}static{this.Region=new F("region")}static fromValue(Q){switch(Q){case"comment":return F.Comment;case"imports":return F.Imports;case"region":return F.Region}return new F(Q)}constructor(Q){this.value=Q}}t.FoldingRangeKind=F;var C;(function(P){P[P.AIGenerated=1]="AIGenerated"})(C||(t.NewSymbolNameTag=C={}));var I;(function(P){P[P.Invoke=0]="Invoke",P[P.Automatic=1]="Automatic"})(I||(t.NewSymbolNameTriggerKind=I={}));var x;(function(P){function Q(de){return!de||typeof de!="object"?!1:typeof de.id=="string"&&typeof de.title=="string"}P.is=Q})(x||(t.Command=x={}));var O;(function(P){P[P.Collapsed=0]="Collapsed",P[P.Expanded=1]="Expanded"})(O||(t.CommentThreadCollapsibleState=O={}));var T;(function(P){P[P.Unresolved=0]="Unresolved",P[P.Resolved=1]="Resolved"})(T||(t.CommentThreadState=T={}));var H;(function(P){P[P.Current=0]="Current",P[P.Outdated=1]="Outdated"})(H||(t.CommentThreadApplicability=H={}));var J;(function(P){P[P.Editing=0]="Editing",P[P.Preview=1]="Preview"})(J||(t.CommentMode=J={}));var Y;(function(P){P[P.Published=0]="Published",P[P.Draft=1]="Draft"})(Y||(t.CommentState=Y={}));var $;(function(P){P[P.Type=1]="Type",P[P.Parameter=2]="Parameter"})($||(t.InlayHintKind=$={}));class G{constructor(Q){this.createSupport=Q,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(Q=>{Q&&Q.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}t.LazyTokenizationSupport=G,t.TokenizationRegistry=new p.TokenizationRegistry;var K;(function(P){P[P.None=0]="None",P[P.Option=1]="Option",P[P.Default=2]="Default",P[P.Preferred=3]="Preferred"})(K||(t.ExternalUriOpenerPriority=K={}));var ee;(function(P){P[P.Invoke=0]="Invoke",P[P.Automatic=1]="Automatic"})(ee||(t.InlineEditTriggerKind=ee={}))}),ie(se[74],ue([0,1,24,12,39,19,4,2,46,73,65]),function(W,t,i,D,y,c,p,g,u,a,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=void 0,t.createMonacoBaseAPI=d;class E{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,m){return(0,y.KeyChord)(e,m)}}t.KeyMod=E;function d(){return{editor:void 0,languages:void 0,CancellationTokenSource:i.CancellationTokenSource,Emitter:D.Emitter,KeyCode:o.KeyCode,KeyMod:E,Position:p.Position,Range:g.Range,Selection:u.Selection,SelectionDirection:o.SelectionDirection,MarkerSeverity:o.MarkerSeverity,MarkerTag:o.MarkerTag,Uri:c.URI,Token:a.Token}}}),ie(se[77],ue([0,1,25,19,4,2,61,31,57,58,74,23,64,35,55,15,3,56,63]),function(W,t,i,D,y,c,p,g,u,a,o,E,d,b,e,m,_,L,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EditorSimpleWorker=void 0,t.create=l;class N extends p.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(s){const h=[];for(let f=0;f<this._lines.length;f++){const w=this._lines[f],R=this.offsetAt(new y.Position(f+1,1)),M=w.matchAll(s);for(const S of M)(S.index||S.index===0)&&(S.index=S.index+R),h.push(S)}return h}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(s){return this._lines[s-1]}getWordAtPosition(s,h){const f=(0,g.getWordAtText)(s.column,(0,g.ensureValidWordDefinition)(h),this._lines[s.lineNumber-1],0);return f?new c.Range(s.lineNumber,f.startColumn,s.lineNumber,f.endColumn):null}getWordUntilPosition(s,h){const f=this.getWordAtPosition(s,h);return f?{word:this._lines[s.lineNumber-1].substring(f.startColumn-1,s.column-1),startColumn:f.startColumn,endColumn:s.column}:{word:"",startColumn:s.column,endColumn:s.column}}words(s){const h=this._lines,f=this._wordenize.bind(this);let w=0,R="",M=0,S=[];return{*[Symbol.iterator](){for(;;)if(M<S.length){const F=R.substring(S[M].start,S[M].end);M+=1,yield F}else if(w<h.length)R=h[w],S=f(R,s),M=0,w+=1;else break}}}getLineWords(s,h){const f=this._lines[s-1],w=this._wordenize(f,h),R=[];for(const M of w)R.push({word:f.substring(M.start,M.end),startColumn:M.start+1,endColumn:M.end+1});return R}_wordenize(s,h){const f=[];let w;for(h.lastIndex=0;(w=h.exec(s))&&w[0].length!==0;)f.push({start:w.index,end:w.index+w[0].length});return f}getValueInRange(s){if(s=this._validateRange(s),s.startLineNumber===s.endLineNumber)return this._lines[s.startLineNumber-1].substring(s.startColumn-1,s.endColumn-1);const h=this._eol,f=s.startLineNumber-1,w=s.endLineNumber-1,R=[];R.push(this._lines[f].substring(s.startColumn-1));for(let M=f+1;M<w;M++)R.push(this._lines[M]);return R.push(this._lines[w].substring(0,s.endColumn-1)),R.join(h)}offsetAt(s){return s=this._validatePosition(s),this._ensureLineStarts(),this._lineStarts.getPrefixSum(s.lineNumber-2)+(s.column-1)}positionAt(s){s=Math.floor(s),s=Math.max(0,s),this._ensureLineStarts();const h=this._lineStarts.getIndexOf(s),f=this._lines[h.index].length;return{lineNumber:1+h.index,column:1+Math.min(h.remainder,f)}}_validateRange(s){const h=this._validatePosition({lineNumber:s.startLineNumber,column:s.startColumn}),f=this._validatePosition({lineNumber:s.endLineNumber,column:s.endColumn});return h.lineNumber!==s.startLineNumber||h.column!==s.startColumn||f.lineNumber!==s.endLineNumber||f.column!==s.endColumn?{startLineNumber:h.lineNumber,startColumn:h.column,endLineNumber:f.lineNumber,endColumn:f.column}:s}_validatePosition(s){if(!y.Position.isIPosition(s))throw new Error("bad position");let{lineNumber:h,column:f}=s,w=!1;if(h<1)h=1,f=1,w=!0;else if(h>this._lines.length)h=this._lines.length,f=this._lines[h-1].length+1,w=!0;else{const R=this._lines[h-1].length+1;f<1?(f=1,w=!0):f>R&&(f=R,w=!0)}return w?{lineNumber:h,column:f}:s}}class A{constructor(s,h){this._host=s,this._models=Object.create(null),this._foreignModuleFactory=h,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(s){return this._models[s]}_getModels(){const s=[];return Object.keys(this._models).forEach(h=>s.push(this._models[h])),s}acceptNewModel(s){this._models[s.url]=new N(D.URI.parse(s.url),s.lines,s.EOL,s.versionId)}acceptModelChanged(s,h){if(!this._models[s])return;this._models[s].onEvents(h)}acceptRemovedModel(s){this._models[s]&&delete this._models[s]}async computeUnicodeHighlights(s,h,f){const w=this._getModel(s);return w?d.UnicodeTextModelHighlighter.computeUnicodeHighlights(w,h,f):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async findSectionHeaders(s,h){const f=this._getModel(s);return f?(0,v.findSectionHeaders)(f,h):[]}async computeDiff(s,h,f,w){const R=this._getModel(s),M=this._getModel(h);return!R||!M?null:A.computeDiff(R,M,f,w)}static computeDiff(s,h,f,w){const R=w==="advanced"?e.linesDiffComputers.getDefault():e.linesDiffComputers.getLegacy(),M=s.getLinesContent(),S=h.getLinesContent(),F=R.computeDiff(M,S,f),C=F.changes.length>0?!1:this._modelsAreIdentical(s,h);function I(x){return x.map(O=>[O.original.startLineNumber,O.original.endLineNumberExclusive,O.modified.startLineNumber,O.modified.endLineNumberExclusive,O.innerChanges?.map(T=>[T.originalRange.startLineNumber,T.originalRange.startColumn,T.originalRange.endLineNumber,T.originalRange.endColumn,T.modifiedRange.startLineNumber,T.modifiedRange.startColumn,T.modifiedRange.endLineNumber,T.modifiedRange.endColumn])])}return{identical:C,quitEarly:F.hitTimeout,changes:I(F.changes),moves:F.moves.map(x=>[x.lineRangeMapping.original.startLineNumber,x.lineRangeMapping.original.endLineNumberExclusive,x.lineRangeMapping.modified.startLineNumber,x.lineRangeMapping.modified.endLineNumberExclusive,I(x.changes)])}}static _modelsAreIdentical(s,h){const f=s.getLineCount(),w=h.getLineCount();if(f!==w)return!1;for(let R=1;R<=f;R++){const M=s.getLineContent(R),S=h.getLineContent(R);if(M!==S)return!1}return!0}async computeDirtyDiff(s,h,f){const w=this._getModel(s),R=this._getModel(h);if(!w||!R)return null;const M=w.getLinesContent(),S=R.getLinesContent();return new b.DiffComputer(M,S,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:f,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this._diffLimit=1e5}async computeMoreMinimalEdits(s,h,f){const w=this._getModel(s);if(!w)return h;const R=[];let M;h=h.slice(0).sort((F,C)=>{if(F.range&&C.range)return c.Range.compareRangesUsingStarts(F.range,C.range);const I=F.range?0:1,x=C.range?0:1;return I-x});let S=0;for(let F=1;F<h.length;F++)c.Range.getEndPosition(h[S].range).equals(c.Range.getStartPosition(h[F].range))?(h[S].range=c.Range.fromPositions(c.Range.getStartPosition(h[S].range),c.Range.getEndPosition(h[F].range)),h[S].text+=h[F].text):(S++,h[S]=h[F]);h.length=S+1;for(let{range:F,text:C,eol:I}of h){if(typeof I=="number"&&(M=I),c.Range.isEmpty(F)&&!C)continue;const x=w.getValueInRange(F);if(C=C.replace(/\r\n|\n|\r/g,w.eol),x===C)continue;if(Math.max(C.length,x.length)>A._diffLimit){R.push({range:F,text:C});continue}const O=(0,i.stringDiff)(x,C,f),T=w.offsetAt(c.Range.lift(F).getStartPosition());for(const H of O){const J=w.positionAt(T+H.originalStart),Y=w.positionAt(T+H.originalStart+H.originalLength),$={text:C.substr(H.modifiedStart,H.modifiedLength),range:{startLineNumber:J.lineNumber,startColumn:J.column,endLineNumber:Y.lineNumber,endColumn:Y.column}};w.getValueInRange($.range)!==$.text&&R.push($)}}return typeof M=="number"&&R.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),R}computeHumanReadableDiff(s,h,f){const w=this._getModel(s);if(!w)return h;const R=[];let M;h=h.slice(0).sort((S,F)=>{if(S.range&&F.range)return c.Range.compareRangesUsingStarts(S.range,F.range);const C=S.range?0:1,I=F.range?0:1;return C-I});for(let{range:S,text:F,eol:C}of h){let J=function($,G){return new y.Position($.lineNumber+G.lineNumber-1,G.lineNumber===1?$.column+G.column-1:G.column)},Y=function($,G){const K=[];for(let ee=G.startLineNumber;ee<=G.endLineNumber;ee++){const P=$[ee-1];ee===G.startLineNumber&&ee===G.endLineNumber?K.push(P.substring(G.startColumn-1,G.endColumn-1)):ee===G.startLineNumber?K.push(P.substring(G.startColumn-1)):ee===G.endLineNumber?K.push(P.substring(0,G.endColumn-1)):K.push(P)}return K};if(typeof C=="number"&&(M=C),c.Range.isEmpty(S)&&!F)continue;const I=w.getValueInRange(S);if(F=F.replace(/\r\n|\n|\r/g,w.eol),I===F)continue;if(Math.max(F.length,I.length)>A._diffLimit){R.push({range:S,text:F});continue}const x=I.split(/\r\n|\n|\r/),O=F.split(/\r\n|\n|\r/),T=e.linesDiffComputers.getDefault().computeDiff(x,O,f),H=c.Range.lift(S).getStartPosition();for(const $ of T.changes)if($.innerChanges)for(const G of $.innerChanges)R.push({range:c.Range.fromPositions(J(H,G.originalRange.getStartPosition()),J(H,G.originalRange.getEndPosition())),text:Y(O,G.modifiedRange).join(w.eol)});else throw new _.BugIndicatingError("The experimental diff algorithm always produces inner changes")}return typeof M=="number"&&R.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),R}async computeLinks(s){const h=this._getModel(s);return h?(0,u.computeLinks)(h):null}async computeDefaultDocumentColors(s){const h=this._getModel(s);return h?(0,L.computeDefaultDocumentColors)(h):null}static{this._suggestionsLimit=1e4}async textualSuggest(s,h,f,w){const R=new E.StopWatch,M=new RegExp(f,w),S=new Set;e:for(const F of s){const C=this._getModel(F);if(C){for(const I of C.words(M))if(!(I===h||!isNaN(Number(I)))&&(S.add(I),S.size>A._suggestionsLimit))break e}}return{words:Array.from(S),duration:R.elapsed()}}async computeWordRanges(s,h,f,w){const R=this._getModel(s);if(!R)return Object.create(null);const M=new RegExp(f,w),S=Object.create(null);for(let F=h.startLineNumber;F<h.endLineNumber;F++){const C=R.getLineWords(F,M);for(const I of C){if(!isNaN(Number(I.word)))continue;let x=S[I.word];x||(x=[],S[I.word]=x),x.push({startLineNumber:F,startColumn:I.startColumn,endLineNumber:F,endColumn:I.endColumn})}}return S}async navigateValueSet(s,h,f,w,R){const M=this._getModel(s);if(!M)return null;const S=new RegExp(w,R);h.startColumn===h.endColumn&&(h={startLineNumber:h.startLineNumber,startColumn:h.startColumn,endLineNumber:h.endLineNumber,endColumn:h.endColumn+1});const F=M.getValueInRange(h),C=M.getWordAtPosition({lineNumber:h.startLineNumber,column:h.startColumn},S);if(!C)return null;const I=M.getValueInRange(C);return a.BasicInplaceReplace.INSTANCE.navigateValueSet(h,F,C,I,f)}loadForeignModule(s,h,f){const w=(S,F)=>this._host.fhr(S,F),M={host:(0,m.createProxyObject)(f,w),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(M,h),Promise.resolve((0,m.getAllMethodNames)(this._foreignModule))):new Promise((S,F)=>{W([s],C=>{this._foreignModule=C.create(M,h),S((0,m.getAllMethodNames)(this._foreignModule))},F)})}fmr(s,h){if(!this._foreignModule||typeof this._foreignModule[s]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+s));try{return Promise.resolve(this._foreignModule[s].apply(this._foreignModule,h))}catch(f){return Promise.reject(f)}}}t.EditorSimpleWorker=A;function l(n){return new A(n,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,o.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a045dcfceda27f896936bfd8cbf524f6a93a2f46/core/vs/base/worker/workerMain.js.map
