/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/platform/files/common/files","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","vs/base/common/process","os","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","fs/promises","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ce=function(ne){for(var e=[],_=0,U=ne.length;_<U;_++)e[_]=ae[ne[_]];return e};define(ae[124],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=e.isESM=void 0,e.isESM=!1;class _{static get(){const A=new Map,O=new Map,k=new Map,R=new Map;function P(l,c){l.has(c.detail)||l.set(c.detail,-c.timestamp)}function d(l,c){const p=l.get(c.detail);p&&(p>=0||l.set(c.detail,p+c.timestamp))}let C=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(C=ne.getStats().slice(0).sort((l,c)=>l.timestamp-c.timestamp));for(const l of C)switch(l.type){case 10:P(A,l);break;case 11:case 12:d(A,l);break;case 21:P(O,l);break;case 22:d(O,l);break;case 33:P(k,l);break;case 34:d(k,l);break;case 31:P(R,l);break;case 32:d(R,l);break}let E=0;k.forEach(l=>E+=l);function v(l){const c=[];return l.forEach((p,g)=>c.push([g,p])),c}return{amdLoad:v(A),amdInvoke:v(O),nodeRequire:v(k),nodeEval:v(R),nodeRequireTotal:E}}static toMarkdownTable(A,O){let k="";const R=[];return A.forEach((P,d)=>{R[d]=P.length}),O.forEach(P=>{P.forEach((d,C)=>{typeof d>"u"&&(d=P[C]="-");const E=d.toString().length;R[C]=Math.max(E,R[C])})}),A.forEach((P,d)=>{k+=`| ${P+" ".repeat(R[d]-P.toString().length)} `}),k+=`|
`,A.forEach((P,d)=>{k+=`| ${"-".repeat(R[d])} `}),k+=`|
`,O.forEach(P=>{P.forEach((d,C)=>{typeof d<"u"&&(k+=`| ${d+" ".repeat(R[C]-d.toString().length)} `)}),k+=`|
`}),k}}e.LoaderStats=_}),define(ae[125],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=_,e.findLastIdx=U,e.findLastMonotonous=A,e.findLastIdxMonotonous=O,e.findFirstMonotonous=k,e.findFirstIdxMonotonousOrArrLen=R,e.findFirstIdxMonotonous=P,e.findFirstMax=C,e.findLastMax=E,e.findFirstMin=v,e.findMaxIdx=l,e.mapFindFirst=c;function _(p,g){const u=U(p,g);if(u!==-1)return p[u]}function U(p,g,u=p.length-1){for(let h=u;h>=0;h--){const m=p[h];if(g(m))return h}return-1}function A(p,g){const u=O(p,g);return u===-1?void 0:p[u]}function O(p,g,u=0,h=p.length){let m=u,f=h;for(;m<f;){const S=Math.floor((m+f)/2);g(p[S])?m=S+1:f=S}return m-1}function k(p,g){const u=R(p,g);return u===p.length?void 0:p[u]}function R(p,g,u=0,h=p.length){let m=u,f=h;for(;m<f;){const S=Math.floor((m+f)/2);g(p[S])?f=S:m=S+1}return m}function P(p,g,u=0,h=p.length){const m=R(p,g,u,h);return m===p.length?-1:m}class d{static{this.assertInvariants=!1}constructor(g){this._array=g,this._findLastMonotonousLastIdx=0}findLastMonotonous(g){if(d.assertInvariants){if(this._prevFindLastPredicate){for(const h of this._array)if(this._prevFindLastPredicate(h)&&!g(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=g}const u=O(this._array,g,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=u+1,u===-1?void 0:this._array[u]}}e.MonotonousArray=d;function C(p,g){if(p.length===0)return;let u=p[0];for(let h=1;h<p.length;h++){const m=p[h];g(m,u)>0&&(u=m)}return u}function E(p,g){if(p.length===0)return;let u=p[0];for(let h=1;h<p.length;h++){const m=p[h];g(m,u)>=0&&(u=m)}return u}function v(p,g){return C(p,(u,h)=>-g(u,h))}function l(p,g){if(p.length===0)return-1;let u=0;for(let h=1;h<p.length;h++){const m=p[h];g(m,p[u])>0&&(u=h)}return u}function c(p,g){for(const u of p){const h=g(u);if(h!==void 0)return h}}}),define(ae[126],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.groupBy=_,e.diffSets=U,e.diffMaps=A,e.intersection=O;function _(k,R){const P=Object.create(null);for(const d of k){const C=R(d);let E=P[C];E||(E=P[C]=[]),E.push(d)}return P}function U(k,R){const P=[],d=[];for(const C of k)R.has(C)||P.push(C);for(const C of R)k.has(C)||d.push(C);return{removed:P,added:d}}function A(k,R){const P=[],d=[];for(const[C,E]of k)R.has(C)||P.push(E);for(const[C,E]of R)k.has(C)||d.push(E);return{removed:P,added:d}}function O(k,R){const P=new Set;for(const d of R)k.has(d)&&P.add(d);return P}}),define(ae[84],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=U,e.debounce=A,e.throttle=O;function _(k){return(R,P,d)=>{let C=null,E=null;if(typeof d.value=="function"?(C="value",E=d.value):typeof d.get=="function"&&(C="get",E=d.get),!E)throw new Error("not supported");d[C]=k(E,P)}}function U(k,R,P){let d=null,C=null;if(typeof P.value=="function"?(d="value",C=P.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(d="get",C=P.get),!C)throw new Error("not supported");const E=`$memoize$${R}`;P[d]=function(...v){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,v)}),this[E]}}function A(k,R,P){return _((d,C)=>{const E=`$debounce$${C}`,v=`$debounce$result$${C}`;return function(...l){this[v]||(this[v]=P?P():void 0),clearTimeout(this[E]),R&&(this[v]=R(this[v],...l),l=[this[v]]),this[E]=setTimeout(()=>{d.apply(this,l),this[v]=P?P():void 0},k)}})}function O(k,R,P){return _((d,C)=>{const E=`$throttle$timer$${C}`,v=`$throttle$result$${C}`,l=`$throttle$lastRun$${C}`,c=`$throttle$pending$${C}`;return function(...p){if(this[v]||(this[v]=P?P():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),R&&(this[v]=R(this[v],...p)),this[c])return;const g=this[l]+k;g<=Date.now()?(this[l]=Date.now(),d.apply(this,[this[v]]),this[v]=P?P():void 0):(this[c]=!0,this[E]=setTimeout(()=>{this[c]=!1,this[l]=Date.now(),d.apply(this,[this[v]]),this[v]=P?P():void 0},g-Date.now()))}})}}),define(ae[7],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=U,e.isSigPipeError=A,e.onUnexpectedError=O,e.onUnexpectedExternalError=k,e.transformErrorForSerialization=R,e.isCancellationError=d,e.canceled=E,e.illegalArgument=v,e.illegalState=l,e.getErrorMessage=p;class _{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?m.isErrorNoTelemetry(t)?new m(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=_,e.errorHandler=new _;function U(S){e.errorHandler.setUnexpectedErrorHandler(S)}function A(S){if(!S||typeof S!="object")return!1;const t=S;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function O(S){d(S)||e.errorHandler.onUnexpectedError(S)}function k(S){d(S)||e.errorHandler.onUnexpectedExternalError(S)}function R(S){if(S instanceof Error){const{name:t,message:r}=S,n=S.stacktrace||S.stack;return{$isError:!0,name:t,message:r,stack:n,noTelemetry:m.isErrorNoTelemetry(S)}}return S}const P="Canceled";function d(S){return S instanceof C?!0:S instanceof Error&&S.name===P&&S.message===P}class C extends Error{constructor(){super(P),this.name=this.message}}e.CancellationError=C;function E(){const S=new Error(P);return S.name=S.message,S}function v(S){return S?new Error(`Illegal argument: ${S}`):new Error("Illegal argument")}function l(S){return S?new Error(`Illegal state: ${S}`):new Error("Illegal state")}class c extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=c;function p(S){return S?S.message?S.message:S.stack?S.stack.split(`
`)[0]:String(S):"Error"}class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=g;class u extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=u;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=h;class m extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof m)return t;const r=new m;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=m;class f extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype)}}e.BugIndicatingError=f}),define(ae[17],ce([0,1,7,125]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=A,e.tail2=O,e.equals=k,e.removeFastWithoutKeepingOrder=R,e.binarySearch=P,e.binarySearch2=d,e.quickSelect=C,e.groupBy=E,e.groupAdjacentBy=v,e.forEachAdjacent=l,e.forEachWithNeighbors=c,e.sortedDiff=p,e.delta=g,e.top=u,e.topAsync=h,e.coalesce=f,e.coalesceInPlace=S,e.move=t,e.isFalsyOrEmpty=r,e.isNonEmptyArray=n,e.distinct=s,e.uniqueFilter=i,e.firstOrDefault=o,e.lastOrDefault=a,e.commonPrefixLength=y,e.flatten=I,e.range=w,e.index=b,e.insert=D,e.remove=L,e.arrayInsert=N,e.shuffle=F,e.pushToStart=x,e.pushToEnd=X,e.pushMany=B,e.mapArrayOrNot=Y,e.asArray=z,e.getRandomElement=H,e.insertInto=V,e.splice=q,e.compareBy=ue,e.tieBreakComparators=te,e.reverseOrder=T;function A(G,ee=0){return G[G.length-(1+ee)]}function O(G){if(G.length===0)throw new Error("Invalid tail call");return[G.slice(0,G.length-1),G[G.length-1]]}function k(G,ee,Z=(J,se)=>J===se){if(G===ee)return!0;if(!G||!ee||G.length!==ee.length)return!1;for(let J=0,se=G.length;J<se;J++)if(!Z(G[J],ee[J]))return!1;return!0}function R(G,ee){const Z=G.length-1;ee<Z&&(G[ee]=G[Z]),G.pop()}function P(G,ee,Z){return d(G.length,J=>Z(G[J],ee))}function d(G,ee){let Z=0,J=G-1;for(;Z<=J;){const se=(Z+J)/2|0,he=ee(se);if(he<0)Z=se+1;else if(he>0)J=se-1;else return se}return-(Z+1)}function C(G,ee,Z){if(G=G|0,G>=ee.length)throw new TypeError("invalid index");const J=ee[Math.floor(ee.length*Math.random())],se=[],he=[],ge=[];for(const de of ee){const me=Z(de,J);me<0?se.push(de):me>0?he.push(de):ge.push(de)}return G<se.length?C(G,se,Z):G<se.length+ge.length?ge[0]:C(G-(se.length+ge.length),he,Z)}function E(G,ee){const Z=[];let J;for(const se of G.slice(0).sort(ee))!J||ee(J[0],se)!==0?(J=[se],Z.push(J)):J.push(se);return Z}function*v(G,ee){let Z,J;for(const se of G)J!==void 0&&ee(J,se)?Z.push(se):(Z&&(yield Z),Z=[se]),J=se;Z&&(yield Z)}function l(G,ee){for(let Z=0;Z<=G.length;Z++)ee(Z===0?void 0:G[Z-1],Z===G.length?void 0:G[Z])}function c(G,ee){for(let Z=0;Z<G.length;Z++)ee(Z===0?void 0:G[Z-1],G[Z],Z+1===G.length?void 0:G[Z+1])}function p(G,ee,Z){const J=[];function se(de,me,Ee){if(me===0&&Ee.length===0)return;const we=J[J.length-1];we&&we.start+we.deleteCount===de?(we.deleteCount+=me,we.toInsert.push(...Ee)):J.push({start:de,deleteCount:me,toInsert:Ee})}let he=0,ge=0;for(;;){if(he===G.length){se(he,0,ee.slice(ge));break}if(ge===ee.length){se(he,G.length-he,[]);break}const de=G[he],me=ee[ge],Ee=Z(de,me);Ee===0?(he+=1,ge+=1):Ee<0?(se(he,1,[]),he+=1):Ee>0&&(se(he,0,[me]),ge+=1)}return J}function g(G,ee,Z){const J=p(G,ee,Z),se=[],he=[];for(const ge of J)se.push(...G.slice(ge.start,ge.start+ge.deleteCount)),he.push(...ge.toInsert);return{removed:se,added:he}}function u(G,ee,Z){if(Z===0)return[];const J=G.slice(0,Z).sort(ee);return m(G,ee,J,Z,G.length),J}function h(G,ee,Z,J,se){return Z===0?Promise.resolve([]):new Promise((he,ge)=>{(async()=>{const de=G.length,me=G.slice(0,Z).sort(ee);for(let Ee=Z,we=Math.min(Z+J,de);Ee<de;Ee=we,we=Math.min(we+J,de)){if(Ee>Z&&await new Promise(Pe=>setTimeout(Pe)),se&&se.isCancellationRequested)throw new _.CancellationError;m(G,ee,me,Ee,we)}return me})().then(he,ge)})}function m(G,ee,Z,J,se){for(const he=Z.length;J<se;J++){const ge=G[J];if(ee(ge,Z[he-1])<0){Z.pop();const de=(0,U.findFirstIdxMonotonousOrArrLen)(Z,me=>ee(ge,me)<0);Z.splice(de,0,ge)}}}function f(G){return G.filter(ee=>!!ee)}function S(G){let ee=0;for(let Z=0;Z<G.length;Z++)G[Z]&&(G[ee]=G[Z],ee+=1);G.length=ee}function t(G,ee,Z){G.splice(Z,0,G.splice(ee,1)[0])}function r(G){return!Array.isArray(G)||G.length===0}function n(G){return Array.isArray(G)&&G.length>0}function s(G,ee=Z=>Z){const Z=new Set;return G.filter(J=>{const se=ee(J);return Z.has(se)?!1:(Z.add(se),!0)})}function i(G){const ee=new Set;return Z=>{const J=G(Z);return ee.has(J)?!1:(ee.add(J),!0)}}function o(G,ee){return G.length>0?G[0]:ee}function a(G,ee){return G.length>0?G[G.length-1]:ee}function y(G,ee,Z=(J,se)=>J===se){let J=0;for(let se=0,he=Math.min(G.length,ee.length);se<he&&Z(G[se],ee[se]);se++)J++;return J}function I(G){return[].concat(...G)}function w(G,ee){let Z=typeof ee=="number"?G:0;typeof ee=="number"?Z=G:(Z=0,ee=G);const J=[];if(Z<=ee)for(let se=Z;se<ee;se++)J.push(se);else for(let se=Z;se>ee;se--)J.push(se);return J}function b(G,ee,Z){return G.reduce((J,se)=>(J[ee(se)]=Z?Z(se):se,J),Object.create(null))}function D(G,ee){return G.push(ee),()=>L(G,ee)}function L(G,ee){const Z=G.indexOf(ee);if(Z>-1)return G.splice(Z,1),ee}function N(G,ee,Z){const J=G.slice(0,ee),se=G.slice(ee);return J.concat(Z,se)}function F(G,ee){let Z;if(typeof ee=="number"){let J=ee;Z=()=>{const se=Math.sin(J++)*179426549;return se-Math.floor(se)}}else Z=Math.random;for(let J=G.length-1;J>0;J-=1){const se=Math.floor(Z()*(J+1)),he=G[J];G[J]=G[se],G[se]=he}}function x(G,ee){const Z=G.indexOf(ee);Z>-1&&(G.splice(Z,1),G.unshift(ee))}function X(G,ee){const Z=G.indexOf(ee);Z>-1&&(G.splice(Z,1),G.push(ee))}function B(G,ee){for(const Z of ee)G.push(Z)}function Y(G,ee){return Array.isArray(G)?G.map(ee):ee(G)}function z(G){return Array.isArray(G)?G:[G]}function H(G){return G[Math.floor(Math.random()*G.length)]}function V(G,ee,Z){const J=ie(G,ee),se=G.length,he=Z.length;G.length=se+he;for(let ge=se-1;ge>=J;ge--)G[ge+he]=G[ge];for(let ge=0;ge<he;ge++)G[ge+J]=Z[ge]}function q(G,ee,Z,J){const se=ie(G,ee);let he=G.splice(se,Z);return he===void 0&&(he=[]),V(G,se,J),he}function ie(G,ee){return ee<0?Math.max(ee+G.length,0):Math.min(ee,G.length)}var re;(function(G){function ee(he){return he<0}G.isLessThan=ee;function Z(he){return he<=0}G.isLessThanOrEqual=Z;function J(he){return he>0}G.isGreaterThan=J;function se(he){return he===0}G.isNeitherLessOrGreaterThan=se,G.greaterThan=1,G.lessThan=-1,G.neitherLessOrGreaterThan=0})(re||(e.CompareResult=re={}));function ue(G,ee){return(Z,J)=>ee(G(Z),G(J))}function te(...G){return(ee,Z)=>{for(const J of G){const se=J(ee,Z);if(!re.isNeitherLessOrGreaterThan(se))return se}return re.neitherLessOrGreaterThan}}const j=(G,ee)=>G-ee;e.numberComparator=j;const W=(G,ee)=>(0,e.numberComparator)(G?1:0,ee?1:0);e.booleanComparator=W;function T(G){return(ee,Z)=>-G(ee,Z)}class M{constructor(ee){this.items=ee,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(ee){let Z=this.firstIdx;for(;Z<this.items.length&&ee(this.items[Z]);)Z++;const J=Z===this.firstIdx?null:this.items.slice(this.firstIdx,Z);return this.firstIdx=Z,J}takeFromEndWhile(ee){let Z=this.lastIdx;for(;Z>=0&&ee(this.items[Z]);)Z--;const J=Z===this.lastIdx?null:this.items.slice(Z+1,this.lastIdx+1);return this.lastIdx=Z,J}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const ee=this.items[this.firstIdx];return this.firstIdx++,ee}removeLast(){const ee=this.items[this.lastIdx];return this.lastIdx--,ee}takeCount(ee){const Z=this.items.slice(this.firstIdx,this.firstIdx+ee);return this.firstIdx+=ee,Z}}e.ArrayQueue=M;class ${static{this.empty=new $(ee=>{})}constructor(ee){this.iterate=ee}forEach(ee){this.iterate(Z=>(ee(Z),!0))}toArray(){const ee=[];return this.iterate(Z=>(ee.push(Z),!0)),ee}filter(ee){return new $(Z=>this.iterate(J=>ee(J)?Z(J):!0))}map(ee){return new $(Z=>this.iterate(J=>Z(ee(J))))}some(ee){let Z=!1;return this.iterate(J=>(Z=ee(J),!Z)),Z}findFirst(ee){let Z;return this.iterate(J=>ee(J)?(Z=J,!1):!0),Z}findLast(ee){let Z;return this.iterate(J=>(ee(J)&&(Z=J),!0)),Z}findLastMaxBy(ee){let Z,J=!0;return this.iterate(se=>((J||re.isGreaterThan(ee(se,Z)))&&(J=!1,Z=se),!0)),Z}}e.CallbackIterable=$;class Q{constructor(ee){this._indexMap=ee}static createSortPermutation(ee,Z){const J=Array.from(ee.keys()).sort((se,he)=>Z(ee[se],ee[he]));return new Q(J)}apply(ee){return ee.map((Z,J)=>ee[this._indexMap[J]])}inverse(){const ee=this._indexMap.slice();for(let Z=0;Z<this._indexMap.length;Z++)ee[this._indexMap[Z]]=Z;return new Q(ee)}}e.Permutation=Q}),define(ae[127],ce([0,1,7]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=U,e.assertNever=A,e.assert=O,e.softAssert=k,e.assertFn=R,e.checkAdjacentItems=P;function U(d,C){if(!d)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}function A(d,C="Unreachable"){throw new Error(C)}function O(d){if(!d)throw new _.BugIndicatingError("Assertion Failed")}function k(d){d||(0,_.onUnexpectedError)(new _.BugIndicatingError("Soft Assertion Failed"))}function R(d){if(!d()){debugger;d(),(0,_.onUnexpectedError)(new _.BugIndicatingError("Assertion Failed"))}}function P(d,C){let E=0;for(;E<d.length-1;){const v=d[E],l=d[E+1];if(!C(v,l))return!1;E++}return!0}}),define(ae[85],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=_;function _(U,A){const O=this;let k=!1,R;return function(){if(k)return R;if(k=!0,A)try{R=U.apply(O,arguments)}finally{A()}else R=U.apply(O,arguments);return R}}}),define(ae[61],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var _;(function(U){function A(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}U.is=A;const O=Object.freeze([]);function k(){return O}U.empty=k;function*R(t){yield t}U.single=R;function P(t){return A(t)?t:R(t)}U.wrap=P;function d(t){return t||O}U.from=d;function*C(t){for(let r=t.length-1;r>=0;r--)yield t[r]}U.reverse=C;function E(t){return!t||t[Symbol.iterator]().next().done===!0}U.isEmpty=E;function v(t){return t[Symbol.iterator]().next().value}U.first=v;function l(t,r){for(const n of t)if(r(n))return!0;return!1}U.some=l;function c(t,r){for(const n of t)if(r(n))return n}U.find=c;function*p(t,r){for(const n of t)r(n)&&(yield n)}U.filter=p;function*g(t,r){let n=0;for(const s of t)yield r(s,n++)}U.map=g;function*u(...t){for(const r of t)yield*r}U.concat=u;function h(t,r,n){let s=n;for(const i of t)s=r(s,i);return s}U.reduce=h;function*m(t,r,n=t.length){for(r<0&&(r+=t.length),n<0?n+=t.length:n>t.length&&(n=t.length);r<n;r++)yield t[r]}U.slice=m;function f(t,r=Number.POSITIVE_INFINITY){const n=[];if(r===0)return[n,t];const s=t[Symbol.iterator]();for(let i=0;i<r;i++){const o=s.next();if(o.done)return[n,U.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return s}}]}U.consume=f;async function S(t){const r=[];for await(const n of t)r.push(n);return Promise.resolve(r)}U.asyncToArray=S})(_||(e.Iterable=_={}))}),define(ae[35],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.createScanner=k,e.getLocation=E,e.parse=v,e.parseTree=l,e.findNodeAtLocation=c,e.getNodePath=p,e.getNodeValue=g,e.contains=u,e.findNodeAtOffset=h,e.visit=m,e.stripComments=f,e.getNodeType=S;var _;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(_||(e.ScanError=_={}));var U;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(U||(e.SyntaxKind=U={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function k(t,r=!1){let n=0;const s=t.length;let i="",o=0,a=16,y=0;function I(x){let X=0,B=0;for(;X<x;){const Y=t.charCodeAt(n);if(Y>=48&&Y<=57)B=B*16+Y-48;else if(Y>=65&&Y<=70)B=B*16+Y-65+10;else if(Y>=97&&Y<=102)B=B*16+Y-97+10;else break;n++,X++}return X<x&&(B=-1),B}function w(x){n=x,i="",o=0,a=16,y=0}function b(){const x=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&d(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&d(t.charCodeAt(n)))for(n++;n<t.length&&d(t.charCodeAt(n));)n++;else return y=3,t.substring(x,n);let X=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&d(t.charCodeAt(n))){for(n++;n<t.length&&d(t.charCodeAt(n));)n++;X=n}else y=3;return t.substring(x,X)}function D(){let x="",X=n;for(;;){if(n>=s){x+=t.substring(X,n),y=2;break}const B=t.charCodeAt(n);if(B===34){x+=t.substring(X,n),n++;break}if(B===92){if(x+=t.substring(X,n),n++,n>=s){y=2;break}switch(t.charCodeAt(n++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const z=I(4);z>=0?x+=String.fromCharCode(z):y=4;break}default:y=5}X=n;continue}if(B>=0&&B<=31)if(P(B)){x+=t.substring(X,n),y=2;break}else y=6;n++}return x}function L(){if(i="",y=0,o=n,n>=s)return o=s,a=17;let x=t.charCodeAt(n);if(R(x)){do n++,i+=String.fromCharCode(x),x=t.charCodeAt(n);while(R(x));return a=15}if(P(x))return n++,i+=String.fromCharCode(x),x===13&&t.charCodeAt(n)===10&&(n++,i+=`
`),a=14;switch(x){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,i=D(),a=10;case 47:{const X=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<s&&!P(t.charCodeAt(n));)n++;return i=t.substring(X,n),a=12}if(t.charCodeAt(n+1)===42){n+=2;const B=s-1;let Y=!1;for(;n<B;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,Y=!0;break}n++}return Y||(n++,y=1),i=t.substring(X,n),a=13}return i+=String.fromCharCode(x),n++,a=16}case 45:if(i+=String.fromCharCode(x),n++,n===s||!d(t.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=b(),a=11;default:for(;n<s&&N(x);)n++,x=t.charCodeAt(n);if(o!==n){switch(i=t.substring(o,n),i){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return i+=String.fromCharCode(x),n++,a=16}}function N(x){if(R(x)||P(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let x;do x=L();while(x>=12&&x<=15);return x}return{setPosition:w,getPosition:()=>n,scan:r?F:L,getToken:()=>a,getTokenValue:()=>i,getTokenOffset:()=>o,getTokenLength:()=>n-o,getTokenError:()=>y}}function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function P(t){return t===10||t===13||t===8232||t===8233}function d(t){return t>=48&&t<=57}var C;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(C||(C={}));function E(t,r){const n=[],s=new Object;let i;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function y(I,w,b,D){o.value=I,o.offset=w,o.length=b,o.type=D,o.colonOffset=void 0,i=o}try{m(t,{onObjectBegin:(I,w)=>{if(r<=I)throw s;i=void 0,a=r>I,n.push("")},onObjectProperty:(I,w,b)=>{if(r<w||(y(I,w,b,"property"),n[n.length-1]=I,r<=w+b))throw s},onObjectEnd:(I,w)=>{if(r<=I)throw s;i=void 0,n.pop()},onArrayBegin:(I,w)=>{if(r<=I)throw s;i=void 0,n.push(0)},onArrayEnd:(I,w)=>{if(r<=I)throw s;i=void 0,n.pop()},onLiteralValue:(I,w,b)=>{if(r<w||(y(I,w,b,S(I)),r<=w+b))throw s},onSeparator:(I,w,b)=>{if(r<=w)throw s;if(I===":"&&i&&i.type==="property")i.colonOffset=w,a=!1,i=void 0;else if(I===","){const D=n[n.length-1];typeof D=="number"?n[n.length-1]=D+1:(a=!0,n[n.length-1]=""),i=void 0}}})}catch(I){if(I!==s)throw I}return{path:n,previousNode:i,isAtPropertyKey:a,matches:I=>{let w=0;for(let b=0;w<I.length&&b<n.length;b++)if(I[w]===n[b]||I[w]==="*")w++;else if(I[w]!=="**")return!1;return w===I.length}}}function v(t,r=[],n=O.DEFAULT){let s=null,i=[];const o=[];function a(I){Array.isArray(i)?i.push(I):s!==null&&(i[s]=I)}return m(t,{onObjectBegin:()=>{const I={};a(I),o.push(i),i=I,s=null},onObjectProperty:I=>{s=I},onObjectEnd:()=>{i=o.pop()},onArrayBegin:()=>{const I=[];a(I),o.push(i),i=I,s=null},onArrayEnd:()=>{i=o.pop()},onLiteralValue:a,onError:(I,w,b)=>{r.push({error:I,offset:w,length:b})}},n),i[0]}function l(t,r=[],n=O.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(I){s.type==="property"&&(s.length=I-s.offset,s=s.parent)}function o(I){return s.children.push(I),I}m(t,{onObjectBegin:I=>{s=o({type:"object",offset:I,length:-1,parent:s,children:[]})},onObjectProperty:(I,w,b)=>{s=o({type:"property",offset:w,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:I,offset:w,length:b,parent:s})},onObjectEnd:(I,w)=>{s.length=I+w-s.offset,s=s.parent,i(I+w)},onArrayBegin:(I,w)=>{s=o({type:"array",offset:I,length:-1,parent:s,children:[]})},onArrayEnd:(I,w)=>{s.length=I+w-s.offset,s=s.parent,i(I+w)},onLiteralValue:(I,w,b)=>{o({type:S(I),offset:w,length:b,parent:s,value:I}),i(w+b)},onSeparator:(I,w,b)=>{s.type==="property"&&(I===":"?s.colonOffset=w:I===","&&i(w))},onError:(I,w,b)=>{r.push({error:I,offset:w,length:b})}},n);const y=s.children[0];return y&&delete y.parent,y}function c(t,r){if(!t)return;let n=t;for(const s of r)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let i=!1;for(const o of n.children)if(Array.isArray(o.children)&&o.children[0].value===s){n=o.children[1],i=!0;break}if(!i)return}else{const i=s;if(n.type!=="array"||i<0||!Array.isArray(n.children)||i>=n.children.length)return;n=n.children[i]}return n}function p(t){if(!t.parent||!t.parent.children)return[];const r=p(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;r.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&r.push(n)}return r}function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const r=Object.create(null);for(const n of t.children){const s=n.children[1];s&&(r[n.children[0].value]=g(s))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function u(t,r,n=!1){return r>=t.offset&&r<t.offset+t.length||n&&r===t.offset+t.length}function h(t,r,n=!1){if(u(t,r,n)){const s=t.children;if(Array.isArray(s))for(let i=0;i<s.length&&s[i].offset<=r;i++){const o=h(s[i],r,n);if(o)return o}return t}}function m(t,r,n=O.DEFAULT){const s=k(t,!1);function i(ue){return ue?()=>ue(s.getTokenOffset(),s.getTokenLength()):()=>!0}function o(ue){return ue?te=>ue(te,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=i(r.onObjectBegin),y=o(r.onObjectProperty),I=i(r.onObjectEnd),w=i(r.onArrayBegin),b=i(r.onArrayEnd),D=o(r.onLiteralValue),L=o(r.onSeparator),N=i(r.onComment),F=o(r.onError),x=n&&n.disallowComments,X=n&&n.allowTrailingComma;function B(){for(;;){const ue=s.scan();switch(s.getTokenError()){case 4:Y(14);break;case 5:Y(15);break;case 3:Y(13);break;case 1:x||Y(11);break;case 2:Y(12);break;case 6:Y(16);break}switch(ue){case 12:case 13:x?Y(10):N();break;case 16:Y(1);break;case 15:case 14:break;default:return ue}}}function Y(ue,te=[],j=[]){if(F(ue),te.length+j.length>0){let W=s.getToken();for(;W!==17;){if(te.indexOf(W)!==-1){B();break}else if(j.indexOf(W)!==-1)break;W=B()}}}function z(ue){const te=s.getTokenValue();return ue?D(te):y(te),B(),!0}function H(){switch(s.getToken()){case 11:{let ue=0;try{ue=JSON.parse(s.getTokenValue()),typeof ue!="number"&&(Y(2),ue=0)}catch{Y(2)}D(ue);break}case 7:D(null);break;case 8:D(!0);break;case 9:D(!1);break;default:return!1}return B(),!0}function V(){return s.getToken()!==10?(Y(3,[],[2,5]),!1):(z(!1),s.getToken()===6?(L(":"),B(),re()||Y(4,[],[2,5])):Y(5,[],[2,5]),!0)}function q(){a(),B();let ue=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ue||Y(4,[],[]),L(","),B(),s.getToken()===2&&X)break}else ue&&Y(6,[],[]);V()||Y(4,[],[2,5]),ue=!0}return I(),s.getToken()!==2?Y(7,[2],[]):B(),!0}function ie(){w(),B();let ue=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ue||Y(4,[],[]),L(","),B(),s.getToken()===4&&X)break}else ue&&Y(6,[],[]);re()||Y(4,[],[4,5]),ue=!0}return b(),s.getToken()!==4?Y(8,[4],[]):B(),!0}function re(){switch(s.getToken()){case 3:return ie();case 1:return q();case 10:return z(!0);default:return H()}}return B(),s.getToken()===17?n.allowEmptyContent?!0:(Y(4,[],[]),!1):re()?(s.getToken()!==17&&Y(9,[],[]),!0):(Y(4,[],[]),!1)}function f(t,r){const n=k(t),s=[];let i,o=0,a;do switch(a=n.getPosition(),i=n.scan(),i){case 12:case 13:case 17:o!==a&&s.push(t.substring(o,a)),r!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,r)),o=n.getPosition();break}while(i!==17);return s.join("")}function S(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ae[44],ce([0,1,35]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.format=U,e.toFormattedString=A,e.getEOL=R,e.isEOL=P;function U(d,C,E){let v,l,c,p,g;if(C){for(p=C.offset,g=p+C.length,c=p;c>0&&!P(d,c-1);)c--;let a=g;for(;a<d.length&&!P(d,a);)a++;l=d.substring(c,a),v=k(l,E)}else l=d,v=0,c=0,p=0,g=d.length;const u=R(E,d);let h=!1,m=0,f;E.insertSpaces?f=O(" ",E.tabSize||4):f="	";const S=(0,_.createScanner)(l,!1);let t=!1;function r(){return u+O(f,v+m)}function n(){let a=S.scan();for(h=!1;a===15||a===14;)h=h||a===14,a=S.scan();return t=a===16||S.getTokenError()!==0,a}const s=[];function i(a,y,I){!t&&y<g&&I>p&&d.substring(y,I)!==a&&s.push({offset:y,length:I-y,content:a})}let o=n();if(o!==17){const a=S.getTokenOffset()+c,y=O(f,v);i(y,c,a)}for(;o!==17;){let a=S.getTokenOffset()+S.getTokenLength()+c,y=n(),I="";for(;!h&&(y===12||y===13);){const b=S.getTokenOffset()+c;i(" ",a,b),a=S.getTokenOffset()+S.getTokenLength()+c,I=y===12?r():"",y=n()}if(y===2)o!==1&&(m--,I=r());else if(y===4)o!==3&&(m--,I=r());else{switch(o){case 3:case 1:m++,I=r();break;case 5:case 12:I=r();break;case 13:h?I=r():I=" ";break;case 6:I=" ";break;case 10:if(y===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?I=" ":y!==5&&y!==17&&(t=!0);break;case 16:t=!0;break}h&&(y===12||y===13)&&(I=r())}const w=S.getTokenOffset()+c;i(I,a,w),o=y}return s}function A(d,C){const E=JSON.stringify(d,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?E.replace(/\r\n|\r|\n/g,C.eol):E}function O(d,C){let E="";for(let v=0;v<C;v++)E+=d;return E}function k(d,C){let E=0,v=0;const l=C.tabSize||4;for(;E<d.length;){const c=d.charAt(E);if(c===" ")v++;else if(c==="	")v+=l;else break;E++}return Math.floor(v/l)}function R(d,C){for(let E=0;E<C.length;E++){const v=C.charAt(E);if(v==="\r")return E+1<C.length&&C.charAt(E+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return d&&d.eol||`
`}function P(d,C){return`\r
`.indexOf(d.charAt(C))!==-1}}),define(ae[62],ce([0,1,35,44]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeProperty=A,e.setProperty=O,e.withFormatting=k,e.applyEdit=R,e.applyEdits=P;function A(d,C,E){return O(d,C,void 0,E)}function O(d,C,E,v,l){const c=C.slice(),p=[],g=(0,_.parseTree)(d,p);let u,h;for(;c.length>0&&(h=c.pop(),u=(0,_.findNodeAtLocation)(g,c),u===void 0&&E!==void 0);)typeof h=="string"?E={[h]:E}:E=[E];if(u)if(u.type==="object"&&typeof h=="string"&&Array.isArray(u.children)){const m=(0,_.findNodeAtLocation)(u,[h]);if(m!==void 0)if(E===void 0){if(!m.parent)throw new Error("Malformed AST");const f=u.children.indexOf(m.parent);let S,t=m.parent.offset+m.parent.length;if(f>0){const r=u.children[f-1];S=r.offset+r.length}else S=u.offset+1,u.children.length>1&&(t=u.children[1].offset);return k(d,{offset:S,length:t-S,content:""},v)}else return k(d,{offset:m.offset,length:m.length,content:JSON.stringify(E)},v);else{if(E===void 0)return[];const f=`${JSON.stringify(h)}: ${JSON.stringify(E)}`,S=l?l(u.children.map(r=>r.children[0].value)):u.children.length;let t;if(S>0){const r=u.children[S-1];t={offset:r.offset+r.length,length:0,content:","+f}}else u.children.length===0?t={offset:u.offset+1,length:0,content:f}:t={offset:u.offset+1,length:0,content:f+","};return k(d,t,v)}}else if(u.type==="array"&&typeof h=="number"&&Array.isArray(u.children))if(E!==void 0){const m=`${JSON.stringify(E)}`;let f;if(u.children.length===0||h===0)f={offset:u.offset+1,length:0,content:u.children.length===0?m:m+","};else{const S=h===-1||h>u.children.length?u.children.length:h,t=u.children[S-1];f={offset:t.offset+t.length,length:0,content:","+m}}return k(d,f,v)}else{const m=h,f=u.children[m];let S;if(u.children.length===1)S={offset:u.offset+1,length:u.length-2,content:""};else if(u.children.length-1===m){const t=u.children[m-1],r=t.offset+t.length,n=u.offset+u.length;S={offset:r,length:n-2-r,content:""}}else S={offset:f.offset,length:u.children[m+1].offset-f.offset,content:""};return k(d,S,v)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${u.type}`);else return E===void 0?[]:k(d,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(E)},v)}function k(d,C,E){let v=R(d,C),l=C.offset,c=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;l>0&&!(0,U.isEOL)(v,l-1);)l--;for(;c<v.length&&!(0,U.isEOL)(v,c);)c++}const p=(0,U.format)(v,{offset:l,length:c-l},E);for(let u=p.length-1;u>=0;u--){const h=p[u];v=R(v,h),l=Math.min(l,h.offset),c=Math.max(c,h.offset+h.length),c+=h.content.length-h.length}const g=d.length-(v.length-c)-l;return[{offset:l,length:g,content:v.substring(l,c)}]}function R(d,C){return d.substring(0,C.offset)+C.content+d.substring(C.offset+C.length)}function P(d,C){const E=C.slice(0).sort((l,c)=>{const p=l.offset-c.offset;return p===0?l.length-c.length:p});let v=d.length;for(let l=E.length-1;l>=0;l--){const c=E[l];if(c.offset+c.length<=v)d=R(d,c);else throw new Error("Overlapping edit");v=c.offset}return d}}),define(ae[53],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class _{constructor(A){this.executor=A,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=_}),define(ae[86],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class _{static{this.Undefined=new _(void 0)}constructor(O){this.element=O,this.next=_.Undefined,this.prev=_.Undefined}}class U{constructor(){this._first=_.Undefined,this._last=_.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===_.Undefined}clear(){let O=this._first;for(;O!==_.Undefined;){const k=O.next;O.prev=_.Undefined,O.next=_.Undefined,O=k}this._first=_.Undefined,this._last=_.Undefined,this._size=0}unshift(O){return this._insert(O,!1)}push(O){return this._insert(O,!0)}_insert(O,k){const R=new _(O);if(this._first===_.Undefined)this._first=R,this._last=R;else if(k){const d=this._last;this._last=R,R.prev=d,d.next=R}else{const d=this._first;this._first=R,R.next=d,d.prev=R}this._size+=1;let P=!1;return()=>{P||(P=!0,this._remove(R))}}shift(){if(this._first!==_.Undefined){const O=this._first.element;return this._remove(this._first),O}}pop(){if(this._last!==_.Undefined){const O=this._last.element;return this._remove(this._last),O}}_remove(O){if(O.prev!==_.Undefined&&O.next!==_.Undefined){const k=O.prev;k.next=O.next,O.next.prev=k}else O.prev===_.Undefined&&O.next===_.Undefined?(this._first=_.Undefined,this._last=_.Undefined):O.next===_.Undefined?(this._last=this._last.prev,this._last.next=_.Undefined):O.prev===_.Undefined&&(this._first=this._first.next,this._first.prev=_.Undefined);this._size-=1}*[Symbol.iterator](){let O=this._first;for(;O!==_.Undefined;)yield O.element,O=O.next}}e.LinkedList=U}),define(ae[34],ce([0,1]),function(ne,e){"use strict";var _,U,A;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=O,e.mapToString=k,e.setToString=R,e.mapsStrictEqualIgnoreOrder=f;function O(S,t,r){let n=S.get(t);return n===void 0&&(n=r,S.set(t,n)),n}function k(S){const t=[];return S.forEach((r,n)=>{t.push(`${n} => ${r}`)}),`Map(${S.size}) {${t.join(", ")}}`}function R(S){const t=[];return S.forEach(r=>{t.push(r)}),`Set(${S.size}) {${t.join(", ")}}`}class P{constructor(t,r){this.uri=t,this.value=r}}function d(S){return Array.isArray(S)}class C{static{this.defaultToKey=t=>t.toString()}constructor(t,r){if(this[_]="ResourceMap",t instanceof C)this.map=new Map(t.map),this.toKey=r??C.defaultToKey;else if(d(t)){this.map=new Map,this.toKey=r??C.defaultToKey;for(const[n,s]of t)this.set(n,s)}else this.map=new Map,this.toKey=t??C.defaultToKey}set(t,r){return this.map.set(this.toKey(t),new P(t,r)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,r){typeof r<"u"&&(t=t.bind(r));for(const[n,s]of this.map)t(s.value,s.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(_=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=C;class E{constructor(t,r){this[U]="ResourceSet",!t||typeof t=="function"?this._map=new C(t):(this._map=new C(r),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,r){this._map.forEach((n,s)=>t.call(r,s,s,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(U=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=E;var v;(function(S){S[S.None=0]="None",S[S.AsOld=1]="AsOld",S[S.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class l{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,r=0){const n=this._map.get(t);if(n)return r!==0&&this.touch(n,r),n.value}set(t,r,n=0){let s=this._map.get(t);if(s)s.value=r,n!==0&&this.touch(s,n);else{switch(s={key:t,value:r,next:void 0,previous:void 0},n){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(t,s),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this._map.get(t);if(r)return this._map.delete(t),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,r){const n=this._state;let s=this._head;for(;s;){if(r?t.bind(r)(s.value,s.key,this):t(s.value,s.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const t=this,r=this._state;let n=this._head;const s={[Symbol.iterator](){return s},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const i={value:n.key,done:!1};return n=n.next,i}else return{value:void 0,done:!0}}};return s}values(){const t=this,r=this._state;let n=this._head;const s={[Symbol.iterator](){return s},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const i={value:n.value,done:!1};return n=n.next,i}else return{value:void 0,done:!0}}};return s}entries(){const t=this,r=this._state;let n=this._head;const s={[Symbol.iterator](){return s},next(){if(t._state!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const i={value:[n.key,n.value],done:!1};return n=n.next,i}else return{value:void 0,done:!0}}};return s}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this._head,n=this.size;for(;r&&n>t;)this._map.delete(r.key),r=r.next,n--;this._head=r,this._size=n,r&&(r.previous=void 0),this._state++}trimNew(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this._tail,n=this.size;for(;r&&n>t;)this._map.delete(r.key),r=r.previous,n--;this._tail=r,this._size=n,r&&(r.next=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const r=t.next,n=t.previous;if(!r||!n)throw new Error("Invalid list");r.previous=n,n.next=r}t.next=void 0,t.previous=void 0,this._state++}touch(t,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this._head)return;const n=t.next,s=t.previous;t===this._tail?(s.next=void 0,this._tail=s):(n.previous=s,s.next=n),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(r===2){if(t===this._tail)return;const n=t.next,s=t.previous;t===this._head?(n.previous=void 0,this._head=n):(n.previous=s,s.next=n),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((r,n)=>{t.push([n,r])}),t}fromJSON(t){this.clear();for(const[r,n]of t)this.set(r,n)}}e.LinkedMap=l;class c extends l{constructor(t,r=1){super(),this._limit=t,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class p extends c{constructor(t,r=1){super(t,r)}trim(t){this.trimOld(t)}set(t,r){return super.set(t,r),this.checkTrim(),this}}e.LRUCache=p;class g extends c{constructor(t,r=1){super(t,r)}trim(t){this.trimNew(t)}set(t,r){return this._limit<=this.size&&!this.has(t)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(t,r),this}}e.MRUCache=g;class u{constructor(){this.map=new Map}add(t){return this.map.set(t,(this.map.get(t)||0)+1),this}delete(t){let r=this.map.get(t)||0;return r===0?!1:(r--,r===0?this.map.delete(t):this.map.set(t,r),!0)}has(t){return this.map.has(t)}}e.CounterSet=u;class h{constructor(t){if(this._m1=new Map,this._m2=new Map,t)for(const[r,n]of t)this.set(r,n)}clear(){this._m1.clear(),this._m2.clear()}set(t,r){this._m1.set(t,r),this._m2.set(r,t)}get(t){return this._m1.get(t)}getKey(t){return this._m2.get(t)}delete(t){const r=this._m1.get(t);return r===void 0?!1:(this._m1.delete(t),this._m2.delete(r),!0)}forEach(t,r){this._m1.forEach((n,s)=>{t.call(r,n,s,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=h;class m{constructor(){this.map=new Map}add(t,r){let n=this.map.get(t);n||(n=new Set,this.map.set(t,n)),n.add(r)}delete(t,r){const n=this.map.get(t);n&&(n.delete(r),n.size===0&&this.map.delete(t))}forEach(t,r){const n=this.map.get(t);n&&n.forEach(r)}get(t){const r=this.map.get(t);return r||new Set}}e.SetMap=m;function f(S,t){if(S===t)return!0;if(S.size!==t.size)return!1;for(const[r,n]of S)if(!t.has(r)||t.get(r)!==n)return!1;for(const[r]of t)if(!S.has(r))return!1;return!0}}),define(ae[2],ce([0,1,17,126,34,85,61]),function(ne,e,_,U,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=C,e.trackDisposable=E,e.markAsDisposed=v,e.markAsSingleton=p,e.isDisposable=g,e.dispose=u,e.disposeIfDisposable=h,e.combinedDisposable=m,e.toDisposable=f,e.disposeOnReturn=I;const R=!1;let P=null;class d{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(D){let L=this.livingDisposables.get(D);return L||(L={parent:null,source:null,isSingleton:!1,value:D,idx:d.idx++},this.livingDisposables.set(D,L)),L}trackDisposable(D){const L=this.getDisposableData(D);L.source||(L.source=new Error().stack)}setParent(D,L){const N=this.getDisposableData(D);N.parent=L}markAsDisposed(D){this.livingDisposables.delete(D)}markAsSingleton(D){this.getDisposableData(D).isSingleton=!0}getRootParent(D,L){const N=L.get(D);if(N)return N;const F=D.parent?this.getRootParent(this.getDisposableData(D.parent),L):D;return L.set(D,F),F}getTrackedDisposables(){const D=new Map;return[...this.livingDisposables.entries()].filter(([,N])=>N.source!==null&&!this.getRootParent(N,D).isSingleton).flatMap(([N])=>N)}computeLeakingDisposables(D=10,L){let N;if(L)N=L;else{const Y=new Map,z=[...this.livingDisposables.values()].filter(V=>V.source!==null&&!this.getRootParent(V,Y).isSingleton);if(z.length===0)return;const H=new Set(z.map(V=>V.value));if(N=z.filter(V=>!(V.parent&&H.has(V.parent))),N.length===0)throw new Error("There are cyclic diposable chains!")}if(!N)return;function F(Y){function z(V,q){for(;V.length>0&&q.some(ie=>typeof ie=="string"?ie===V[0]:V[0].match(ie));)V.shift()}const H=Y.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return z(H,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),H.reverse()}const x=new A.SetMap;for(const Y of N){const z=F(Y);for(let H=0;H<=z.length;H++)x.add(z.slice(0,H).join(`
`),Y)}N.sort((0,_.compareBy)(Y=>Y.idx,_.numberComparator));let X="",B=0;for(const Y of N.slice(0,D)){B++;const z=F(Y),H=[];for(let V=0;V<z.length;V++){let q=z[V];q=`(shared with ${x.get(z.slice(0,V+1).join(`
`)).size}/${N.length} leaks) at ${q}`;const re=x.get(z.slice(0,V).join(`
`)),ue=(0,U.groupBy)([...re].map(te=>F(te)[V]),te=>te);delete ue[z[V]];for(const[te,j]of Object.entries(ue))H.unshift(`    - stacktraces of ${j.length} other leaks continue with ${te}`);H.unshift(q)}X+=`


==================== Leaking disposable ${B}/${N.length}: ${Y.value.constructor.name} ====================
${H.join(`
`)}
============================================================

`}return N.length>D&&(X+=`


... and ${N.length-D} more leaking disposables

`),{leaks:N,details:X}}}e.DisposableTracker=d;function C(b){P=b}if(R){const b="__is_disposable_tracked__";C(new class{trackDisposable(D){const L=new Error("Potentially leaked disposable").stack;setTimeout(()=>{D[b]||console.log(L)},3e3)}setParent(D,L){if(D&&D!==t.None)try{D[b]=!0}catch{}}markAsDisposed(D){if(D&&D!==t.None)try{D[b]=!0}catch{}}markAsSingleton(D){}})}function E(b){return P?.trackDisposable(b),b}function v(b){P?.markAsDisposed(b)}function l(b,D){P?.setParent(b,D)}function c(b,D){if(P)for(const L of b)P.setParent(L,D)}function p(b){return P?.markAsSingleton(b),b}function g(b){return typeof b=="object"&&b!==null&&typeof b.dispose=="function"&&b.dispose.length===0}function u(b){if(k.Iterable.is(b)){const D=[];for(const L of b)if(L)try{L.dispose()}catch(N){D.push(N)}if(D.length===1)throw D[0];if(D.length>1)throw new AggregateError(D,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}function h(b){for(const D of b)g(D)&&D.dispose();return[]}function m(...b){const D=f(()=>u(b));return c(b,D),D}function f(b){const D=E({dispose:(0,O.createSingleCallFunction)(()=>{v(D),b()})});return D}class S{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,E(this)}dispose(){this._isDisposed||(v(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{u(this._toDispose)}finally{this._toDispose.clear()}}add(D){if(!D)return D;if(D===this)throw new Error("Cannot register a disposable on itself!");return l(D,this),this._isDisposed?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(D),D}delete(D){if(D){if(D===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(D),D.dispose()}}deleteAndLeak(D){D&&this._toDispose.has(D)&&(this._toDispose.delete(D),l(D,null))}}e.DisposableStore=S;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new S,E(this),l(this._store,this)}dispose(){v(this),this._store.dispose()}_register(D){if(D===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(D)}}e.Disposable=t;class r{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(D){this._isDisposed||D===this._value||(this._value?.dispose(),D&&l(D,this),this._value=D)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,v(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const D=this._value;return this._value=void 0,D&&l(D,null),D}}e.MutableDisposable=r;class n{constructor(D){this._disposable=new r,this._isDisposed=!1,this._disposable.value=D}get value(){return this._disposable.value}set value(D){this._isDisposed||D===this._disposable.value||(this._disposable.value=D)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=n;class s{constructor(D){this._disposable=D,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(D){let L=D;return this.unset=()=>L=void 0,this.isset=()=>L!==void 0,this.dispose=()=>{L&&(L(),L=void 0,v(this))},this}}e.SafeDisposable=i;class o{constructor(){this.references=new Map}acquire(D,...L){let N=this.references.get(D);N||(N={counter:0,object:this.createReferencedObject(D,...L)},this.references.set(D,N));const{object:F}=N,x=(0,O.createSingleCallFunction)(()=>{--N.counter===0&&(this.destroyReferencedObject(D,N.object),this.references.delete(D))});return N.counter++,{object:F,dispose:x}}}e.ReferenceCollection=o;class a{constructor(D){this.referenceCollection=D}async acquire(D,...L){const N=this.referenceCollection.acquire(D,...L);try{return{object:await N.object,dispose:()=>N.dispose()}}catch(F){throw N.dispose(),F}}}e.AsyncReferenceCollection=a;class y{constructor(D){this.object=D}dispose(){}}e.ImmortalReference=y;function I(b){const D=new S;try{b(D)}finally{D.dispose()}}class w{constructor(){this._store=new Map,this._isDisposed=!1,E(this)}dispose(){v(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{u(this._store.values())}finally{this._store.clear()}}has(D){return this._store.has(D)}get size(){return this._store.size}get(D){return this._store.get(D)}set(D,L,N=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),N||this._store.get(D)?.dispose(),this._store.set(D,L)}deleteAndDispose(D){this._store.get(D)?.dispose(),this._store.delete(D)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=w}),define(ae[87],ce([0,1,34]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=A,e.normalizeNFD=k;const U=new _.LRUCache(1e4);function A(d){return P(d,"NFC",U)}const O=new _.LRUCache(1e4);function k(d){return P(d,"NFD",O)}const R=/[^\u0000-\u0080]/;function P(d,C,E){if(!d)return d;const v=E.get(d);if(v)return v;let l;return R.test(d)?l=d.normalize(C):l=d,E.set(d,l),l}e.removeAccents=function(){const d=/[\u0300-\u036f]/g;return function(C){return k(C).replace(d,"")}}()}),function(){function ne(A){const O=[];typeof A=="number"&&O.push("code/timeOrigin",A);function k(P){O.push(P,Date.now())}function R(){const P=[];for(let d=0;d<O.length;d+=2)P.push({name:O[d],startTime:O[d+1]});return P}return{mark:k,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const k of performance.getEntriesByType("mark"))O.push({name:k.name,startTime:Math.round(A+k.startTime)});return O}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function _(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var U;typeof global=="object"?U=global:typeof self=="object"?U=self:U={},typeof define=="function"?define("vs/base/common/performance",[],function(){return _(U)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=_(U):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),U.perf=_(U))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var _=e();for(var U in _)(typeof exports=="object"?exports:ne)[U]=_[U]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function _(U){if(e[U])return e[U].exports;var A=e[U]={i:U,l:!1,exports:{}};return ne[U].call(A.exports,A,A.exports,_),A.l=!0,A.exports}return _.m=ne,_.c=e,_.d=function(U,A,O){_.o(U,A)||Object.defineProperty(U,A,{enumerable:!0,get:O})},_.r=function(U){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(U,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(U,"__esModule",{value:!0})},_.t=function(U,A){if(1&A&&(U=_(U)),8&A||4&A&&typeof U=="object"&&U&&U.__esModule)return U;var O=Object.create(null);if(_.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:U}),2&A&&typeof U!="string")for(var k in U)_.d(O,k,function(R){return U[R]}.bind(null,k));return O},_.n=function(U){var A=U&&U.__esModule?function(){return U.default}:function(){return U};return _.d(A,"a",A),A},_.o=function(U,A){return Object.prototype.hasOwnProperty.call(U,A)},_.p="",_(_.s=0)}([function(ne,e,_){(function(U){var A;e=ne.exports=j,A=typeof U=="object"&&U.env&&U.env.NODE_DEBUG&&/\bsemver\b/i.test(U.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],P=e.src=[],d=0,C=d++;P[C]="0|[1-9]\\d*";var E=d++;P[E]="[0-9]+";var v=d++;P[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=d++;P[l]="("+P[C]+")\\.("+P[C]+")\\.("+P[C]+")";var c=d++;P[c]="("+P[E]+")\\.("+P[E]+")\\.("+P[E]+")";var p=d++;P[p]="(?:"+P[C]+"|"+P[v]+")";var g=d++;P[g]="(?:"+P[E]+"|"+P[v]+")";var u=d++;P[u]="(?:-("+P[p]+"(?:\\."+P[p]+")*))";var h=d++;P[h]="(?:-?("+P[g]+"(?:\\."+P[g]+")*))";var m=d++;P[m]="[0-9A-Za-z-]+";var f=d++;P[f]="(?:\\+("+P[m]+"(?:\\."+P[m]+")*))";var S=d++,t="v?"+P[l]+P[u]+"?"+P[f]+"?";P[S]="^"+t+"$";var r="[v=\\s]*"+P[c]+P[h]+"?"+P[f]+"?",n=d++;P[n]="^"+r+"$";var s=d++;P[s]="((?:<|>)?=?)";var i=d++;P[i]=P[E]+"|x|X|\\*";var o=d++;P[o]=P[C]+"|x|X|\\*";var a=d++;P[a]="[v=\\s]*("+P[o]+")(?:\\.("+P[o]+")(?:\\.("+P[o]+")(?:"+P[u]+")?"+P[f]+"?)?)?";var y=d++;P[y]="[v=\\s]*("+P[i]+")(?:\\.("+P[i]+")(?:\\.("+P[i]+")(?:"+P[h]+")?"+P[f]+"?)?)?";var I=d++;P[I]="^"+P[s]+"\\s*"+P[a]+"$";var w=d++;P[w]="^"+P[s]+"\\s*"+P[y]+"$";var b=d++;P[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=d++;P[D]="(?:~>?)";var L=d++;P[L]="(\\s*)"+P[D]+"\\s+",R[L]=new RegExp(P[L],"g");var N=d++;P[N]="^"+P[D]+P[a]+"$";var F=d++;P[F]="^"+P[D]+P[y]+"$";var x=d++;P[x]="(?:\\^)";var X=d++;P[X]="(\\s*)"+P[x]+"\\s+",R[X]=new RegExp(P[X],"g");var B=d++;P[B]="^"+P[x]+P[a]+"$";var Y=d++;P[Y]="^"+P[x]+P[y]+"$";var z=d++;P[z]="^"+P[s]+"\\s*("+r+")$|^$";var H=d++;P[H]="^"+P[s]+"\\s*("+t+")$|^$";var V=d++;P[V]="(\\s*)"+P[s]+"\\s*("+r+"|"+P[a]+")",R[V]=new RegExp(P[V],"g");var q=d++;P[q]="^\\s*("+P[a]+")\\s+-\\s+("+P[a]+")\\s*$";var ie=d++;P[ie]="^\\s*("+P[y]+")\\s+-\\s+("+P[y]+")\\s*$";var re=d++;P[re]="(<|>)?=?\\s*\\*";for(var ue=0;ue<35;ue++)A(ue,P[ue]),R[ue]||(R[ue]=new RegExp(P[ue]));function te(le,Se){if(le instanceof j)return le;if(typeof le!="string"||le.length>O||!(Se?R[n]:R[S]).test(le))return null;try{return new j(le,Se)}catch{return null}}function j(le,Se){if(le instanceof j){if(le.loose===Se)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof j))return new j(le,Se);A("SemVer",le,Se),this.loose=Se;var ve=le.trim().match(Se?R[n]:R[S]);if(!ve)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(De){if(/^[0-9]+$/.test(De)){var Le=+De;if(Le>=0&&Le<k)return Le}return De}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=te,e.valid=function(le,Se){var ve=te(le,Se);return ve?ve.version:null},e.clean=function(le,Se){var ve=te(le.trim().replace(/^[=v]+/,""),Se);return ve?ve.version:null},e.SemVer=j,j.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},j.prototype.toString=function(){return this.version},j.prototype.compare=function(le){return A("SemVer.compare",this.version,this.loose,le),le instanceof j||(le=new j(le,this.loose)),this.compareMain(le)||this.comparePre(le)},j.prototype.compareMain=function(le){return le instanceof j||(le=new j(le,this.loose)),T(this.major,le.major)||T(this.minor,le.minor)||T(this.patch,le.patch)},j.prototype.comparePre=function(le){if(le instanceof j||(le=new j(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var Se=0;do{var ve=this.prerelease[Se],De=le.prerelease[Se];if(A("prerelease compare",Se,ve,De),ve===void 0&&De===void 0)return 0;if(De===void 0)return 1;if(ve===void 0)return-1;if(ve!==De)return T(ve,De)}while(++Se)},j.prototype.inc=function(le,Se){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Se);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Se);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Se),this.inc("pre",Se);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Se),this.inc("pre",Se);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}Se&&(this.prerelease[0]===Se?isNaN(this.prerelease[1])&&(this.prerelease=[Se,0]):this.prerelease=[Se,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,Se,ve,De){typeof ve=="string"&&(De=ve,ve=void 0);try{return new j(le,ve).inc(Se,De).version}catch{return null}},e.diff=function(le,Se){if(G(le,Se))return null;var ve=te(le),De=te(Se);if(ve.prerelease.length||De.prerelease.length){for(var Le in ve)if((Le==="major"||Le==="minor"||Le==="patch")&&ve[Le]!==De[Le])return"pre"+Le;return"prerelease"}for(var Le in ve)if((Le==="major"||Le==="minor"||Le==="patch")&&ve[Le]!==De[Le])return Le},e.compareIdentifiers=T;var W=/^[0-9]+$/;function T(le,Se){var ve=W.test(le),De=W.test(Se);return ve&&De&&(le=+le,Se=+Se),ve&&!De?-1:De&&!ve?1:le<Se?-1:le>Se?1:0}function M(le,Se,ve){return new j(le,ve).compare(new j(Se,ve))}function $(le,Se,ve){return M(le,Se,ve)>0}function Q(le,Se,ve){return M(le,Se,ve)<0}function G(le,Se,ve){return M(le,Se,ve)===0}function ee(le,Se,ve){return M(le,Se,ve)!==0}function Z(le,Se,ve){return M(le,Se,ve)>=0}function J(le,Se,ve){return M(le,Se,ve)<=0}function se(le,Se,ve,De){var Le;switch(Se){case"===":typeof le=="object"&&(le=le.version),typeof ve=="object"&&(ve=ve.version),Le=le===ve;break;case"!==":typeof le=="object"&&(le=le.version),typeof ve=="object"&&(ve=ve.version),Le=le!==ve;break;case"":case"=":case"==":Le=G(le,ve,De);break;case"!=":Le=ee(le,ve,De);break;case">":Le=$(le,ve,De);break;case">=":Le=Z(le,ve,De);break;case"<":Le=Q(le,ve,De);break;case"<=":Le=J(le,ve,De);break;default:throw new TypeError("Invalid operator: "+Se)}return Le}function he(le,Se){if(le instanceof he){if(le.loose===Se)return le;le=le.value}if(!(this instanceof he))return new he(le,Se);A("comparator",le,Se),this.loose=Se,this.parse(le),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(le,Se){return T(Se,le)},e.major=function(le,Se){return new j(le,Se).major},e.minor=function(le,Se){return new j(le,Se).minor},e.patch=function(le,Se){return new j(le,Se).patch},e.compare=M,e.compareLoose=function(le,Se){return M(le,Se,!0)},e.rcompare=function(le,Se,ve){return M(Se,le,ve)},e.sort=function(le,Se){return le.sort(function(ve,De){return e.compare(ve,De,Se)})},e.rsort=function(le,Se){return le.sort(function(ve,De){return e.rcompare(ve,De,Se)})},e.gt=$,e.lt=Q,e.eq=G,e.neq=ee,e.gte=Z,e.lte=J,e.cmp=se,e.Comparator=he;var ge={};function de(le,Se){if(le instanceof de)return le.loose===Se?le:new de(le.raw,Se);if(le instanceof he)return new de(le.value,Se);if(!(this instanceof de))return new de(le,Se);if(this.loose=Se,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function me(le){return!le||le.toLowerCase()==="x"||le==="*"}function Ee(le,Se,ve,De,Le,Ne,Te,xe,Me,$e,We,Oe,oe){return((Se=me(ve)?"":me(De)?">="+ve+".0.0":me(Le)?">="+ve+"."+De+".0":">="+Se)+" "+(xe=me(Me)?"":me($e)?"<"+(+Me+1)+".0.0":me(We)?"<"+Me+"."+(+$e+1)+".0":Oe?"<="+Me+"."+$e+"."+We+"-"+Oe:"<="+xe)).trim()}function we(le,Se){for(var ve=0;ve<le.length;ve++)if(!le[ve].test(Se))return!1;if(Se.prerelease.length){for(ve=0;ve<le.length;ve++)if(A(le[ve].semver),le[ve].semver!==ge&&le[ve].semver.prerelease.length>0){var De=le[ve].semver;if(De.major===Se.major&&De.minor===Se.minor&&De.patch===Se.patch)return!0}return!1}return!0}function Pe(le,Se,ve){try{Se=new de(Se,ve)}catch{return!1}return Se.test(le)}function _e(le,Se,ve,De){var Le,Ne,Te,xe,Me;switch(le=new j(le,De),Se=new de(Se,De),ve){case">":Le=$,Ne=J,Te=Q,xe=">",Me=">=";break;case"<":Le=Q,Ne=Z,Te=$,xe="<",Me="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Pe(le,Se,De))return!1;for(var $e=0;$e<Se.set.length;++$e){var We=Se.set[$e],Oe=null,oe=null;if(We.forEach(function(fe){fe.semver===ge&&(fe=new he(">=0.0.0")),Oe=Oe||fe,oe=oe||fe,Le(fe.semver,Oe.semver,De)?Oe=fe:Te(fe.semver,oe.semver,De)&&(oe=fe)}),Oe.operator===xe||Oe.operator===Me||(!oe.operator||oe.operator===xe)&&Ne(le,oe.semver)||oe.operator===Me&&Te(le,oe.semver))return!1}return!0}he.prototype.parse=function(le){var Se=this.loose?R[z]:R[H],ve=le.match(Se);if(!ve)throw new TypeError("Invalid comparator: "+le);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new j(ve[2],this.loose):this.semver=ge},he.prototype.toString=function(){return this.value},he.prototype.test=function(le){return A("Comparator.test",le,this.loose),this.semver===ge||(typeof le=="string"&&(le=new j(le,this.loose)),se(le,this.operator,this.semver,this.loose))},he.prototype.intersects=function(le,Se){if(!(le instanceof he))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new de(le.value,Se),Pe(this.value,ve,Se);if(le.operator==="")return ve=new de(this.value,Se),Pe(le.semver,ve,Se);var De=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Le=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Ne=this.semver.version===le.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),xe=se(this.semver,"<",le.semver,Se)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Me=se(this.semver,">",le.semver,Se)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return De||Le||Ne&&Te||xe||Me},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(le){var Se=this.loose;le=le.trim(),A("range",le,Se);var ve=Se?R[ie]:R[q];le=le.replace(ve,Ee),A("hyphen replace",le),le=le.replace(R[V],"$1$2$3"),A("comparator trim",le,R[V]),le=(le=(le=le.replace(R[L],"$1~")).replace(R[X],"$1^")).split(/\s+/).join(" ");var De=Se?R[z]:R[H],Le=le.split(" ").map(function(Ne){return function(Te,xe){return A("comp",Te),Te=function(Me,$e){return Me.trim().split(/\s+/).map(function(We){return function(Oe,oe){A("caret",Oe,oe);var fe=oe?R[Y]:R[B];return Oe.replace(fe,function(pe,ye,Ie,Re,ke){var Ue;return A("caret",Oe,pe,ye,Ie,Re,ke),me(ye)?Ue="":me(Ie)?Ue=">="+ye+".0.0 <"+(+ye+1)+".0.0":me(Re)?Ue=ye==="0"?">="+ye+"."+Ie+".0 <"+ye+"."+(+Ie+1)+".0":">="+ye+"."+Ie+".0 <"+(+ye+1)+".0.0":ke?(A("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ue=ye==="0"?Ie==="0"?">="+ye+"."+Ie+"."+Re+ke+" <"+ye+"."+Ie+"."+(+Re+1):">="+ye+"."+Ie+"."+Re+ke+" <"+ye+"."+(+Ie+1)+".0":">="+ye+"."+Ie+"."+Re+ke+" <"+(+ye+1)+".0.0"):(A("no pr"),Ue=ye==="0"?Ie==="0"?">="+ye+"."+Ie+"."+Re+" <"+ye+"."+Ie+"."+(+Re+1):">="+ye+"."+Ie+"."+Re+" <"+ye+"."+(+Ie+1)+".0":">="+ye+"."+Ie+"."+Re+" <"+(+ye+1)+".0.0"),A("caret return",Ue),Ue})}(We,$e)}).join(" ")}(Te,xe),A("caret",Te),Te=function(Me,$e){return Me.trim().split(/\s+/).map(function(We){return function(Oe,oe){var fe=oe?R[F]:R[N];return Oe.replace(fe,function(pe,ye,Ie,Re,ke){var Ue;return A("tilde",Oe,pe,ye,Ie,Re,ke),me(ye)?Ue="":me(Ie)?Ue=">="+ye+".0.0 <"+(+ye+1)+".0.0":me(Re)?Ue=">="+ye+"."+Ie+".0 <"+ye+"."+(+Ie+1)+".0":ke?(A("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ue=">="+ye+"."+Ie+"."+Re+ke+" <"+ye+"."+(+Ie+1)+".0"):Ue=">="+ye+"."+Ie+"."+Re+" <"+ye+"."+(+Ie+1)+".0",A("tilde return",Ue),Ue})}(We,$e)}).join(" ")}(Te,xe),A("tildes",Te),Te=function(Me,$e){return A("replaceXRanges",Me,$e),Me.split(/\s+/).map(function(We){return function(Oe,oe){Oe=Oe.trim();var fe=oe?R[w]:R[I];return Oe.replace(fe,function(pe,ye,Ie,Re,ke,Ue){A("xRange",Oe,pe,ye,Ie,Re,ke,Ue);var ze=me(Ie),qe=ze||me(Re),Fe=qe||me(ke);return ye==="="&&Fe&&(ye=""),ze?pe=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Fe?(qe&&(Re=0),Fe&&(ke=0),ye===">"?(ye=">=",qe?(Ie=+Ie+1,Re=0,ke=0):Fe&&(Re=+Re+1,ke=0)):ye==="<="&&(ye="<",qe?Ie=+Ie+1:Re=+Re+1),pe=ye+Ie+"."+Re+"."+ke):qe?pe=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Fe&&(pe=">="+Ie+"."+Re+".0 <"+Ie+"."+(+Re+1)+".0"),A("xRange return",pe),pe})}(We,$e)}).join(" ")}(Te,xe),A("xrange",Te),Te=function(Me,$e){return A("replaceStars",Me,$e),Me.trim().replace(R[re],"")}(Te,xe),A("stars",Te),Te}(Ne,Se)}).join(" ").split(/\s+/);return this.loose&&(Le=Le.filter(function(Ne){return!!Ne.match(De)})),Le=Le.map(function(Ne){return new he(Ne,Se)})},de.prototype.intersects=function(le,Se){if(!(le instanceof de))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(De){return le.set.some(function(Le){return Le.every(function(Ne){return De.intersects(Ne,Se)})})})})},e.toComparators=function(le,Se){return new de(le,Se).set.map(function(ve){return ve.map(function(De){return De.value}).join(" ").trim().split(" ")})},de.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new j(le,this.loose));for(var Se=0;Se<this.set.length;Se++)if(we(this.set[Se],le))return!0;return!1},e.satisfies=Pe,e.maxSatisfying=function(le,Se,ve){var De=null,Le=null;try{var Ne=new de(Se,ve)}catch{return null}return le.forEach(function(Te){Ne.test(Te)&&(De&&Le.compare(Te)!==-1||(Le=new j(De=Te,ve)))}),De},e.minSatisfying=function(le,Se,ve){var De=null,Le=null;try{var Ne=new de(Se,ve)}catch{return null}return le.forEach(function(Te){Ne.test(Te)&&(De&&Le.compare(Te)!==1||(Le=new j(De=Te,ve)))}),De},e.validRange=function(le,Se){try{return new de(le,Se).range||"*"}catch{return null}},e.ltr=function(le,Se,ve){return _e(le,Se,"<",ve)},e.gtr=function(le,Se,ve){return _e(le,Se,">",ve)},e.outside=_e,e.prerelease=function(le,Se){var ve=te(le,Se);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(le,Se,ve){return le=new de(le,ve),Se=new de(Se,ve),le.intersects(Se)},e.coerce=function(le){if(le instanceof j)return le;if(typeof le!="string")return null;var Se=le.match(R[b]);return Se==null?null:te((Se[1]||"0")+"."+(Se[2]||"0")+"."+(Se[3]||"0"))}}).call(this,_(1))},function(ne,e){var _,U,A=ne.exports={};function O(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function R(g){if(_===setTimeout)return setTimeout(g,0);if((_===O||!_)&&setTimeout)return _=setTimeout,setTimeout(g,0);try{return _(g,0)}catch{try{return _.call(null,g,0)}catch{return _.call(this,g,0)}}}(function(){try{_=typeof setTimeout=="function"?setTimeout:O}catch{_=O}try{U=typeof clearTimeout=="function"?clearTimeout:k}catch{U=k}})();var P,d=[],C=!1,E=-1;function v(){C&&P&&(C=!1,P.length?d=P.concat(d):E=-1,d.length&&l())}function l(){if(!C){var g=R(v);C=!0;for(var u=d.length;u;){for(P=d,d=[];++E<u;)P&&P[E].run();E=-1,u=d.length}P=null,C=!1,function(h){if(U===clearTimeout)return clearTimeout(h);if((U===k||!U)&&clearTimeout)return U=clearTimeout,clearTimeout(h);try{U(h)}catch{try{return U.call(null,h)}catch{return U.call(this,h)}}}(g)}}function c(g,u){this.fun=g,this.array=u}function p(){}A.nextTick=function(g){var u=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)u[h-1]=arguments[h];d.push(new c(g,u)),d.length!==1||C||R(l)},c.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=p,A.addListener=p,A.once=p,A.off=p,A.removeListener=p,A.removeAllListeners=p,A.emit=p,A.prependListener=p,A.prependOnceListener=p,A.listeners=function(g){return[]},A.binding=function(g){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(g){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(ae[128],ce([0,1]),function(ne,e){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class U{constructor(R,P,d){this.level=R,this.key=P,this.value=d,this.forward=[]}}const A=void 0;class O{constructor(R,P=2**16){this.comparator=R,this[_]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(P)|0),this._header=new U(this._maxLevel,A,A)}get size(){return this._size}clear(){this._header=new U(this._maxLevel,A,A),this._size=0}has(R){return!!O._search(this,R,this.comparator)}get(R){return O._search(this,R,this.comparator)?.value}set(R,P){return O._insert(this,R,P,this.comparator)&&(this._size+=1),this}delete(R){const P=O._delete(this,R,this.comparator);return P&&(this._size-=1),P}forEach(R,P){let d=this._header.forward[0];for(;d;)R.call(P,d.value,d.key,this),d=d.forward[0]}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",P=this._header.forward[0];for(;P;)R+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return R}static _search(R,P,d){let C=R._header;for(let E=R._level-1;E>=0;E--)for(;C.forward[E]&&d(C.forward[E].key,P)<0;)C=C.forward[E];if(C=C.forward[0],C&&d(C.key,P)===0)return C}static _insert(R,P,d,C){const E=[];let v=R._header;for(let l=R._level-1;l>=0;l--){for(;v.forward[l]&&C(v.forward[l].key,P)<0;)v=v.forward[l];E[l]=v}if(v=v.forward[0],v&&C(v.key,P)===0)return v.value=d,!1;{const l=O._randomLevel(R);if(l>R._level){for(let c=R._level;c<l;c++)E[c]=R._header;R._level=l}v=new U(l,P,d);for(let c=0;c<l;c++)v.forward[c]=E[c].forward[c],E[c].forward[c]=v;return!0}}static _randomLevel(R,P=.5){let d=1;for(;Math.random()<P&&d<R._maxLevel;)d+=1;return d}static _delete(R,P,d){const C=[];let E=R._header;for(let v=R._level-1;v>=0;v--){for(;E.forward[v]&&d(E.forward[v].key,P)<0;)E=E.forward[v];C[v]=E}if(E=E.forward[0],!E||d(E.key,P)!==0)return!1;for(let v=0;v<R._level&&C[v].forward[v]===E;v++)C[v].forward[v]=E.forward[v];for(;R._level>0&&R._header.forward[R._level-1]===A;)R._level-=1;return!0}}e.SkipList=O}),define(ae[63],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const _=globalThis.performance&&typeof globalThis.performance.now=="function";class U{static create(O){return new U(O)}constructor(O){this._now=_&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=U}),define(ae[3],ce([0,1,7,85,2,86,63]),function(ne,e,_,U,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=l;const R=!1,P=!1,d=!1;var C;(function(L){L.None=()=>A.Disposable.None;function N(de){if(d){const{onDidAddListener:me}=de,Ee=p.create();let we=0;de.onDidAddListener=()=>{++we===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ee.print()),me?.()}}}function F(de,me){return re(de,()=>{},0,void 0,!0,void 0,me)}L.defer=F;function x(de){return(me,Ee=null,we)=>{let Pe=!1,_e;return _e=de(le=>{if(!Pe)return _e?_e.dispose():Pe=!0,me.call(Ee,le)},null,we),Pe&&_e.dispose(),_e}}L.once=x;function X(de,me,Ee){return q((we,Pe=null,_e)=>de(le=>we.call(Pe,me(le)),null,_e),Ee)}L.map=X;function B(de,me,Ee){return q((we,Pe=null,_e)=>de(le=>{me(le),we.call(Pe,le)},null,_e),Ee)}L.forEach=B;function Y(de,me,Ee){return q((we,Pe=null,_e)=>de(le=>me(le)&&we.call(Pe,le),null,_e),Ee)}L.filter=Y;function z(de){return de}L.signal=z;function H(...de){return(me,Ee=null,we)=>{const Pe=(0,A.combinedDisposable)(...de.map(_e=>_e(le=>me.call(Ee,le))));return ie(Pe,we)}}L.any=H;function V(de,me,Ee,we){let Pe=Ee;return X(de,_e=>(Pe=me(Pe,_e),Pe),we)}L.reduce=V;function q(de,me){let Ee;const we={onWillAddFirstListener(){Ee=de(Pe.fire,Pe)},onDidRemoveLastListener(){Ee?.dispose()}};me||N(we);const Pe=new S(we);return me?.add(Pe),Pe.event}function ie(de,me){return me instanceof Array?me.push(de):me&&me.add(de),de}function re(de,me,Ee=100,we=!1,Pe=!1,_e,le){let Se,ve,De,Le=0,Ne;const Te={leakWarningThreshold:_e,onWillAddFirstListener(){Se=de(Me=>{Le++,ve=me(ve,Me),we&&!De&&(xe.fire(ve),ve=void 0),Ne=()=>{const $e=ve;ve=void 0,De=void 0,(!we||Le>1)&&xe.fire($e),Le=0},typeof Ee=="number"?(clearTimeout(De),De=setTimeout(Ne,Ee)):De===void 0&&(De=0,queueMicrotask(Ne))})},onWillRemoveListener(){Pe&&Le>0&&Ne?.()},onDidRemoveLastListener(){Ne=void 0,Se.dispose()}};le||N(Te);const xe=new S(Te);return le?.add(xe),xe.event}L.debounce=re;function ue(de,me=0,Ee){return L.debounce(de,(we,Pe)=>we?(we.push(Pe),we):[Pe],me,void 0,!0,void 0,Ee)}L.accumulate=ue;function te(de,me=(we,Pe)=>we===Pe,Ee){let we=!0,Pe;return Y(de,_e=>{const le=we||!me(_e,Pe);return we=!1,Pe=_e,le},Ee)}L.latch=te;function j(de,me,Ee){return[L.filter(de,me,Ee),L.filter(de,we=>!me(we),Ee)]}L.split=j;function W(de,me=!1,Ee=[],we){let Pe=Ee.slice(),_e=de(ve=>{Pe?Pe.push(ve):Se.fire(ve)});we&&we.add(_e);const le=()=>{Pe?.forEach(ve=>Se.fire(ve)),Pe=null},Se=new S({onWillAddFirstListener(){_e||(_e=de(ve=>Se.fire(ve)),we&&we.add(_e))},onDidAddFirstListener(){Pe&&(me?setTimeout(le):le())},onDidRemoveLastListener(){_e&&_e.dispose(),_e=null}});return we&&we.add(Se),Se.event}L.buffer=W;function T(de,me){return(we,Pe,_e)=>{const le=me(new $);return de(function(Se){const ve=le.evaluate(Se);ve!==M&&we.call(Pe,ve)},void 0,_e)}}L.chain=T;const M=Symbol("HaltChainable");class ${constructor(){this.steps=[]}map(me){return this.steps.push(me),this}forEach(me){return this.steps.push(Ee=>(me(Ee),Ee)),this}filter(me){return this.steps.push(Ee=>me(Ee)?Ee:M),this}reduce(me,Ee){let we=Ee;return this.steps.push(Pe=>(we=me(we,Pe),we)),this}latch(me=(Ee,we)=>Ee===we){let Ee=!0,we;return this.steps.push(Pe=>{const _e=Ee||!me(Pe,we);return Ee=!1,we=Pe,_e?Pe:M}),this}evaluate(me){for(const Ee of this.steps)if(me=Ee(me),me===M)break;return me}}function Q(de,me,Ee=we=>we){const we=(...Se)=>le.fire(Ee(...Se)),Pe=()=>de.on(me,we),_e=()=>de.removeListener(me,we),le=new S({onWillAddFirstListener:Pe,onDidRemoveLastListener:_e});return le.event}L.fromNodeEventEmitter=Q;function G(de,me,Ee=we=>we){const we=(...Se)=>le.fire(Ee(...Se)),Pe=()=>de.addEventListener(me,we),_e=()=>de.removeEventListener(me,we),le=new S({onWillAddFirstListener:Pe,onDidRemoveLastListener:_e});return le.event}L.fromDOMEventEmitter=G;function ee(de){return new Promise(me=>x(de)(me))}L.toPromise=ee;function Z(de){const me=new S;return de.then(Ee=>{me.fire(Ee)},()=>{me.fire(void 0)}).finally(()=>{me.dispose()}),me.event}L.fromPromise=Z;function J(de,me,Ee){return me(Ee),de(we=>me(we))}L.runAndSubscribe=J;class se{constructor(me,Ee){this._observable=me,this._counter=0,this._hasChanged=!1;const we={onWillAddFirstListener:()=>{me.addObserver(this)},onDidRemoveLastListener:()=>{me.removeObserver(this)}};Ee||N(we),this.emitter=new S(we),Ee&&Ee.add(this.emitter)}beginUpdate(me){this._counter++}handlePossibleChange(me){}handleChange(me,Ee){this._hasChanged=!0}endUpdate(me){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function he(de,me){return new se(de,me).emitter.event}L.fromObservable=he;function ge(de){return(me,Ee,we)=>{let Pe=0,_e=!1;const le={beginUpdate(){Pe++},endUpdate(){Pe--,Pe===0&&(de.reportChanges(),_e&&(_e=!1,me.call(Ee)))},handlePossibleChange(){},handleChange(){_e=!0}};de.addObserver(le),de.reportChanges();const Se={dispose(){de.removeObserver(le)}};return we instanceof A.DisposableStore?we.add(Se):Array.isArray(we)&&we.push(Se),Se}}L.fromObservableLight=ge})(C||(e.Event=C={}));class E{static{this.all=new Set}static{this._idPool=0}constructor(N){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${N}_${E._idPool++}`,E.all.add(this)}start(N){this._stopWatch=new k.StopWatch,this.listenerCount=N}stop(){if(this._stopWatch){const N=this._stopWatch.elapsed();this.durations.push(N),this.elapsedOverall+=N,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=E;let v=-1;function l(L){const N=v;return v=L,{dispose(){v=N}}}class c{constructor(N,F=Math.random().toString(18).slice(2,5)){this.threshold=N,this.name=F,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(N,F){const x=this.threshold;if(x<=0||F<x)return;this._stacks||(this._stacks=new Map);const X=this._stacks.get(N.value)||0;if(this._stacks.set(N.value,X+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=x*.5;let B,Y=0;for(const[z,H]of this._stacks)(!B||Y<H)&&(B=z,Y=H);console.warn(`[${this.name}] potential listener LEAK detected, having ${F} listeners already. MOST frequent listener (${Y}):`),console.warn(B)}return()=>{const B=this._stacks.get(N.value)||0;this._stacks.set(N.value,B-1)}}}class p{static create(){return new p(new Error().stack??"")}constructor(N){this.value=N}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let g=0;class u{constructor(N){this.value=N,this.id=g++}}const h=2,m=(L,N)=>{if(L instanceof u)N(L);else for(let F=0;F<L.length;F++){const x=L[F];x&&N(x)}},f=R?new FinalizationRegistry(L=>{typeof L=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(L))}):void 0;class S{constructor(N){this._size=0,this._options=N,this._leakageMon=v>0||this._options?.leakWarningThreshold?new c(this._options?.leakWarningThreshold??v):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(P){const N=this._listeners;queueMicrotask(()=>{m(N,F=>F.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(N,F,x)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),A.Disposable.None;if(this._disposed)return A.Disposable.None;F&&(N=N.bind(F));const X=new u(N);let B,Y;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(X.stack=p.create(),B=this._leakageMon.check(X.stack,this._size+1)),P&&(X.stack=Y??p.create()),this._listeners?this._listeners instanceof u?(this._deliveryQueue??=new r,this._listeners=[this._listeners,X]):this._listeners.push(X):(this._options?.onWillAddFirstListener?.(this),this._listeners=X,this._options?.onDidAddFirstListener?.(this)),this._size++;const z=(0,A.toDisposable)(()=>{f?.unregister(z),B?.(),this._removeListener(X)});if(x instanceof A.DisposableStore?x.add(z):Array.isArray(x)&&x.push(z),f){const H=new Error().stack.split(`
`).slice(2).join(`
`).trim();f.register(z,H,z)}return z},this._event}_removeListener(N){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const F=this._listeners,x=F.indexOf(N);if(x===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,F[x]=void 0;const X=this._deliveryQueue.current===this;if(this._size*h<=F.length){let B=0;for(let Y=0;Y<F.length;Y++)F[Y]?F[B++]=F[Y]:X&&(this._deliveryQueue.end--,B<this._deliveryQueue.i&&this._deliveryQueue.i--);F.length=B}}_deliver(N,F){if(!N)return;const x=this._options?.onListenerError||_.onUnexpectedError;if(!x){N.value(F);return}try{N.value(F)}catch(X){x(X)}}_deliverQueue(N){const F=N.current._listeners;for(;N.i<N.end;)this._deliver(F[N.i++],N.value);N.reset()}fire(N){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof u)this._deliver(this._listeners,N);else{const F=this._deliveryQueue;F.enqueue(this,N,this._listeners.length),this._deliverQueue(F)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=S;const t=()=>new r;e.createEventDeliveryQueue=t;class r{constructor(){this.i=-1,this.end=0}enqueue(N,F,x){this.i=0,this.end=x,this.current=N,this.value=F}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends S{async fireAsync(N,F,x){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new O.LinkedList),m(this._listeners,X=>this._asyncDeliveryQueue.push([X.value,N]));this._asyncDeliveryQueue.size>0&&!F.isCancellationRequested;){const[X,B]=this._asyncDeliveryQueue.shift(),Y=[],z={...B,token:F,waitUntil:H=>{if(Object.isFrozen(Y))throw new Error("waitUntil can NOT be called asynchronous");x&&(H=x(H,X)),Y.push(H)}};try{X(z)}catch(H){(0,_.onUnexpectedError)(H);continue}Object.freeze(Y),await Promise.allSettled(Y).then(H=>{for(const V of H)V.status==="rejected"&&(0,_.onUnexpectedError)(V.reason)})}}}e.AsyncEmitter=n;class s extends S{get isPaused(){return this._isPaused!==0}constructor(N){super(N),this._isPaused=0,this._eventQueue=new O.LinkedList,this._mergeFn=N?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const N=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(N))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(N){this._size&&(this._isPaused!==0?this._eventQueue.push(N):super.fire(N))}}e.PauseableEmitter=s;class i extends s{constructor(N){super(N),this._delay=N.delay??100}fire(N){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(N)}}e.DebounceEmitter=i;class o extends S{constructor(N){super(N),this._queuedEvents=[],this._mergeFn=N?.merge}fire(N){this.hasListeners()&&(this._queuedEvents.push(N),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(F=>super.fire(F)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=o;class a{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new S({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(N){const F={event:N,listener:null};this.events.push(F),this.hasListeners&&this.hook(F);const x=()=>{this.hasListeners&&this.unhook(F);const X=this.events.indexOf(F);this.events.splice(X,1)};return(0,A.toDisposable)((0,U.createSingleCallFunction)(x))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(N=>this.hook(N))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(N=>this.unhook(N))}hook(N){N.listener=N.event(F=>this.emitter.fire(F))}unhook(N){N.listener?.dispose(),N.listener=null}dispose(){this.emitter.dispose();for(const N of this.events)N.listener?.dispose();this.events=[]}}e.EventMultiplexer=a;class y{constructor(N,F,x,X){this._store=new A.DisposableStore;const B=this._store.add(new a),Y=this._store.add(new A.DisposableMap);function z(H){Y.set(H,B.add(X(H)))}for(const H of N)z(H);this._store.add(F(H=>{z(H)})),this._store.add(x(H=>{Y.deleteAndDispose(H)})),this.event=B.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=y;class I{constructor(){this.buffers=[]}wrapEvent(N){return(F,x,X)=>N(B=>{const Y=this.buffers[this.buffers.length-1];Y?Y.push(()=>F.call(x,B)):F.call(x,B)},void 0,X)}bufferEvents(N){const F=[];this.buffers.push(F);const x=N();return this.buffers.pop(),F.forEach(X=>X()),x}}e.EventBufferer=I;class w{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=A.Disposable.None,this.emitter=new S({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(N){this.inputEvent=N,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=N(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w;class b{static const(N){return new D(N)}constructor(N){this._value=N,this._onDidChange=new S,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(N){N!==this._value&&(this._value=N,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=b;class D{constructor(N){this.value=N,this.onDidChange=C.None}}}),define(ae[26],ce([0,1,3]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=R;const U=Object.freeze(function(P,d){const C=setTimeout(P.bind(d),0);return{dispose(){clearTimeout(C)}}});var A;(function(P){function d(C){return C===P.None||C===P.Cancelled||C instanceof O?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}P.isCancellationToken=d,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:_.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:U})})(A||(e.CancellationToken=A={}));class O{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?U:(this._emitter||(this._emitter=new _.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new O),this._token}cancel(){this._token?this._token instanceof O&&this._token.cancel():this._token=A.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof O&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=k;function R(P){const d=new k;return P.add({dispose(){d.cancel()}}),d.token}}),define(ae[129],ce([0,1,26]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=A;class U{constructor(P){this.task=P,this.result=null}get(){if(this.result)return this.result;const P=new _.CancellationTokenSource,d=this.task(P.token);return this.result={promise:d,dispose:()=>{this.result=null,P.cancel(),P.dispose()}},this.result}}e.Cache=U;function A(R){return R}class O{constructor(P,d){this.lastCache=void 0,this.lastArgKey=void 0,typeof P=="function"?(this._fn=P,this._computeKey=A):(this._fn=d,this._computeKey=P.getCacheKey)}get(P){const d=this._computeKey(P);return this.lastArgKey!==d&&(this.lastArgKey=d,this.lastCache=this._fn(P)),this.lastCache}}e.LRUCachedFunction=O;class k{get cachedValues(){return this._map}constructor(P,d){this._map=new Map,this._map2=new Map,typeof P=="function"?(this._fn=P,this._computeKey=A):(this._fn=d,this._computeKey=P.getCacheKey)}get(P){const d=this._computeKey(P);if(this._map2.has(d))return this._map2.get(d);const C=this._fn(P);return this._map.set(P,C),this._map2.set(d,C),C}}e.CachedFunction=k}),define(ae[50],ce([0,1,7,2]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=A,e.isReadableStream=O,e.isReadableBufferedStream=k,e.newWriteableStream=R,e.consumeReadable=d,e.peekReadable=C,e.consumeStream=E,e.listenStream=v,e.peekStream=l,e.toStream=c,e.emptyStream=p,e.toReadable=g,e.transform=u,e.prefixedReadable=h,e.prefixedStream=m;function A(f){const S=f;return S?typeof S.read=="function":!1}function O(f){const S=f;return S?[S.on,S.pause,S.resume,S.destroy].every(t=>typeof t=="function"):!1}function k(f){const S=f;return S?O(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}function R(f,S){return new P(f,S)}class P{constructor(S,t){this.reducer=S,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(S){if(!this.state.destroyed){if(this.state.flowing)this.emitData(S);else if(this.buffer.data.push(S),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(S){this.state.destroyed||(this.state.flowing?this.emitError(S):this.buffer.error.push(S))}end(S){this.state.destroyed||(typeof S<"u"&&this.write(S),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(S){this.listeners.data.slice(0).forEach(t=>t(S))}emitError(S){this.listeners.error.length===0?(0,_.onUnexpectedError)(S):this.listeners.error.slice(0).forEach(t=>t(S))}emitEnd(){this.listeners.end.slice(0).forEach(S=>S())}on(S,t){if(!this.state.destroyed)switch(S){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(S,t){if(this.state.destroyed)return;let r;switch(S){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const n=r.indexOf(t);n>=0&&r.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const S=this.reducer(this.buffer.data);this.emitData(S),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const S of this.buffer.error)this.emitError(S);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(f,S){const t=[];let r;for(;(r=f.read())!==null;)t.push(r);return S(t)}function C(f,S,t){const r=[];let n;for(;(n=f.read())!==null&&r.length<t;)r.push(n);return n===null&&r.length>0?S(r):{read:()=>{if(r.length>0)return r.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return f.read()}}}function E(f,S){return new Promise((t,r)=>{const n=[];v(f,{onData:s=>{S&&n.push(s)},onError:s=>{S?r(s):t(void 0)},onEnd:()=>{t(S?S(n):void 0)}})})}function v(f,S,t){f.on("error",r=>{t?.isCancellationRequested||S.onError(r)}),f.on("end",()=>{t?.isCancellationRequested||S.onEnd()}),f.on("data",r=>{t?.isCancellationRequested||S.onData(r)})}function l(f,S){return new Promise((t,r)=>{const n=new U.DisposableStore,s=[],i=y=>{if(s.push(y),s.length>S)return n.dispose(),f.pause(),t({stream:f,buffer:s,ended:!1})},o=y=>(n.dispose(),r(y)),a=()=>(n.dispose(),t({stream:f,buffer:s,ended:!0}));n.add((0,U.toDisposable)(()=>f.removeListener("error",o))),f.on("error",o),n.add((0,U.toDisposable)(()=>f.removeListener("end",a))),f.on("end",a),n.add((0,U.toDisposable)(()=>f.removeListener("data",i))),f.on("data",i)})}function c(f,S){const t=R(S);return t.end(f),t}function p(){const f=R(()=>{throw new Error("not supported")});return f.end(),f}function g(f){let S=!1;return{read:()=>S?null:(S=!0,f)}}function u(f,S,t){const r=R(t);return v(f,{onData:n=>r.write(S.data(n)),onError:n=>r.error(S.error?S.error(n):n),onEnd:()=>r.end()}),r}function h(f,S,t){let r=!1;return{read:()=>{const n=S.read();return r?n:(r=!0,n!==null?t([f,n]):f)}}}function m(f,S,t){let r=!1;const n=R(t);return v(S,{onData:s=>r?n.write(s):(r=!0,n.write(t([f,s]))),onError:s=>n.error(s),onEnd:()=>{r||(r=!0,n.write(f)),n.end()}}),n}}),define(ae[15],ce([0,1,53,50]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=d,e.readUInt16LE=C,e.writeUInt16LE=E,e.readUInt32BE=v,e.writeUInt32BE=l,e.readUInt32LE=c,e.writeUInt32LE=p,e.readUInt8=g,e.writeUInt8=u,e.readableToBuffer=h,e.bufferToReadable=m,e.streamToBuffer=f,e.bufferedStreamToBuffer=S,e.bufferToStream=t,e.streamToBufferReadableStream=r,e.newWriteableBufferStream=n,e.prefixedBufferReadable=s,e.prefixedBufferStream=i,e.decodeBase64=o,e.encodeBase64=I;const A=typeof Buffer<"u",O=new _.Lazy(()=>new Uint8Array(256));let k,R;class P{static alloc(b){return A?new P(Buffer.allocUnsafe(b)):new P(new Uint8Array(b))}static wrap(b){return A&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new P(b)}static fromString(b,D){return!(D?.dontUseNodeBuffer||!1)&&A?new P(Buffer.from(b)):(k||(k=new TextEncoder),new P(k.encode(b)))}static fromByteArray(b){const D=P.alloc(b.length);for(let L=0,N=b.length;L<N;L++)D.buffer[L]=b[L];return D}static concat(b,D){if(typeof D>"u"){D=0;for(let F=0,x=b.length;F<x;F++)D+=b[F].byteLength}const L=P.alloc(D);let N=0;for(let F=0,x=b.length;F<x;F++){const X=b[F];L.set(X,N),N+=X.byteLength}return L}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=P.alloc(this.byteLength);return b.set(this),b}toString(){return A?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(b,D){return new P(this.buffer.subarray(b,D))}set(b,D){if(b instanceof P)this.buffer.set(b.buffer,D);else if(b instanceof Uint8Array)this.buffer.set(b,D);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),D);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return v(this.buffer,b)}writeUInt32BE(b,D){l(this.buffer,b,D)}readUInt32LE(b){return c(this.buffer,b)}writeUInt32LE(b,D){p(this.buffer,b,D)}readUInt8(b){return g(this.buffer,b)}writeUInt8(b,D){u(this.buffer,b,D)}indexOf(b,D=0){return d(this.buffer,b instanceof P?b.buffer:b,D)}}e.VSBuffer=P;function d(w,b,D=0){const L=b.byteLength,N=w.byteLength;if(L===0)return 0;if(L===1)return w.indexOf(b[0]);if(L>N-D)return-1;const F=O.value;F.fill(b.length);for(let Y=0;Y<b.length;Y++)F[b[Y]]=b.length-Y-1;let x=D+b.length-1,X=x,B=-1;for(;x<N;)if(w[x]===b[X]){if(X===0){B=x;break}x--,X--}else x+=Math.max(b.length-X,F[w[x]]),X=b.length-1;return B}function C(w,b){return w[b+0]<<0>>>0|w[b+1]<<8>>>0}function E(w,b,D){w[D+0]=b&255,b=b>>>8,w[D+1]=b&255}function v(w,b){return w[b]*2**24+w[b+1]*2**16+w[b+2]*2**8+w[b+3]}function l(w,b,D){w[D+3]=b,b=b>>>8,w[D+2]=b,b=b>>>8,w[D+1]=b,b=b>>>8,w[D]=b}function c(w,b){return w[b+0]<<0>>>0|w[b+1]<<8>>>0|w[b+2]<<16>>>0|w[b+3]<<24>>>0}function p(w,b,D){w[D+0]=b&255,b=b>>>8,w[D+1]=b&255,b=b>>>8,w[D+2]=b&255,b=b>>>8,w[D+3]=b&255}function g(w,b){return w[b]}function u(w,b,D){w[D]=b}function h(w){return U.consumeReadable(w,b=>P.concat(b))}function m(w){return U.toReadable(w)}function f(w){return U.consumeStream(w,b=>P.concat(b))}async function S(w){return w.ended?P.concat(w.buffer):P.concat([...w.buffer,await f(w.stream)])}function t(w){return U.toStream(w,b=>P.concat(b))}function r(w){return U.transform(w,{data:b=>typeof b=="string"?P.fromString(b):P.wrap(b)},b=>P.concat(b))}function n(w){return U.newWriteableStream(b=>P.concat(b),w)}function s(w,b){return U.prefixedReadable(w,b,D=>P.concat(D))}function i(w,b){return U.prefixedStream(w,b,D=>P.concat(D))}function o(w){let b=0,D=0,L=0;const N=new Uint8Array(Math.floor(w.length/4*3)),F=X=>{switch(D){case 3:N[L++]=b|X,D=0;break;case 2:N[L++]=b|X>>>2,b=X<<6,D=3;break;case 1:N[L++]=b|X>>>4,b=X<<4,D=2;break;default:b=X<<2,D=1}};for(let X=0;X<w.length;X++){const B=w.charCodeAt(X);if(B>=65&&B<=90)F(B-65);else if(B>=97&&B<=122)F(B-97+26);else if(B>=48&&B<=57)F(B-48+52);else if(B===43||B===45)F(62);else if(B===47||B===95)F(63);else{if(B===61)break;throw new SyntaxError(`Unexpected base64 character ${w[X]}`)}}const x=L;for(;D>0;)F(0);return P.wrap(N).slice(0,x)}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:w},b=!0,D=!1){const L=D?y:a;let N="";const F=w.byteLength%3;let x=0;for(;x<w.byteLength-F;x+=3){const X=w[x+0],B=w[x+1],Y=w[x+2];N+=L[X>>>2],N+=L[(X<<4|B>>>4)&63],N+=L[(B<<2|Y>>>6)&63],N+=L[Y&63]}if(F===1){const X=w[x+0];N+=L[X>>>2],N+=L[X<<4&63],b&&(N+="==")}else if(F===2){const X=w[x+0],B=w[x+1];N+=L[X>>>2],N+=L[(X<<4|B>>>4)&63],N+=L[B<<2&63],b&&(N+="=")}return N}}),define(ae[27],ce([0,1,129,53]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=A,e.format=k,e.format2=P,e.htmlAttributeEncodeValue=d,e.escape=C,e.escapeRegExpCharacters=E,e.count=v,e.truncate=l,e.truncateMiddle=c,e.trim=p,e.ltrim=g,e.rtrim=u,e.convertSimple2RegExpPattern=h,e.stripWildcards=m,e.createRegExp=f,e.regExpLeadsToEndlessLoop=S,e.splitLines=t,e.splitLinesIncludeSeparators=r,e.firstNonWhitespaceIndex=n,e.getLeadingWhitespace=s,e.lastNonWhitespaceIndex=i,e.replaceAsync=o,e.compare=a,e.compareSubstring=y,e.compareIgnoreCase=I,e.compareSubstringIgnoreCase=w,e.isAsciiDigit=b,e.isLowerAsciiLetter=D,e.isUpperAsciiLetter=L,e.equalsIgnoreCase=N,e.startsWithIgnoreCase=F,e.commonPrefixLength=x,e.commonSuffixLength=X,e.isHighSurrogate=B,e.isLowSurrogate=Y,e.computeCodePoint=z,e.getNextCodePoint=H,e.nextCharLength=re,e.prevCharLength=ue,e.getCharContainingOffset=te,e.charCount=j,e.containsRTL=M,e.isBasicASCII=Q,e.containsUnusualLineTerminators=G,e.isFullWidthCharacter=ee,e.isEmojiImprecise=Z,e.lcut=J,e.forAnsiStringParts=he,e.removeAnsiEscapeCodes=ge,e.startsWithUTF8BOM=de,e.stripUTF8BOM=me,e.fuzzyContains=Ee,e.containsUppercaseCharacter=we,e.uppercaseFirstLetter=Pe,e.getNLines=_e,e.singleLetterHash=le,e.getGraphemeBreakType=Se,e.getLeftDeleteOffset=Te;function A(oe){return!oe||typeof oe!="string"?!0:oe.trim().length===0}const O=/{(\d+)}/g;function k(oe,...fe){return fe.length===0?oe:oe.replace(O,function(pe,ye){const Ie=parseInt(ye,10);return isNaN(Ie)||Ie<0||Ie>=fe.length?pe:fe[Ie]})}const R=/{([^}]+)}/g;function P(oe,fe){return Object.keys(fe).length===0?oe:oe.replace(R,(pe,ye)=>fe[ye]??pe)}function d(oe){return oe.replace(/[<>"'&]/g,fe=>{switch(fe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return fe})}function C(oe){return oe.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}function E(oe){return oe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function v(oe,fe){let pe=0;const ye=fe.charCodeAt(0);for(let Ie=oe.length-1;Ie>=0;Ie--)oe.charCodeAt(Ie)===ye&&pe++;return pe}function l(oe,fe,pe="\u2026"){return oe.length<=fe?oe:`${oe.substr(0,fe)}${pe}`}function c(oe,fe,pe="\u2026"){if(oe.length<=fe)return oe;const ye=Math.ceil(fe/2)-pe.length/2,Ie=Math.floor(fe/2)-pe.length/2;return`${oe.substr(0,ye)}${pe}${oe.substr(oe.length-Ie)}`}function p(oe,fe=" "){const pe=g(oe,fe);return u(pe,fe)}function g(oe,fe){if(!oe||!fe)return oe;const pe=fe.length;if(pe===0||oe.length===0)return oe;let ye=0;for(;oe.indexOf(fe,ye)===ye;)ye=ye+pe;return oe.substring(ye)}function u(oe,fe){if(!oe||!fe)return oe;const pe=fe.length,ye=oe.length;if(pe===0||ye===0)return oe;let Ie=ye,Re=-1;for(;Re=oe.lastIndexOf(fe,Ie-1),!(Re===-1||Re+pe!==Ie);){if(Re===0)return"";Ie=Re}return oe.substring(0,Ie)}function h(oe){return oe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function m(oe){return oe.replace(/\*/g,"")}function f(oe,fe,pe={}){if(!oe)throw new Error("Cannot create regex from empty string");fe||(oe=E(oe)),pe.wholeWord&&(/\B/.test(oe.charAt(0))||(oe="\\b"+oe),/\B/.test(oe.charAt(oe.length-1))||(oe=oe+"\\b"));let ye="";return pe.global&&(ye+="g"),pe.matchCase||(ye+="i"),pe.multiline&&(ye+="m"),pe.unicode&&(ye+="u"),new RegExp(oe,ye)}function S(oe){return oe.source==="^"||oe.source==="^$"||oe.source==="$"||oe.source==="^\\s*$"?!1:!!(oe.exec("")&&oe.lastIndex===0)}function t(oe){return oe.split(/\r\n|\r|\n/)}function r(oe){const fe=[],pe=oe.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(pe.length/2);ye++)fe.push(pe[2*ye]+(pe[2*ye+1]??""));return fe}function n(oe){for(let fe=0,pe=oe.length;fe<pe;fe++){const ye=oe.charCodeAt(fe);if(ye!==32&&ye!==9)return fe}return-1}function s(oe,fe=0,pe=oe.length){for(let ye=fe;ye<pe;ye++){const Ie=oe.charCodeAt(ye);if(Ie!==32&&Ie!==9)return oe.substring(fe,ye)}return oe.substring(fe,pe)}function i(oe,fe=oe.length-1){for(let pe=fe;pe>=0;pe--){const ye=oe.charCodeAt(pe);if(ye!==32&&ye!==9)return pe}return-1}function o(oe,fe,pe){const ye=[];let Ie=0;for(const Re of oe.matchAll(fe)){if(ye.push(oe.slice(Ie,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Ie=Re.index+Re[0].length,ye.push(pe(Re[0],...Re.slice(1),Re.index,oe,Re.groups))}return ye.push(oe.slice(Ie)),Promise.all(ye).then(Re=>Re.join(""))}function a(oe,fe){return oe<fe?-1:oe>fe?1:0}function y(oe,fe,pe=0,ye=oe.length,Ie=0,Re=fe.length){for(;pe<ye&&Ie<Re;pe++,Ie++){const ze=oe.charCodeAt(pe),qe=fe.charCodeAt(Ie);if(ze<qe)return-1;if(ze>qe)return 1}const ke=ye-pe,Ue=Re-Ie;return ke<Ue?-1:ke>Ue?1:0}function I(oe,fe){return w(oe,fe,0,oe.length,0,fe.length)}function w(oe,fe,pe=0,ye=oe.length,Ie=0,Re=fe.length){for(;pe<ye&&Ie<Re;pe++,Ie++){let ze=oe.charCodeAt(pe),qe=fe.charCodeAt(Ie);if(ze===qe)continue;if(ze>=128||qe>=128)return y(oe.toLowerCase(),fe.toLowerCase(),pe,ye,Ie,Re);D(ze)&&(ze-=32),D(qe)&&(qe-=32);const Fe=ze-qe;if(Fe!==0)return Fe}const ke=ye-pe,Ue=Re-Ie;return ke<Ue?-1:ke>Ue?1:0}function b(oe){return oe>=48&&oe<=57}function D(oe){return oe>=97&&oe<=122}function L(oe){return oe>=65&&oe<=90}function N(oe,fe){return oe.length===fe.length&&w(oe,fe)===0}function F(oe,fe){const pe=fe.length;return fe.length>oe.length?!1:w(oe,fe,0,pe)===0}function x(oe,fe){const pe=Math.min(oe.length,fe.length);let ye;for(ye=0;ye<pe;ye++)if(oe.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return pe}function X(oe,fe){const pe=Math.min(oe.length,fe.length);let ye;const Ie=oe.length-1,Re=fe.length-1;for(ye=0;ye<pe;ye++)if(oe.charCodeAt(Ie-ye)!==fe.charCodeAt(Re-ye))return ye;return pe}function B(oe){return 55296<=oe&&oe<=56319}function Y(oe){return 56320<=oe&&oe<=57343}function z(oe,fe){return(oe-55296<<10)+(fe-56320)+65536}function H(oe,fe,pe){const ye=oe.charCodeAt(pe);if(B(ye)&&pe+1<fe){const Ie=oe.charCodeAt(pe+1);if(Y(Ie))return z(ye,Ie)}return ye}function V(oe,fe){const pe=oe.charCodeAt(fe-1);if(Y(pe)&&fe>1){const ye=oe.charCodeAt(fe-2);if(B(ye))return z(ye,pe)}return pe}class q{get offset(){return this._offset}constructor(fe,pe=0){this._str=fe,this._len=fe.length,this._offset=pe}setOffset(fe){this._offset=fe}prevCodePoint(){const fe=V(this._str,this._offset);return this._offset-=fe>=65536?2:1,fe}nextCodePoint(){const fe=H(this._str,this._len,this._offset);return this._offset+=fe>=65536?2:1,fe}eol(){return this._offset>=this._len}}e.CodePointIterator=q;class ie{get offset(){return this._iterator.offset}constructor(fe,pe=0){this._iterator=new q(fe,pe)}nextGraphemeLength(){const fe=Le.getInstance(),pe=this._iterator,ye=pe.offset;let Ie=fe.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Re=pe.offset,ke=fe.getGraphemeBreakType(pe.nextCodePoint());if(ve(Ie,ke)){pe.setOffset(Re);break}Ie=ke}return pe.offset-ye}prevGraphemeLength(){const fe=Le.getInstance(),pe=this._iterator,ye=pe.offset;let Ie=fe.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Re=pe.offset,ke=fe.getGraphemeBreakType(pe.prevCodePoint());if(ve(ke,Ie)){pe.setOffset(Re);break}Ie=ke}return ye-pe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ie;function re(oe,fe){return new ie(oe,fe).nextGraphemeLength()}function ue(oe,fe){return new ie(oe,fe).prevGraphemeLength()}function te(oe,fe){fe>0&&Y(oe.charCodeAt(fe))&&fe--;const pe=fe+re(oe,fe);return[pe-ue(oe,pe),pe]}function j(oe){const fe=new ie(oe);let pe=0;for(;!fe.eol();)pe++,fe.nextGraphemeLength();return pe}let W;function T(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function M(oe){return W||(W=T()),W.test(oe)}const $=/^[\t\n\r\x20-\x7E]*$/;function Q(oe){return $.test(oe)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function G(oe){return e.UNUSUAL_LINE_TERMINATORS.test(oe)}function ee(oe){return oe>=11904&&oe<=55215||oe>=63744&&oe<=64255||oe>=65281&&oe<=65374}function Z(oe){return oe>=127462&&oe<=127487||oe===8986||oe===8987||oe===9200||oe===9203||oe>=9728&&oe<=10175||oe===11088||oe===11093||oe>=127744&&oe<=128591||oe>=128640&&oe<=128764||oe>=128992&&oe<=129008||oe>=129280&&oe<=129535||oe>=129648&&oe<=129782}function J(oe,fe,pe=""){const ye=oe.trimStart();if(ye.length<fe)return ye;const Ie=/\b/g;let Re=0;for(;Ie.test(ye)&&!(ye.length-Ie.lastIndex<fe);)Re=Ie.lastIndex,Ie.lastIndex+=1;return Re===0?ye:pe+ye.substring(Re).trimStart()}const se=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*he(oe){let fe=0;for(const pe of oe.matchAll(se))fe!==pe.index&&(yield{isCode:!1,str:oe.substring(fe,pe.index)}),yield{isCode:!0,str:pe[0]},fe=pe.index+pe[0].length;fe!==oe.length&&(yield{isCode:!1,str:oe.substring(fe)})}function ge(oe){return oe&&(oe=oe.replace(se,"")),oe}e.UTF8_BOM_CHARACTER="\uFEFF";function de(oe){return!!(oe&&oe.length>0&&oe.charCodeAt(0)===65279)}function me(oe){return de(oe)?oe.substr(1):oe}function Ee(oe,fe){if(!oe||!fe||oe.length<fe.length)return!1;const pe=fe.length,ye=oe.toLowerCase();let Ie=0,Re=-1;for(;Ie<pe;){const ke=ye.indexOf(fe[Ie],Re+1);if(ke<0)return!1;Re=ke,Ie++}return!0}function we(oe,fe=!1){return oe?(fe&&(oe=oe.replace(/\\./g,"")),oe.toLowerCase()!==oe):!1}function Pe(oe){return oe.charAt(0).toUpperCase()+oe.slice(1)}function _e(oe,fe=1){if(fe===0)return"";let pe=-1;do pe=oe.indexOf(`
`,pe+1),fe--;while(fe>0&&pe>=0);return pe===-1?oe:(oe[pe-1]==="\r"&&pe--,oe.substr(0,pe))}function le(oe){return oe=oe%(2*26),oe<26?String.fromCharCode(97+oe):String.fromCharCode(65+oe-26)}function Se(oe){return Le.getInstance().getGraphemeBreakType(oe)}function ve(oe,fe){return oe===0?fe!==5&&fe!==7:oe===2&&fe===3?!1:oe===4||oe===2||oe===3||fe===4||fe===2||fe===3?!0:!(oe===8&&(fe===8||fe===9||fe===11||fe===12)||(oe===11||oe===9)&&(fe===9||fe===10)||(oe===12||oe===10)&&fe===10||fe===5||fe===13||fe===7||oe===1||oe===13&&fe===14||oe===6&&fe===6)}var De;(function(oe){oe[oe.Other=0]="Other",oe[oe.Prepend=1]="Prepend",oe[oe.CR=2]="CR",oe[oe.LF=3]="LF",oe[oe.Control=4]="Control",oe[oe.Extend=5]="Extend",oe[oe.Regional_Indicator=6]="Regional_Indicator",oe[oe.SpacingMark=7]="SpacingMark",oe[oe.L=8]="L",oe[oe.V=9]="V",oe[oe.T=10]="T",oe[oe.LV=11]="LV",oe[oe.LVT=12]="LVT",oe[oe.ZWJ=13]="ZWJ",oe[oe.Extended_Pictographic=14]="Extended_Pictographic"})(De||(e.GraphemeBreakType=De={}));class Le{static{this._INSTANCE=null}static getInstance(){return Le._INSTANCE||(Le._INSTANCE=new Le),Le._INSTANCE}constructor(){this._data=Ne()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const pe=this._data,ye=pe.length/3;let Ie=1;for(;Ie<=ye;)if(fe<pe[3*Ie])Ie=2*Ie;else if(fe>pe[3*Ie+1])Ie=2*Ie+1;else return pe[3*Ie+2];return 0}}function Ne(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(oe,fe){if(oe===0)return 0;const pe=xe(oe,fe);if(pe!==void 0)return pe;const ye=new q(fe,oe);return ye.prevCodePoint(),ye.offset}function xe(oe,fe){const pe=new q(fe,oe);let ye=pe.prevCodePoint();for(;Me(ye)||ye===65039||ye===8419;){if(pe.offset===0)return;ye=pe.prevCodePoint()}if(!Z(ye))return;let Ie=pe.offset;return Ie>0&&pe.prevCodePoint()===8205&&(Ie=pe.offset),Ie}function Me(oe){return 127995<=oe&&oe<=127999}var $e;(function(oe){oe[oe.zwj=8205]="zwj",oe[oe.emojiVariantSelector=65039]="emojiVariantSelector",oe[oe.enclosingKeyCap=8419]="enclosingKeyCap"})($e||($e={})),e.noBreakWhitespace="\xA0";class We{static{this.ambiguousCharacterData=new U.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new _.LRUCachedFunction({getCacheKey:JSON.stringify},fe=>{function pe(Fe){const Ke=new Map;for(let Be=0;Be<Fe.length;Be+=2)Ke.set(Fe[Be],Fe[Be+1]);return Ke}function ye(Fe,Ke){const Be=new Map(Fe);for(const[Ze,tt]of Ke)Be.set(Ze,tt);return Be}function Ie(Fe,Ke){if(!Fe)return Ke;const Be=new Map;for(const[Ze,tt]of Fe)Ke.has(Ze)&&Be.set(Ze,tt);return Be}const Re=this.ambiguousCharacterData.value;let ke=fe.filter(Fe=>!Fe.startsWith("_")&&Fe in Re);ke.length===0&&(ke=["_default"]);let Ue;for(const Fe of ke){const Ke=pe(Re[Fe]);Ue=Ie(Ue,Ke)}const ze=pe(Re._common),qe=ye(ze,Ue);return new We(qe)})}static getInstance(fe){return We.cache.get(Array.from(fe))}static{this._locales=new U.Lazy(()=>Object.keys(We.ambiguousCharacterData.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return We._locales.value}constructor(fe){this.confusableDictionary=fe}isAmbiguous(fe){return this.confusableDictionary.has(fe)}getPrimaryConfusable(fe){return this.confusableDictionary.get(fe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=We;class Oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(Oe.getRawData())),this._data}static isInvisibleCharacter(fe){return Oe.getData().has(fe)}static get codePoints(){return Oe.getData()}}e.InvisibleCharacters=Oe}),define(ae[54],ce([0,1,27]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=U,e.doHash=A,e.numberHash=O,e.stringHash=R,e.toHexString=p;function U(u){return A(u,0)}function A(u,h){switch(typeof u){case"object":return u===null?O(349,h):Array.isArray(u)?P(u,h):d(u,h);case"string":return R(u,h);case"boolean":return k(u,h);case"number":return O(u,h);case"undefined":return O(937,h);default:return O(617,h)}}function O(u,h){return(h<<5)-h+u|0}function k(u,h){return O(u?433:863,h)}function R(u,h){h=O(149417,h);for(let m=0,f=u.length;m<f;m++)h=O(u.charCodeAt(m),h);return h}function P(u,h){return h=O(104579,h),u.reduce((m,f)=>A(f,m),h)}function d(u,h){return h=O(181387,h),Object.keys(u).sort().reduce((m,f)=>(m=R(f,m),A(u[f],m)),h)}class C{constructor(){this._value=0}get value(){return this._value}hash(h){return this._value=A(h,this._value),this._value}}e.Hasher=C;var E;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function v(u,h,m=32){const f=m-h,S=~((1<<f)-1);return(u<<h|(S&u)>>>f)>>>0}function l(u,h=0,m=u.byteLength,f=0){for(let S=0;S<m;S++)u[h+S]=f}function c(u,h,m="0"){for(;u.length<h;)u=m+u;return u}function p(u,h=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(m=>m.toString(16).padStart(2,"0")).join(""):c((u>>>0).toString(16),h/4)}class g{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(h){const m=h.length;if(m===0)return;const f=this._buff;let S=this._buffLen,t=this._leftoverHighSurrogate,r,n;for(t!==0?(r=t,n=-1,t=0):(r=h.charCodeAt(0),n=0);;){let s=r;if(_.isHighSurrogate(r))if(n+1<m){const i=h.charCodeAt(n+1);_.isLowSurrogate(i)?(n++,s=_.computeCodePoint(r,i)):s=65533}else{t=r;break}else _.isLowSurrogate(r)&&(s=65533);if(S=this._push(f,S,s),n++,n<m)r=h.charCodeAt(n);else break}this._buffLen=S,this._leftoverHighSurrogate=t}_push(h,m,f){return f<128?h[m++]=f:f<2048?(h[m++]=192|(f&1984)>>>6,h[m++]=128|(f&63)>>>0):f<65536?(h[m++]=224|(f&61440)>>>12,h[m++]=128|(f&4032)>>>6,h[m++]=128|(f&63)>>>0):(h[m++]=240|(f&1835008)>>>18,h[m++]=128|(f&258048)>>>12,h[m++]=128|(f&4032)>>>6,h[m++]=128|(f&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,h[0]=h[64],h[1]=h[65],h[2]=h[66]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,l(this._buff,this._buffLen),this._buffLen>56&&(this._step(),l(this._buff));const h=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(h/4294967296),!1),this._buffDV.setUint32(60,h%4294967296,!1),this._step()}_step(){const h=g._bigBlock32,m=this._buffDV;for(let a=0;a<64;a+=4)h.setUint32(a,m.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)h.setUint32(a,v(h.getUint32(a-12,!1)^h.getUint32(a-32,!1)^h.getUint32(a-56,!1)^h.getUint32(a-64,!1),1),!1);let f=this._h0,S=this._h1,t=this._h2,r=this._h3,n=this._h4,s,i,o;for(let a=0;a<80;a++)a<20?(s=S&t|~S&r,i=1518500249):a<40?(s=S^t^r,i=1859775393):a<60?(s=S&t|S&r|t&r,i=2400959708):(s=S^t^r,i=3395469782),o=v(f,5)+s+n+i+h.getUint32(a*4,!1)&4294967295,n=r,r=t,t=v(S,30),S=f,f=o;this._h0=this._h0+f&4294967295,this._h1=this._h1+S&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=g}),define(ae[88],ce([0,1,27]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var U;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(U||(U={})),function(A){const O="error",k="warning",R="warn",P="info",d="ignore";function C(v){return v?_.equalsIgnoreCase(O,v)?A.Error:_.equalsIgnoreCase(k,v)||_.equalsIgnoreCase(R,v)?A.Warning:_.equalsIgnoreCase(P,v)?A.Info:A.Ignore:A.Ignore}A.fromValue=C;function E(v){switch(v){case A.Error:return O;case A.Warning:return k;case A.Info:return P;default:return d}}A.toString=E}(U||(U={})),e.default=U}),define(ae[130],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ae[51],ce([0,1,17,27]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class A{constructor(){this._value="",this._pos=0}reset(l){return this._value=l,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(l){const c=l.charCodeAt(0),p=this._value.charCodeAt(this._pos);return c-p}value(){return this._value[this._pos]}}e.StringIterator=A;class O{constructor(l=!0){this._caseSensitive=l}reset(l){return this._value=l,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let l=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(l)this._from++;else break;else l=!1;return this}cmp(l){return this._caseSensitive?(0,U.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,U.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=O;class k{constructor(l=!0,c=!0){this._splitOnBackslash=l,this._caseSensitive=c}reset(l){this._from=0,this._to=0,this._value=l,this._valueLen=l.length;for(let c=l.length-1;c>=0;c--,this._valueLen--){const p=this._value.charCodeAt(c);if(!(p===47||this._splitOnBackslash&&p===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let l=!0;for(;this._to<this._valueLen;this._to++){const c=this._value.charCodeAt(this._to);if(c===47||this._splitOnBackslash&&c===92)if(l)this._from++;else break;else l=!1}return this}cmp(l){return this._caseSensitive?(0,U.compareSubstring)(l,this._value,0,l.length,this._from,this._to):(0,U.compareSubstringIgnoreCase)(l,this._value,0,l.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=k;var R;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(R||(R={}));class P{constructor(l,c){this._ignorePathCasing=l,this._ignoreQueryAndFragment=c,this._states=[],this._stateIdx=0}reset(l){return this._value=l,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new k(!1,!this._ignorePathCasing(l)),this._pathIterator.reset(l.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(l)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(l){if(this._states[this._stateIdx]===1)return(0,U.compareIgnoreCase)(l,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,U.compareIgnoreCase)(l,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(l);if(this._states[this._stateIdx]===4)return(0,U.compare)(l,this._value.query);if(this._states[this._stateIdx]===5)return(0,U.compare)(l,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=P;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(C||(C={}));class E{static forUris(l=()=>!1,c=()=>!1){return new E(new P(l,c))}static forPaths(l=!1){return new E(new k(void 0,!l))}static forStrings(){return new E(new A)}static forConfigKeys(){return new E(new O)}constructor(l){this._iter=l}clear(){this._root=void 0}fill(l,c){if(c){const p=c.slice(0);(0,_.shuffle)(p);for(const g of p)this.set(g,l)}else{const p=l.slice(0);(0,_.shuffle)(p);for(const g of p)this.set(g[0],g[1])}}set(l,c){const p=this._iter.reset(l);let g;this._root||(this._root=new d,this._root.segment=p.value());const u=[];for(g=this._root;;){const m=p.cmp(g.segment);if(m>0)g.left||(g.left=new d,g.left.segment=p.value()),u.push([-1,g]),g=g.left;else if(m<0)g.right||(g.right=new d,g.right.segment=p.value()),u.push([1,g]),g=g.right;else if(p.hasNext())p.next(),g.mid||(g.mid=new d,g.mid.segment=p.value()),u.push([0,g]),g=g.mid;else break}const h=g.value;g.value=c,g.key=l;for(let m=u.length-1;m>=0;m--){const f=u[m][1];f.updateHeight();const S=f.balanceFactor();if(S<-1||S>1){const t=u[m][0],r=u[m+1][0];if(t===1&&r===1)u[m][1]=f.rotateLeft();else if(t===-1&&r===-1)u[m][1]=f.rotateRight();else if(t===1&&r===-1)f.right=u[m+1][1]=u[m+1][1].rotateRight(),u[m][1]=f.rotateLeft();else if(t===-1&&r===1)f.left=u[m+1][1]=u[m+1][1].rotateLeft(),u[m][1]=f.rotateRight();else throw new Error;if(m>0)switch(u[m-1][0]){case-1:u[m-1][1].left=u[m][1];break;case 1:u[m-1][1].right=u[m][1];break;case 0:u[m-1][1].mid=u[m][1];break}else this._root=u[0][1]}}return h}get(l){return this._getNode(l)?.value}_getNode(l){const c=this._iter.reset(l);let p=this._root;for(;p;){const g=c.cmp(p.segment);if(g>0)p=p.left;else if(g<0)p=p.right;else if(c.hasNext())c.next(),p=p.mid;else break}return p}has(l){const c=this._getNode(l);return!(c?.value===void 0&&c?.mid===void 0)}delete(l){return this._delete(l,!1)}deleteSuperstr(l){return this._delete(l,!0)}_delete(l,c){const p=this._iter.reset(l),g=[];let u=this._root;for(;u;){const h=p.cmp(u.segment);if(h>0)g.push([-1,u]),u=u.left;else if(h<0)g.push([1,u]),u=u.right;else if(p.hasNext())p.next(),g.push([0,u]),u=u.mid;else break}if(u){if(c?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const h=this._min(u.right);if(h.key){const{key:m,value:f,segment:S}=h;this._delete(h.key,!1),u.key=m,u.value=f,u.segment=S}}else{const h=u.left??u.right;if(g.length>0){const[m,f]=g[g.length-1];switch(m){case-1:f.left=h;break;case 0:f.mid=h;break;case 1:f.right=h;break}}else this._root=h}for(let h=g.length-1;h>=0;h--){const m=g[h][1];m.updateHeight();const f=m.balanceFactor();if(f>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),g[h][1]=m.rotateLeft()):f<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),g[h][1]=m.rotateRight()),h>0)switch(g[h-1][0]){case-1:g[h-1][1].left=g[h][1];break;case 1:g[h-1][1].right=g[h][1];break;case 0:g[h-1][1].mid=g[h][1];break}else this._root=g[0][1]}}}_min(l){for(;l.left;)l=l.left;return l}findSubstr(l){const c=this._iter.reset(l);let p=this._root,g;for(;p;){const u=c.cmp(p.segment);if(u>0)p=p.left;else if(u<0)p=p.right;else if(c.hasNext())c.next(),g=p.value||g,p=p.mid;else break}return p&&p.value||g}findSuperstr(l){return this._findSuperstrOrElement(l,!1)}_findSuperstrOrElement(l,c){const p=this._iter.reset(l);let g=this._root;for(;g;){const u=p.cmp(g.segment);if(u>0)g=g.left;else if(u<0)g=g.right;else if(p.hasNext())p.next(),g=g.mid;else return g.mid?this._entries(g.mid):c?g.value:void 0}}hasElementOrSubtree(l){return this._findSuperstrOrElement(l,!0)!==void 0}forEach(l){for(const[c,p]of this)l(p,c)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(l){const c=[];return this._dfsEntries(l,c),c[Symbol.iterator]()}_dfsEntries(l,c){l&&(l.left&&this._dfsEntries(l.left,c),l.value&&c.push([l.key,l.value]),l.mid&&this._dfsEntries(l.mid,c),l.right&&this._dfsEntries(l.right,c))}_isBalanced(){const l=c=>{if(!c)return!0;const p=c.balanceFactor();return p<-1||p>1?!1:l(c.left)&&l(c.right)};return l(this._root)}}e.TernarySearchTree=E}),define(ae[13],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=_,e.isStringArray=U,e.isObject=A,e.isTypedArray=O,e.isNumber=k,e.isIterable=R,e.isBoolean=P,e.isUndefined=d,e.isDefined=C,e.isUndefinedOrNull=E,e.assertType=v,e.assertIsDefined=l,e.assertAllDefined=c,e.isEmptyObject=g,e.isFunction=u,e.areFunctions=h,e.validateConstraints=m,e.validateConstraint=f;function _(S){return typeof S=="string"}function U(S){return Array.isArray(S)&&S.every(t=>_(t))}function A(S){return typeof S=="object"&&S!==null&&!Array.isArray(S)&&!(S instanceof RegExp)&&!(S instanceof Date)}function O(S){const t=Object.getPrototypeOf(Uint8Array);return typeof S=="object"&&S instanceof t}function k(S){return typeof S=="number"&&!isNaN(S)}function R(S){return!!S&&typeof S[Symbol.iterator]=="function"}function P(S){return S===!0||S===!1}function d(S){return typeof S>"u"}function C(S){return!E(S)}function E(S){return d(S)||S===null}function v(S,t){if(!S)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function l(S){if(E(S))throw new Error("Assertion Failed: argument is undefined or null");return S}function c(...S){const t=[];for(let r=0;r<S.length;r++){const n=S[r];if(E(n))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(n)}return t}const p=Object.prototype.hasOwnProperty;function g(S){if(!A(S))return!1;for(const t in S)if(p.call(S,t))return!1;return!0}function u(S){return typeof S=="function"}function h(...S){return S.length>0&&S.every(u)}function m(S,t){const r=Math.min(S.length,t.length);for(let n=0;n<r;n++)f(S[n],t[n])}function f(S,t){if(_(t)){if(typeof S!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(S instanceof t)return}catch{}if(!E(S)&&S.constructor===t||t.length===1&&t.call(void 0,S)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ae[30],ce([0,1,13]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=U,e.deepFreeze=A,e.cloneAndChange=k,e.mixin=P,e.equals=d,e.safeStringify=C,e.distinct=E,e.getCaseInsensitive=v,e.filter=l,e.getAllPropertyNames=c,e.getAllMethodNames=p,e.createProxyObject=g;function U(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const h=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([m,f])=>{h[m]=f&&typeof f=="object"?U(f):f}),h}function A(u){if(!u||typeof u!="object")return u;const h=[u];for(;h.length>0;){const m=h.shift();Object.freeze(m);for(const f in m)if(O.call(m,f)){const S=m[f];typeof S=="object"&&!Object.isFrozen(S)&&!(0,_.isTypedArray)(S)&&h.push(S)}}return u}const O=Object.prototype.hasOwnProperty;function k(u,h){return R(u,h,new Set)}function R(u,h,m){if((0,_.isUndefinedOrNull)(u))return u;const f=h(u);if(typeof f<"u")return f;if(Array.isArray(u)){const S=[];for(const t of u)S.push(R(t,h,m));return S}if((0,_.isObject)(u)){if(m.has(u))throw new Error("Cannot clone recursive data-structure");m.add(u);const S={};for(const t in u)O.call(u,t)&&(S[t]=R(u[t],h,m));return m.delete(u),S}return u}function P(u,h,m=!0){return(0,_.isObject)(u)?((0,_.isObject)(h)&&Object.keys(h).forEach(f=>{f in u?m&&((0,_.isObject)(u[f])&&(0,_.isObject)(h[f])?P(u[f],h[f],m):u[f]=h[f]):u[f]=h[f]}),u):h}function d(u,h){if(u===h)return!0;if(u==null||h===null||h===void 0||typeof u!=typeof h||typeof u!="object"||Array.isArray(u)!==Array.isArray(h))return!1;let m,f;if(Array.isArray(u)){if(u.length!==h.length)return!1;for(m=0;m<u.length;m++)if(!d(u[m],h[m]))return!1}else{const S=[];for(f in u)S.push(f);S.sort();const t=[];for(f in h)t.push(f);if(t.sort(),!d(S,t))return!1;for(m=0;m<S.length;m++)if(!d(u[S[m]],h[S[m]]))return!1}return!0}function C(u){const h=new Set;return JSON.stringify(u,(m,f)=>{if((0,_.isObject)(f)||Array.isArray(f)){if(h.has(f))return"[Circular]";h.add(f)}return typeof f=="bigint"?`[BigInt ${f.toString()}]`:f})}function E(u,h){const m=Object.create(null);return!u||!h||Object.keys(h).forEach(S=>{const t=u[S],r=h[S];d(t,r)||(m[S]=r)}),m}function v(u,h){const m=h.toLowerCase(),f=Object.keys(u).find(S=>S.toLowerCase()===m);return f?u[f]:u[h]}function l(u,h){const m=Object.create(null);for(const[f,S]of Object.entries(u))h(f,S)&&(m[f]=S);return m}function c(u){let h=[];for(;Object.prototype!==u;)h=h.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return h}function p(u){const h=[];for(const m of c(u))typeof u[m]=="function"&&h.push(m);return h}function g(u,h){const m=S=>function(){const t=Array.prototype.slice.call(arguments,0);return h(S,t)},f={};for(const S of u)f[S]=m(S);return f}}),define(ae[32],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=U;const _=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function U(A){return _.test(A)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(R){for(let P=0;P<R.length;P++)R[P]=Math.floor(Math.random()*256);return R};const O=new Uint8Array(16),k=[];for(let R=0;R<256;R++)k.push(R.toString(16).padStart(2,"0"));return function(){A(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let P=0,d="";return d+=k[O[P++]],d+=k[O[P++]],d+=k[O[P++]],d+=k[O[P++]],d+="-",d+=k[O[P++]],d+=k[O[P++]],d+="-",d+=k[O[P++]],d+=k[O[P++]],d+="-",d+=k[O[P++]],d+=k[O[P++]],d+="-",d+=k[O[P++]],d+=k[O[P++]],d+=k[O[P++]],d+=k[O[P++]],d+=k[O[P++]],d+=k[O[P++]],d}}()}),define(ae[131],ce([0,1,37]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=O;const U=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(k){const R=k.replace(/\-/g,":").toLowerCase();return!U.has(R)}function O(){const k=(0,_.networkInterfaces)();for(const R in k){const P=k[R];if(P){for(const{mac:d}of P)if(A(d))return d}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ae[132],ce([0,1,273,15]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StreamSplitter=void 0;class A extends _.Transform{constructor(k){if(super(),typeof k=="number")this.splitter=k,this.spitterLen=1;else{const R=Buffer.isBuffer(k)?k:Buffer.from(k);this.splitter=R.length===1?R[0]:R,this.spitterLen=R.length}}_transform(k,R,P){this.buffer?this.buffer=Buffer.concat([this.buffer,k]):this.buffer=k;let d=0;for(;d<this.buffer.length;){const C=typeof this.splitter=="number"?this.buffer.indexOf(this.splitter,d):(0,U.binaryIndexOf)(this.buffer,this.splitter,d);if(C===-1)break;this.push(this.buffer.slice(d,C+this.spitterLen)),d=C+this.spitterLen}this.buffer=d===this.buffer.length?void 0:this.buffer.slice(d),P()}_flush(k){this.buffer&&this.push(this.buffer),k()}}e.StreamSplitter=A}),define(ae[133],ce([0,1,64]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BROWSER_RESTRICTED_PORTS=void 0,e.findFreePort=U,e.findFreePortFaster=O;function U(R,P,d,C=1){let E=!1;return new Promise(v=>{const l=setTimeout(()=>{if(!E)return E=!0,v(0)},d);A(R,P,C,c=>{if(!E)return E=!0,clearTimeout(l),v(c)})})}function A(R,P,d,C){if(P===0)return C(0);const E=new _.Socket;E.once("connect",()=>(k(E),A(R+d,P-1,d,C))),E.once("data",()=>{}),E.once("error",v=>(k(E),v.code!=="ECONNREFUSED"?A(R+d,P-1,d,C):C(R))),E.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(R,P,d,C="127.0.0.1"){let E=!1,v,l=1;const c=_.createServer({pauseOnConnect:!0});function p(g,u){E||(E=!0,c.removeAllListeners(),c.close(),v&&clearTimeout(v),u(g))}return new Promise(g=>{v=setTimeout(()=>{p(0,g)},d),c.on("listening",()=>{p(R,g)}),c.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&l<P?(R++,l++,c.listen(R,C)):p(0,g)}),c.on("close",()=>{p(0,g)}),c.listen(R,C)})}function k(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(P){console.error(P)}}}),define(ae[134],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=_;function _(U){return!!U.parentPort}}),define(ae[135],ce([11,10]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ae[65],ce([0,1,135]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=d,e.getDurationString=C,e.toLocalISOString=E;const U=60,A=U*60,O=A*24,k=O*7,R=O*30,P=O*365;function d(v,l,c,p){typeof v!="number"&&(v=v.getTime());const g=Math.round((new Date().getTime()-v)/1e3);if(g<-30)return(0,_.localize)(0,null,d(new Date().getTime()+g*1e3,!1));if(!p&&g<30)return(0,_.localize)(1,null);let u;return g<U?(u=g,l?u===1?c?(0,_.localize)(2,null,u):(0,_.localize)(3,null,u):c?(0,_.localize)(4,null,u):(0,_.localize)(5,null,u):u===1?c?(0,_.localize)(6,null,u):(0,_.localize)(7,null,u):c?(0,_.localize)(8,null,u):(0,_.localize)(9,null,u)):g<A?(u=Math.floor(g/U),l?u===1?c?(0,_.localize)(10,null,u):(0,_.localize)(11,null,u):c?(0,_.localize)(12,null,u):(0,_.localize)(13,null,u):u===1?c?(0,_.localize)(14,null,u):(0,_.localize)(15,null,u):c?(0,_.localize)(16,null,u):(0,_.localize)(17,null,u)):g<O?(u=Math.floor(g/A),l?u===1?c?(0,_.localize)(18,null,u):(0,_.localize)(19,null,u):c?(0,_.localize)(20,null,u):(0,_.localize)(21,null,u):u===1?c?(0,_.localize)(22,null,u):(0,_.localize)(23,null,u):c?(0,_.localize)(24,null,u):(0,_.localize)(25,null,u)):g<k?(u=Math.floor(g/O),l?u===1?(0,_.localize)(26,null,u):(0,_.localize)(27,null,u):u===1?(0,_.localize)(28,null,u):(0,_.localize)(29,null,u)):g<R?(u=Math.floor(g/k),l?u===1?c?(0,_.localize)(30,null,u):(0,_.localize)(31,null,u):c?(0,_.localize)(32,null,u):(0,_.localize)(33,null,u):u===1?c?(0,_.localize)(34,null,u):(0,_.localize)(35,null,u):c?(0,_.localize)(36,null,u):(0,_.localize)(37,null,u)):g<P?(u=Math.floor(g/R),l?u===1?c?(0,_.localize)(38,null,u):(0,_.localize)(39,null,u):c?(0,_.localize)(40,null,u):(0,_.localize)(41,null,u):u===1?c?(0,_.localize)(42,null,u):(0,_.localize)(43,null,u):c?(0,_.localize)(44,null,u):(0,_.localize)(45,null,u)):(u=Math.floor(g/P),l?u===1?c?(0,_.localize)(46,null,u):(0,_.localize)(47,null,u):c?(0,_.localize)(48,null,u):(0,_.localize)(49,null,u):u===1?c?(0,_.localize)(50,null,u):(0,_.localize)(51,null,u):c?(0,_.localize)(52,null,u):(0,_.localize)(53,null,u))}function C(v,l){const c=Math.abs(v/1e3);return c<1?l?(0,_.localize)(54,null,v):(0,_.localize)(55,null,v):c<U?l?(0,_.localize)(56,null,Math.round(v)/1e3):(0,_.localize)(57,null,Math.round(v)/1e3):c<A?l?(0,_.localize)(58,null,Math.round(v/(1e3*U))):(0,_.localize)(59,null,Math.round(v/(1e3*U))):c<O?l?(0,_.localize)(60,null,Math.round(v/(1e3*A))):(0,_.localize)(61,null,Math.round(v/(1e3*A))):(0,_.localize)(62,null,Math.round(v/(1e3*O)))}function E(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ae[136],ce([11,10]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ae[38],ce([0,1,17,13,136]),function(ne,e,_,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=P,e.isErrorWithActions=d,e.createErrorWithActions=C;function O(E,v){return v&&(E.stack||E.stacktrace)?A.localize(0,null,R(E),k(E.stack)||k(E.stacktrace)):R(E)}function k(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?A.localize(1,null,E.message):E.message||A.localize(2,null)}function P(E=null,v=!1){if(!E)return A.localize(3,null);if(Array.isArray(E)){const l=_.coalesce(E),c=P(l[0],v);return l.length>1?A.localize(4,null,c,l.length):c}if(U.isString(E))return E;if(E.detail){const l=E.detail;if(l.error)return O(l.error,v);if(l.exception)return O(l.exception,v)}return E.stack?O(E,v):E.message?E.message:A.localize(5,null)}function d(E){const v=E;return v instanceof Error&&Array.isArray(v.actions)}function C(E,v){let l;return typeof E=="string"?l=new Error(E):l=E,l.actions=v,l}}),define(ae[137],ce([11,10]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(ae[138],ce([0,1,137]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=U;function U(A){switch(A){case 1:return(0,_.localize)(0,null);case 2:return(0,_.localize)(1,null);case 3:return(0,_.localize)(2,null);case 4:return(0,_.localize)(3,null);case 5:return(0,_.localize)(4,null);case 6:return(0,_.localize)(5,null);case 7:return(0,_.localize)(6,null);case 8:return(0,_.localize)(7,null);case 9:return(0,_.localize)(8,null);default:return""}}}),define(ae[139],ce([11,10]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(ae[5],ce([0,1,139]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=r,e.isLittleEndian=y,e.isBigSurOrNewer=I,e.LANGUAGE_DEFAULT="en";let U=!1,A=!1,O=!1,k=!1,R=!1,P=!1,d=!1,C=!1,E=!1,v=!1,l,c=e.LANGUAGE_DEFAULT,p=e.LANGUAGE_DEFAULT,g,u;const h=globalThis;let m;typeof h.vscode<"u"&&typeof h.vscode.process<"u"?m=h.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(m=process);const f=typeof m?.versions?.electron=="string",S=f&&m?.type==="renderer";if(typeof m=="object"){U=m.platform==="win32",A=m.platform==="darwin",O=m.platform==="linux",k=O&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,d=f,E=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=e.LANGUAGE_DEFAULT,c=e.LANGUAGE_DEFAULT;const w=m.env.VSCODE_NLS_CONFIG;if(w)try{const b=JSON.parse(w),D=b.availableLanguages["*"];l=b.locale,p=b.osLocale,c=D||e.LANGUAGE_DEFAULT,g=b._translationsConfigFile}catch{}R=!0}else typeof navigator=="object"&&!S?(u=navigator.userAgent,U=u.indexOf("Windows")>=0,A=u.indexOf("Macintosh")>=0,C=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=u.indexOf("Linux")>=0,v=u?.indexOf("Mobi")>=0,P=!0,l=_.getConfiguredDefaultLocale(_.localize(0,null))||e.LANGUAGE_DEFAULT,c=l,p=navigator.language):console.error("Unable to resolve platform.");var t;(function(w){w[w.Web=0]="Web",w[w.Mac=1]="Mac",w[w.Linux=2]="Linux",w[w.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(w){switch(w){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let n=0;A?n=1:U?n=3:O&&(n=2),e.isWindows=U,e.isMacintosh=A,e.isLinux=O,e.isLinuxSnap=k,e.isNative=R,e.isElectron=d,e.isWeb=P,e.isWebWorker=P&&typeof h.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?h.origin:void 0,e.isIOS=C,e.isMobile=v,e.isCI=E,e.platform=n,e.userAgent=u,e.language=c;var s;(function(w){function b(){return e.language}w.value=b;function D(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}w.isDefaultVariant=D;function L(){return e.language==="en"}w.isDefault=L})(s||(e.Language=s={})),e.locale=l,e.platformLocale=p,e.translationsConfigFile=g,e.setTimeout0IsFaster=typeof h.postMessage=="function"&&!h.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const w=[];h.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let L=0,N=w.length;L<N;L++){const F=w[L];if(F.id===D.data.vscodeScheduleAsyncWork){w.splice(L,1),F.callback();return}}});let b=0;return D=>{const L=++b;w.push({id:L,callback:D}),h.postMessage({vscodeScheduleAsyncWork:L},"*")}}return w=>setTimeout(w)})();var i;(function(w){w[w.Windows=1]="Windows",w[w.Macintosh=2]="Macintosh",w[w.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=A||C?2:U?1:3;let o=!0,a=!1;function y(){if(!a){a=!0;const w=new Uint8Array(2);w[0]=1,w[1]=2,o=new Uint16Array(w.buffer)[0]===513}return o}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function I(w){return parseFloat(w)>=20}}),define(ae[36],ce([0,1,5]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let U;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const O=A.process;U={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"?U={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:U={get platform(){return _.isWindows?"win32":_.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=U.cwd,e.env=U.env,e.platform=U.platform,e.arch=U.arch}),define(ae[140],ce([0,1,36]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getDesktopEnvironment=k;var U;(function(R){R.UNKNOWN="UNKNOWN",R.CINNAMON="CINNAMON",R.DEEPIN="DEEPIN",R.GNOME="GNOME",R.KDE3="KDE3",R.KDE4="KDE4",R.KDE5="KDE5",R.KDE6="KDE6",R.PANTHEON="PANTHEON",R.UNITY="UNITY",R.XFCE="XFCE",R.UKUI="UKUI",R.LXQT="LXQT"})(U||(U={}));const A="XDG_CURRENT_DESKTOP",O="KDE_SESSION_VERSION";function k(){const R=_.env[A];if(R){const d=R.split(":").map(C=>C.trim()).filter(C=>C.length>0);for(const C of d)switch(C){case"Unity":{const E=_.env.DESKTOP_SESSION;return E&&E.includes("gnome-fallback")?U.GNOME:U.UNITY}case"Deepin":return U.DEEPIN;case"GNOME":return U.GNOME;case"X-Cinnamon":return U.CINNAMON;case"KDE":{const E=_.env[O];return E==="5"?U.KDE5:E==="6"?U.KDE6:U.KDE4}case"Pantheon":return U.PANTHEON;case"XFCE":return U.XFCE;case"UKUI":return U.UKUI;case"LXQt":return U.LXQT}}const P=_.env.DESKTOP_SESSION;if(P)switch(P){case"deepin":return U.DEEPIN;case"gnome":case"mate":return U.GNOME;case"kde4":case"kde-plasma":return U.KDE4;case"kde":return O in _.env?U.KDE4:U.KDE3;case"xfce":case"xubuntu":return U.XFCE;case"ukui":return U.UKUI}return"GNOME_DESKTOP_SESSION_ID"in _.env?U.GNOME:"KDE_FULL_SESSION"in _.env?O in _.env?U.KDE4:U.KDE3:U.UNKNOWN}}),define(ae[14],ce([0,1,36]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const U=65,A=97,O=90,k=122,R=46,P=47,d=92,C=58,E=63;class v extends Error{constructor(r,n,s){let i;typeof n=="string"&&n.indexOf("not ")===0?(i="must not be",n=n.replace(/^not /,"")):i="must be";const o=r.indexOf(".")!==-1?"property":"argument";let a=`The "${r}" ${o} ${i} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function l(t,r){if(t===null||typeof t!="object")throw new v(r,"Object",t)}function c(t,r){if(typeof t!="string")throw new v(r,"string",t)}const p=_.platform==="win32";function g(t){return t===P||t===d}function u(t){return t===P}function h(t){return t>=U&&t<=O||t>=A&&t<=k}function m(t,r,n,s){let i="",o=0,a=-1,y=0,I=0;for(let w=0;w<=t.length;++w){if(w<t.length)I=t.charCodeAt(w);else{if(s(I))break;I=P}if(s(I)){if(!(a===w-1||y===1))if(y===2){if(i.length<2||o!==2||i.charCodeAt(i.length-1)!==R||i.charCodeAt(i.length-2)!==R){if(i.length>2){const b=i.lastIndexOf(n);b===-1?(i="",o=0):(i=i.slice(0,b),o=i.length-1-i.lastIndexOf(n)),a=w,y=0;continue}else if(i.length!==0){i="",o=0,a=w,y=0;continue}}r&&(i+=i.length>0?`${n}..`:"..",o=2)}else i.length>0?i+=`${n}${t.slice(a+1,w)}`:i=t.slice(a+1,w),o=w-a-1;a=w,y=0}else I===R&&y!==-1?++y:y=-1}return i}function f(t,r){l(r,"pathObject");const n=r.dir||r.root,s=r.base||`${r.name||""}${r.ext||""}`;return n?n===r.root?`${n}${s}`:`${n}${t}${s}`:s}e.win32={resolve(...t){let r="",n="",s=!1;for(let i=t.length-1;i>=-1;i--){let o;if(i>=0){if(o=t[i],c(o,"path"),o.length===0)continue}else r.length===0?o=_.cwd():(o=_.env[`=${r}`]||_.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==r.toLowerCase()&&o.charCodeAt(2)===d)&&(o=`${r}\\`));const a=o.length;let y=0,I="",w=!1;const b=o.charCodeAt(0);if(a===1)g(b)&&(y=1,w=!0);else if(g(b))if(w=!0,g(o.charCodeAt(1))){let D=2,L=D;for(;D<a&&!g(o.charCodeAt(D));)D++;if(D<a&&D!==L){const N=o.slice(L,D);for(L=D;D<a&&g(o.charCodeAt(D));)D++;if(D<a&&D!==L){for(L=D;D<a&&!g(o.charCodeAt(D));)D++;(D===a||D!==L)&&(I=`\\\\${N}\\${o.slice(L,D)}`,y=D)}}}else y=1;else h(b)&&o.charCodeAt(1)===C&&(I=o.slice(0,2),y=2,a>2&&g(o.charCodeAt(2))&&(w=!0,y=3));if(I.length>0)if(r.length>0){if(I.toLowerCase()!==r.toLowerCase())continue}else r=I;if(s){if(r.length>0)break}else if(n=`${o.slice(y)}\\${n}`,s=w,w&&r.length>0)break}return n=m(n,!s,"\\",g),s?`${r}\\${n}`:`${r}${n}`||"."},normalize(t){c(t,"path");const r=t.length;if(r===0)return".";let n=0,s,i=!1;const o=t.charCodeAt(0);if(r===1)return u(o)?"\\":t;if(g(o))if(i=!0,g(t.charCodeAt(1))){let y=2,I=y;for(;y<r&&!g(t.charCodeAt(y));)y++;if(y<r&&y!==I){const w=t.slice(I,y);for(I=y;y<r&&g(t.charCodeAt(y));)y++;if(y<r&&y!==I){for(I=y;y<r&&!g(t.charCodeAt(y));)y++;if(y===r)return`\\\\${w}\\${t.slice(I)}\\`;y!==I&&(s=`\\\\${w}\\${t.slice(I,y)}`,n=y)}}}else n=1;else h(o)&&t.charCodeAt(1)===C&&(s=t.slice(0,2),n=2,r>2&&g(t.charCodeAt(2))&&(i=!0,n=3));let a=n<r?m(t.slice(n),!i,"\\",g):"";return a.length===0&&!i&&(a="."),a.length>0&&g(t.charCodeAt(r-1))&&(a+="\\"),s===void 0?i?`\\${a}`:a:i?`${s}\\${a}`:`${s}${a}`},isAbsolute(t){c(t,"path");const r=t.length;if(r===0)return!1;const n=t.charCodeAt(0);return g(n)||r>2&&h(n)&&t.charCodeAt(1)===C&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,n;for(let o=0;o<t.length;++o){const a=t[o];c(a,"path"),a.length>0&&(r===void 0?r=n=a:r+=`\\${a}`)}if(r===void 0)return".";let s=!0,i=0;if(typeof n=="string"&&g(n.charCodeAt(0))){++i;const o=n.length;o>1&&g(n.charCodeAt(1))&&(++i,o>2&&(g(n.charCodeAt(2))?++i:s=!1))}if(s){for(;i<r.length&&g(r.charCodeAt(i));)i++;i>=2&&(r=`\\${r.slice(i)}`)}return e.win32.normalize(r)},relative(t,r){if(c(t,"from"),c(r,"to"),t===r)return"";const n=e.win32.resolve(t),s=e.win32.resolve(r);if(n===s||(t=n.toLowerCase(),r=s.toLowerCase(),t===r))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===d;)i++;let o=t.length;for(;o-1>i&&t.charCodeAt(o-1)===d;)o--;const a=o-i;let y=0;for(;y<r.length&&r.charCodeAt(y)===d;)y++;let I=r.length;for(;I-1>y&&r.charCodeAt(I-1)===d;)I--;const w=I-y,b=a<w?a:w;let D=-1,L=0;for(;L<b;L++){const F=t.charCodeAt(i+L);if(F!==r.charCodeAt(y+L))break;F===d&&(D=L)}if(L!==b){if(D===-1)return s}else{if(w>b){if(r.charCodeAt(y+L)===d)return s.slice(y+L+1);if(L===2)return s.slice(y+L)}a>b&&(t.charCodeAt(i+L)===d?D=L:L===2&&(D=3)),D===-1&&(D=0)}let N="";for(L=i+D+1;L<=o;++L)(L===o||t.charCodeAt(L)===d)&&(N+=N.length===0?"..":"\\..");return y+=D,N.length>0?`${N}${s.slice(y,I)}`:(s.charCodeAt(y)===d&&++y,s.slice(y,I))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.win32.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===d){if(r.charCodeAt(1)===d){const n=r.charCodeAt(2);if(n!==E&&n!==R)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(h(r.charCodeAt(0))&&r.charCodeAt(1)===C&&r.charCodeAt(2)===d)return`\\\\?\\${r}`;return t},dirname(t){c(t,"path");const r=t.length;if(r===0)return".";let n=-1,s=0;const i=t.charCodeAt(0);if(r===1)return g(i)?t:".";if(g(i)){if(n=s=1,g(t.charCodeAt(1))){let y=2,I=y;for(;y<r&&!g(t.charCodeAt(y));)y++;if(y<r&&y!==I){for(I=y;y<r&&g(t.charCodeAt(y));)y++;if(y<r&&y!==I){for(I=y;y<r&&!g(t.charCodeAt(y));)y++;if(y===r)return t;y!==I&&(n=s=y+1)}}}}else h(i)&&t.charCodeAt(1)===C&&(n=r>2&&g(t.charCodeAt(2))?3:2,s=n);let o=-1,a=!0;for(let y=r-1;y>=s;--y)if(g(t.charCodeAt(y))){if(!a){o=y;break}}else a=!1;if(o===-1){if(n===-1)return".";o=n}return t.slice(0,o)},basename(t,r){r!==void 0&&c(r,"ext"),c(t,"path");let n=0,s=-1,i=!0,o;if(t.length>=2&&h(t.charCodeAt(0))&&t.charCodeAt(1)===C&&(n=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let a=r.length-1,y=-1;for(o=t.length-1;o>=n;--o){const I=t.charCodeAt(o);if(g(I)){if(!i){n=o+1;break}}else y===-1&&(i=!1,y=o+1),a>=0&&(I===r.charCodeAt(a)?--a===-1&&(s=o):(a=-1,s=y))}return n===s?s=y:s===-1&&(s=t.length),t.slice(n,s)}for(o=t.length-1;o>=n;--o)if(g(t.charCodeAt(o))){if(!i){n=o+1;break}}else s===-1&&(i=!1,s=o+1);return s===-1?"":t.slice(n,s)},extname(t){c(t,"path");let r=0,n=-1,s=0,i=-1,o=!0,a=0;t.length>=2&&t.charCodeAt(1)===C&&h(t.charCodeAt(0))&&(r=s=2);for(let y=t.length-1;y>=r;--y){const I=t.charCodeAt(y);if(g(I)){if(!o){s=y+1;break}continue}i===-1&&(o=!1,i=y+1),I===R?n===-1?n=y:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||i===-1||a===0||a===1&&n===i-1&&n===s+1?"":t.slice(n,i)},format:f.bind(null,"\\"),parse(t){c(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const n=t.length;let s=0,i=t.charCodeAt(0);if(n===1)return g(i)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(g(i)){if(s=1,g(t.charCodeAt(1))){let D=2,L=D;for(;D<n&&!g(t.charCodeAt(D));)D++;if(D<n&&D!==L){for(L=D;D<n&&g(t.charCodeAt(D));)D++;if(D<n&&D!==L){for(L=D;D<n&&!g(t.charCodeAt(D));)D++;D===n?s=D:D!==L&&(s=D+1)}}}}else if(h(i)&&t.charCodeAt(1)===C){if(n<=2)return r.root=r.dir=t,r;if(s=2,g(t.charCodeAt(2))){if(n===3)return r.root=r.dir=t,r;s=3}}s>0&&(r.root=t.slice(0,s));let o=-1,a=s,y=-1,I=!0,w=t.length-1,b=0;for(;w>=s;--w){if(i=t.charCodeAt(w),g(i)){if(!I){a=w+1;break}continue}y===-1&&(I=!1,y=w+1),i===R?o===-1?o=w:b!==1&&(b=1):o!==-1&&(b=-1)}return y!==-1&&(o===-1||b===0||b===1&&o===y-1&&o===a+1?r.base=r.name=t.slice(a,y):(r.name=t.slice(a,o),r.base=t.slice(a,y),r.ext=t.slice(o,y))),a>0&&a!==s?r.dir=t.slice(0,a-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const S=(()=>{if(p){const t=/\\/g;return()=>{const r=_.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>_.cwd()})();e.posix={resolve(...t){let r="",n=!1;for(let s=t.length-1;s>=-1&&!n;s--){const i=s>=0?t[s]:S();c(i,"path"),i.length!==0&&(r=`${i}/${r}`,n=i.charCodeAt(0)===P)}return r=m(r,!n,"/",u),n?`/${r}`:r.length>0?r:"."},normalize(t){if(c(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===P,n=t.charCodeAt(t.length-1)===P;return t=m(t,!r,"/",u),t.length===0?r?"/":n?"./":".":(n&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return c(t,"path"),t.length>0&&t.charCodeAt(0)===P},join(...t){if(t.length===0)return".";let r;for(let n=0;n<t.length;++n){const s=t[n];c(s,"path"),s.length>0&&(r===void 0?r=s:r+=`/${s}`)}return r===void 0?".":e.posix.normalize(r)},relative(t,r){if(c(t,"from"),c(r,"to"),t===r||(t=e.posix.resolve(t),r=e.posix.resolve(r),t===r))return"";const n=1,s=t.length,i=s-n,o=1,a=r.length-o,y=i<a?i:a;let I=-1,w=0;for(;w<y;w++){const D=t.charCodeAt(n+w);if(D!==r.charCodeAt(o+w))break;D===P&&(I=w)}if(w===y)if(a>y){if(r.charCodeAt(o+w)===P)return r.slice(o+w+1);if(w===0)return r.slice(o+w)}else i>y&&(t.charCodeAt(n+w)===P?I=w:w===0&&(I=0));let b="";for(w=n+I+1;w<=s;++w)(w===s||t.charCodeAt(w)===P)&&(b+=b.length===0?"..":"/..");return`${b}${r.slice(o+I)}`},toNamespacedPath(t){return t},dirname(t){if(c(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===P;let n=-1,s=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===P){if(!s){n=i;break}}else s=!1;return n===-1?r?"/":".":r&&n===1?"//":t.slice(0,n)},basename(t,r){r!==void 0&&c(r,"ext"),c(t,"path");let n=0,s=-1,i=!0,o;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let a=r.length-1,y=-1;for(o=t.length-1;o>=0;--o){const I=t.charCodeAt(o);if(I===P){if(!i){n=o+1;break}}else y===-1&&(i=!1,y=o+1),a>=0&&(I===r.charCodeAt(a)?--a===-1&&(s=o):(a=-1,s=y))}return n===s?s=y:s===-1&&(s=t.length),t.slice(n,s)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===P){if(!i){n=o+1;break}}else s===-1&&(i=!1,s=o+1);return s===-1?"":t.slice(n,s)},extname(t){c(t,"path");let r=-1,n=0,s=-1,i=!0,o=0;for(let a=t.length-1;a>=0;--a){const y=t.charCodeAt(a);if(y===P){if(!i){n=a+1;break}continue}s===-1&&(i=!1,s=a+1),y===R?r===-1?r=a:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||s===-1||o===0||o===1&&r===s-1&&r===n+1?"":t.slice(r,s)},format:f.bind(null,"/"),parse(t){c(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const n=t.charCodeAt(0)===P;let s;n?(r.root="/",s=1):s=0;let i=-1,o=0,a=-1,y=!0,I=t.length-1,w=0;for(;I>=s;--I){const b=t.charCodeAt(I);if(b===P){if(!y){o=I+1;break}continue}a===-1&&(y=!1,a=I+1),b===R?i===-1?i=I:w!==1&&(w=1):i!==-1&&(w=-1)}if(a!==-1){const b=o===0&&n?1:o;i===-1||w===0||w===1&&i===a-1&&i===o+1?r.base=r.name=t.slice(b,a):(r.name=t.slice(b,i),r.base=t.slice(b,a),r.ext=t.slice(i,a))}return o>0?r.dir=t.slice(0,o-1):n&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p?e.win32.normalize:e.posix.normalize,e.isAbsolute=p?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p?e.win32.join:e.posix.join,e.resolve=p?e.win32.resolve:e.posix.resolve,e.relative=p?e.win32.relative:e.posix.relative,e.dirname=p?e.win32.dirname:e.posix.dirname,e.basename=p?e.win32.basename:e.posix.basename,e.extname=p?e.win32.extname:e.posix.extname,e.format=p?e.win32.format:e.posix.format,e.parse=p?e.win32.parse:e.posix.parse,e.toNamespacedPath=p?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p?e.win32.sep:e.posix.sep,e.delimiter=p?e.win32.delimiter:e.posix.delimiter}),define(ae[40],ce([0,1,14,5,27,13]),function(ne,e,_,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=k,e.toSlashes=R,e.toPosixPath=P,e.getRoot=d,e.isUNC=C,e.isValidBasename=c,e.isEqual=p,e.isEqualOrParent=g,e.isWindowsDriveLetter=u,e.sanitizeFilePath=h,e.removeTrailingPathSeparator=m,e.isRootOrDriveLetter=f,e.hasDriveLetter=S,e.getDriveLetter=t,e.indexOfPath=r,e.parseLineAndColumnAware=n,e.randomPath=o;function k(a){return a===47||a===92}function R(a){return a.replace(/[\\/]/g,_.posix.sep)}function P(a){return a.indexOf("/")===-1&&(a=R(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}function d(a,y=_.posix.sep){if(!a)return"";const I=a.length,w=a.charCodeAt(0);if(k(w)){if(k(a.charCodeAt(1))&&!k(a.charCodeAt(2))){let D=3;const L=D;for(;D<I&&!k(a.charCodeAt(D));D++);if(L!==D&&!k(a.charCodeAt(D+1))){for(D+=1;D<I;D++)if(k(a.charCodeAt(D)))return a.slice(0,D+1).replace(/[\\/]/g,y)}}return y}else if(u(w)&&a.charCodeAt(1)===58)return k(a.charCodeAt(2))?a.slice(0,2)+y:a.slice(0,2);let b=a.indexOf("://");if(b!==-1){for(b+=3;b<I;b++)if(k(a.charCodeAt(b)))return a.slice(0,b+1)}return""}function C(a){if(!U.isWindows||!a||a.length<5)return!1;let y=a.charCodeAt(0);if(y!==92||(y=a.charCodeAt(1),y!==92))return!1;let I=2;const w=I;for(;I<a.length&&(y=a.charCodeAt(I),y!==92);I++);return!(w===I||(y=a.charCodeAt(I+1),isNaN(y)||y===92))}const E=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(a,y=U.isWindows){const I=y?E:v;return!(!a||a.length===0||/^\s+$/.test(a)||(I.lastIndex=0,I.test(a))||y&&l.test(a)||a==="."||a===".."||y&&a[a.length-1]==="."||y&&a.length!==a.trim().length||a.length>255)}function p(a,y,I){const w=a===y;return!I||w?w:!a||!y?!1:(0,A.equalsIgnoreCase)(a,y)}function g(a,y,I,w=_.sep){if(a===y)return!0;if(!a||!y||y.length>a.length)return!1;if(I){if(!(0,A.startsWithIgnoreCase)(a,y))return!1;if(y.length===a.length)return!0;let D=y.length;return y.charAt(y.length-1)===w&&D--,a.charAt(D)===w}return y.charAt(y.length-1)!==w&&(y+=w),a.indexOf(y)===0}function u(a){return a>=65&&a<=90||a>=97&&a<=122}function h(a,y){return U.isWindows&&a.endsWith(":")&&(a+=_.sep),(0,_.isAbsolute)(a)||(a=(0,_.join)(y,a)),a=(0,_.normalize)(a),m(a)}function m(a){return U.isWindows?(a=(0,A.rtrim)(a,_.sep),a.endsWith(":")&&(a+=_.sep)):(a=(0,A.rtrim)(a,_.sep),a||(a=_.sep)),a}function f(a){const y=(0,_.normalize)(a);return U.isWindows?a.length>3?!1:S(y)&&(a.length===2||y.charCodeAt(2)===92):y===_.posix.sep}function S(a,y=U.isWindows){return y?u(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}function t(a,y=U.isWindows){return S(a,y)?a[0]:void 0}function r(a,y,I){return y.length>a.length?-1:a===y?0:(I&&(a=a.toLowerCase(),y=y.toLowerCase()),a.indexOf(y))}function n(a){const y=a.split(":");let I,w,b;for(const D of y){const L=Number(D);(0,O.isNumber)(L)?w===void 0?w=L:b===void 0&&(b=L):I=I?[I,D].join(":"):D}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:w!==void 0?w:void 0,column:b!==void 0?b:w!==void 0?1:void 0}}const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(a,y,I=8){let w="";for(let D=0;D<I;D++){let L;D===0&&U.isWindows&&!y&&(I===3||I===4)?L=i:L=s,w+=L.charAt(Math.floor(Math.random()*L.length))}let b;return y?b=`${y}-${w}`:b=w,a?(0,_.join)(a,b):b}}),define(ae[141],ce([0,1,14]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Mimes=void 0,e.getMediaOrTextMime=O,e.getMediaMime=k,e.getExtensionForMimeType=R,e.normalizeMimeType=d,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const U={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(C){const E=(0,_.extname)(C),v=U[E.toLowerCase()];return v!==void 0?v:k(C)}function k(C){const E=(0,_.extname)(C);return A[E.toLowerCase()]}function R(C){for(const E in A)if(A[E]===C)return E}const P=/^(.+)\/(.+?)(;.+)?$/;function d(C,E){const v=P.exec(C);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:E?void 0:C}}),define(ae[89],ce([0,1,5]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=O,e.removeDangerousEnvVariables=k;var U;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(U||(e.Source=U={}));var A;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function O(R,...P){const d=P.reduce((v,l)=>(v[l]=!0,v),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(v=>!d[v]).forEach(v=>{for(let l=0;l<C.length;l++)if(v.search(C[l])!==-1){delete R[v];break}})}function k(R){R&&(delete R.DEBUG,_.isMacintosh&&delete R.DYLD_LIBRARY_PATH,_.isLinux&&delete R.LD_PRELOAD)}}),define(ae[8],ce([0,1,14,5]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=c,e.uriToFsPath=f;const A=/^\w[\w\d+.-]*$/,O=/^\//,k=/^\/\//;function R(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!A.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!O.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(s,i){return!s&&!i?"file":s}function d(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==E&&(i=E+i):i=E;break}return i}const C="",E="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(i){return i instanceof l?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,o,a,y,I,w=!1){typeof i=="object"?(this.scheme=i.scheme||C,this.authority=i.authority||C,this.path=i.path||C,this.query=i.query||C,this.fragment=i.fragment||C):(this.scheme=P(i,w),this.authority=o||C,this.path=d(this.scheme,a||C),this.query=y||C,this.fragment=I||C,R(this,w))}get fsPath(){return f(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:a,path:y,query:I,fragment:w}=i;return o===void 0?o=this.scheme:o===null&&(o=C),a===void 0?a=this.authority:a===null&&(a=C),y===void 0?y=this.path:y===null&&(y=C),I===void 0?I=this.query:I===null&&(I=C),w===void 0?w=this.fragment:w===null&&(w=C),o===this.scheme&&a===this.authority&&y===this.path&&I===this.query&&w===this.fragment?this:new g(o,a,y,I,w)}static parse(i,o=!1){const a=v.exec(i);return a?new g(a[2]||C,n(a[4]||C),n(a[5]||C),n(a[7]||C),n(a[9]||C),o):new g(C,C,C,C,C)}static file(i){let o=C;if(U.isWindows&&(i=i.replace(/\\/g,E)),i[0]===E&&i[1]===E){const a=i.indexOf(E,2);a===-1?(o=i.substring(2),i=E):(o=i.substring(2,a),i=i.substring(a)||E)}return new g("file",o,i,C,C)}static from(i,o){return new g(i.scheme,i.authority,i.path,i.query,i.fragment,o)}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return U.isWindows&&i.scheme==="file"?a=l.file(_.win32.join(f(i,!0),...o)).path:a=_.posix.join(i.path,...o),i.with({path:a})}toString(i=!1){return S(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof l)return i;{const o=new g(i);return o._formatted=i.external??null,o._fsPath=i._sep===p?i.fsPath??null:null,o}}else return i}}e.URI=l;function c(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}const p=U.isWindows?1:void 0;class g extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(i=!1){return i?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=p),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const u={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function h(s,i,o){let a,y=-1;for(let I=0;I<s.length;I++){const w=s.charCodeAt(I);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||i&&w===47||o&&w===91||o&&w===93||o&&w===58)y!==-1&&(a+=encodeURIComponent(s.substring(y,I)),y=-1),a!==void 0&&(a+=s.charAt(I));else{a===void 0&&(a=s.substr(0,I));const b=u[w];b!==void 0?(y!==-1&&(a+=encodeURIComponent(s.substring(y,I)),y=-1),a+=b):y===-1&&(y=I)}}return y!==-1&&(a+=encodeURIComponent(s.substring(y))),a!==void 0?a:s}function m(s){let i;for(let o=0;o<s.length;o++){const a=s.charCodeAt(o);a===35||a===63?(i===void 0&&(i=s.substr(0,o)),i+=u[a]):i!==void 0&&(i+=s[o])}return i!==void 0?i:s}function f(s,i){let o;return s.authority&&s.path.length>1&&s.scheme==="file"?o=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?o=s.path.substr(1):o=s.path[1].toLowerCase()+s.path.substr(2):o=s.path,U.isWindows&&(o=o.replace(/\//g,"\\")),o}function S(s,i){const o=i?m:h;let a="",{scheme:y,authority:I,path:w,query:b,fragment:D}=s;if(y&&(a+=y,a+=":"),(I||y==="file")&&(a+=E,a+=E),I){let L=I.indexOf("@");if(L!==-1){const N=I.substr(0,L);I=I.substr(L+1),L=N.lastIndexOf(":"),L===-1?a+=o(N,!1,!1):(a+=o(N.substr(0,L),!1,!1),a+=":",a+=o(N.substr(L+1),!1,!0)),a+="@"}I=I.toLowerCase(),L=I.lastIndexOf(":"),L===-1?a+=o(I,!1,!0):(a+=o(I.substr(0,L),!1,!0),a+=I.substr(L))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const L=w.charCodeAt(1);L>=65&&L<=90&&(w=`/${String.fromCharCode(L+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const L=w.charCodeAt(0);L>=65&&L<=90&&(w=`${String.fromCharCode(L+32)}:${w.substr(2)}`)}a+=o(w,!0,!1)}return b&&(a+="?",a+=o(b,!1,!1)),D&&(a+="#",a+=i?D:h(D,!1,!1)),a}function t(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+t(s.substr(3)):s}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(r)?s.replace(r,i=>t(i)):s}}),define(ae[142],ce([0,1,8]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=U,e.parse=A,e.getFirstFrame=O,e.log=R;function U(d){const C=d;return C&&typeof C.type=="string"&&typeof C.severity=="string"}function A(d){const C=[];let E;try{const v=JSON.parse(d.arguments),l=v[v.length-1];l&&l.__$stack&&(v.pop(),E=l.__$stack),C.push(...v)}catch{C.push("Unable to log remote console arguments",d.arguments)}return{args:C,stack:E}}function O(d){if(typeof d!="string")return O(A(d).stack);const C=d;if(C){const E=k(C),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(v&&v.length===4)return{uri:_.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}function k(d){if(!d)return d;const C=d.indexOf(`
`);return C===-1?d:d.substring(0,C)}function R(d,C){const{args:E,stack:v}=A(d),l=typeof E[0]=="string"&&E.length===1;let c=k(v);c&&(c=`(${c.trim()})`);let p=[];if(typeof E[0]=="string"?c&&l?p=[`%c[${C}] %c${E[0]} %c${c}`,P("blue"),P(""),P("grey")]:p=[`%c[${C}] %c${E[0]}`,P("blue"),P(""),...E.slice(1)]:p=[`%c[${C}]%`,P("blue"),...E],c&&!l&&p.push(c),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,p)}function P(d){return`color: ${d}`}}),define(ae[66],ce([0,1,15,8]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=A,e.parse=O,e.revive=R;function A(P){return JSON.stringify(P,k)}function O(P){let d=JSON.parse(P);return d=R(d),d}function k(P,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:d.flags}:d}function R(P,d=0){if(!P||d>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return U.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 17:return new Date(P.source)}if(P instanceof _.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let C=0;C<P.length;++C)P[C]=R(P[C],d+1);else for(const C in P)Object.hasOwnProperty.call(P,C)&&(P[C]=R(P[C],d+1))}return P}}),define(ae[23],ce([0,1,7,5,27,8,14]),function(ne,e,_,U,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=P,e.matchesSomeScheme=d,e.getServerRootPath=E;var R;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatCodeBlock="vscode-chat-code-block",c.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm",c.commentsInput="comment",c.codeSetting="code-setting"})(R||(e.Schemas=R={}));function P(c,p){return O.URI.isUri(c)?(0,A.equalsIgnoreCase)(c.scheme,p):(0,A.startsWithIgnoreCase)(c,p+":")}function d(c,...p){return p.some(g=>P(c,g))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(p){this._preferredWebSchema=p}setDelegate(p){this._delegate=p}setServerRootPath(p,g){this._serverRootPath=E(p,g)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return k.posix.join(this._serverRootPath,R.vscodeRemoteResource)}set(p,g,u){this._hosts[p]=g,this._ports[p]=u}setConnectionToken(p,g){this._connectionTokens[p]=g}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(p){if(this._delegate)try{return this._delegate(p)}catch(S){return _.onUnexpectedError(S),p}const g=p.authority;let u=this._hosts[g];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const h=this._ports[g],m=this._connectionTokens[g];let f=`path=${encodeURIComponent(p.path)}`;return typeof m=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),O.URI.from({scheme:U.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${u}:${h}`,path:this._remoteResourcesPath,query:f})}}e.RemoteAuthorities=new C;function E(c,p){return k.posix.join(p??"/",`${c.quality??"oss"}-${c.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class v{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(p){const g=this.toUri(p,ne);return this.uriToBrowserUri(g)}uriToBrowserUri(p){return p.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(p):p.scheme===R.file&&(U.isNative||U.webWorkerOrigin===`${R.vscodeFileResource}://${v.FALLBACK_AUTHORITY}`)?p.with({scheme:R.vscodeFileResource,authority:p.authority||v.FALLBACK_AUTHORITY,query:null,fragment:null}):p}asFileUri(p){const g=this.toUri(p,ne);return this.uriToFileUri(g)}uriToFileUri(p){return p.scheme===R.vscodeFileResource?p.with({scheme:R.file,authority:p.authority!==v.FALLBACK_AUTHORITY?p.authority:null,query:null,fragment:null}):p}toUri(p,g){return O.URI.isUri(p)?p:O.URI.parse(g.toUrl(p))}}e.FileAccess=new v;var l;(function(c){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(p.get("3"));const g="vscode-coi";function u(m){let f;typeof m=="string"?f=new URL(m).searchParams:m instanceof URL?f=m.searchParams:O.URI.isUri(m)&&(f=new URL(m.toString(!0)).searchParams);const S=f?.get(g);if(S)return p.get(S)}c.getHeadersFromQuery=u;function h(m,f,S){if(!globalThis.crossOriginIsolated)return;const t=f&&S?"3":S?"2":"1";m instanceof URLSearchParams?m.set(g,t):m[g]=t}c.addSearchParam=h})(l||(e.COI=l={}))}),define(ae[143],ce([0,1,124,23,5,8]),function(ne,e,_,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.importAMDNodeModule=C;class k{constructor(v,l,c){this.id=v,this.dependencies=l,this.callback=c}}class R{static{this.INSTANCE=new R}constructor(){this._isWebWorker=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this._isRenderer=typeof document=="object",this._defineCalls=[],this._initialized=!1}_initialize(){this._initialized||(this._initialized=!0,globalThis.define=(v,l,c)=>{typeof v!="string"&&(c=l,l=v,v=null),(typeof l!="object"||!Array.isArray(l))&&(c=l,l=null),this._defineCalls.push(new k(v,l,c))},globalThis.define.amd=!0,this._isRenderer?this._amdPolicy=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){if(v.startsWith(window.location.origin)||v.startsWith("vscode-file://vscode-app"))return v;throw new Error(`[trusted_script_src] Invalid script url: ${v}`)}}):this._isWebWorker&&(this._amdPolicy=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){return v}})))}async load(v){this._initialize();const l=await(this._isWebWorker?this._workerLoadScript(v):this._isRenderer?this._rendererLoadScript(v):this._nodeJSLoadScript(v));if(!l)throw new Error(`Did not receive a define call from script ${v}`);if(Array.isArray(l.dependencies)&&l.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${v}. The dependencies are: ${l.dependencies.join(", ")}`);return typeof l.callback=="function"?l.callback([]):l.callback}_rendererLoadScript(v){return new Promise((l,c)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const g=()=>{p.removeEventListener("load",u),p.removeEventListener("error",h)},u=m=>{g(),l(this._defineCalls.pop())},h=m=>{g(),c(m)};p.addEventListener("load",u),p.addEventListener("error",h),this._amdPolicy&&(v=this._amdPolicy.createScriptURL(v)),p.setAttribute("src",v),window.document.getElementsByTagName("head")[0].appendChild(p)})}_workerLoadScript(v){return new Promise((l,c)=>{try{this._amdPolicy&&(v=this._amdPolicy.createScriptURL(v)),importScripts(v),l(this._defineCalls.pop())}catch(p){c(p)}})}async _nodeJSLoadScript(v){try{const l=globalThis._VSCODE_NODE_MODULES.fs,c=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,g=O.URI.parse(v).fsPath,u=l.readFileSync(g).toString(),h=p.wrap(u.replace(/^#!.*/,""));return new c.Script(h).runInThisContext().apply(),this._defineCalls.pop()}catch(l){throw l}}}const P=new Map;let d={};typeof globalThis.require=="object"&&(d=globalThis.require.paths??{});async function C(E,v,l){if(_.isESM){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),d[E]&&(E=d[E]);const c=`${E}/${v}`;if(P.has(c))return P.get(c);let p;if(/^\w[\w\d+.-]*:\/\//.test(c))p=c;else{const m=`${l&&!A.isWeb?U.nodeModulesAsarPath:U.nodeModulesPath}/${c}`;p=U.FileAccess.asBrowserUri(m).toString(!0)}const g=R.INSTANCE.load(p);return P.set(c,g),g}else return await new Promise((c,p)=>{ne([E],c,p)})}}),define(ae[20],ce([0,1,40,23,14,5,27,8]),function(ne,e,_,U,A,O,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=P,e.distinctParents=C,e.toLocalResource=v;function P(l){return(0,R.uriToFsPath)(l,!0)}class d{constructor(c){this._ignorePathCasing=c}compare(c,p,g=!1){return c===p?0:(0,k.compare)(this.getComparisonKey(c,g),this.getComparisonKey(p,g))}isEqual(c,p,g=!1){return c===p?!0:!c||!p?!1:this.getComparisonKey(c,g)===this.getComparisonKey(p,g)}getComparisonKey(c,p=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,p,g=!1){if(c.scheme===p.scheme){if(c.scheme===U.Schemas.file)return _.isEqualOrParent(P(c),P(p),this._ignorePathCasing(c))&&c.query===p.query&&(g||c.fragment===p.fragment);if((0,e.isEqualAuthority)(c.authority,p.authority))return _.isEqualOrParent(c.path,p.path,this._ignorePathCasing(c),"/")&&c.query===p.query&&(g||c.fragment===p.fragment)}return!1}joinPath(c,...p){return R.URI.joinPath(c,...p)}basenameOrAuthority(c){return(0,e.basename)(c)||c.authority}basename(c){return A.posix.basename(c.path)}extname(c){return A.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let p;return c.scheme===U.Schemas.file?p=R.URI.file(A.dirname(P(c))).path:(p=A.posix.dirname(c.path),c.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),p="/")),c.with({path:p})}normalizePath(c){if(!c.path.length)return c;let p;return c.scheme===U.Schemas.file?p=R.URI.file(A.normalize(P(c))).path:p=A.posix.normalize(c.path),c.with({path:p})}relativePath(c,p){if(c.scheme!==p.scheme||!(0,e.isEqualAuthority)(c.authority,p.authority))return;if(c.scheme===U.Schemas.file){const h=A.relative(P(c),P(p));return O.isWindows?_.toSlashes(h):h}let g=c.path||"/";const u=p.path||"/";if(this._ignorePathCasing(c)){let h=0;for(const m=Math.min(g.length,u.length);h<m&&!(g.charCodeAt(h)!==u.charCodeAt(h)&&g.charAt(h).toLowerCase()!==u.charAt(h).toLowerCase());h++);g=u.substr(0,h)+g.substr(h)}return A.posix.relative(g,u)}resolvePath(c,p){if(c.scheme===U.Schemas.file){const g=R.URI.file(A.resolve(P(c),p));return c.with({authority:g.authority,path:g.path})}return p=_.toPosixPath(p),c.with({path:A.posix.resolve(c.path,p)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,p){return c===p||c!==void 0&&p!==void 0&&(0,k.equalsIgnoreCase)(c,p)}hasTrailingPathSeparator(c,p=A.sep){if(c.scheme===U.Schemas.file){const g=P(c);return g.length>_.getRoot(g).length&&g[g.length-1]===p}else{const g=c.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,p=A.sep){return(0,e.hasTrailingPathSeparator)(c,p)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,p=A.sep){let g=!1;if(c.scheme===U.Schemas.file){const u=P(c);g=u!==void 0&&u.length===_.getRoot(u).length&&u[u.length-1]===p}else{p="/";const u=c.path;g=u.length===1&&u.charCodeAt(u.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(c,p)?c.with({path:c.path+"/"}):c}}e.ExtUri=d,e.extUri=new d(()=>!1),e.extUriBiasedIgnorePathCase=new d(l=>l.scheme===U.Schemas.file?!O.isLinux:!0),e.extUriIgnorePathCase=new d(l=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(l,c){const p=[];for(let g=0;g<l.length;g++){const u=c(l[g]);l.some((h,m)=>m===g?!1:(0,e.isEqualOrParent)(u,c(h)))||p.push(l[g])}return p}var E;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function c(p){const g=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(m=>{const[f,S]=m.split(":");f&&S&&g.set(f,S)});const h=p.path.substring(0,p.path.indexOf(";"));return h&&g.set(l.META_DATA_MIME,h),g}l.parseMetaData=c})(E||(e.DataUri=E={}));function v(l,c,p){if(c){let g=l.path;return g&&g[0]!==A.posix.sep&&(g=A.posix.sep+g),l.with({scheme:p,authority:c,path:g})}return l.with({scheme:p})}}),define(ae[6],ce([0,1,26,7,3,2,20,5,130,53]),function(ne,e,_,U,A,O,k,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=C,e.createCancelablePromise=E,e.raceCancellation=v,e.raceCancellationError=l,e.raceCancellablePromises=c,e.raceTimeout=p,e.asPromise=g,e.promiseWithResolvers=u,e.timeout=o,e.disposableTimeout=a,e.sequence=y,e.first=I,e.firstParallel=w,e.retry=q,e.createCancelableAsyncIterable=G;function C(Z){return!!Z&&typeof Z.then=="function"}function E(Z){const J=new _.CancellationTokenSource,se=Z(J.token),he=new Promise((ge,de)=>{const me=J.token.onCancellationRequested(()=>{me.dispose(),de(new U.CancellationError)});Promise.resolve(se).then(Ee=>{me.dispose(),J.dispose(),ge(Ee)},Ee=>{me.dispose(),J.dispose(),de(Ee)})});return new class{cancel(){J.cancel(),J.dispose()}then(ge,de){return he.then(ge,de)}catch(ge){return this.then(void 0,ge)}finally(ge){return he.finally(ge)}}}function v(Z,J,se){return new Promise((he,ge)=>{const de=J.onCancellationRequested(()=>{de.dispose(),he(se)});Z.then(he,ge).finally(()=>de.dispose())})}function l(Z,J){return new Promise((se,he)=>{const ge=J.onCancellationRequested(()=>{ge.dispose(),he(new U.CancellationError)});Z.then(se,he).finally(()=>ge.dispose())})}async function c(Z){let J=-1;const se=Z.map((he,ge)=>he.then(de=>(J=ge,de)));try{return await Promise.race(se)}finally{Z.forEach((he,ge)=>{ge!==J&&he.cancel()})}}function p(Z,J,se){let he;const ge=setTimeout(()=>{he?.(void 0),se?.()},J);return Promise.race([Z.finally(()=>clearTimeout(ge)),new Promise(de=>he=de)])}function g(Z){return new Promise((J,se)=>{const he=Z();C(he)?he.then(J,se):J(he)})}function u(){let Z,J;return{promise:new Promise((he,ge)=>{Z=he,J=ge}),resolve:Z,reject:J}}class h{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(J){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=J,!this.queuedPromise){const se=()=>{if(this.queuedPromise=null,this.isDisposed)return;const he=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,he};this.queuedPromise=new Promise(he=>{this.activePromise.then(se,se).then(he)})}return new Promise((se,he)=>{this.queuedPromise.then(se,he)})}return this.activePromise=J(),new Promise((se,he)=>{this.activePromise.then(ge=>{this.activePromise=null,se(ge)},ge=>{this.activePromise=null,he(ge)})})}dispose(){this.isDisposed=!0}}e.Throttler=h;class m{constructor(){this.current=Promise.resolve(null)}queue(J){return this.current=this.current.then(()=>J(),()=>J())}}e.Sequencer=m;class f{constructor(){this.promiseMap=new Map}queue(J,se){const ge=(this.promiseMap.get(J)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.promiseMap.get(J)===ge&&this.promiseMap.delete(J)});return this.promiseMap.set(J,ge),ge}}e.SequencerByKey=f;const S=(Z,J)=>{let se=!0;const he=setTimeout(()=>{se=!1,J()},Z);return{isTriggered:()=>se,dispose:()=>{clearTimeout(he),se=!1}}},t=Z=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,Z())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class r{constructor(J){this.defaultDelay=J,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(J,se=this.defaultDelay){this.task=J,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((ge,de)=>{this.doResolve=ge,this.doReject=de}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const ge=this.task;return this.task=null,ge()}}));const he=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=se===P.MicrotaskDelay?t(he):S(se,he),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new U.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=r;class n{constructor(J){this.delayer=new r(J),this.throttler=new h}trigger(J,se){return this.delayer.trigger(()=>this.throttler.queue(J),se)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=n;class s{constructor(){this._isOpen=!1,this._promise=new Promise((J,se)=>{this._completePromise=J})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class i extends s{constructor(J){super(),this._timeout=setTimeout(()=>this.open(),J)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=i;function o(Z,J){return J?new Promise((se,he)=>{const ge=setTimeout(()=>{de.dispose(),se()},Z),de=J.onCancellationRequested(()=>{clearTimeout(ge),de.dispose(),he(new U.CancellationError)})}):E(se=>o(Z,se))}function a(Z,J=0,se){const he=setTimeout(()=>{Z(),se&&ge.dispose()},J),ge=(0,O.toDisposable)(()=>{clearTimeout(he),se?.deleteAndLeak(ge)});return se?.add(ge),ge}function y(Z){const J=[];let se=0;const he=Z.length;function ge(){return se<he?Z[se++]():null}function de(me){me!=null&&J.push(me);const Ee=ge();return Ee?Ee.then(de):Promise.resolve(J)}return Promise.resolve(null).then(de)}function I(Z,J=he=>!!he,se=null){let he=0;const ge=Z.length,de=()=>{if(he>=ge)return Promise.resolve(se);const me=Z[he++];return Promise.resolve(me()).then(we=>J(we)?Promise.resolve(we):de())};return de()}function w(Z,J=he=>!!he,se=null){if(Z.length===0)return Promise.resolve(se);let he=Z.length;const ge=()=>{he=-1;for(const de of Z)de.cancel?.()};return new Promise((de,me)=>{for(const Ee of Z)Ee.then(we=>{--he>=0&&J(we)?(ge(),de(we)):he===0&&de(se)}).catch(we=>{--he>=0&&(ge(),me(we))})})}class b{constructor(J){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=J,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new A.Emitter}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(J){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((se,he)=>{this.outstandingPromises.push({factory:J,c:se,e:he}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const J=this.outstandingPromises.shift();this.runningPromises++;const se=J.factory();se.then(J.c,J.e),se.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=b;class D extends b{constructor(){super(1)}}e.Queue=D;class L{constructor(){this.sequentializer=new ie,this.tasks=0}queue(J){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,J())):this.sequentializer.run(this.tasks++,J())}}e.LimitedQueue=L;class N{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const J=new te;return this.drainers.add(J),J.p}isDrained(){for(const[,J]of this.queues)if(J.size>0)return!1;return!0}queueSize(J,se=k.extUri){const he=se.getComparisonKey(J);return this.queues.get(he)?.size??0}queueFor(J,se,he=k.extUri){const ge=he.getComparisonKey(J);let de=this.queues.get(ge);if(!de){de=new D;const me=this.drainListenerCount++,Ee=A.Event.once(de.onDrained)(()=>{de?.dispose(),this.queues.delete(ge),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(me),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new O.DisposableMap),this.drainListeners.set(me,Ee),this.queues.set(ge,de)}return de.queue(se)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const J of this.drainers)J.complete();this.drainers.clear()}dispose(){for(const[,J]of this.queues)J.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=N;class F{constructor(J,se){this._token=-1,typeof J=="function"&&typeof se=="number"&&this.setIfNotSet(J,se)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(J,se){this.cancel(),this._token=setTimeout(()=>{this._token=-1,J()},se)}setIfNotSet(J,se){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,J()},se))}}e.TimeoutTimer=F;class x{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(J,se,he=globalThis){this.cancel();const ge=he.setInterval(()=>{J()},se);this.disposable=(0,O.toDisposable)(()=>{he.clearInterval(ge),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=x;class X{constructor(J,se){this.timeoutToken=-1,this.runner=J,this.timeout=se,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(J=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,J)}get delay(){return this.timeout}set delay(J){this.timeout=J}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=X;class B{constructor(J,se){se%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.runner=J,this.timeout=se,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(J=this.timeout){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(J/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=B;class Y extends X{constructor(J,se){super(J,se),this.units=[]}work(J){this.units.push(J),this.isScheduled()||this.schedule()}doRun(){const J=this.units;this.units=[],this.runner?.(J)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Y;class z extends O.Disposable{constructor(J,se){super(),this.options=J,this.handler=se,this.pendingWork=[],this.throttler=this._register(new O.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(J){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+J.length>this.options.maxBufferedWork)return!1}else if(this.pending+J.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const se of J)this.pendingWork.push(se);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new X(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=z,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(Z,J)=>{(0,R.setTimeout0)(()=>{if(se)return;const he=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let se=!1;return{dispose(){se||(se=!0)}}}:e._runWhenIdle=(Z,J,se)=>{const he=Z.requestIdleCallback(J,typeof se=="number"?{timeout:se}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,Z.cancelIdleCallback(he))}}},e.runWhenGlobalIdle=Z=>(0,e._runWhenIdle)(globalThis,Z)}();class H{constructor(J,se){this._didRun=!1,this._executor=()=>{try{this._value=se()}catch(he){this._error=he}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(J,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=H;class V extends H{constructor(J){super(globalThis,J)}}e.GlobalIdleValue=V;async function q(Z,J,se){let he;for(let ge=0;ge<se;ge++)try{return await Z()}catch(de){he=de,await o(J)}throw he}class ie{isRunning(J){return typeof J=="number"?this._running?.taskId===J:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(J,se,he){return this._running={taskId:J,cancel:()=>he?.(),promise:se},se.then(()=>this.doneRunning(J),()=>this.doneRunning(J)),se}doneRunning(J){this._running&&J===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const J=this._queued;this._queued=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this._queued)this._queued.run=J;else{const{promise:se,resolve:he,reject:ge}=u();this._queued={run:J,promise:se,promiseResolve:he,promiseReject:ge}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=ie;class re{constructor(J,se=()=>Date.now()){this.interval=J,this.nowFn=se,this.lastIncrementTime=0,this.value=0}increment(){const J=this.nowFn();return J-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=J,this.value=0),this.value++,this.value}}e.IntervalCounter=re;var ue;(function(Z){Z[Z.Resolved=0]="Resolved",Z[Z.Rejected=1]="Rejected"})(ue||(ue={}));class te{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((J,se)=>{this.completeCallback=J,this.errorCallback=se})}complete(J){return new Promise(se=>{this.completeCallback(J),this.outcome={outcome:0,value:J},se()})}error(J){return new Promise(se=>{this.errorCallback(J),this.outcome={outcome:1,value:J},se()})}cancel(){return this.error(new U.CancellationError)}}e.DeferredPromise=te;var j;(function(Z){async function J(he){let ge;const de=await Promise.all(he.map(me=>me.then(Ee=>Ee,Ee=>{ge||(ge=Ee)})));if(typeof ge<"u")throw ge;return de}Z.settled=J;function se(he){return new Promise(async(ge,de)=>{try{await he(ge,de)}catch(me){de(me)}})}Z.withAsyncBody=se})(j||(e.Promises=j={}));class W{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(J){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=J.then(se=>(this._value=se,this._isResolved=!0,se),se=>{throw this._error=se,this._isResolved=!0,se})}requireValue(){if(!this._isResolved)throw new U.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=W;class T{constructor(J){this._compute=J,this._promise=new d.Lazy(()=>new W(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=T;var M;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(M||(M={}));class ${static fromArray(J){return new $(se=>{se.emitMany(J)})}static fromPromise(J){return new $(async se=>{se.emitMany(await J)})}static fromPromises(J){return new $(async se=>{await Promise.all(J.map(async he=>se.emitOne(await he)))})}static merge(J){return new $(async se=>{await Promise.all(J.map(async he=>{for await(const ge of he)se.emitOne(ge)}))})}static{this.EMPTY=$.fromArray([])}constructor(J,se){this._state=0,this._results=[],this._error=null,this._onReturn=se,this._onStateChanged=new A.Emitter,queueMicrotask(async()=>{const he={emitOne:ge=>this.emitOne(ge),emitMany:ge=>this.emitMany(ge),reject:ge=>this.reject(ge)};try{await Promise.resolve(J(he)),this.resolve()}catch(ge){this.reject(ge)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(J<this._results.length)return{done:!1,value:this._results[J++]};if(this._state===1)return{done:!0,value:void 0};await A.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(J,se){return new $(async he=>{for await(const ge of J)he.emitOne(se(ge))})}map(J){return $.map(this,J)}static filter(J,se){return new $(async he=>{for await(const ge of J)se(ge)&&he.emitOne(ge)})}filter(J){return $.filter(this,J)}static coalesce(J){return $.filter(J,se=>!!se)}coalesce(){return $.coalesce(this)}static async toPromise(J){const se=[];for await(const he of J)se.push(he);return se}toPromise(){return $.toPromise(this)}emitOne(J){this._state===0&&(this._results.push(J),this._onStateChanged.fire())}emitMany(J){this._state===0&&(this._results=this._results.concat(J),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(J){this._state===0&&(this._state=2,this._error=J,this._onStateChanged.fire())}}e.AsyncIterableObject=$;class Q extends ${constructor(J,se){super(se),this._source=J}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Q;function G(Z){const J=new _.CancellationTokenSource,se=Z(J.token);return new Q(J,async he=>{const ge=J.token.onCancellationRequested(()=>{ge.dispose(),J.dispose(),he.reject(new U.CancellationError)});try{for await(const de of se){if(J.token.isCancellationRequested)return;he.emitOne(de)}ge.dispose(),J.dispose()}catch(de){ge.dispose(),J.dispose(),he.reject(de)}})}class ee{constructor(J){this._deferred=new te,this._asyncIterable=new $(ge=>{if(se){ge.reject(se);return}return he&&ge.emitMany(he),this._errorFn=de=>ge.reject(de),this._emitFn=de=>ge.emitOne(de),this._deferred.p},J);let se,he;this._emitFn=ge=>{he||(he=[]),he.push(ge)},this._errorFn=ge=>{se||(se=ge)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(J){this._errorFn(J),this._deferred.complete()}emitOne(J){this._emitFn(J)}}e.AsyncIterableSource=ee}),define(ae[90],ce([0,1,17,6,40,34,14,5,27]),function(ne,e,_,U,A,O,k,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GLOB_SPLIT=e.GLOBSTAR=void 0,e.getEmptyExpression=d,e.splitGlobAware=c,e.match=D,e.parse=L,e.isRelativePattern=N,e.getBasenameTerms=F,e.getPathTerms=x,e.patternsEquals=z;function d(){return Object.create(null)}e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",E="[^/\\\\]",v=/\//g;function l(H,V){switch(H){case 0:return"";case 1:return`${E}*?`;default:return`(?:${C}|${E}+${C}${V?`|${C}${E}+`:""})*?`}}function c(H,V){if(!H)return[];const q=[];let ie=!1,re=!1,ue="";for(const te of H){switch(te){case V:if(!ie&&!re){q.push(ue),ue="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":re=!0;break;case"]":re=!1;break}ue+=te}return ue&&q.push(ue),q}function p(H){if(!H)return"";let V="";const q=c(H,e.GLOB_SPLIT);if(q.every(ie=>ie===e.GLOBSTAR))V=".*";else{let ie=!1;q.forEach((re,ue)=>{if(re===e.GLOBSTAR){if(ie)return;V+=l(2,ue===q.length-1)}else{let te=!1,j="",W=!1,T="";for(const M of re){if(M!=="}"&&te){j+=M;continue}if(W&&(M!=="]"||!T)){let $;M==="-"?$=M:(M==="^"||M==="!")&&!T?$="^":M===e.GLOB_SPLIT?$="":$=(0,P.escapeRegExpCharacters)(M),T+=$;continue}switch(M){case"{":te=!0;continue;case"[":W=!0;continue;case"}":{const Q=`(?:${c(j,",").map(G=>p(G)).join("|")})`;V+=Q,te=!1,j="";break}case"]":{V+="["+T+"]",W=!1,T="";break}case"?":V+=E;continue;case"*":V+=l(1);continue;default:V+=(0,P.escapeRegExpCharacters)(M)}}ue<q.length-1&&(q[ue+1]!==e.GLOBSTAR||ue+2<q.length)&&(V+=C)}ie=re===e.GLOBSTAR})}return V}const g=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,S=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new O.LRUCache(1e4),r=function(){return!1},n=function(){return null};function s(H,V){if(!H)return n;let q;typeof H!="string"?q=H.pattern:q=H,q=q.trim();const ie=`${q}_${!!V.trimForExclusions}`;let re=t.get(ie);if(re)return i(re,H);let ue;return g.test(q)?re=a(q.substr(4),q):(ue=u.exec(o(q,V)))?re=y(ue[1],q):(V.trimForExclusions?m:h).test(q)?re=I(q,V):(ue=f.exec(o(q,V)))?re=w(ue[1].substr(1),q,!0):(ue=S.exec(o(q,V)))?re=w(ue[1],q,!1):re=b(q),t.set(ie,re),i(re,H)}function i(H,V){if(typeof V=="string")return H;const q=function(ie,re){return(0,A.isEqualOrParent)(ie,V.base,!R.isLinux)?H((0,P.ltrim)(ie.substr(V.base.length),k.sep),re):null};return q.allBasenames=H.allBasenames,q.allPaths=H.allPaths,q.basenames=H.basenames,q.patterns=H.patterns,q}function o(H,V){return V.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function a(H,V){return function(q,ie){return typeof q=="string"&&q.endsWith(H)?V:null}}function y(H,V){const q=`/${H}`,ie=`\\${H}`,re=function(te,j){return typeof te!="string"?null:j?j===H?V:null:te===H||te.endsWith(q)||te.endsWith(ie)?V:null},ue=[H];return re.basenames=ue,re.patterns=[V],re.allBasenames=ue,re}function I(H,V){const q=Y(H.slice(1,-1).split(",").map(j=>s(j,V)).filter(j=>j!==n),H),ie=q.length;if(!ie)return n;if(ie===1)return q[0];const re=function(j,W){for(let T=0,M=q.length;T<M;T++)if(q[T](j,W))return H;return null},ue=q.find(j=>!!j.allBasenames);ue&&(re.allBasenames=ue.allBasenames);const te=q.reduce((j,W)=>W.allPaths?j.concat(W.allPaths):j,[]);return te.length&&(re.allPaths=te),re}function w(H,V,q){const ie=k.sep===k.posix.sep,re=ie?H:H.replace(v,k.sep),ue=k.sep+re,te=k.posix.sep+H;let j;return q?j=function(W,T){return typeof W=="string"&&(W===re||W.endsWith(ue)||!ie&&(W===H||W.endsWith(te)))?V:null}:j=function(W,T){return typeof W=="string"&&(W===re||!ie&&W===H)?V:null},j.allPaths=[(q?"*/":"./")+H],j}function b(H){try{const V=new RegExp(`^${p(H)}$`);return function(q){return V.lastIndex=0,typeof q=="string"&&V.test(q)?H:null}}catch{return n}}function D(H,V,q){return!H||typeof V!="string"?!1:L(H)(V,void 0,q)}function L(H,V={}){if(!H)return r;if(typeof H=="string"||N(H)){const q=s(H,V);if(q===n)return r;const ie=function(re,ue){return!!q(re,ue)};return q.allBasenames&&(ie.allBasenames=q.allBasenames),q.allPaths&&(ie.allPaths=q.allPaths),ie}return X(H,V)}function N(H){const V=H;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}function F(H){return H.allBasenames||[]}function x(H){return H.allPaths||[]}function X(H,V){const q=Y(Object.getOwnPropertyNames(H).map(j=>B(j,H[j],V)).filter(j=>j!==n)),ie=q.length;if(!ie)return n;if(!q.some(j=>!!j.requiresSiblings)){if(ie===1)return q[0];const j=function(M,$){let Q;for(let G=0,ee=q.length;G<ee;G++){const Z=q[G](M,$);if(typeof Z=="string")return Z;(0,U.isThenable)(Z)&&(Q||(Q=[]),Q.push(Z))}return Q?(async()=>{for(const G of Q){const ee=await G;if(typeof ee=="string")return ee}return null})():null},W=q.find(M=>!!M.allBasenames);W&&(j.allBasenames=W.allBasenames);const T=q.reduce((M,$)=>$.allPaths?M.concat($.allPaths):M,[]);return T.length&&(j.allPaths=T),j}const re=function(j,W,T){let M,$;for(let Q=0,G=q.length;Q<G;Q++){const ee=q[Q];ee.requiresSiblings&&T&&(W||(W=(0,k.basename)(j)),M||(M=W.substr(0,W.length-(0,k.extname)(j).length)));const Z=ee(j,W,M,T);if(typeof Z=="string")return Z;(0,U.isThenable)(Z)&&($||($=[]),$.push(Z))}return $?(async()=>{for(const Q of $){const G=await Q;if(typeof G=="string")return G}return null})():null},ue=q.find(j=>!!j.allBasenames);ue&&(re.allBasenames=ue.allBasenames);const te=q.reduce((j,W)=>W.allPaths?j.concat(W.allPaths):j,[]);return te.length&&(re.allPaths=te),re}function B(H,V,q){if(V===!1)return n;const ie=s(H,q);if(ie===n)return n;if(typeof V=="boolean")return ie;if(V){const re=V.when;if(typeof re=="string"){const ue=(te,j,W,T)=>{if(!T||!ie(te,j))return null;const M=re.replace("$(basename)",()=>W),$=T(M);return(0,U.isThenable)($)?$.then(Q=>Q?H:null):$?H:null};return ue.requiresSiblings=!0,ue}}return ie}function Y(H,V){const q=H.filter(j=>!!j.basenames);if(q.length<2)return H;const ie=q.reduce((j,W)=>{const T=W.basenames;return T?j.concat(T):j},[]);let re;if(V){re=[];for(let j=0,W=ie.length;j<W;j++)re.push(V)}else re=q.reduce((j,W)=>{const T=W.patterns;return T?j.concat(T):j},[]);const ue=function(j,W){if(typeof j!="string")return null;if(!W){let M;for(M=j.length;M>0;M--){const $=j.charCodeAt(M-1);if($===47||$===92)break}W=j.substr(M)}const T=ie.indexOf(W);return T!==-1?re[T]:null};ue.basenames=ie,ue.patterns=re,ue.allBasenames=ie;const te=H.filter(j=>!j.basenames);return te.push(ue),te}function z(H,V){return(0,_.equals)(H,V,(q,ie)=>typeof q=="string"&&typeof ie=="string"?q===ie:typeof q!="string"&&typeof ie!="string"?q.base===ie.base&&q.pattern===ie.pattern:!1)}}),define(ae[91],ce([0,1,15,8]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=R,e.transformIncomingURIs=d,e.transformAndReviveIncomingURIs=C;function A(E){return E.toJSON()}class O{constructor(v){this._uriTransformer=v}transformIncoming(v){const l=this._uriTransformer.transformIncoming(v);return l===v?v:A(U.URI.from(l))}transformOutgoing(v){const l=this._uriTransformer.transformOutgoing(v);return l===v?v:A(U.URI.from(l))}transformOutgoingURI(v){const l=this._uriTransformer.transformOutgoing(v);return l===v?v:U.URI.from(l)}transformOutgoingScheme(v){return this._uriTransformer.transformOutgoingScheme(v)}}e.URITransformer=O,e.DefaultURITransformer=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function k(E,v,l){if(!E||l>200)return null;if(typeof E=="object"){if(E instanceof U.URI)return v.transformOutgoing(E);for(const c in E)if(Object.hasOwnProperty.call(E,c)){const p=k(E[c],v,l+1);p!==null&&(E[c]=p)}}return null}function R(E,v){const l=k(E,v,0);return l===null?E:l}function P(E,v,l,c){if(!E||c>200)return null;if(typeof E=="object"){if(E.$mid===1)return l?U.URI.revive(v.transformIncoming(E)):v.transformIncoming(E);if(E instanceof _.VSBuffer)return null;for(const p in E)if(Object.hasOwnProperty.call(E,p)){const g=P(E[p],v,l,c+1);g!==null&&(E[p]=g)}}return null}function d(E,v){const l=P(E,v,!1,0);return l===null?E:l}function C(E,v){const l=P(E,v,!0,0);return l===null?E:l}}),define(ae[144],ce([0,1,37,51,32,131,5]),function(ne,e,_,U,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.virtualMachineHint=void 0,e.getMachineId=P,e.getSqmMachineId=E,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(v){return this._virtualMachineOUIs||(this._virtualMachineOUIs=U.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(v)}value(){if(this._value===void 0){let v=0,l=0;const c=(0,_.networkInterfaces)();for(const p in c){const g=c[p];if(g)for(const{mac:u,internal:h}of g)h||(l+=1,this._isVirtualMachineMacAddress(u.toUpperCase())&&(v+=1))}this._value=l>0?v/l:0}return this._value}};let R;async function P(v){return R||(R=(async()=>await d(v)||A.generateUuid())()),R}async function d(v){try{const l=await new Promise((p,g)=>{ne(["crypto"],p,g)}),c=(0,O.getMac)();return l.createHash("sha256").update(c,"utf8").digest("hex")}catch(l){v(l);return}}const C="Software\\Microsoft\\SQMClient";async function E(v){if(k.isWindows){const l=await new Promise((c,p)=>{ne(["@vscode/windows-registry"],c,p)});try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",C,"MachineId")||""}catch(c){return v(c),""}}return""}}),define(ae[145],ce([0,1,41,146,14,36]),function(ne,e,_,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getDisplayProtocol=C,e.getCodeDisplayProtocol=E;const k="XDG_SESSION_TYPE",R="WAYLAND_DISPLAY",P="XDG_RUNTIME_DIR";var d;(function(v){v.Wayland="wayland",v.XWayland="xwayland",v.X11="x11",v.Unknown="unknown"})(d||(d={}));async function C(v){const l=O.env[k];if(l)return l==="wayland"||l==="x11"?l:"unknown";if(O.env[R]){const p=O.env[P];if(p){const g=(0,A.join)(p,"wayland-0");try{return await(0,U.access)(g,_.constants.R_OK),"wayland"}catch(u){return v(u),"unknown"}}else return"unknown"}else return"x11"}function E(v,l){if(l)switch(l){case"auto":return v;case"x11":return v==="wayland"?"xwayland":"x11";case"wayland":return"wayland";default:return"unknown"}else return v==="wayland"?"xwayland":"x11"}}),define(ae[147],ce([0,1,41,146,274,5]),function(ne,e,_,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getOSReleaseInfo=k;async function k(R){if(O.isMacintosh||O.isWindows)return;let P;for(const d of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{P=await(0,U.open)(d,_.constants.R_OK);break}catch{}if(!P){R("Unable to retrieve release information from known identifier paths.");return}try{const d=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),C={id:"unknown"};for await(const E of(0,A.createInterface)({input:P.createReadStream(),crlfDelay:1/0})){if(!E.includes("="))continue;const v=E.split("=")[0].toUpperCase().trim();if(d.has(v)){const l=E.split("=")[1].replace(/"/g,"").toLowerCase().trim();v==="ID"||v==="DISTRIB_ID"?C.id=l:v==="ID_LIKE"?C.id_like=l:(v==="VERSION_ID"||v==="DISTRIB_RELEASE")&&(C.version_id=l)}}return C}catch(d){R(d)}}}),define(ae[31],ce([0,1,41,37,275,6,40,87,14,5,20,8]),function(ne,e,_,U,A,O,k,R,P,d,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=g,e.readdirSync=m,e.whenDeleted=t,e.configureFlushOnWrite=o,e.writeFileSync=y;var v;(function(B){B[B.UNLINK=0]="UNLINK",B[B.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function l(B,Y=v.UNLINK,z){if((0,k.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");return Y===v.UNLINK?p(B):c(B,z)}async function c(B,Y=(0,k.randomPath)((0,U.tmpdir)())){try{try{await _.promises.rename(B,Y)}catch(z){return z.code==="ENOENT"?void 0:p(B)}p(Y).catch(z=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function p(B){return(0,A.promisify)(_.rm)(B,{recursive:!0,force:!0,maxRetries:3})}function g(B){if((0,k.isRootOrDriveLetter)(B))throw new Error("rimraf - will refuse to recursively delete root");_.rmSync(B,{recursive:!0,force:!0,maxRetries:3})}async function u(B,Y){return f(await(Y?h(B):(0,A.promisify)(_.readdir)(B)))}async function h(B){try{return await(0,A.promisify)(_.readdir)(B,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const Y=[],z=await u(B);for(const H of z){let V=!1,q=!1,ie=!1;try{const re=await e.Promises.lstat((0,P.join)(B,H));V=re.isFile(),q=re.isDirectory(),ie=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}Y.push({name:H,isFile:()=>V,isDirectory:()=>q,isSymbolicLink:()=>ie})}return Y}function m(B){return f(_.readdirSync(B))}function f(B){return B.map(Y=>typeof Y=="string"?d.isMacintosh?(0,R.normalizeNFC)(Y):Y:(Y.name=d.isMacintosh?(0,R.normalizeNFC)(Y.name):Y.name,Y))}async function S(B){const Y=await u(B),z=[];for(const H of Y)await r.existsDirectory((0,P.join)(B,H))&&z.push(H);return z}function t(B,Y=1e3){return new Promise(z=>{let H=!1;const V=setInterval(()=>{H||(H=!0,_.access(B,q=>{H=!1,q&&(clearInterval(V),z(void 0))}))},Y)})}var r;(function(B){async function Y(V){let q;try{if(q=await e.Promises.lstat(V),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ie){if(ie.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(d.isWindows&&ie.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw re}throw ie}}B.stat=Y;async function z(V){try{const{stat:q,symbolicLink:ie}=await B.stat(V);return q.isFile()&&ie?.dangling!==!0}catch{}return!1}B.existsFile=z;async function H(V){try{const{stat:q,symbolicLink:ie}=await B.stat(V);return q.isDirectory()&&ie?.dangling!==!0}catch{}return!1}B.existsDirectory=H})(r||(e.SymlinkSupport=r={}));const n=new O.ResourceQueue;function s(B,Y,z){return n.queueFor(E.URI.file(B),()=>{const H=I(z);return new Promise((V,q)=>a(B,Y,H,ie=>ie?q(ie):V()))},C.extUriBiasedIgnorePathCase)}let i=!0;function o(B){i=B}function a(B,Y,z,H){if(!i)return _.writeFile(B,Y,{mode:z.mode,flag:z.flag},H);_.open(B,z.flag,z.mode,(V,q)=>{if(V)return H(V);_.writeFile(q,Y,ie=>{if(ie)return _.close(q,()=>H(ie));_.fdatasync(q,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),o(!1)),_.close(q,ue=>H(ue))))})})}function y(B,Y,z){const H=I(z);if(!i)return _.writeFileSync(B,Y,{mode:H.mode,flag:H.flag});const V=_.openSync(B,H.flag,H.mode);try{_.writeFileSync(V,Y);try{_.fdatasyncSync(V)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),o(!1)}}finally{_.closeSync(V)}}function I(B){return B?{mode:typeof B.mode=="number"?B.mode:438,flag:typeof B.flag=="string"?B.flag:"w"}:{mode:438,flag:"w"}}async function w(B,Y,z=6e4){if(B!==Y)try{d.isWindows&&typeof z=="number"?await b(B,Y,Date.now(),z):await(0,A.promisify)(_.rename)(B,Y)}catch(H){if(B.toLowerCase()!==Y.toLowerCase()&&H.code==="EXDEV"||B.endsWith("."))await D(B,Y,{preserveSymlinks:!1}),await l(B,v.MOVE);else throw H}}async function b(B,Y,z,H,V=0){try{return await(0,A.promisify)(_.rename)(B,Y)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-z>=H)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${q}`),q;if(V===0){let ie=!1;try{const{stat:re}=await r.stat(Y);re.isFile()||(ie=!0)}catch{}if(ie)throw q}return await(0,O.timeout)(Math.min(100,V*10)),b(B,Y,z,H,V+1)}}async function D(B,Y,z){return N(B,Y,{root:{source:B,target:Y},options:z,handledSourcePaths:new Set})}const L=511;async function N(B,Y,z){if(z.handledSourcePaths.has(B))return;z.handledSourcePaths.add(B);const{stat:H,symbolicLink:V}=await r.stat(B);if(V){if(z.options.preserveSymlinks)try{return await X(B,Y,z)}catch{}if(V.dangling)return}return H.isDirectory()?F(B,Y,H.mode&L,z):x(B,Y,H.mode&L)}async function F(B,Y,z,H){await e.Promises.mkdir(Y,{recursive:!0,mode:z});const V=await u(B);for(const q of V)await N((0,P.join)(B,q),(0,P.join)(Y,q),H)}async function x(B,Y,z){await e.Promises.copyFile(B,Y),await e.Promises.chmod(Y,z)}async function X(B,Y,z){let H=await e.Promises.readlink(B);(0,k.isEqualOrParent)(H,z.root.source,!d.isLinux)&&(H=(0,P.join)(z.root.target,H.substr(z.root.source.length+1))),await e.Promises.symlink(H,Y)}e.Promises=new class{get access(){return(0,A.promisify)(_.access)}get stat(){return(0,A.promisify)(_.stat)}get lstat(){return(0,A.promisify)(_.lstat)}get utimes(){return(0,A.promisify)(_.utimes)}get read(){return(B,Y,z,H,V)=>new Promise((q,ie)=>{_.read(B,Y,z,H,V,(re,ue,te)=>re?ie(re):q({bytesRead:ue,buffer:te}))})}get readFile(){return(0,A.promisify)(_.readFile)}get write(){return(B,Y,z,H,V)=>new Promise((q,ie)=>{_.write(B,Y,z,H,V,(re,ue,te)=>re?ie(re):q({bytesWritten:ue,buffer:te}))})}get appendFile(){return(0,A.promisify)(_.appendFile)}get fdatasync(){return(0,A.promisify)(_.fdatasync)}get truncate(){return(0,A.promisify)(_.truncate)}get copyFile(){return(0,A.promisify)(_.copyFile)}get open(){return(0,A.promisify)(_.open)}get close(){return(0,A.promisify)(_.close)}get symlink(){return(0,A.promisify)(_.symlink)}get readlink(){return(0,A.promisify)(_.readlink)}get chmod(){return(0,A.promisify)(_.chmod)}get mkdir(){return(0,A.promisify)(_.mkdir)}get unlink(){return(0,A.promisify)(_.unlink)}get rmdir(){return(0,A.promisify)(_.rmdir)}get realpath(){return(0,A.promisify)(_.realpath)}async exists(B){try{return await e.Promises.access(B),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return S}get writeFile(){return s}get rm(){return l}get rename(){return w}get copy(){return D}}}),define(ae[148],ce([0,1,41,14,5,27,31]),function(ne,e,_,U,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realcaseSync=R,e.realcase=P,e.realpath=d,e.realpathSync=C;function R(v){if(A.isLinux)return v;const l=(0,U.dirname)(v);if(v===l)return v;const c=((0,U.basename)(v)||v).toLowerCase();try{const g=(0,k.readdirSync)(l).filter(u=>u.toLowerCase()===c);if(g.length===1){const u=R(l);if(u)return(0,U.join)(u,g[0])}else if(g.length>1){const u=g.indexOf(c);if(u>=0){const h=R(l);if(h)return(0,U.join)(h,g[u])}}}catch{}return null}async function P(v,l){if(A.isLinux)return v;const c=(0,U.dirname)(v);if(v===c)return v;const p=((0,U.basename)(v)||v).toLowerCase();try{if(l?.isCancellationRequested)return null;const u=(await k.Promises.readdir(c)).filter(h=>h.toLowerCase()===p);if(u.length===1){const h=await P(c,l);if(h)return(0,U.join)(h,u[0])}else if(u.length>1){const h=u.indexOf(p);if(h>=0){const m=await P(c,l);if(m)return(0,U.join)(m,u[h])}}}catch{}return null}async function d(v){try{return await k.Promises.realpath(v)}catch{const c=E(v);return await k.Promises.access(c,_.constants.R_OK),c}}function C(v){try{return _.realpathSync(v)}catch{const c=E(v);return _.accessSync(c,_.constants.R_OK),c}}function E(v){return(0,O.rtrim)((0,U.normalize)(v),U.sep)}}),define(ae[149],ce([0,1,14,5,36,89,13,31]),function(ne,e,_,U,A,O,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=P,e.createQueuedSender=d,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function P(E=A.env){return E.comspec||"cmd.exe"}function d(E){let v=[],l=!1;const c=function(p){if(l){v.push(p);return}(!E.send(p,u=>{if(u&&console.error(u),l=!1,v.length>0){const h=v.slice(0);v=[],h.forEach(m=>c(m))}})||U.isWindows)&&(l=!0)};return{send:c}}var C;(function(E){async function v(l,c,p){if(_.isAbsolute(l))return l;if(c===void 0&&(c=A.cwd()),_.dirname(l)!=="."||(p===void 0&&k.isString(A.env.PATH)&&(p=A.env.PATH.split(_.delimiter)),p===void 0||p.length===0))return _.join(c,l);async function u(h){if(await R.Promises.exists(h)){let m;try{m=await R.Promises.stat(h)}catch(f){f.message.startsWith("EACCES")&&(m=await R.Promises.lstat(h))}return m?!m.isDirectory():!1}return!1}for(const h of p){let m;if(_.isAbsolute(h)?m=_.join(h,l):m=_.join(c,h,l),await u(m))return m;let f=m+".com";if(await u(f)||(f=m+".exe",await u(f)))return f}return _.join(c,l)}E.findExecutable=v})(C||(e.win32=C={}))}),define(ae[150],ce([0,1,67,23]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=A;function A(k){return new Promise((R,P)=>{let d;const C=new Map;function E(l,c,p,g,u){const h=C.get(c);if(l===k||h){const m={name:v(p),cmd:p,pid:l,ppid:c,load:g,mem:u};C.set(l,m),l===k&&(d=m),h&&(h.children||(h.children=[]),h.children.push(m),h.children.length>1&&(h.children=h.children.sort((f,S)=>f.pid-S.pid)))}}function v(l){const c=/--utility-sub-type=network/i,p=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,h=/--type=([a-zA-Z-]+)/;if(p.exec(l))return"electron-crash-reporter";if(g.exec(l))return"winpty-agent";if(u.exec(l))return"conpty-agent";let m=h.exec(l);if(m&&m.length===2)return m[1]==="renderer"?"window":m[1]==="utility"?c.exec(l)?"utility-network-service":"utility-process":m[1]==="extensionHost"?"extension-host":m[1];const f=/[a-zA-Z-]+\.js/g;let S="";do m=f.exec(l),m&&(S+=m+" ");while(m);return S&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${S})`:l}if(process.platform==="win32"){const l=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substring(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substring(5):c;new Promise((c,p)=>{ne(["@vscode/windows-process-tree"],c,p)}).then(c=>{c.getProcessList(k,p=>{if(!p){P(new Error(`Root process ${k} not found`));return}c.getProcessCpuUsage(p,g=>{const u=new Map;g.forEach(h=>{const m=l(h.commandLine||"");u.set(h.pid,{name:v(m),cmd:m,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),d=u.get(k),d?(u.forEach(h=>{const m=u.get(h.ppid);m&&(m.children||(m.children=[]),m.children.push(h))}),u.forEach(h=>{h.children&&(h.children=h.children.sort((m,f)=>m.pid-f.pid))}),R(d)):P(new Error(`Root process ${k} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let l=function(){let c=[d];const p=[];for(;c.length;){const u=c.shift();u&&(p.push(u.pid),u.children&&(c=c.concat(u.children)))}let g=JSON.stringify(U.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);g+=" "+p.join(" "),(0,_.exec)(g,{},(u,h,m)=>{if(u||m)P(u||new Error(m.toString()));else{const f=h.toString().split(`
`);for(let S=0;S<p.length;S++){const t=C.get(p[S]);t.load=parseFloat(f[S])}if(!d){P(new Error(`Root process ${k} not found`));return}R(d)}})};(0,_.exec)("which ps",{},(c,p,g)=>{if(c||g)if(process.platform!=="linux")P(c||new Error(g.toString()));else{const u=JSON.stringify(U.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,_.exec)(u,{},(h,m,f)=>{h||f?P(h||new Error(f.toString())):(O(m,E),l())})}else{const u=p.toString().trim();(0,_.exec)(`${u} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,f,S)=>{m||S&&!S.includes("screen size is bogus")?P(m||new Error(S.toString())):(O(f,E),process.platform==="linux"?l():d?R(d):P(new Error(`Root process ${k} not found`)))})}})}})}function O(k,R){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=k.toString().split(`
`);for(const C of d){const E=P.exec(C.trim());E&&E.length===6&&R(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var Ce=this&&this.__decorate||function(ne,e,_,U){var A=arguments.length,O=A<3?e:U===null?U=Object.getOwnPropertyDescriptor(e,_):U,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(ne,e,_,U);else for(var R=ne.length-1;R>=0;R--)(k=ne[R])&&(O=(A<3?k(O):A>3?k(e,_,O):k(e,_))||O);return A>3&&O&&Object.defineProperty(e,_,O),O};define(ae[42],ce([0,1,17,6,15,26,84,7,3,2,66,27,13]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=o,e.deserialize=a,e.getDelayedChannel=L,e.getNextTickChannel=N;var l;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(l||(l={}));function c(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(p||(p={}));function g(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(u||(u={}));function h(V){let q=0;for(let ie=0;;ie+=7){const re=V.read(1);if(q|=(re.buffer[0]&127)<<ie,!(re.buffer[0]&128))return q}}const m=n(0);function f(V,q){if(q===0){V.write(m);return}let ie=0;for(let ue=q;ue!==0;ue=ue>>>7)ie++;const re=A.VSBuffer.alloc(ie);for(let ue=0;q!==0;ue++)re.buffer[ue]=q&127,q=q>>>7,q>0&&(re.buffer[ue]|=128);V.write(re)}class S{constructor(q){this.buffer=q,this.pos=0}read(q){const ie=this.buffer.slice(this.pos,this.pos+q);return this.pos+=ie.byteLength,ie}}e.BufferReader=S;class t{constructor(){this.buffers=[]}get buffer(){return A.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}e.BufferWriter=t;var r;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(r||(r={}));function n(V){const q=A.VSBuffer.alloc(1);return q.writeUInt8(V,0),q}const s={Undefined:n(r.Undefined),String:n(r.String),Buffer:n(r.Buffer),VSBuffer:n(r.VSBuffer),Array:n(r.Array),Object:n(r.Object),Uint:n(r.Int)},i=typeof Buffer<"u";function o(V,q){if(typeof q>"u")V.write(s.Undefined);else if(typeof q=="string"){const ie=A.VSBuffer.fromString(q);V.write(s.String),f(V,ie.byteLength),V.write(ie)}else if(i&&Buffer.isBuffer(q)){const ie=A.VSBuffer.wrap(q);V.write(s.Buffer),f(V,ie.byteLength),V.write(ie)}else if(q instanceof A.VSBuffer)V.write(s.VSBuffer),f(V,q.byteLength),V.write(q);else if(Array.isArray(q)){V.write(s.Array),f(V,q.length);for(const ie of q)o(V,ie)}else if(typeof q=="number"&&(q|0)===q)V.write(s.Uint),f(V,q);else{const ie=A.VSBuffer.fromString(JSON.stringify(q));V.write(s.Object),f(V,ie.byteLength),V.write(ie)}}function a(V){switch(V.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return V.read(h(V)).toString();case r.Buffer:return V.read(h(V)).buffer;case r.VSBuffer:return V.read(h(V));case r.Array:{const ie=h(V),re=[];for(let ue=0;ue<ie;ue++)re.push(a(V));return re}case r.Object:return JSON.parse(V.read(h(V)).toString());case r.Int:return h(V)}}class y{constructor(q,ie,re=null,ue=1e3){this.protocol=q,this.ctx=ie,this.logger=re,this.timeoutDelay=ue,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(te=>this.onRawMessage(te)),this.sendResponse({type:200})}registerChannel(q,ie){this.channels.set(q,ie),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const ie=this.send([q.type]);this.logger?.logOutgoing(ie,0,1,g(q.type));return}case 201:case 202:case 204:case 203:{const ie=this.send([q.type,q.id],q.data);this.logger?.logOutgoing(ie,q.id,1,g(q.type),q.data);return}}}send(q,ie=void 0){const re=new t;return o(re,q),o(re,ie),this.sendBuffer(re.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const ie=new S(q),re=a(ie),ue=a(ie),te=re[0];switch(te){case 100:return this.logger?.logIncoming(q.byteLength,re[1],1,`${c(te)}: ${re[2]}.${re[3]}`,ue),this.onPromise({type:te,id:re[1],channelName:re[2],name:re[3],arg:ue});case 102:return this.logger?.logIncoming(q.byteLength,re[1],1,`${c(te)}: ${re[2]}.${re[3]}`,ue),this.onEventListen({type:te,id:re[1],channelName:re[2],name:re[3],arg:ue});case 101:return this.logger?.logIncoming(q.byteLength,re[1],1,`${c(te)}`),this.disposeActiveRequest({type:te,id:re[1]});case 103:return this.logger?.logIncoming(q.byteLength,re[1],1,`${c(te)}`),this.disposeActiveRequest({type:te,id:re[1]})}}onPromise(q){const ie=this.channels.get(q.channelName);if(!ie){this.collectPendingRequest(q);return}const re=new O.CancellationTokenSource;let ue;try{ue=ie.call(this.ctx,q.name,q.arg,re.token)}catch(W){ue=Promise.reject(W)}const te=q.id;ue.then(W=>{this.sendResponse({id:te,data:W,type:201})},W=>{W instanceof Error?this.sendResponse({id:te,data:{message:W.message,name:W.name,stack:W.stack?W.stack.split?W.stack.split(`
`):W.stack:void 0},type:202}):this.sendResponse({id:te,data:W,type:203})}).finally(()=>{j.dispose(),this.activeRequests.delete(q.id)});const j=(0,d.toDisposable)(()=>re.cancel());this.activeRequests.set(q.id,j)}onEventListen(q){const ie=this.channels.get(q.channelName);if(!ie){this.collectPendingRequest(q);return}const re=q.id,te=ie.listen(this.ctx,q.name,q.arg)(j=>this.sendResponse({id:re,data:j,type:204}));this.activeRequests.set(q.id,te)}disposeActiveRequest(q){const ie=this.activeRequests.get(q.id);ie&&(ie.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let ie=this.pendingRequests.get(q.channelName);ie||(ie=[],this.pendingRequests.set(q.channelName,ie));const re=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);ie.push({request:q,timeoutTimer:re})}flushPendingRequests(q){const ie=this.pendingRequests.get(q);if(ie){for(const re of ie)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.onPromise(re.request);break;case 102:this.onEventListen(re.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=y;var I;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class w{constructor(q,ie=null){this.protocol=q,this.isDisposed=!1,this.state=u.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new P.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(re=>this.onBuffer(re)),this.logger=ie}getChannel(q){const ie=this;return{call(re,ue,te){return ie.isDisposed?Promise.reject(new R.CancellationError):ie.requestPromise(q,re,ue,te)},listen(re,ue){return ie.isDisposed?P.Event.None:ie.requestEvent(q,re,ue)}}}requestPromise(q,ie,re,ue=O.CancellationToken.None){const te=this.lastRequestId++,W={id:te,type:100,channelName:q,name:ie,arg:re};if(ue.isCancellationRequested)return Promise.reject(new R.CancellationError);let T;return new Promise(($,Q)=>{if(ue.isCancellationRequested)return Q(new R.CancellationError);const G=()=>{const se=he=>{switch(he.type){case 201:this.handlers.delete(te),$(he.data);break;case 202:{this.handlers.delete(te);const ge=new Error(he.data.message);ge.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,ge.name=he.data.name,Q(ge);break}case 203:this.handlers.delete(te),Q(he.data);break}};this.handlers.set(te,se),this.sendRequest(W)};let ee=null;this.state===u.Idle?G():(ee=(0,U.createCancelablePromise)(se=>this.whenInitialized()),ee.then(()=>{ee=null,G()}));const Z=()=>{ee?(ee.cancel(),ee=null):this.sendRequest({id:te,type:101}),Q(new R.CancellationError)},J=ue.onCancellationRequested(Z);T=(0,d.combinedDisposable)((0,d.toDisposable)(Z),J),this.activeRequests.add(T)}).finally(()=>{T.dispose(),this.activeRequests.delete(T)})}requestEvent(q,ie,re){const ue=this.lastRequestId++,j={id:ue,type:102,channelName:q,name:ie,arg:re};let W=null;const T=new P.Emitter({onWillAddFirstListener:()=>{W=(0,U.createCancelablePromise)($=>this.whenInitialized()),W.then(()=>{W=null,this.activeRequests.add(T),this.sendRequest(j)})},onDidRemoveLastListener:()=>{W?(W.cancel(),W=null):(this.activeRequests.delete(T),this.sendRequest({id:ue,type:103}))}}),M=$=>T.fire($.data);return this.handlers.set(ue,M),T.event}sendRequest(q){switch(q.type){case 100:case 102:{const ie=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger?.logOutgoing(ie,q.id,0,`${c(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const ie=this.send([q.type,q.id]);this.logger?.logOutgoing(ie,q.id,0,c(q.type));return}}}send(q,ie=void 0){const re=new t;return o(re,q),o(re,ie),this.sendBuffer(re.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const ie=new S(q),re=a(ie),ue=a(ie),te=re[0];switch(te){case 200:return this.logger?.logIncoming(q.byteLength,0,0,g(te)),this.onResponse({type:re[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(q.byteLength,re[1],0,g(te),ue),this.onResponse({type:re[0],id:re[1],data:ue})}}onResponse(q){if(q.type===200){this.state=u.Idle,this._onDidInitialize.fire();return}this.handlers.get(q.id)?.(q)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=w,Ce([k.memoize],w.prototype,"onDidInitializePromise",null);class b{get connections(){const q=[];return this._connections.forEach(ie=>q.push(ie)),q}constructor(q,ie,re){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new P.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new P.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new d.DisposableStore,this.disposables.add(q(({protocol:ue,onDidClientDisconnect:te})=>{const j=P.Event.once(ue.onMessage);this.disposables.add(j(W=>{const T=new S(W),M=a(T),$=new y(ue,M,ie,re),Q=new w(ue,ie);this.channels.forEach((ee,Z)=>$.registerChannel(Z,ee));const G={channelServer:$,channelClient:Q,ctx:M};this._connections.add(G),this._onDidAddConnection.fire(G),this.disposables.add(te(()=>{$.dispose(),Q.dispose(),this._connections.delete(G),this._onDidRemoveConnection.fire(G)}))}))}))}getChannel(q,ie){const re=this;return{call(ue,te,j){let W;if((0,v.isFunction)(ie)){const M=(0,_.getRandomElement)(re.connections.filter(ie));W=M?Promise.resolve(M):P.Event.toPromise(P.Event.filter(re.onDidAddConnection,ie))}else W=ie.routeCall(re,ue,te);const T=W.then(M=>M.channelClient.getChannel(q));return L(T).call(ue,te,j)},listen(ue,te){if((0,v.isFunction)(ie))return re.getMulticastEvent(q,ie,ue,te);const j=ie.routeEvent(re,ue,te).then(W=>W.channelClient.getChannel(q));return L(j).listen(ue,te)}}}getMulticastEvent(q,ie,re,ue){const te=this;let j;const W=new P.Emitter({onWillAddFirstListener:()=>{j=new d.DisposableStore;const T=new P.EventMultiplexer,M=new Map,$=G=>{const Z=G.channelClient.getChannel(q).listen(re,ue),J=T.add(Z);M.set(G,J)},Q=G=>{const ee=M.get(G);ee&&(ee.dispose(),M.delete(G))};te.connections.filter(ie).forEach($),P.Event.filter(te.onDidAddConnection,ie)($,void 0,j),te.onDidRemoveConnection(Q,void 0,j),T.event(W.fire,W,j),j.add(T)},onDidRemoveLastListener:()=>{j?.dispose(),j=void 0}});return W.event}registerChannel(q,ie){this.channels.set(q,ie);for(const re of this._connections)re.channelServer.registerChannel(q,ie)}dispose(){this.disposables.dispose();for(const q of this._connections)q.channelClient.dispose(),q.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=b;class D{constructor(q,ie,re=null){const ue=new t;o(ue,ie),q.send(ue.buffer),this.channelClient=new w(q,re),this.channelServer=new y(q,ie,re)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,ie){this.channelServer.registerChannel(q,ie)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=D;function L(V){return{call(q,ie,re){return V.then(ue=>ue.call(q,ie,re))},listen(q,ie){const re=new P.Relay;return V.then(ue=>re.input=ue.listen(q,ie)),re.event}}}function N(V){let q=!1;return{call(ie,re,ue){return q?V.call(ie,re,ue):(0,U.timeout)(0).then(()=>q=!0).then(()=>V.call(ie,re,ue))},listen(ie,re){if(q)return V.listen(ie,re);const ue=new P.Relay;return(0,U.timeout)(0).then(()=>q=!0).then(()=>ue.input=V.listen(ie,re)),ue.event}}}class F{constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const ie of q.connections)if(await Promise.resolve(this.fn(ie.ctx)))return Promise.resolve(ie);return await P.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=F;var x;(function(V){function q(te,j,W){const T=te,M=W&&W.disableMarshalling,$=new Map;for(const Q in T)re(Q)&&$.set(Q,P.Event.buffer(T[Q],!0,void 0,j));return new class{listen(Q,G,ee){const Z=$.get(G);if(Z)return Z;const J=T[G];if(typeof J=="function"){if(ue(G))return J.call(T,ee);if(re(G))return $.set(G,P.Event.buffer(T[G],!0,void 0,j)),$.get(G)}throw new R.ErrorNoTelemetry(`Event not found: ${G}`)}call(Q,G,ee){const Z=T[G];if(typeof Z=="function"){if(!M&&Array.isArray(ee))for(let se=0;se<ee.length;se++)ee[se]=(0,C.revive)(ee[se]);let J=Z.apply(T,ee);return J instanceof Promise||(J=Promise.resolve(J)),J}throw new R.ErrorNoTelemetry(`Method not found: ${G}`)}}}V.fromService=q;function ie(te,j){const W=j&&j.disableMarshalling;return new Proxy({},{get(T,M){if(typeof M=="string")return j?.properties?.has(M)?j.properties.get(M):ue(M)?function($){return te.listen(M,$)}:re(M)?te.listen(M):async function(...$){let Q;j&&!(0,v.isUndefinedOrNull)(j.context)?Q=[j.context,...$]:Q=$;const G=await te.call(M,Q);return W?G:(0,C.revive)(G)};throw new R.ErrorNoTelemetry(`Property not found: ${String(M)}`)}})}V.toService=ie;function re(te){return te[0]==="o"&&te[1]==="n"&&E.isUpperAsciiLetter(te.charCodeAt(2))}function ue(te){return/^onDynamic/.test(te)&&E.isUpperAsciiLetter(te.charCodeAt(9))}})(x||(e.ProxyChannel=x={}));const X=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function B(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const q=V.toString();if(q!=="[object Object]")return q}return V}function Y(V){return Array.isArray(V)?V.map(B):B(V)}function z(V,q,ie,re,ue,te,j){j=Y(j);const W=X[ue],T=W[re%W.length];let M=[`%c[${V}]%c[${String(q).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${T}`];/\($/.test(te)?(M=M.concat(j),M.push(")")):M.push(j),console.log.apply(console,M)}class H{constructor(q,ie){this._outgoingPrefix=q,this._incomingPrefix=ie,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,ie,re,ue,te){this._totalOutgoing+=q,z(this._outgoingPrefix,this._totalOutgoing,q,ie,re,ue,te)}logIncoming(q,ie,re,ue,te){this._totalIncoming+=q,z(this._incomingPrefix,this._totalIncoming,q,ie,re,ue,te)}}e.IPCLogger=H}),define(ae[68],ce([0,1,15,3,2,42]),function(ne,e,_,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(k||(e.SocketDiagnosticsEventType=k={}));var R;(function(s){s.enableDiagnostics=!1,s.records=[];const i=new WeakMap;let o=0;function a(I,w){if(!i.has(I)){const b=String(++o);i.set(I,b)}return i.get(I)}function y(I,w,b,D){if(!s.enableDiagnostics)return;const L=a(I,w);if(D instanceof _.VSBuffer||D instanceof Uint8Array||D instanceof ArrayBuffer||ArrayBuffer.isView(D)){const N=_.VSBuffer.alloc(D.byteLength);N.set(D),s.records.push({timestamp:Date.now(),id:L,label:w,type:b,buff:N})}else s.records.push({timestamp:Date.now(),id:L,label:w,type:b,data:D})}s.traceSocketEvent=y})(R||(e.SocketDiagnostics=R={}));var P;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(P||(e.SocketCloseEventType=P={}));let d=null;function C(){return d||(d=_.VSBuffer.alloc(0)),d}class E{get byteLength(){return this._totalLength}constructor(){this._chunks=[],this._totalLength=0}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,o){if(i===0)return C();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const w=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=i),w}if(this._chunks[0].byteLength>i){const w=this._chunks[0].slice(0,i);return o&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),w}const a=_.VSBuffer.alloc(i);let y=0,I=0;for(;i>0;){const w=this._chunks[I];if(w.byteLength>i){const b=w.slice(0,i);a.set(b,y),y+=i,o&&(this._chunks[I]=w.slice(i),this._totalLength-=i),i-=i}else a.set(w,y),y+=w.byteLength,o?(this._chunks.shift(),this._totalLength-=w.byteLength):I++,i-=w.byteLength}return a}}e.ChunkStream=E;var v;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(v||(v={}));function l(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var c;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(c||(e.ProtocolConstants=c={}));class p{constructor(i,o,a,y){this.type=i,this.id=o,this.ack=a,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends A.Disposable{constructor(i){super(),this._onMessage=this._register(new U.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:l(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,y=this._state.id,I=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new p(a,y,I,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class u{constructor(i){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=_.VSBuffer.alloc(13);o.writeUInt8(i.type,0),o.writeUInt32BE(i.id,1),o.writeUInt32BE(i.ack,5),o.writeUInt32BE(i.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:l(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",i.data),this._writeSoon(o,i.data)}_bufferAdd(i,o){const a=this._totalLength===0;return this._data.push(i,o),this._totalLength+=i.byteLength+o.byteLength,a}_bufferTake(){const i=_.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,o){this._bufferAdd(i,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const i=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this._socket.write(i)}}class h extends A.Disposable{constructor(i){super(),this._onMessage=new U.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new U.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new u(this._socket)),this._socketReader=this._register(new g(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new p(1,0,0,i))}}e.Protocol=h;class m extends O.IPCClient{static fromSocket(i,o){return new m(new h(i),o)}get onDidDispose(){return this.protocol.onDidDispose}constructor(i,o,a=null){super(i,o,a),this.protocol=i}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=m;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new U.Emitter({onWillAddFirstListener:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onDidRemoveLastListener:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class S{constructor(i){this.data=i,this.next=null}}class t{constructor(){this._first=null,this._last=null}length(){let i=0,o=this._first;for(;o;)o=o.next,i++;return i}peek(){return this._first?this._first.data:null}toArray(){const i=[];let o=0,a=this._first;for(;a;)i[o++]=a.data,a=a.next;return i}pop(){if(this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const o=new S(i);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class r{static{this._HISTORY_LENGTH=10}static{this._INSTANCE=null}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}constructor(){this.lastRuns=[];const i=Date.now();for(let o=0;o<r._HISTORY_LENGTH;o++)this.lastRuns[o]=i-1e3*o;setInterval(()=>{for(let o=r._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}load(){const i=Date.now(),o=(1+r._HISTORY_LENGTH)*1e3;let a=0;for(let y=0;y<r._HISTORY_LENGTH;y++)i-this.lastRuns[y]<=o&&a++;return 1-a/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}class n{get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}constructor(i){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=i.loadEstimator??r.getInstance(),this._shouldSendKeepAlive=i.sendKeepAlive??!0,this._isReconnecting=!1,this._outgoingUnackMsg=new t,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=new A.DisposableStore,this._socket=i.socket,this._socketWriter=this._socketDisposables.add(new u(this._socket)),this._socketReader=this._socketDisposables.add(new g(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.add(this._socket.onClose(o=>this._onSocketClose.fire(o))),i.initialChunk&&this._socketReader.acceptChunk(i.initialChunk),this._shouldSendKeepAlive?this._keepAliveInterval=setInterval(()=>{this._sendKeepAlive()},5e3):this._keepAliveInterval=null}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._keepAliveInterval&&(clearInterval(this._keepAliveInterval),this._keepAliveInterval=null),this._socketDisposables.dispose()}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new p(5,0,0,C());this._socketWriter.write(i),this._socketWriter.flush()}sendPause(){const i=new p(7,0,0,C());this._socketWriter.write(i)}sendResume(){const i=new p(8,0,0,C());this._socketWriter.write(i)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,o){this._isReconnecting=!0,this._socketDisposables.dispose(),this._socketDisposables=new A.DisposableStore,this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=i,this._socketWriter=this._socketDisposables.add(new u(this._socket)),this._socketReader=this._socketDisposables.add(new g(this._socket)),this._socketDisposables.add(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.add(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const i=new p(3,0,this._incomingAckId,C());this._socketWriter.write(i);const o=this._outgoingUnackMsg.toArray();for(let a=0,y=o.length;a<y;a++)this._socketWriter.write(o[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new p(6,0,0,C())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data);break}case 2:{this._onControlMessage.fire(i.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let a=0,y=o.length;a<y;a++)this._socketWriter.write(o[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}case 9:break}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new p(1,o,this._incomingAckId,i);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(i){const o=new p(2,0,0,i);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),o=Date.now()-i.writtenTime,a=Date.now()-this._socketReader.lastReadTime,y=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&a>=2e4&&y>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:a});return}const I=Math.max(2e4-o,2e4-a,2e4-y,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},I)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new p(3,0,this._incomingAckId,C());this._socketWriter.write(i)}_sendKeepAlive(){this._incomingAckId=this._incomingMsgId;const i=new p(9,0,this._incomingAckId,C());this._socketWriter.write(i)}}e.PersistentProtocol=n}),define(ae[92],ce([0,1,67,6,15,26,142,7,3,2,30,149,89,42]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class c extends l.ChannelServer{constructor(u){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",h=>A.VSBuffer.wrap(Buffer.from(h,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.Server=c;class p{constructor(u,h){this.modulePath=u,this.options=h,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new P.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const m=h&&h.timeout?h.timeout:6e4;this.disposeDelayer=new U.Delayer(m),this.child=null,this._client=null}getChannel(u){const h=this;return{call(m,f,S){return h.requestPromise(u,m,f,S)},listen(m,f){return h.requestEvent(u,m,f)}}}requestPromise(u,h,m,f=O.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const S=this.getCachedChannel(u),t=(0,U.createCancelablePromise)(s=>S.call(h,m,s)),r=f.onCancellationRequested(()=>t.cancel()),n=(0,d.toDisposable)(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{r.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(u,h,m){if(!this.disposeDelayer)return P.Event.None;this.disposeDelayer.cancel();let f;const S=new P.Emitter({onWillAddFirstListener:()=>{f=this.getCachedChannel(u).listen(h,m)(S.fire,S),this.activeRequests.add(f)},onDidRemoveLastListener:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return S.event}get client(){if(!this._client){const u=this.options&&this.options.args?this.options.args:[],h=Object.create(null);h.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(h.env={...h.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(h.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,v.removeDangerousEnvVariables)(h.env),this.child=(0,_.fork)(this.modulePath,u,h);const m=new P.Emitter,S=P.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,k.isRemoteConsoleLog)(o)){(0,k.log)(o,`IPC Library: ${this.options.serverName}`);return}m.fire(A.VSBuffer.wrap(Buffer.from(o,"base64")))}),t=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,r=o=>this.child&&this.child.connected&&t.send(o.buffer.toString("base64")),n=m.event,s={send:r,onMessage:n};this._client=new l.ChannelClient(s);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,a)=>{process.removeListener("exit",i),S.dispose(),this.activeRequests.forEach(y=>(0,d.dispose)(y)),this.activeRequests.clear(),o!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+a),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:a})})}return this._client}getCachedChannel(u){let h=this.channels.get(u);return h||(h=this.client.getChannel(u),this.channels.set(u,h)),h}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=p}),define(ae[151],ce([0,1,134,15,42,3,13,17]),function(ne,e,_,U,A,O,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0,e.once=C;class P{constructor(v){this.port=v,this.onMessage=O.Event.fromNodeEventEmitter(this.port,"message",l=>l.data?U.VSBuffer.wrap(l.data):U.VSBuffer.alloc(0)),v.start()}send(v){this.port.postMessage(v.buffer)}disconnect(){this.port.close()}}class d extends A.IPCServer{static getOnDidClientConnect(v){(0,k.assertType)((0,_.isUtilityProcess)(process),"Electron Utility Process");const l=new O.Emitter;return process.parentPort.on("message",c=>{if(v?.handledClientConnection(c))return;const p=(0,R.firstOrDefault)(c.ports);p&&l.fire(p)}),O.Event.map(l.event,c=>({protocol:new P(c),onDidClientDisconnect:O.Event.fromNodeEventEmitter(c,"close")}))}constructor(v){super(d.getOnDidClientConnect(v))}}e.Server=d;function C(E,v,l){const c=p=>{p.data===v&&(E.removeListener("message",c),l())};E.on("message",c)}}),define(ae[69],ce([0,1,6,3,2,66,13]),function(ne,e,_,U,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.StorageHint=void 0,e.isStorageItemsChangeEvent=P;var R;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function P(v){const l=v;return l?.changed instanceof Map||l?.deleted instanceof Set}var d;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(d||(e.StorageState=d={}));class C extends A.Disposable{static{this.DEFAULT_FLUSH_DELAY=100}constructor(l,c=Object.create(null)){super(),this.database=l,this.options=c,this._onDidChangeStorage=this._register(new U.PauseableEmitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=d.None,this.cache=new Map,this.flushDelayer=this._register(new _.ThrottledDelayer(C.DEFAULT_FLUSH_DELAY)),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(l=>this.onDidChangeItemsExternal(l)))}onDidChangeItemsExternal(l){this._onDidChangeStorage.pause();try{l.changed?.forEach((c,p)=>this.acceptExternal(p,c)),l.deleted?.forEach(c=>this.acceptExternal(c,void 0))}finally{this._onDidChangeStorage.resume()}}acceptExternal(l,c){if(this.state===d.Closed)return;let p=!1;(0,k.isUndefinedOrNull)(c)?p=this.cache.delete(l):this.cache.get(l)!==c&&(this.cache.set(l,c),p=!0),p&&this._onDidChangeStorage.fire({key:l,external:!0})}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===d.None&&(this.state=d.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(l,c){const p=this.cache.get(l);return(0,k.isUndefinedOrNull)(p)?c:p}getBoolean(l,c){const p=this.get(l);return(0,k.isUndefinedOrNull)(p)?c:p==="true"}getNumber(l,c){const p=this.get(l);return(0,k.isUndefinedOrNull)(p)?c:parseInt(p,10)}getObject(l,c){const p=this.get(l);return(0,k.isUndefinedOrNull)(p)?c:(0,O.parse)(p)}async set(l,c,p=!1){if(this.state===d.Closed)return;if((0,k.isUndefinedOrNull)(c))return this.delete(l,p);const g=(0,k.isObject)(c)||Array.isArray(c)?(0,O.stringify)(c):String(c);if(this.cache.get(l)!==g)return this.cache.set(l,g),this.pendingInserts.set(l,g),this.pendingDeletes.delete(l),this._onDidChangeStorage.fire({key:l,external:p}),this.doFlush()}async delete(l,c=!1){if(!(this.state===d.Closed||!this.cache.delete(l)))return this.pendingDeletes.has(l)||this.pendingDeletes.add(l),this.pendingInserts.delete(l),this._onDidChangeStorage.fire({key:l,external:c}),this.doFlush()}async optimize(){if(this.state!==d.Closed)return await this.flush(0),this.database.optimize()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=d.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const l={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(l).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(l){if(this.hasPending)return this.doFlush(l)}async doFlush(l){return this.options.hint===R.STORAGE_IN_MEMORY?this.flushPending():this.flushDelayer.trigger(()=>this.flushPending(),l)}async whenFlushed(){if(this.hasPending)return new Promise(l=>this.whenFlushedCallbacks.push(l))}isInMemory(){return this.options.hint===R.STORAGE_IN_MEMORY}}e.Storage=C;class E{constructor(){this.onDidChangeItemsExternal=U.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(l){l.insert?.forEach((c,p)=>this.items.set(p,c)),l.delete?.forEach(c=>this.items.delete(c))}async optimize(){}async close(){}}e.InMemoryStorageDatabase=E}),define(ae[152],ce([11,10]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(ae[70],ce([0,1,41,6,14,13,31,152]),function(ne,e,_,U,A,O,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtractError=e.CorruptZipMessage=void 0,e.zip=g,e.extract=u,e.buffer=m,e.CorruptZipMessage="end of central directory record signature not found";const P=new RegExp(e.CorruptZipMessage);class d extends Error{constructor(S,t){let r=t.message;switch(S){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=S,this.cause=t}}e.ExtractError=d;function C(f){const S=f.externalFileAttributes>>16||33188;return[448,56,7].map(t=>S&t).reduce((t,r)=>t+r,S&61440)}function E(f){if(f instanceof d)return f;let S;return P.test(f.message)&&(S="CorruptZip"),new d(S,f)}function v(f,S,t,r,n,s){const i=A.dirname(S),o=A.join(r,i);if(!o.startsWith(r))return Promise.reject(new Error(R.localize(0,null,S)));const a=A.join(r,S);let y;return s.onCancellationRequested(()=>{y?.destroy()}),Promise.resolve(k.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((I,w)=>{if(!s.isCancellationRequested)try{y=(0,_.createWriteStream)(a,{mode:t}),y.once("close",()=>I()),y.once("error",w),f.once("error",w),f.pipe(y)}catch(b){w(b)}}))}function l(f,S,t,r){let n=(0,U.createCancelablePromise)(()=>Promise.resolve()),s=0;const i=r.onCancellationRequested(()=>{n.cancel(),f.close()});return new Promise((o,a)=>{const y=new U.Sequencer,I=w=>{w.isCancellationRequested||(s++,f.readEntry())};f.once("error",a),f.once("close",()=>n.then(()=>{r.isCancellationRequested||f.entryCount===s?o():a(new d("Incomplete",new Error(R.localize(1,null,s,f.entryCount))))},a)),f.readEntry(),f.on("entry",w=>{if(r.isCancellationRequested)return;if(!t.sourcePathRegex.test(w.fileName)){I(r);return}const b=w.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(b)){const N=A.join(S,b);n=(0,U.createCancelablePromise)(F=>k.Promises.mkdir(N,{recursive:!0}).then(()=>I(F)).then(void 0,a));return}const D=p(f,w),L=C(w);n=(0,U.createCancelablePromise)(N=>y.queue(()=>D.then(F=>v(F,b,L,S,t,N).then(()=>I(N)))).then(null,a))})}).finally(()=>i.dispose())}async function c(f,S=!1){const{open:t}=await new Promise((r,n)=>{ne(["yauzl"],r,n)});return new Promise((r,n)=>{t(f,S?{lazyEntries:!0}:void 0,(s,i)=>{s?n(E(s)):r((0,O.assertIsDefined)(i))})})}function p(f,S){return new Promise((t,r)=>{f.openReadStream(S,(n,s)=>{n?r(E(n)):t((0,O.assertIsDefined)(s))})})}async function g(f,S){const{ZipFile:t}=await new Promise((r,n)=>{ne(["yazl"],r,n)});return new Promise((r,n)=>{const s=new t;S.forEach(o=>{o.contents?s.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&s.addFile(o.localPath,o.path)}),s.end();const i=(0,_.createWriteStream)(f);s.outputStream.pipe(i),s.outputStream.once("error",n),i.once("error",n),i.once("finish",()=>r(f))})}function u(f,S,t={},r){const n=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let s=c(f,!0);return t.overwrite&&(s=s.then(i=>k.Promises.rm(S).then(()=>i))),s.then(i=>l(i,S,{sourcePathRegex:n},r))}function h(f,S){return c(f).then(t=>new Promise((r,n)=>{t.on("entry",s=>{s.fileName===S&&p(t,s).then(i=>r(i),i=>n(i))}),t.once("close",()=>n(new Error(R.localize(2,null,S))))}))}function m(f,S){return h(f,S).then(t=>new Promise((r,n)=>{const s=[];t.once("error",n),t.on("data",i=>s.push(i)),t.on("end",()=>r(Buffer.concat(s)))}))}}),define(ae[153],ce([11,10]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[154],ce([11,10]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[155],ce([11,10]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(ae[156],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ae[157],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[158],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[159],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[160],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ae[161],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ae[162],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[163],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(ae[164],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ae[165],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(ae[166],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[167],ce([11,10]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ae[168],ce([11,10]),function(ne,e){return ne.create("vs/platform/log/common/log",e)}),define(ae[169],ce([11,10]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ae[170],ce([11,10]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(ae[171],ce([11,10]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(ae[172],ce([11,10]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ae[173],ce([11,10]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[174],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[175],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ae[176],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ae[177],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ae[178],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ae[179],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ae[180],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ae[181],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ae[182],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ae[183],ce([11,10]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ae[184],ce([0,1,7,155]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var A;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(A||(e.TokenType=A={}));function O(...d){switch(d.length){case 1:return(0,U.localize)(0,null,d[0]);case 2:return(0,U.localize)(1,null,d[0],d[1]);case 3:return(0,U.localize)(2,null,d[0],d[1],d[2]);default:return}}const k=(0,U.localize)(3,null),R=(0,U.localize)(4,null);class P{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,_.illegalState)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(C){return this._input=C,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const E=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:E})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const E=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:E})}else this._match(126)?this._addToken(9):this._error(O("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(O("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(C){return this._isAtEnd()||this._input.charCodeAt(this._current)!==C?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(C){this._tokens.push({type:C,offset:this._start})}_error(C){const E=this._start,v=this._input.substring(this._start,this._current),l={type:19,offset:this._start,lexeme:v};this._errors.push({offset:E,lexeme:v,additionalInfo:C}),this._tokens.push(l)}_string(){this.stringRe.lastIndex=this._start;const C=this.stringRe.exec(this._input);if(C){this._current=this._start+C[0].length;const E=this._input.substring(this._start,this._current),v=P._keywords.get(E);v?this._addToken(v):this._tokens.push({type:17,lexeme:E,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(k);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let C=this._current,E=!1,v=!1;for(;;){if(C>=this._input.length){this._current=C,this._error(R);return}const c=this._input.charCodeAt(C);if(E)E=!1;else if(c===47&&!v){C++;break}else c===91?v=!0:c===92?E=!0:c===93&&(v=!1);C++}for(;C<this._input.length&&P._regexFlags.has(this._input.charCodeAt(C));)C++;this._current=C;const l=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:l,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=P}),define(ae[185],ce([0,1,65,84,23,14,36,20,8]),function(ne,e,_,U,A,O,k,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=C,e.parseDebugParams=E,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class d{get appRoot(){return(0,O.dirname)(A.FileAccess.asFileUri("").fsPath)}get userHome(){return P.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return P.URI.file((0,O.join)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.paths.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,R.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:A.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.join)(this.userDataPath,"logs",l)}return P.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(P.URI.file((0,O.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=k.env.VSCODE_PORTABLE;return l?P.URI.file((0,O.join)(l,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,O.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,O.resolve)(l):(0,O.normalize)((0,O.join)(A.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?P.URI.file((0,O.resolve)(l)):P.URI.file((0,O.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,O.resolve)(l);const c=k.env.VSCODE_EXTENSIONS;if(c)return c;const p=k.env.VSCODE_PORTABLE;return p?(0,O.join)(p,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(c=>/^[^:/?#]+?:\/\//.test(c)?P.URI.parse(c):P.URI.file((0,O.normalize)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?P.URI.parse(l):P.URI.file((0,O.normalize)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(l))}get extensionLogLevel(){const l=[];for(const c of this.args.log||[]){const p=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(c);p&&p[1]&&p[2]&&l.push([p[1],p[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,R.joinPath)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=k.env.VSCODE_PORTABLE;return l?P.URI.file((0,O.join)(l,"policy.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this._args}constructor(l,c,p){this._args=l,this.paths=c,this.productService=p,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=d,Ce([U.memoize],d.prototype,"appRoot",null),Ce([U.memoize],d.prototype,"userHome",null),Ce([U.memoize],d.prototype,"userDataPath",null),Ce([U.memoize],d.prototype,"appSettingsHome",null),Ce([U.memoize],d.prototype,"tmpDir",null),Ce([U.memoize],d.prototype,"cacheHome",null),Ce([U.memoize],d.prototype,"stateResource",null),Ce([U.memoize],d.prototype,"userRoamingDataHome",null),Ce([U.memoize],d.prototype,"userDataSyncHome",null),Ce([U.memoize],d.prototype,"sync",null),Ce([U.memoize],d.prototype,"machineSettingsResource",null),Ce([U.memoize],d.prototype,"workspaceStorageHome",null),Ce([U.memoize],d.prototype,"localHistoryHome",null),Ce([U.memoize],d.prototype,"keyboardLayoutResource",null),Ce([U.memoize],d.prototype,"argvResource",null),Ce([U.memoize],d.prototype,"isExtensionDevelopment",null),Ce([U.memoize],d.prototype,"untitledWorkspacesHome",null),Ce([U.memoize],d.prototype,"builtinExtensionsPath",null),Ce([U.memoize],d.prototype,"extensionsPath",null),Ce([U.memoize],d.prototype,"extensionDevelopmentLocationURI",null),Ce([U.memoize],d.prototype,"extensionDevelopmentKind",null),Ce([U.memoize],d.prototype,"extensionTestsLocationURI",null),Ce([U.memoize],d.prototype,"debugExtensionHost",null),Ce([U.memoize],d.prototype,"logLevel",null),Ce([U.memoize],d.prototype,"extensionLogLevel",null),Ce([U.memoize],d.prototype,"serviceMachineIdResource",null),Ce([U.memoize],d.prototype,"disableTelemetry",null),Ce([U.memoize],d.prototype,"disableWorkspaceTrust",null),Ce([U.memoize],d.prototype,"useInMemorySecretStorage",null),Ce([U.memoize],d.prototype,"policyFile",null);function C(v,l){return E(v["inspect-extensions"],v["inspect-brk-extensions"],5870,l,v.debugId,v.extensionEnvironment)}function E(v,l,c,p,g,u){const m=Number(l||v)||(p?null:c),f=m?!!l:!1;let S;if(u)try{S=JSON.parse(u)}catch{}return{port:m,break:f,debugId:g,env:S}}}),function(){"use strict";function ne(e,_,U){function A(k,R){const P=O(k,R),d=[P];return e.isAbsolute(P)||d.unshift(U),e.resolve(...d)}function O(k,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,R);const C=k["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(E,"AppData","Roaming")}break;case"darwin":d=e.join(_.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(_.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,R)}return{getUserDataPath:A}}if(typeof define=="function")define(ae[186],ce([276,37,36]),function(e,_,U){return ne(e,_,U.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),_=require("os");module.exports=ne(e,_,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[187],ce([0,1,37,185,186]),function(ne,e,_,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=k,e.parseSharedProcessDebugPort=R;class O extends U.AbstractNativeEnvironmentService{constructor(d,C){super(d,{homeDir:(0,_.homedir)(),tmpDir:(0,_.tmpdir)(),userDataDir:(0,A.getUserDataPath)(d,C.nameShort)},C)}}e.NativeEnvironmentService=O;function k(P,d){return(0,U.parseDebugParams)(P["inspect-ptyhost"],P["inspect-brk-ptyhost"],5877,d,P.extensionEnvironment)}function R(P,d){return(0,U.parseDebugParams)(P["inspect-sharedprocess"],P["inspect-brk-sharedprocess"],5879,d,P.extensionEnvironment)}}),define(ae[188],ce([0,1,13,158]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=A;function A(k,R,P,d){try{O(k,R,P,d)}catch(C){k.error(C?.message??C)}return R}function O(k,R,P,d){const C=(E,v,l)=>{const c=E[v];if((0,_.isString)(c)){const p=c,g=p.length;if(g>1&&p[0]==="%"&&p[g-1]==="%"){const u=p.substr(1,g-2);let h=P[u];h===void 0&&d&&(h=d[u]);const m=typeof h=="string"?h:h?.message,f=d?.[u],S=typeof f=="string"?f:f?.message;if(!m){S||k.warn(`[${R.name}]: ${(0,U.localize)(0,null,u)}`);return}if(l&&(v==="title"||v==="category")&&S&&S!==m){const t={value:m,original:S};E[v]=t}else E[v]=m}}else if((0,_.isObject)(c))for(const p in c)c.hasOwnProperty(p)&&(p==="commands"?C(c,p,!0):C(c,p,l));else if(Array.isArray(c))for(let p=0;p<c.length;p++)C(c,p,l)};for(const E in R)R.hasOwnProperty(E)&&C(R,E)}}),define(ae[189],ce([0,1,70,161]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=A;function A(O){return(0,_.buffer)(O,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,U.localize)(0,null))}})}}),define(ae[190],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class _{constructor(O){this.channel=O}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(O){return this.channel.call("promptImportantExtensionsInstallNotification",[O])}promptWorkspaceRecommendations(O){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=_;class U{constructor(O){this.service=O}listen(O,k){throw new Error(`Event not found: ${k}`)}call(O,k,R){switch(k){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${k}`)}}e.ExtensionRecommendationNotificationServiceChannel=U}),define(ae[71],ce([0,1,20,88,162,55]),function(ne,e,_,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidVersionStr=P,e.parseVersion=d,e.normalizeVersion=C,e.isValidVersion=E,e.validateExtensionManifest=v,e.isValidExtensionVersion=l,e.isEngineValid=c;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function P(u){return u=u.trim(),u==="*"||k.test(u)}function d(u){if(!P(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=u.match(k);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}function C(u){if(!u)return null;const h=u.majorBase,m=u.majorMustEqual,f=u.minorBase;let S=u.minorMustEqual;const t=u.patchBase;let r=u.patchMustEqual;u.hasCaret&&(h===0||(S=!1),r=!1);let n=0;if(u.preRelease){const s=R.exec(u.preRelease);if(s){const[,i,o,a]=s;n=Date.UTC(Number(i),Number(o)-1,Number(a))}}return{majorBase:h,majorMustEqual:m,minorBase:f,minorMustEqual:S,patchBase:t,patchMustEqual:r,isMinimum:u.hasGreaterEquals,notBefore:n}}function E(u,h,m){let f;typeof u=="string"?f=C(d(u)):f=u;let S;h instanceof Date?S=h.getTime():typeof h=="string"&&(S=new Date(h).getTime());let t;if(typeof m=="string"?t=C(d(m)):t=m,!f||!t)return!1;const r=f.majorBase,n=f.minorBase,s=f.patchBase;let i=t.majorBase,o=t.minorBase,a=t.patchBase;const y=t.notBefore;let I=t.majorMustEqual,w=t.minorMustEqual,b=t.patchMustEqual;return t.isMinimum?r>i?!0:r<i?!1:n>o?!0:n<o||S&&S<y?!1:s>=a:(r===1&&i===0&&(!I||!w||!b)&&(i=1,o=0,a=0,I=!0,w=!1,b=!1),r<i?!1:r>i?!I:n<o?!1:n>o?!w:s<a?!1:s>a?!b:!(S&&S<y))}function v(u,h,m,f,S){const t=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return t.push([U.default.Error,A.localize(0,null)]),t;if(typeof f.name!="string")return t.push([U.default.Error,A.localize(1,null,"name")]),t;if(typeof f.version!="string")return t.push([U.default.Error,A.localize(2,null,"version")]),t;if(!f.engines)return t.push([U.default.Error,A.localize(3,null,"engines")]),t;if(typeof f.engines.vscode!="string")return t.push([U.default.Error,A.localize(4,null,"engines.vscode")]),t;if(typeof f.extensionDependencies<"u"&&!g(f.extensionDependencies))return t.push([U.default.Error,A.localize(5,null,"extensionDependencies")]),t;if(typeof f.activationEvents<"u"){if(!g(f.activationEvents))return t.push([U.default.Error,A.localize(6,null,"activationEvents")]),t;if(typeof f.main>"u"&&typeof f.browser>"u")return t.push([U.default.Error,A.localize(7,null,"activationEvents","main","browser")]),t}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&t.push([U.default.Warning,A.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return t.push([U.default.Error,A.localize(9,null,"main")]),t;{const s=(0,_.joinPath)(m,f.main);(0,_.isEqualOrParent)(s,m)||t.push([U.default.Warning,A.localize(10,null,s.path,m.path)])}}if(typeof f.browser<"u"){if(typeof f.browser!="string")return t.push([U.default.Error,A.localize(11,null,"browser")]),t;{const s=(0,_.joinPath)(m,f.browser);(0,_.isEqualOrParent)(s,m)||t.push([U.default.Warning,A.localize(12,null,s.path,m.path)])}}if(!O.valid(f.version))return t.push([U.default.Error,A.localize(13,null)]),t;const r=[];if(!l(u,h,f,S,r))for(const s of r)t.push([U.default.Error,s]);return t}function l(u,h,m,f,S){return f||typeof m.main>"u"&&typeof m.browser>"u"?!0:p(u,h,m.engines.vscode,S)}function c(u,h,m){return u==="*"||p(h,m,u)}function p(u,h,m,f=[]){const S=C(d(m));if(!S)return f.push(A.localize(14,null,m)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return f.push(A.localize(15,null,m)),!1}else if(!S.majorMustEqual)return f.push(A.localize(16,null,m)),!1;return E(u,h,S)?!0:(f.push(A.localize(17,null,u,m)),!1)}function g(u){if(!Array.isArray(u))return!1;for(let h=0,m=u.length;h<m;h++)if(typeof u[h]!="string")return!1;return!0}}),define(ae[45],ce([0,1,15,32]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=A;async function A(O,k,R){let P=R&&R.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const C=(await k.readFile(O.serviceMachineIdResource)).value.toString();P=(0,U.isUUID)(C)?C:null}catch{P=null}if(!P){P=(0,U.generateUuid)();try{await k.writeFile(O.serviceMachineIdResource,_.VSBuffer.fromString(P))}catch{}}return R?.store("storage.serviceMachineId",P,-1,1),P}}),define(ae[72],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class _{constructor(A,O=[],k=!1){this.ctor=A,this.staticArguments=O,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=_}),define(ae[191],ce([0,1,72]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.registerSingleton=O,e.getSingletonServiceDescriptors=k;const U=[];var A;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function O(R,P,d){P instanceof _.SyncDescriptor||(P=new _.SyncDescriptor(P,[],!!d)),U.push([R,P])}function k(){return U}}),define(ae[192],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class _{constructor(O,k){this.key=O,this.data=k,this.incoming=new Map,this.outgoing=new Map}}e.Node=_;class U{constructor(O){this._hashFn=O,this._nodes=new Map}roots(){const O=[];for(const k of this._nodes.values())k.outgoing.size===0&&O.push(k);return O}insertEdge(O,k){const R=this.lookupOrInsertNode(O),P=this.lookupOrInsertNode(k);R.outgoing.set(P.key,P),P.incoming.set(R.key,R)}removeNode(O){const k=this._hashFn(O);this._nodes.delete(k);for(const R of this._nodes.values())R.outgoing.delete(k),R.incoming.delete(k)}lookupOrInsertNode(O){const k=this._hashFn(O);let R=this._nodes.get(k);return R||(R=new _(k,O),this._nodes.set(k,R)),R}lookup(O){return this._nodes.get(this._hashFn(O))}isEmpty(){return this._nodes.size===0}toString(){const O=[];for(const[k,R]of this._nodes)O.push(`${k}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,k]of this._nodes){const R=new Set([O]),P=this._findCycle(k,R);if(P)return P}}_findCycle(O,k){for(const[R,P]of O.outgoing){if(k.has(R))return[...k,R].join(" -> ");k.add(R);const d=this._findCycle(P,k);if(d)return d;k.delete(R)}}}e.Graph=U}),define(ae[4],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=A,e.refineServiceDecorator=O;var _;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function R(P){return P[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=R})(_||(e._util=_={})),e.IInstantiationService=A("instantiationService");function U(k,R,P){R[_.DI_TARGET]===R?R[_.DI_DEPENDENCIES].push({id:k,index:P}):(R[_.DI_DEPENDENCIES]=[{id:k,index:P}],R[_.DI_TARGET]=R)}function A(k){if(_.serviceIds.has(k))return _.serviceIds.get(k);const R=function(P,d,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");U(R,P,C)};return R.toString=()=>k,_.serviceIds.set(k,R),R}function O(k){return k}}),define(ae[193],ce([0,1,4]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,_.createDecorator)("checksumService")}),define(ae[21],ce([0,1,13,8,4]),function(ne,e,_,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.IConfigurationService=void 0,e.isConfigurationOverrides=O,e.isConfigurationUpdateOverrides=k,e.ConfigurationTargetToString=P,e.isConfigured=d,e.toValuesTree=C,e.addToValueTree=E,e.removeFromValueTree=v,e.getConfigurationValue=c,e.merge=p,e.getLanguageTagSettingPlainKey=g,e.IConfigurationService=(0,A.createDecorator)("configurationService");function O(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof U.URI)}function k(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof U.URI)}var R;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function P(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function d(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}function C(u,h){const m=Object.create(null);for(const f in u)E(m,f,u[f],h);return m}function E(u,h,m,f){const S=h.split("."),t=S.pop();let r=u;for(let n=0;n<S.length;n++){const s=S[n];let i=r[s];switch(typeof i){case"undefined":i=r[s]=Object.create(null);break;case"object":if(i===null){f(`Ignoring ${h} as ${S.slice(0,n+1).join(".")} is null`);return}break;default:f(`Ignoring ${h} as ${S.slice(0,n+1).join(".")} is ${JSON.stringify(i)}`);return}r=i}if(typeof r=="object"&&r!==null)try{r[t]=m}catch{f(`Ignoring ${h} as ${S.join(".")} is ${JSON.stringify(r)}`)}else f(`Ignoring ${h} as ${S.join(".")} is ${JSON.stringify(r)}`)}function v(u,h){const m=h.split(".");l(u,m)}function l(u,h){const m=h.shift();if(h.length===0){delete u[m];return}if(Object.keys(u).indexOf(m)!==-1){const f=u[m];typeof f=="object"&&!Array.isArray(f)&&(l(f,h),Object.keys(f).length===0&&delete u[m])}}function c(u,h,m){function f(r,n){let s=r;for(const i of n){if(typeof s!="object"||s===null)return;s=s[i]}return s}const S=h.split("."),t=f(u,S);return typeof t>"u"?m:t}function p(u,h,m){Object.keys(h).forEach(f=>{f!=="__proto__"&&(f in u?_.isObject(u[f])&&_.isObject(h[f])?p(u[f],h[f],m):m&&(u[f]=h[f]):u[f]=h[f])})}function g(u){return u.replace(/[\[\]]/g,"")}}),define(ae[93],ce([0,1,5,27,184,4,154,7]),function(ne,e,_,U,A,O,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=d,e.validateWhenClauses=r,e.expressionsAreEqualWithConstantSubstitution=n,e.implies=ue;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",_.isMacintosh),P.set("isLinux",_.isLinux),P.set("isWindows",_.isWindows),P.set("isWeb",_.isWeb),P.set("isMacNative",_.isMacintosh&&!_.isWeb),P.set("isEdge",_.isEdge),P.set("isFirefox",_.isFirefox),P.set("isChrome",_.isChrome),P.set("isSafari",_.isSafari);function d(W,T){if(P.get(W)!==void 0)throw(0,R.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");P.set(W,T)}const C=Object.prototype.hasOwnProperty;var E;(function(W){W[W.False=0]="False",W[W.True=1]="True",W[W.Defined=2]="Defined",W[W.Not=3]="Not",W[W.Equals=4]="Equals",W[W.NotEquals=5]="NotEquals",W[W.And=6]="And",W[W.Regex=7]="Regex",W[W.NotRegex=8]="NotRegex",W[W.Or=9]="Or",W[W.In=10]="In",W[W.NotIn=11]="NotIn",W[W.Greater=12]="Greater",W[W.GreaterEquals=13]="GreaterEquals",W[W.Smaller=14]="Smaller",W[W.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const v={regexParsingWithErrorRecovery:!0},l=(0,k.localize)(0,null),c=(0,k.localize)(1,null),p=(0,k.localize)(2,null),g=(0,k.localize)(3,null),u=(0,k.localize)(4,null),h=(0,k.localize)(5,null),m=(0,k.localize)(6,null),f=(0,k.localize)(7,null);class S{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(T=v){this._config=T,this._scanner=new A.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(T){if(T===""){this._parsingErrors.push({message:l,offset:0,lexeme:"",additionalInfo:c});return}this._tokens=this._scanner.reset(T).scan(),this._current=0,this._parsingErrors=[];try{const M=this._expr();if(!this._isAtEnd()){const $=this._peek(),Q=$.type===17?h:void 0;throw this._parsingErrors.push({message:u,offset:$.offset,lexeme:A.Scanner.getLexeme($),additionalInfo:Q}),S._parseError}return M}catch(M){if(M!==S._parseError)throw M;return}}_expr(){return this._or()}_or(){const T=[this._and()];for(;this._matchOne(16);){const M=this._and();T.push(M)}return T.length===1?T[0]:t.or(...T)}_and(){const T=[this._term()];for(;this._matchOne(15);){const M=this._term();T.push(M)}return T.length===1?T[0]:t.and(...T)}_term(){if(this._matchOne(2)){const T=this._peek();switch(T.type){case 11:return this._advance(),i.INSTANCE;case 12:return this._advance(),o.INSTANCE;case 0:{this._advance();const M=this._expr();return this._consume(1,g),M?.negate()}case 17:return this._advance(),D.create(T.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",T)}}return this._primary()}_primary(){const T=this._peek();switch(T.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const M=this._expr();return this._consume(1,g),M}case 17:{const M=T.lexeme;if(this._advance(),this._matchOne(9)){const Q=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),Q.type!==10)throw this._errExpectedButGot("REGEX",Q);const G=Q.lexeme,ee=G.lastIndexOf("/"),Z=ee===G.length-1?void 0:this._removeFlagsGY(G.substring(ee+1));let J;try{J=new RegExp(G.substring(1,ee),Z)}catch{throw this._errExpectedButGot("REGEX",Q)}return B.create(M,J)}switch(Q.type){case 10:case 19:{const G=[Q.lexeme];this._advance();let ee=this._peek(),Z=0;for(let de=0;de<Q.lexeme.length;de++)Q.lexeme.charCodeAt(de)===40?Z++:Q.lexeme.charCodeAt(de)===41&&Z--;for(;!this._isAtEnd()&&ee.type!==15&&ee.type!==16;){switch(ee.type){case 0:Z++;break;case 1:Z--;break;case 10:case 18:for(let de=0;de<ee.lexeme.length;de++)ee.lexeme.charCodeAt(de)===40?Z++:Q.lexeme.charCodeAt(de)===41&&Z--}if(Z<0)break;G.push(A.Scanner.getLexeme(ee)),this._advance(),ee=this._peek()}const J=G.join(""),se=J.lastIndexOf("/"),he=se===J.length-1?void 0:this._removeFlagsGY(J.substring(se+1));let ge;try{ge=new RegExp(J.substring(1,se),he)}catch{throw this._errExpectedButGot("REGEX",Q)}return t.regex(M,ge)}case 18:{const G=Q.lexeme;this._advance();let ee=null;if(!(0,U.isFalsyOrWhitespace)(G)){const Z=G.indexOf("/"),J=G.lastIndexOf("/");if(Z!==J&&Z>=0){const se=G.slice(Z+1,J),he=G[J+1]==="i"?"i":"";try{ee=new RegExp(se,he)}catch{throw this._errExpectedButGot("REGEX",Q)}}}if(ee===null)throw this._errExpectedButGot("REGEX",Q);return B.create(M,ee)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,p);const Q=this._value();return t.notIn(M,Q)}switch(this._peek().type){case 3:{this._advance();const Q=this._value();if(this._previous().type===18)return t.equals(M,Q);switch(Q){case"true":return t.has(M);case"false":return t.not(M);default:return t.equals(M,Q)}}case 4:{this._advance();const Q=this._value();if(this._previous().type===18)return t.notEquals(M,Q);switch(Q){case"true":return t.not(M);case"false":return t.has(M);default:return t.notEquals(M,Q)}}case 5:return this._advance(),x.create(M,this._value());case 6:return this._advance(),X.create(M,this._value());case 7:return this._advance(),N.create(M,this._value());case 8:return this._advance(),F.create(M,this._value());case 13:return this._advance(),t.in(M,this._value());default:return t.has(M)}}case 20:throw this._parsingErrors.push({message:m,offset:T.offset,lexeme:"",additionalInfo:f}),S._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const T=this._peek();switch(T.type){case 17:case 18:return this._advance(),T.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(T){return T.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(T){return this._check(T)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(T,M){if(this._check(T))return this._advance();throw this._errExpectedButGot(M,this._peek())}_errExpectedButGot(T,M,$){const Q=(0,k.localize)(8,null,T,A.Scanner.getLexeme(M)),G=M.offset,ee=A.Scanner.getLexeme(M);return this._parsingErrors.push({message:Q,offset:G,lexeme:ee,additionalInfo:$}),S._parseError}_check(T){return this._peek().type===T}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=S;class t{static false(){return i.INSTANCE}static true(){return o.INSTANCE}static has(T){return a.create(T)}static equals(T,M){return y.create(T,M)}static notEquals(T,M){return b.create(T,M)}static regex(T,M){return B.create(T,M)}static in(T,M){return I.create(T,M)}static notIn(T,M){return w.create(T,M)}static not(T){return D.create(T)}static and(...T){return H.create(T,null,!0)}static or(...T){return V.create(T,null,!0)}static greater(T,M){return N.create(T,M)}static greaterEquals(T,M){return F.create(T,M)}static smaller(T,M){return x.create(T,M)}static smallerEquals(T,M){return X.create(T,M)}static{this._parser=new S({regexParsingWithErrorRecovery:!1})}static deserialize(T){return T==null?void 0:this._parser.parse(T)}}e.ContextKeyExpr=t;function r(W){const T=new S({regexParsingWithErrorRecovery:!1});return W.map(M=>(T.parse(M),T.lexingErrors.length>0?T.lexingErrors.map($=>({errorMessage:$.additionalInfo?(0,k.localize)(9,null,$.additionalInfo):(0,k.localize)(10,null),offset:$.offset,length:$.lexeme.length})):T.parsingErrors.length>0?T.parsingErrors.map($=>({errorMessage:$.additionalInfo?`${$.message}. ${$.additionalInfo}`:$.message,offset:$.offset,length:$.lexeme.length})):[]))}function n(W,T){const M=W?W.substituteConstants():void 0,$=T?T.substituteConstants():void 0;return!M&&!$?!0:!M||!$?!1:M.equals($)}function s(W,T){return W.cmp(T)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!1}serialize(){return"false"}keys(){return[]}map(T){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=i;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!0}serialize(){return"true"}keys(){return[]}map(T){return this}negate(){return i.INSTANCE}}e.ContextKeyTrueExpr=o;class a{static create(T,M=null){const $=P.get(T);return typeof $=="boolean"?$?o.INSTANCE:i.INSTANCE:new a(T,M)}constructor(T,M){this.key=T,this.negated=M,this.type=2}cmp(T){return T.type!==this.type?this.type-T.type:ie(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=P.get(this.key);return typeof T=="boolean"?T?o.INSTANCE:i.INSTANCE:this}evaluate(T){return!!T.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(T){return T.mapDefined(this.key)}negate(){return this.negated||(this.negated=D.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=a;class y{static create(T,M,$=null){if(typeof M=="boolean")return M?a.create(T,$):D.create(T,$);const Q=P.get(T);return typeof Q=="boolean"?M===(Q?"true":"false")?o.INSTANCE:i.INSTANCE:new y(T,M,$)}constructor(T,M,$){this.key=T,this.value=M,this.negated=$,this.type=4}cmp(T){return T.type!==this.type?this.type-T.type:re(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=P.get(this.key);if(typeof T=="boolean"){const M=T?"true":"false";return this.value===M?o.INSTANCE:i.INSTANCE}return this}evaluate(T){return T.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(T){return T.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=y;class I{static create(T,M){return new I(T,M)}constructor(T,M){this.key=T,this.valueKey=M,this.type=10,this.negated=null}cmp(T){return T.type!==this.type?this.type-T.type:re(this.key,this.valueKey,T.key,T.valueKey)}equals(T){return T.type===this.type?this.key===T.key&&this.valueKey===T.valueKey:!1}substituteConstants(){return this}evaluate(T){const M=T.getValue(this.valueKey),$=T.getValue(this.key);return Array.isArray(M)?M.includes($):typeof $=="string"&&typeof M=="object"&&M!==null?C.call(M,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(T){return T.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=w.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=I;class w{static create(T,M){return new w(T,M)}constructor(T,M){this.key=T,this.valueKey=M,this.type=11,this._negated=I.create(T,M)}cmp(T){return T.type!==this.type?this.type-T.type:this._negated.cmp(T._negated)}equals(T){return T.type===this.type?this._negated.equals(T._negated):!1}substituteConstants(){return this}evaluate(T){return!this._negated.evaluate(T)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(T){return T.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=w;class b{static create(T,M,$=null){if(typeof M=="boolean")return M?D.create(T,$):a.create(T,$);const Q=P.get(T);return typeof Q=="boolean"?M===(Q?"true":"false")?i.INSTANCE:o.INSTANCE:new b(T,M,$)}constructor(T,M,$){this.key=T,this.value=M,this.negated=$,this.type=5}cmp(T){return T.type!==this.type?this.type-T.type:re(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=P.get(this.key);if(typeof T=="boolean"){const M=T?"true":"false";return this.value===M?i.INSTANCE:o.INSTANCE}return this}evaluate(T){return T.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(T){return T.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class D{static create(T,M=null){const $=P.get(T);return typeof $=="boolean"?$?i.INSTANCE:o.INSTANCE:new D(T,M)}constructor(T,M){this.key=T,this.negated=M,this.type=3}cmp(T){return T.type!==this.type?this.type-T.type:ie(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=P.get(this.key);return typeof T=="boolean"?T?i.INSTANCE:o.INSTANCE:this}evaluate(T){return!T.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(T){return T.mapNot(this.key)}negate(){return this.negated||(this.negated=a.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=D;function L(W,T){if(typeof W=="string"){const M=parseFloat(W);isNaN(M)||(W=M)}return typeof W=="string"||typeof W=="number"?T(W):i.INSTANCE}class N{static create(T,M,$=null){return L(M,Q=>new N(T,Q,$))}constructor(T,M,$){this.key=T,this.value=M,this.negated=$,this.type=12}cmp(T){return T.type!==this.type?this.type-T.type:re(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=X.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=N;class F{static create(T,M,$=null){return L(M,Q=>new F(T,Q,$))}constructor(T,M,$){this.key=T,this.value=M,this.negated=$,this.type=13}cmp(T){return T.type!==this.type?this.type-T.type:re(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=x.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=F;class x{static create(T,M,$=null){return L(M,Q=>new x(T,Q,$))}constructor(T,M,$){this.key=T,this.value=M,this.negated=$,this.type=14}cmp(T){return T.type!==this.type?this.type-T.type:re(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=F.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=x;class X{static create(T,M,$=null){return L(M,Q=>new X(T,Q,$))}constructor(T,M,$){this.key=T,this.value=M,this.negated=$,this.type=15}cmp(T){return T.type!==this.type?this.type-T.type:re(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=N.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=X;class B{static create(T,M){return new B(T,M)}constructor(T,M){this.key=T,this.regexp=M,this.type=7,this.negated=null}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.key<T.key)return-1;if(this.key>T.key)return 1;const M=this.regexp?this.regexp.source:"",$=T.regexp?T.regexp.source:"";return M<$?-1:M>$?1:0}equals(T){if(T.type===this.type){const M=this.regexp?this.regexp.source:"",$=T.regexp?T.regexp.source:"";return this.key===T.key&&M===$}return!1}substituteConstants(){return this}evaluate(T){const M=T.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const T=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${T}`}keys(){return[this.key]}map(T){return T.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=Y.create(this)),this.negated}}e.ContextKeyRegexExpr=B;class Y{static create(T){return new Y(T)}constructor(T){this._actual=T,this.type=8}cmp(T){return T.type!==this.type?this.type-T.type:this._actual.cmp(T._actual)}equals(T){return T.type===this.type?this._actual.equals(T._actual):!1}substituteConstants(){return this}evaluate(T){return!this._actual.evaluate(T)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(T){return new Y(this._actual.map(T))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=Y;function z(W){let T=null;for(let M=0,$=W.length;M<$;M++){const Q=W[M].substituteConstants();if(W[M]!==Q&&T===null){T=[];for(let G=0;G<M;G++)T[G]=W[G]}T!==null&&(T[M]=Q)}return T===null?W:T}class H{static create(T,M,$){return H._normalizeArr(T,M,$)}constructor(T,M){this.expr=T,this.negated=M,this.type=6}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let M=0,$=this.expr.length;M<$;M++){const Q=s(this.expr[M],T.expr[M]);if(Q!==0)return Q}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].equals(T.expr[M]))return!1;return!0}return!1}substituteConstants(){const T=z(this.expr);return T===this.expr?this:H.create(T,this.negated,!1)}evaluate(T){for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].evaluate(T))return!1;return!0}static _normalizeArr(T,M,$){const Q=[];let G=!1;for(const ee of T)if(ee){if(ee.type===1){G=!0;continue}if(ee.type===0)return i.INSTANCE;if(ee.type===6){Q.push(...ee.expr);continue}Q.push(ee)}if(Q.length===0&&G)return o.INSTANCE;if(Q.length!==0){if(Q.length===1)return Q[0];Q.sort(s);for(let ee=1;ee<Q.length;ee++)Q[ee-1].equals(Q[ee])&&(Q.splice(ee,1),ee--);if(Q.length===1)return Q[0];for(;Q.length>1;){const ee=Q[Q.length-1];if(ee.type!==9)break;Q.pop();const Z=Q.pop(),J=Q.length===0,se=V.create(ee.expr.map(he=>H.create([he,Z],null,$)),null,J);se&&(Q.push(se),Q.sort(s))}if(Q.length===1)return Q[0];if($){for(let ee=0;ee<Q.length;ee++)for(let Z=ee+1;Z<Q.length;Z++)if(Q[ee].negate().equals(Q[Z]))return i.INSTANCE;if(Q.length===1)return Q[0]}return new H(Q,M)}}serialize(){return this.expr.map(T=>T.serialize()).join(" && ")}keys(){const T=[];for(const M of this.expr)T.push(...M.keys());return T}map(T){return new H(this.expr.map(M=>M.map(T)),null)}negate(){if(!this.negated){const T=[];for(const M of this.expr)T.push(M.negate());this.negated=V.create(T,this,!0)}return this.negated}}e.ContextKeyAndExpr=H;class V{static create(T,M,$){return V._normalizeArr(T,M,$)}constructor(T,M){this.expr=T,this.negated=M,this.type=9}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let M=0,$=this.expr.length;M<$;M++){const Q=s(this.expr[M],T.expr[M]);if(Q!==0)return Q}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].equals(T.expr[M]))return!1;return!0}return!1}substituteConstants(){const T=z(this.expr);return T===this.expr?this:V.create(T,this.negated,!1)}evaluate(T){for(let M=0,$=this.expr.length;M<$;M++)if(this.expr[M].evaluate(T))return!0;return!1}static _normalizeArr(T,M,$){let Q=[],G=!1;if(T){for(let ee=0,Z=T.length;ee<Z;ee++){const J=T[ee];if(J){if(J.type===0){G=!0;continue}if(J.type===1)return o.INSTANCE;if(J.type===9){Q=Q.concat(J.expr);continue}Q.push(J)}}if(Q.length===0&&G)return i.INSTANCE;Q.sort(s)}if(Q.length!==0){if(Q.length===1)return Q[0];for(let ee=1;ee<Q.length;ee++)Q[ee-1].equals(Q[ee])&&(Q.splice(ee,1),ee--);if(Q.length===1)return Q[0];if($){for(let ee=0;ee<Q.length;ee++)for(let Z=ee+1;Z<Q.length;Z++)if(Q[ee].negate().equals(Q[Z]))return o.INSTANCE;if(Q.length===1)return Q[0]}return new V(Q,M)}}serialize(){return this.expr.map(T=>T.serialize()).join(" || ")}keys(){const T=[];for(const M of this.expr)T.push(...M.keys());return T}map(T){return new V(this.expr.map(M=>M.map(T)),null)}negate(){if(!this.negated){const T=[];for(const M of this.expr)T.push(M.negate());for(;T.length>1;){const M=T.shift(),$=T.shift(),Q=[];for(const G of j(M))for(const ee of j($))Q.push(H.create([G,ee],null,!1));T.unshift(V.create(Q,null,!1))}this.negated=V.create(T,this,!0)}return this.negated}}e.ContextKeyOrExpr=V;class q extends a{static{this._info=[]}static all(){return q._info.values()}constructor(T,M,$){super(T,null),this._defaultValue=M,typeof $=="object"?q._info.push({...$,key:T}):$!==!0&&q._info.push({key:T,description:$,type:M!=null?typeof M:void 0})}bindTo(T){return T.createKey(this.key,this._defaultValue)}getValue(T){return T.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(T){return y.create(this.key,T)}notEqualsTo(T){return b.create(this.key,T)}}e.RawContextKey=q,e.IContextKeyService=(0,O.createDecorator)("contextKeyService");function ie(W,T){return W<T?-1:W>T?1:0}function re(W,T,M,$){return W<M?-1:W>M?1:T<$?-1:T>$?1:0}function ue(W,T){if(W.type===0||T.type===1)return!0;if(W.type===9)return T.type===9?te(W.expr,T.expr):!1;if(T.type===9){for(const M of T.expr)if(ue(W,M))return!0;return!1}if(W.type===6){if(T.type===6)return te(T.expr,W.expr);for(const M of W.expr)if(ue(M,T))return!0;return!1}return W.equals(T)}function te(W,T){let M=0,$=0;for(;M<W.length&&$<T.length;){const Q=W[M].cmp(T[$]);if(Q<0)return!1;Q===0&&M++,$++}return M===W.length}function j(W){return W.type===9?W.expr:[W]}}),define(ae[94],ce([0,1,4]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.IDiagnosticsService=e.ID=void 0,e.isRemoteDiagnosticError=U,e.ID="diagnosticsService",e.IDiagnosticsService=(0,_.createDecorator)(e.ID);function U(O){return!!O.hostName&&!!O.errorMessage}class A{async getPerformanceInfo(k,R){return{}}async getSystemInfo(k,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(k,R){return""}async getWorkspaceFileExtensions(k){return{extensions:[]}}async reportWorkspaceStats(k){}}e.NullDiagnosticsService=A}),define(ae[95],ce([0,1,4]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,_.createDecorator)("downloadService")}),define(ae[16],ce([0,1,4]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,_.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,_.refineServiceDecorator)(e.IEnvironmentService)}),define(ae[29],ce([0,1,157,4]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionGalleryError=e.ExtensionGalleryErrorCode=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.EXTENSION_INSTALL_DEP_PACK_CONTEXT=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.TargetPlatformToString=A,e.toTargetPlatform=O,e.getTargetPlatform=k,e.isNotWebExtensionInWebTargetPlatform=R,e.isTargetPlatformCompatible=P,e.isIExtensionIdentifier=d,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync",e.EXTENSION_INSTALL_DEP_PACK_CONTEXT="dependecyOrPackExtensionInstall";function A(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"linux-ppc64le":return"Linux PowerPC";case"linux-riscv64":return"Linux RISC-V 64";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function O(h){switch(h){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"linux-ppc64le":return"linux-ppc64le";case"linux-riscv64":return"linux-riscv64";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function k(h,m){switch(h){case 3:return m==="x64"?"win32-x64":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":m==="ppc64le"?"linux-ppc64le":m==="riscv64"?"linux-riscv64":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function R(h,m){return m==="web"&&!h.includes("web")}function P(h,m,f){return R(m,f)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===f}function d(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}var C;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var E;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var v;(function(h){h.Install="install",h.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var l;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(l||(e.InstallOperation=l={})),e.IExtensionGalleryService=(0,U.createDecorator)("extensionGalleryService");var c;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.DownloadSignature="DownloadSignature",h.UpdateMetadata="UpdateMetadata",h.Extract="Extract",h.Scanning="Scanning",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.NotAllowed="NotAllowed",h.Gallery="Gallery",h.Cancelled="Cancelled",h.Unknown="Unknown",h.Internal="Internal"})(c||(e.ExtensionManagementErrorCode=c={}));class p extends Error{constructor(m,f){super(m),this.code=f,this.name=f}}e.ExtensionManagementError=p;var g;(function(h){h.Timeout="Timeout",h.Cancelled="Cancelled",h.Failed="Failed"})(g||(e.ExtensionGalleryErrorCode=g={}));class u extends Error{constructor(m,f){super(m),this.code=f,this.name=f}}e.ExtensionGalleryError=u,e.IExtensionManagementService=(0,U.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,U.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,U.createDecorator)("IExtensionTipsService"),e.ExtensionsLocalizedLabel=(0,_.localize2)(0,"Extensions"),e.PreferencesLocalizedLabel=(0,_.localize2)(1,"Preferences")}),define(ae[194],ce([0,1,3,2,30,8,91,29]),function(ne,e,_,U,A,O,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(g,u){return g?O.URI.revive(u?u.transformIncoming(g):g):void 0}function d(g,u){return u?u.transformOutgoingURI(g):g}function C(g,u){u=u||k.DefaultURITransformer;const h=g.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...g,manifest:void 0},u),manifest:h}}function E(g,u){return g?.profileLocation?(0,k.transformAndReviveIncomingURIs)(g,u??k.DefaultURITransformer):g}function v(g,u){return u?(0,A.cloneAndChange)(g,h=>h instanceof O.URI?u.transformOutgoingURI(h):void 0):g}class l{constructor(u,h){this.service=u,this.getUriTransformer=h,this.onInstallExtension=_.Event.buffer(u.onInstallExtension,!0),this.onDidInstallExtensions=_.Event.buffer(u.onDidInstallExtensions,!0),this.onUninstallExtension=_.Event.buffer(u.onUninstallExtension,!0),this.onDidUninstallExtension=_.Event.buffer(u.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=_.Event.buffer(u.onDidUpdateExtensionMetadata,!0)}listen(u,h){const m=this.getUriTransformer(u);switch(h){case"onInstallExtension":return _.Event.map(this.onInstallExtension,f=>({...f,profileLocation:f.profileLocation?d(f.profileLocation,m):f.profileLocation}));case"onDidInstallExtensions":return _.Event.map(this.onDidInstallExtensions,f=>f.map(S=>({...S,local:S.local?v(S.local,m):S.local,profileLocation:S.profileLocation?d(S.profileLocation,m):S.profileLocation})));case"onUninstallExtension":return _.Event.map(this.onUninstallExtension,f=>({...f,profileLocation:f.profileLocation?d(f.profileLocation,m):f.profileLocation}));case"onDidUninstallExtension":return _.Event.map(this.onDidUninstallExtension,f=>({...f,profileLocation:f.profileLocation?d(f.profileLocation,m):f.profileLocation}));case"onDidUpdateExtensionMetadata":return _.Event.map(this.onDidUpdateExtensionMetadata,f=>v(f,m))}throw new Error("Invalid listen")}async call(u,h,m){const f=this.getUriTransformer(u);switch(h){case"zip":{const S=C(m[0],f),t=await this.service.zip(S);return d(t,f)}case"unzip":return this.service.unzip(P(m[0],f));case"install":return this.service.install(P(m[0],f),E(m[1],f));case"installFromLocation":return this.service.installFromLocation(P(m[0],f),P(m[1],f));case"installExtensionsFromProfile":return this.service.installExtensionsFromProfile(m[0],P(m[1],f),P(m[2],f));case"getManifest":return this.service.getManifest(P(m[0],f));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(m[0]);case"installFromGallery":return this.service.installFromGallery(m[0],E(m[1],f));case"installGalleryExtensions":{const S=m[0];return this.service.installGalleryExtensions(S.map(({extension:t,options:r})=>({extension:t,options:E(r,f)??{}})))}case"uninstall":return this.service.uninstall(C(m[0],f),E(m[1],f));case"reinstallFromGallery":return this.service.reinstallFromGallery(C(m[0],f));case"getInstalled":return(await this.service.getInstalled(m[0],P(m[1],f),m[2])).map(t=>v(t,f));case"toggleAppliationScope":{const S=await this.service.toggleAppliationScope(C(m[0],f),P(m[1],f));return v(S,f)}case"copyExtensions":return this.service.copyExtensions(P(m[0],f),P(m[1],f));case"updateMetadata":{const S=await this.service.updateMetadata(C(m[0],f),m[1],P(m[2],f));return v(S,f)}case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest();case"download":return this.service.download(m[0],m[1],m[2]);case"cleanUp":return this.service.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=l;class c extends U.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(u){super(),this.channel=u,this._onInstallExtension=this._register(new _.Emitter),this._onDidInstallExtensions=this._register(new _.Emitter),this._onUninstallExtension=this._register(new _.Emitter),this._onDidUninstallExtension=this._register(new _.Emitter),this._onDidUpdateExtensionMetadata=this._register(new _.Emitter),this._register(this.channel.listen("onInstallExtension")(h=>this.fireEvent(this._onInstallExtension,{...h,source:this.isUriComponents(h.source)?O.URI.revive(h.source):h.source,profileLocation:O.URI.revive(h.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(h=>this.fireEvent(this._onDidInstallExtensions,h.map(m=>({...m,local:m.local?C(m.local,null):m.local,source:this.isUriComponents(m.source)?O.URI.revive(m.source):m.source,profileLocation:O.URI.revive(m.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(h=>this.fireEvent(this._onUninstallExtension,{...h,profileLocation:O.URI.revive(h.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(h=>this.fireEvent(this._onDidUninstallExtension,{...h,profileLocation:O.URI.revive(h.profileLocation)}))),this._register(this.channel.listen("onDidUpdateExtensionMetadata")(h=>this._onDidUpdateExtensionMetadata.fire(C(h,null))))}fireEvent(u,h){u.fire(h)}isUriComponents(u){return u?typeof u.path=="string"&&typeof u.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(u){const h=await this.getTargetPlatform();return u.allTargetPlatforms.some(m=>(0,R.isTargetPlatformCompatible)(m,u.allTargetPlatforms,h))}zip(u){return Promise.resolve(this.channel.call("zip",[u]).then(h=>O.URI.revive(h)))}unzip(u){return Promise.resolve(this.channel.call("unzip",[u]))}install(u,h){return Promise.resolve(this.channel.call("install",[u,h])).then(m=>C(m,null))}installFromLocation(u,h){return Promise.resolve(this.channel.call("installFromLocation",[u,h])).then(m=>C(m,null))}async installExtensionsFromProfile(u,h,m){return(await this.channel.call("installExtensionsFromProfile",[u,h,m])).map(S=>C(S,null))}getManifest(u){return Promise.resolve(this.channel.call("getManifest",[u]))}installFromGallery(u,h){return Promise.resolve(this.channel.call("installFromGallery",[u,h])).then(m=>C(m,null))}async installGalleryExtensions(u){return(await this.channel.call("installGalleryExtensions",[u])).map(m=>({...m,local:m.local?C(m.local,null):m.local,source:this.isUriComponents(m.source)?O.URI.revive(m.source):m.source,profileLocation:O.URI.revive(m.profileLocation)}))}uninstall(u,h){if(u.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.channel.call("uninstall",[u,h]))}reinstallFromGallery(u){return Promise.resolve(this.channel.call("reinstallFromGallery",[u])).then(h=>C(h,null))}getInstalled(u=null,h,m){return Promise.resolve(this.channel.call("getInstalled",[u,h,m])).then(f=>f.map(S=>C(S,null)))}updateMetadata(u,h,m){return Promise.resolve(this.channel.call("updateMetadata",[u,h,m])).then(f=>C(f,null))}toggleAppliationScope(u,h){return this.channel.call("toggleAppliationScope",[u,h]).then(m=>C(m,null))}copyExtensions(u,h){return this.channel.call("copyExtensions",[u,h])}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}async download(u,h,m){const f=await this.channel.call("download",[u,h,m]);return O.URI.revive(f)}async cleanUp(){return this.channel.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=c;class p{constructor(u){this.service=u}listen(u,h){throw new Error("Invalid listen")}call(u,h,m){switch(h){case"getConfigBasedTips":return this.service.getConfigBasedTips(O.URI.revive(m[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=p}),define(ae[96],ce([0,1,4]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.RecommendationSourceToString=A;var U;(function(k){k[k.FILE=1]="FILE",k[k.WORKSPACE=2]="WORKSPACE",k[k.EXE=3]="EXE"})(U||(e.RecommendationSource=U={}));function A(k){switch(k){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}var O;(function(k){k.Ignored="ignored",k.Cancelled="cancelled",k.TooMany="toomany",k.IncompatibleWindow="incompatibleWindow",k.Accepted="reacted"})(O||(e.RecommendationsNotificationResult=O={})),e.IExtensionRecommendationNotificationService=(0,_.createDecorator)("IExtensionRecommendationNotificationService")}),define(ae[12],ce([0,1,51,14,27,13,8,164,4,5,23,53]),function(ne,e,_,U,A,O,k,R,P,d,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=v,e.isFileSystemWatcher=g,e.hasReadWriteCapability=h,e.hasFileFolderCopyCapability=m,e.hasFileCloneCapability=f,e.hasOpenReadWriteCloseCapability=S,e.hasFileReadStreamCapability=t,e.hasFileAtomicReadCapability=r,e.hasFileAtomicWriteCapability=n,e.hasFileAtomicDeleteCapability=s,e.hasReadonlyCapability=i,e.createFileSystemProviderError=y,e.ensureFileSystemProviderError=I,e.markAsFileSystemProviderError=w,e.toFileSystemProviderErrorCode=b,e.toFileOperationResult=D,e.isParent=X,e.etag=q,e.whenProviderRegistered=ie,e.getLargeFileConfirmationLimit=ue,e.IFileService=(0,P.createDecorator)("fileService");function v(te){return te.create===!0}var l;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(l||(e.FileType=l={}));var c;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var p;(function(te){te[te.UPDATED=2]="UPDATED",te[te.ADDED=4]="ADDED",te[te.DELETED=8]="DELETED"})(p||(e.FileChangeFilter=p={}));function g(te){const j=te;return!!j&&typeof j.onDidChange=="function"}var u;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(u||(e.FileSystemProviderCapabilities=u={}));function h(te){return!!(te.capabilities&2)}function m(te){return!!(te.capabilities&8)}function f(te){return!!(te.capabilities&131072)}function S(te){return!!(te.capabilities&4)}function t(te){return!!(te.capabilities&16)}function r(te){return h(te)?!!(te.capabilities&16384):!1}function n(te){return h(te)?!!(te.capabilities&32768):!1}function s(te){return!!(te.capabilities&65536)}function i(te){return!!(te.capabilities&2048)}var o;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class a extends Error{static create(j,W){const T=new a(j.toString(),W);return w(T,W),T}constructor(j,W){super(j),this.code=W}}e.FileSystemProviderError=a;function y(te,j){return a.create(te,j)}function I(te){return te||y((0,R.localize)(0,null),o.Unknown)}function w(te,j){return te.name=j?`${j} (FileSystemError)`:"FileSystemError",te}function b(te){if(!te)return o.Unknown;if(te instanceof a)return te.code;const j=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!j)return o.Unknown;switch(j[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}function D(te){if(te instanceof B)return te.fileOperationResult;switch(b(te)){case o.FileNotFound:return 1;case o.FileIsADirectory:return 0;case o.FileNotADirectory:return 9;case o.FileWriteLocked:return 5;case o.NoPermissions:return 6;case o.FileExists:return 4;case o.FileTooLarge:return 7;default:return 10}}var L;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class N{constructor(j,W,T){this.resource=j,this.operation=W,this.target=T}isOperation(j){return this.operation===j}}e.FileOperationEvent=N;var F;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class x{static{this.MIXED_CORRELATION=null}constructor(j,W){this.ignorePathCasing=W,this.correlationId=void 0,this.added=new E.Lazy(()=>{const T=_.TernarySearchTree.forUris(()=>this.ignorePathCasing);return T.fill(this.rawAdded.map(M=>[M,!0])),T}),this.updated=new E.Lazy(()=>{const T=_.TernarySearchTree.forUris(()=>this.ignorePathCasing);return T.fill(this.rawUpdated.map(M=>[M,!0])),T}),this.deleted=new E.Lazy(()=>{const T=_.TernarySearchTree.forUris(()=>this.ignorePathCasing);return T.fill(this.rawDeleted.map(M=>[M,!0])),T}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const T of j){switch(T.type){case 1:this.rawAdded.push(T.resource);break;case 0:this.rawUpdated.push(T.resource);break;case 2:this.rawDeleted.push(T.resource);break}this.correlationId!==x.MIXED_CORRELATION&&(typeof T.cId=="number"?this.correlationId===void 0?this.correlationId=T.cId:this.correlationId!==T.cId&&(this.correlationId=x.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=x.MIXED_CORRELATION))}}contains(j,...W){return this.doContains(j,{includeChildren:!1},...W)}affects(j,...W){return this.doContains(j,{includeChildren:!0},...W)}doContains(j,W,...T){if(!j)return!1;const M=T.length>0;return!!((!M||T.includes(1))&&(this.added.value.get(j)||W.includeChildren&&this.added.value.findSuperstr(j))||(!M||T.includes(0))&&(this.updated.value.get(j)||W.includeChildren&&this.updated.value.findSuperstr(j))||(!M||T.includes(2))&&(this.deleted.value.findSubstr(j)||W.includeChildren&&this.deleted.value.findSuperstr(j)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(j){return this.correlationId===j}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=x;function X(te,j,W){return!te||!j||te===j||j.length>te.length?!1:(j.charAt(j.length-1)!==U.sep&&(j+=U.sep),W?(0,A.startsWithIgnoreCase)(te,j):te.indexOf(j)===0)}class B extends Error{constructor(j,W,T){super(j),this.fileOperationResult=W,this.options=T}}e.FileOperationError=B;class Y extends B{constructor(j,W,T,M){super(j,W,M),this.fileOperationResult=W,this.size=T}}e.TooLargeFileOperationError=Y;class z extends B{constructor(j,W,T){super(j,2,T),this.stat=W}}e.NotModifiedSinceFileOperationError=z;var H;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(H||(e.FileOperationResult=H={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var V;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(V||(e.FileKind=V={})),e.ETAG_DISABLED="";function q(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function ie(te,j){if(!j.hasProvider(k.URI.from({scheme:te.scheme})))return new Promise(W=>{const T=j.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===te.scheme&&M.added&&(T.dispose(),W())})})}class re{static{this.KB=1024}static{this.MB=re.KB*re.KB}static{this.GB=re.MB*re.KB}static{this.TB=re.GB*re.KB}static formatSize(j){return(0,O.isNumber)(j)||(j=0),j<re.KB?(0,R.localize)(1,null,j.toFixed(0)):j<re.MB?(0,R.localize)(2,null,(j/re.KB).toFixed(2)):j<re.GB?(0,R.localize)(3,null,(j/re.MB).toFixed(2)):j<re.TB?(0,R.localize)(4,null,(j/re.GB).toFixed(2)):(0,R.localize)(5,null,(j/re.TB).toFixed(2))}}e.ByteSize=re;function ue(te){const j=typeof te=="string"||te?.scheme===C.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===C.Schemas.file?1024*re.MB:j?10*re.MB:d.isWeb?50*re.MB:1024*re.MB}});var K=this&&this.__param||function(ne,e){return function(_,U){e(_,U,ne)}};define(ae[195],ce([0,1,73,50,12]),function(ne,e,_,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let O=class{constructor(R){this.fileService=R}async checksum(R){const P=(await this.fileService.readFileStream(R)).value;return new Promise((d,C)=>{const E=(0,_.createHash)("sha256");(0,U.listenStream)(P,{onData:v=>E.update(v.buffer),onError:v=>C(v),onEnd:()=>d(E.digest("base64").replace(/=+$/,""))})})}};e.ChecksumService=O,e.ChecksumService=O=Ce([K(0,A.IFileService)],O)}),define(ae[97],ce([0,1,15,7,165,12]),function(ne,e,_,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=k;async function k(C,E,v,l,c,p){let g;try{await R(C,E,v,l,c,p)}catch(u){g=u}finally{g&&c.errorTransformer&&(g=c.errorTransformer(g)),typeof g<"u"&&v.error(g),v.end()}}async function R(C,E,v,l,c,p){P(p);const g=await C.open(E,{create:!1});try{P(p);let u=0,h=0,m=c&&typeof c.length=="number"?c.length:void 0,f=_.VSBuffer.alloc(Math.min(c.bufferSize,typeof m=="number"?m:c.bufferSize)),S=c&&typeof c.position=="number"?c.position:0,t=0;do h=await C.read(g,S,f.buffer,t,f.byteLength-t),S+=h,t+=h,u+=h,typeof m=="number"&&(m-=h),t===f.byteLength&&(await v.write(l(f)),f=_.VSBuffer.alloc(Math.min(c.bufferSize,typeof m=="number"?m:c.bufferSize)),t=0);while(h>0&&(typeof m!="number"||m>0)&&P(p)&&d(u,c));if(t>0){let r=t;typeof m=="number"&&(r=Math.min(t,m)),v.write(l(f.slice(0,r)))}}catch(u){throw(0,O.ensureFileSystemProviderError)(u)}finally{await C.close(g)}}function P(C){if(C.isCancellationRequested)throw(0,U.canceled)();return!0}function d(C,E){if(typeof E?.limits?.size=="number"&&C>E.limits.size)throw(0,O.createFileSystemProviderError)((0,A.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[46],ce([0,1,90,2,14,5,8,12]),function(ne,e,_,U,A,O,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=void 0,e.isWatchRequestWithCorrelation=P,e.isRecursiveWatchRequest=d,e.reviveFileChanges=l,e.coalesceEvents=c,e.normalizeWatcherPattern=p,e.parseWatcherPatterns=g,e.isFiltered=h,e.requestFilterToString=m;function P(f){return typeof f.correlationId=="number"}function d(f){return f.recursive===!0}class C extends U.Disposable{static{this.MAX_RESTARTS=5}constructor(S,t,r,n){super(),this.onFileChanges=S,this.onLogMessage=t,this.verboseLogging=r,this.options=n,this.watcherDisposables=this._register(new U.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const S=new U.DisposableStore;this.watcherDisposables.value=S,this.watcher=this.createWatcher(S),this.watcher.setVerboseLogging(this.verboseLogging),S.add(this.watcher.onDidChangeFile(t=>this.onFileChanges(t))),S.add(this.watcher.onDidLogMessage(t=>this.onLogMessage(t))),S.add(this.watcher.onDidError(t=>this.onError(t)))}onError(S){this.options.restartOnError?this.restartCounter<C.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${S}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${S}`):this.error(S)}restart(S){this.restartCounter++,this.init(),this.watch(S)}async watch(S){this.requests=S,await this.watcher?.watch(S)}async setVerboseLogging(S){this.verboseLogging=S,await this.watcher?.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${S}`})}trace(S){this.onLogMessage({type:"trace",message:`[File Watcher (${this.options.type})] ${S}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=C;class E extends C{constructor(S,t,r){super(S,t,r,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=E;class v extends C{constructor(S,t,r){super(S,t,r,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=v;function l(f){return f.map(S=>({type:S.type,resource:k.URI.revive(S.resource),cId:S.cId}))}function c(f){const S=new u;for(const t of f)S.processEvent(t);return S.coalesce()}function p(f,S){return typeof S=="string"&&!S.startsWith(_.GLOBSTAR)&&!(0,A.isAbsolute)(S)?{base:f,pattern:S}:S}function g(f,S){const t=[];for(const r of S)t.push((0,_.parse)(p(f,r)));return t}class u{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(S){return O.isLinux?S.resource.fsPath:S.resource.fsPath.toLowerCase()}processEvent(S){const t=this.mapPathToChange.get(this.toKey(S));let r=!1;if(t){const n=t.type,s=S.type;t.resource.fsPath!==S.resource.fsPath&&(S.type===2||S.type===1)?r=!0:n===1&&s===2?(this.mapPathToChange.delete(this.toKey(S)),this.coalesced.delete(t)):n===2&&s===1?t.type=0:n===1&&s===0||(t.type=s)}else r=!0;r&&(this.coalesced.add(S),this.mapPathToChange.set(this.toKey(S),S))}coalesce(){const S=[],t=[];return Array.from(this.coalesced).filter(r=>r.type!==2?(S.push(r),!1):!0).sort((r,n)=>r.resource.fsPath.length-n.resource.fsPath.length).filter(r=>t.some(n=>(0,R.isParent)(r.resource.fsPath,n,!O.isLinux))?!1:(t.push(r.resource.fsPath),!0)).concat(S)}}function h(f,S){if(typeof S=="number")switch(f.type){case 1:return(S&4)===0;case 2:return(S&8)===0;case 0:return(S&2)===0}return!1}function m(f){if(typeof f=="number"){const S=[];return f&4&&S.push("Added"),f&8&&S.push("Deleted"),f&2&&S.push("Updated"),S.length===0?"<all>":`[${S.join(", ")}]`}return"<none>"}}),define(ae[196],ce([0,1,15,38,7,3,2,50,32,12,46]),function(ne,e,_,U,A,O,k,R,P,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends k.Disposable{constructor(l,c){super(),this.channel=l,this.extraCapabilities=c,this.onDidChangeCapabilities=O.Event.None,this._onDidChange=this._register(new O.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,P.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=253982,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(l){return this.channel.call("stat",[l])}readdir(l){return this.channel.call("readdir",[l])}async readFile(l,c){const{buffer:p}=await this.channel.call("readFile",[l,c]);return p}readFileStream(l,c,p){const g=(0,R.newWriteableStream)(h=>_.VSBuffer.concat(h.map(m=>_.VSBuffer.wrap(m))).buffer),u=new k.DisposableStore;return u.add(this.channel.listen("readFileStream",[l,c])(h=>{if(h instanceof _.VSBuffer)g.write(h.buffer);else{if(h==="end")g.end();else{let m;if(h instanceof Error)m=h;else{const f=h;m=(0,d.createFileSystemProviderError)(f.message??(0,U.toErrorMessage)(f),f.code??d.FileSystemProviderErrorCode.Unknown)}g.error(m),g.end()}u.dispose()}})),u.add(p.onCancellationRequested(()=>{g.error((0,A.canceled)()),g.end(),u.dispose()})),g}writeFile(l,c,p){return this.channel.call("writeFile",[l,_.VSBuffer.wrap(c),p])}open(l,c){return this.channel.call("open",[l,c])}close(l){return this.channel.call("close",[l])}async read(l,c,p,g,u){const[h,m]=await this.channel.call("read",[l,c,u]);return p.set(h.buffer.slice(0,m),g),m}write(l,c,p,g,u){return this.channel.call("write",[l,c,_.VSBuffer.wrap(p),g,u])}mkdir(l){return this.channel.call("mkdir",[l])}delete(l,c){return this.channel.call("delete",[l,c])}rename(l,c,p){return this.channel.call("rename",[l,c,p])}copy(l,c,p){return this.channel.call("copy",[l,c,p])}cloneFile(l,c){return this.channel.call("cloneFile",[l,c])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(l=>{if(Array.isArray(l)){const c=l;this._onDidChange.fire((0,C.reviveFileChanges)(c))}else{const c=l;this._onDidWatchError.fire(c)}}))}watch(l,c){const p=(0,P.generateUuid)();return this.channel.call("watch",[this.sessionId,p,l,c]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,p]))}}e.DiskFileSystemProviderClient=E}),define(ae[197],ce([0,1,41,2,46,3,8,6]),function(ne,e,_,U,A,O,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseWatcher=void 0;class P extends U.Disposable{constructor(){super(),this._onDidChangeFile=this._register(new O.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new O.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this._onDidWatchFail=this._register(new O.Emitter),this.onDidWatchFail=this._onDidWatchFail.event,this.allNonCorrelatedWatchRequests=new Set,this.allCorrelatedWatchRequests=new Map,this.suspendedWatchRequests=this._register(new U.DisposableMap),this.suspendedWatchRequestsWithPolling=new Set,this.suspendedWatchRequestPollingInterval=5007,this.joinWatch=new R.DeferredPromise,this.verboseLogging=!1,this._register(this.onDidWatchFail(C=>this.handleDidWatchFail(C)))}handleDidWatchFail(C){this.isCorrelated(C)&&this.suspendWatchRequest(C)}isCorrelated(C){return(0,A.isWatchRequestWithCorrelation)(C)}async watch(C){this.joinWatch.isSettled||this.joinWatch.complete(),this.joinWatch=new R.DeferredPromise;try{this.allCorrelatedWatchRequests.clear(),this.allNonCorrelatedWatchRequests.clear();for(const E of C)this.isCorrelated(E)?this.allCorrelatedWatchRequests.set(E.correlationId,E):this.allNonCorrelatedWatchRequests.add(E);for(const[E]of this.suspendedWatchRequests)this.allCorrelatedWatchRequests.has(E)||(this.suspendedWatchRequests.deleteAndDispose(E),this.suspendedWatchRequestsWithPolling.delete(E));return await this.updateWatchers()}finally{this.joinWatch.complete()}}updateWatchers(){return this.doWatch([...this.allNonCorrelatedWatchRequests,...Array.from(this.allCorrelatedWatchRequests.values()).filter(C=>!this.suspendedWatchRequests.has(C.correlationId))])}isSuspended(C){return typeof C.correlationId!="number"?!1:this.suspendedWatchRequestsWithPolling.has(C.correlationId)?"polling":this.suspendedWatchRequests.has(C.correlationId)}async suspendWatchRequest(C){if(this.suspendedWatchRequests.has(C.correlationId))return;const E=new U.DisposableStore;this.suspendedWatchRequests.set(C.correlationId,E),await this.joinWatch.p,!E.isDisposed&&(this.monitorSuspendedWatchRequest(C,E),this.updateWatchers())}resumeWatchRequest(C){this.suspendedWatchRequests.deleteAndDispose(C.correlationId),this.suspendedWatchRequestsWithPolling.delete(C.correlationId),this.updateWatchers()}monitorSuspendedWatchRequest(C,E){this.doMonitorWithExistingWatcher(C,E)?(this.trace(`reusing an existing recursive watcher to monitor ${C.path}`),this.suspendedWatchRequestsWithPolling.delete(C.correlationId)):(this.doMonitorWithNodeJS(C,E),this.suspendedWatchRequestsWithPolling.add(C.correlationId))}doMonitorWithExistingWatcher(C,E){const v=this.recursiveWatcher?.subscribe(C.path,(l,c)=>{E.isDisposed||(l?this.monitorSuspendedWatchRequest(C,E):c?.type===1&&this.onMonitoredPathAdded(C))});return v?(E.add(v),!0):!1}doMonitorWithNodeJS(C,E){let v=!1;const l=(c,p)=>{if(E.isDisposed)return;const g=this.isPathNotFound(c),u=this.isPathNotFound(p),h=v;v=g,!g&&(u||h)&&this.onMonitoredPathAdded(C)};this.trace(`starting fs.watchFile() on ${C.path} (correlationId: ${C.correlationId})`);try{(0,_.watchFile)(C.path,{persistent:!1,interval:this.suspendedWatchRequestPollingInterval},l)}catch(c){this.warn(`fs.watchFile() failed with error ${c} on path ${C.path} (correlationId: ${C.correlationId})`)}E.add((0,U.toDisposable)(()=>{this.trace(`stopping fs.watchFile() on ${C.path} (correlationId: ${C.correlationId})`);try{(0,_.unwatchFile)(C.path,l)}catch(c){this.warn(`fs.unwatchFile() failed with error ${c} on path ${C.path} (correlationId: ${C.correlationId})`)}}))}onMonitoredPathAdded(C){this.trace(`detected ${C.path} exists again, resuming watcher (correlationId: ${C.correlationId})`);const E={resource:k.URI.file(C.path),type:1,cId:C.correlationId};this._onDidChangeFile.fire([E]),this.traceEvent(E,C),this.resumeWatchRequest(C)}isPathNotFound(C){return C.ctimeMs===0&&C.ino===0}async stop(){this.suspendedWatchRequests.clearAndDisposeAll(),this.suspendedWatchRequestsWithPolling.clear()}traceEvent(C,E){if(this.verboseLogging){const v=` >> normalized ${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.resource.fsPath}`;this.traceWithCorrelation(v,E)}}traceWithCorrelation(C,E){this.verboseLogging&&this.trace(`${C}${typeof E.correlationId=="number"?` <${E.correlationId}> `:""}`)}requestToString(C){return`${C.path} (excludes: ${C.excludes.length>0?C.excludes:"<none>"}, includes: ${C.includes&&C.includes.length>0?JSON.stringify(C.includes):"<all>"}, filter: ${(0,A.requestFilterToString)(C.filter)}, correlationId: ${typeof C.correlationId=="number"?C.correlationId:"<none>"})`}async setVerboseLogging(C){this.verboseLogging=C}}e.BaseWatcher=P}),define(ae[198],ce([0,1,41,6,26,40,2,87,14,5,20,8,148,31,46]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcherLibrary=void 0,e.watchFileContents=g;class p extends k.Disposable{static{this.FILE_DELETE_HANDLER_DELAY=100}static{this.FILE_CHANGES_HANDLER_DELAY=75}get isReusingRecursiveWatcher(){return this._isReusingRecursiveWatcher}get failed(){return this.didFail}constructor(h,m,f,S,t,r){super(),this.request=h,this.recursiveWatcher=m,this.onDidFilesChange=f,this.onDidWatchFail=S,this.onLogMessage=t,this.verboseLogging=r,this.throttledFileChangesEmitter=this._register(new U.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},n=>this.onDidFilesChange(n))),this.fileChangesAggregator=this._register(new U.RunOnceWorker(n=>this.handleFileChanges(n),p.FILE_CHANGES_HANDLER_DELAY)),this.excludes=(0,c.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,c.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.filter=(0,c.isWatchRequestWithCorrelation)(this.request)?this.request.filter:void 0,this.cts=new A.CancellationTokenSource,this.ready=this.watch(),this._isReusingRecursiveWatcher=!1,this.didFail=!1}async watch(){try{const h=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const m=await l.Promises.stat(h);if(this.cts.token.isCancellationRequested)return;this._register(await this.doWatch(h,m.isDirectory()))}catch(h){h.code!=="ENOENT"?this.error(h):this.trace(`ignoring a path for watching who's stat info failed to resolve: ${this.request.path} (error: ${h})`),this.notifyWatchFailed()}}notifyWatchFailed(){this.didFail=!0,this.onDidWatchFail?.()}async normalizePath(h){let m=h.path;try{m=await l.Promises.realpath(h.path),h.path===m&&(m=await(0,v.realcase)(h.path,this.cts.token)??h.path),h.path!==m&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${m})`)}catch{}return m}async doWatch(h,m){const f=new k.DisposableStore;return this.doWatchWithExistingWatcher(h,m,f)?(this.trace(`reusing an existing recursive watcher for ${this.request.path}`),this._isReusingRecursiveWatcher=!0):(this._isReusingRecursiveWatcher=!1,await this.doWatchWithNodeJS(h,m,f)),f}doWatchWithExistingWatcher(h,m,f){if(m)return!1;const S=E.URI.file(this.request.path),t=this.recursiveWatcher?.subscribe(this.request.path,async(r,n)=>{if(!f.isDisposed)if(r){const s=await this.doWatch(h,m);f.isDisposed?s.dispose():f.add(s)}else n&&(typeof n.cId=="number"||typeof this.request.correlationId=="number")&&this.onFileChange({resource:S,type:n.type,cId:this.request.correlationId},!0)});return t?(f.add(t),!0):!1}async doWatchWithNodeJS(h,m,f){if(d.isMacintosh&&(0,O.isEqualOrParent)(h,"/Volumes/",!0)){this.error(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const S=new A.CancellationTokenSource(this.cts.token);f.add((0,k.toDisposable)(()=>S.dispose(!0)));const t=new k.DisposableStore;f.add(t);try{const r=E.URI.file(this.request.path),n=(0,P.basename)(h),s=(0,_.watch)(h);t.add((0,k.toDisposable)(()=>{s.removeAllListeners(),s.close()})),this.trace(`Started watching: '${h}'`);const i=new Set;if(m)try{for(const a of await l.Promises.readdir(h))i.add(a)}catch(a){this.error(a)}if(S.token.isCancellationRequested)return;const o=new Map;t.add((0,k.toDisposable)(()=>{for(const[,a]of o)a.dispose();o.clear()})),s.on("error",(a,y)=>{S.token.isCancellationRequested||(this.error(`Failed to watch ${h} for changes using fs.watch() (${a}, ${y})`),this.notifyWatchFailed())}),s.on("change",(a,y)=>{if(S.token.isCancellationRequested)return;this.verboseLogging&&this.traceWithCorrelation(`[raw] ["${a}"] ${y}`);let I="";if(y&&(I=y.toString(),d.isMacintosh&&(I=(0,R.normalizeNFC)(I))),!(!I||a!=="change"&&a!=="rename"))if(m)if(a==="rename"){o.get(I)?.dispose();const w=setTimeout(async()=>{if(o.delete(I),I===n&&!await l.Promises.exists(h)){this.onWatchedPathDeleted(r);return}if(S.token.isCancellationRequested)return;const b=await this.existsChildStrictCase((0,P.join)(h,I));if(S.token.isCancellationRequested)return;let D;b?i.has(I)?D=0:(D=1,i.add(I)):(i.delete(I),D=2),this.onFileChange({resource:(0,C.joinPath)(r,I),type:D,cId:this.request.correlationId})},p.FILE_DELETE_HANDLER_DELAY);o.set(I,(0,k.toDisposable)(()=>clearTimeout(w)))}else{let w;i.has(I)?w=0:(w=1,i.add(I)),this.onFileChange({resource:(0,C.joinPath)(r,I),type:w,cId:this.request.correlationId})}else if(a==="rename"||I!==n){const w=setTimeout(async()=>{const b=await l.Promises.exists(h);S.token.isCancellationRequested||(b?(this.onFileChange({resource:r,type:0,cId:this.request.correlationId},!0),t.add(await this.doWatch(h,!1))):this.onWatchedPathDeleted(r))},p.FILE_DELETE_HANDLER_DELAY);t.clear(),t.add((0,k.toDisposable)(()=>clearTimeout(w)))}else this.onFileChange({resource:r,type:0,cId:this.request.correlationId},!0)})}catch(r){S.token.isCancellationRequested||this.error(`Failed to watch ${h} for changes using fs.watch() (${r.toString()})`),this.notifyWatchFailed()}}onWatchedPathDeleted(h){this.warn("Watcher shutdown because watched path got deleted"),this.onFileChange({resource:h,type:2,cId:this.request.correlationId},!0),this.fileChangesAggregator.flush(),this.notifyWatchFailed()}onFileChange(h,m=!1){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.traceWithCorrelation(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`),!m&&this.excludes.some(f=>f(h.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (excluded) ${h.resource.fsPath}`):!m&&this.includes&&this.includes.length>0&&!this.includes.some(f=>f(h.resource.fsPath))?this.verboseLogging&&this.traceWithCorrelation(` >> ignored (not included) ${h.resource.fsPath}`):this.fileChangesAggregator.work(h))}handleFileChanges(h){const m=(0,c.coalesceEvents)(h),f=[];for(const t of m){if((0,c.isFiltered)(t,this.filter)){this.verboseLogging&&this.traceWithCorrelation(` >> ignored (filtered) ${t.resource.fsPath}`);continue}f.push(t)}if(f.length===0)return;if(this.verboseLogging)for(const t of f)this.traceWithCorrelation(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.throttledFileChangesEmitter.work(f)?this.throttledFileChangesEmitter.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesEmitter.pending}, most recent change: ${f[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async existsChildStrictCase(h){if(d.isLinux)return l.Promises.exists(h);try{const m=(0,P.basename)(h);return(await l.Promises.readdir((0,P.dirname)(h))).some(S=>S===m)}catch(m){return this.trace(m),!1}}setVerboseLogging(h){this.verboseLogging=h}error(h){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}warn(h){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}trace(h){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}traceWithCorrelation(h){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.trace(`${h}${typeof this.request.correlationId=="number"?` <${this.request.correlationId}> `:""}`)}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=p;async function g(u,h,m,f,S=512){const t=await l.Promises.open(u,"r"),r=Buffer.allocUnsafe(S),n=new A.CancellationTokenSource(f);let s,i=!1;const o={path:u,excludes:[],recursive:!1},a=new p(o,void 0,y=>{(async()=>{for(const{type:I}of y)if(I===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:w}=await l.Promises.read(t,r,0,S,null);if(!w||n.token.isCancellationRequested)break;h(r.slice(0,w))}}catch(w){s=new Error(w),n.dispose(!0)}finally{i=!1}}})()});return await a.ready,m(),new Promise((y,I)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await l.Promises.close(t)}catch(w){s=new Error(w)}s?I(s):y()})})}}),define(ae[199],ce([0,1,3,90,197,5,198,40]),function(ne,e,_,U,A,O,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends A.BaseWatcher{constructor(C){super(),this.recursiveWatcher=C,this.onDidError=_.Event.None,this.watchers=new Set}async doWatch(C){C=this.removeDuplicateRequests(C);const E=[],v=new Set(Array.from(this.watchers));for(const l of C){const c=this.findWatcher(l);c&&(0,U.patternsEquals)(c.request.excludes,l.excludes)&&(0,U.patternsEquals)(c.request.includes,l.includes)?v.delete(c):E.push(l)}E.length&&this.trace(`Request to start watching: ${E.map(l=>this.requestToString(l)).join(",")}`),v.size&&this.trace(`Request to stop watching: ${Array.from(v).map(l=>this.requestToString(l.request)).join(",")}`);for(const l of v)this.stopWatching(l);for(const l of E)this.startWatching(l)}findWatcher(C){for(const E of this.watchers)if(typeof C.correlationId=="number"||typeof E.request.correlationId=="number"){if(E.request.correlationId===C.correlationId)return E}else if((0,R.isEqual)(E.request.path,C.path,!O.isLinux))return E}startWatching(C){const E=new k.NodeJSFileWatcherLibrary(C,this.recursiveWatcher,l=>this._onDidChangeFile.fire(l),()=>this._onDidWatchFail.fire(C),l=>this._onDidLogMessage.fire(l),this.verboseLogging),v={request:C,instance:E};this.watchers.add(v)}async stop(){await super.stop();for(const C of this.watchers)this.stopWatching(C)}stopWatching(C){this.trace("stopping file watcher",C),this.watchers.delete(C),C.instance.dispose()}removeDuplicateRequests(C){const E=new Map;for(const v of C){const l=O.isLinux?v.path:v.path.toLowerCase();let c=E.get(v.correlationId);c||(c=new Map,E.set(v.correlationId,c)),c.has(l)&&this.trace(`ignoring a request for watching who's path is already watched: ${this.requestToString(v)}`),c.set(l,v)}return Array.from(E.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(C){super.setVerboseLogging(C);for(const E of this.watchers)E.instance.setVerboseLogging(C)}trace(C,E){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(C,E)})}warn(C){this._onDidLogMessage.fire({type:"warn",message:this.toMessage(C)})}toMessage(C,E){return E?`[File Watcher (node.js)] ${C} (${this.requestToString(E.request)})`:`[File Watcher (node.js)] ${C}`}}e.NodeJSWatcher=P}),define(ae[200],ce([0,1,46,199]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class A extends _.AbstractNonRecursiveWatcherClient{constructor(k,R,P){super(k,R,P),this.init()}createWatcher(k){return k.add(new U.NodeJSWatcher(void 0))}}e.NodeJSWatcherClient=A}),define(ae[201],ce([0,1,23,42,92,46]),function(ne,e,_,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class k extends O.AbstractUniversalWatcherClient{constructor(P,d,C){super(P,d,C),this.init()}createWatcher(P){const d=P.add(new A.Client(_.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(d.onDidProcessExit(({code:C,signal:E})=>this.onError(`terminated by itself with code ${C}, signal: ${E} (ETERM)`))),U.ProxyChannel.toService((0,U.getNextTickChannel)(d.getChannel("watcher")))}}e.UniversalWatcherClient=k}),define(ae[74],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class _{constructor(...A){this._entries=new Map;for(const[O,k]of A)this.set(O,k)}set(A,O){const k=this._entries.get(A);return this._entries.set(A,O),k}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=_}),define(ae[202],ce([0,1,6,7,2,72,192,4,74,86]),function(ne,e,_,U,A,O,k,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const C=!1;class E extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class v{constructor(g=new P.ServiceCollection,u=!1,h,m=C){this._services=g,this._strict=u,this._parent=h,this._enableTracing=m,this._isDisposed=!1,this._servicesToMaybeDispose=new Set,this._children=new Set,this._activeInstantiations=new Set,this._services.set(R.IInstantiationService,this),this._globalGraph=m?h?._globalGraph??new k.Graph(f=>f):void 0}dispose(){if(!this._isDisposed){this._isDisposed=!0,(0,A.dispose)(this._children),this._children.clear();for(const g of this._servicesToMaybeDispose)(0,A.isDisposable)(g)&&g.dispose();this._servicesToMaybeDispose.clear()}}_throwIfDisposed(){if(this._isDisposed)throw new Error("InstantiationService has been disposed")}createChild(g){this._throwIfDisposed();const u=new class extends v{dispose(){this._children.delete(u),super.dispose()}}(g,this._strict,this,this._enableTracing);return this._children.add(u),u}invokeFunction(g,...u){this._throwIfDisposed();const h=c.traceInvocation(this._enableTracing,g);let m=!1;try{return g({get:S=>{if(m)throw(0,U.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(S,h);if(!t)throw new Error(`[invokeFunction] unknown service '${S}'`);return t}},...u)}finally{m=!0,h.stop()}}createInstance(g,...u){this._throwIfDisposed();let h,m;return g instanceof O.SyncDescriptor?(h=c.traceCreation(this._enableTracing,g.ctor),m=this._createInstance(g.ctor,g.staticArguments.concat(u),h)):(h=c.traceCreation(this._enableTracing,g),m=this._createInstance(g,u,h)),h.stop(),m}_createInstance(g,u=[],h){const m=R._util.getServiceDependencies(g).sort((t,r)=>t.index-r.index),f=[];for(const t of m){const r=this._getOrCreateServiceInstance(t.id,h);r||this._throwIfStrict(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),f.push(r)}const S=m.length>0?m[0].index:u.length;if(u.length!==S){console.trace(`[createInstance] First service dependency of ${g.name} at position ${S+1} conflicts with ${u.length} static arguments`);const t=S-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,S)}return Reflect.construct(g,u.concat(f))}_setCreatedServiceInstance(g,u){if(this._services.get(g)instanceof O.SyncDescriptor)this._services.set(g,u);else if(this._parent)this._parent._setCreatedServiceInstance(g,u);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(g){const u=this._services.get(g);return!u&&this._parent?this._parent._getServiceInstanceOrDescriptor(g):u}_getOrCreateServiceInstance(g,u){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(g));const h=this._getServiceInstanceOrDescriptor(g);return h instanceof O.SyncDescriptor?this._safeCreateAndCacheServiceInstance(g,h,u.branch(g,!0)):(u.branch(g,!1),h)}_safeCreateAndCacheServiceInstance(g,u,h){if(this._activeInstantiations.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this._activeInstantiations.add(g);try{return this._createAndCacheServiceInstance(g,u,h)}finally{this._activeInstantiations.delete(g)}}_createAndCacheServiceInstance(g,u,h){const m=new k.Graph(t=>t.id.toString());let f=0;const S=[{id:g,desc:u,_trace:h}];for(;S.length;){const t=S.pop();if(m.lookupOrInsertNode(t),f++>1e3)throw new E(m);for(const r of R._util.getServiceDependencies(t.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(r.id);if(n||this._throwIfStrict(`[createInstance] ${g} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),n instanceof O.SyncDescriptor){const s={id:r.id,desc:n,_trace:t._trace.branch(r.id,!0)};m.insertEdge(t,s),S.push(s)}}}for(;;){const t=m.roots();if(t.length===0){if(!m.isEmpty())throw new E(m);break}for(const{data:r}of t){if(this._getServiceInstanceOrDescriptor(r.id)instanceof O.SyncDescriptor){const s=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setCreatedServiceInstance(r.id,s)}m.removeNode(r)}}return this._getServiceInstanceOrDescriptor(g)}_createServiceInstanceWithOwner(g,u,h=[],m,f){if(this._services.get(g)instanceof O.SyncDescriptor)return this._createServiceInstance(g,u,h,m,f,this._servicesToMaybeDispose);if(this._parent)return this._parent._createServiceInstanceWithOwner(g,u,h,m,f);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}_createServiceInstance(g,u,h=[],m,f,S){if(m){const t=new v(void 0,this._strict,this,this._enableTracing);t._globalGraphImplicitDependency=String(g);const r=new Map,n=new _.GlobalIdleValue(()=>{const s=t._createInstance(u,h,f);for(const[i,o]of r){const a=s[i];if(typeof a=="function")for(const y of o)y.disposable=a.apply(s,y.listener)}return r.clear(),S.add(s),s});return new Proxy(Object.create(null),{get(s,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let y=r.get(i);return y||(y=new d.LinkedList,r.set(i,y)),(w,b,D)=>{if(n.isInitialized)return n.value[i](w,b,D);{const L={listener:[w,b,D],disposable:void 0},N=y.push(L);return(0,A.toDisposable)(()=>{N(),L.disposable?.dispose()})}}}if(i in s)return s[i];const o=n.value;let a=o[i];return typeof a!="function"||(a=a.bind(o),s[i]=a),a},set(s,i,o){return n.value[i]=o,!0},getPrototypeOf(s){return u.prototype}})}else{const t=this._createInstance(u,h,f);return S.add(t),t}}_throwIfStrict(g,u){if(u&&console.warn(g),this._strict)throw new Error(g)}}e.InstantiationService=v;var l;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(l||(l={}));class c{static{this.all=new Set}static{this._None=new class extends c{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,u){return g?new c(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):c._None}static traceCreation(g,u){return g?new c(1,u.name):c._None}static{this._totals=0}constructor(g,u){this.type=g,this.name=u,this._start=Date.now(),this._dep=[]}branch(g,u){const h=new c(3,g.toString());return this._dep.push([g,u,h]),h}stop(){const g=Date.now()-this._start;c._totals+=g;let u=!1;function h(f,S){const t=[],r=new Array(f+1).join("	");for(const[n,s,i]of S._dep)if(s&&i){u=!0,t.push(`${r}CREATES -> ${n}`);const o=h(f+1,i);o&&t.push(o)}else t.push(`${r}uses -> ${n}`);return t.join(`
`)}const m=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(g>2||u)&&c.all.add(m.join(`
`))}}e.Trace=c}),define(ae[56],ce([0,1,4]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,_.createDecorator)("mainProcessService");class U{constructor(O,k){this.server=O,this.router=k}getChannel(O){return this.server.getChannel(O,this.router)}registerChannel(O,k){this.server.registerChannel(O,k)}}e.MainProcessService=U}),define(ae[75],ce([0,1,26,2,5,167,29,4]),function(ne,e,_,U,A,O,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.getLocale=P;function P(C){return C.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.ILanguagePackService=(0,R.createDecorator)("languagePackService");let d=class extends U.Disposable{constructor(E){super(),this.extensionGalleryService=E}async getAvailableLanguages(){const E=new _.CancellationTokenSource;setTimeout(()=>E.cancel(),1e3);let v;try{v=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const c=v.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(g=>g.startsWith("lp-"))).map(p=>{const g=p.properties.localizedLanguages?.[0],u=P(p);return{...this.createQuickPickItem(u,g,p),extensionId:p.identifier.id,galleryExtension:p}});return c.push(this.createQuickPickItem("en","English")),c}createQuickPickItem(E,v,l){const c=v??E;let p;if(c!==E&&(p=`(${E})`),E.toLowerCase()===A.language.toLowerCase()&&(p??="",p+=(0,O.localize)(0,null)),l?.installCount){p??="";const g=l.installCount;let u;g>1e6?u=`${Math.floor(g/1e5)/10}M`:g>1e3?u=`${Math.floor(g/1e3)}K`:u=String(g),p+=` $(cloud-download) ${u}`}return{id:E,label:c,description:p}}};e.LanguagePackBaseService=d,e.LanguagePackBaseService=d=Ce([K(0,k.IExtensionGalleryService)],d)}),define(ae[203],ce([0,1,2,75]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let A=class extends _.Disposable{constructor(k){super(),this.localizationsService=k,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};e.LocalizationsUpdater=A,e.LocalizationsUpdater=A=Ce([K(0,U.ILanguagePackService)],A)}),define(ae[9],ce([0,1,168,38,3,54,2,34,5,20,13,8,93,4]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=p,e.log=u,e.getLogLevel=a,e.LogLevelToString=y,e.LogLevelToLocalizedString=I,e.parseLogLevel=w,e.ILogService=(0,l.createDecorator)("logService"),e.ILoggerService=(0,l.createDecorator)("loggerService");function c(){return new Date().toISOString()}function p(b){return(0,C.isNumber)(b)}var g;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(g||(e.LogLevel=g={})),e.DEFAULT_LOG_LEVEL=g.Info;function u(b,D,L){switch(D){case g.Trace:b.trace(L);break;case g.Debug:b.debug(L);break;case g.Info:b.info(L);break;case g.Warning:b.warn(L);break;case g.Error:b.error(L);break;case g.Off:break;default:throw new Error(`Invalid log level ${D}`)}}function h(b,D=!1){let L="";for(let N=0;N<b.length;N++){let F=b[N];if(F instanceof Error&&(F=(0,U.toErrorMessage)(F,D)),typeof F=="object")try{F=JSON.stringify(F)}catch{}L+=(N>0?" ":"")+F}return L}class m extends k.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(D){this.level!==D&&(this.level=D,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(D){return this.level!==g.Off&&this.level<=D}}e.AbstractLogger=m;class f extends m{constructor(D){super(),this.logAlways=D}checkLogLevel(D){return this.logAlways||super.checkLogLevel(D)}trace(D,...L){this.checkLogLevel(g.Trace)&&this.log(g.Trace,h([D,...L],!0))}debug(D,...L){this.checkLogLevel(g.Debug)&&this.log(g.Debug,h([D,...L]))}info(D,...L){this.checkLogLevel(g.Info)&&this.log(g.Info,h([D,...L]))}warn(D,...L){this.checkLogLevel(g.Warning)&&this.log(g.Warning,h([D,...L]))}error(D,...L){if(this.checkLogLevel(g.Error))if(D instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=D.stack,this.log(g.Error,h(N))}else this.log(g.Error,h([D,...L]))}flush(){}}e.AbstractMessageLogger=f;class S extends m{constructor(D=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(D),this.useColors=!P.isWindows}trace(D,...L){this.checkLogLevel(g.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,D,...L):console.log(`[main ${c()}]`,D,...L))}debug(D,...L){this.checkLogLevel(g.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,D,...L):console.log(`[main ${c()}]`,D,...L))}info(D,...L){this.checkLogLevel(g.Info)&&(this.useColors?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,D,...L):console.log(`[main ${c()}]`,D,...L))}warn(D,...L){this.checkLogLevel(g.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,D,...L):console.warn(`[main ${c()}]`,D,...L))}error(D,...L){this.checkLogLevel(g.Error)&&(this.useColors?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,D,...L):console.error(`[main ${c()}]`,D,...L))}flush(){}}e.ConsoleMainLogger=S;class t extends m{constructor(D=e.DEFAULT_LOG_LEVEL,L=!0){super(),this.useColors=L,this.setLevel(D)}trace(D,...L){this.checkLogLevel(g.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",D,...L):console.log(D,...L))}debug(D,...L){this.checkLogLevel(g.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",D,...L):console.log(D,...L))}info(D,...L){this.checkLogLevel(g.Info)&&(this.useColors?console.log("%c INFO","color: #33f",D,...L):console.log(D,...L))}warn(D,...L){this.checkLogLevel(g.Warning)&&(this.useColors?console.log("%c WARN","color: #993",D,...L):console.log(D,...L))}error(D,...L){this.checkLogLevel(g.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",D,...L):console.error(D,...L))}flush(){}}e.ConsoleLogger=t;class r extends m{constructor(D,L=e.DEFAULT_LOG_LEVEL){super(),this.adapter=D,this.setLevel(L)}trace(D,...L){this.checkLogLevel(g.Trace)&&this.adapter.log(g.Trace,[this.extractMessage(D),...L])}debug(D,...L){this.checkLogLevel(g.Debug)&&this.adapter.log(g.Debug,[this.extractMessage(D),...L])}info(D,...L){this.checkLogLevel(g.Info)&&this.adapter.log(g.Info,[this.extractMessage(D),...L])}warn(D,...L){this.checkLogLevel(g.Warning)&&this.adapter.log(g.Warning,[this.extractMessage(D),...L])}error(D,...L){this.checkLogLevel(g.Error)&&this.adapter.log(g.Error,[this.extractMessage(D),...L])}extractMessage(D){return typeof D=="string"?D:(0,U.toErrorMessage)(D,this.checkLogLevel(g.Trace))}flush(){}}e.AdapterLogger=r;class n extends m{constructor(D){super(),this.loggers=D,D.length&&this.setLevel(D[0].getLevel())}setLevel(D){for(const L of this.loggers)L.setLevel(D);super.setLevel(D)}trace(D,...L){for(const N of this.loggers)N.trace(D,...L)}debug(D,...L){for(const N of this.loggers)N.debug(D,...L)}info(D,...L){for(const N of this.loggers)N.info(D,...L)}warn(D,...L){for(const N of this.loggers)N.warn(D,...L)}error(D,...L){for(const N of this.loggers)N.error(D,...L)}flush(){for(const D of this.loggers)D.flush()}dispose(){for(const D of this.loggers)D.dispose();super.dispose()}}e.MultiplexLogger=n;class s extends k.Disposable{constructor(D,L,N){if(super(),this.logLevel=D,this.logsHome=L,this._loggers=new R.ResourceMap,this._onDidChangeLoggers=this._register(new A.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,N)for(const F of N)this._loggers.set(F.resource,{logger:void 0,info:F})}getLoggerEntry(D){return(0,C.isString)(D)?[...this._loggers.values()].find(L=>L.info.id===D):this._loggers.get(D)}getLogger(D){return this.getLoggerEntry(D)?.logger}createLogger(D,L){const N=this.toResource(D),F=(0,C.isString)(D)?D:L?.id??(0,O.hash)(N.toString()).toString(16);let x=this._loggers.get(N)?.logger;const X=L?.logLevel==="always"?g.Trace:L?.logLevel;x||(x=this.doCreateLogger(N,X??this.getLogLevel(N)??this.logLevel,{...L,id:F}));const B={logger:x,info:{resource:N,id:F,logLevel:X,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(B.info),this._loggers.set(N,B),x}toResource(D){return(0,C.isString)(D)?(0,d.joinPath)(this.logsHome,`${D}.log`):D}setLogLevel(D,L){if(E.URI.isUri(D)){const N=D,F=L,x=this._loggers.get(N);x&&F!==x.info.logLevel&&(x.info.logLevel=F===this.logLevel?void 0:F,x.logger?.setLevel(F),this._loggers.set(x.info.resource,x),this._onDidChangeLogLevel.fire([N,F]))}else{this.logLevel=D;for(const[N,F]of this._loggers.entries())this._loggers.get(N)?.info.logLevel===void 0&&F.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(D,L){const N=this.getLoggerEntry(D);N&&L!==!N.info.hidden&&(N.info.hidden=!L,this._loggers.set(N.info.resource,N),this._onDidChangeVisibility.fire([N.info.resource,L]))}getLogLevel(D){let L;return D&&(L=this._loggers.get(D)?.info.logLevel),L??this.logLevel}registerLogger(D){const L=this._loggers.get(D.resource);L?L.info.hidden!==D.hidden&&this.setVisibility(D.resource,!D.hidden):(this._loggers.set(D.resource,{info:D,logger:void 0}),this._onDidChangeLoggers.fire({added:[D],removed:[]}))}deregisterLogger(D){const L=this._loggers.get(D);L&&(L.logger&&L.logger.dispose(),this._loggers.delete(D),this._onDidChangeLoggers.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const D of this._loggers.values())yield D.info}getRegisteredLogger(D){return this._loggers.get(D)?.info}dispose(){this._loggers.forEach(D=>D.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=s;class i{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(D){}getLevel(){return g.Info}trace(D,...L){}debug(D,...L){}info(D,...L){}warn(D,...L){}error(D,...L){}critical(D,...L){}dispose(){}flush(){}}e.NullLogger=i;class o extends i{}e.NullLogService=o;function a(b){if(b.verbose)return g.Trace;if(typeof b.logLevel=="string"){const D=w(b.logLevel.toLowerCase());if(D!==void 0)return D}return e.DEFAULT_LOG_LEVEL}function y(b){switch(b){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function I(b){switch(b){case g.Trace:return{original:"Trace",value:_.localize(0,null)};case g.Debug:return{original:"Debug",value:_.localize(1,null)};case g.Info:return{original:"Info",value:_.localize(2,null)};case g.Warning:return{original:"Warning",value:_.localize(3,null)};case g.Error:return{original:"Error",value:_.localize(4,null)};case g.Off:return{original:"Off",value:_.localize(5,null)}}}function w(b){switch(b){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.CONTEXT_LOG_LEVEL=new v.RawContextKey("logLevel",y(g.Info))}),define(ae[204],ce([0,1,6,7,2,23,14,20,31,16,9]),function(ne,e,_,U,A,O,k,R,P,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends A.Disposable{constructor(l,c){super(),this.environmentService=l,this.logService=c,this._register(new _.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const l=(0,R.basename)(this.environmentService.logsHome),c=(0,R.dirname)(this.environmentService.logsHome.with({scheme:O.Schemas.file})).fsPath,u=(await P.Promises.readdir(c)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==l),h=u.slice(0,Math.max(0,u.length-9));h.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${h.join(", ")}'`),await Promise.all(h.map(m=>P.Promises.rm((0,k.join)(c,m)))))}catch(l){(0,U.onUnexpectedError)(l)}}};e.LogsDataCleaner=E,e.LogsDataCleaner=E=Ce([K(0,d.IEnvironmentService),K(1,C.ILogService)],E)}),define(ae[205],ce([0,1,17,6,7,3,40,2,14,46,9]),function(ne,e,_,U,A,O,k,R,P,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class E extends R.Disposable{constructor(l,c){super(),this.logService=l,this.options=c,this._onDidChangeFile=this._register(new O.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalWatchRequests=[],this.universalWatchRequestDelayer=this._register(new U.ThrottledDelayer(0)),this.nonRecursiveWatchRequests=[],this.nonRecursiveWatchRequestDelayer=this._register(new U.ThrottledDelayer(0))}watch(l,c){return c.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(l,c):this.watchNonRecursive(l,c)}watchUniversal(l,c){const p={path:this.toWatchPath(l),excludes:c.excludes,includes:c.includes,recursive:c.recursive,filter:c.filter,correlationId:c.correlationId},g=(0,_.insert)(this.universalWatchRequests,p);return this.refreshUniversalWatchers(),(0,R.toDisposable)(()=>{g(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(l=>(0,A.onUnexpectedError)(l))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(c=>this._onDidChangeFile.fire((0,d.reviveFileChanges)(c)),c=>this.onWatcherLogMessage(c),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)})));const l=this.options?.watcher?.recursive?.usePolling;if(l===!0)for(const c of this.universalWatchRequests)(0,d.isRecursiveWatchRequest)(c)&&(c.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(l))for(const c of this.universalWatchRequests)(0,d.isRecursiveWatchRequest)(c)&&l.includes(c.path)&&(c.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalWatchRequests)}watchNonRecursive(l,c){const p={path:this.toWatchPath(l),excludes:c.excludes,includes:c.includes,recursive:!1,filter:c.filter,correlationId:c.correlationId},g=(0,_.insert)(this.nonRecursiveWatchRequests,p);return this.refreshNonRecursiveWatchers(),(0,R.toDisposable)(()=>{g(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(l=>(0,A.onUnexpectedError)(l))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(l=>this._onDidChangeFile.fire((0,d.reviveFileChanges)(l)),l=>this.onWatcherLogMessage(l),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursiveWatchRequests)}onWatcherLogMessage(l){l.type==="error"&&this._onDidWatchError.fire(l.message),this.logWatcherMessage(l)}logWatcherMessage(l){this.logService[l.type](l.message)}toFilePath(l){return(0,P.normalize)(l.fsPath)}toWatchPath(l){const c=this.toFilePath(l);return(0,k.removeTrailingPathSeparator)(c)}}e.AbstractDiskFileSystemProvider=E}),define(ae[206],ce([0,1,17,6,15,26,3,54,61,2,51,23,98,20,50,163,12,97,9,7]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g,u,h,m){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let S=class extends d.Disposable{static{f=this}constructor(r){super(),this.logService=r,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this.internalOnDidFilesChange=this._register(new k.Emitter),this._onDidUncorrelatedFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidUncorrelatedFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new U.ResourceQueue)}registerProvider(r,n){if(this.provider.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${r}`);const s=new d.DisposableStore;return this.provider.set(r,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:r,provider:n}),s.add(n.onDidChangeFile(i=>{const o=new g.FileChangesEvent(i,!this.isPathCaseSensitive(n));this.internalOnDidFilesChange.fire(o),o.hasCorrelation()||this._onDidUncorrelatedFilesChange.fire(o)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),s.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:r}))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:r,provider:n}),this.provider.delete(r),(0,d.dispose)(s)})}getProvider(r){return this.provider.get(r)}async activateProvider(r){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:r,join(s){n.push(s)}}),!this.provider.has(r)&&await U.Promises.settled(n)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.provider.has(r.scheme)}hasCapability(r,n){const s=this.provider.get(r.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return P.Iterable.map(this.provider,([r,n])=>({scheme:r,capabilities:n.capabilities}))}async withProvider(r){if(!(0,l.isAbsolutePath)(r))throw new g.FileOperationError((0,p.localize)(0,null,this.resourceForError(r)),8);await this.activateProvider(r.scheme);const n=this.provider.get(r.scheme);if(!n){const s=new m.ErrorNoTelemetry;throw s.message=(0,p.localize)(1,null,r.toString()),s}return n}async withReadProvider(r){const n=await this.withProvider(r);if((0,g.hasOpenReadWriteCloseCapability)(n)||(0,g.hasReadWriteCapability)(n)||(0,g.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(r){const n=await this.withProvider(r);if((0,g.hasOpenReadWriteCloseCapability)(n)||(0,g.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,n){try{return await this.doResolveFile(r,n)}catch(s){throw(0,g.toFileSystemProviderErrorCode)(s)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,p.localize)(2,null,this.resourceForError(r)),1):(0,g.ensureFileSystemProviderError)(s)}}async doResolveFile(r,n){const s=await this.withProvider(r),i=this.isPathCaseSensitive(s),o=n?.resolveTo,a=n?.resolveSingleChildDescendants,y=n?.resolveMetadata,I=await s.stat(r);let w;return this.toFileStat(s,r,I,void 0,!!y,(b,D)=>(w||(w=C.TernarySearchTree.forUris(()=>!i),w.set(r,!0),o&&w.fill(!0,o)),w.get(b.resource)||w.findSuperstr(b.resource.with({query:null,fragment:null}))?!0:b.isDirectory&&a?D===1:!1))}async toFileStat(r,n,s,i,o,a){const{providerExtUri:y}=this.getExtUri(r),I={resource:n,name:y.basename(n),isFile:(s.type&g.FileType.File)!==0,isDirectory:(s.type&g.FileType.Directory)!==0,isSymbolicLink:(s.type&g.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&g.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((s.permissions??0)&g.FilePermission.Locked),etag:(0,g.etag)({mtime:s.mtime,size:s.size}),children:void 0};if(I.isDirectory&&a(I,i)){try{const w=await r.readdir(n),b=await U.Promises.settled(w.map(async([D,L])=>{try{const N=y.joinPath(n,D),F=o?await r.stat(N):{type:L};return await this.toFileStat(r,N,F,w.length,o,a)}catch(N){return this.logService.trace(N),null}}));I.children=(0,_.coalesce)(b)}catch(w){this.logService.trace(w),I.children=[]}return I}return I}async resolveAll(r){return U.Promises.settled(r.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async stat(r){const n=await this.withProvider(r),s=await n.stat(r);return this.toFileStat(n,r,s,void 0,!0,()=>!1)}async exists(r){const n=await this.withProvider(r);try{return!!await n.stat(r)}catch{return!1}}async canCreateFile(r,n){try{await this.doValidateCreateFile(r,n)}catch(s){return s}return!0}async doValidateCreateFile(r,n){if(!n?.overwrite&&await this.exists(r))throw new g.FileOperationError((0,p.localize)(3,null,this.resourceForError(r)),3,n)}async createFile(r,n=A.VSBuffer.fromString(""),s){await this.doValidateCreateFile(r,s);const i=await this.writeFile(r,n);return this._onDidRunOperation.fire(new g.FileOperationEvent(r,0,i)),i}async writeFile(r,n,s){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),{providerExtUri:o}=this.getExtUri(i);let a=s;if((0,g.hasFileAtomicWriteCapability)(i)&&!a?.atomic){const y=i.enforceAtomicWriteFile?.(r);y&&(a={...s,atomic:y})}try{await this.validateWriteFile(i,r,a)||await this.mkdirp(i,o.dirname(r));let I;if((0,g.hasReadWriteCapability)(i)&&!(n instanceof A.VSBuffer))if((0,c.isReadableStream)(n)){const w=await(0,c.peekStream)(n,3);w.ended?I=A.VSBuffer.concat(w.buffer):I=w}else I=(0,c.peekReadable)(n,w=>A.VSBuffer.concat(w),3);else I=n;!(0,g.hasOpenReadWriteCloseCapability)(i)||(0,g.hasReadWriteCapability)(i)&&I instanceof A.VSBuffer||(0,g.hasReadWriteCapability)(i)&&(0,g.hasFileAtomicWriteCapability)(i)&&a?.atomic?await this.doWriteUnbuffered(i,r,a,I):await this.doWriteBuffered(i,r,a,I instanceof A.VSBuffer?(0,A.bufferToReadable)(I):I),this._onDidRunOperation.fire(new g.FileOperationEvent(r,4))}catch(y){throw new g.FileOperationError((0,p.localize)(4,null,this.resourceForError(r),(0,g.ensureFileSystemProviderError)(y).toString()),(0,g.toFileOperationResult)(y),a)}return this.resolve(r,{resolveMetadata:!0})}async validateWriteFile(r,n,s){const i=!!s?.unlock;if(i&&!(r.capabilities&8192))throw new Error((0,p.localize)(5,null,this.resourceForError(n)));if(!!s?.atomic){if(!(r.capabilities&32768))throw new Error((0,p.localize)(6,null,this.resourceForError(n)));if(!(r.capabilities&2))throw new Error((0,p.localize)(7,null,this.resourceForError(n)));if(i)throw new Error((0,p.localize)(8,null,this.resourceForError(n)))}let a;try{a=await r.stat(n)}catch{return}if(a.type&g.FileType.Directory)throw new g.FileOperationError((0,p.localize)(9,null,this.resourceForError(n)),0,s);if(this.throwIfFileIsReadonly(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==g.ETAG_DISABLED&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,g.etag)({mtime:s.mtime,size:a.size}))throw new g.FileOperationError((0,p.localize)(10,null),3,s);return a}async readFile(r,n,s){const i=await this.withReadProvider(r);return n?.atomic?this.doReadFileAtomic(i,r,n,s):this.doReadFile(i,r,n,s)}async doReadFileAtomic(r,n,s,i){return new Promise((o,a)=>{this.writeQueue.queueFor(n,async()=>{try{const y=await this.doReadFile(r,n,s,i);o(y)}catch(y){a(y)}},this.getExtUri(r).providerExtUri)})}async doReadFile(r,n,s,i){const o=await this.doReadFileStream(r,n,{...s,preferUnbuffered:!0},i);return{...o,value:await(0,A.streamToBuffer)(o.value)}}async readFileStream(r,n,s){const i=await this.withReadProvider(r);return this.doReadFileStream(i,r,n,s)}async doReadFileStream(r,n,s,i){const o=new O.CancellationTokenSource(i);let a=s;(0,g.hasFileAtomicReadCapability)(r)&&r.enforceAtomicReadFile?.(n)&&(a={...s,atomic:!0});const y=this.validateReadFile(n,a).then(w=>w,w=>{throw o.dispose(!0),w});let I;try{return typeof a?.etag=="string"&&a.etag!==g.ETAG_DISABLED&&await y,a?.atomic&&(0,g.hasFileAtomicReadCapability)(r)||!((0,g.hasOpenReadWriteCloseCapability)(r)||(0,g.hasFileReadStreamCapability)(r))||(0,g.hasReadWriteCapability)(r)&&a?.preferUnbuffered?I=this.readFileUnbuffered(r,n,a):(0,g.hasFileReadStreamCapability)(r)?I=this.readFileStreamed(r,n,o.token,a):I=this.readFileBuffered(r,n,o.token,a),I.on("end",()=>o.dispose()),I.on("error",()=>o.dispose()),{...await y,value:I}}catch(w){throw I&&await(0,c.consumeStream)(I),this.restoreReadError(w,n,a)}}restoreReadError(r,n,s){const i=(0,p.localize)(11,null,this.resourceForError(n),(0,g.ensureFileSystemProviderError)(r).toString());return r instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(i,r.stat,s):r instanceof g.TooLargeFileOperationError?new g.TooLargeFileOperationError(i,r.fileOperationResult,r.size,r.options):new g.FileOperationError(i,(0,g.toFileOperationResult)(r),s)}readFileStreamed(r,n,s,i=Object.create(null)){const o=r.readFileStream(n,i,s);return(0,c.transform)(o,{data:a=>a instanceof A.VSBuffer?a:A.VSBuffer.wrap(a),error:a=>this.restoreReadError(a,n,i)},a=>A.VSBuffer.concat(a))}readFileBuffered(r,n,s,i=Object.create(null)){const o=(0,A.newWriteableBufferStream)();return(0,u.readFileIntoStream)(r,n,o,a=>a,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:a=>this.restoreReadError(a,n,i)},s),o}readFileUnbuffered(r,n,s){const i=(0,c.newWriteableStream)(o=>A.VSBuffer.concat(o));return(async()=>{try{let o;s?.atomic&&(0,g.hasFileAtomicReadCapability)(r)?o=await r.readFile(n,{atomic:!0}):o=await r.readFile(n),typeof s?.position=="number"&&(o=o.slice(s.position)),typeof s?.length=="number"&&(o=o.slice(0,s.length)),this.validateReadFileLimits(n,o.byteLength,s),i.end(A.VSBuffer.wrap(o))}catch(o){i.error(o),i.end()}})(),i}async validateReadFile(r,n){const s=await this.resolve(r,{resolveMetadata:!0});if(s.isDirectory)throw new g.FileOperationError((0,p.localize)(12,null,this.resourceForError(r)),0,n);if(typeof n?.etag=="string"&&n.etag!==g.ETAG_DISABLED&&n.etag===s.etag)throw new g.NotModifiedSinceFileOperationError((0,p.localize)(13,null),s,n);return this.validateReadFileLimits(r,s.size,n),s}validateReadFileLimits(r,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new g.TooLargeFileOperationError((0,p.localize)(14,null,this.resourceForError(r)),7,n,s)}async canMove(r,n,s){return this.doCanMoveCopy(r,n,"move",s)}async canCopy(r,n,s){return this.doCanMoveCopy(r,n,"copy",s)}async doCanMoveCopy(r,n,s,i){if(r.toString()!==n.toString())try{const o=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r):await this.withReadProvider(r),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(o,r,a,n,s,i)}catch(o){return o}return!0}async move(r,n,s){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),a=await this.doMoveCopy(i,r,o,n,"move",!!s),y=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(r,a==="move"?2:3,y)),y}async copy(r,n,s){const i=await this.withReadProvider(r),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),a=await this.doMoveCopy(i,r,o,n,"copy",!!s),y=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(r,a==="copy"?3:2,y)),y}async doMoveCopy(r,n,s,i,o,a){if(n.toString()===i.toString())return o;const{exists:y,isSameResourceWithDifferentPathCase:I}=await this.doValidateMoveCopy(r,n,s,i,o,a);if(y&&!I&&a&&await this.del(i,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(i)),o==="copy"){if(r===s&&(0,g.hasFileFolderCopyCapability)(r))await r.copy(n,i,{overwrite:a});else{const w=await this.resolve(n);w.isDirectory?await this.doCopyFolder(r,w,s,i):await this.doCopyFile(r,n,s,i)}return o}else return r===s?(await r.rename(n,i,{overwrite:a}),o):(await this.doMoveCopy(r,n,s,i,"copy",a),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(r,n,s,i){if((0,g.hasOpenReadWriteCloseCapability)(r)&&(0,g.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(r,n,s,i);if((0,g.hasOpenReadWriteCloseCapability)(r)&&(0,g.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(r,n,s,i);if((0,g.hasReadWriteCapability)(r)&&(0,g.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(r,n,s,i);if((0,g.hasReadWriteCapability)(r)&&(0,g.hasReadWriteCapability)(s))return this.doPipeUnbuffered(r,n,s,i)}async doCopyFolder(r,n,s,i){await s.mkdir(i),Array.isArray(n.children)&&await U.Promises.settled(n.children.map(async o=>{const a=this.getExtUri(s).providerExtUri.joinPath(i,o.name);return o.isDirectory?this.doCopyFolder(r,await this.resolve(o.resource),s,a):this.doCopyFile(r,o.resource,s,a)}))}async doValidateMoveCopy(r,n,s,i,o,a){let y=!1;if(r===s){const{providerExtUri:w,isPathCaseSensitive:b}=this.getExtUri(r);if(b||(y=w.isEqual(n,i)),y&&o==="copy")throw new Error((0,p.localize)(15,null,this.resourceForError(n),this.resourceForError(i)));if(!y&&w.isEqualOrParent(i,n))throw new Error((0,p.localize)(16,null,this.resourceForError(n),this.resourceForError(i)))}const I=await this.exists(i);if(I&&!y){if(!a)throw new g.FileOperationError((0,p.localize)(17,null,this.resourceForError(n),this.resourceForError(i)),4);if(r===s){const{providerExtUri:w}=this.getExtUri(r);if(w.isEqualOrParent(n,i))throw new Error((0,p.localize)(18,null,this.resourceForError(n),this.resourceForError(i)))}}return{exists:I,isSameResourceWithDifferentPathCase:y}}getExtUri(r){const n=this.isPathCaseSensitive(r);return{providerExtUri:n?l.extUri:l.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(r){return!!(r.capabilities&1024)}async createFolder(r){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r);await this.mkdirp(n,r);const s=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(r,0,s)),s}async mkdirp(r,n){const s=[],{providerExtUri:i}=this.getExtUri(r);for(;!i.isEqual(n,i.dirname(n));)try{if(!((await r.stat(n)).type&g.FileType.Directory))throw new Error((0,p.localize)(19,null,this.resourceForError(n)));break}catch(o){if((0,g.toFileSystemProviderErrorCode)(o)!==g.FileSystemProviderErrorCode.FileNotFound)throw o;s.push(i.basename(n)),n=i.dirname(n)}for(let o=s.length-1;o>=0;o--){n=i.joinPath(n,s[o]);try{await r.mkdir(n)}catch(a){if((0,g.toFileSystemProviderErrorCode)(a)!==g.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(r,n){try{await this.doValidateDelete(r,n)}catch(s){return s}return!0}async doValidateDelete(r,n){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(r),r),i=!!n?.useTrash;if(i&&!(s.capabilities&4096))throw new Error((0,p.localize)(20,null,this.resourceForError(r)));const o=n?.atomic;if(o&&!(s.capabilities&65536))throw new Error((0,p.localize)(21,null,this.resourceForError(r)));if(i&&o)throw new Error((0,p.localize)(22,null,this.resourceForError(r)));let a;try{a=await s.stat(r)}catch{}if(a)this.throwIfFileIsReadonly(r,a);else throw new g.FileOperationError((0,p.localize)(23,null,this.resourceForError(r)),1);if(!!!n?.recursive){const I=await this.resolve(r);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,p.localize)(24,null,this.resourceForError(r)))}return s}async del(r,n){const s=await this.doValidateDelete(r,n);let i=n;if((0,g.hasFileAtomicDeleteCapability)(s)&&!i?.atomic){const I=s.enforceAtomicDelete?.(r);I&&(i={...n,atomic:I})}const o=!!i?.useTrash,a=!!i?.recursive,y=i?.atomic??!1;await s.delete(r,{recursive:a,useTrash:o,atomic:y}),this._onDidRunOperation.fire(new g.FileOperationEvent(r,1))}async cloneFile(r,n){const s=await this.withProvider(r),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);if(!(s===i&&this.getExtUri(s).providerExtUri.isEqual(r,n)))return s===i&&(0,g.hasFileCloneCapability)(s)?s.cloneFile(r,n):(await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(n)),s===i&&(0,g.hasFileFolderCopyCapability)(s)?this.writeQueue.queueFor(r,()=>s.copy(r,n,{overwrite:!0}),this.getExtUri(s).providerExtUri):this.writeQueue.queueFor(r,()=>this.doCopyFile(s,r,i,n),this.getExtUri(s).providerExtUri))}static{this.WATCHER_CORRELATION_IDS=0}createWatcher(r,n){return this.watch(r,{...n,correlationId:f.WATCHER_CORRELATION_IDS++})}watch(r,n={recursive:!1,excludes:[]}){const s=new d.DisposableStore;let i=!1,o=()=>{i=!0};s.add((0,d.toDisposable)(()=>o())),(async()=>{try{const y=await this.doWatch(r,n);i?(0,d.dispose)(y):o=()=>(0,d.dispose)(y)}catch(y){this.logService.error(y)}})();const a=n.correlationId;if(typeof a=="number"){const y=s.add(new k.Emitter);return s.add(this.internalOnDidFilesChange.event(w=>{w.correlates(a)&&y.fire(w)})),{onDidChange:y.event,dispose:()=>s.dispose()}}return s}async doWatch(r,n){const s=await this.withProvider(r),i=(0,R.hash)([this.getExtUri(s).providerExtUri.getComparisonKey(r),n]);let o=this.activeWatchers.get(i);return o||(o={count:0,disposable:s.watch(r,n)},this.activeWatchers.set(i,o)),o.count+=1,(0,d.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,d.dispose)(o.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,r]of this.activeWatchers)(0,d.dispose)(r.disposable);this.activeWatchers.clear()}async doWriteBuffered(r,n,s,i){return this.writeQueue.queueFor(n,async()=>{const o=await r.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,c.isReadableStream)(i)||(0,c.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(r,o,i):await this.doWriteReadableBufferedQueued(r,o,i)}catch(a){throw(0,g.ensureFileSystemProviderError)(a)}finally{await r.close(o)}},this.getExtUri(r).providerExtUri)}async doWriteStreamBufferedQueued(r,n,s){let i=0,o;if((0,c.isReadableBufferedStream)(s)){if(s.buffer.length>0){const a=A.VSBuffer.concat(s.buffer);await this.doWriteBuffer(r,n,a,a.byteLength,i,0),i+=a.byteLength}if(s.ended)return;o=s.stream}else o=s;return new Promise((a,y)=>{(0,c.listenStream)(o,{onData:async I=>{o.pause();try{await this.doWriteBuffer(r,n,I,I.byteLength,i,0)}catch(w){return y(w)}i+=I.byteLength,setTimeout(()=>o.resume())},onError:I=>y(I),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(r,n,s){let i=0,o;for(;(o=s.read())!==null;)await this.doWriteBuffer(r,n,o,o.byteLength,i,0),i+=o.byteLength}async doWriteBuffer(r,n,s,i,o,a){let y=0;for(;y<i;){const I=await r.write(n,o+y,s.buffer,a+y,i-y);y+=I}}async doWriteUnbuffered(r,n,s,i){return this.writeQueue.queueFor(n,()=>this.doWriteUnbufferedQueued(r,n,s,i),this.getExtUri(r).providerExtUri)}async doWriteUnbufferedQueued(r,n,s,i){let o;i instanceof A.VSBuffer?o=i:(0,c.isReadableStream)(i)?o=await(0,A.streamToBuffer)(i):(0,c.isReadableBufferedStream)(i)?o=await(0,A.bufferedStreamToBuffer)(i):o=(0,A.readableToBuffer)(i),await r.writeFile(n,o.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async doPipeBuffered(r,n,s,i){return this.writeQueue.queueFor(i,()=>this.doPipeBufferedQueued(r,n,s,i),this.getExtUri(s).providerExtUri)}async doPipeBufferedQueued(r,n,s,i){let o,a;try{o=await r.open(n,{create:!1}),a=await s.open(i,{create:!0,unlock:!1});const y=A.VSBuffer.alloc(this.BUFFER_SIZE);let I=0,w=0,b=0;do b=await r.read(o,I,y.buffer,w,y.byteLength-w),await this.doWriteBuffer(s,a,y,b,I,w),I+=b,w+=b,w===y.byteLength&&(w=0);while(b>0)}catch(y){throw(0,g.ensureFileSystemProviderError)(y)}finally{await U.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async doPipeUnbuffered(r,n,s,i){return this.writeQueue.queueFor(i,()=>this.doPipeUnbufferedQueued(r,n,s,i),this.getExtUri(s).providerExtUri)}async doPipeUnbufferedQueued(r,n,s,i){return s.writeFile(i,await r.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async doPipeUnbufferedToBuffered(r,n,s,i){return this.writeQueue.queueFor(i,()=>this.doPipeUnbufferedToBufferedQueued(r,n,s,i),this.getExtUri(s).providerExtUri)}async doPipeUnbufferedToBufferedQueued(r,n,s,i){const o=await s.open(i,{create:!0,unlock:!1});try{const a=await r.readFile(n);await this.doWriteBuffer(s,o,A.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,g.ensureFileSystemProviderError)(a)}finally{await s.close(o)}}async doPipeBufferedToUnbuffered(r,n,s,i){const o=await(0,A.streamToBuffer)(this.readFileBuffered(r,n,O.CancellationToken.None));await this.doWriteUnbuffered(s,i,void 0,o)}throwIfFileSystemIsReadonly(r,n){if(r.capabilities&2048)throw new g.FileOperationError((0,p.localize)(25,null,this.resourceForError(n)),6);return r}throwIfFileIsReadonly(r,n){if((n.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,p.localize)(26,null,this.resourceForError(r)),6)}resourceForError(r){return r.scheme===E.Schemas.file?r.fsPath:r.toString(!0)}};e.FileService=S,e.FileService=S=f=Ce([K(0,h.ILogService)],S)}),define(ae[207],ce([0,1,41,277,6,34,15,3,40,2,14,5,20,50,31,166,12,97,205,38,201,200]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g,u,h,m,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,U.gracefulify)(_)}catch(r){console.error(`Error enabling graceful-fs: ${(0,m.toErrorMessage)(r)}`)}})();class t extends h.AbstractDiskFileSystemProvider{static{this.TRACE_LOG_RESOURCE_LOCKS=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new O.ResourceMap(i=>v.extUriBiasedIgnorePathCase.getComparisonKey(i)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=253982,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:s,symbolicLink:i}=await c.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(s,i),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:g.FilePermission.Locked}}catch(s){throw this.toFileSystemProviderError(s)}}async statIgnoreError(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await c.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),i=[];return await Promise.all(s.map(async o=>{try{let a;o.isSymbolicLink()?a=(await this.stat((0,v.joinPath)(n,o.name))).type:a=this.toType(o),i.push([o.name,a])}catch(a){this.logService.trace(a)}})),i}catch(s){throw this.toFileSystemProviderError(s)}}toType(n,s){let i;return s?.dangling?i=g.FileType.Unknown:n.isFile()?i=g.FileType.File:n.isDirectory()?i=g.FileType.Directory:i=g.FileType.Unknown,s&&(i|=g.FileType.SymbolicLink),i}async createResourceLock(n){const s=this.toFilePath(n);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let i;for(;i=this.resourceLocks.get(n);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await i.wait();const o=new A.Barrier;return this.resourceLocks.set(n,o),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,d.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.resourceLocks.get(n)===o&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.resourceLocks.delete(n)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),o.open()})}async readFile(n,s){let i;try{s?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),i=await this.createResourceLock(n));const o=this.toFilePath(n);return await c.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{i?.dispose()}}traceLock(n){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(n)}readFileStream(n,s,i){const o=(0,l.newWriteableStream)(a=>k.VSBuffer.concat(a.map(y=>k.VSBuffer.wrap(y))).buffer);return(0,u.readFileIntoStream)(this,n,o,a=>a.buffer,{...s,bufferSize:256*1024},i),o}async writeFile(n,s,i){return i?.atomic!==!1&&i?.atomic?.postfix&&await this.canWriteFileAtomic(n)?this.doWriteFileAtomic(n,(0,v.joinPath)((0,v.dirname)(n),`${(0,v.basename)(n)}${i.atomic.postfix}`),s,i):this.doWriteFile(n,s,i)}async canWriteFileAtomic(n){try{const s=this.toFilePath(n),{symbolicLink:i}=await c.SymlinkSupport.stat(s);if(i)return!1}catch{}return!0}async doWriteFileAtomic(n,s,i,o){const a=new d.DisposableStore;try{a.add(await this.createResourceLock(n)),a.add(await this.createResourceLock(s)),await this.doWriteFile(s,i,o,!0);try{await this.rename(s,n,{overwrite:!0})}catch(y){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw y}}finally{a.dispose()}}async doWriteFile(n,s,i,o){let a;try{const y=this.toFilePath(n);if(!i.create||!i.overwrite){if(await c.Promises.exists(y)){if(!i.overwrite)throw(0,g.createFileSystemProviderError)((0,p.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,g.createFileSystemProviderError)((0,p.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:i.unlock},o),await this.write(a,0,s,0,s.byteLength)}catch(y){throw await this.toFileSystemProviderWriteError(n,y)}finally{typeof a=="number"&&await this.close(a)}}static{this.canFlush=!0}static configureFlushOnWrite(n){t.canFlush=n}async open(n,s,i){const o=this.toFilePath(n);let a;(0,g.isFileOpenForWriteOptions)(s)&&!i&&(a=await this.createResourceLock(n));let y;try{if((0,g.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:w}=await c.SymlinkSupport.stat(o);w.mode&128||await c.Promises.chmod(o,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.logService.trace(w)}let I;if((0,g.isFileOpenForWriteOptions)(s)){if(E.isWindows)try{await c.Promises.truncate(o,0),I="r+"}catch(w){w.code!=="ENOENT"&&this.logService.trace(w)}I||(I="w")}else I="r";y=await c.Promises.open(o,I)}catch(I){throw a?.dispose(),(0,g.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(n,I):this.toFileSystemProviderError(I)}if(this.mapHandleToPos.set(y,0),(0,g.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(y,n),a){const I=this.mapHandleToLock.get(y);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${y} (${o})`),this.mapHandleToLock.set(y,a),I&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${y} (${o})`),I.dispose())}return y}async close(n){const s=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&t.canFlush)try{await c.Promises.fdatasync(n)}catch(i){t.configureFlushOnWrite(!1),this.logService.error(i)}return await c.Promises.close(n)}catch(i){throw this.toFileSystemProviderError(i)}finally{s&&(this.mapHandleToLock.get(n)===s&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,i,o,a){const y=this.normalizePos(n,s);let I=null;try{I=(await c.Promises.read(n,i,o,a,y)).bytesRead}catch(w){throw this.toFileSystemProviderError(w)}finally{this.updatePos(n,y,I)}return I}normalizePos(n,s){return s===this.mapHandleToPos.get(n)?null:s}updatePos(n,s,i){const o=this.mapHandleToPos.get(n);typeof o=="number"&&(typeof s=="number"||(typeof i=="number"?this.mapHandleToPos.set(n,o+i):this.mapHandleToPos.delete(n)))}async write(n,s,i,o,a){return(0,A.retry)(()=>this.doWrite(n,s,i,o,a),100,3)}async doWrite(n,s,i,o,a){const y=this.normalizePos(n,s);let I=null;try{I=(await c.Promises.write(n,i,o,a,y)).bytesWritten}catch(w){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),w)}finally{this.updatePos(n,y,I)}return I}async mkdir(n){try{await c.Promises.mkdir(this.toFilePath(n))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(n,s){try{const i=this.toFilePath(n);if(s.recursive){let o;s?.atomic!==!1&&s.atomic.postfix&&(o=(0,C.join)((0,C.dirname)(i),`${(0,C.basename)(i)}${s.atomic.postfix}`)),await c.Promises.rm(i,c.RimRafMode.MOVE,o)}else try{await c.Promises.unlink(i)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let a=!1;try{const{stat:y,symbolicLink:I}=await c.SymlinkSupport.stat(i);a=y.isDirectory()&&!I}catch{}if(a)await c.Promises.rmdir(i);else throw o}else throw o}}catch(i){throw this.toFileSystemProviderError(i)}}async rename(n,s,i){const o=this.toFilePath(n),a=this.toFilePath(s);if(o!==a)try{await this.validateMoveCopy(n,s,"move",i.overwrite),await c.Promises.rename(o,a)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,p.localize)(2,null,(0,C.basename)(o),(0,C.basename)((0,C.dirname)(a)),y.toString()))),this.toFileSystemProviderError(y)}}async copy(n,s,i){const o=this.toFilePath(n),a=this.toFilePath(s);if(o!==a)try{await this.validateMoveCopy(n,s,"copy",i.overwrite),await c.Promises.copy(o,a,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,p.localize)(3,null,(0,C.basename)(o),(0,C.basename)((0,C.dirname)(a)),y.toString()))),this.toFileSystemProviderError(y)}}async validateMoveCopy(n,s,i,o){const a=this.toFilePath(n),y=this.toFilePath(s);let I=!1;if(!!(this.capabilities&1024)||(I=(0,P.isEqual)(a,y,!0)),I){if(i==="copy")throw(0,g.createFileSystemProviderError)((0,p.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const b=await this.statIgnoreError(n);if(!b)throw(0,g.createFileSystemProviderError)((0,p.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const D=await this.statIgnoreError(s);if(D){if(!o)throw(0,g.createFileSystemProviderError)((0,p.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);b.type&g.FileType.File&&D.type&g.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.doCloneFile(n,s,!1)}async doCloneFile(n,s,i){const o=this.toFilePath(n),a=this.toFilePath(s),y=!!(this.capabilities&1024);if((0,P.isEqual)(o,a,!y))return;const I=new d.DisposableStore;try{I.add(await this.createResourceLock(n)),I.add(await this.createResourceLock(s)),i&&await c.Promises.mkdir((0,C.dirname)(a),{recursive:!0}),await c.Promises.copyFile(o,a)}catch(w){if(w.code==="ENOENT"&&!i)return this.doCloneFile(n,s,!0);throw this.toFileSystemProviderError(w)}finally{I.dispose()}}createUniversalWatcher(n,s,i){return new f.UniversalWatcherClient(o=>n(o),o=>s(o),i)}createNonRecursiveWatcher(n,s,i){return new S.NodeJSWatcherClient(o=>n(o),o=>s(o),i)}toFileSystemProviderError(n){if(n instanceof g.FileSystemProviderError)return n;let s=n,i;switch(n.code){case"ENOENT":i=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=g.FileSystemProviderErrorCode.Unknown;break;default:i=g.FileSystemProviderErrorCode.Unknown}return(0,g.createFileSystemProviderError)(s,i)}async toFileSystemProviderWriteError(n,s){let i=this.toFileSystemProviderError(s);if(n&&i.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await c.SymlinkSupport.stat(this.toFilePath(n));o.mode&128||(i=(0,g.createFileSystemProviderError)(s,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return i}}e.DiskFileSystemProvider=t}),define(ae[99],ce([0,1,3,2,4,9]),function(ne,e,_,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,A.createDecorator)("sharedProcessLifecycleService");let k=class extends U.Disposable{constructor(P){super(),this.logService=P,this._onWillShutdown=this._register(new _.Emitter),this.onWillShutdown=this._onWillShutdown.event}fireOnWillShutdown(){this.logService.trace("Lifecycle#onWillShutdown.fire()"),this._onWillShutdown.fire()}};e.SharedProcessLifecycleService=k,e.SharedProcessLifecycleService=k=Ce([K(0,O.ILogService)],k)}),define(ae[208],ce([0,1,8,3,9,2]),function(ne,e,_,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class k extends A.AbstractLoggerService{constructor(E,v,l,c,p){super(v,l,c),this.windowId=E,this.channel=p,this._register(p.listen("onDidChangeLogLevel",E)(g=>{(0,A.isLogLevel)(g)?super.setLogLevel(g):super.setLogLevel(_.URI.revive(g[0]),g[1])})),this._register(p.listen("onDidChangeVisibility",E)(([g,u])=>super.setVisibility(_.URI.revive(g),u))),this._register(p.listen("onDidChangeLoggers",E)(({added:g,removed:u})=>{for(const h of g)super.registerLogger({...h,resource:_.URI.revive(h.resource)});for(const h of u)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new A.AdapterLogger({log:(E,v)=>{this.channel.call("consoleLog",[E,v])}})}registerLogger(E){super.registerLogger(E),this.channel.call("registerLogger",[E,this.windowId])}deregisterLogger(E){super.deregisterLogger(E),this.channel.call("deregisterLogger",[E,this.windowId])}setLogLevel(E,v){super.setLogLevel(E,v),this.channel.call("setLogLevel",[E,v])}setVisibility(E,v){super.setVisibility(E,v),this.channel.call("setVisibility",[this.toResource(E),v])}doCreateLogger(E,v,l){return new R(this.channel,E,v,l,this.windowId)}static setLogLevel(E,v,l){return E.call("setLogLevel",[v,l])}}e.LoggerChannelClient=k;class R extends A.AbstractMessageLogger{constructor(E,v,l,c,p){super(c?.logLevel==="always"),this.channel=E,this.file=v,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(l),this.channel.call("createLogger",[v,c,p]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,v){const l=[[E,v]];this.isLoggerCreated?this.doLog(l):this.buffer.push(...l)}doLog(E){this.channel.call("log",[this.file,E])}}class P{constructor(E,v){this.loggerService=E,this.getUriTransformer=v}listen(E,v){const l=this.getUriTransformer(E);switch(v){case"onDidChangeLoggers":return U.Event.map(this.loggerService.onDidChangeLoggers,c=>({added:[...c.added].map(p=>this.transformLogger(p,l)),removed:[...c.removed].map(p=>this.transformLogger(p,l))}));case"onDidChangeVisibility":return U.Event.map(this.loggerService.onDidChangeVisibility,c=>[l.transformOutgoingURI(c[0]),c[1]]);case"onDidChangeLogLevel":return U.Event.map(this.loggerService.onDidChangeLogLevel,c=>(0,A.isLogLevel)(c)?c:[l.transformOutgoingURI(c[0]),c[1]])}throw new Error(`Event not found: ${v}`)}async call(E,v,l){const c=this.getUriTransformer(E);switch(v){case"setLogLevel":return(0,A.isLogLevel)(l[0])?this.loggerService.setLogLevel(l[0]):this.loggerService.setLogLevel(_.URI.revive(c.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(p=>this.transformLogger(p,c)))}throw new Error(`Call not found: ${v}`)}transformLogger(E,v){return{...E,resource:v.transformOutgoingURI(E.resource)}}}e.LoggerChannel=P;class d extends O.Disposable{constructor(E,v){super(),v.call("setLogLevel",[E.getLogLevel()]),this._register(E.onDidChangeLogLevel(l=>v.call("setLogLevel",[l]))),v.call("getRegisteredLoggers").then(l=>{for(const c of l)E.registerLogger({...c,resource:_.URI.revive(c.resource)})}),this._register(v.listen("onDidChangeVisibility")(([l,c])=>E.setVisibility(_.URI.revive(l),c))),this._register(v.listen("onDidChangeLoggers")(({added:l,removed:c})=>{for(const p of l)E.registerLogger({...p,resource:_.URI.revive(p.resource)});for(const p of c)E.deregisterLogger(p.resource)}))}}e.RemoteLoggerChannelClient=d}),define(ae[209],ce([0,1,2,9]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class A extends _.Disposable{constructor(k,R=[]){super(),this.logger=new U.MultiplexLogger([k,...R]),this._register(k.onDidChangeLogLevel(P=>this.setLevel(P)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(k){this.logger.setLevel(k)}getLevel(){return this.logger.getLevel()}trace(k,...R){this.logger.trace(k,...R)}debug(k,...R){this.logger.debug(k,...R)}info(k,...R){this.logger.info(k,...R)}warn(k,...R){this.logger.warn(k,...R)}error(k,...R){this.logger.error(k,...R)}flush(){this.logger.flush()}}e.LogService=A}),define(ae[57],ce([0,1,4]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,_.createDecorator)("nativeHostService")}),define(ae[210],ce([0,1,42,56]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostService=void 0;let A=class{constructor(k,R){return this.windowId=k,_.ProxyChannel.toService(R.getChannel("nativeHost"),{context:k,properties:(()=>{const P=new Map;return P.set("windowId",k),P})()})}};e.NativeHostService=A,e.NativeHostService=A=Ce([K(1,U.IMainProcessService)],A)}),define(ae[58],ce([0,1,3,61,2,4]),function(ne,e,_,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,O.createDecorator)("policy");class k extends A.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new _.Emitter),this.onDidChange=this._onDidChange.event}async updatePolicyDefinitions(d){const C=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...d,...this.policyDefinitions},C!==Object.keys(this.policyDefinitions).length&&await this._updatePolicyDefinitions(d),U.Iterable.reduce(this.policies.entries(),(E,[v,l])=>({...E,[v]:l}),{})}getPolicyValue(d){return this.policies.get(d)}serialize(){return U.Iterable.reduce(Object.entries(this.policyDefinitions),(d,[C,E])=>({...d,[C]:{definition:E,value:this.policies.get(C)}}),{})}}e.AbstractPolicyService=k;class R{constructor(){this.onDidChange=_.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=R}),define(ae[211],ce([0,1,3,2,58]),function(ne,e,_,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class O{constructor(P){this.service=P,this.disposables=new U.DisposableStore}listen(P,d){switch(d){case"onDidChange":return _.Event.map(this.service.onDidChange,C=>C.reduce((E,v)=>({...E,[v]:this.service.getPolicyValue(v)??null}),{}),this.disposables)}throw new Error(`Event not found: ${d}`)}call(P,d,C){switch(d){case"updatePolicyDefinitions":return this.service.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${d}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=O;class k extends A.AbstractPolicyService{constructor(P,d){super(),this.channel=d;for(const C in P){const{definition:E,value:v}=P[C];this.policyDefinitions[C]=E,v!==void 0&&this.policies.set(C,v)}this.channel.listen("onDidChange")(C=>{for(const E in C){const v=C[E];v===null?this.policies.delete(E):this.policies.set(E,v)}this._onDidChange.fire(Object.keys(C))})}async _updatePolicyDefinitions(P){const d=await this.channel.call("updatePolicyDefinitions",P);for(const C in d)this.policies.set(C,d[C])}}e.PolicyChannelClient=k}),define(ae[100],ce([0,1,36]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let U;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.context<"u"){const O=A.context.configuration();if(O)U=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){U=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:O,searchUrl:k,itemUrl:R,controlUrl:P}=U.extensionsGallery||{};Object.assign(U,{extensionsGallery:{serviceUrl:_.env.VSCODE_GALLERY_SERVICE_URL||O,searchUrl:_.env.VSCODE_GALLERY_SEARCH_URL||k,itemUrl:_.env.VSCODE_GALLERY_ITEM_URL||R,controlUrl:_.env.VSCODE_GALLERY_CONTROL_URL||P}});try{const d=(...E)=>E.reduce((v,l)=>(Object.keys(l).forEach(c=>{Array.isArray(v[c])&&Array.isArray(l[c])?v[c]=l[c]:typeof v[c]=="object"&&typeof l[c]=="object"?v[c]=d(v[c],l[c]):v[c]=l[c]}),v),{}),C=globalThis._VSCODE_USER_PRODUCT_JSON||{};U=d(U,C)}catch{}if(_.env.VSCODE_DEV&&Object.assign(U,{nameShort:`${U.nameShort} Dev`,nameLong:`${U.nameLong} Dev`,dataFolderName:`${U.dataFolderName}-dev`,serverDataFolderName:U.serverDataFolderName?`${U.serverDataFolderName}-dev`:void 0}),!U.version){const d=globalThis._VSCODE_PACKAGE_JSON;Object.assign(U,{version:d.version,release:d.release})}}else U={},Object.keys(U).length===0&&Object.assign(U,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=U}),define(ae[24],ce([0,1,4]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,_.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ae[212],ce([0,1,6,7,2,14,31,9,24]),function(ne,e,_,U,A,O,k,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let d=class extends A.Disposable{constructor(E,v,l){super(),this.productService=v,this.logService=l,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this._register(new _.RunOnceScheduler(()=>{this.cleanUpCodeCaches(E)},3e4)).schedule()}async cleanUpCodeCaches(E){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const v=Date.now(),l=(0,O.dirname)(E),c=(0,O.basename)(E),p=await k.Promises.readdir(l);await Promise.all(p.map(async g=>{if(g===c)return;const u=(0,O.join)(l,g),h=await k.Promises.stat(u);if(h.isDirectory()&&v-h.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${g}.`),k.Promises.rm(u)}))}catch(v){(0,U.onUnexpectedError)(v)}}};e.CodeCacheCleaner=d,e.CodeCacheCleaner=d=Ce([K(1,P.IProductService),K(2,R.ILogService)],d)}),define(ae[213],ce([0,1,6,7,2,14,31,16,9,24]),function(ne,e,_,U,A,O,k,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let C=class extends A.Disposable{constructor(v,l,c){super(),this.environmentService=v,this.logService=l,this.productService=c,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new _.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},4e4)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const v=Object.create(null),l=JSON.parse(await k.Promises.readFile((0,O.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const h of Object.keys(l)){const m=l[h];v[`${m.hash}.${h}`]=!0}const c=(0,O.join)(this.environmentService.userDataPath,"clp");if(!await k.Promises.exists(c))return;const g=await k.Promises.readdir(c);for(const h of g){if(v[h]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${h}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${h}`),await k.Promises.rm((0,O.join)(c,h))}const u=Date.now();for(const h of Object.keys(v)){const m=(0,O.join)(c,h),f=await k.Promises.readdir(m);for(const S of f){if(S==="tcf.json")continue;const t=(0,O.join)(m,S),r=await k.Promises.stat(t);r.isDirectory()&&u-r.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,O.join)(h,S)}`),await k.Promises.rm(t))}}}catch(v){(0,U.onUnexpectedError)(v)}}};e.LanguagePackCachedDataCleaner=C,e.LanguagePackCachedDataCleaner=C=Ce([K(0,R.INativeEnvironmentService),K(1,P.ILogService),K(2,d.IProductService)],C)}),define(ae[214],ce([0,1,14,4]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,U.createDecorator)("IV8InspectProfilingService");var A;(function(O){function k(P){return!!(P.samples&&P.timeDeltas)}O.isValidProfile=k;function R(P,d="noAbsolutePaths"){for(const C of P.nodes)C.callFrame&&C.callFrame.url&&((0,_.isAbsolute)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,_.join)(d,(0,_.basename)(C.callFrame.url)));return P}O.rewriteAbsolutePaths=R})(A||(e.Utils=A={}))}),define(ae[215],ce([0,1,32]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class U{constructor(){this._sessions=new Map}async startProfiling(O){const R=await(await new Promise((d,C)=>{ne(["v8-inspect-profiler"],d,C)})).startProfiling({host:O.host,port:O.port,checkForPaused:!0}),P=(0,_.generateUuid)();return this._sessions.set(P,R),P}async stopProfiling(O){const k=this._sessions.get(O);if(!k)throw new Error(`UNKNOWN session '${O}'`);const R=await k.stop();return this._sessions.delete(O),R.profile}}e.InspectProfilingService=U}),define(ae[43],ce([0,1,127,13]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(k,R){_.ok(U.isString(k)),_.ok(U.isObject(R)),_.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,R)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new A}),define(ae[101],ce([0,1,3,43]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class O{constructor(){this._onDidChangeSchema=new _.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(P,d){this.schemasById[A(P)]=d,this._onDidChangeSchema.fire(P)}notifySchemaChanged(P){this._onDidChangeSchema.fire(P)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new O;U.Registry.add(e.Extensions.JSONContribution,k)}),define(ae[47],ce([0,1,17,3,13,153,21,101,43]),function(ne,e,_,U,A,O,k,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0,e.overrideIdentifiersFromKey=p,e.keyFromOverrideIdentifiers=g,e.getDefaultValue=u,e.validateProperty=m,e.getScopes=f;var d;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(d||(e.EditPresentationTypes=d={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=P.Registry.as(R.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new U.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new U.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const n=new Set;this.doRegisterConfigurations(t,r,n),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(t){const r=new Set;this.doDeregisterConfigurations(t,r),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:t,remove:r}){const n=new Set;this.doDeregisterConfigurations(r,n),this.doRegisterConfigurations(t,!1,n),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}registerDefaultConfigurations(t){const r=new Set;this.doRegisterDefaultConfigurations(t,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}doRegisterDefaultConfigurations(t,r){const n=[];for(const{overrides:s,source:i}of t)for(const o in s)if(r.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const a=this.configurationDefaultsOverrides.get(o),y=a?.valuesSources??new Map;if(i)for(const D of Object.keys(s[o]))y.set(D,i);const I={...a?.value||{},...s[o]};this.configurationDefaultsOverrides.set(o,{source:i,value:I,valuesSources:y});const w=(0,k.getLanguageTagSettingPlainKey)(o),b={type:"object",default:I,description:O.localize(1,null,w),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:I,source:A.isString(i)?void 0:i,defaultValueSource:i};n.push(...p(o)),this.configurationProperties[o]=b,this.defaultLanguageConfigurationOverridesNode.properties[o]=b}else{this.configurationDefaultsOverrides.set(o,{value:s[o],source:i});const a=this.configurationProperties[o];a&&(this.updatePropertyDefaultValue(o,a),this.updateSchema(o,a))}this.doRegisterOverrideIdentifiers(n)}deregisterDefaultConfigurations(t){const r=new Set;this.doDeregisterDefaultConfigurations(t,r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}doDeregisterDefaultConfigurations(t,r){for(const{overrides:n,source:s}of t)for(const i in n){const o=this.configurationDefaultsOverrides.get(i),a=A.isString(s)?s:s?.id,y=A.isString(o?.source)?o?.source:o?.source?.id;if(a===y)if(r.add(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const I=this.configurationProperties[i];I&&(this.updatePropertyDefaultValue(i,I),this.updateSchema(i,I))}}this.updateOverridePropertyPatternKey()}deltaConfiguration(t){let r=!1;const n=new Set;t.removedDefaults&&(this.doDeregisterDefaultConfigurations(t.removedDefaults,n),r=!0),t.addedDefaults&&(this.doRegisterDefaultConfigurations(t.addedDefaults,n),r=!0),t.removedConfigurations&&this.doDeregisterConfigurations(t.removedConfigurations,n),t.addedConfigurations&&this.doRegisterConfigurations(t.addedConfigurations,!1,n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){this.doRegisterOverrideIdentifiers(t),this._onDidSchemaChange.fire()}doRegisterOverrideIdentifiers(t){for(const r of t)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,r,n){t.forEach(s=>{this.validateAndRegisterProperties(s,r,s.extensionInfo,s.restrictedProperties,void 0,n),this.configurationContributors.push(s),this.registerJSONConfiguration(s)})}doDeregisterConfigurations(t,r){const n=s=>{if(s.properties)for(const i in s.properties){r.add(i);const o=this.configurationProperties[i];o?.policy?.name&&this.policyConfigurations.delete(o.policy.name),delete this.configurationProperties[i],this.removeFromSchema(i,s.properties[i])}s.allOf?.forEach(i=>n(i))};for(const s of t){n(s);const i=this.configurationContributors.indexOf(s);i!==-1&&this.configurationContributors.splice(i,1)}}validateAndRegisterProperties(t,r=!0,n,s,i=3,o){i=A.isUndefinedOrNull(t.scope)?i:t.scope;const a=t.properties;if(a)for(const I in a){const w=a[I];if(r&&m(I,w)){delete a[I];continue}if(w.source=n,w.defaultDefaultValue=a[I].default,this.updatePropertyDefaultValue(I,w),e.OVERRIDE_PROPERTY_REGEX.test(I)?w.scope=void 0:(w.scope=A.isUndefinedOrNull(w.scope)?i:w.scope,w.restricted=A.isUndefinedOrNull(w.restricted)?!!s?.includes(I):w.restricted),a[I].hasOwnProperty("included")&&!a[I].included){this.excludedConfigurationProperties[I]=a[I],delete a[I];continue}else this.configurationProperties[I]=a[I],a[I].policy?.name&&this.policyConfigurations.set(a[I].policy.name,I);!a[I].deprecationMessage&&a[I].markdownDeprecationMessage&&(a[I].deprecationMessage=a[I].markdownDeprecationMessage),o.add(I)}const y=t.allOf;if(y)for(const I of y)this.validateAndRegisterProperties(I,r,n,s,i,o)}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const r=n=>{const s=n.properties;if(s)for(const o in s)this.updateSchema(o,s[o]);n.allOf?.forEach(r)};r(t)}updateSchema(t,r){switch(e.allSettings.properties[t]=r,r.scope){case 1:e.applicationSettings.properties[t]=r;break;case 2:e.machineSettings.properties[t]=r;break;case 6:e.machineOverridableSettings.properties[t]=r;break;case 3:e.windowSettings.properties[t]=r;break;case 4:e.resourceSettings.properties[t]=r;break;case 5:e.resourceSettings.properties[t]=r,this.resourceLanguageSettingsSchema.properties[t]=r;break}}removeFromSchema(t,r){switch(delete e.allSettings.properties[t],r.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const r=`[${t}]`,n={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,n),e.allSettings.properties[r]=n,e.applicationSettings.properties[r]=n,e.machineSettings.properties[r]=n,e.machineOverridableSettings.properties[r]=n,e.windowSettings.properties[r]=n,e.resourceSettings.properties[r]=n}}registerOverridePropertyPatternKey(){const t={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,r){const n=this.configurationDefaultsOverrides.get(t);let s=n?.value,i=n?.source;A.isUndefined(s)&&(s=r.defaultDefaultValue,i=void 0),A.isUndefined(s)&&(s=u(r.type)),r.default=s,r.defaultValueSource=i}}const l="\\[([^\\]]+)\\]",c=new RegExp(l,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${l})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(S){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(S)){let r=c.exec(S);for(;r?.length;){const n=r[1].trim();n&&t.push(n),r=c.exec(S)}}return(0,_.distinct)(t)}function g(S){return S.reduce((t,r)=>`${t}[${r}]`,"")}function u(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const h=new v;P.Registry.add(e.Extensions.Configuration,h);function m(S,t){return S.trim()?e.OVERRIDE_PROPERTY_REGEX.test(S)?O.localize(7,null,S):h.getConfigurationProperties()[S]!==void 0?O.localize(8,null,S):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?O.localize(9,null,S,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:O.localize(6,null)}function f(){const S=[],t=h.getConfigurationProperties();for(const r of Object.keys(t))S.push([r,t[r].scope]);return S.push(["launch",4]),S.push(["task",4]),S}}),define(ae[76],ce([0,1,17,3,35,2,34,30,13,8,21,47,43]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0,e.mergeChanges=m;function l(r){return Object.isFrozen(r)?r:R.deepFreeze(r)}class c{static createEmptyModel(n){return new c({},[],[],void 0,n)}constructor(n,s,i,o,a){this._contents=n,this._keys=s,this._overrides=i,this.raw=o,this.logService=a,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof c)return s;const i=new p("",this.logService);return i.parseRaw(s),i.configurationModel});this._rawConfiguration=n.reduce((s,i)=>i===s?i:s.merge(i),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this._contents}get overrides(){return this._overrides}get keys(){return this._keys}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,C.getConfigurationValue)(this.contents,n):this.contents}inspect(n,s){const i=this;return{get value(){return l(i.rawConfiguration.getValue(n))},get override(){return s?l(i.rawConfiguration.getOverrideValue(n,s)):void 0},get merged(){return l(s?i.rawConfiguration.override(s).getValue(n):i.rawConfiguration.getValue(n))},get overrides(){const o=[];for(const{contents:a,identifiers:y,keys:I}of i.rawConfiguration.overrides){const w=new c(a,I,[],void 0,i.logService).getValue(n);w!==void 0&&o.push({identifiers:y,value:w})}return o.length?l(o):void 0}}}getOverrideValue(n,s){const i=this.getContentsForOverrideIdentifer(s);return i?n?(0,C.getConfigurationValue)(i,n):i:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const i of this.overrides)i.identifiers.includes(n)&&s.push(...i.keys);return _.distinct(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return _.distinct(n)}override(n){let s=this.overrideConfigurations.get(n);return s||(s=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,s)),s}merge(...n){const s=R.deepClone(this.contents),i=R.deepClone(this.overrides),o=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const y of n)if(a.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.mergeContents(s,y.contents);for(const I of y.overrides){const[w]=i.filter(b=>_.equals(b.identifiers,I.identifiers));w?(this.mergeContents(w.contents,I.contents),w.keys.push(...I.keys),w.keys=_.distinct(w.keys)):i.push(R.deepClone(I))}for(const I of y.keys)o.indexOf(I)===-1&&o.push(I)}return new c(s,o,i,a.every(y=>y instanceof c)?void 0:a,this.logService)}createOverrideConfigurationModel(n){const s=this.getContentsForOverrideIdentifer(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const i={};for(const o of _.distinct([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[o];const y=s[o];y&&(typeof a=="object"&&typeof y=="object"?(a=R.deepClone(a),this.mergeContents(a,y)):a=y),i[o]=a}return new c(i,this.keys,this.overrides,void 0,this.logService)}mergeContents(n,s){for(const i of Object.keys(s)){if(i in n&&P.isObject(n[i])&&P.isObject(s[i])){this.mergeContents(n[i],s[i]);continue}n[i]=R.deepClone(s[i])}}getContentsForOverrideIdentifer(n){let s=null,i=null;const o=a=>{a&&(i?this.mergeContents(i,a):i=R.deepClone(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&o(a.contents);return o(s),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.updateValue(n,s,!0)}setValue(n,s){this.updateValue(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,C.removeFromValueTree)(this.contents,n),E.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(i=>_.equals(i.identifiers,(0,E.overrideIdentifiersFromKey)(n))),1))}updateValue(n,s,i){(0,C.addToValueTree)(this.contents,n,s,o=>this.logService.error(o)),i=i||this.keys.indexOf(n)===-1,i&&this.keys.push(n),E.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,E.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,C.toValuesTree)(this.contents[n],o=>this.logService.error(o))})}}e.ConfigurationModel=c;class p{constructor(n,s){this._name=n,this.logService=s,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||c.createEmptyModel(this.logService)}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,s){if(!P.isUndefinedOrNull(n)){const i=this.doParseContent(n);this.parseRaw(i,s)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,s){this._raw=n;const{contents:i,keys:o,overrides:a,restricted:y,hasExcludedProperties:I}=this.doParseRaw(n,s);this._configurationModel=new c(i,o,a,I?[n]:void 0,this.logService),this._restrictedConfigurations=y||[]}doParseContent(n){let s={},i=null,o=[];const a=[],y=[];function I(b){Array.isArray(o)?o.push(b):i!==null&&(o[i]=b)}const w={onObjectBegin:()=>{const b={};I(b),a.push(o),o=b,i=null},onObjectProperty:b=>{i=b},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const b=[];I(b),a.push(o),o=b,i=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:I,onError:(b,D,L)=>{y.push({error:b,offset:D,length:L})}};if(n)try{A.visit(n,w),s=o[0]||{}}catch(b){this.logService.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return s}doParseRaw(n,s){const i=v.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=this.filter(n,i,!0,s);n=o.raw;const a=(0,C.toValuesTree)(n,w=>this.logService.error(`Conflict in settings file ${this._name}: ${w}`)),y=Object.keys(n),I=this.toOverrides(n,w=>this.logService.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:a,keys:y,overrides:I,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(n,s,i,o){let a=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const y={},I=[];for(const w in n)if(E.OVERRIDE_PROPERTY_REGEX.test(w)&&i){const b=this.filter(n[w],s,!1,o);y[w]=b.raw,a=a||b.hasExcludedProperties,I.push(...b.restricted)}else{const b=s[w],D=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&I.push(w),!o.exclude?.includes(w)&&(o.include?.includes(w)||(D===void 0||o.scopes===void 0||o.scopes.includes(D))&&!(o.skipRestricted&&b?.restricted))?y[w]=n[w]:a=!0}return{raw:y,restricted:I,hasExcludedProperties:a}}toOverrides(n,s){const i=[];for(const o of Object.keys(n))if(E.OVERRIDE_PROPERTY_REGEX.test(o)){const a={};for(const y in n[o])a[y]=n[o][y];i.push({identifiers:(0,E.overrideIdentifiersFromKey)(o),keys:Object.keys(a),contents:(0,C.toValuesTree)(a,s)})}return i}}e.ConfigurationModelParser=p;class g extends O.Disposable{constructor(n,s,i,o,a){super(),this.userSettingsResource=n,this.parseOptions=s,this.fileService=o,this.logService=a,this._onDidChange=this._register(new U.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString(),a),this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(U.Event.any(U.Event.filter(this.fileService.onDidFilesChange,y=>y.contains(this.userSettingsResource)),U.Event.filter(this.fileService.onDidRunOperation,y=>(y.isOperation(0)||y.isOperation(3)||y.isOperation(1)||y.isOperation(4))&&i.isEqual(y.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return c.createEmptyModel(this.logService)}}reparse(n){return n&&(this.parseOptions=n),this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class u{constructor(n,s,i,o,a,y,I,w,b,D,L,N,F){this.key=n,this.overrides=s,this._value=i,this.overrideIdentifiers=o,this.defaultConfiguration=a,this.policyConfiguration=y,this.applicationConfiguration=I,this.userConfiguration=w,this.localUserConfiguration=b,this.remoteUserConfiguration=D,this.workspaceConfiguration=L,this.folderConfigurationModel=N,this.memoryConfigurationModel=F}get value(){return l(this._value)}toInspectValue(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.toInspectValue(this.defaultInspectValue)}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.toInspectValue(this.applicationInspectValue)}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.toInspectValue(this.userInspectValue)}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.toInspectValue(this.userLocalInspectValue)}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.toInspectValue(this.userRemoteInspectValue)}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.toInspectValue(this.workspaceInspectValue)}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.toInspectValue(this.workspaceFolderInspectValue)}get memoryInspectValue(){return this._memoryInspectValue===void 0&&(this._memoryInspectValue=this.memoryConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier)),this._memoryInspectValue}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.toInspectValue(this.memoryInspectValue)}}class h{constructor(n,s,i,o,a,y,I,w,b,D){this._defaultConfiguration=n,this._policyConfiguration=s,this._applicationConfiguration=i,this._localUserConfiguration=o,this._remoteUserConfiguration=a,this._workspaceConfiguration=y,this._folderConfigurations=I,this._memoryConfiguration=w,this._memoryConfigurationByResource=b,this.logService=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(n,s,i){return this.getConsolidatedConfigurationModel(n,s,i).getValue(n)}updateValue(n,s,i={}){let o;i.resource?(o=this._memoryConfigurationByResource.get(i.resource),o||(o=c.createEmptyModel(this.logService),this._memoryConfigurationByResource.set(i.resource,o))):o=this._memoryConfiguration,s===void 0?o.removeValue(n):o.setValue(n,s),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,s,i){const o=this.getConsolidatedConfigurationModel(n,s,i),a=this.getFolderConfigurationModelForResource(s.resource,i),y=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,I=new Set;for(const w of o.overrides)for(const b of w.identifiers)o.getOverrideValue(n,b)!==void 0&&I.add(b);return new u(n,s,o.getValue(n),I.size?[...I]:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this._workspaceConfiguration:void 0,a||void 0,y)}keys(n){const s=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this._workspaceConfiguration.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,s){this._folderConfigurations.set(n,s),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const i=[];if(!s){const{added:o,updated:a,removed:y}=S(this._defaultConfiguration,n);s=[...o,...a,...y]}for(const o of s)for(const a of(0,E.overrideIdentifiersFromKey)(o)){const y=this._defaultConfiguration.getKeysForOverrideIdentifier(a),I=n.getKeysForOverrideIdentifier(a),w=[...I.filter(b=>y.indexOf(b)===-1),...y.filter(b=>I.indexOf(b)===-1),...y.filter(b=>!R.equals(this._defaultConfiguration.override(a).getValue(b),n.override(a).getValue(b)))];i.push([a,w])}return this.updateDefaultConfiguration(n),{keys:s,overrides:i}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:i,removed:o}=S(this._policyConfiguration,n),a=[...s,...i,...o];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=S(this.applicationConfiguration,n),y=[...s,...i,...o];return y.length&&this.updateApplicationConfiguration(n),{keys:y,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=S(this.localUserConfiguration,n),y=[...s,...i,...o];return y.length&&this.updateLocalUserConfiguration(n),{keys:y,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=S(this.remoteUserConfiguration,n),y=[...s,...i,...o];return y.length&&this.updateRemoteUserConfiguration(n),{keys:y,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=S(this.workspaceConfiguration,n),y=[...s,...i,...o];return y.length&&this.updateWorkspaceConfiguration(n),{keys:y,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const i=this.folderConfigurations.get(n),{added:o,updated:a,removed:y,overrides:I}=S(i,s),w=[...o,...a,...y];return(w.length||!i)&&this.updateFolderConfiguration(n,s),{keys:w,overrides:I}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:i,updated:o,removed:a,overrides:y}=S(s,void 0);return{keys:[...i,...o,...a],overrides:y}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration)),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,s,i){let o=this.getConsolidatedConfigurationModelForResource(s,i);return s.overrideIdentifier&&(o=o.override(s.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:n},s){let i=this.getWorkspaceConsolidatedConfiguration();if(s&&n){const o=s.getFolder(n);o&&(i=this.getFolderConsolidatedConfiguration(o.uri)||i);const a=this._memoryConfigurationByResource.get(n);a&&(i=i.merge(a))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration)),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let s=this._foldersConsolidatedConfigurations.get(n);if(!s){const i=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(n);o?(s=i.merge(o),this._foldersConsolidatedConfigurations.set(n,s)):s=i}return s}getFolderConfigurationModelForResource(n,s){if(s&&n){const i=s.getFolder(n);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,s)=>{const{contents:i,overrides:o,keys:a}=this._folderConfigurations.get(s);return n.push([s,{contents:i,overrides:o,keys:a}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this._workspaceConfiguration.keys.forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.keys.forEach(i=>n.add(i))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this._workspaceConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getAllOverrideIdentifiers().forEach(i=>n.add(i))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(n).forEach(o=>s.add(o))),[...s.values()]}static parse(n,s){const i=this.parseConfigurationModel(n.defaults,s),o=this.parseConfigurationModel(n.policy,s),a=this.parseConfigurationModel(n.application,s),y=this.parseConfigurationModel(n.user,s),I=this.parseConfigurationModel(n.workspace,s),w=n.folders.reduce((b,D)=>(b.set(d.URI.revive(D[0]),this.parseConfigurationModel(D[1],s)),b),new k.ResourceMap);return new h(i,o,a,y,c.createEmptyModel(s),I,w,c.createEmptyModel(s),new k.ResourceMap,s)}static parseConfigurationModel(n,s){return new c(n.contents,n.keys,n.overrides,void 0,s)}}e.Configuration=h;function m(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const n=new Set,s=new Map;for(const o of r)o.keys.forEach(a=>n.add(a)),o.overrides.forEach(([a,y])=>{const I=(0,k.getOrSet)(s,a,new Set);y.forEach(w=>I.add(w))});const i=[];return s.forEach((o,a)=>i.push([a,[...o.values()]])),{keys:[...n.values()],overrides:i}}class f{constructor(n,s,i,o,a){this.change=n,this.previous=s,this.currentConfiguraiton=i,this.currentWorkspace=o,this.logService=a,this._marker=`
`,this._markerCode1=this._marker.charCodeAt(0),this._markerCode2=46,this.affectedKeys=new Set,this._previousConfiguration=void 0;for(const y of n.keys)this.affectedKeys.add(y);for(const[,y]of n.overrides)for(const I of y)this.affectedKeys.add(I);this._affectsConfigStr=this._marker;for(const y of this.affectedKeys)this._affectsConfigStr+=y+this._marker}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data,this.logService)),this._previousConfiguration}affectsConfiguration(n,s){const i=this._marker+n,o=this._affectsConfigStr.indexOf(i);if(o<0)return!1;const a=o+i.length;if(a>=this._affectsConfigStr.length)return!1;const y=this._affectsConfigStr.charCodeAt(a);if(y!==this._markerCode1&&y!==this._markerCode2)return!1;if(s){const I=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.previous?.workspace):void 0,w=this.currentConfiguraiton.getValue(n,s,this.currentWorkspace);return!R.equals(I,w)}return!0}}e.ConfigurationChangeEvent=f;function S(r,n){const{added:s,removed:i,updated:o}=t(n?.rawConfiguration,r?.rawConfiguration),a=[],y=r?.getAllOverrideIdentifiers()||[],I=n?.getAllOverrideIdentifiers()||[];if(n){const w=I.filter(b=>!y.includes(b));for(const b of w)a.push([b,n.getKeysForOverrideIdentifier(b)])}if(r){const w=y.filter(b=>!I.includes(b));for(const b of w)a.push([b,r.getKeysForOverrideIdentifier(b)])}if(n&&r){for(const w of y)if(I.includes(w)){const b=t({contents:r.getOverrideValue(void 0,w)||{},keys:r.getKeysForOverrideIdentifier(w)},{contents:n.getOverrideValue(void 0,w)||{},keys:n.getKeysForOverrideIdentifier(w)});a.push([w,[...b.added,...b.removed,...b.updated]])}}return{added:s,removed:i,updated:o,overrides:a}}function t(r,n){const s=r?n?r.keys.filter(a=>n.keys.indexOf(a)===-1):[...r.keys]:[],i=n?r?n.keys.filter(a=>r.keys.indexOf(a)===-1):[...n.keys]:[],o=[];if(r&&n){for(const a of n.keys)if(r.keys.indexOf(a)!==-1){const y=(0,C.getConfigurationValue)(n.contents,a),I=(0,C.getConfigurationValue)(r.contents,a);R.equals(y,I)||o.push(a)}}return{added:s,removed:i,updated:o}}}),define(ae[216],ce([0,1,17,3,2,30,13,76,47,9,58,43]),function(ne,e,_,U,A,O,k,R,P,d,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class v extends A.Disposable{get configurationModel(){return this._configurationModel}constructor(g){super(),this.logService=g,this._onDidChangeConfiguration=this._register(new U.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=R.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.resetConfigurationModel(),this._register(E.Registry.as(P.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:u})=>this.onDidUpdateConfiguration(Array.from(g),u))),this.configurationModel}reload(){return this.resetConfigurationModel(),this.configurationModel}onDidUpdateConfiguration(g,u){this.updateConfigurationModel(g,E.Registry.as(P.Extensions.Configuration).getConfigurationProperties()),this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:g})}getConfigurationDefaultOverrides(){return{}}resetConfigurationModel(){this._configurationModel=R.ConfigurationModel.createEmptyModel(this.logService);const g=E.Registry.as(P.Extensions.Configuration).getConfigurationProperties();this.updateConfigurationModel(Object.keys(g),g)}updateConfigurationModel(g,u){const h=this.getConfigurationDefaultOverrides();for(const m of g){const f=h[m],S=u[m];f!==void 0?this._configurationModel.addValue(m,f):S?this._configurationModel.addValue(m,S.default):this._configurationModel.removeValue(m)}}}e.DefaultConfiguration=v;class l{constructor(){this.onDidChangeConfiguration=U.Event.None,this.configurationModel=R.ConfigurationModel.createEmptyModel(new d.NullLogService)}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=l;let c=class extends A.Disposable{get configurationModel(){return this._configurationModel}constructor(g,u,h){super(),this.defaultConfiguration=g,this.policyService=u,this.logService=h,this._onDidChangeConfiguration=this._register(new U.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=R.ConfigurationModel.createEmptyModel(this.logService)}async initialize(){return this.logService.trace("PolicyConfiguration#initialize"),this.update(await this.updatePolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(g=>this.onDidChangePolicies(g))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:g})=>this.update(await this.updatePolicyDefinitions(g),!0))),this._configurationModel}async updatePolicyDefinitions(g){this.logService.trace("PolicyConfiguration#updatePolicyDefinitions",g);const u={},h=[],m=E.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(const f of g){const S=m[f];if(!S){h.push(f);continue}if(S.policy){if(S.type!=="string"&&S.type!=="number"){this.logService.warn(`Policy ${S.policy.name} has unsupported type ${S.type}`);continue}h.push(f),u[S.policy.name]={type:S.type}}}return(0,k.isEmptyObject)(u)||await this.policyService.updatePolicyDefinitions(u),h}onDidChangePolicies(g){this.logService.trace("PolicyConfiguration#onDidChangePolicies",g);const u=E.Registry.as(P.Extensions.Configuration).getPolicyConfigurations(),h=(0,_.coalesce)(g.map(m=>u.get(m)));this.update(h,!0)}update(g,u){this.logService.trace("PolicyConfiguration#update",g);const h=E.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),m=[],f=this._configurationModel.isEmpty();for(const S of g){const t=h[S]?.policy?.name;if(t){const r=this.policyService.getPolicyValue(t);(f?r!==void 0:!(0,O.equals)(this._configurationModel.getValue(S),r))&&m.push([S,r])}else this._configurationModel.getValue(S)!==void 0&&m.push([S,void 0])}if(m.length){this.logService.trace("PolicyConfiguration#changed",m);const S=this._configurationModel;this._configurationModel=R.ConfigurationModel.createEmptyModel(this.logService);for(const t of S.keys)this._configurationModel.setValue(t,S.getValue(t));for(const[t,r]of m)r===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,r);u&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};e.PolicyConfiguration=c,e.PolicyConfiguration=c=Ce([K(1,C.IPolicyService),K(2,d.ILogService)],c)}),define(ae[217],ce([0,1,17,6,15,3,35,62,2,34,30,5,20,21,76,47,216,58]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class h extends P.Disposable{constructor(S,t,r,n){super(),this.settingsResource=S,this.logService=n,this._onDidChangeConfiguration=this._register(new O.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new g.DefaultConfiguration(n)),this.policyConfiguration=r instanceof u.NullPolicyService?new g.NullPolicyConfiguration:this._register(new g.PolicyConfiguration(this.defaultConfiguration,r,n)),this.userConfiguration=this._register(new c.UserSettings(this.settingsResource,{},v.extUriBiasedIgnorePathCase,t,n)),this.configuration=new c.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,c.ConfigurationModel.createEmptyModel(n),c.ConfigurationModel.createEmptyModel(n),c.ConfigurationModel.createEmptyModel(n),c.ConfigurationModel.createEmptyModel(n),new d.ResourceMap,c.ConfigurationModel.createEmptyModel(n),new d.ResourceMap,n),this.configurationEditing=new m(S,t,this),this.reloadConfigurationScheduler=this._register(new U.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:s,properties:i})=>this.onDidDefaultConfigurationChange(s,i))),this._register(this.policyConfiguration.onDidChangeConfiguration(s=>this.onDidPolicyConfigurationChange(s))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,t,r]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new c.Configuration(S,t,c.ConfigurationModel.createEmptyModel(this.logService),r,c.ConfigurationModel.createEmptyModel(this.logService),c.ConfigurationModel.createEmptyModel(this.logService),new d.ResourceMap,c.ConfigurationModel.createEmptyModel(this.logService),new d.ResourceMap,this.logService)}getConfigurationData(){return this.configuration.toData()}getValue(S,t){const r=typeof S=="string"?S:void 0,n=(0,l.isConfigurationOverrides)(S)?S:(0,l.isConfigurationOverrides)(t)?t:{};return this.configuration.getValue(r,n,void 0)}async updateValue(S,t,r,n,s){const i=(0,l.isConfigurationUpdateOverrides)(r)?r:(0,l.isConfigurationOverrides)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,o=i?n:r;if(o!==void 0&&o!==3&&o!==2)throw new Error(`Unable to write ${S} to target ${o}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,_.distinct)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const a=this.inspect(S,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(a.policyValue!==void 0)throw new Error(`Unable to write ${S} because it is configured in system policy.`);if((0,C.equals)(t,a.defaultValue)&&(t=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const I=i.overrideIdentifiers.sort(),w=this.configuration.localUserConfiguration.overrides.find(b=>(0,_.equals)([...b.identifiers].sort(),I));w&&(i.overrideIdentifiers=w.identifiers)}const y=i?.overrideIdentifiers?.length?[(0,p.keyFromOverrideIdentifiers)(i.overrideIdentifiers),S]:[S];await this.configurationEditing.write(y,t),await this.reloadConfiguration()}inspect(S,t={}){return this.configuration.inspect(S,t,void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const t=this.configuration.toData(),r=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(r,t,2)}onDidDefaultConfigurationChange(S,t){const r=this.configuration.toData(),n=this.configuration.compareAndUpdateDefaultConfiguration(S,t);this.trigger(n,r,7)}onDidPolicyConfigurationChange(S){const t=this.configuration.toData(),r=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(r,t,7)}trigger(S,t,r){const n=new c.ConfigurationChangeEvent(S,{data:t},this.configuration,void 0,this.logService);n.source=r,this._onDidChangeConfiguration.fire(n)}}e.ConfigurationService=h;class m{constructor(S,t,r){this.settingsResource=S,this.fileService=t,this.configurationService=r,this.queue=new U.Queue}write(S,t){return this.queue.queue(()=>this.doWriteConfiguration(S,t))}async doWriteConfiguration(S,t){let r;try{r=(await this.fileService.readFile(this.settingsResource)).value.toString()}catch(i){if(i.fileOperationResult===1)r="{}";else throw i}const n=[];if((0,k.parse)(r,n,{allowTrailingComma:!0,allowEmptyContent:!0}),n.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.getEdits(r,S,t);r=(0,R.applyEdits)(r,s),await this.fileService.writeFile(this.settingsResource,A.VSBuffer.fromString(r))}getEdits(S,t,r){const{tabSize:n,insertSpaces:s,eol:i}=this.formattingOptions;if(!t.length){const o=JSON.stringify(r,null,s?" ".repeat(n):"	");return[{content:o,length:o.length,offset:0}]}return(0,R.setProperty)(S,t,r,{tabSize:n,insertSpaces:s,eol:i})}get formattingOptions(){if(!this._formattingOptions){let S=E.OS===3||E.OS===2?`
`:`\r
`;const t=this.configurationService.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(S=t),this._formattingOptions={eol:S,insertSpaces:!!this.configurationService.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.configurationService.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this._formattingOptions}}}),define(ae[218],ce([0,1,15,3,2,68]),function(ne,e,_,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagedSocket=e.socketRawEndHeaderSequence=e.makeRawSocketHeaders=void 0,e.connectManagedSocket=R;const k=(d,C,E)=>{const v=new Uint8Array(16);for(let p=0;p<16;p++)v[p]=Math.round(Math.random()*256);const l=(0,_.encodeBase64)(_.VSBuffer.wrap(v));return[`GET ws://localhost${d}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${l}`].join(`\r
`)+`\r
\r
`};e.makeRawSocketHeaders=k,e.socketRawEndHeaderSequence=_.VSBuffer.fromString(`\r
\r
`);async function R(d,C,E,v,l){d.write(_.VSBuffer.fromString((0,e.makeRawSocketHeaders)(C,E,v)));const c=new A.DisposableStore;try{return await new Promise((p,g)=>{let u;c.add(d.onData(h=>{u?u=_.VSBuffer.concat([u,h],u.byteLength+h.byteLength):u=h;const m=u.indexOf(e.socketRawEndHeaderSequence);if(m===-1)return;p(d),d.pauseData();const f=u.slice(m+e.socketRawEndHeaderSequence.byteLength);f.byteLength&&l.onData.fire(f)})),c.add(d.onClose(h=>g(h??new Error("socket closed")))),c.add(d.onEnd(()=>g(new Error("socket ended"))))})}catch(p){throw d.dispose(),p}finally{c.dispose()}}class P extends A.Disposable{constructor(C,E){super(),this.debugLabel=C,this.pausableDataEmitter=this._register(new U.PauseableEmitter),this.onData=(...v)=>(this.pausableDataEmitter.isPaused&&queueMicrotask(()=>this.pausableDataEmitter.resume()),this.pausableDataEmitter.event(...v)),this.didDisposeEmitter=this._register(new U.Emitter),this.onDidDispose=this.didDisposeEmitter.event,this.ended=!1,this._register(E.onData),this._register(E.onData.event(v=>this.pausableDataEmitter.fire(v))),this.onClose=this._register(E.onClose).event,this.onEnd=this._register(E.onEnd).event}pauseData(){this.pausableDataEmitter.pause()}drain(){return Promise.resolve()}end(){this.ended=!0,this.closeRemote()}traceSocketEvent(C,E){O.SocketDiagnostics.traceSocketEvent(this,this.debugLabel,C,E)}dispose(){this.ended||this.closeRemote(),this.didDisposeEmitter.fire(),super.dispose()}}e.ManagedSocket=P}),define(ae[219],ce([0,1,7,4]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.WebSocketRemoteConnection=e.ManagedRemoteConnection=e.RemoteConnectionType=e.IRemoteAuthorityResolverService=void 0,e.getRemoteAuthorityPrefix=d,e.IRemoteAuthorityResolverService=(0,U.createDecorator)("remoteAuthorityResolverService");var A;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class O{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.ManagedRemoteConnection=O;class k{constructor(E,v){this.host=E,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.WebSocketRemoteConnection=k;var R;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class P extends _.ErrorNoTelemetry{static isNotAvailable(E){return E instanceof P&&E._code===R.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof P&&E._code===R.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof P&&E._code===R.NoResolverFound}static isInvalidAuthority(E){return E instanceof P&&E._code===R.InvalidAuthority}static isHandled(E){return E instanceof P&&E.isHandled}constructor(E,v=R.Unknown,l){super(E),this._message=E,this._code=v,this._detail=l,this.isHandled=v===R.NotAvailable&&l===!0,Object.setPrototypeOf(this,P.prototype)}}e.RemoteAuthorityResolverError=P;function d(C){const E=C.indexOf("+");return E===-1?C:C.substring(0,E)}}),define(ae[220],ce([0,1,6,15,26,7,3,2,23,98,63,32,68,219]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.connectRemoteAgentManagement=y,e.connectRemoteAgentExtensionHost=I,e.connectRemoteAgentTunnel=b;const c=30*1e3;var p;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function g(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(W){const T=new A.CancellationTokenSource;return setTimeout(()=>T.cancel(),W),T.token}function h(W,T){if(W.isCancellationRequested||T.isCancellationRequested)return A.CancellationToken.Cancelled;const M=new A.CancellationTokenSource;return W.onCancellationRequested(()=>M.cancel()),T.onCancellationRequested(()=>M.cancel()),M.token}class m{get didTimeout(){return this._state==="timedout"}constructor(T){this._state="pending",this._disposables=new R.DisposableStore,{promise:this.promise,resolve:this._resolvePromise,reject:this._rejectPromise}=(0,_.promiseWithResolvers)(),T.isCancellationRequested?this._timeout():this._disposables.add(T.onCancellationRequested(()=>this._timeout()))}registerDisposable(T){this._state==="pending"?this._disposables.add(T):T.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const T=new Error("Time limit reached");return T.code="ETIMEDOUT",T.syscall="connect",T}resolve(T){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(T))}reject(T){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(T))}}function f(W,T){const M=new m(T);return M.registerDisposable(W.onControlMessage($=>{const Q=JSON.parse($.toString()),G=q(Q);G?M.reject(G):M.resolve(Q)})),M.promise}function S(W,T,M,$,Q,G,ee,Z){const J=new m(Z),se=C.StopWatch.create(!1);return W.info(`Creating a socket (${ee})...`),d.mark(`code/willCreateSocket/${G}`),T.connect(M,$,Q,ee).then(he=>{J.didTimeout?(d.mark(`code/didCreateSocketError/${G}`),W.info(`Creating a socket (${ee}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(d.mark(`code/didCreateSocketOK/${G}`),W.info(`Creating a socket (${ee}) was successful after ${se.elapsed()} ms.`),J.resolve(he))},he=>{d.mark(`code/didCreateSocketError/${G}`),W.info(`Creating a socket (${ee}) returned an error after ${se.elapsed()} ms.`),W.error(he),J.reject(he)}),J.promise}function t(W,T){const M=new m(T);return W.then($=>{M.didTimeout||M.resolve($)},$=>{M.didTimeout||M.reject($)}),M.promise}async function r(W,T,M,$){const Q=te(W,T);W.logService.trace(`${Q} 1/6. invoking socketFactory.connect().`);let G;try{G=await S(W.logService,W.remoteSocketFactoryService,W.connectTo,P.RemoteAuthorities.getServerRootPath(),`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,g(T),`renderer-${g(T)}-${W.reconnectionToken}`,$)}catch(he){throw W.logService.error(`${Q} socketFactory.connect() failed or timed out. Error:`),W.logService.error(he),he}W.logService.trace(`${Q} 2/6. socketFactory.connect() was successful.`);let ee,Z;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(G,null),ee=W.reconnectionProtocol,Z=!1):(ee=new v.PersistentProtocol({socket:G}),Z=!0),W.logService.trace(`${Q} 3/6. sending AuthRequest control message.`);const J=await t(W.signService.createNewMessage((0,E.generateUuid)()),$),se={type:"auth",auth:W.connectionToken||"00000000000000000000",data:J.data};ee.sendControl(U.VSBuffer.fromString(JSON.stringify(se)));try{const he=await f(ee,h($,u(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(W.logService.trace(`${Q} 4/6. received SignRequest control message.`),!await t(W.signService.validate(J,he.signedData),$)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const de=await t(W.signService.sign(he.data),$),me={type:"connectionType",commit:W.commit,signedData:de,desiredConnectionType:T};return M&&(me.args=M),W.logService.trace(`${Q} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(U.VSBuffer.fromString(JSON.stringify(me))),{protocol:ee,ownsProtocol:Z}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(W.logService.error(`${Q} the handshake timed out. Error:`),W.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${Q} received error control message when negotiating connection. Error:`),W.logService.error(he)),Z&&V(ee),he}}async function n(W,T,M,$){const Q=Date.now(),G=te(W,T),{protocol:ee,ownsProtocol:Z}=await r(W,T,M,$),J=new m($);return J.registerDisposable(ee.onControlMessage(se=>{const he=JSON.parse(se.toString()),ge=q(he);ge?(W.logService.error(`${G} received error control message when negotiating connection. Error:`),W.logService.error(ge),Z&&V(ee),J.reject(ge)):(W.reconnectionProtocol?.endAcceptReconnection(),W.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${j(Q)}!`),J.resolve({protocol:ee,firstMessage:he}))})),J.promise}async function s(W,T){const{protocol:M}=await n(W,1,void 0,T);return{protocol:M}}async function i(W,T,M){const{protocol:$,firstMessage:Q}=await n(W,2,T,M),G=Q&&Q.debugPort;return{protocol:$,debugPort:G}}async function o(W,T,M){const $=Date.now(),Q=te(W,3),{protocol:G}=await r(W,3,T,M);return W.logService.trace(`${Q} 6/6. handshake finished, connection is up and running after ${j($)}!`),G}async function a(W,T,M){const{connectTo:$,connectionToken:Q}=await W.addressProvider.getAddress();return{commit:W.commit,quality:W.quality,connectTo:$,connectionToken:Q,reconnectionToken:T,reconnectionProtocol:M,remoteSocketFactoryService:W.remoteSocketFactoryService,signService:W.signService,logService:W.logService}}async function y(W,T,M){return w(W,async $=>{const{protocol:Q}=await s($,A.CancellationToken.None);return new z(W,T,M,$.reconnectionToken,Q)})}async function I(W,T){return w(W,async M=>{const{protocol:$,debugPort:Q}=await i(M,T,A.CancellationToken.None);return new H(W,T,M.reconnectionToken,$,Q)})}async function w(W,T){for(let $=1;;$++)try{const Q=(0,E.generateUuid)(),G=await a(W,Q,null);return await T(G)}catch(Q){if($<5)W.logService.error(`[remote-connection][attempt ${$}] An error occurred in initial connection! Will retry... Error:`),W.logService.error(Q);else throw W.logService.error(`[remote-connection][attempt ${$}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),W.logService.error(Q),Y.triggerPermanentFailure(0,0,l.RemoteAuthorityResolverError.isHandled(Q)),Q}}async function b(W,T,M){const $=await a(W,(0,E.generateUuid)(),null);return await o($,{host:T,port:M},A.CancellationToken.None)}function D(W){return(0,_.createCancelablePromise)(T=>new Promise((M,$)=>{const Q=setTimeout(M,W*1e3);T.onCancellationRequested(()=>{clearTimeout(Q),M()})}))}var L;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain"})(L||(e.PersistentConnectionEventType=L={}));class N{constructor(T,M){this.reconnectionToken=T,this.millisSinceLastIncomingData=M,this.type=0}}e.ConnectionLostEvent=N;class F{constructor(T,M,$,Q){this.reconnectionToken=T,this.millisSinceLastIncomingData=M,this.durationSeconds=$,this.cancellableTimer=Q,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=F;class x{constructor(T,M,$){this.reconnectionToken=T,this.millisSinceLastIncomingData=M,this.attempt=$,this.type=2}}e.ReconnectionRunningEvent=x;class X{constructor(T,M,$){this.reconnectionToken=T,this.millisSinceLastIncomingData=M,this.attempt=$,this.type=4}}e.ConnectionGainEvent=X;class B{constructor(T,M,$,Q){this.reconnectionToken=T,this.millisSinceLastIncomingData=M,this.attempt=$,this.handled=Q,this.type=3}}e.ReconnectionPermanentFailureEvent=B;class Y extends R.Disposable{static triggerPermanentFailure(T,M,$){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=T,this._permanentFailureAttempt=M,this._permanentFailureHandled=$,this._instances.forEach(Q=>Q._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(T=>T._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(T=>T._pauseSocketWriting())}static{this._permanentFailure=!1}static{this._permanentFailureMillisSinceLastIncomingData=0}static{this._permanentFailureAttempt=0}static{this._permanentFailureHandled=!1}static{this._instances=[]}get _isPermanentFailure(){return this._permanentFailure||Y._permanentFailure}constructor(T,M,$,Q,G){super(),this._connectionType=T,this._options=M,this.reconnectionToken=$,this.protocol=Q,this._reconnectionFailureIsFatal=G,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._isDisposed=!1,this._onDidStateChange.fire(new X(this.reconnectionToken,0,0)),this._register(Q.onSocketClose(ee=>{const Z=ue(this._connectionType,this.reconnectionToken,!0);ee?ee.type===0?(this._options.logService.info(`${Z} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this._options.logService.error(ee.error)):(this._options.logService.info(`${Z} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this._options.logService.error(ee.event)):this._options.logService.info(`${Z} received socket close event.`),this._beginReconnecting()})),this._register(Q.onSocketTimeout(ee=>{const Z=ue(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Z} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),Y._instances.push(this),this._register((0,R.toDisposable)(()=>{const ee=Y._instances.indexOf(this);ee>=0&&Y._instances.splice(ee,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(Y._permanentFailureMillisSinceLastIncomingData,Y._permanentFailureAttempt,Y._permanentFailureHandled)}dispose(){super.dispose(),this._isDisposed=!0}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure||this._isDisposed)return;const T=ue(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${T} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const M=[0,5,5,10,10,10,10,10,30];let $=-1;do{$++;const Q=$<M.length?M[$]:M[M.length-1];try{if(Q>0){const ee=D(Q);this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q,ee)),this._options.logService.info(`${T} waiting for ${Q} seconds before reconnecting...`);try{await ee}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${T} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$+1)),this._options.logService.info(`${T} resolving connection...`);const G=await a(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${T} connecting to ${G.connectTo}...`),await this._reconnect(G,u(c)),this._options.logService.info(`${T} reconnected!`),this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$+1));break}catch(G){if(G.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${T} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(G),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,!1);break}if($>360){this._options.logService.error(`${T} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(G),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,!1);break}if(l.RemoteAuthorityResolverError.isTemporarilyNotAvailable(G)){this._options.logService.info(`${T} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((G.code==="ETIMEDOUT"||G.code==="ENETUNREACH"||G.code==="ECONNREFUSED"||G.code==="ECONNRESET")&&G.syscall==="connect"){this._options.logService.info(`${T} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((0,O.isCancellationError)(G)){this._options.logService.info(`${T} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if(G instanceof l.RemoteAuthorityResolverError){this._options.logService.error(`${T} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(G),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,l.RemoteAuthorityResolverError.isHandled(G));break}this._options.logService.error(`${T} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(G),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,!1);break}}while(!this._isPermanentFailure&&!this._isDisposed)}_onReconnectionPermanentFailure(T,M,$){this._reconnectionFailureIsFatal?Y.triggerPermanentFailure(T,M,$):this._gotoPermanentFailure(T,M,$)}_gotoPermanentFailure(T,M,$){this._onDidStateChange.fire(new B(this.reconnectionToken,T,M,$)),V(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=Y;class z extends Y{constructor(T,M,$,Q,G){super(1,T,Q,G,!0),this.client=this._register(new v.Client(G,{remoteAuthority:M,clientId:$},T.ipcLogger))}async _reconnect(T,M){await s(T,M)}}e.ManagementPersistentConnection=z;class H extends Y{constructor(T,M,$,Q,G){super(2,T,$,Q,!1),this._startArguments=M,this.debugPort=G}async _reconnect(T,M){await i(T,this._startArguments,M)}}e.ExtensionHostPersistentConnection=H;function V(W){try{W.acceptDisconnect();const T=W.getSocket();W.dispose(),T.dispose()}catch(T){(0,O.onUnexpectedError)(T)}}function q(W){if(W&&W.type==="error"){const T=new Error(`Connection error: ${W.reason}`);return T.code="VSCODE_CONNECTION_ERROR",T}return null}function ie(W,T){for(;W.length<T;)W+=" ";return W}function re(W,T){return`[remote-connection][${ie(g(W),13)}][${T.substr(0,5)}\u2026]`}function ue(W,T,M){return`${re(W,T)}[${M?"reconnect":"initial"}]`}function te(W,T){return`${ue(T,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.connectTo}]`}function j(W){return`${Date.now()-W} ms`}}),define(ae[102],ce([0,1,23]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthority=U,e.getRemoteName=A,e.parseAuthorityWithPort=O,e.parseAuthorityWithOptionalPort=k;function U(P){return P.scheme===_.Schemas.vscodeRemote?P.authority:void 0}function A(P){if(!P)return;const d=P.indexOf("+");return d<0?P:P.substr(0,d)}function O(P){const{host:d,port:C}=R(P);if(typeof C>"u")throw new Error(`Invalid remote authority: ${P}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:d,port:C}}function k(P,d){let{host:C,port:E}=R(P);return typeof E>"u"&&(E=d),{host:C,port:E}}function R(P){const d=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(d)return{host:d[1],port:parseInt(d[2],10)};const C=P.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const E=P.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:P,port:void 0}}}),define(ae[48],ce([0,1,27,4,102]),function(ne,e,_,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.getWorkspaceSupportTypeMessage=O,e.isApplicationScopedExtension=E,e.isLanguagePackExtension=v,e.isAuthenticationProviderExtension=l,e.isResolverExtension=c,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function O(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var k;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(k||(e.ExtensionType=k={}));var R;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.LINUX_PPC64LE="linux-ppc64le",p.LINUX_RISCV64="linux-riscv64",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class P{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,u){if(typeof g>"u"||g===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof g=="string"||typeof u=="string"){const h=typeof g=="string"?g:g.value,m=typeof u=="string"?u:u.value;return _.equalsIgnoreCase(h,m)}return g._lower===u._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=P;class d{get size(){return this._set.size}constructor(g){if(this._set=new Set,g)for(const u of g)this.add(u)}add(g){this._set.add(P.toKey(g))}delete(g){return this._set.delete(P.toKey(g))}has(g){return this._set.has(P.toKey(g))}}e.ExtensionIdentifierSet=d;class C{constructor(){this._map=new Map}clear(){this._map.clear()}delete(g){this._map.delete(P.toKey(g))}get(g){return this._map.get(P.toKey(g))}has(g){return this._map.has(P.toKey(g))}set(g,u){this._map.set(P.toKey(g),u)}values(){return this._map.values()}forEach(g){this._map.forEach(g)}[Symbol.iterator](){return this._map[Symbol.iterator]()}}e.ExtensionIdentifierMap=C;function E(p){return v(p)}function v(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}function l(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}function c(p,g){if(g){const u=`onResolveRemoteAuthority:${(0,A.getRemoteName)(g)}`;return!!p.activationEvents?.includes(u)}return!1}e.IBuiltinExtensionsScannerService=(0,U.createDecorator)("IBuiltinExtensionsScannerService")}),define(ae[221],ce([0,1,2,48,12]),function(ne,e,_,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class O extends _.Disposable{constructor(R,P,d,C,E){super(),this.userDataProfilesService=R,this.fileService=P,this.uriIdentityService=d,this.logService=E,this._register(C.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(C.onDidUninstallExtension(v=>this.onDidUnInstallExtension(v)))}onDidInstallExtensions(R){for(const P of R)P.local&&this.invalidate(P.profileLocation)}onDidUnInstallExtension(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const P of this.userDataProfilesService.profiles)this.uriIdentityService.extUri.isEqual(P.extensionsResource,R)&&await this.deleteUserCacheFile(P);else await this.deleteUserCacheFile(this.userDataProfilesService.defaultProfile)}async deleteUserCacheFile(R){try{await this.fileService.del(this.uriIdentityService.extUri.joinPath(R.cacheHome,U.USER_MANIFEST_CACHE_FILE))}catch(P){(0,A.toFileOperationResult)(P)!==1&&this.logService.error(P)}}}e.ExtensionsManifestCache=O}),define(ae[103],ce([0,1,2,4]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteSocketFactoryService=e.IRemoteSocketFactoryService=void 0,e.IRemoteSocketFactoryService=(0,U.createDecorator)("remoteSocketFactoryService");class A{constructor(){this.factories={}}register(k,R){return this.factories[k]??=[],this.factories[k].push(R),(0,_.toDisposable)(()=>{const P=this.factories[k]?.indexOf(R);typeof P=="number"&&P>=0&&this.factories[k]?.splice(P,1)})}getSocketFactory(k){return(this.factories[k.type]||[]).find(P=>P.supports(k))}connect(k,R,P,d){const C=this.getSocketFactory(k);if(!C)throw new Error(`No socket factory found for ${k}`);return C.connect(k,R,P,d)}}e.RemoteSocketFactoryService=A}),define(ae[222],ce([0,1,4]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,_.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ae[104],ce([0,1,4,169]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.INACTIVE_TUNNEL_MODE=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,_.createDecorator)("IRemoteTunnelService"),e.INACTIVE_TUNNEL_MODE={active:!1};var A;(function(O){O.disconnected=k=>({type:"disconnected",onTokenFailed:k}),O.connected=(k,R)=>({type:"connected",info:k,serviceInstallFailed:R}),O.connecting=k=>({type:"connecting",progress:k}),O.uninitialized={type:"uninitialized"}})(A||(e.TunnelStates=A={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,U.localize)(0,null)}),define(ae[59],ce([0,1,15,7,2,171,47,4,9,43]),function(ne,e,_,U,A,O,k,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractRequestService=e.IRequestService=void 0,e.isSuccess=v,e.hasNoContent=l,e.asText=c,e.asTextOrError=p,e.asJson=g,e.updateProxyConfigurationsScope=u,e.IRequestService=(0,R.createDecorator)("requestService");class C{constructor(S){this.original=S}toJSON(){if(!this.headers){const S=Object.create(null);for(const t in this.original)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?S[t]="*****":S[t]=this.original[t];this.headers=S}return this.headers}}class E extends A.Disposable{constructor(S){super(),this.counter=0,this.logger=S.createLogger("network",{name:(0,O.localize)(0,null),when:P.CONTEXT_LOG_LEVEL.isEqualTo((0,P.LogLevelToString)(P.LogLevel.Trace)).serialize()})}async logAndRequest(S,t,r){const n=`${S} #${++this.counter}: ${t.url}`;this.logger.trace(`${n} - begin`,t.type,new C(t.headers??{}));try{const s=await r();return this.logger.trace(`${n} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.logger.error(`${n} - error`,t.type,(0,U.getErrorMessage)(s)),s}}}e.AbstractRequestService=E;function v(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}function l(f){return f.res.statusCode===204}async function c(f){return l(f)?null:(await(0,_.streamToBuffer)(f.stream)).toString()}async function p(f){if(!v(f))throw new Error("Server returned "+f.res.statusCode);return c(f)}async function g(f){if(!v(f))throw new Error("Server returned "+f.res.statusCode);if(l(f))return null;const t=(await(0,_.streamToBuffer)(f.stream)).toString();try{return JSON.parse(t)}catch(r){throw r.message+=`:
`+t,r}}function u(f){m(f)}let h;function m(f){const S=d.Registry.as(k.Extensions.Configuration),t=h;h={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:f,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},S.updateConfigurations({add:[h],remove:t?[t]:[]})}m(1)}),define(ae[223],ce([0,1,26,23,12,59]),function(ne,e,_,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(P,d){this.requestService=P,this.fileService=d}async download(P,d,C=_.CancellationToken.None){if(P.scheme===U.Schemas.file||P.scheme===U.Schemas.vscodeRemote){await this.fileService.copy(P,d);return}const E={type:"GET",url:P.toString(!0)},v=await this.requestService.request(E,C);if(v.res.statusCode===200)await this.fileService.writeFile(d,v.stream);else{const l=await(0,O.asTextOrError)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${l}`)}}};e.DownloadService=k,e.DownloadService=k=Ce([K(0,O.IRequestService),K(1,A.IFileService)],k)}),define(ae[224],ce([0,1,15,26]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class A{constructor(R){this.service=R}listen(R,P){throw new Error("Invalid listen")}call(R,P,d,C=U.CancellationToken.None){switch(P){case"request":return this.service.request(d[0],C).then(async({res:E,stream:v})=>{const l=await(0,_.streamToBuffer)(v);return[{statusCode:E.statusCode,headers:E.headers},l]});case"resolveProxy":return this.service.resolveProxy(d[0]);case"loadCertificates":return this.service.loadCertificates()}throw new Error("Invalid call")}}e.RequestChannel=A;class O{constructor(R){this.channel=R}async request(R,P){const[d,C]=await this.channel.call("request",[R],P);return{res:d,stream:(0,_.bufferToStream)(C)}}async resolveProxy(R){return this.channel.call("resolveProxy",[R])}async loadCertificates(){return this.channel.call("loadCertificates")}}e.RequestChannelClient=O}),define(ae[225],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRawConnection=e.SharedProcessChannelConnection=e.SharedProcessLifecycle=void 0,e.SharedProcessLifecycle={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.SharedProcessChannelConnection={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.SharedProcessRawConnection={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ae[226],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSignService=void 0;class _{constructor(){this.validators=new Map}static{this._nextId=1}async createNewMessage(A){try{const O=await this.getValidator();if(O){const k=String(_._nextId++);return this.validators.set(k,O),{id:k,data:O.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,O){if(!A.id)return!0;const k=this.validators.get(A.id);if(!k)return!1;this.validators.delete(A.id);try{return k.validate(O)==="ok"}catch{return!1}finally{k.dispose?.()}}async sign(A){try{return await this.signValue(A)}catch{}return A}}e.AbstractSignService=_}),define(ae[105],ce([0,1,4]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,_.createDecorator)(e.SIGN_SERVICE_ID)}),define(ae[227],ce([0,1,226]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class U extends _.AbstractSignService{getValidator(){return this.vsda().then(O=>new O.validator)}signValue(O){return this.vsda().then(k=>new k.signer().sign(O))}vsda(){return new Promise((O,k)=>ne(["vsda"],O,k))}}e.SignService=U}),define(ae[77],ce([0,1,3,2]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class A extends U.Disposable{constructor(E,v,l){super(),this.channel=E,this.profile=v,this.workspace=l}async getItems(){const E={profile:this.profile,workspace:this.workspace},v=await this.channel.call("getItems",E);return new Map(v)}updateItems(E){const v={profile:this.profile,workspace:this.workspace};return E.insert&&(v.insert=Array.from(E.insert.entries())),E.delete&&(v.delete=Array.from(E.delete.values())),this.channel.call("updateItems",v)}optimize(){const E={profile:this.profile,workspace:this.workspace};return this.channel.call("optimize",E)}}class O extends A{constructor(E,v){super(E,v,void 0),this._onDidChangeItemsExternal=this._register(new _.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(E=>this.onDidChangeStorage(E)))}onDidChangeStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class k extends O{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=k;class R extends O{constructor(E,v){super(E,v)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=R;class P extends A{constructor(E,v){super(E,void 0,v),this.onDidChangeItemsExternal=_.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=P;class d{constructor(E){this.channel=E}isUsed(E){const v={payload:E,profile:void 0,workspace:void 0};return this.channel.call("isUsed",v)}}e.StorageClient=d}),define(ae[106],ce([0,1,5,36,32]),function(ne,e,_,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=k,e.verifyMicrosoftInternalDomain=R;function O(P){if(_.platform===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}function k(P,d,C,E,v,l,c,p,g){const u=Object.create(null);u["common.machineId"]=l,u["common.sqmId"]=c,u.sessionID=(0,A.generateUuid)()+Date.now(),u.commitHash=E,u.version=v,u["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,_.PlatformToString)(_.platform),u["common.nodePlatform"]=U.platform,u["common.nodeArch"]=C,u["common.product"]=g||"desktop",p&&(u["common.msftInternal"]=p);let h=0;const m=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-m,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),_.isLinuxSnap&&(u["common.snap"]="true");const f=O(d);return f&&(u["common.platformDetail"]=f),u}function R(P){const d=U.env.USERDNSDOMAIN;if(!d)return!1;const C=d.toLowerCase();return P.some(E=>C===E)}}),define(ae[22],ce([0,1,4]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.sqmIdKey=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,_.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,_.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.sqmIdKey="telemetry.sqmId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var U;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(U||(e.TelemetryLevel=U={}));var A;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(ae[228],ce([0,1,37,6,35,23,14,5,8,144,31,150,94,12,24,22]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=void 0,e.collectWorkspaceStats=u,e.getMachineInfo=m,e.collectLaunchConfigs=f;const g=new Map;async function u(t,r){const n=`${t}::${r.join(":")}`,s=g.get(n);if(s)return s;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,a=new Map,y=2e4;function I(b,D,L,N){const F=D.substring(b.length+1);return U.Promises.withAsyncBody(async x=>{let X;try{X=await C.Promises.readdir(D,{withFileTypes:!0})}catch{x();return}if(N.count>=y){N.count+=X.length,N.maxReached=!0,x();return}let B=X.length;if(B===0){x();return}let Y=X;N.count+X.length>y&&(N.maxReached=!0,B=y-N.count,Y=X.slice(0,B)),N.count+=X.length;for(const z of Y)if(z.isDirectory()){if(L.includes(z.name)||await I(b,(0,k.join)(D,z.name),L,N),--B===0){x();return}}else{const H=z.name.lastIndexOf(".");if(H>=0){const V=z.name.substring(H+1);V&&o.set(V,(o.get(V)??0)+1)}for(const V of i)V.relativePathPattern?.test(F)!==!1&&V.filePattern.test(z.name)&&a.set(V.tag,(a.get(V.tag)??0)+1);if(--B===0){x();return}}})}const w=U.Promises.withAsyncBody(async b=>{const D={count:0,maxReached:!1};await I(t,t,r,D);const L=await f(t);b({configFiles:h(a),fileTypes:h(o),fileCount:D.count,maxFilesReached:D.maxReached,launchConfigFiles:L})});return g.set(n,w),w}function h(t){return Array.from(t.entries(),([r,n])=>({name:r,count:n})).sort((r,n)=>n.count-r.count)}function m(){const t={os:`${_.type()} ${_.arch()} ${_.release()}`,memory:`${(_.totalmem()/l.ByteSize.GB).toFixed(2)}GB (${(_.freemem()/l.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.virtualMachineHint.value()*100)}%`},r=_.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}async function f(t){try{const r=new Map,n=(0,k.join)(t,".vscode","launch.json"),s=await C.Promises.readFile(n),i=[],o=(0,A.parse)(s.toString(),i);if(i.length)return console.log(`Unable to parse ${n}`),[];if((0,A.getNodeType)(o)==="object"&&o.configurations)for(const a of o.configurations){const y=a.type;y&&(r.has(y)?r.set(y,r.get(y)+1):r.set(y,1))}return h(r)}catch{return[]}}let S=class{constructor(r,n){this.telemetryService=r,this.productService=n}formatMachineInfo(r){const n=[];return n.push(`OS Version:       ${r.os}`),n.push(`CPUs:             ${r.cpus}`),n.push(`Memory (System):  ${r.memory}`),n.push(`VM:               ${r.vmHint}`),n.join(`
`)}formatEnvironment(r){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} ${this.productService.release||"Release unknown"} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${_.type()} ${_.arch()} ${_.release()}`);const s=_.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(_.totalmem()/l.ByteSize.GB).toFixed(2)}GB (${(_.freemem()/l.ByteSize.GB).toFixed(2)}GB free)`),R.isWindows||n.push(`Load (avg):       ${_.loadavg().map(i=>Math.round(i)).join(", ")}`),n.push(`VM:               ${Math.round(d.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${r.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(r,n){return Promise.all([(0,E.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async s=>{let[i,o]=s,a=this.formatProcessList(r,i);return n.forEach(y=>{if((0,v.isRemoteDiagnosticError)(y))a+=`
${y.errorMessage}`,o+=`
${y.errorMessage}`;else if(a+=`

Remote: ${y.hostName}`,y.processes&&(a+=`
${this.formatProcessList(r,y.processes)}`),y.workspaceMetadata){o+=`
|  Remote: ${y.hostName}`;for(const I of Object.keys(y.workspaceMetadata)){const w=y.workspaceMetadata[I];let b=`${w.fileCount} files`;w.maxFilesReached&&(b=`more than ${b}`),o+=`|    Folder (${I}): ${b}`,o+=this.formatWorkspaceStats(w)}}}),{processInfo:a,workspaceInfo:o}})}async getSystemInfo(r,n){const{memory:s,vmHint:i,os:o,cpus:a}=m(),y={os:o,memory:s,cpus:a,vmHint:i,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:n};return R.isWindows||(y.load=`${_.loadavg().map(I=>Math.round(I)).join(", ")}`),R.isLinux&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(r,n){const s=[];return(0,E.listProcesses)(r.mainPID).then(async i=>(s.push(""),s.push(this.formatEnvironment(r)),s.push(""),s.push(this.formatProcessList(r,i)),r.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(r))),n.forEach(o=>{if((0,v.isRemoteDiagnosticError)(o))s.push(`
${o.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${o.hostName}`),s.push(this.formatMachineInfo(o.machineInfo)),o.processes&&s.push(this.formatProcessList(r,o.processes)),o.workspaceMetadata)for(const a of Object.keys(o.workspaceMetadata)){const y=o.workspaceMetadata[a];let I=`${y.fileCount} files`;y.maxFilesReached&&(I=`more than ${I}`),s.push(`Folder (${a}): ${I}`),s.push(this.formatWorkspaceStats(y))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(r){const n=[];let i=0;const o=(w,b)=>{const D=` ${w}(${b})`;i+D.length>60?(n.push(a),a="|                 ",i=a.length):i+=D.length,a+=D};let a="|      File types:";const y=10,I=r.fileTypes.length>y?y:r.fileTypes.length;for(let w=0;w<I;w++){const b=r.fileTypes[w];o(b.name,b.count)}if(n.push(a),r.configFiles.length>=0&&(a="|      Conf files:",i=0,r.configFiles.forEach(w=>{o(w.name,w.count)}),n.push(a)),r.launchConfigFiles.length>0){let w="|      Launch Configs:";r.launchConfigFiles.forEach(b=>{const D=b.count>1?` ${b.name}(${b.count})`:` ${b.name}`;w+=D}),n.push(w)}return n.join(`
`)}expandGPUFeatures(r){const n=Math.max(...Object.keys(r).map(s=>s.length));return Object.keys(r).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${r[s]}`).join(`
                  `)}formatWorkspaceMetadata(r){const n=[],s=[];return r.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(n.push(`|  Window (${i.title})`),i.folderURIs.forEach(o=>{const a=P.URI.revive(o);if(a.scheme===O.Schemas.file){const y=a.fsPath;s.push(u(y,["node_modules",".git"]).then(I=>{let w=`${I.fileCount} files`;I.maxFilesReached&&(w=`more than ${w}`),n.push(`|    Folder (${(0,k.basename)(y)}): ${w}`),n.push(this.formatWorkspaceStats(I))}).catch(I=>{n.push(`|      Error: Unable to collect workspace stats for folder ${y} (${I.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(i=>n.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}formatProcessList(r,n){const s=new Map;r.windows.forEach(o=>s.set(o.pid,`window [${o.id}] (${o.title})`)),r.pidToNames.forEach(({pid:o,name:a})=>s.set(o,a));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(r.mainPID,s,i,n,0),i.join(`
`)}formatProcessItem(r,n,s,i,o){const a=o===0;let y;a?y=i.pid===r?`${this.productService.applicationName} main`:"remote agent":n.has(i.pid)?y=n.get(i.pid):y=`${"  ".repeat(o)} ${i.name}`;const I=process.platform==="win32"?i.mem:_.totalmem()*(i.mem/100);s.push(`${i.load.toFixed(0).padStart(5," ")}	${(I/l.ByteSize.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(i.children)&&i.children.forEach(w=>this.formatProcessItem(r,n,s,w,o+1))}async getWorkspaceFileExtensions(r){const n=new Set;for(const{uri:s}of r.folders){const i=P.URI.revive(s);if(i.scheme!==O.Schemas.file)continue;const o=i.fsPath;try{(await u(o,["node_modules",".git"])).fileTypes.forEach(y=>n.add(y.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(r){for(const{uri:n}of r.folders){const s=P.URI.revive(n);if(s.scheme!==O.Schemas.file)continue;const i=s.fsPath;try{const o=await u(i,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),o.fileTypes.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),o.launchConfigFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),o.configFiles.forEach(a=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.DiagnosticsService=S,e.DiagnosticsService=S=Ce([K(0,p.ITelemetryService),K(1,c.IProductService)],S)}),define(ae[107],ce([0,1,7,4,9,22]),function(ne,e,_,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.ExtensionSignatureVerificationError=e.ExtensionSignatureVerificationCode=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,U.createDecorator)("IExtensionSignatureVerificationService");var k;(function(d){d.None="None",d.RequiredArgumentMissing="RequiredArgumentMissing",d.InvalidArgument="InvalidArgument",d.PackageIsUnreadable="PackageIsUnreadable",d.UnhandledException="UnhandledException",d.SignatureManifestIsMissing="SignatureManifestIsMissing",d.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",d.SignatureIsMissing="SignatureIsMissing",d.SignatureIsUnreadable="SignatureIsUnreadable",d.CertificateIsUnreadable="CertificateIsUnreadable",d.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",d.FileAlreadyExists="FileAlreadyExists",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",d.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",d.Success="Success",d.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",d.SignatureIsInvalid="SignatureIsInvalid",d.SignatureManifestIsInvalid="SignatureManifestIsInvalid",d.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",d.EntryIsMissing="EntryIsMissing",d.EntryIsTampered="EntryIsTampered",d.Untrusted="Untrusted",d.CertificateRevoked="CertificateRevoked",d.SignatureIsNotValid="SignatureIsNotValid",d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(k||(e.ExtensionSignatureVerificationCode=k={}));class R extends Error{constructor(C){super(C),this.code=C}}e.ExtensionSignatureVerificationError=R;let P=class{constructor(C,E){this.logService=C,this.telemetryService=E}vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((C,E)=>ne(["@vscode/vsce-sign"],async v=>C(v),E))),this.moduleLoadingPromise}async verify(C,E,v){let l;try{l=await this.vsceSign()}catch(u){return this.logService.error("Could not load vsce-sign module",(0,_.getErrorMessage)(u)),this.logService.info(`Extension signature verification is not done: ${C}`),!1}const c=new Date().getTime();let p;try{p=await l.verify(E,v,this.logService.getLevel()===A.LogLevel.Trace)}catch(u){p={code:"UnknownError",didExecute:!1,output:(0,_.getErrorMessage)(u)}}const g=new Date().getTime()-c;if(this.logService.info(`Extension signature verification result for ${C}: ${p.code}. Duration: ${g}ms.`),this.logService.trace(`Extension signature verification output for ${C}:
${p.output}`),this.telemetryService.publicLog2("extensionsignature:verification",{extensionId:C,code:p.code,duration:g,didExecute:p.didExecute}),p.code==="Success")return!0;throw new R(p.code)}};e.ExtensionSignatureVerificationService=P,e.ExtensionSignatureVerificationService=P=Ce([K(0,A.ILogService),K(1,O.ITelemetryService)],P)}),define(ae[108],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class _{constructor(O){this.appenders=O}listen(O,k){throw new Error(`Event not found: ${k}`)}call(O,k,{eventName:R,data:P}){return this.appenders.forEach(d=>d.log(R,P)),Promise.resolve(null)}}e.TelemetryAppenderChannel=_;class U{constructor(O){this.channel=O}log(O,k){return this.channel.call("log",{eventName:O,data:k}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=U}),define(ae[49],ce([0,1,30,13,102,106,22]),function(ne,e,_,U,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0,e.supportsTelemetry=C,e.isLoggingOnly=E,e.getTelemetryLevel=v,e.validateTelemetryData=l,e.cleanRemoteAuthority=p,e.isInternalTelemetry=u,e.getPiiPathsFromEnvironment=h,e.cleanData=S;class R{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=R;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class d{async publicLog(r,n,s){}async publicLogError(r,n,s){}}e.NullEndpointTelemetryService=d,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(t,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!t.enableTelemetry)}function E(t,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function v(t){const r=t.getValue(k.TELEMETRY_SETTING_ID),n=t.getValue(k.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(t.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function l(t){const r={},n={},s={};g(t,s);for(let i in s){i=i.length>150?i.substr(i.length-149):i;const o=s[i];typeof o=="number"?n[i]=o:typeof o=="boolean"?n[i]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${o.length}`),r[i]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[i]=o)}return{properties:r,measurements:n}}const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(t){if(!t)return"none";const r=(0,A.getRemoteName)(t);return c.has(r)?r:"other"}function g(t,r,n=0,s){if(t)for(const i of Object.getOwnPropertyNames(t)){const o=t[i],a=s?s+i:i;Array.isArray(o)?r[a]=(0,_.safeStringify)(o):o instanceof Date?r[a]=o.toISOString():(0,U.isObject)(o)?n<2?g(o,r,n+1,a+"."):r[a]=(0,_.safeStringify)(o):r[a]=o}}function u(t,r){const n=t.msftInternalDomains||[],s=r.getValue("telemetry.internalTesting");return(0,O.verifyMicrosoftInternalDomain)(n)||s}function h(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function m(t,r){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let n=t;const s=[];for(const y of r)for(;;){const I=y.exec(t);if(!I)break;s.push([I.index,y.lastIndex])}const i=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const y=o.exec(t);if(!y)break;const I=s.some(([w,b])=>y.index<b&&w<o.lastIndex);!i.test(y[0])&&!I&&(n+=t.substring(a,y.index)+"<REDACTED: user-file-path>",a=o.lastIndex)}return a<t.length&&(n+=t.substr(a)),n}function f(t){if(!t)return t;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of r)if(n.regex.test(t))return`<REDACTED: ${n.label}>`;return t}function S(t,r){return(0,_.cloneAndChange)(t,n=>{if(n instanceof R||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=m(s,r);for(const i of r)s=s.replace(i,"");return s=f(s),s}})}}),define(ae[33],ce([0,1,27,29,48,5,8,7,36,49]),function(ne,e,_,U,A,O,k,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BetterMergeId=e.ExtensionKey=void 0,e.areSameExtensions=C,e.getIdAndVersion=c,e.getExtensionId=p,e.adoptToGalleryExtensionId=g,e.getGalleryExtensionId=u,e.groupByExtension=h,e.getLocalExtensionTelemetryData=m,e.getGalleryExtensionTelemetryData=f,e.getExtensionDependencies=S,e.computeTargetPlatform=r;function C(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,_.compareIgnoreCase)(n.id,s.id)===0}const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(s){const i=s.manifest?s.manifest.version:s.version,o=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new v(s.identifier,i,o)}static parse(s){const i=E.exec(s);return i&&i[1]&&i[2]?new v({id:i[1]},i[2],i[4]||void 0):null}constructor(s,i,o="undefined"){this.version=i,this.targetPlatform=o,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof v?C(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=v;const l=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function c(n){const s=l.exec(n);return s&&s[1]?[g(s[1]),s[2]]:[g(n),void 0]}function p(n,s){return`${n}.${s}`}function g(n){return n.toLowerCase()}function u(n,s){return g(p(n??A.UNDEFINED_PUBLISHER,s))}function h(n,s){const i=[],o=a=>{for(const y of i)if(y.some(I=>C(s(I),s(a))))return y;return null};for(const a of n){const y=o(a);y?y.push(a):i.push([a])}return i}function m(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function f(n){return{id:new d.TelemetryTrustedValue(n.identifier.id),name:new d.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function S(n,s){const i=[],o=s.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const a=o.shift();if(a&&i.every(y=>!C(y.identifier,{id:a}))){const y=n.filter(I=>C(I.identifier,{id:a}));y.length===1&&(i.push(y[0]),o.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}async function t(n,s){if(!O.isLinux)return!1;let i;try{i=(await n.readFile(k.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await n.readFile(k.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(a))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(n,s){const i=await t(n,s),o=(0,U.getTargetPlatform)(i?"alpine":O.platform,P.arch);return s.debug("ComputeTargetPlatform:",o),o}}),define(ae[229],ce([0,1,17,2,20,8,12,24,6,3,14,5,36,33]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let c=class extends U.Disposable{constructor(m,f){super(),this.fileService=m,this.productService=f,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,S])=>this.allConfigBasedTips.set(S.configPath,S))}getConfigBasedTips(m){return this.getValidConfigBasedTips(m)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(m){const f=[];for(const[S,t]of this.allConfigBasedTips)if(!(t.configScheme&&t.configScheme!==m.scheme))try{const r=(await this.fileService.readFile((0,A.joinPath)(m,S))).value.toString();for(const[n,s]of Object.entries(t.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(r))&&f.push({extensionId:n,extensionName:s.name,configName:t.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return f}};e.ExtensionTipsService=c,e.ExtensionTipsService=c=Ce([K(0,k.IFileService),K(1,R.IProductService)],c);const p="extensionTips/promptedExecutableTips",g="extensionTips/lastPromptedMediumImpExeTime";class u extends c{constructor(m,f,S,t,r,n,s,i){super(s,i),this.userHome=m,this.windowEvents=f,this.telemetryService=S,this.extensionManagementService=t,this.storageService=r,this.extensionRecommendationNotificationService=n,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,i.exeBasedExtensionTips&&Object.entries(i.exeBasedExtensionTips).forEach(([o,a])=>{const y=[],I=[],w=[];Object.entries(a.recommendations).forEach(([b,D])=>{D.important?a.important?y.push({extensionId:b,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):I.push({extensionId:b,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):w.push({extensionId:b,extensionName:D.name,isExtensionPack:!!D.isExtensionPack})}),y.length&&this.highImportanceExecutableTips.set(o,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:y}),I.length&&this.mediumImportanceExecutableTips.set(o,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:I}),w.length&&this.allOtherExecutableTips.set(o,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:w})}),(0,P.disposableTimeout)(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()},3e3,this._store)}async getImportantExecutableBasedTips(){const m=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),f=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...m,...f]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const m=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),f=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),S=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(m,S),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(f,S)}groupImportantTipsByExe(m,f){const S=new Map;m.forEach(i=>S.set(i.extensionId.toLowerCase(),i));const{installed:t,uninstalled:r}=this.groupByInstalled([...S.keys()],f);for(const i of t){const o=S.get(i);o&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:i,exeName:o.exeName})}for(const i of r){const o=S.get(i);o&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:i,exeName:o.exeName})}const n=this.getPromptedExecutableTips(),s=new Map;for(const i of r){const o=S.get(i);if(o&&(!n[o.exeName]||!n[o.exeName].includes(o.extensionId))){let a=s.get(o.exeName);a||(a=[],s.set(o.exeName,a)),a.push(o)}}return s}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[m,f]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(f).then(S=>{switch(S){case"reacted":this.addToRecommendedExecutables(f[0].exeName,f);break;case"ignored":this.highImportanceTipsByExe.delete(m);break;case"incompatibleWindow":{const t=d.Event.once(d.Event.latch(d.Event.any(this.windowEvents.onDidOpenMainWindow,this.windowEvents.onDidFocusMainWindow)));this._register(t(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const t=this._register(new U.MutableDisposable);t.value=(0,P.disposableTimeout)(()=>{t.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3);break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const m=this.getLastPromptedMediumExeTime(),f=Date.now()-m,S=7*24*60*60*1e3;if(f<S){const n=this._register(new U.MutableDisposable);n.value=(0,P.disposableTimeout)(()=>{n.dispose(),this.promptMediumImportanceExeBasedTip()},S-f);return}const[t,r]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(r).then(n=>{switch(n){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(t),this.addToRecommendedExecutables(r[0].exeName,r);const s=this._register(new U.MutableDisposable);s.value=(0,P.disposableTimeout)(()=>{s.dispose(),this.promptMediumImportanceExeBasedTip()},S);break}case"ignored":this.mediumImportanceTipsByExe.delete(t),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const s=d.Event.once(d.Event.latch(d.Event.any(this.windowEvents.onDidOpenMainWindow,this.windowEvents.onDidFocusMainWindow)));this._register(s(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const s=this._register(new U.MutableDisposable);s.value=(0,P.disposableTimeout)(()=>{s.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3);break}}})}async promptExeRecommendations(m){const f=await this.extensionManagementService.getInstalled(1),S=m.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(r=>f.every(n=>!(0,l.areSameExtensions)(n.identifier,{id:r})))).map(({extensionId:t})=>t.toLowerCase());return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification({extensions:S,source:3,name:m[0].exeFriendlyName,searchValue:`@exe:"${m[0].exeName}"`})}getLastPromptedMediumExeTime(){let m=this.storageService.getNumber(g,-1);return m||(m=Date.now(),this.updateLastPromptedMediumExeTime(m)),m}updateLastPromptedMediumExeTime(m){this.storageService.store(g,m,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(p,-1,"{}"))}addToRecommendedExecutables(m,f){const S=this.getPromptedExecutableTips();S[m]=f.map(({extensionId:t})=>t.toLowerCase()),this.storageService.store(p,JSON.stringify(S),-1,0)}groupByInstalled(m,f){const S=[],t=[],r=f.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return m.forEach(n=>{r.has(n.toLowerCase())?S.push(n):t.push(n)}),{installed:S,uninstalled:t}}async getValidExecutableBasedExtensionTips(m){const f=[],S=new Map;for(const t of m.keys()){const r=m.get(t);if(!r||!(0,_.isNonEmptyArray)(r.recommendations))continue;const n=[];E.isWindows?r.windowsPath&&n.push(r.windowsPath.replace("%USERPROFILE%",()=>v.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>v.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>v.env.ProgramFiles).replace("%APPDATA%",()=>v.env.APPDATA).replace("%WINDIR%",()=>v.env.WINDIR)):(n.push((0,C.join)("/usr/local/bin",t)),n.push((0,C.join)("/usr/bin",t)),n.push((0,C.join)(this.userHome.fsPath,t)));for(const s of n){let i=S.get(s);if(i===void 0&&(i=await this.fileService.exists(O.URI.file(s)),S.set(s,i)),i)for(const{extensionId:o,extensionName:a,isExtensionPack:y,whenNotInstalled:I}of r.recommendations)f.push({extensionId:o,extensionName:a,isExtensionPack:y,exeName:t,exeFriendlyName:r.exeFriendlyName,windowsPath:r.windowsPath,whenNotInstalled:I})}}return f}}e.AbstractNativeExtensionTipsService=u}),define(ae[230],ce([0,1,26,33]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=A;async function A(O,k,R,P,d){try{const C=await O.getExtensionsControlManifest();if(!C.deprecated)return;const E=await O.getInstalled(1);for(const[v,l]of Object.entries(C.deprecated)){if(!l?.extension)continue;const{id:c,autoMigrate:p,preRelease:g}=l.extension;if(!p)continue;const u=E.find(m=>(0,U.areSameExtensions)(m.identifier,{id:v}));if(!u)continue;const h=(await k.getExtensions([{id:c,preRelease:g}],{targetPlatform:await O.getTargetPlatform(),compatible:!0},_.CancellationToken.None))[0];if(!h){d.info(`Skipping migrating '${u.identifier.id}' extension because, the comaptible target '${c}' extension is not found`);continue}try{d.info(`Migrating '${u.identifier.id}' extension to '${c}' extension...`);const m=!P.getDisabledExtensions().some(S=>(0,U.areSameExtensions)(S,u.identifier));await O.uninstall(u),d.info(`Uninstalled the unsupported extension '${u.identifier.id}'`);let f=E.find(S=>(0,U.areSameExtensions)(S.identifier,{id:c}));(!f||!f.isPreReleaseVersion&&m)&&(f=await O.installFromGallery(h,{installPreReleaseVersion:!0,isMachineScoped:u.isMachineScoped,operation:4}),d.info(`Installed the pre-release extension '${f.identifier.id}'`),m||(await P.disableExtension(f.identifier),d.info(`Disabled the pre-release extension '${f.identifier.id}' because the unsupported extension '${u.identifier.id}' is disabled`)),p.storage&&(R.addToMigrationList((0,U.getExtensionId)(u.manifest.publisher,u.manifest.name),(0,U.getExtensionId)(f.manifest.publisher,f.manifest.name)),d.info("Added pre-release extension to the storage migration list"))),d.info(`Migrated '${u.identifier.id}' extension to '${c}' extension.`)}catch(m){d.error(m)}}}catch(C){d.error(C)}}}),define(ae[231],ce([0,1,6,7,2,23,20,55,13,32,31,70,21,16,29,33,107,12,9]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g,u,h){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let f=class extends A.Disposable{static{m=this}static{this.SignatureArchiveExtension=".sigzip"}constructor(t,r,n,s,i,o){super(),this.fileService=r,this.extensionGalleryService=n,this.configurationService=s,this.extensionSignatureVerificationService=i,this.logService=o,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(t,r,n){await this.cleanUpPromise;const s=(0,k.joinPath)(this.extensionsDownloadDir,this.getName(t));try{await this.downloadFile(t,s,o=>this.extensionGalleryService.download(t,o,r))}catch(o){throw new c.ExtensionManagementError(o.message,c.ExtensionManagementErrorCode.Download)}let i=!1;if(n&&this.shouldVerifySignature(t)){const o=await this.downloadSignatureArchive(t);try{i=await this.extensionSignatureVerificationService.verify(t.identifier.id,s.fsPath,o.fsPath)}catch(a){if(i=a.code,i==="PackageIsInvalidZip"||i==="SignatureArchiveIsInvalidZip"){try{await this.delete(s)}catch(I){this.logService.error(I)}throw new c.ExtensionManagementError(E.CorruptZipMessage,c.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(a){this.logService.error(a)}}}return{location:s,verificationStatus:i}}shouldVerifySignature(t){if(!t.isSigned)return this.logService.info(`Extension is not signed: ${t.identifier.id}`),!1;const r=this.configurationService.getValue("extensions.verifySignature");return(0,P.isBoolean)(r)?r:!0}async downloadSignatureArchive(t){await this.cleanUpPromise;const r=(0,k.joinPath)(this.extensionsDownloadDir,`${this.getName(t)}${m.SignatureArchiveExtension}`);try{await this.downloadFile(t,r,n=>this.extensionGalleryService.downloadSignatureArchive(t,n))}catch(n){throw new c.ExtensionManagementError(n.message,c.ExtensionManagementErrorCode.DownloadSignature)}return r}async downloadFile(t,r,n){if(await this.fileService.exists(r))return;if(r.scheme!==O.Schemas.file){await n(r);return}const s=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(s)||await n(s);try{await C.Promises.rename(s.fsPath,r.fsPath,2*60*1e3)}catch(i){try{await this.fileService.del(s)}catch{}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,r.path);else throw this.logService.info(`Rename failed because of ${(0,U.getErrorMessage)(i)}. Deleted the file from downloaded location`,s.path),i}}async delete(t){await this.cleanUpPromise,await this.fileService.del(t)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const r=[],n=[],s=[];for(const a of t.children)if(a.name.endsWith(m.SignatureArchiveExtension))s.push(a.resource);else{const y=p.ExtensionKey.parse(a.name);y&&n.push([y,a])}const i=(0,p.groupByExtension)(n,([a])=>a),o=[];for(const a of i)a.sort((y,I)=>R.rcompare(y[0].version,I[0].version)),r.push(...a.slice(1).map(y=>y[1].resource)),o.push(a[0][1]);o.sort((a,y)=>a.mtime-y.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(a=>a.resource)),r.push(...s),await _.Promises.settled(r.map(a=>(this.logService.trace("Deleting from cache",a.path),this.fileService.del(a))))}}catch(t){this.logService.error(t)}}getName(t){return this.cache?p.ExtensionKey.create(t).toString().toLowerCase():(0,d.generateUuid)()}};e.ExtensionsDownloader=f,e.ExtensionsDownloader=f=m=Ce([K(0,l.INativeEnvironmentService),K(1,u.IFileService),K(2,c.IExtensionGalleryService),K(3,v.IConfigurationService),K(4,g.IExtensionSignatureVerificationService),K(5,h.ILogService)],f)}),define(ae[232],ce([0,1,3,2,34,33,48]),function(ne,e,_,U,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class R extends U.Disposable{constructor(d,C,E,v,l,c,p){super(),this.extensionManagementService=d,this.extensionsScannerService=C,this.userDataProfilesService=E,this.extensionsProfileScannerService=v,this.uriIdentityService=l,this.fileService=c,this.logService=p,this._onDidChangeExtensionsByAnotherSource=this._register(new _.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.allExtensions=new Map,this.extensionsProfileWatchDisposables=this._register(new U.DisposableMap),this.initialize().then(null,g=>p.error(g))}async initialize(){await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.onDidChangeProfiles(this.userDataProfilesService.profiles),this.registerListeners(),await this.uninstallExtensionsNotInProfiles()}registerListeners(){this._register(this.userDataProfilesService.onDidChangeProfiles(d=>this.onDidChangeProfiles(d.added))),this._register(this.extensionsProfileScannerService.onAddExtensions(d=>this.onAddExtensions(d))),this._register(this.extensionsProfileScannerService.onDidAddExtensions(d=>this.onDidAddExtensions(d))),this._register(this.extensionsProfileScannerService.onRemoveExtensions(d=>this.onRemoveExtensions(d))),this._register(this.extensionsProfileScannerService.onDidRemoveExtensions(d=>this.onDidRemoveExtensions(d))),this._register(this.fileService.onDidFilesChange(d=>this.onDidFilesChange(d)))}async onDidChangeProfiles(d){try{d.length&&await Promise.all(d.map(C=>(this.extensionsProfileWatchDisposables.set(C.id,(0,U.combinedDisposable)(this.fileService.watch(this.uriIdentityService.extUri.dirname(C.extensionsResource)),this.fileService.watch(C.extensionsResource))),this.populateExtensionsFromProfile(C.extensionsResource))))}catch(C){throw this.logService.error(C),C}}async onAddExtensions(d){for(const C of d.extensions)this.addExtensionWithKey(this.getKey(C.identifier,C.version),d.profileLocation)}async onDidAddExtensions(d){for(const C of d.extensions){const E=this.getKey(C.identifier,C.version);d.error?this.removeExtensionWithKey(E,d.profileLocation):this.addExtensionWithKey(E,d.profileLocation)}}async onRemoveExtensions(d){for(const C of d.extensions)this.removeExtensionWithKey(this.getKey(C.identifier,C.version),d.profileLocation)}async onDidRemoveExtensions(d){const C=[],E=[];for(const v of d.extensions){const l=this.getKey(v.identifier,v.version);d.error?this.addExtensionWithKey(l,d.profileLocation):(this.removeExtensionWithKey(l,d.profileLocation),this.allExtensions.has(l)||(this.logService.debug("Extension is removed from all profiles",v.identifier.id,v.version),E.push(this.extensionManagementService.scanInstalledExtensionAtLocation(v.location).then(c=>{c?C.push(c):this.logService.info("Extension not found at the location",v.location.toString())},c=>this.logService.error(c)))))}try{await Promise.all(E),C.length&&await this.uninstallExtensionsNotInProfiles(C)}catch(v){this.logService.error(v)}}onDidFilesChange(d){for(const C of this.userDataProfilesService.profiles)d.contains(C.extensionsResource,0,1)&&this.onDidExtensionsProfileChange(C.extensionsResource)}async onDidExtensionsProfileChange(d){const C=[],E=[],v=await this.extensionsProfileScannerService.scanProfileExtensions(d),l=new Set,c=new Set;for(const[p,g]of this.allExtensions)g.has(d)&&c.add(p);for(const p of v){const g=this.getKey(p.identifier,p.version);l.add(g),c.has(g)||(C.push(p.identifier),this.addExtensionWithKey(g,d))}for(const p of c)if(!l.has(p)){const g=this.fromKey(p);g&&(E.push(g.identifier),this.removeExtensionWithKey(p,d))}(C.length||E.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:C.length?{extensions:C,profileLocation:d}:void 0,removed:E.length?{extensions:E,profileLocation:d}:void 0})}async populateExtensionsFromProfile(d){const C=await this.extensionsProfileScannerService.scanProfileExtensions(d);for(const E of C)this.addExtensionWithKey(this.getKey(E.identifier,E.version),d)}async uninstallExtensionsNotInProfiles(d){d||(d=(await this.extensionManagementService.scanAllUserInstalledExtensions()).filter(E=>!this.allExtensions.has(this.getKey(E.identifier,E.manifest.version)))),d.length&&await this.extensionManagementService.markAsUninstalled(...d)}addExtensionWithKey(d,C){let E=this.allExtensions.get(d);E||this.allExtensions.set(d,E=new A.ResourceSet(v=>this.uriIdentityService.extUri.getComparisonKey(v))),E.add(C)}removeExtensionWithKey(d,C){const E=this.allExtensions.get(d);E&&E.delete(C),E?.size||this.allExtensions.delete(d)}getKey(d,C){return`${k.ExtensionIdentifier.toKey(d.id)}@${C}`}fromKey(d){const[C,E]=(0,O.getIdAndVersion)(d);return E?{identifier:{id:C},version:E}:void 0}}e.ExtensionsWatcher=R}),define(ae[233],ce([0,1,45,49]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=A;async function A(O,k,R,P,d,C,E){const v={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${k.nameShort})`};if((0,U.supportsTelemetry)(k,R)&&(0,U.getTelemetryLevel)(P)===3){const l=await(0,_.getServiceMachineId)(R,d,C);v["X-Market-User-Id"]=l,v["VSCode-SessionId"]=E.machineId||l}return v}}),define(ae[234],ce([0,1,73,17,6,2,23,14,31,16,29,33,9,75,8]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let p=class extends l.LanguagePackBaseService{constructor(m,f,S,t){super(S),this.extensionManagementService=m,this.logService=t,this.cache=this._register(new g(f,t)),this.extensionManagementService.registerParticipant({postInstall:async r=>this.postInstallExtension(r),postUninstall:async r=>this.postUninstallExtension(r)})}async getBuiltInExtensionTranslationsUri(m,f){const t=(await this.cache.getLanguagePacks())[f];if(!t){this.logService.warn(`No language pack found for ${f}`);return}const r=t.translations[m];return r?c.URI.file(r):void 0}async getInstalledLanguages(){const m=await this.cache.getLanguagePacks(),f=Object.keys(m).map(S=>{const t=m[S];return{...this.createQuickPickItem(S,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return f.push(this.createQuickPickItem("en","English")),f.sort((S,t)=>S.label.localeCompare(t.label)),f}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const f=await this.cache.getLanguagePacks();Object.keys(f).some(S=>f[S]&&f[S].extensions.some(t=>(0,E.areSameExtensions)(t.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,f]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),S=await this.cache.update(f);return!(0,U.equals)(Object.keys(m),Object.keys(S))}};e.NativeLanguagePackService=p,e.NativeLanguagePackService=p=Ce([K(0,C.IExtensionManagementService),K(1,d.INativeEnvironmentService),K(2,C.IExtensionGalleryService),K(3,v.ILogService)],p);let g=class extends O.Disposable{constructor(m,f){super(),this.logService=f,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new A.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(f=>{Object.keys(f).forEach(S=>delete f[S]),this.createLanguagePacksFromExtensions(f,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...f){for(const S of f)S&&S.manifest&&S.manifest.contributes&&S.manifest.contributes.localizations&&S.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,S);Object.keys(m).forEach(S=>this.updateHash(m[S]))}createLanguagePacksFromExtension(m,f){const S=f.identifier,t=f.manifest.contributes&&f.manifest.contributes.localizations?f.manifest.contributes.localizations:[];for(const r of t)if(f.location.scheme===k.Schemas.file&&u(r)){let n=m[r.languageId];n||(n={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},m[r.languageId]=n);const s=n.extensions.filter(i=>(0,E.areSameExtensions)(i.extensionIdentifier,S))[0];s?s.version=f.manifest.version:n.extensions.push({extensionIdentifier:S,version:f.manifest.version});for(const i of r.translations)n.translations[i.id]=(0,R.join)(f.location.fsPath,i.path)}}updateHash(m){if(m){const f=(0,_.createHash)("md5");for(const S of m.extensions)f.update(S.extensionIdentifier.uuid||S.extensionIdentifier.id).update(S.version);m.hash=f.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let f=null;return P.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,S=>S.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(S)).then(S=>{try{return JSON.parse(S)}catch{return{}}}).then(S=>(f=m(S),S)).then(S=>{for(const r of Object.keys(S))S[r]||delete S[r];this.languagePacks=S,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),P.Promises.writeFile(this.languagePacksFilePath,t)}).then(()=>f,S=>this.logService.error(S))})}};g=Ce([K(0,d.INativeEnvironmentService),K(1,v.ILogService)],g);function u(h){if(typeof h.languageId!="string"||!Array.isArray(h.translations)||h.translations.length===0)return!1;for(const m of h.translations)if(typeof m.id!="string"||typeof m.path!="string")return!1;return!(h.languageName&&typeof h.languageName!="string"||h.localizedLanguageName&&typeof h.localizedLanguageName!="string")}}),define(ae[235],ce([0,1,143,7,30,49]),function(ne,e,_,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const k="https://0.0.0.0/OneCollector/1.0",R="https://0.0.0.0/ping";async function P(C,E,v){const l=await(0,_.importAMDNodeModule)("@microsoft/1ds-core-js","dist/ms.core.js"),c=await(0,_.importAMDNodeModule)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new l.AppInsightsCore,g=new c.PostChannel,u={instrumentationKey:C,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(v){u.extensionConfig={};const h={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:v};u.extensionConfig[g.identifier]=h}return p.initialize(u,[]),p.addTelemetryInitializer(h=>{h.ext=h.ext??{},h.ext.web=h.ext.web??{},h.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',E&&(h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),p}class d{constructor(E,v,l,c,p){this._isInternalTelemetry=E,this._eventPrefix=v,this._defaultData=l,this._xhrOverride=p,this.endPointUrl=k,this.endPointHealthUrl=R,this._defaultData||(this._defaultData={}),typeof c=="function"?this._aiCoreOrKey=c():this._aiCoreOrKey=c,this._asyncAiCore=null}_withAIClient(E){if(this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){E(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=P(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(v=>{E(v)},v=>{(0,U.onUnexpectedError)(v),console.error(v)})}}log(E,v){if(!this._aiCoreOrKey)return;v=(0,A.mixin)(v,this._defaultData),v=(0,O.validateTelemetryData)(v);const l=this._eventPrefix+"/"+E;try{this._withAIClient(c=>{c.pluginVersionString=v?.properties.version??"Unknown",c.track({name:l,baseData:{name:l,properties:v?.properties,measurements:v?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(E=>{this._withAIClient(v=>{v.unload(!0,()=>{this._aiCoreOrKey=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=d}),define(ae[109],ce([0,1,2,172,16,9,24,49]),function(ne,e,_,U,A,O,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let P=class extends _.Disposable{constructor(C,E,v,l,c=""){super(),this.prefix=c;const p=E.getLogger(R.telemetryLogId);if(p)this.logger=this._register(p);else{const u=(0,R.isLoggingOnly)(l,v)?" (Not Sent)":"",h=()=>(0,R.supportsTelemetry)(l,v)&&C.getLevel()===O.LogLevel.Trace;this.logger=this._register(E.createLogger(R.telemetryLogId,{name:(0,U.localize)(0,null,u),hidden:!h()})),this._register(C.onDidChangeLogLevel(()=>E.setVisibility(R.telemetryLogId,h()))),this.logger.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,E){this.logger.trace(`${this.prefix}telemetry/${C}`,(0,R.validateTelemetryData)(E))}};e.TelemetryLogAppender=P,e.TelemetryLogAppender=P=Ce([K(0,O.ILogService),K(1,O.ILoggerService),K(2,A.IEnvironmentService),K(3,k.IProductService)],P)}),define(ae[110],ce([0,1,2,30,5,27,173,21,47,100,24,43,22,49]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let c=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(u,h,m){this._configurationService=h,this._productService=m,this._experimentProperties={},this._disposables=new _.DisposableStore,this._cleanupPatterns=[],this._appenders=u.appenders,this._commonProperties=u.commonProperties??Object.create(null),this.sessionId=this._commonProperties.sessionID,this.machineId=this._commonProperties["common.machineId"],this.sqmId=this._commonProperties["common.sqmId"],this.firstSessionDate=this._commonProperties["common.firstSessionDate"],this.msftInternal=this._commonProperties["common.msftInternal"],this._piiPaths=u.piiPaths||[],this._telemetryLevel=3,this._sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const f of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,O.escapeRegExpCharacters)(f),"gi")),f.indexOf("\\")>=0&&this._cleanupPatterns.push(new RegExp((0,O.escapeRegExpCharacters)(f.replace(/\\/g,"/")),"gi"));this._updateTelemetryLevel(),this._disposables.add(this._configurationService.onDidChangeConfiguration(f=>{(f.affectsConfiguration(v.TELEMETRY_SETTING_ID)||f.affectsConfiguration(v.TELEMETRY_OLD_SETTING_ID)||f.affectsConfiguration(v.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this._updateTelemetryLevel()}))}setExperimentProperty(u,h){this._experimentProperties[u]=h}_updateTelemetryLevel(){let u=(0,l.getTelemetryLevel)(this._configurationService);const h=this._productService.enabledTelemetryLevels;if(h){this._sendErrorTelemetry=this.sendErrorTelemetry?h.error:!1;const m=h.usage?3:h.error?2:0;u=Math.min(u,m)}this._telemetryLevel=u}get sendErrorTelemetry(){return this._sendErrorTelemetry}get telemetryLevel(){return this._telemetryLevel}dispose(){this._disposables.dispose()}_log(u,h,m){this._telemetryLevel<h||(m=(0,U.mixin)(m,this._experimentProperties),m=(0,l.cleanData)(m,this._cleanupPatterns),m=(0,U.mixin)(m,this._commonProperties),this._appenders.forEach(f=>f.log(u,m)))}publicLog(u,h){this._log(u,3,h)}publicLog2(u,h){this.publicLog(u,h)}publicLogError(u,h){this._sendErrorTelemetry&&this._log(u,2,h)}publicLogError2(u,h){this.publicLogError(u,h)}};e.TelemetryService=c,e.TelemetryService=c=Ce([K(1,R.IConfigurationService),K(2,C.IProductService)],c);function p(){const g=(0,k.localize)(0,null,d.default.nameLong),u=d.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=A.isWeb?"":(0,k.localize)(3,null),m=(0,k.localize)(4,null),f=(0,k.localize)(5,null),S=(0,k.localize)(6,null),t=(0,k.localize)(7,null),r=`
|       | ${m} | ${f} | ${S} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,k.localize)(8,null);return`
${g} ${u} ${h}

&nbsp;

${t}
${r}

&nbsp;

${n}
`}E.Registry.as(P.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,k.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:p(),default:"off",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(P.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,k.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,k.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[236],ce([0,1,15,26,278,235]),function(ne,e,_,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;async function k(C,E){const v=await E.request(C,U.CancellationToken.None),l=(await(0,_.streamToBuffer)(v.stream)).toString(),c=v.res.statusCode??200;return{headers:v.res.headers,statusCode:c,responseData:l}}async function R(C){const E={method:C.type,headers:C.headers};return new Promise((l,c)=>{const p=A.request(C.url??"",E,g=>{g.on("data",function(u){l({headers:g.headers,statusCode:g.statusCode??200,responseData:u.toString()})}),g.on("error",function(u){c(u)})});p.write(C.data,g=>{g&&c(g)}),p.end()})}async function P(C,E,v){const l=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),c={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:l};try{const p=C?await k(c,C):await R(c);v(p.statusCode,p.headers,p.responseData)}catch{v(0,{})}}class d extends O.AbstractOneDataSystemAppender{constructor(E,v,l,c,p){const g={sendPOST:(u,h)=>{P(E,u,h)}};super(v,l,c,p,g)}}e.OneDataSystemAppender=d}),define(ae[237],ce([0,1,23,92,21,16,9,24,22,108,109,110]),function(ne,e,_,U,A,O,k,R,P,d,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let v=class{constructor(c,p,g,u,h,m){this.configurationService=c,this.telemetryService=p,this.logService=g,this.loggerService=u,this.environmentService=h,this.productService=m,this.customTelemetryServices=new Map}getCustomTelemetryService(c){if(!this.customTelemetryServices.has(c.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.telemetryService.machineId,p["common.vscodesessionid"]=this.telemetryService.sessionId;const g=[c.id,JSON.stringify(p),c.aiKey],h=new U.Client(_.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),m=[new d.TelemetryAppenderClient(h),new C.TelemetryLogAppender(this.logService,this.loggerService,this.environmentService,this.productService,`[${c.id}] `)];this.customTelemetryServices.set(c.id,new E.TelemetryService({appenders:m,sendErrorTelemetry:c.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(c.id)}publicLog(c,p,g){this.getCustomTelemetryService(c).publicLog(p,g)}publicLogError(c,p,g){this.getCustomTelemetryService(c).publicLogError(p,g)}};e.CustomEndpointTelemetryService=v,e.CustomEndpointTelemetryService=v=Ce([K(0,A.IConfigurationService),K(1,P.ITelemetryService),K(2,k.ILogService),K(3,k.ILoggerService),K(4,O.IEnvironmentService),K(5,R.IProductService)],v)}),define(ae[78],ce([0,1,3,8,21,4,9]),function(ne,e,_,U,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.ALL_INTERFACES_ADDRESSES=e.LOCALHOST_ADDRESSES=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.isTunnelProvider=d,e.extractLocalHostUriMetaDataForPortMapping=E,e.extractQueryLocalHostUriMetaDataForPortMapping=v,e.isLocalhost=l,e.isAllInterfaces=c,e.isPortPrivileged=p,e.ITunnelService=(0,O.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,O.createDecorator)("sharedTunnelsService");var R;(function(h){h.Http="http",h.Https="https"})(R||(e.TunnelProtocol=R={}));var P;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(P||(e.TunnelPrivacyId=P={}));function d(h){return!!h.forwardPort}var C;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(C||(e.ProvidedOnAutoForward=C={}));function E(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(m)return{address:m[1],port:+m[2]}}function v(h){if(h.scheme!=="http"&&h.scheme!=="https"||!h.query)return;const m=h.query.split("&");for(const f of m){const S=f.split("=")[1];if(/^https?:/.exec(S)){const t=E(U.URI.parse(S));if(t)return t}}}e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function l(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function c(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}function p(h,m,f,S){if(f===1)return!1;if(f===2&&c(m)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(S);if(t?.length===4&&parseInt(t[1])>=18)return!1}return h<1024}class g{constructor(m,f,S){this.remoteAddress=m,this.localAddress=f,this._dispose=S,this._onDispose=new _.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=g;let u=class{constructor(m,f){this.logService=m,this.configurationService=f,this._onTunnelOpened=new _.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new _.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new _.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canChangeProtocol=!0,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const m=this.configurationService.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(m){return this._tunnelProvider=m,m?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this._canElevate=m.elevation,this._privacyOptions=m.privacyOptions,this._canChangeProtocol=m.protocol}get canChangeProtocol(){return this._canChangeProtocol}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const m=[],f=Array.from(this._tunnels.values());for(const S of f){const t=Array.from(S.values());for(const r of t){const n=await r.value;n&&typeof n!="string"&&m.push(n)}}return m}async dispose(){for(const m of this._tunnels.values()){for(const{value:f}of m.values())await f.then(S=>typeof S!="string"?S?.dispose():void 0);m.clear()}this._tunnels.clear()}setEnvironmentTunnel(m,f,S,t,r){this.addTunnelToMap(m,f,Promise.resolve({tunnelRemoteHost:m,tunnelRemotePort:f,localAddress:S,privacy:t,protocol:r,dispose:()=>Promise.resolve()}))}async getExistingTunnel(m,f){(c(m)||l(m))&&(m=e.LOCALHOST_ADDRESSES[0]);const S=this.getTunnelFromMap(m,f);if(S)return++S.refcount,S.value}openTunnel(m,f,S,t,r,n=!1,s,i){this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${S} on local port ${r}.`);const o=this._tunnelProvider??m;if(!o)return;if(f||(f="localhost"),t||(t=this.defaultTunnelHost),this._tunnelProvider&&this._factoryInProgress.has(S)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.retainOrCreateTunnel(o,f,S,t,r,n,s,i);return a?a.then(y=>{if(y){if(typeof y=="string")return this.logService.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.removeEmptyOrErrorTunnelFromMap(f,S),y}else{this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyOrErrorTunnelFromMap(f,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.makeTunnel(y);return(y.tunnelRemoteHost!==f||y.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&y.privacy!==s&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this._onTunnelOpened.fire(I),I}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const f=this._tunnels.get(m.tunnelRemoteHost);if(f){const S=f.get(m.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(m.tunnelRemoteHost,m.tunnelRemotePort,S))}}}}async tryDisposeTunnel(m,f,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${f}.`);const t=S.value.then(async r=>{r&&typeof r!="string"&&(await r.dispose(!0),this._onTunnelClosed.fire({host:r.tunnelRemoteHost,port:r.tunnelRemotePort}))});return this._tunnels.has(m)&&this._tunnels.get(m).delete(f),t}}async closeTunnel(m,f){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${f} `);const S=this._tunnels.get(m);if(S&&S.has(f)){const t=S.get(f);t.refcount=0,await this.tryDisposeTunnel(m,f,t)}}addTunnelToMap(m,f,S){this._tunnels.has(m)||this._tunnels.set(m,new Map),this._tunnels.get(m).set(f,{refcount:1,value:S})}async removeEmptyOrErrorTunnelFromMap(m,f){const S=this._tunnels.get(m);if(S){const t=S.get(f),r=t?await t.value:void 0;(!r||typeof r=="string")&&S.delete(f),S.size===0&&this._tunnels.delete(m)}}getTunnelFromMap(m,f){const S=[m];l(m)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):c(m)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const t=S.map(r=>this._tunnels.get(r));for(const r of t){const n=r?.get(f);if(n)return n}}canTunnel(m){return!!E(m)}createWithProvider(m,f,S,t,r,n,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${S} on local port ${t}.`);const i=S;this._factoryInProgress.add(i);const o=t===void 0?S:t,a={elevationRequired:r?this.isPortPrivileged(o):!1},y={remoteAddress:{host:f,port:S},localAddressPort:t,privacy:n,public:n?n!==P.Private:void 0,protocol:s},I=m.forwardPort(y,a);return I?(this.addTunnelToMap(f,S,I),I.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(i)})):this._factoryInProgress.delete(i),I}};e.AbstractTunnelService=u,e.AbstractTunnelService=u=Ce([K(0,k.ILogService),K(1,A.IConfigurationService)],u)}),define(ae[238],ce([0,1,9,78,2,7,6]),function(ne,e,_,U,A,O,k){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends A.Disposable{constructor(){super(),this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new k.DeferredPromise),this._addressPromise.p)}setAddress(E){this._address=E,this._addressPromise&&(this._addressPromise.complete(E),this._addressPromise=null)}setTunnel(E){this._register(E)}}let d=class extends A.Disposable{static{R=this}static{this._lastId=0}constructor(E,v){super(),this._tunnelService=E,this._logService=v,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(E=>E.dispose())}async createTunnel(){return{id:String(++R._lastId)}}async startTunnel(E,v,l,c,p,g,u){const h=new P,m=await Promise.resolve(this._tunnelService.openTunnel(E,h,l,c,p,g,u));if(!m||typeof m=="string")throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${l}:${c} (remote).`),h.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(v))throw this._disposedTunnels.delete(v),h.dispose(),await m.dispose(),(0,O.canceled)();return h.setTunnel(m),this._tunnels.set(v,h),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${v}: ${m.localAddress} (local) to ${l}:${c} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(E,v){const l=this._tunnels.get(E);l&&l.setAddress(v)}async destroyTunnel(E){const v=this._tunnels.get(E);if(v){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${E}.`),this._tunnels.delete(E),await v.dispose();return}this._disposedTunnels.add(E)}};e.SharedProcessTunnelService=d,e.SharedProcessTunnelService=d=R=Ce([K(0,U.ISharedTunnelsService),K(1,_.ILogService)],d)}),define(ae[28],ce([0,1,4]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,_.createDecorator)("IUriIdentityService")}),define(ae[239],ce([0,1,28,191,12,20,128,3,2]),function(ne,e,_,U,A,O,k,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class d{static{this._clock=0}constructor(v){this.uri=v,this.time=d._clock++}touch(){return this.time=d._clock++,this}}let C=class{constructor(v){this._fileService=v,this._dispooables=new P.DisposableStore,this._limit=2**16;const l=new Map,c=p=>{let g=l.get(p.scheme);return g===void 0&&(g=v.hasProvider(p)&&!this._fileService.hasCapability(p,1024),l.set(p.scheme,g)),g};this._dispooables.add(R.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(p=>{l.delete(p.scheme)})),this.extUri=new O.ExtUri(c),this._canonicalUris=new k.SkipList((p,g)=>this.extUri.compare(p,g,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(v){this._fileService.hasProvider(v)&&(v=(0,O.normalizePath)(v));const l=this._canonicalUris.get(v);return l?l.touch().uri.with({fragment:v.fragment}):(this._canonicalUris.set(v,new d(v)),this._checkTrim(),v)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const v=[...this._canonicalUris.entries()].sort((c,p)=>c[1].time<p[1].time?1:c[1].time>p[1].time?-1:0);d._clock=0,this._canonicalUris.clear();const l=this._limit*.5;for(let c=0;c<l;c++)this._canonicalUris.set(v[c][0],v[c][1].touch())}};e.UriIdentityService=C,e.UriIdentityService=C=Ce([K(0,A.IFileService)],C),(0,U.registerSingleton)(_.IUriIdentityService,C,1)}),define(ae[240],ce([0,1,3,2,12,51,34]),function(ne,e,_,U,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends U.Disposable{constructor(d,C,E,v,l,c){super(),this.fileSystemScheme=d,this.fileSystemProvider=C,this.userDataScheme=E,this.userDataProfilesService=v,this.uriIdentityService=l,this.logService=c,this.capabilities=this.fileSystemProvider.capabilities,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new _.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=O.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.atomicReadWriteResources=new k.ResourceSet(p=>this.uriIdentityService.extUri.getComparisonKey(this.toFileSystemResource(p))),this.updateAtomicReadWritesResources(),this._register(v.onDidChangeProfiles(()=>this.updateAtomicReadWritesResources())),this._register(this.fileSystemProvider.onDidChangeFile(p=>this.handleFileChanges(p)))}updateAtomicReadWritesResources(){this.atomicReadWriteResources.clear();for(const d of this.userDataProfilesService.profiles)this.atomicReadWriteResources.add(d.settingsResource),this.atomicReadWriteResources.add(d.keybindingsResource),this.atomicReadWriteResources.add(d.tasksResource),this.atomicReadWriteResources.add(d.extensionsResource)}open(d,C){return this.fileSystemProvider.open(this.toFileSystemResource(d),C)}close(d){return this.fileSystemProvider.close(d)}read(d,C,E,v,l){return this.fileSystemProvider.read(d,C,E,v,l)}write(d,C,E,v,l){return this.fileSystemProvider.write(d,C,E,v,l)}watch(d,C){this.watchResources.set(d,d);const E=this.fileSystemProvider.watch(this.toFileSystemResource(d),C);return(0,U.toDisposable)(()=>{this.watchResources.delete(d),E.dispose()})}stat(d){return this.fileSystemProvider.stat(this.toFileSystemResource(d))}mkdir(d){return this.fileSystemProvider.mkdir(this.toFileSystemResource(d))}rename(d,C,E){return this.fileSystemProvider.rename(this.toFileSystemResource(d),this.toFileSystemResource(C),E)}readFile(d,C){return this.fileSystemProvider.readFile(this.toFileSystemResource(d),C)}readFileStream(d,C,E){return this.fileSystemProvider.readFileStream(this.toFileSystemResource(d),C,E)}readdir(d){return this.fileSystemProvider.readdir(this.toFileSystemResource(d))}enforceAtomicReadFile(d){return this.atomicReadWriteResources.has(d)}writeFile(d,C,E){return this.fileSystemProvider.writeFile(this.toFileSystemResource(d),C,E)}enforceAtomicWriteFile(d){return this.atomicReadWriteResources.has(d)?{postfix:".vsctmp"}:!1}delete(d,C){return this.fileSystemProvider.delete(this.toFileSystemResource(d),C)}copy(d,C,E){if((0,A.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(d),this.toFileSystemResource(C),E);throw new Error("copy not supported")}cloneFile(d,C){if((0,A.hasFileCloneCapability)(this.fileSystemProvider))return this.fileSystemProvider.cloneFile(this.toFileSystemResource(d),this.toFileSystemResource(C));throw new Error("clone not supported")}handleFileChanges(d){const C=[];for(const E of d){if(E.resource.scheme!==this.fileSystemScheme)continue;const v=this.toUserDataResource(E.resource);this.watchResources.findSubstr(v)&&C.push({resource:v,type:E.type,cId:E.cId})}C.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(C))}toFileSystemResource(d){return d.with({scheme:this.fileSystemScheme})}toUserDataResource(d){return d.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(ae[79],ce([0,1,62]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=U,e.getLineStartOffset=A,e.getLineEndOffset=O;function U(k,R,P,d){const C=(0,_.setProperty)(k,R,P,d)[0];return C&&(k=k.substring(0,C.offset)+C.content+k.substring(C.offset+C.length)),k}function A(k,R,P){let d=P;for(;d>=0;){if(k.charAt(d)===R.charAt(R.length-1)&&R.length===1)return d+1;if(d--,R.length===2&&d>=0&&k.charAt(d)===R.charAt(0))return d+2}return 0}function O(k,R,P){let d=P;for(;d>=0;)if(k.charAt(d)===R.charAt(R.length-1)&&R.length===1||(d++,R.length===2&&d>=0&&k.charAt(d)===R.charAt(1)))return d;return k.length-1}}),define(ae[241],ce([0,1,30,55,13]),function(ne,e,_,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=O;function O(l,c,p,g,u,h){const m=[],f=[],S=[];if(!c){const x=l.filter(({identifier:X})=>u.every(B=>B.toLowerCase()!==X.id.toLowerCase()));return{local:{added:m,removed:f,updated:S},remote:x.length>0?{added:x,updated:[],removed:[],all:x}:null}}l=l.map(E),c=c.map(E),p=p?p.map(E):null;const t=new Map,r=x=>{x.uuid&&t.set(x.id.toLowerCase(),x.uuid)};l.forEach(({identifier:x})=>r(x)),c.forEach(({identifier:x})=>r(x)),p?.forEach(({identifier:x})=>r(x)),g?.forEach(({identifier:x})=>r(x)),h?.forEach(x=>r(x));const n=x=>{const X=x.identifier.uuid||t.get(x.identifier.id.toLowerCase());return X?`uuid:${X}`:`id:${x.identifier.id.toLowerCase()}`},s=(x,X)=>(x.set(n(X),X),x),i=l.reduce(s,new Map),o=c.reduce(s,new Map),a=c.reduce((x,X)=>s(x,(0,_.deepClone)(X)),new Map),y=p?p.reduce(s,new Map):null,I=g.reduce(s,new Map),w=u.reduce((x,X)=>{const B=t.get(X.toLowerCase());return x.add(B?`uuid:${B}`:`id:${X.toLowerCase()}`)},new Set),b=h?h.reduce((x,{id:X,uuid:B})=>(B=B??t.get(X.toLowerCase()),x.add(B?`uuid:${B}`:`id:${X.toLowerCase()}`)),new Set):null,D=k(i,o,w,!1);if(D.added.size>0||D.removed.size>0||D.updated.size>0){const x=k(y,i,w,!1),X=k(y,o,w,!0),B=(Y,z,H,V)=>{let q,ie,re;return z.installed?(q=V.pinned,re=V.preRelease,q&&(ie=V.version)):(q=H.pinned,re=H.preRelease,q&&(ie=H.version)),q===void 0&&(q=z.pinned,q&&(ie=z.version)),re===void 0&&(re=z.preRelease),{...V,installed:z.installed||H.installed,pinned:q,preRelease:re,version:ie??(H.version&&(!z.installed||U.gt(H.version,z.version))?H.version:z.version),state:P(z,H,y?.get(Y))}};for(const Y of X.removed.values()){const z=i.get(Y);if(!z)continue;const H=(0,A.assertIsDefined)(y?.get(Y)),V=b&&!b.has(Y)&&H.installed;z.installed&&V?f.push(z.identifier):a.set(Y,z)}for(const Y of X.added.values()){const z=(0,A.assertIsDefined)(o.get(Y)),H=i.get(Y);if(H){if(D.updated.has(Y)){const V=B(Y,H,z,z);R(H,z,!1,!1)||S.push(v(V,Y)),a.set(Y,V)}}else z.installed&&m.push(v(z,Y))}for(const Y of X.updated.values()){const z=(0,A.assertIsDefined)(o.get(Y)),H=(0,A.assertIsDefined)(y?.get(Y)),V=i.get(Y);if(V)if(b&&!b.has(Y)&&H.installed&&V.installed&&!z.installed)f.push(V.identifier);else{const ie=B(Y,V,z,z);S.push(v(ie,Y)),a.set(Y,ie)}else z.installed&&m.push(v(z,Y))}for(const Y of x.added.values())X.added.has(Y)||a.set(Y,(0,A.assertIsDefined)(i.get(Y)));for(const Y of x.updated.values()){if(X.removed.has(Y)||X.updated.has(Y))continue;const z=(0,A.assertIsDefined)(i.get(Y)),H=(0,A.assertIsDefined)(o.get(Y));a.set(Y,B(Y,z,H,z))}for(const Y of x.removed.values())X.updated.has(Y)||X.removed.has(Y)||I.has(Y)||(0,A.assertIsDefined)(o.get(Y)).installed&&b&&(b.has(Y)||!(0,A.assertIsDefined)(y?.get(Y)).installed||a.delete(Y))}const L=[],N=k(o,a,new Set,!0),F=N.added.size>0||N.updated.size>0||N.removed.size>0;return F&&a.forEach((x,X)=>L.push(v(x,X))),{local:{added:m,removed:f,updated:S},remote:F?{added:[...N.added].map(x=>a.get(x)),updated:[...N.updated].map(x=>a.get(x)),removed:[...N.removed].map(x=>o.get(x)),all:L}:null}}function k(l,c,p,g){const u=l?[...l.keys()].filter(t=>!p.has(t)):[],h=[...c.keys()].filter(t=>!p.has(t)),m=h.filter(t=>!u.includes(t)).reduce((t,r)=>(t.add(r),t),new Set),f=u.filter(t=>!h.includes(t)).reduce((t,r)=>(t.add(r),t),new Set),S=new Set;for(const t of u){if(f.has(t))continue;const r=l.get(t),n=c.get(t);(!n||!R(r,n,g,!0))&&S.add(t)}return{added:m,removed:f,updated:S}}function R(l,c,p,g){return!(l.disabled!==c.disabled||!!l.isApplicationScoped!=!!c.isApplicationScoped||g&&l.installed!==c.installed||l.installed&&c.installed&&(l.preRelease!==c.preRelease||l.pinned!==c.pinned||c.pinned&&l.version!==c.version)||!C(l.state,c.state)||p&&l.version!==c.version)}function P(l,c,p){const g=l.state,u=c.state,h=p?.state;if(!c.version||g&&U.gt(l.version,c.version))return g;if(u&&U.gt(c.version,l.version)||!g)return u;if(!u)return g;const m=(0,_.deepClone)(g),f=h?d(h,u):{added:Object.keys(u).reduce((t,r)=>(t.add(r),t),new Set),removed:new Set,updated:new Set},S=h?d(h,g):{added:Object.keys(g).reduce((t,r)=>(t.add(r),t),new Set),removed:new Set,updated:new Set};for(const t of[...f.added.values(),...f.updated.values()])m[t]=u[t];for(const t of f.removed.values())S.updated.has(t)||delete m[t];return m}function d(l,c){const p=Object.keys(l),g=Object.keys(c),u=g.filter(f=>!p.includes(f)).reduce((f,S)=>(f.add(S),f),new Set),h=p.filter(f=>!g.includes(f)).reduce((f,S)=>(f.add(S),f),new Set),m=new Set;for(const f of p){if(h.has(f))continue;const S=l[f],t=c[f];(0,_.equals)(S,t)||m.add(f)}return{added:u,removed:h,updated:m}}function C(l={},c={}){const{added:p,removed:g,updated:u}=d(l,c);return p.size===0&&g.size===0&&u.size===0}function E(l){return{...l,disabled:!!l.disabled,installed:!!l.installed}}function v(l,c){const p={...l,identifier:{id:l.identifier.id,uuid:c.startsWith("uuid:")?c.substring(5):void 0},preRelease:!!l.preRelease,pinned:!!l.pinned};return l.disabled||delete p.disabled,l.installed||delete p.installed,l.state||delete p.state,l.isApplicationScoped||delete p.isApplicationScoped,p}}),define(ae[111],ce([0,1,17,21,4]),function(ne,e,_,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,A.createDecorator)("IIgnoredExtensionsManagementService");let O=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,P){let d=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return d=d.filter(C=>C!==R&&C!==`-${R}`),P&&d.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}updateSynchronizedExtensions(R,P){let d=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return d=d.filter(C=>C!==R&&C!==`-${R}`),P&&d.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}getIgnoredExtensions(R){const P=R.filter(v=>v.isMachineScoped).map(v=>v.identifier.id.toLowerCase()),d=this.getConfiguredIgnoredExtensions().map(v=>v.toLowerCase()),C=[],E=[];if(Array.isArray(d))for(const v of d)v.startsWith("-")?E.push(v.substring(1)):C.push(v);return(0,_.distinct)([...P,...C].filter(v=>!E.includes(v)))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};e.IgnoredExtensionsManagementService=O,e.IgnoredExtensionsManagementService=O=Ce([K(0,U.IConfigurationService)],O)}),define(ae[242],ce([0,1,17,35,30,93,79]),function(ne,e,_,U,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=P;function R(f){return(0,U.parse)(f)||[]}async function P(f,S,t,r,n){const s=R(f),i=R(S),o=t?R(t):null,a=[...s,...i,...o||[]].map(B=>B.key),y=await n.resolveUserBindings(a),I=C(s,i,o,y);if(!I.hasLocalForwarded&&!I.hasRemoteForwarded)return{mergeContent:f,hasChanges:!1,hasConflicts:!1};if(!I.hasLocalForwarded&&I.hasRemoteForwarded)return{mergeContent:S,hasChanges:!0,hasConflicts:!1};if(I.hasLocalForwarded&&!I.hasRemoteForwarded)return{mergeContent:f,hasChanges:!0,hasConflicts:!1};const w=v(s),b=v(i),D=o?v(o):null,L=c(w,b,y),N=D?c(D,w,y):{added:[...w.keys()].reduce((B,Y)=>(B.add(Y),B),new Set),removed:new Set,updated:new Set},F=D?c(D,b,y):{added:[...b.keys()].reduce((B,Y)=>(B.add(Y),B),new Set),removed:new Set,updated:new Set},x=d(L,N,F);let X=f;for(const B of x.removed.values())x.conflicts.has(B)||(X=h(X,B,r));for(const B of x.added.values()){if(x.conflicts.has(B))continue;const Y=b.get(B);if(Y.some(z=>z.command!==`-${B}`&&I.conflicts.has(y[z.key]))){x.conflicts.add(B);continue}X=u(X,Y,r)}for(const B of x.updated.values()){if(x.conflicts.has(B))continue;const Y=b.get(B);if(Y.some(z=>z.command!==`-${B}`&&I.conflicts.has(y[z.key]))){x.conflicts.add(B);continue}X=m(X,B,Y,r)}return{mergeContent:X,hasChanges:!0,hasConflicts:x.conflicts.size>0}}function d(f,S,t){const r=new Set,n=new Set,s=new Set,i=new Set;for(const o of S.removed.values())t.updated.has(o)&&i.add(o);for(const o of t.removed.values())i.has(o)||(S.updated.has(o)?i.add(o):n.add(o));for(const o of S.added.values())i.has(o)||t.added.has(o)&&f.updated.has(o)&&i.add(o);for(const o of t.added.values())i.has(o)||(S.added.has(o)?f.updated.has(o)&&i.add(o):r.add(o));for(const o of S.updated.values())i.has(o)||t.updated.has(o)&&f.updated.has(o)&&i.add(o);for(const o of t.updated.values())i.has(o)||(S.updated.has(o)?f.updated.has(o)&&i.add(o):s.add(o));return{added:r,removed:n,updated:s,conflicts:i}}function C(f,S,t,r){const n=new Set,s=E(f,r),i=E(S,r),o=t?E(t,r):null,a=l(s,i);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const y=o?l(o,s):{added:[...s.keys()].reduce((N,F)=>(N.add(F),N),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const I=o?l(o,i):{added:[...i.keys()].reduce((N,F)=>(N.add(F),N),new Set),removed:new Set,updated:new Set};if(I.added.size===0&&I.removed.size===0&&I.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:w,removed:b,updated:D,conflicts:L}=d(a,y,I);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:w,removed:b,updated:D,conflicts:L}}function E(f,S){const t=new Map;for(const r of f){const n=S[r.key];let s=t.get(n);s||(s=[],t.set(n,s)),s.push(r)}return t}function v(f){const S=new Map;for(const t of f){const r=t.command[0]==="-"?t.command.substring(1):t.command;let n=S.get(r);n||(n=[],S.set(r,n)),n.push(t)}return S}function l(f,S){const t=[...f.keys()],r=[...S.keys()],n=r.filter(o=>!t.includes(o)).reduce((o,a)=>(o.add(a),o),new Set),s=t.filter(o=>!r.includes(o)).reduce((o,a)=>(o.add(a),o),new Set),i=new Set;for(const o of t){if(s.has(o))continue;const a=f.get(o).map(I=>({...I,key:o})),y=S.get(o).map(I=>({...I,key:o}));(0,_.equals)(a,y,(I,w)=>g(I,w))||i.add(o)}return{added:n,removed:s,updated:i}}function c(f,S,t){const r=[...f.keys()],n=[...S.keys()],s=n.filter(a=>!r.includes(a)).reduce((a,y)=>(a.add(y),a),new Set),i=r.filter(a=>!n.includes(a)).reduce((a,y)=>(a.add(y),a),new Set),o=new Set;for(const a of r){if(i.has(a))continue;const y=f.get(a).map(w=>({...w,key:t[w.key]})),I=S.get(a).map(w=>({...w,key:t[w.key]}));p(y,I)||o.add(a)}return{added:s,removed:i,updated:o}}function p(f,S){return!(!(0,_.equals)(f.filter(({command:t})=>t[0]!=="-"),S.filter(({command:t})=>t[0]!=="-"),(t,r)=>g(t,r))||!(0,_.equals)(f.filter(({command:t})=>t[0]==="-"),S.filter(({command:t})=>t[0]==="-"),(t,r)=>g(t,r)))}function g(f,S){if(f.command!==S.command||f.key!==S.key)return!1;const t=O.ContextKeyExpr.deserialize(f.when),r=O.ContextKeyExpr.deserialize(S.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!A.equals(f.args,S.args))}function u(f,S,t){for(const r of S)f=k.edit(f,[-1],r,t);return f}function h(f,S,t){const r=R(f);for(let n=r.length-1;n>=0;n--)(r[n].command===S||r[n].command===`-${S}`)&&(f=k.edit(f,[n],void 0,t));return f}function m(f,S,t,r){const n=R(f),s=n.findIndex(i=>i.command===S||i.command===`-${S}`);for(let i=n.length-1;i>=0;i--)(n[i].command===S||n[i].command===`-${S}`)&&(f=k.edit(f,[i],void 0,r));for(let i=t.length-1;i>=0;i--)f=k.edit(f,[s],t[i],r);return f}}),define(ae[243],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=_,e.areSame=A;function _(O,k,R){const P={},d={},C=new Set;if(!k)return{local:{added:P,updated:d,removed:[...C.values()]},remote:{added:O,updated:{},removed:[]},conflicts:[]};const E=U(O,k);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:P,updated:d,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const v=U(R,O),l=U(R,k),c={},p={},g=new Set,u=new Set;for(const h of v.removed.values())l.updated.has(h)?P[h]=k[h]:g.add(h);for(const h of l.removed.values())u.has(h)||(v.updated.has(h)?u.add(h):C.add(h));for(const h of v.updated.values())u.has(h)||(l.updated.has(h)?E.updated.has(h)&&u.add(h):p[h]=O[h]);for(const h of l.updated.values())u.has(h)||(v.updated.has(h)?E.updated.has(h)&&u.add(h):O[h]!==void 0&&(d[h]=k[h]));for(const h of v.added.values())u.has(h)||(l.added.has(h)?E.updated.has(h)&&u.add(h):c[h]=O[h]);for(const h of l.added.values())u.has(h)||(v.added.has(h)?E.updated.has(h)&&u.add(h):P[h]=k[h]);return{local:{added:P,removed:[...C.values()],updated:d},remote:{added:c,removed:[...g.values()],updated:p},conflicts:[...u.values()]}}function U(O,k){const R=O?Object.keys(O):[],P=k?Object.keys(k):[],d=P.filter(v=>!R.includes(v)).reduce((v,l)=>(v.add(l),v),new Set),C=R.filter(v=>!P.includes(v)).reduce((v,l)=>(v.add(l),v),new Set),E=new Set;for(const v of R){if(C.has(v))continue;const l=O[v],c=k[v];l!==c&&E.add(v)}return{added:d,removed:C,updated:E}}function A(O,k){const{added:R,removed:P,updated:d}=U(O,k);return R.size===0&&P.size===0&&d.size===0}}),define(ae[244],ce([0,1,30]),function(ne,e,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=U;function U(O,k,R,P){const d={added:[],removed:[],updated:[]};let C={added:[],removed:[],updated:[]};if(!k){const v=O.filter(({id:l})=>!P.includes(l));return v.length?C.added=v:C=null,{local:d,remote:C}}const E=A(O,k,P);if(E.added.length>0||E.removed.length>0||E.updated.length>0){const v=A(R,O,P),l=A(R,k,P);for(const c of l.removed){const p=O.find(g=>g.id===c);p&&d.removed.push(p)}for(const c of l.added){const p=k.find(g=>g.id===c);v.added.includes(c)?E.updated.includes(c)&&d.updated.push(p):d.added.push(p)}for(const c of l.updated)d.updated.push(k.find(p=>p.id===c));for(const c of v.added)l.added.includes(c)||C.added.push(O.find(p=>p.id===c));for(const c of v.updated)l.removed.includes(c)||l.updated.includes(c)||C.updated.push(O.find(p=>p.id===c));for(const c of v.removed){const p=k.find(g=>g.id===c);p&&C.removed.push(p)}}return C.added.length===0&&C.removed.length===0&&C.updated.length===0&&(C=null),{local:d,remote:C}}function A(O,k,R){O=O?O.filter(({id:l})=>!R.includes(l)):[],k=k.filter(({id:l})=>!R.includes(l));const P=O.map(({id:l})=>l),d=k.map(({id:l})=>l),C=d.filter(l=>!P.includes(l)),E=P.filter(l=>!d.includes(l)),v=[];for(const{id:l,name:c,shortName:p,icon:g,useDefaultFlags:u}of O){if(E.includes(l))continue;const h=k.find(m=>m.id===l);(!h||h.name!==c||h.shortName!==p||h.icon!==g||!(0,_.equals)(h.useDefaultFlags,u))&&v.push(l)}return{added:C,removed:E,updated:v}}}),define(ae[25],ce([0,1,17,13,179,47,29,4,101,43]),function(ne,e,_,U,A,O,k,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncLocalStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.ALL_SYNC_RESOURCES=e.SyncResource=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=void 0,e.getDisallowedIgnoredSettings=C,e.getDefaultIgnoredSettings=E,e.registerConfiguration=v,e.isAuthenticationProvider=l,e.getPathSegments=p,e.getLastSyncResourceUri=g,e.createSyncHeaders=u,e.getEnablementKey=s;function C(){const i=d.Registry.as(O.Extensions.Configuration).getConfigurationProperties();return Object.keys(i).filter(o=>!!i[o].disallowSyncIgnore)}function E(){const i=d.Registry.as(O.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(i).filter(I=>!!i[I].ignoreSync),a=Object.keys(i).filter(I=>i[I].scope===2||i[I].scope===6),y=C();return(0,_.distinct)([...o,...a,...y])}e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function v(){const i="vscode://schemas/ignoredSettings",o=d.Registry.as(O.Extensions.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:k.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:i,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=d.Registry.as(P.Extensions.JSONContribution),y=()=>{const I=C(),w=E(),b=Object.keys(O.allSettings.properties).filter(N=>!w.includes(N)),D=w.filter(N=>!I.includes(N)),L={items:{type:"string",enum:[...b,...D.map(N=>`-${N}`)]}};a.registerSchema(i,L)};return o.onDidUpdateConfiguration(()=>y())}function l(i){return i&&(0,U.isObject)(i)&&(0,U.isString)(i.id)&&Array.isArray(i.scopes)}var c;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState",i.Profiles="profiles",i.WorkspaceState="workspaceState"})(c||(e.SyncResource=c={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(i,...o){return i?[i,...o]:o}function g(i,o,a,y){return y.joinPath(a.userDataSyncHome,...p(i,o,`lastSync${o}.json`))}e.IUserDataSyncStoreManagementService=(0,R.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,R.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncLocalStoreService=(0,R.createDecorator)("IUserDataSyncLocalStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function u(i){const o={};return o[e.HEADER_EXECUTION_ID]=i,o}var h;(function(i){i.Unauthorized="Unauthorized",i.Forbidden="Forbidden",i.NotFound="NotFound",i.MethodNotFound="MethodNotFound",i.Conflict="Conflict",i.Gone="Gone",i.PreconditionFailed="PreconditionFailed",i.TooLarge="TooLarge",i.UpgradeRequired="UpgradeRequired",i.PreconditionRequired="PreconditionRequired",i.TooManyRequests="RemoteTooManyRequests",i.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",i.RequestFailed="RequestFailed",i.RequestCanceled="RequestCanceled",i.RequestTimeout="RequestTimeout",i.RequestProtocolNotSupported="RequestProtocolNotSupported",i.RequestPathNotEscaped="RequestPathNotEscaped",i.RequestHeadersNotObject="RequestHeadersNotObject",i.NoCollection="NoCollection",i.NoRef="NoRef",i.EmptyResponse="EmptyResponse",i.TurnedOff="TurnedOff",i.SessionExpired="SessionExpired",i.ServiceChanged="ServiceChanged",i.DefaultServiceChanged="DefaultServiceChanged",i.LocalTooManyProfiles="LocalTooManyProfiles",i.LocalTooManyRequests="LocalTooManyRequests",i.LocalPreconditionFailed="LocalPreconditionFailed",i.LocalInvalidContent="LocalInvalidContent",i.LocalError="LocalError",i.IncompatibleLocalContent="IncompatibleLocalContent",i.IncompatibleRemoteContent="IncompatibleRemoteContent",i.Unknown="Unknown"})(h||(e.UserDataSyncErrorCode=h={}));class m extends Error{constructor(o,a,y,I){super(o),this.code=a,this.resource=y,this.operationId=I,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=m;class f extends m{constructor(o,a,y,I,w){super(o,y,void 0,w),this.url=a,this.serverCode=I}}e.UserDataSyncStoreError=f;class S extends m{constructor(o,a){super(o,a)}}e.UserDataAutoSyncError=S,function(i){function o(a){if(a instanceof i)return a;const y=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(y&&y[1]){const I=y[2]==="unknown"?void 0:y[2],w=y[3]==="unknown"?void 0:y[3];return new i(a.message,y[1],I,w)}return new i(a.message,"Unknown")}i.toUserDataSyncError=o}(m||(e.UserDataSyncError=m={}));var t;(function(i){i.Uninitialized="uninitialized",i.Idle="idle",i.Syncing="syncing",i.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var r;(function(i){i[i.None=0]="None",i[i.Added=1]="Added",i[i.Modified=2]="Modified",i[i.Deleted=3]="Deleted"})(r||(e.Change=r={}));var n;(function(i){i.Preview="preview",i.Conflict="conflict",i.Accepted="accepted"})(n||(e.MergeState=n={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function s(i){return`sync.enable.${i}`}e.IUserDataSyncEnablementService=(0,R.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,R.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,R.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,R.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,R.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,R.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(ae[245],ce([0,1,30,25]),function(ne,e,_,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=A;function A(k,R,P,d,C){if(!R)return{remote:{added:Object.keys(k),removed:[],updated:[],all:Object.keys(k).length>0?k:null},local:{added:{},removed:[],updated:{}}};const E=O(k,R);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const v=P?O(P,R):{added:Object.keys(R).reduce((h,m)=>(h.add(m),h),new Set),removed:new Set,updated:new Set},l=P?O(P,k):{added:Object.keys(k).reduce((h,m)=>(h.add(m),h),new Set),removed:new Set,updated:new Set},c={added:{},removed:[],updated:{}},p=_.deepClone(R),g=!P;for(const h of l.added.values())h!==U.SYNC_SERVICE_URL_TYPE&&g&&v.added.has(h)||(p[h]=k[h]);for(const h of l.updated.values())p[h]=k[h];for(const h of l.removed.values())d.unregistered.includes(h)||delete p[h];for(const h of v.added.values()){const m=R[h];if(d.machine.includes(h)){C.info(`GlobalState: Skipped adding ${h} in local storage because it is declared as machine scoped.`);continue}if(P&&l.added.has(h))continue;const f=k[h];f&&f.value===m.value||h===U.SYNC_SERVICE_URL_TYPE&&g&&l.added.has(h)||(f?c.updated[h]=m:c.added[h]=m)}for(const h of v.updated.values()){const m=R[h];if(d.machine.includes(h)){C.info(`GlobalState: Skipped updating ${h} in local storage because it is declared as machine scoped.`);continue}if(l.updated.has(h)||l.removed.has(h))continue;const f=k[h];f&&f.value===m.value||(c.updated[h]=m)}for(const h of v.removed.values()){if(d.machine.includes(h)){C.trace(`GlobalState: Skipped removing ${h} in local storage because it is declared as machine scoped.`);continue}l.updated.has(h)||l.removed.has(h)||c.removed.push(h)}const u=O(R,p);return{local:c,remote:{added:[...u.added],updated:[...u.updated],removed:[...u.removed],all:u.added.size===0&&u.removed.size===0&&u.updated.size===0?null:p}}}function O(k,R){const P=Object.keys(k),d=Object.keys(R),C=d.filter(l=>!P.includes(l)).reduce((l,c)=>(l.add(c),l),new Set),E=P.filter(l=>!d.includes(l)).reduce((l,c)=>(l.add(c),l),new Set),v=new Set;for(const l of P){if(E.has(l))continue;const c=k[l],p=R[l];_.equals(c,p)||v.add(l)}return{added:C,removed:E,updated:v}}}),define(ae[246],ce([0,1,17,35,62,44,30,79,25]),function(ne,e,_,U,A,O,k,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getIgnoredSettings=d,e.removeComments=v,e.updateIgnoredSettings=l,e.merge=c,e.isEmpty=g,e.addSetting=h;function d(a,y,I){let w=[];I?w=E(I):w=C(y);const b=[],D=[...(0,P.getDisallowedIgnoredSettings)()];if(Array.isArray(w))for(const L of w)L.startsWith("-")?D.push(L.substring(1)):b.push(L);return(0,_.distinct)([...a,...b].filter(L=>!D.includes(L)))}function C(a){let y=a.inspect("settingsSync.ignoredSettings").userValue;return y!==void 0||(y=a.inspect("sync.ignoredSettings").userValue,y!==void 0)?y:a.getValue("settingsSync.ignoredSettings")||[]}function E(a){const y=(0,U.parse)(a);return y?y["settingsSync.ignoredSettings"]||y["sync.ignoredSettings"]||[]:[]}function v(a,y){const I=(0,U.parse)(a)||{};let w="{}";for(const b of Object.keys(I)){const D=(0,A.setProperty)(w,[b],I[b],y);w=(0,A.applyEdits)(w,D)}return w}function l(a,y,I,w){if(I.length){const b=o(y),D=(0,U.parse)(y)||{},L=(0,U.parse)(a);if(!L)return a;const N=[];for(const F of I){const x=D[F],X=L[F];x===void 0?a=R.edit(a,[F],void 0,w):X!==void 0?a=R.edit(a,[F],x,w):N.push(t(F,b))}N.sort((F,x)=>F.startOffset-x.startOffset),N.forEach(F=>a=h(F.setting.key,y,a,w))}return a}function c(a,y,I,w,b,D){const L=l(a,y,w,D),N=I!==L,F=I!==y;if(!N&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(N&&!F)return{conflictsSettings:[],localContent:null,remoteContent:L,hasConflicts:!1};if(F&&!N)return{conflictsSettings:[],localContent:l(y,a,w,D),remoteContent:null,hasConflicts:!1};if(I===null&&g(a)){const M=p(a,y,w)?null:l(y,a,w,D);return{conflictsSettings:[],localContent:M,remoteContent:null,hasConflicts:!1}}let x=a,X=y;const B=(0,U.parse)(a),Y=(0,U.parse)(y),z=I?(0,U.parse)(I):null,H=w.reduce((M,$)=>(M.add($),M),new Set),V=u(B,Y,H),q=u(z,B,H),ie=u(z,Y,H),re=new Map,ue=new Set,te=M=>{ue.add(M);const $=b.filter(({key:Q})=>Q===M)[0];$?(x=R.edit(x,[M],$.value,D),X=R.edit(X,[M],$.value,D)):re.set(M,{key:M,localValue:B[M],remoteValue:Y[M]})};for(const M of q.removed.values())ie.updated.has(M)?te(M):X=R.edit(X,[M],void 0,D);for(const M of ie.removed.values())ue.has(M)||(q.updated.has(M)?te(M):x=R.edit(x,[M],void 0,D));for(const M of q.updated.values())ue.has(M)||(ie.updated.has(M)?V.updated.has(M)&&te(M):X=R.edit(X,[M],B[M],D));for(const M of ie.updated.values())ue.has(M)||(q.updated.has(M)?V.updated.has(M)&&te(M):x=R.edit(x,[M],Y[M],D));for(const M of q.added.values())ue.has(M)||(ie.added.has(M)?V.updated.has(M)&&te(M):X=h(M,x,X,D));for(const M of ie.added.values())ue.has(M)||(q.added.has(M)?V.updated.has(M)&&te(M):x=h(M,X,x,D));const j=re.size>0||!p(x,X,w),W=j||!p(x,a,[]),T=j||!p(X,y,[]);return{localContent:W?x:null,remoteContent:T?X:null,conflictsSettings:[...re.values()],hasConflicts:j}}function p(a,y,I){if(a===y)return!0;const w=(0,U.parse)(a),b=(0,U.parse)(y),D=I.reduce((F,x)=>(F.add(x),F),new Set),L=o(a).filter(F=>!(F.setting&&D.has(F.setting.key))),N=o(y).filter(F=>!(F.setting&&D.has(F.setting.key)));if(L.length!==N.length)return!1;for(let F=0;F<L.length;F++){const x=L[F],X=N[F];if(x.setting&&X.setting){if(x.setting.key!==X.setting.key||!k.equals(w[x.setting.key],b[x.setting.key]))return!1}else if(!x.setting&&!X.setting){if(x.value!==X.value)return!1}else return!1}return!0}function g(a){return a?o(a).length===0:!0}function u(a,y,I){const w=a?Object.keys(a).filter(F=>!I.has(F)):[],b=Object.keys(y).filter(F=>!I.has(F)),D=b.filter(F=>!w.includes(F)).reduce((F,x)=>(F.add(x),F),new Set),L=w.filter(F=>!b.includes(F)).reduce((F,x)=>(F.add(x),F),new Set),N=new Set;if(a)for(const F of w){if(L.has(F))continue;const x=a[F],X=y[F];k.equals(x,X)||N.add(F)}return{added:D,removed:L,updated:N}}function h(a,y,I,w){const b=(0,U.parse)(y),D=o(y),L=o(I),N=m(a,D,L);return f(I,a,b[a],N,L,w)}function m(a,y,I){const w=y.findIndex(D=>D.setting?.key===a),b=y[w-1];if(b){if(b.setting){const L=t(b.setting.key,I);if(L)return{index:I.indexOf(L),insertAfter:!0}}else{const L=r(w,y);if(L){const N=t(L.setting.key,I);if(N){const F=n(I.indexOf(N),I),x=s(y,L,y[w]);if(F){const X=s(I,N,F),B=i(x,X);return B?{index:I.indexOf(B),insertAfter:!0}:{index:I.indexOf(F),insertAfter:!1}}else{const X=s(I,N,I[I.length-1]),B=i(x,X);return B?{index:I.indexOf(B),insertAfter:!0}:{index:I.length-1,insertAfter:!0}}}}}const D=y[w+1];if(D)if(D.setting){const L=t(D.setting.key,I);if(L)return{index:I.indexOf(L),insertAfter:!1}}else{const L=n(w,y);if(L){const N=t(L.setting.key,I);if(N){const F=r(I.indexOf(N),I),x=s(y,y[w],L);if(F){const X=s(I,F,N),B=i(x.reverse(),X.reverse());return B?{index:I.indexOf(B),insertAfter:!1}:{index:I.indexOf(F),insertAfter:!0}}else{const X=s(I,I[0],N),B=i(x.reverse(),X.reverse());return B?{index:I.indexOf(B),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:I.length-1,insertAfter:!0}}function f(a,y,I,w,b,D){let L;return w.index===-1?L=(0,A.setProperty)(a,[y],I,D):L=S(a,y,I,w,b,D).map(N=>(0,A.withFormatting)(a,N,D)[0]),(0,A.applyEdits)(a,L)}function S(a,y,I,w,b,D){const L=`${JSON.stringify(y)}: ${JSON.stringify(I)}`,N=(0,O.getEOL)(D,a),F=b[w.index];if(w.insertAfter){const x=[];if(F.setting)x.push({offset:F.endOffset,length:0,content:","+L});else{const X=n(w.index,b),B=r(w.index,b),Y=B?.setting?.commaOffset;B&&Y===void 0&&x.push({offset:B.endOffset,length:0,content:","});const z=Y!==void 0&&Y>F.endOffset;x.push({offset:z?Y+1:F.endOffset,length:0,content:X?N+L+",":N+L})}return x}else{if(F.setting)return[{offset:F.startOffset,length:0,content:L+","}];const x=(b[w.index-1]&&!b[w.index-1].setting?N:"")+L+(n(w.index,b)?",":"")+N;return[{offset:F.startOffset,length:0,content:x}]}}function t(a,y){return y.filter(I=>I.setting?.key===a)[0]}function r(a,y){for(let I=a-1;I>=0;I--)if(y[I].setting)return y[I]}function n(a,y){for(let I=a+1;I<y.length;I++)if(y[I].setting)return y[I]}function s(a,y,I){const w=a.indexOf(y),b=a.indexOf(I);return a.filter((D,L)=>w<L&&L<b)}function i(a,y){if(a.length&&y.length){let I=0;for(;I<y.length&&I<a.length;I++)if(a[I].value!==y[I].value)return y[I-1];return y[I-1]}}function o(a){const y=[];let I=-1,w,b;const D={onObjectBegin:L=>{I++},onObjectProperty:(L,N,F)=>{I===0&&(w=N,b=L)},onObjectEnd:(L,N)=>{I--,I===0&&y.push({startOffset:w,endOffset:L+N,value:a.substring(w,L+N),setting:{key:b,commaOffset:void 0}})},onArrayBegin:(L,N)=>{I++},onArrayEnd:(L,N)=>{I--,I===0&&y.push({startOffset:w,endOffset:L+N,value:a.substring(w,L+N),setting:{key:b,commaOffset:void 0}})},onLiteralValue:(L,N,F)=>{I===0&&y.push({startOffset:w,endOffset:N+F,value:a.substring(w,N+F),setting:{key:b,commaOffset:void 0}})},onSeparator:(L,N,F)=>{if(I===0&&L===","){let x=y.length-1;for(;x>=0&&!y[x].setting;x--);const X=y[x];X&&y.splice(x,1,{startOffset:X.startOffset,endOffset:X.endOffset,value:X.value,setting:{key:X.setting.key,commaOffset:N}})}},onComment:(L,N)=>{I===0&&y.push({startOffset:L,endOffset:L+N,value:a.substring(L,L+N)})}};return(0,U.visit)(a,D),y}}),define(ae[80],ce([0,1,3,2,4,25]),function(ne,e,_,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,A.createDecorator)("IUserDataSyncAccountService");let k=class extends U.Disposable{get account(){return this._account}constructor(P,d){super(),this.userDataSyncStoreService=P,this.logService=d,this._onDidChangeAccount=this._register(new _.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new _.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(P.onTokenFailed(C=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed,C),this.updateAccount(void 0),C==="Forbidden"?this._onTokenFailed.fire(!0):this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(P.onTokenSucceed(()=>this.wasTokenFailed=!1))}async updateAccount(P){(P&&this._account?P.token!==this._account.token||P.authenticationProviderId!==this._account.authenticationProviderId:P!==this._account)&&(this._account=P,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(P))}};e.UserDataSyncAccountService=k,e.UserDataSyncAccountService=k=Ce([K(0,O.IUserDataSyncStoreService),K(1,O.IUserDataSyncLogService)],k)}),define(ae[247],ce([0,1,20,180,16,9,25]),function(ne,e,_,U,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends O.AbstractLogger{constructor(d,C){super(),this.logger=this._register(d.createLogger((0,_.joinPath)(C.logsHome,`${k.USER_DATA_SYNC_LOG_ID}.log`),{id:k.USER_DATA_SYNC_LOG_ID,name:(0,U.localize)(0,null)}))}trace(d,...C){this.logger.trace(d,...C)}debug(d,...C){this.logger.debug(d,...C)}info(d,...C){this.logger.info(d,...C)}warn(d,...C){this.logger.warn(d,...C)}error(d,...C){this.logger.error(d,...C)}flush(){this.logger.flush()}};e.UserDataSyncLogService=R,e.UserDataSyncLogService=R=Ce([K(0,O.ILoggerService),K(1,A.IEnvironmentService)],R)}),define(ae[248],ce([0,1,6,3,2]),function(ne,e,_,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class O extends A.Disposable{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:P,getActiveWindowId:d}){super(),this.disposables=this._register(new A.DisposableStore),U.Event.latch(U.Event.any(R,P))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,_.createCancelablePromise)(()=>d()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=O}),define(ae[112],ce([0,1,183,14,51,20,8,4,23]),function(ne,e,_,U,A,O,k,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.STANDALONE_EDITOR_WORKSPACE_ID=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.WorkspaceFolder=e.Workspace=e.WorkbenchState=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.IWorkspaceContextService=void 0,e.isSingleFolderWorkspaceIdentifier=d,e.isEmptyWorkspaceIdentifier=C,e.toWorkspaceIdentifier=E,e.isWorkspaceIdentifier=v,e.reviveIdentifier=l,e.isWorkspace=p,e.isWorkspaceFolder=g,e.toWorkspaceFolder=m,e.isUntitledWorkspace=f,e.isTemporaryWorkspace=S,e.isStandaloneEditorWorkspace=t,e.isSavedWorkspace=r,e.hasWorkspaceFileExtension=n,e.IWorkspaceContextService=(0,R.createDecorator)("contextService");function d(s){const i=s;return typeof i?.id=="string"&&k.URI.isUri(i.uri)}function C(s){return typeof s?.id=="string"&&!d(s)&&!v(s)}e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function E(s,i){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,U.basename)(s)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=s;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function v(s){const i=s;return typeof i?.id=="string"&&k.URI.isUri(i.configPath)}function l(s){const i=s;if(i?.uri)return{id:i.id,uri:k.URI.revive(i.uri)};const o=s;if(o?.configPath)return{id:o.id,configPath:k.URI.revive(o.configPath)};if(s?.id)return{id:s.id}}var c;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(c||(e.WorkbenchState=c={}));function p(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}function g(s){const i=s;return!!(i&&typeof i=="object"&&k.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}class u{constructor(i,o,a,y,I){this._id=i,this._transient=a,this._configuration=y,this._ignorePathCasing=I,this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=A.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=u;class h{constructor(i,o){this.raw=o,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,O.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function m(s){return new h({uri:s,index:0,name:(0,O.basenameOrAuthority)(s)},{uri:s.toString()})}e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,_.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function f(s,i){return O.extUriBiasedIgnorePathCase.isEqualOrParent(s,i.untitledWorkspacesHome)}function S(s){let i;return k.URI.isUri(s)?i=s:i=s.configuration,i?.scheme===P.Schemas.tmp}e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.STANDALONE_EDITOR_WORKSPACE_ID}function r(s,i){return!f(s,i)&&!S(s)}function n(s){return(typeof s=="string"?(0,U.extname)(s):(0,O.extname)(s))===e.WORKSPACE_SUFFIX}}),define(ae[18],ce([0,1,54,3,2,20,8,174,16,12,4,9,112,34,28,6,32,27,13]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.IUserDataProfilesService=e.ProfileResourceType=void 0,e.isUserDataProfile=f,e.reviveProfile=S,e.toUserDataProfile=t;var m;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(m||(e.ProfileResourceType=m={}));function f(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&k.URI.isUri(i.location)&&k.URI.isUri(i.globalStorageHome)&&k.URI.isUri(i.settingsResource)&&k.URI.isUri(i.keybindingsResource)&&k.URI.isUri(i.tasksResource)&&k.URI.isUri(i.snippetsHome)&&k.URI.isUri(i.extensionsResource))}e.IUserDataProfilesService=(0,C.createDecorator)("IUserDataProfilesService");function S(s,i){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:k.URI.revive(s.location).with({scheme:i}),globalStorageHome:k.URI.revive(s.globalStorageHome).with({scheme:i}),settingsResource:k.URI.revive(s.settingsResource).with({scheme:i}),keybindingsResource:k.URI.revive(s.keybindingsResource).with({scheme:i}),tasksResource:k.URI.revive(s.tasksResource).with({scheme:i}),snippetsHome:k.URI.revive(s.snippetsHome).with({scheme:i}),extensionsResource:k.URI.revive(s.extensionsResource).with({scheme:i}),cacheHome:k.URI.revive(s.cacheHome).with({scheme:i}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function t(s,i,o,a,y,I){return{id:s,name:i,location:o,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:I&&y?.useDefaultFlags?.globalState?I.globalStorageHome:(0,O.joinPath)(o,"globalStorage"),settingsResource:I&&y?.useDefaultFlags?.settings?I.settingsResource:(0,O.joinPath)(o,"settings.json"),keybindingsResource:I&&y?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,O.joinPath)(o,"keybindings.json"),tasksResource:I&&y?.useDefaultFlags?.tasks?I.tasksResource:(0,O.joinPath)(o,"tasks.json"),snippetsHome:I&&y?.useDefaultFlags?.snippets?I.snippetsHome:(0,O.joinPath)(o,"snippets"),extensionsResource:I&&y?.useDefaultFlags?.extensions?I.extensionsResource:(0,O.joinPath)(o,"extensions.json"),cacheHome:(0,O.joinPath)(a,s),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let r=class extends A.Disposable{static{this.PROFILES_KEY="userDataProfiles"}static{this.PROFILE_ASSOCIATIONS_KEY="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(i,o,a,y){super(),this.environmentService=i,this.fileService=o,this.uriIdentityService=a,this.logService=y,this.enabled=!0,this._onDidChangeProfiles=this._register(new U.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new U.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new U.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new U.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new l.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,O.joinPath)(this.environmentService.userRoamingDataHome,"profiles"),this.profilesCacheHome=(0,O.joinPath)(this.environmentService.cacheHome,"CachedProfilesData")}init(){this._profilesObject=void 0}setEnablement(i){this.enabled!==i&&(this._profilesObject=void 0,this.enabled=i)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const i=this.createDefaultProfile(),o=[i];if(this.enabled)try{for(const I of this.getStoredProfiles()){if(!I.name||!(0,h.isString)(I.name)||!I.location){this.logService.warn("Skipping the invalid stored profile",I.location||I.name);continue}o.push(t((0,O.basename)(I.location),I.name,I.location,this.profilesCacheHome,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},i))}}catch(I){this.logService.error(I)}const a=new l.ResourceMap,y=new Map;if(o.length)try{const I=this.getStoredProfileAssociations();if(I.workspaces)for(const[w,b]of Object.entries(I.workspaces)){const D=k.URI.parse(w),L=o.find(N=>N.id===b);L&&a.set(D,L)}if(I.emptyWindows)for(const[w,b]of Object.entries(I.emptyWindows)){const D=o.find(L=>L.id===b);D&&y.set(w,D)}}catch(I){this.logService.error(I)}this._profilesObject={profiles:o,workspaces:a,emptyWindows:y}}return this._profilesObject}createDefaultProfile(){const i=t("__default__profile__",(0,R.localize)(0,null),this.environmentService.userRoamingDataHome,this.profilesCacheHome);return{...i,extensionsResource:this.getDefaultProfileExtensionsLocation()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const o="Temp",a=new RegExp(`${(0,u.escapeRegExpCharacters)(o)}\\s(\\d+)`);let y=0;for(const w of this.profiles){const b=a.exec(w.name),D=b?parseInt(b[1]):0;y=D>y?D:y}const I=`${o} ${y+1}`;return this.createProfile((0,_.hash)((0,g.generateUuid)()).toString(16),I,{transient:!0},i)}async createNamedProfile(i,o,a){return this.createProfile((0,_.hash)((0,g.generateUuid)()).toString(16),i,o,a)}async createProfile(i,o,a,y){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const I=await this.doCreateProfile(i,o,a);return y&&await this.setProfileForWorkspace(y,I),I}async doCreateProfile(i,o,a){if(!(0,h.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.profileCreationPromises.get(o);return y||(y=(async()=>{try{if(this.profiles.find(D=>D.name===o||D.id===i))throw new Error(`Profile with ${o} name already exists`);const w=t(i,o,(0,O.joinPath)(this.profilesHome,i),this.profilesCacheHome,a,this.defaultProfile);await this.fileService.createFolder(w.location);const b=[];return this._onWillCreateProfile.fire({profile:w,join(D){b.push(D)}}),await p.Promises.settled(b),this.updateProfiles([w],[],[]),w}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,y)),y}async updateProfile(i,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(y=>y.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=t(a.id,o.name??a.name,a.location,this.profilesCacheHome,{shortName:o.shortName??a.shortName,icon:o.icon===null?void 0:o.icon??a.icon,transient:o.transient??a.isTransient,useDefaultFlags:o.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.updateProfiles([],[],[a]),a}async removeProfile(i){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(y=>y.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);const a=[];this._onWillRemoveProfile.fire({profile:o,join(y){a.push(y)}});try{await Promise.allSettled(a)}catch(y){this.logService.error(y)}for(const y of[...this.profilesObject.emptyWindows.keys()])o.id===this.profilesObject.emptyWindows.get(y)?.id&&this.profilesObject.emptyWindows.delete(y);for(const y of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(y)?.id&&this.profilesObject.workspaces.delete(y);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{await this.fileService.del(o.cacheHome,{recursive:!0})}catch(y){(0,d.toFileOperationResult)(y)!==1&&this.logService.error(y)}}async setProfileForWorkspace(i,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(y=>y.id===o.id);if(!a)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(i,a)}unsetWorkspace(i,o){if(!this.enabled)throw new Error("Profiles are disabled in the current environment.");this.updateWorkspaceAssociation(i,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindows.clear(),this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindows.clear(),this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(this.enabled&&await this.fileService.exists(this.profilesHome)){const i=await this.fileService.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(o=>o.isDirectory&&this.profiles.every(a=>!this.uriIdentityService.extUri.isEqual(a.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const i=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(i.map(o=>this.removeProfile(o)))}getProfileForWorkspace(i){const o=this.getWorkspace(i);return k.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindows.get(o)??this.profilesObject.emptyWindows.get(o)}getWorkspace(i){return(0,v.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,v.isWorkspaceIdentifier)(i)?i.configPath:i.id}isProfileAssociatedToWorkspace(i){return!!([...this.transientProfilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,i.location))||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,i.location))||[...this.profilesObject.emptyWindows.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,i.location))||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,i.location)))}updateProfiles(i,o,a){const y=[...this.profiles,...i],I=[];this.transientProfilesObject.profiles=[];for(let w of y)w.isDefault||o.some(b=>w.id===b.id)||(w=a.find(b=>w.id===b.id)??w,w.isTransient?this.transientProfilesObject.profiles.push(w):I.push({location:w.location,name:w.name,shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags}));this.saveStoredProfiles(I),this._profilesObject=void 0,this.triggerProfilesChanges(i,o,a)}triggerProfilesChanges(i,o,a){this._onDidChangeProfiles.fire({added:i,removed:o,updated:a,all:this.profiles})}updateWorkspaceAssociation(i,o,a){a=o?.isTransient?!0:a,a||this.updateWorkspaceAssociation(i,void 0,!0);const y=this.getWorkspace(i),I=a?this.transientProfilesObject:this.profilesObject;k.URI.isUri(y)?(I.workspaces.delete(y),o&&I.workspaces.set(y,o)):(I.emptyWindows.delete(y),o&&I.emptyWindows.set(y,o)),a||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const i={};for(const[a,y]of this.profilesObject.workspaces.entries())i[a.toString()]=y.id;const o={};for(const[a,y]of this.profilesObject.emptyWindows.entries())o[a.toString()]=y.id;this.saveStoredProfileAssociations({workspaces:i,emptyWindows:o}),this._profilesObject=void 0}migrateStoredProfileAssociations(i){const o={},a=this.createDefaultProfile();if(i.workspaces)for(const[I,w]of Object.entries(i.workspaces)){const b=k.URI.parse(w);o[I]=this.uriIdentityService.extUri.isEqual(b,a.location)?a.id:this.uriIdentityService.extUri.basename(b)}const y={};if(i.emptyWindows)for(const[I,w]of Object.entries(i.emptyWindows)){const b=k.URI.parse(w);y[I]=this.uriIdentityService.extUri.isEqual(b,a.location)?a.id:this.uriIdentityService.extUri.basename(b)}return{workspaces:o,emptyWindows:y}}getStoredProfiles(){return[]}saveStoredProfiles(i){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(i){throw new Error("not implemented")}getDefaultProfileExtensionsLocation(){}};e.UserDataProfilesService=r,e.UserDataProfilesService=r=Ce([K(0,P.IEnvironmentService),K(1,d.IFileService),K(2,c.IUriIdentityService),K(3,E.ILogService)],r);class n extends r{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(i){this.storedProfiles=i}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(i){this.storedProfileAssociations=i}}e.InMemoryUserDataProfilesService=n}),define(ae[249],ce([0,1,6,2,18]),function(ne,e,_,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let O=class extends U.Disposable{constructor(R){super(),this._register(new _.RunOnceScheduler(()=>{R.cleanUp()},10*1e3)).schedule()}};e.UserDataProfilesCleaner=O,e.UserDataProfilesCleaner=O=Ce([K(0,A.IUserDataProfilesService)],O)}),define(ae[250],ce([0,1,17,6,26,7,3,2,5,13,8,156,29,33,48,9,24,22,28,18]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g,u,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.AbstractExtensionManagementService=void 0,e.toExtensionManagementError=S;let f=class extends R.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}get onDidUpdateExtensionMetadata(){return this._onDidUpdateExtensionMetadata.event}constructor(s,i,o,a,y,I){super(),this.galleryService=s,this.telemetryService=i,this.uriIdentityService=o,this.logService=a,this.productService=y,this.userDataProfilesService=I,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this._onDidInstallExtensions=this._register(new k.Emitter),this._onUninstallExtension=this._register(new k.Emitter),this._onDidUninstallExtension=this._register(new k.Emitter),this._onDidUpdateExtensionMetadata=this._register(new k.Emitter),this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(({task:w})=>w.cancel()),this.uninstallingExtensions.forEach(w=>w.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(s){const i=await this.getTargetPlatform();return s.allTargetPlatforms.some(o=>(0,v.isTargetPlatformCompatible)(o,s.allTargetPlatforms,i))}async installFromGallery(s,i={}){try{const a=(await this.installGalleryExtensions([{extension:s,options:i}])).find(({identifier:y})=>(0,l.areSameExtensions)(y,s.identifier));if(a?.local)return a?.local;throw a?.error?a.error:new v.ExtensionManagementError(`Unknown error while installing extension ${s.identifier.id}`,v.ExtensionManagementErrorCode.Unknown)}catch(o){throw S(o)}}async installGalleryExtensions(s){if(!this.galleryService.isEnabled())throw new v.ExtensionManagementError(E.localize(0,null),v.ExtensionManagementErrorCode.NotAllowed);const i=[],o=[];return await Promise.allSettled(s.map(async({extension:a,options:y})=>{try{const I=await this.checkAndGetCompatibleVersion(a,!!y?.installGivenVersion,!!y?.installPreReleaseVersion,y.productVersion??{version:this.productService.version,date:this.productService.date});o.push({...I,options:y})}catch(I){i.push({identifier:a.identifier,operation:2,source:a,error:I})}})),o.length&&i.push(...await this.installExtensions(o)),i}async uninstall(s,i={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.uninstallExtension(s,i)}async toggleAppliationScope(s,i){if((0,c.isApplicationScopedExtension)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let o=await this.updateMetadata(s,{isApplicationScoped:!1},this.userDataProfilesService.defaultProfile.extensionsResource);this.uriIdentityService.extUri.isEqual(i,this.userDataProfilesService.defaultProfile.extensionsResource)||(o=await this.copyExtension(s,this.userDataProfilesService.defaultProfile.extensionsResource,i));for(const a of this.userDataProfilesService.profiles){const y=(await this.getInstalled(1,a.extensionsResource)).find(I=>(0,l.areSameExtensions)(I.identifier,s.identifier));y?this._onDidUpdateExtensionMetadata.fire(y):this._onDidUninstallExtension.fire({identifier:s.identifier,profileLocation:a.extensionsResource})}return o}else{const o=this.uriIdentityService.extUri.isEqual(i,this.userDataProfilesService.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.userDataProfilesService.defaultProfile.extensionsResource):await this.copyExtension(s,i,this.userDataProfilesService.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this._onDidInstallExtensions.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.extensionsControlManifest||s-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=s),this.extensionsControlManifest}registerParticipant(s){this.participants.push(s)}async installExtensions(s){const i=new Map,o=new Map,a=[],y=(w,b)=>`${l.ExtensionKey.create(w).toString()}-${b.toString()}`,I=(w,b,D,L)=>{const N=this.createInstallExtensionTask(w,b,D),F=`${(0,l.getGalleryExtensionId)(w.publisher,w.name)}-${D.profileLocation.toString()}`;o.set(F,{task:N,root:L}),this._onInstallExtension.fire({identifier:N.identifier,source:b,profileLocation:D.profileLocation}),this.logService.info("Installing extension:",N.identifier.id),C.URI.isUri(b)||this.installingExtensions.set(y(b,D.profileLocation),{task:N,waitingTasks:[]})};try{for(const{manifest:w,extension:b,options:D}of s){const L=D.isApplicationScoped||D.isBuiltin||(0,c.isApplicationScopedExtension)(w),N={...D,installOnlyNewlyAddedFromExtensionPack:D.installOnlyNewlyAddedFromExtensionPack??!C.URI.isUri(b),isApplicationScoped:L,profileLocation:L?this.userDataProfilesService.defaultProfile.extensionsResource:D.profileLocation??this.getCurrentExtensionsManifestLocation(),productVersion:D.productVersion??{version:this.productService.version,date:this.productService.date}},F=C.URI.isUri(b)?void 0:this.installingExtensions.get(y(b,N.profileLocation));F?(this.logService.info("Extension is already requested to install",F.task.identifier.id),a.push(F.task.waitUntilTaskIsFinished())):I(w,b,N,void 0)}return await Promise.all([...o.values()].map(async({task:w})=>{if(w.options.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",w.identifier.id);else try{const b=await this.getAllDepsAndPackExtensions(w.identifier,w.manifest,!!w.options.installOnlyNewlyAddedFromExtensionPack,!!w.options.installPreReleaseVersion,w.options.profileLocation,w.options.productVersion),D=await this.getInstalled(void 0,w.options.profileLocation,w.options.productVersion),L={...w.options,context:{...w.options.context,[v.EXTENSION_INSTALL_DEP_PACK_CONTEXT]:!0}};for(const{gallery:N,manifest:F}of(0,_.distinct)(b,({gallery:x})=>x.identifier.id)){if(o.has(`${N.identifier.id.toLowerCase()}-${L.profileLocation.toString()}`))continue;const x=this.installingExtensions.get(y(N,L.profileLocation));if(x){if(this.canWaitForTask(w,x.task)){const X=x.task.identifier;this.logService.info("Waiting for already requested installing extension",X.id,w.identifier.id),x.waitingTasks.push(w),a.push(k.Event.toPromise(k.Event.filter(this.onDidInstallExtensions,B=>B.some(Y=>(0,l.areSameExtensions)(Y.identifier,X)))).then(B=>{if(this.logService.info("Finished waiting for already requested installing extension",X.id,w.identifier.id),!B.find(z=>(0,l.areSameExtensions)(z.identifier,X))?.local)throw new Error(`Extension ${X.id} is not installed`)}))}}else D.some(({identifier:X})=>(0,l.areSameExtensions)(X,N.identifier))||I(F,N,L,w)}}catch(b){if(C.URI.isUri(w.source))(0,_.isNonEmptyArray)(w.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",w.identifier.id,b.message),(0,_.isNonEmptyArray)(w.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",w.identifier.id,b.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",w.identifier.id),b}})),await this.joinAllSettled([...o.entries()].map(async([w,{task:b}])=>{const D=new Date().getTime();try{const L=await b.run();if(await this.joinAllSettled(this.participants.map(N=>N.postInstall(L,b.source,b.options,A.CancellationToken.None))),!C.URI.isUri(b.source)){const N=b.operation===3,F=N?void 0:(new Date().getTime()-b.source.lastUpdated)/1e3;if(t(this.telemetryService,N?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.getGalleryExtensionTelemetryData)(b.source),verificationStatus:b.verificationStatus,duration:new Date().getTime()-D,durationSinceUpdate:F}),P.isWeb&&b.operation!==3)try{await this.galleryService.reportStatistic(L.manifest.publisher,L.manifest.name,L.manifest.version,"install")}catch{}}i.set(w,{local:L,identifier:b.identifier,operation:b.operation,source:b.source,context:b.options.context,profileLocation:b.profileLocation,applicationScoped:L.isApplicationScoped})}catch(L){const N=S(L);throw C.URI.isUri(b.source)||t(this.telemetryService,b.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.getGalleryExtensionTelemetryData)(b.source),error:N}),i.set(w,{error:N,identifier:b.identifier,operation:b.operation,source:b.source,context:b.options.context,profileLocation:b.profileLocation,applicationScoped:b.options.isApplicationScoped}),this.logService.error("Error while installing the extension",b.identifier.id,(0,O.getErrorMessage)(N)),N}})),a.length&&await this.joinAllSettled(a),[...i.values()]}catch(w){const b=(N,F,x)=>{const X=[];N.manifest.extensionDependencies?.length&&X.push(...N.manifest.extensionDependencies),N.manifest.extensionPack?.length&&X.push(...N.manifest.extensionPack);for(const B of X){if(x.includes(B.toLowerCase()))continue;x.push(B.toLowerCase());const Y=i.get(`${B.toLowerCase()}-${F.toString()}`);Y?.local&&(x=b(Y.local,F,x))}return x},D=N=>({identifier:N.identifier,operation:2,source:N.source,context:N.options.context,profileLocation:N.profileLocation,error:w}),L=[];for(const[N,{task:F,root:x}]of o){const X=i.get(N);X?X.local&&x&&!i.get(`${x.identifier.id.toLowerCase()}-${F.profileLocation.toString()}`)?.local&&(L.push(this.createUninstallExtensionTask(X.local,{versionOnly:!0,profileLocation:F.profileLocation})),i.set(N,D(F))):(F.cancel(),i.set(N,D(F)))}for(const[N,{task:F}]of o){const x=i.get(N);if(!x?.local||F.options.donotIncludePackAndDependencies)continue;b(x.local,F.profileLocation,[x.local.identifier.id.toLowerCase()]).slice(1).some(B=>o.has(`${B.toLowerCase()}-${F.profileLocation.toString()}`)&&!i.get(`${B.toLowerCase()}-${F.profileLocation.toString()}`)?.local)&&(L.push(this.createUninstallExtensionTask(x.local,{versionOnly:!0,profileLocation:F.profileLocation})),i.set(N,D(F)))}throw L.length&&await Promise.allSettled(L.map(async N=>{try{await N.run(),this.logService.info("Rollback: Uninstalled extension",N.extension.identifier.id)}catch(F){this.logService.warn("Rollback: Error while uninstalling extension",N.extension.identifier.id,(0,O.getErrorMessage)(F))}})),w}finally{for(const{task:w}of o.values())w.source&&!C.URI.isUri(w.source)&&this.installingExtensions.delete(y(w.source,w.profileLocation));if(i.size){const w=[...i.values()];for(const b of w)b.local&&this.logService.info("Extension installed successfully:",b.identifier.id);this._onDidInstallExtensions.fire(w)}}}canWaitForTask(s,i){for(const[,{task:o,waitingTasks:a}]of this.installingExtensions.entries())if(o===s&&(a.includes(i)||a.some(y=>this.canWaitForTask(y,i)))||o===i&&a[0]&&!this.canWaitForTask(s,a[0]))return!1;return!0}async joinAllSettled(s){const i=[],o=[],a=await Promise.allSettled(s);for(const y of a)y.status==="fulfilled"?i.push(y.value):o.push(y.reason);if(o.length){if(o.length===1)throw o[0];let y=new v.ExtensionManagementError("",v.ExtensionManagementErrorCode.Unknown);for(const I of o){const w=I instanceof v.ExtensionManagementError?I.code:v.ExtensionManagementErrorCode.Unknown;y=new v.ExtensionManagementError(I.message?`${I.message}, ${y.message}`:y.message,w!==v.ExtensionManagementErrorCode.Unknown&&w!==v.ExtensionManagementErrorCode.Internal?w:y.code)}throw y}return i}async getAllDepsAndPackExtensions(s,i,o,a,y,I){if(!this.galleryService.isEnabled())return[];const w=await this.getInstalled(void 0,y,I),b=[],D=[],L=async(N,F)=>{b.push(N);const x=F.extensionDependencies||[],X=[...x];if(F.extensionPack){const B=o?w.find(Y=>(0,l.areSameExtensions)(Y.identifier,N)):void 0;for(const Y of F.extensionPack)B&&B.manifest.extensionPack&&B.manifest.extensionPack.some(z=>(0,l.areSameExtensions)({id:z},{id:Y}))||X.every(z=>!(0,l.areSameExtensions)({id:z},{id:Y}))&&X.push(Y)}if(X.length){const B=X.filter(Y=>b.every(z=>!(0,l.areSameExtensions)(z,{id:Y})));if(B.length){const Y=await this.galleryService.getExtensions(B.map(z=>({id:z,preRelease:a})),A.CancellationToken.None);for(const z of Y){if(b.find(q=>(0,l.areSameExtensions)(q,z.identifier)))continue;const H=x.some(q=>(0,l.areSameExtensions)({id:q},z.identifier));let V;try{V=await this.checkAndGetCompatibleVersion(z,!1,a,I)}catch(q){if(H)throw q;this.logService.info("Skipping the packed extension as it cannot be installed",z.identifier.id,(0,O.getErrorMessage)(q));continue}D.push({gallery:V.extension,manifest:V.manifest}),await L(V.extension.identifier,V.manifest)}}}};return await L(s,i),D}async checkAndGetCompatibleVersion(s,i,o,a){let y;const I=await this.getExtensionsControlManifest();if(I.malicious.some(D=>(0,l.areSameExtensions)(s.identifier,D)))throw new v.ExtensionManagementError(E.localize(1,null,s.identifier.id),v.ExtensionManagementErrorCode.Malicious);const w=I.deprecated[s.identifier.id.toLowerCase()];if(w?.extension?.autoMigrate){if(this.logService.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${w.extension.id}' extension instead.`),y=(await this.galleryService.getExtensions([{id:w.extension.id,preRelease:w.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:a},A.CancellationToken.None))[0],!y)throw new v.ExtensionManagementError(E.localize(2,null,s.identifier.id,w.extension.id),v.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const D=await this.getTargetPlatform();throw new v.ExtensionManagementError(E.localize(3,null,s.identifier.id,this.productService.nameLong,(0,v.TargetPlatformToString)(D)),v.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(y=await this.getCompatibleVersion(s,i,o,a),!y)throw!o&&s.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([s.identifier],A.CancellationToken.None))[0]?new v.ExtensionManagementError(E.localize(4,null,s.displayName??s.identifier.id),v.ExtensionManagementErrorCode.ReleaseVersionNotFound):new v.ExtensionManagementError(E.localize(5,null,s.identifier.id,this.productService.nameLong,this.productService.version),v.ExtensionManagementErrorCode.Incompatible)}this.logService.info("Getting Manifest...",y.identifier.id);const b=await this.galleryService.getManifest(y,A.CancellationToken.None);if(b===null)throw new v.ExtensionManagementError(`Missing manifest for extension ${y.identifier.id}`,v.ExtensionManagementErrorCode.Invalid);if(b.version!==y.version)throw new v.ExtensionManagementError(`Cannot install '${y.identifier.id}' extension because of version mismatch in Marketplace`,v.ExtensionManagementErrorCode.Invalid);return{extension:y,manifest:b}}async getCompatibleVersion(s,i,o,a){const y=await this.getTargetPlatform();let I=null;return!i&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==o&&(I=(await this.galleryService.getExtensions([{...s.identifier,preRelease:o}],{targetPlatform:y,compatible:!0,productVersion:a},A.CancellationToken.None))[0]||null),!I&&await this.galleryService.isExtensionCompatible(s,o,y,a)&&(I=s),I||(i?I=(await this.galleryService.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:y,compatible:!0,productVersion:a},A.CancellationToken.None))[0]||null:I=await this.galleryService.getCompatibleExtension(s,o,y,a)),I}async uninstallExtension(s,i){const o={...i,profileLocation:s.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:i.profileLocation??this.getCurrentExtensionsManifestLocation()},a=L=>`${L.id.toLowerCase()}${o.versionOnly?`-${s.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,y=this.uninstallingExtensions.get(a(s.identifier));if(y)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),y.waitUntilTaskIsFinished();const I=L=>{const N=this.createUninstallExtensionTask(L,o);return this.uninstallingExtensions.set(a(N.extension.identifier),N),o.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${L.identifier.id}@${L.manifest.version}`,o.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${L.identifier.id}@${L.manifest.version}`),this._onUninstallExtension.fire({identifier:L.identifier,profileLocation:o.profileLocation,applicationScoped:L.isApplicationScoped}),N},w=(L,N)=>{N?o.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${L.identifier.id}@${L.manifest.version}`,o.profileLocation.toString(),N.message):this.logService.error("Failed to uninstall extension:",`${L.identifier.id}@${L.manifest.version}`,N.message):o.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${L.identifier.id}@${L.manifest.version}`,o.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${L.identifier.id}@${L.manifest.version}`),t(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,l.getLocalExtensionTelemetryData)(L),error:N}),this._onDidUninstallExtension.fire({identifier:L.identifier,error:N?.code,profileLocation:o.profileLocation,applicationScoped:L.isApplicationScoped})},b=[],D=[];try{b.push(I(s));const L=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const N=this.getAllPackExtensionsToUninstall(s,L);for(const F of N)this.uninstallingExtensions.has(a(F.identifier))?this.logService.info("Extensions is already requested to uninstall",F.identifier.id):b.push(I(F))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.checkForDependents(b.map(N=>N.extension),L,s),await this.joinAllSettled(b.map(async N=>{try{if(await N.run(),await this.joinAllSettled(this.participants.map(F=>F.postUninstall(N.extension,o,A.CancellationToken.None))),N.extension.identifier.uuid)try{await this.galleryService.reportStatistic(N.extension.manifest.publisher,N.extension.manifest.name,N.extension.manifest.version,"uninstall")}catch{}w(N.extension)}catch(F){const x=S(F);throw w(N.extension,x),x}finally{D.push(N)}}))}catch(L){const N=S(L);for(const F of b){try{F.cancel()}catch{}D.includes(F)||w(F.extension,N)}throw N}finally{for(const L of b)this.uninstallingExtensions.delete(a(L.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",L.extension.identifier.id)}}checkForDependents(s,i,o){for(const a of s){const y=this.getDependents(a,i);if(y.length){const I=y.filter(w=>!s.some(b=>(0,l.areSameExtensions)(b.identifier,w.identifier)));if(I.length)throw new Error(this.getDependentsErrorMessage(a,I,o))}}}getDependentsErrorMessage(s,i,o){return o===s?i.length===1?E.localize(6,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?E.localize(7,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):E.localize(8,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?E.localize(9,null,o.manifest.displayName||o.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?E.localize(10,null,o.manifest.displayName||o.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):E.localize(11,null,o.manifest.displayName||o.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(s,i,o=[]){if(o.indexOf(s)!==-1)return[];o.push(s);const a=s.manifest.extensionPack?s.manifest.extensionPack:[];if(a.length){const y=i.filter(w=>!w.isBuiltin&&a.some(b=>(0,l.areSameExtensions)({id:b},w.identifier))),I=[];for(const w of y)I.push(...this.getAllPackExtensionsToUninstall(w,i,o));return[...y,...I]}return[]}getDependents(s,i){return i.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(a=>(0,l.areSameExtensions)({id:a},s.identifier)))}async updateControlCache(){try{return this.logService.trace("ExtensionManagementService.updateControlCache"),await this.galleryService.getExtensionsControlManifest()}catch(s){return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,O.getErrorMessage)(s)),{malicious:[],deprecated:{},search:[]}}}};e.AbstractExtensionManagementService=f,e.AbstractExtensionManagementService=f=Ce([K(0,v.IExtensionGalleryService),K(1,u.ITelemetryService),K(2,h.IUriIdentityService),K(3,p.ILogService),K(4,g.IProductService),K(5,m.IUserDataProfilesService)],f);function S(n){if(n instanceof v.ExtensionManagementError)return n;if(n instanceof v.ExtensionGalleryError){const i=new v.ExtensionManagementError(n.message,v.ExtensionManagementErrorCode.Gallery);return i.stack=n.stack,i}const s=new v.ExtensionManagementError(n.message,(0,O.isCancellationError)(n)?v.ExtensionManagementErrorCode.Cancelled:v.ExtensionManagementErrorCode.Internal);return s.stack=n.stack,s}function t(n,s,{extensionData:i,verificationStatus:o,duration:a,error:y,durationSinceUpdate:I}){let w,b;(0,d.isDefined)(o)&&(o===!0?o="Verified":(o===!1||(w=v.ExtensionManagementErrorCode.Signature,b=o),o="Unverified")),y&&(w=y.code,y.code===v.ExtensionManagementErrorCode.Signature&&(b=y.message)),n.publicLog(s,{...i,verificationStatus:o,success:!y,duration:a,errorcode:w,errorcodeDetail:b,durationSinceUpdate:I})}class r{constructor(){this.barrier=new U.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}run(){return this.cancellablePromise||(this.cancellablePromise=(0,U.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,U.createCancelablePromise)(s=>new Promise((i,o)=>{const a=s.onCancellationRequested(()=>{a.dispose(),o(new O.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=r}),define(ae[52],ce([0,1,6,15,2,3,34,8,29,33,12,4,9,18,28,13,7,22]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class m extends Error{constructor(n,s){super(n),this.code=s}}e.ExtensionsProfileScanningError=m,e.IExtensionsProfileScannerService=(0,E.createDecorator)("IExtensionsProfileScannerService");let f=class extends A.Disposable{constructor(n,s,i,o,a,y){super(),this.extensionsLocation=n,this.fileService=s,this.userDataProfilesService=i,this.uriIdentityService=o,this.telemetryService=a,this.logService=y,this._onAddExtensions=this._register(new O.Emitter),this.onAddExtensions=this._onAddExtensions.event,this._onDidAddExtensions=this._register(new O.Emitter),this.onDidAddExtensions=this._onDidAddExtensions.event,this._onRemoveExtensions=this._register(new O.Emitter),this.onRemoveExtensions=this._onRemoveExtensions.event,this._onDidRemoveExtensions=this._register(new O.Emitter),this.onDidRemoveExtensions=this._onDidRemoveExtensions.event,this.resourcesAccessQueueMap=new k.ResourceMap}scanProfileExtensions(n,s){return this.withProfileExtensions(n,void 0,s)}async addExtensionsToProfile(n,s,i){const o=[],a=[];try{return await this.withProfileExtensions(s,y=>{const I=[];if(i)I.push(...y);else for(const w of y)n.some(([b])=>(0,d.areSameExtensions)(b.identifier,w.identifier)&&b.manifest.version!==w.version)?o.push(w):I.push(w);for(const[w,b]of n){const D=I.findIndex(N=>(0,d.areSameExtensions)(N.identifier,w.identifier)&&N.version===w.manifest.version),L={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:b};D===-1?(a.push(L),I.push(L)):I.splice(D,1,L)}return a.length&&this._onAddExtensions.fire({extensions:a,profileLocation:s}),o.length&&this._onRemoveExtensions.fire({extensions:o,profileLocation:s}),I}),a.length&&this._onDidAddExtensions.fire({extensions:a,profileLocation:s}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,profileLocation:s}),a}catch(y){throw a.length&&this._onDidAddExtensions.fire({extensions:a,error:y,profileLocation:s}),o.length&&this._onDidRemoveExtensions.fire({extensions:o,error:y,profileLocation:s}),y}}async updateMetadata(n,s){const i=[];return await this.withProfileExtensions(s,o=>{const a=[];for(const y of o){const I=n.find(([w])=>(0,d.areSameExtensions)(w.identifier,y.identifier)&&w.manifest.version===y.version);I&&(y.metadata={...y.metadata,...I[1]},i.push(y)),a.push(y)}return a}),i}async removeExtensionFromProfile(n,s){const i=[];try{await this.withProfileExtensions(s,o=>{const a=[];for(const y of o)(0,d.areSameExtensions)(y.identifier,n.identifier)?i.push(y):a.push(y);return i.length&&this._onRemoveExtensions.fire({extensions:i,profileLocation:s}),a}),i.length&&this._onDidRemoveExtensions.fire({extensions:i,profileLocation:s})}catch(o){throw i.length&&this._onDidRemoveExtensions.fire({extensions:i,error:o,profileLocation:s}),o}}async withProfileExtensions(n,s,i){return this.getResourceAccessQueue(n).queue(async()=>{let o=[],a;try{const y=await this.fileService.readFile(n);a=JSON.parse(y.value.toString().trim()||"[]")}catch(y){if((0,C.toFileOperationResult)(y)!==1)throw y;if(this.uriIdentityService.extUri.isEqual(n,this.userDataProfilesService.defaultProfile.extensionsResource)&&(a=await this.migrateFromOldDefaultProfileExtensionsLocation()),!a&&i?.bailOutWhenFileNotFound)throw new m((0,g.getErrorMessage)(y),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.reportAndThrowInvalidConentError(n);let y=!1;for(const I of a){S(I)||this.reportAndThrowInvalidConentError(n);let w;if((0,p.isString)(I.relativeLocation)&&I.relativeLocation)w=this.resolveExtensionLocation(I.relativeLocation);else if((0,p.isString)(I.location)){this.logService.warn(`Extensions profile: Ignoring extension with invalid location: ${I.location}`);continue}else{w=R.URI.revive(I.location);const b=this.toRelativePath(w);b&&(y=!0,I.relativeLocation=b)}(0,p.isUndefined)(I.metadata?.hasPreReleaseVersion)&&I.metadata?.preRelease&&(y=!0,I.metadata.hasPreReleaseVersion=!0),o.push({identifier:I.identifier,location:w,version:I.version,metadata:I.metadata})}y&&await this.fileService.writeFile(n,U.VSBuffer.fromString(JSON.stringify(a)))}if(s){o=s(o);const y=o.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.toRelativePath(I.location),metadata:I.metadata}));await this.fileService.writeFile(n,U.VSBuffer.fromString(JSON.stringify(y)))}return o})}reportAndThrowInvalidConentError(n){const s=new m(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.telemetryService.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}toRelativePath(n){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(n),this.extensionsLocation)?this.uriIdentityService.extUri.basename(n):void 0}resolveExtensionLocation(n){return this.uriIdentityService.extUri.joinPath(this.extensionsLocation,n)}async migrateFromOldDefaultProfileExtensionsLocation(){return this._migrationPromise||(this._migrationPromise=(async()=>{const n=this.uriIdentityService.extUri.joinPath(this.userDataProfilesService.defaultProfile.location,"extensions.json"),s=this.uriIdentityService.extUri.joinPath(this.extensionsLocation,".init-default-profile-extensions");let i;try{i=(await this.fileService.readFile(n)).value.toString()}catch(a){if((0,C.toFileOperationResult)(a)===1)return;throw a}this.logService.info("Migrating extensions from old default profile location",n.toString());let o;try{const a=JSON.parse(i);Array.isArray(a)&&a.every(y=>S(y))?o=a:this.logService.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.logService.error(a)}if(o)try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,U.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.logService.info("Migrated extensions from old default profile location to new location",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString())}catch(a){if((0,C.toFileOperationResult)(a)===3)this.logService.info("Migration from old default profile location to new location is done by another window",n.toString(),this.userDataProfilesService.defaultProfile.extensionsResource.toString());else throw a}try{await this.fileService.del(n)}catch(a){(0,C.toFileOperationResult)(a)!==1&&this.logService.error(a)}try{await this.fileService.del(s)}catch(a){(0,C.toFileOperationResult)(a)!==1&&this.logService.error(a)}return o})()),this._migrationPromise}getResourceAccessQueue(n){let s=this.resourcesAccessQueueMap.get(n);return s||(s=new _.Queue,this.resourcesAccessQueueMap.set(n,s)),s}};e.AbstractExtensionsProfileScannerService=f,e.AbstractExtensionsProfileScannerService=f=Ce([K(1,C.IFileService),K(2,l.IUserDataProfilesService),K(3,c.IUriIdentityService),K(4,u.ITelemetryService),K(5,v.ILogService)],f);function S(r){return(0,p.isObject)(r)&&(0,P.isIExtensionIdentifier)(r.identifier)&&(t(r.location)||(0,p.isString)(r.location)&&r.location)&&((0,p.isUndefined)(r.relativeLocation)||(0,p.isString)(r.relativeLocation))&&r.version&&(0,p.isString)(r.version)}function t(r){return r?(0,p.isString)(r.path)&&(0,p.isString)(r.scheme):!1}}),define(ae[81],ce([0,1,17,6,30,15,7,35,138,2,23,14,5,20,55,88,13,8,159,16,33,48,71,12,4,9,24,3,66,52,18,28,188]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g,u,h,m,f,S,t,r,n,s,i,o,a,y,I,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0,e.toExtensionDescription=X;var D;(function(Y){function z(H,V){if(H===V)return!0;const q=Object.keys(H),ie=new Set;for(const re of Object.keys(V))ie.add(re);if(q.length!==ie.size)return!1;for(const re of q){if(H[re]!==V[re])return!1;ie.delete(re)}return ie.size===0}Y.equals=z})(D||(e.Translations=D={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let L=class extends d.Disposable{constructor(z,H,V,q,ie,re,ue,te,j,W,T,M){super(),this.systemExtensionsLocation=z,this.userExtensionsLocation=H,this.extensionsControlLocation=V,this.currentProfile=q,this.userDataProfilesService=ie,this.extensionsProfileScannerService=re,this.fileService=ue,this.logService=te,this.environmentService=j,this.productService=W,this.uriIdentityService=T,this.instantiationService=M,this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,l.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(x,this.currentProfile,this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(x,this.currentProfile,this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(F,this.obsoleteFile)),this.initializeDefaultProfileExtensionsPromise=void 0,this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(z,H,V){const[q,ie]=await Promise.all([this.scanSystemExtensions(z),this.scanUserExtensions(H)]),re=V?await this.scanExtensionsUnderDevelopment(z,[...q,...ie]):[];return this.dedupExtensions(q,ie,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(z){const H=[];H.push(this.scanDefaultSystemExtensions(!!z.useCache,z.language)),H.push(this.scanDevSystemExtensions(z.language,!!z.checkControlFile));const[V,q]=await Promise.all(H);return this.applyScanOptions([...V,...q],0,z,!1)}async scanUserExtensions(z){const H=z.profileLocation??this.userExtensionsLocation;this.logService.trace("Started scanning user extensions",H);const V=this.uriIdentityService.extUri.isEqual(z.profileLocation,this.userDataProfilesService.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.createExtensionScannerInput(H,!!z.profileLocation,1,!z.includeUninstalled,z.language,!0,V,z.productVersion??this.getProductVersion()),ie=z.useCache&&!q.devMode&&q.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner;let re;try{re=await ie.scanExtensions(q)}catch(ue){if(ue instanceof y.ExtensionsProfileScanningError&&ue.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions(),re=await ie.scanExtensions(q);else throw ue}return re=await this.applyScanOptions(re,1,z,!0),this.logService.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(z,H){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const V=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(q=>q.scheme===C.Schemas.file).map(async q=>{const ie=await this.createExtensionScannerInput(q,!1,1,!0,z.language,!1,void 0,z.productVersion??this.getProductVersion());return(await this.extensionsScanner.scanOneOrMultipleExtensions(ie)).map(ue=>(ue.type=H.find(te=>(0,f.areSameExtensions)(te.identifier,ue.identifier))?.type??ue.type,this.extensionsScanner.validate(ue,ie)))}))).flat();return this.applyScanOptions(V,"development",z,!0)}return[]}async scanExistingExtension(z,H,V){const q=await this.createExtensionScannerInput(z,!1,H,!0,V.language,!0,void 0,V.productVersion??this.getProductVersion()),ie=await this.extensionsScanner.scanExtension(q);return!ie||!V.includeInvalid&&!ie.isValid?null:ie}async scanOneOrMultipleExtensions(z,H,V){const q=await this.createExtensionScannerInput(z,!1,H,!0,V.language,!0,void 0,V.productVersion??this.getProductVersion()),ie=await this.extensionsScanner.scanOneOrMultipleExtensions(q);return this.applyScanOptions(ie,H,V,!0)}async scanMultipleExtensions(z,H,V){const q=[];return await Promise.all(z.map(async ie=>{const re=await this.scanOneOrMultipleExtensions(ie,H,V);q.push(...re)})),this.applyScanOptions(q,H,V,!0)}async scanMetadata(z){const H=(0,l.joinPath)(z,"package.json"),V=(await this.fileService.readFile(H)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(z,H){const V=(0,l.joinPath)(z,"package.json"),q=(await this.fileService.readFile(V)).value.toString(),ie=JSON.parse(q);H.isMachineScoped===!1&&delete H.isMachineScoped,H.isBuiltin===!1&&delete H.isBuiltin,ie.__metadata={...ie.__metadata,...H},await this.fileService.writeFile((0,l.joinPath)(z,"package.json"),O.VSBuffer.fromString(JSON.stringify(ie,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.extensionsProfileScannerService.scanProfileExtensions(this.userDataProfilesService.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(z){if(z instanceof y.ExtensionsProfileScanningError&&z.code==="ERROR_PROFILE_NOT_FOUND")await this.doInitializeDefaultProfileExtensions();else throw z}}async doInitializeDefaultProfileExtensions(){return this.initializeDefaultProfileExtensionsPromise||(this.initializeDefaultProfileExtensionsPromise=(async()=>{try{this.logService.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const z=await this.scanUserExtensions({includeInvalid:!0});if(z.length)await this.extensionsProfileScannerService.addExtensionsToProfile(z.map(H=>[H,H.metadata]),this.userDataProfilesService.defaultProfile.extensionsResource);else try{await this.fileService.createFile(this.userDataProfilesService.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify([])))}catch(H){(0,r.toFileOperationResult)(H)!==1&&this.logService.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,k.getErrorMessage)(H))}this.logService.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(z){this.logService.error(z)}finally{this.initializeDefaultProfileExtensionsPromise=void 0}})()),this.initializeDefaultProfileExtensionsPromise}async applyScanOptions(z,H,V,q){return V.includeAllVersions||(z=this.dedupExtensions(H===0?z:void 0,H===1?z:void 0,H==="development"?z:void 0,await this.getTargetPlatform(),q)),V.includeInvalid||(z=z.filter(ie=>ie.isValid)),z.sort((ie,re)=>{const ue=E.basename(ie.location.fsPath),te=E.basename(re.location.fsPath);return ue<te?-1:ue>te?1:0})}dedupExtensions(z,H,V,q,ie){const re=(te,j,W)=>{if(te.isValid&&!j.isValid)return!1;if(te.isValid===j.isValid){if(ie&&c.gt(te.manifest.version,j.manifest.version))return this.logService.debug(`Skipping extension ${j.location.path} with lower version ${j.manifest.version} in favour of ${te.location.path} with version ${te.manifest.version}`),!1;if(c.eq(te.manifest.version,j.manifest.version)){if(te.type===0)return this.logService.debug(`Skipping extension ${j.location.path} in favour of system extension ${te.location.path} with same version`),!1;if(te.targetPlatform===q)return this.logService.debug(`Skipping extension ${j.location.path} from different target platform ${j.targetPlatform}`),!1}}return W?this.logService.warn(`Overwriting user extension ${te.location.path} with ${j.location.path}.`):this.logService.debug(`Overwriting user extension ${te.location.path} with ${j.location.path}.`),!0},ue=new S.ExtensionIdentifierMap;return z?.forEach(te=>{const j=ue.get(te.identifier.id);(!j||re(j,te,!1))&&ue.set(te.identifier.id,te)}),H?.forEach(te=>{const j=ue.get(te.identifier.id);if(!j&&z&&te.type===0){this.logService.debug(`Skipping obsolete system extension ${te.location.path}.`);return}(!j||re(j,te,!1))&&ue.set(te.identifier.id,te)}),V?.forEach(te=>{const j=ue.get(te.identifier.id);(!j||re(j,te,!0))&&ue.set(te.identifier.id,te),ue.set(te.identifier.id,te)}),[...ue.values()]}async scanDefaultSystemExtensions(z,H){this.logService.trace("Started scanning system extensions");const V=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,H,!0,void 0,this.getProductVersion()),ie=await(z&&!V.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(V);return this.logService.trace("Scanned system extensions:",ie.length),ie}async scanDevSystemExtensions(z,H){const V=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!V?.length)return[];this.logService.trace("Started scanning dev system extensions");const q=H?await this.getBuiltInExtensionControl():{},ie=[],re=u.URI.file(E.normalize(E.join(C.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const te of V){const j=q[te.name]||"marketplace";switch(j){case"disabled":break;case"marketplace":ie.push((0,l.joinPath)(re,te.name));break;default:ie.push(u.URI.file(j));break}}const ue=await Promise.all(ie.map(async te=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(te,!1,0,!0,z,!0,void 0,this.getProductVersion()))));return this.logService.trace("Scanned dev system extensions:",ue.length),(0,_.coalesce)(ue)}async getBuiltInExtensionControl(){try{const z=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(z.value.toString())}catch{return{}}}async createExtensionScannerInput(z,H,V,q,ie,re,ue,te){const j=await this.getTranslations(ie??v.language),W=await this.getMtime(z),T=H&&!this.uriIdentityService.extUri.isEqual(z,this.userDataProfilesService.defaultProfile.extensionsResource)?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,M=T?await this.getMtime(T):void 0;return new N(z,W,T,M,H,ue,V,q,re,te.version,te.date,this.productService.commit,!this.environmentService.isBuilt,ie,j)}async getMtime(z){try{const H=await this.fileService.stat(z);if(typeof H.mtime=="number")return H.mtime}catch{}}getProductVersion(){return{version:this.productService.version,date:this.productService.date}}};e.AbstractExtensionsScannerService=L,e.AbstractExtensionsScannerService=L=Ce([K(4,I.IUserDataProfilesService),K(5,y.IExtensionsProfileScannerService),K(6,r.IFileService),K(7,s.ILogService),K(8,m.IEnvironmentService),K(9,i.IProductService),K(10,w.IUriIdentityService),K(11,n.IInstantiationService)],L);class N{constructor(z,H,V,q,ie,re,ue,te,j,W,T,M,$,Q,G){this.location=z,this.mtime=H,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=q,this.profile=ie,this.profileScanOptions=re,this.type=ue,this.excludeObsolete=te,this.validate=j,this.productVersion=W,this.productDate=T,this.productCommit=M,this.devMode=$,this.language=Q,this.translations=G}static createNlsConfiguration(z){return{language:z.language,pseudo:z.language==="pseudo",devMode:z.devMode,translations:z.translations}}static equals(z,H){return(0,l.isEqual)(z.location,H.location)&&z.mtime===H.mtime&&(0,l.isEqual)(z.applicationExtensionslocation,H.applicationExtensionslocation)&&z.applicationExtensionslocationMtime===H.applicationExtensionslocationMtime&&z.profile===H.profile&&A.equals(z.profileScanOptions,H.profileScanOptions)&&z.type===H.type&&z.excludeObsolete===H.excludeObsolete&&z.validate===H.validate&&z.productVersion===H.productVersion&&z.productDate===H.productDate&&z.productCommit===H.productCommit&&z.devMode===H.devMode&&z.language===H.language&&D.equals(z.translations,H.translations)}}e.ExtensionScannerInput=N;let F=class extends d.Disposable{constructor(z,H,V,q,ie){super(),this.obsoleteFile=z,this.extensionsProfileScannerService=H,this.uriIdentityService=V,this.fileService=q,this.logService=ie}async scanExtensions(z){const H=z.profile?await this.scanExtensionsFromProfile(z):await this.scanExtensionsFromLocation(z);let V={};if(z.excludeObsolete&&z.type===1)try{const q=(await this.fileService.readFile(this.obsoleteFile)).value.toString();V=JSON.parse(q)}catch{}return(0,g.isEmptyObject)(V)?H:H.filter(q=>!V[f.ExtensionKey.create(q).toString()])}async scanExtensionsFromLocation(z){const H=await this.fileService.resolve(z.location);if(!H.children?.length)return[];const V=await Promise.all(H.children.map(async q=>{if(!q.isDirectory||z.type===1&&(0,l.basename)(q.resource).indexOf(".")===0)return null;const ie=new N(q.resource,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(ie)}));return(0,_.coalesce)(V).sort((q,ie)=>q.location.path<ie.location.path?-1:1)}async scanExtensionsFromProfile(z){let H=await this.scanExtensionsFromProfileResource(z.location,()=>!0,z);if(z.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(z.location,z.applicationExtensionslocation)){H=H.filter(q=>!q.metadata?.isApplicationScoped);const V=await this.scanExtensionsFromProfileResource(z.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,z);H.push(...V)}return H}async scanExtensionsFromProfileResource(z,H,V){const q=await this.extensionsProfileScannerService.scanProfileExtensions(z,V.profileScanOptions);if(!q.length)return[];const ie=await Promise.all(q.map(async re=>{if(H(re)){const ue=new N(re.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(ue,re.metadata)}return null}));return(0,_.coalesce)(ie)}async scanOneOrMultipleExtensions(z){try{if(await this.fileService.exists((0,l.joinPath)(z.location,"package.json"))){const H=await this.scanExtension(z);return H?[H]:[]}else return await this.scanExtensions(z)}catch(H){return this.logService.error(`Error scanning extensions at ${z.location.path}:`,(0,k.getErrorMessage)(H)),[]}}async scanExtension(z,H){try{let V=await this.scanExtensionManifest(z.location);if(V){V.publisher||(V.publisher=S.UNDEFINED_PUBLISHER),H=H??V.__metadata,delete V.__metadata;const q=(0,f.getGalleryExtensionId)(V.publisher,V.name),ie=H?.id?{id:q,uuid:H.id}:{id:q},re=H?.isSystem?0:z.type,ue=re===0||!!H?.isBuiltin;V=await this.translateManifest(z.location,V,N.createNlsConfiguration(z));const te={type:re,identifier:ie,manifest:V,location:z.location,isBuiltin:ue,targetPlatform:H?.targetPlatform??"undefined",publisherDisplayName:H?.publisherDisplayName,metadata:H,isValid:!0,validations:[]};return z.validate?this.validate(te,z):te}}catch(V){z.type!==0&&this.logService.error(V)}return null}validate(z,H){let V=!0;const q=(0,t.validateExtensionManifest)(H.productVersion,H.productDate,H.location,z.manifest,z.isBuiltin);for(const[ie,re]of q)ie===p.default.Error&&(V=!1,this.logService.error(this.formatMessage(H.location,re)));return z.isValid=V,z.validations=q,z}async scanExtensionManifest(z){const H=(0,l.joinPath)(z,"package.json");let V;try{V=(await this.fileService.readFile(H)).value.toString()}catch(ie){return(0,r.toFileOperationResult)(ie)!==1&&this.logService.error(this.formatMessage(z,(0,h.localize)(0,null,H.path,ie.message))),null}let q;try{q=JSON.parse(V)}catch{const re=[];(0,R.parse)(V,re);for(const ue of re)this.logService.error(this.formatMessage(z,(0,h.localize)(1,null,H.path,ue.offset,ue.length,(0,P.getParseErrorMessage)(ue.error))));return null}return(0,R.getNodeType)(q)!=="object"?(this.logService.error(this.formatMessage(z,(0,h.localize)(2,null,H.path))),null):q}async translateManifest(z,H,V){const q=await this.getLocalizedMessages(z,H,V);if(q)try{const ie=[],re=await this.resolveOriginalMessageBundle(q.default,ie);if(ie.length>0)return ie.forEach(te=>{this.logService.error(this.formatMessage(z,(0,h.localize)(3,null,q.default?.path,(0,P.getParseErrorMessage)(te.error))))}),H;if((0,R.getNodeType)(q)!=="object")return this.logService.error(this.formatMessage(z,(0,h.localize)(4,null,q.default?.path))),H;const ue=q.values||Object.create(null);return(0,b.localizeManifest)(this.logService,H,ue,re)}catch{}return H}async getLocalizedMessages(z,H,V){const q=(0,l.joinPath)(z,"package.nls.json"),ie=(j,W)=>{W.forEach(T=>{this.logService.error(this.formatMessage(z,(0,h.localize)(5,null,j?.path,(0,P.getParseErrorMessage)(T.error))))})},re=j=>{this.logService.error(this.formatMessage(z,(0,h.localize)(6,null,j?.path)))},ue=`${H.publisher}.${H.name}`,te=V.translations[ue];if(te)try{const j=u.URI.file(te),W=(await this.fileService.readFile(j)).value.toString(),T=[],M=(0,R.parse)(W,T);return T.length>0?(ie(j,T),{values:void 0,default:q}):(0,R.getNodeType)(M)!=="object"?(re(j),{values:void 0,default:q}):{values:M.contents?M.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.fileService.exists(q))return;let W;try{W=await this.findMessageBundles(z,V)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const T=(await this.fileService.readFile(W.localized)).value.toString(),M=[],$=(0,R.parse)(T,M);return M.length>0?(ie(W.localized,M),{values:void 0,default:W.original}):(0,R.getNodeType)($)!=="object"?(re(W.localized),{values:void 0,default:W.original}):{values:$,default:W.original}}catch{return{values:void 0,default:W.original}}}}async resolveOriginalMessageBundle(z,H){if(z)try{const V=(await this.fileService.readFile(z)).value.toString();return(0,R.parse)(V,H)}catch{}}findMessageBundles(z,H){return new Promise((V,q)=>{const ie=re=>{const ue=(0,l.joinPath)(z,`package.nls.${re}.json`);this.fileService.exists(ue).then(te=>{te&&V({localized:ue,original:(0,l.joinPath)(z,"package.nls.json")});const j=re.lastIndexOf("-");j===-1?V({localized:(0,l.joinPath)(z,"package.nls.json"),original:null}):(re=re.substring(0,j),ie(re))})};if(H.devMode||H.pseudo||!H.language)return V({localized:(0,l.joinPath)(z,"package.nls.json"),original:null});ie(H.language)})}formatMessage(z,H){return`[${z.path}]: ${H}`}};F=Ce([K(1,y.IExtensionsProfileScannerService),K(2,w.IUriIdentityService),K(3,r.IFileService),K(4,s.ILogService)],F);let x=class extends F{constructor(z,H,V,q,ie,re,ue){super(H,q,ie,re,ue),this.currentProfile=z,this.userDataProfilesService=V,this.cacheValidatorThrottler=this._register(new U.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new o.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(z){const H=this.getCacheFile(z),V=await this.readExtensionCache(H);if(this.input=z,V&&V.input&&N.equals(V.input,this.input))return this.logService.debug("Using cached extensions scan result",z.location.toString()),this.cacheValidatorThrottler.trigger(()=>this.validateCache()),V.result.map(ie=>(ie.location=u.URI.revive(ie.location),ie));const q=await super.scanExtensions(z);return await this.writeExtensionCache(H,{input:z,result:q}),q}async readExtensionCache(z){try{const H=await this.fileService.readFile(z),V=JSON.parse(H.value.toString());return{result:V.result,input:(0,a.revive)(V.input)}}catch(H){this.logService.debug("Error while reading the extension cache file:",z.path,(0,k.getErrorMessage)(H))}return null}async writeExtensionCache(z,H){try{await this.fileService.writeFile(z,O.VSBuffer.fromString(JSON.stringify(H)))}catch(V){this.logService.debug("Error while writing the extension cache file:",z.path,(0,k.getErrorMessage)(V))}}async validateCache(){if(!this.input)return;const z=this.getCacheFile(this.input),H=await this.readExtensionCache(z);if(!H)return;const V=H.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!A.equals(q,V))try{this.logService.info("Invalidating Cache",V,q),await this.fileService.del(z),this._onDidChangeCache.fire()}catch(ie){this.logService.error(ie)}}getCacheFile(z){const H=this.getProfile(z);return this.uriIdentityService.extUri.joinPath(H.cacheHome,z.type===0?S.BUILTIN_MANIFEST_CACHE_FILE:S.USER_MANIFEST_CACHE_FILE)}getProfile(z){return z.type===0?this.userDataProfilesService.defaultProfile:z.profile?this.uriIdentityService.extUri.isEqual(z.location,this.currentProfile.extensionsResource)?this.currentProfile:this.userDataProfilesService.profiles.find(H=>this.uriIdentityService.extUri.isEqual(z.location,H.extensionsResource))??this.currentProfile:this.userDataProfilesService.defaultProfile}};x=Ce([K(2,I.IUserDataProfilesService),K(3,y.IExtensionsProfileScannerService),K(4,w.IUriIdentityService),K(5,r.IFileService),K(6,s.ILogService)],x);function X(Y,z){const H=(0,f.getExtensionId)(Y.manifest.publisher,Y.manifest.name);return{id:H,identifier:new S.ExtensionIdentifier(H),isBuiltin:Y.type===0,isUserBuiltin:Y.type===1&&Y.isBuiltin,isUnderDevelopment:z,extensionLocation:Y.location,uuid:Y.identifier.uuid,targetPlatform:Y.targetPlatform,publisherDisplayName:Y.publisherDisplayName,...Y.manifest}}class B extends L{constructor(z,H,V,q,ie,re,ue,te,j,W,T,M){super(z,H,(0,l.joinPath)(V,".vscode-oss-dev","extensions","control.json"),q,ie,re,ue,te,j,W,T,M),this.translationsPromise=(async()=>{if(v.translationsConfigFile)try{const $=await this.fileService.readFile(u.URI.file(v.translationsConfigFile));return JSON.parse($.value.toString())}catch{}return Object.create(null)})()}getTranslations(z){return this.translationsPromise}}e.NativeExtensionsScannerService=B}),define(ae[251],ce([0,1,67,6,38,3,2,23,14,31,9,18]),function(ne,e,_,U,A,O,k,R,P,d,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=class extends k.Disposable{constructor(c,p){super(),this.userDataProfilesService=c,this.logService=p,this.processesLimiter=new U.Limiter(5)}async postUninstall(c){const p=this.parseScript(c,"uninstall");p&&(this.logService.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(async()=>{try{await this.runLifecycleHook(p.script,"uninstall",p.args,!0,c),this.logService.info("Finished running post uninstall script",c.identifier.id,c.manifest.version)}catch(g){this.logService.error("Failed to run post uninstall script",c.identifier.id,c.manifest.version),this.logService.error(g)}}));try{await d.Promises.rm(this.getExtensionStoragePath(c))}catch(g){this.logService.error("Error while removing extension storage path",c.identifier.id),this.logService.error(g)}}parseScript(c,p){const g=`vscode:${p}`;if(c.location.scheme===R.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[g]=="string"){const u=c.manifest.scripts[g].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.logService.warn(c.identifier.id,c.manifest.version,`${g} should be a node script`),null):{script:(0,P.join)(c.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}runLifecycleHook(c,p,g,u,h){return new Promise((m,f)=>{const S=this.start(c,p,g,h);let t;const r=n=>{t&&(clearTimeout(t),t=null),n?f(n):m(void 0)};S.on("error",n=>{r((0,A.toErrorMessage)(n)||"Unknown")}),S.on("exit",(n,s)=>{r(n?`post-${p} process exited with code ${n}`:void 0)}),u&&(t=setTimeout(()=>{t=null,S.kill(),f("timed out")},5e3))})}start(c,p,g,u){const h={silent:!0,execArgv:void 0},m=(0,_.fork)(c,[`--type=extension-post-${p}`,...g],h);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const f=O.Event.fromNodeEventEmitter(m.stdout,"data"),S=O.Event.fromNodeEventEmitter(m.stderr,"data");this._register(f(n=>this.logService.info(u.identifier.id,u.manifest.version,`post-${p}`,n))),this._register(S(n=>this.logService.error(u.identifier.id,u.manifest.version,`post-${p}`,n)));const t=O.Event.any(O.Event.map(f,n=>({data:`%c${n}`,format:[""]}),this._store),O.Event.map(S,n=>({data:`%c${n}`,format:["color: red"]}),this._store));return O.Event.debounce(t,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100,void 0,void 0,void 0,this._store)(n=>{console.group(u.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),m}getExtensionStoragePath(c){return(0,P.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=v,e.ExtensionsLifecycle=v=Ce([K(0,E.IUserDataProfilesService),K(1,C.ILogService)],v)}),define(ae[113],ce([0,1,6,15,26,38,7,3,54,2,34,23,14,20,55,13,8,32,31,70,160,95,16,250,29,33,52,81,231,251,189,221,232,71,12,4,9,24,22,28,18]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g,u,h,m,f,S,t,r,n,s,i,o,a,y,I,w,b,D,L,N,F,x,X,B,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,N.refineServiceDecorator)(n.IExtensionManagementService);const z=".vsctmp";let H=class extends r.AbstractExtensionManagementService{constructor(j,W,T,M,$,Q,G,ee,Z,J,se,he){super(j,W,se,T,J,he),this.extensionsScannerService=$,this.extensionsProfileScannerService=Q,this.downloadService=G,this.fileService=Z,this.installGalleryExtensionsTasks=new Map,this.knownDirectories=new C.ResourceSet;const ge=this._register(ee.createInstance(y.ExtensionsLifecycle));this.extensionsScanner=this._register(ee.createInstance(V,me=>ge.postUninstall(me))),this.manifestCache=this._register(new w.ExtensionsManifestCache(he,Z,se,this,this.logService)),this.extensionsDownloader=this._register(ee.createInstance(a.ExtensionsDownloader));const de=this._register(new b.ExtensionsWatcher(this,this.extensionsScannerService,he,Q,se,Z,T));this._register(de.onDidChangeExtensionsByAnotherSource(me=>this.onDidChangeExtensionsFromAnotherSource(me))),this.watchForExtensionsNotInstalledBySystem()}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(j){this.logService.trace("ExtensionManagementService#zip",j.identifier.id);const W=await this.collectFiles(j),T=await(0,m.zip)((0,l.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,W);return g.URI.file(T)}async unzip(j){return this.logService.trace("ExtensionManagementService#unzip",j.toString()),(await this.install(j)).identifier}async getManifest(j){const{location:W,cleanup:T}=await this.downloadVsix(j),M=v.resolve(W.fsPath);try{return await(0,I.getManifest)(M)}finally{await T()}}getInstalled(j,W=this.userDataProfilesService.defaultProfile.extensionsResource,T={version:this.productService.version,date:this.productService.date}){return this.extensionsScanner.scanExtensions(j??null,W,T)}scanAllUserInstalledExtensions(){return this.extensionsScanner.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(j){return this.extensionsScanner.scanUserExtensionAtLocation(j)}async install(j,W={}){this.logService.trace("ExtensionManagementService#install",j.toString());const{location:T,cleanup:M}=await this.downloadVsix(j);try{const $=await(0,I.getManifest)(v.resolve(T.fsPath)),Q=(0,s.getGalleryExtensionId)($.publisher,$.name);if($.engines&&$.engines.vscode&&!(0,D.isEngineValid)($.engines.vscode,this.productService.version,this.productService.date))throw new Error(f.localize(0,null,Q,this.productService.version));const ee=(await this.installExtensions([{manifest:$,extension:T,options:W}])).find(({identifier:Z})=>(0,s.areSameExtensions)(Z,{id:Q}));if(ee?.local)return ee.local;throw ee?.error?ee.error:(0,r.toExtensionManagementError)(new Error(`Unknown error while installing extension ${Q}`))}finally{await M()}}async installFromLocation(j,W){this.logService.trace("ExtensionManagementService#installFromLocation",j.toString());const T=await this.extensionsScanner.scanUserExtensionAtLocation(j);if(!T||!T.manifest.name||!T.manifest.version)throw new Error(`Cannot find a valid extension from the location ${j.toString()}`);return await this.addExtensionsToProfile([[T,{source:"resource"}]],W),this.logService.info("Successfully installed extension",T.identifier.id,W.toString()),T}async installExtensionsFromProfile(j,W,T){this.logService.trace("ExtensionManagementService#installExtensionsFromProfile",j,W.toString(),T.toString());const M=(await this.getInstalled(1,W)).filter($=>j.some(Q=>(0,s.areSameExtensions)(Q,$.identifier)));if(M.length){const $=await Promise.all(M.map(Q=>this.extensionsScanner.scanMetadata(Q,W)));await this.addExtensionsToProfile(M.map((Q,G)=>[Q,$[G]]),T),this.logService.info("Successfully installed extensions",M.map(Q=>Q.identifier.id),T.toString())}return M}async updateMetadata(j,W,T=this.userDataProfilesService.defaultProfile.extensionsResource){return this.logService.trace("ExtensionManagementService#updateMetadata",j.identifier.id),W.isPreReleaseVersion&&(W.preRelease=!0,W.hasPreReleaseVersion=!0),W.isMachineScoped===!1&&(W.isMachineScoped=void 0),W.isBuiltin===!1&&(W.isBuiltin=void 0),W.pinned===!1&&(W.pinned=void 0),j=await this.extensionsScanner.updateMetadata(j,W,T),this.manifestCache.invalidate(T),this._onDidUpdateExtensionMetadata.fire(j),j}async reinstallFromGallery(j){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",j.identifier.id),!this.galleryService.isEnabled())throw new Error(f.localize(1,null));const W=await this.getTargetPlatform(),[T]=await this.galleryService.getExtensions([{...j.identifier,preRelease:j.preRelease}],{targetPlatform:W,compatible:!0},A.CancellationToken.None);if(!T)throw new Error(f.localize(2,null));await this.extensionsScanner.setUninstalled(j);try{await this.extensionsScanner.removeUninstalledExtension(j)}catch(M){throw new Error(f.localize(3,null,(0,O.toErrorMessage)(M)))}return this.installFromGallery(T)}copyExtension(j,W,T,M){return this.extensionsScanner.copyExtension(j,W,T,M)}copyExtensions(j,W){return this.extensionsScanner.copyExtensions(j,W,{version:this.productService.version,date:this.productService.date})}markAsUninstalled(...j){return this.extensionsScanner.setUninstalled(...j)}async cleanUp(){this.logService.trace("ExtensionManagementService#cleanUp");try{await this.extensionsScanner.cleanUp()}catch(j){this.logService.error(j)}}async download(j,W,T){const{location:M}=await this.extensionsDownloader.download(j,W,!T);return M}async downloadVsix(j){if(j.scheme===E.Schemas.file)return{location:j,async cleanup(){}};this.logService.trace("Downloading extension from",j.toString());const W=(0,l.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,u.generateUuid)());return await this.downloadService.download(j,W),this.logService.info("Downloaded extension to",W.toString()),{location:W,cleanup:async()=>{try{await this.fileService.del(W)}catch(M){this.logService.error(M)}}}}getCurrentExtensionsManifestLocation(){return this.userDataProfilesService.defaultProfile.extensionsResource}createInstallExtensionTask(j,W,T){if(g.URI.isUri(W))return new re(j,W,T,this.galleryService,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService);const M=s.ExtensionKey.create(W).toString();let $=this.installGalleryExtensionsTasks.get(M);return $||(this.installGalleryExtensionsTasks.set(M,$=new ie(j,W,T,this.extensionsDownloader,this.extensionsScanner,this.uriIdentityService,this.userDataProfilesService,this.extensionsScannerService,this.extensionsProfileScannerService,this.logService,this.telemetryService)),$.waitUntilTaskIsFinished().finally(()=>this.installGalleryExtensionsTasks.delete(M))),$}createUninstallExtensionTask(j,W){return new ue(j,W.profileLocation,this.extensionsProfileScannerService)}async collectFiles(j){const W=async M=>{let $=await h.Promises.readdir(M);$=$.map(ee=>v.join(M,ee));const Q=await Promise.all($.map(ee=>h.Promises.stat(ee)));let G=Promise.resolve([]);return Q.forEach((ee,Z)=>{const J=$[Z];ee.isFile()&&(G=G.then(se=>[...se,J])),ee.isDirectory()&&(G=G.then(se=>W(J).then(he=>[...se,...he])))}),G};return(await W(j.location.fsPath)).map(M=>({path:`extension/${v.relative(j.location.fsPath,M)}`,localPath:M}))}async onDidChangeExtensionsFromAnotherSource({added:j,removed:W}){if(W){const T=j&&this.uriIdentityService.extUri.isEqual(W.profileLocation,j.profileLocation)?W.extensions.filter(M=>j.extensions.every($=>!(0,s.areSameExtensions)($,M))):W.extensions;for(const M of T)this.logService.info("Extensions removed from another source",M.id,W.profileLocation.toString()),this._onDidUninstallExtension.fire({identifier:M,profileLocation:W.profileLocation})}if(j){const M=(await this.getInstalled(1,j.profileLocation)).filter($=>j.extensions.some(Q=>(0,s.areSameExtensions)(Q,$.identifier)));this._onDidInstallExtensions.fire(M.map($=>(this.logService.info("Extensions added from another source",$.identifier.id,j.profileLocation.toString()),{identifier:$.identifier,local:$,profileLocation:j.profileLocation,operation:1})))}}async watchForExtensionsNotInstalledBySystem(){this._register(this.extensionsScanner.onExtract(W=>this.knownDirectories.add(W)));const j=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation);for(const W of j.children??[])W.isDirectory&&this.knownDirectories.add(W.resource);this._register(this.fileService.watch(this.extensionsScannerService.userExtensionsLocation)),this._register(this.fileService.onDidFilesChange(W=>this.onDidFilesChange(W)))}async onDidFilesChange(j){if(!j.affects(this.extensionsScannerService.userExtensionsLocation,1))return;const W=[];for(const T of j.rawAdded){if(this.knownDirectories.has(T)||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(T),this.extensionsScannerService.userExtensionsLocation)||this.uriIdentityService.extUri.isEqual(T,this.uriIdentityService.extUri.joinPath(this.extensionsScannerService.userExtensionsLocation,".obsolete"))||this.uriIdentityService.extUri.basename(T).startsWith(".")||!(await this.fileService.stat(T)).isDirectory)continue;const M=await this.extensionsScanner.scanUserExtensionAtLocation(T);M&&M.installedTimestamp===void 0&&(this.knownDirectories.add(T),W.push(M))}W.length&&(await this.addExtensionsToProfile(W.map(T=>[T,void 0]),this.userDataProfilesService.defaultProfile.extensionsResource),this.logService.info("Added extensions to default profile from external source",W.map(T=>T.identifier.id)))}async addExtensionsToProfile(j,W){const T=j.map(M=>M[0]);await this.setInstalled(T),await this.extensionsProfileScannerService.addExtensionsToProfile(j,W),this._onDidInstallExtensions.fire(T.map(M=>({local:M,identifier:M.identifier,operation:1,profileLocation:W})))}async setInstalled(j){const W=await this.extensionsScanner.getUninstalledExtensions();for(const T of j){const M=s.ExtensionKey.create(T);W[M.toString()]&&(this.logService.trace("Removing the extension from uninstalled list:",M.id),await this.extensionsScanner.setInstalled(M),this.logService.info("Removed the extension from uninstalled list:",M.id))}}};e.ExtensionManagementService=H,e.ExtensionManagementService=H=Ce([K(0,n.IExtensionGalleryService),K(1,X.ITelemetryService),K(2,F.ILogService),K(3,t.INativeEnvironmentService),K(4,o.IExtensionsScannerService),K(5,i.IExtensionsProfileScannerService),K(6,S.IDownloadService),K(7,N.IInstantiationService),K(8,L.IFileService),K(9,x.IProductService),K(10,B.IUriIdentityService),K(11,Y.IUserDataProfilesService)],H);let V=class extends d.Disposable{constructor(j,W,T,M,$,Q){super(),this.beforeRemovingExtension=j,this.fileService=W,this.extensionsScannerService=T,this.extensionsProfileScannerService=M,this.uriIdentityService=$,this.logService=Q,this._onExtract=this._register(new R.Emitter),this.onExtract=this._onExtract.event,this.uninstalledResource=(0,l.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete"),this.uninstalledFileLimiter=new _.Queue}async cleanUp(){await this.removeTemporarilyDeletedFolders(),await this.removeUninstalledExtensions()}async scanExtensions(j,W,T){const M={includeInvalid:!0,profileLocation:W,productVersion:T};let $=[];return j===null||j===0?$.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},M,!1)):j===1&&$.push(...await this.extensionsScannerService.scanUserExtensions(M)),$=j!==null?$.filter(Q=>Q.type===j):$,Promise.all($.map(Q=>this.toLocalExtension(Q)))}async scanAllUserExtensions(j){const W=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!j,includeInvalid:!0});return Promise.all(W.map(T=>this.toLocalExtension(T)))}async scanUserExtensionAtLocation(j){try{const W=await this.extensionsScannerService.scanExistingExtension(j,1,{includeInvalid:!0});if(W)return await this.toLocalExtension(W)}catch(W){this.logService.error(W)}return null}async extractUserExtension(j,W,T,M,$){const Q=j.toString(),G=g.URI.file(v.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`)),ee=g.URI.file(v.join(this.extensionsScannerService.userExtensionsLocation.fsPath,Q));let Z=await this.fileService.exists(ee);if(Z&&M){try{await this.deleteExtensionFromLocation(j.id,ee,"removeExisting")}catch{throw new n.ExtensionManagementError(f.localize(4,null,ee.fsPath,j.id),n.ExtensionManagementErrorCode.Delete)}Z=!1}if(Z)await this.extensionsScannerService.updateMetadata(ee,T);else try{try{this.logService.trace(`Started extracting the extension from ${W} to ${ee.fsPath}`),await(0,m.extract)(W,G.fsPath,{sourcePath:"extension",overwrite:!0},$),this.logService.info(`Extracted extension to ${ee}:`,j.id)}catch(J){let se=n.ExtensionManagementErrorCode.Extract;throw J instanceof m.ExtractError&&(J.type==="CorruptZip"?se=n.ExtensionManagementErrorCode.CorruptZip:J.type==="Incomplete"&&(se=n.ExtensionManagementErrorCode.IncompleteZip)),new n.ExtensionManagementError(J.message,se)}await this.extensionsScannerService.updateMetadata(G,T);try{this.logService.trace(`Started renaming the extension from ${G.fsPath} to ${ee.fsPath}`),await this.rename(G.fsPath,ee.fsPath),this.logService.info("Renamed to",ee.fsPath)}catch(J){if(J.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",j.id);else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(J)}. Deleted from extracted location`,G),J}this._onExtract.fire(ee)}catch(J){try{await this.fileService.del(G,{recursive:!0})}catch{}throw J}return this.scanLocalExtension(ee,1)}async scanMetadata(j,W){return W?(await this.getScannedExtension(j,W))?.metadata:this.extensionsScannerService.scanMetadata(j.location)}async getScannedExtension(j,W){return(await this.extensionsProfileScannerService.scanProfileExtensions(W)).find(M=>(0,s.areSameExtensions)(M.identifier,j.identifier))}async updateMetadata(j,W,T){return T?await this.extensionsProfileScannerService.updateMetadata([[j,W]],T):await this.extensionsScannerService.updateMetadata(j.location,W),this.scanLocalExtension(j.location,j.type,T)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...j){const W=j.map(T=>s.ExtensionKey.create(T));await this.withUninstalledExtensions(T=>W.forEach(M=>{T[M.toString()]=!0,this.logService.info("Marked extension as uninstalled",M.toString())}))}async setInstalled(j){await this.withUninstalledExtensions(W=>delete W[j.toString()])}async removeExtension(j,W){if(this.uriIdentityService.extUri.isEqualOrParent(j.location,this.extensionsScannerService.userExtensionsLocation))return this.deleteExtensionFromLocation(j.identifier.id,j.location,W)}async removeUninstalledExtension(j){await this.removeExtension(j,"uninstalled"),await this.withUninstalledExtensions(W=>delete W[s.ExtensionKey.create(j).toString()])}async copyExtension(j,W,T,M){const $=await this.getScannedExtension(j,W),Q=await this.getScannedExtension(j,T);if(M={...$?.metadata,...M},Q)if(this.uriIdentityService.extUri.isEqual(Q.location,j.location))await this.extensionsProfileScannerService.updateMetadata([[j,{...Q.metadata,...M}]],T);else{const G=await this.scanLocalExtension(Q.location,j.type,T);await this.extensionsProfileScannerService.removeExtensionFromProfile(G,T),await this.extensionsProfileScannerService.addExtensionsToProfile([[j,{...Q.metadata,...M}]],T)}else await this.extensionsProfileScannerService.addExtensionsToProfile([[j,M]],T);return this.scanLocalExtension(j.location,j.type,T)}async copyExtensions(j,W,T){const M=await this.scanExtensions(1,j,T),$=await Promise.all(M.filter(Q=>!Q.isApplicationScoped).map(async Q=>[Q,await this.scanMetadata(Q,j)]));await this.extensionsProfileScannerService.addExtensionsToProfile($,W)}async deleteExtensionFromLocation(j,W,T){this.logService.trace(`Deleting ${T} extension from disk`,j,W.fsPath);const M=this.uriIdentityService.extUri.joinPath(this.uriIdentityService.extUri.dirname(W),`${this.uriIdentityService.extUri.basename(W)}.${(0,P.hash)((0,u.generateUuid)()).toString(16)}${z}`);await this.rename(W.fsPath,M.fsPath),await this.fileService.del(M,{recursive:!0}),this.logService.info(`Deleted ${T} extension from disk`,j,W.fsPath)}async withUninstalledExtensions(j){return this.uninstalledFileLimiter.queue(async()=>{let W;try{W=(await this.fileService.readFile(this.uninstalledResource,"utf8")).value.toString()}catch(M){if((0,L.toFileOperationResult)(M)!==1)throw M}let T={};if(W)try{T=JSON.parse(W)}catch{}return j&&(j(T),Object.keys(T).length?await this.fileService.writeFile(this.uninstalledResource,U.VSBuffer.fromString(JSON.stringify(T))):await this.fileService.del(this.uninstalledResource)),T})}async rename(j,W){try{await h.Promises.rename(j,W,2*60*1e3)}catch(T){throw new n.ExtensionManagementError(T.message||f.localize(5,null,j,W),T.code||n.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(j,W,T){if(T){const $=(await this.extensionsScannerService.scanUserExtensions({profileLocation:T})).find(Q=>this.uriIdentityService.extUri.isEqual(Q.location,j));if($)return this.toLocalExtension($)}else{const M=await this.extensionsScannerService.scanExistingExtension(j,W,{includeInvalid:!0});if(M)return this.toLocalExtension(M)}throw new Error(f.localize(6,null,j.path))}async toLocalExtension(j){const W=await this.fileService.resolve(j.location);let T,M;return W.children&&(T=W.children.find(({name:$})=>/^readme(\.txt|\.md|)$/i.test($))?.resource,M=W.children.find(({name:$})=>/^changelog(\.txt|\.md|)$/i.test($))?.resource),{identifier:j.identifier,type:j.type,isBuiltin:j.isBuiltin||!!j.metadata?.isBuiltin,location:j.location,manifest:j.manifest,targetPlatform:j.targetPlatform,validations:j.validations,isValid:j.isValid,readmeUrl:T,changelogUrl:M,publisherDisplayName:j.metadata?.publisherDisplayName,publisherId:j.metadata?.publisherId||null,isApplicationScoped:!!j.metadata?.isApplicationScoped,isMachineScoped:!!j.metadata?.isMachineScoped,isPreReleaseVersion:!!j.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!j.metadata?.hasPreReleaseVersion,preRelease:!!j.metadata?.preRelease,installedTimestamp:j.metadata?.installedTimestamp,updated:!!j.metadata?.updated,pinned:!!j.metadata?.pinned,isWorkspaceScoped:!1,source:j.metadata?.source??(j.identifier.uuid?"gallery":"vsix")}}async removeUninstalledExtensions(){const j=await this.getUninstalledExtensions();if(Object.keys(j).length===0){this.logService.debug("No uninstalled extensions found.");return}this.logService.debug("Removing uninstalled extensions:",Object.keys(j));const W=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),T=new Set;for(const $ of W)j[s.ExtensionKey.create($).toString()]||T.add($.identifier.id.toLowerCase());try{const $=(0,s.groupByExtension)(W,Q=>Q.identifier);await _.Promises.settled($.map(async Q=>{const G=Q.sort((ee,Z)=>c.rcompare(ee.manifest.version,Z.manifest.version))[0];T.has(G.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(G))}))}catch($){this.logService.error($)}const M=W.filter($=>$.metadata&&j[s.ExtensionKey.create($).toString()]);await Promise.allSettled(M.map($=>this.removeUninstalledExtension($)))}async removeTemporarilyDeletedFolders(){this.logService.trace("ExtensionManagementService#removeTempDeleteFolders");let j;try{j=await this.fileService.resolve(this.extensionsScannerService.userExtensionsLocation)}catch(W){(0,L.toFileOperationResult)(W)!==1&&this.logService.error(W);return}if(j?.children)try{await Promise.allSettled(j.children.map(async W=>{if(!(!W.isDirectory||!W.name.endsWith(z))){this.logService.trace("Deleting the temporarily deleted folder",W.resource.toString());try{await this.fileService.del(W.resource,{recursive:!0}),this.logService.trace("Deleted the temporarily deleted folder",W.resource.toString())}catch(T){(0,L.toFileOperationResult)(T)!==1&&this.logService.error(T)}}}))}catch{}}};e.ExtensionsScanner=V,e.ExtensionsScanner=V=Ce([K(1,L.IFileService),K(2,o.IExtensionsScannerService),K(3,i.IExtensionsProfileScannerService),K(4,B.IUriIdentityService),K(5,F.ILogService)],V);class q extends r.AbstractExtensionTask{get profileLocation(){return this._profileLocation}get verificationStatus(){return this._verificationStatus}get operation(){return(0,p.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(j,W,T,M,$,Q,G,ee,Z,J){super(),this.manifest=j,this.identifier=W,this.source=T,this.options=M,this.extensionsScanner=$,this.uriIdentityService=Q,this.userDataProfilesService=G,this.extensionsScannerService=ee,this.extensionsProfileScannerService=Z,this.logService=J,this._profileLocation=this.options.profileLocation,this._verificationStatus=!1,this._operation=2}async doRun(j){const[W,T]=await this.install(j);return this._profileLocation=W.isBuiltin||W.isApplicationScoped?this.userDataProfilesService.defaultProfile.extensionsResource:this.options.profileLocation,this.uriIdentityService.extUri.isEqual(this.userDataProfilesService.defaultProfile.extensionsResource,this._profileLocation)&&await this.extensionsScannerService.initializeDefaultProfileExtensions(),await this.extensionsProfileScannerService.addExtensionsToProfile([[W,T]],this._profileLocation,!W.isValid),W}async extractExtension({zipPath:j,key:W,metadata:T},M,$){let Q=await this.unsetIfUninstalled(W);return Q?Q=await this.extensionsScanner.updateMetadata(Q,T):(this.logService.trace("Extracting extension...",W.id),Q=await this.extensionsScanner.extractUserExtension(W,j,T,M,$),this.logService.info("Extracting extension completed.",W.id)),Q}async unsetIfUninstalled(j){return await this.isUninstalled(j)?(this.logService.trace("Removing the extension from uninstalled list:",j.id),await this.extensionsScanner.setInstalled(j),this.logService.info("Removed the extension from uninstalled list:",j.id),(await this.extensionsScanner.scanAllUserExtensions(!0)).find(M=>s.ExtensionKey.create(M).equals(j))):void 0}async isUninstalled(j){return!!(await this.extensionsScanner.getUninstalledExtensions())[j.toString()]}}class ie extends q{constructor(j,W,T,M,$,Q,G,ee,Z,J,se){super(j,W.identifier,W,T,$,Q,G,ee,Z,J),this.gallery=W,this.extensionsDownloader=M,this.telemetryService=se}async install(j){let W;try{W=await this.extensionsScanner.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch($){throw new n.ExtensionManagementError($,n.ExtensionManagementErrorCode.Scanning)}const T=W.find($=>(0,s.areSameExtensions)($.identifier,this.gallery.identifier));T&&(this._operation=3);const M={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||T?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||T?.isMachineScoped,isBuiltin:this.options.isBuiltin||T?.isBuiltin,isSystem:T?.type===0?!0:void 0,updated:!!T,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,hasPreReleaseVersion:T?.hasPreReleaseVersion||this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??T?.pinned,preRelease:(0,p.isBoolean)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.gallery.properties.isPreReleaseVersion||T?.preRelease,source:"gallery"};if(T&&T.type!==0&&T.manifest.version===this.gallery.version)try{return[await this.extensionsScanner.updateMetadata(T,M),M]}catch($){throw new n.ExtensionManagementError((0,k.getErrorMessage)($),n.ExtensionManagementErrorCode.UpdateMetadata)}try{return await this.downloadAndInstallExtension(M,j)}catch($){if($ instanceof n.ExtensionManagementError&&($.code===n.ExtensionManagementErrorCode.CorruptZip||$.code===n.ExtensionManagementErrorCode.IncompleteZip)){this.logService.info("Downloaded VSIX is invalid. Trying to download and install again...",this.gallery.identifier.id);try{const Q=await this.downloadAndInstallExtension(M,j);return this.telemetryService.publicLog2("extensiongallery:install:retry",{extensionId:this.gallery.identifier.id,succeeded:!0}),Q}catch(Q){throw this.telemetryService.publicLog2("extensiongallery:install:retry",{extensionId:this.gallery.identifier.id,succeeded:!1}),Q}}else throw $}}async downloadAndInstallExtension(j,W){const{location:T,verificationStatus:M}=await this.extensionsDownloader.download(this.gallery,this._operation,!this.options.donotVerifySignature);try{return this._verificationStatus=M,this.validateManifest(T.fsPath),[await this.extractExtension({zipPath:T.fsPath,key:s.ExtensionKey.create(this.gallery),metadata:j},!1,W),j]}catch($){try{await this.extensionsDownloader.delete(T)}catch(Q){this.logService.warn("Error while deleting the downloaded file",T.toString(),(0,k.getErrorMessage)(Q))}throw $}}async validateManifest(j){try{await(0,I.getManifest)(j)}catch(W){throw new n.ExtensionManagementError(W.message,n.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=ie;class re extends q{constructor(j,W,T,M,$,Q,G,ee,Z,J){super(j,{id:(0,s.getGalleryExtensionId)(j.publisher,j.name)},W,T,$,Q,G,ee,Z,J),this.location=W,this.galleryService=M}async doRun(j){const W=await super.doRun(j);return this.updateMetadata(W,j),W}async install(j){const W=new s.ExtensionKey(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(G=>(0,s.areSameExtensions)(this.identifier,G.identifier)),$={isApplicationScoped:this.options.isApplicationScoped||M?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||M?.isMachineScoped,isBuiltin:this.options.isBuiltin||M?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??M?.pinned,source:"vsix"};if(M)if(this._operation=3,W.equals(new s.ExtensionKey(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch{throw new Error(f.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&c.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const G=await this.unsetIfUninstalled(W);if(G)try{await this.extensionsScanner.removeExtension(G,"existing")}catch{throw new Error(f.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.extractExtension({zipPath:v.resolve(this.location.fsPath),key:W,metadata:$},!0,j),$]}async updateMetadata(j,W){try{let[T]=await this.galleryService.getExtensions([{id:j.identifier.id,version:j.manifest.version}],W);if(T||([T]=await this.galleryService.getExtensions([{id:j.identifier.id}],W)),T){const M={id:T.identifier.uuid,publisherDisplayName:T.publisherDisplayName,publisherId:T.publisherId,isPreReleaseVersion:T.properties.isPreReleaseVersion,hasPreReleaseVersion:j.hasPreReleaseVersion||T.properties.isPreReleaseVersion,preRelease:T.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.extensionsScanner.updateMetadata(j,M,this.options.profileLocation)}}catch{}}}class ue extends r.AbstractExtensionTask{constructor(j,W,T){super(),this.extension=j,this.profileLocation=W,this.extensionsProfileScannerService=T}async doRun(j){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension,this.profileLocation)}}}),define(ae[252],ce([0,1,9,18,28,22,52,12,16,8]),function(ne,e,_,U,A,O,k,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let C=class extends k.AbstractExtensionsProfileScannerService{constructor(v,l,c,p,g,u){super(d.URI.file(v.extensionsPath),l,c,p,g,u)}};e.ExtensionsProfileScannerService=C,e.ExtensionsProfileScannerService=C=Ce([K(0,P.INativeEnvironmentService),K(1,R.IFileService),K(2,U.IUserDataProfilesService),K(3,A.IUriIdentityService),K(4,O.ITelemetryService),K(5,_.ILogService)],C)}),define(ae[253],ce([0,1,8,16,52,81,12,4,9,24,28,18]),function(ne,e,_,U,A,O,k,R,P,d,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let v=class extends O.NativeExtensionsScannerService{constructor(c,p,g,u,h,m,f,S){super(_.URI.file(h.builtinExtensionsPath),_.URI.file(h.extensionsPath),h.userHome,c.defaultProfile,c,p,g,u,h,m,f,S)}};e.ExtensionsScannerService=v,e.ExtensionsScannerService=v=Ce([K(0,E.IUserDataProfilesService),K(1,A.IExtensionsProfileScannerService),K(2,k.IFileService),K(3,P.ILogService),K(4,U.INativeEnvironmentService),K(5,d.IProductService),K(6,C.IUriIdentityService),K(7,R.IInstantiationService)],v)}),define(ae[19],ce([0,1,6,3,2,98,13,69,4,18]),function(ne,e,_,U,A,O,k,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.loadKeyTargets=l,e.isProfileUsingDefaultStorage=p,e.logStorage=u,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,P.createDecorator)("storageService");var C;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var E;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var v;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function l(h){const m=h.get(e.TARGET_KEY);if(m)try{return JSON.parse(m)}catch{}return Object.create(null)}class c extends A.Disposable{static{this.DEFAULT_FLUSH_INTERVAL=60*1e3}constructor(m={flushInterval:c.DEFAULT_FLUSH_INTERVAL}){super(),this.options=m,this._onDidChangeValue=this._register(new U.PauseableEmitter),this._onDidChangeTarget=this._register(new U.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new U.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new _.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new A.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}onDidChangeValue(m,f,S){return U.Event.filter(this._onDidChangeValue.event,t=>t.scope===m&&(f===void 0||t.key===f),S)}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,_.runWhenGlobalIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,A.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,O.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,f){const{key:S,external:t}=f;if(S===e.TARGET_KEY){switch(m){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:m})}else this._onDidChangeValue.fire({scope:m,key:S,target:this.getKeyTargets(m)[S],external:t})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,f,S){return this.getStorage(f)?.get(m,S)}getBoolean(m,f,S){return this.getStorage(f)?.getBoolean(m,S)}getNumber(m,f,S){return this.getStorage(f)?.getNumber(m,S)}getObject(m,f,S){return this.getStorage(f)?.getObject(m,S)}storeAll(m,f){this.withPausedEmitters(()=>{for(const S of m)this.store(S.key,S.value,S.scope,S.target,f)})}store(m,f,S,t,r=!1){if((0,k.isUndefinedOrNull)(f)){this.remove(m,S,r);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,S,t),this.getStorage(S)?.set(m,f,r)})}remove(m,f,S=!1){this.withPausedEmitters(()=>{this.updateKeyTarget(m,f,void 0),this.getStorage(f)?.delete(m,S)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,f){const S=[],t=this.getKeyTargets(m);for(const r of Object.keys(t))t[r]===f&&S.push(r);return S}updateKeyTarget(m,f,S,t=!1){const r=this.getKeyTargets(f);typeof S=="number"?r[m]!==S&&(r[m]=S,this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(r),t)):typeof r[m]=="number"&&(delete r[m],this.getStorage(f)?.set(e.TARGET_KEY,JSON.stringify(r),t))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(m){switch(m){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(m){const f=this.getStorage(m);return f?l(f):Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=C.NONE){this._onWillSaveState.fire({reason:m});const f=this.getStorage(-1),S=this.getStorage(0),t=this.getStorage(1);switch(m){case C.NONE:await _.Promises.settled([f?.whenFlushed()??Promise.resolve(),S?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await _.Promises.settled([f?.flush(0)??Promise.resolve(),S?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.getStorage(-1)?.items??new Map,f=this.getStorage(0)?.items??new Map,S=this.getStorage(1)?.items??new Map;return u(m,f,S,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async optimize(m){return await this.flush(),this.getStorage(m)?.optimize()}async switch(m,f){return this.emitWillSaveState(C.NONE),(0,d.isUserDataProfile)(m)?this.switchToProfile(m,f):this.switchToWorkspace(m,f)}canSwitchProfile(m,f){return!(m.id===f.id||p(f)&&p(m))}switchData(m,f,S){this.withPausedEmitters(()=>{const t=new Set;for(const[r,n]of m)t.add(r),f.get(r)!==n&&this.emitDidChangeValue(S,{key:r,external:!0});for(const[r]of f.items)t.has(r)||this.emitDidChangeValue(S,{key:r,external:!0})})}}e.AbstractStorageService=c;function p(h){return h.isDefault||!!h.useDefaultFlags?.globalState}class g extends c{constructor(){super(),this.applicationStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.profileStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.profileStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m))),this._register(this.applicationStorage.onDidChangeStorage(m=>this.emitDidChangeValue(-1,m)))}getStorage(m){switch(m){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(m){switch(m){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}shouldFlushWhenIdle(){return!1}hasScope(m){return!1}}e.InMemoryStorageService=g;async function u(h,m,f,S,t,r){const n=D=>{try{return JSON.parse(D)}catch{return D}},s=new Map,i=new Map;h.forEach((D,L)=>{s.set(L,D),i.set(L,n(D))});const o=new Map,a=new Map;m.forEach((D,L)=>{o.set(L,D),a.set(L,n(D))});const y=new Map,I=new Map;f.forEach((D,L)=>{y.set(L,D),I.set(L,n(D))}),console.group(S!==t?`Storage: Application (path: ${S})`:`Storage: Application & Profile (path: ${S}, default profile)`);const w=[];if(s.forEach((D,L)=>{w.push({key:L,value:D})}),console.table(w),console.groupEnd(),console.log(i),S!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const D=[];o.forEach((L,N)=>{D.push({key:N,value:L})}),console.table(D),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${r})`);const b=[];y.forEach((D,L)=>{b.push({key:L,value:D})}),console.table(b),console.groupEnd(),console.log(I)}}),define(ae[114],ce([0,1,3,2,13,29,33,19]),function(ne,e,_,U,A,O,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let P=class extends U.Disposable{constructor(E,v){super(),this._onDidChangeEnablement=new _.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new d(E)),this._register(this.storageManger.onDidChange(l=>this._onDidChangeEnablement.fire({extensions:l,source:"storage"}))),this._register(v.onDidInstallExtensions(l=>l.forEach(({local:c,operation:p})=>{c&&p===4&&this._removeFromDisabledExtensions(c.identifier)})))}async enableExtension(E,v){return this._removeFromDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:v}),!0):!1}async disableExtension(E,v){return this._addToDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:v}),!0):!1}getDisabledExtensions(){return this._getExtensions(O.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(E){const v=this.getDisabledExtensions();return v.every(l=>!(0,k.areSameExtensions)(l,E))?(v.push(E),this._setDisabledExtensions(v),!0):!1}_removeFromDisabledExtensions(E){const v=this.getDisabledExtensions();for(let l=0;l<v.length;l++){const c=v[l];if((0,k.areSameExtensions)(c,E))return v.splice(l,1),this._setDisabledExtensions(v),!0}return!1}_setDisabledExtensions(E){this._setExtensions(O.DISABLED_EXTENSIONS_STORAGE_PATH,E)}_getExtensions(E){return this.storageManger.get(E,0)}_setExtensions(E,v){this.storageManger.set(E,v,0)}};e.GlobalExtensionEnablementService=P,e.GlobalExtensionEnablementService=P=Ce([K(0,R.IStorageService),K(1,O.IExtensionManagementService)],P);class d extends U.Disposable{constructor(E){super(),this.storageService=E,this.storage=Object.create(null),this._onDidChange=this._register(new _.Emitter),this.onDidChange=this._onDidChange.event,this._register(E.onDidChangeValue(0,void 0,this._register(new U.DisposableStore))(v=>this.onDidStorageChange(v)))}get(E,v){let l;return v===0?((0,A.isUndefinedOrNull)(this.storage[E])&&(this.storage[E]=this._get(E,v)),l=this.storage[E]):l=this._get(E,v),JSON.parse(l)}set(E,v,l){const c=JSON.stringify(v.map(({id:g,uuid:u})=>({id:g,uuid:u})));this._get(E,l)!==c&&(l===0&&(v.length?this.storage[E]=c:delete this.storage[E]),this._set(E,v.length?c:void 0,l))}onDidStorageChange(E){if(!(0,A.isUndefinedOrNull)(this.storage[E.key])&&this._get(E.key,E.scope)!==this.storage[E.key]){const l=this.get(E.key,E.scope);delete this.storage[E.key];const c=this.get(E.key,E.scope),p=l.filter(u=>!c.some(h=>(0,k.areSameExtensions)(u,h))),g=c.filter(u=>!l.some(h=>(0,k.areSameExtensions)(h,u)));(p.length||g.length)&&this._onDidChange.fire([...p,...g])}}_get(E,v){return this.storageService.get(E,v,"[]")}_set(E,v,l){v?this.storageService.store(E,v,l,1):this.storageService.remove(E,l)}}e.StorageManager=d}),define(ae[254],ce([0,1,17,26,7,5,36,13,8,21,16,29,33,71,12,9,24,59,233,19,22,63]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g,u,h,m,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=void 0,e.sortExtensionVersions=re;const t=O.isWeb?"web":(0,E.getTargetPlatform)(O.platform,k.arch),r="X-Market-Search-Activity-Id";var n;(function(M){M[M.None=0]="None",M[M.IncludeVersions=1]="IncludeVersions",M[M.IncludeFiles=2]="IncludeFiles",M[M.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",M[M.IncludeSharedAccounts=8]="IncludeSharedAccounts",M[M.IncludeVersionProperties=16]="IncludeVersionProperties",M[M.ExcludeNonValidated=32]="ExcludeNonValidated",M[M.IncludeInstallationTargets=64]="IncludeInstallationTargets",M[M.IncludeAssetUri=128]="IncludeAssetUri",M[M.IncludeStatistics=256]="IncludeStatistics",M[M.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",M[M.Unpublished=4096]="Unpublished",M[M.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...M){return String(M.reduce(($,Q)=>$|Q,0))}var i;(function(M){M[M.Tag=1]="Tag",M[M.ExtensionId=4]="ExtensionId",M[M.Category=5]="Category",M[M.ExtensionName=7]="ExtensionName",M[M.Target=8]="Target",M[M.Featured=9]="Featured",M[M.SearchText=10]="SearchText",M[M.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class w{constructor($=I){this.state=$}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage($,Q=this.state.pageSize){return new w({...this.state,pageNumber:$,pageSize:Q})}withFilter($,...Q){const G=[...this.state.criteria,...Q.length?Q.map(ee=>({filterType:$,value:ee})):[{filterType:$}]];return new w({...this.state,criteria:G})}withSortBy($){return new w({...this.state,sortBy:$})}withSortOrder($){return new w({...this.state,sortOrder:$})}withFlags(...$){return new w({...this.state,flags:$.reduce((Q,G)=>Q|G,0)})}withAssetTypes(...$){return new w({...this.state,assetTypes:$})}withSource($){return new w({...this.state,source:$})}get raw(){const{criteria:$,pageNumber:Q,pageSize:G,sortBy:ee,sortOrder:Z,flags:J,assetTypes:se}=this.state;return{filters:[{criteria:$,pageNumber:Q,pageSize:G,sortBy:ee,sortOrder:Z}],assetTypes:se,flags:J}}get searchText(){const $=this.state.criteria.filter(Q=>Q.filterType===i.SearchText)[0];return $&&$.value?$.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map($=>String($.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function b(M,$){const Q=(M||[]).filter(G=>G.statisticName===$)[0];return Q?Q.value:0}function D(M){const $="Microsoft.VisualStudio.Code.Translation.";return M.files.filter(G=>G.assetType.indexOf($)===0).reduce((G,ee)=>{const Z=F(M,ee.assetType);return Z&&G.push([ee.assetType.substring($.length),Z]),G},[])}function L(M){if(M.properties){const $=M.properties.filter(ee=>ee.key===o.Repository),Q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),G=$.filter(ee=>Q.test(ee.value))[0];return G?{uri:G.value,fallbackUri:G.value}:null}return F(M,o.Repository)}function N(M){return{uri:`${M.fallbackAssetUri}/${o.VSIX}?redirect=true${M.targetPlatform?`&targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${o.VSIX}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}}function F(M,$){return M.files.filter(G=>G.assetType===$)[0]?{uri:`${M.assetUri}/${$}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`,fallbackUri:`${M.fallbackAssetUri}/${$}${M.targetPlatform?`?targetPlatform=${M.targetPlatform}`:""}`}:null}function x(M,$){const Q=M.properties?M.properties.filter(ee=>ee.key===$):[],G=Q.length>0&&Q[0].value;return G?G.split(",").map(ee=>(0,v.adoptToGalleryExtensionId)(ee)):[]}function X(M){const $=M.properties?M.properties.filter(Q=>Q.key===a.Engine):[];return $.length>0&&$[0].value||""}function B(M){const $=M.properties?M.properties.filter(Q=>Q.key===a.PreRelease):[];return $.length>0&&$[0].value==="true"}function Y(M){const $=M.properties?M.properties.filter(G=>G.key===a.LocalizedLanguages):[],Q=$.length>0&&$[0].value||"";return Q?Q.split(","):[]}function z(M){return M.properties?.find($=>$.key===a.SponsorLink)?.value}function H(M){return M.properties?.find($=>$.key===a.SupportLink)?.value}function V(M){return M.indexOf("preview")!==-1}function q(M){return M.targetPlatform?(0,E.toTargetPlatform)(M.targetPlatform):"undefined"}function ie(M){const $=(0,_.distinct)(M.versions.map(q)),Q=!!M.tags?.includes(E.WEB_EXTENSION_TAG),G=$.indexOf("web");return Q?G===-1&&$.push("web"):G!==-1&&$.splice(G,1),$}function re(M,$){for(let Q=0;Q<M.length;Q++){const G=M[Q];if(G.version===M[Q-1]?.version){let ee=Q;if(q(G)===$)for(;ee>0&&M[ee-1].version===G.version;)ee--;ee!==Q&&(M.splice(Q,1),M.splice(ee,0,G))}}return M}function ue(M,$,Q){M.telemetryData={index:$,querySource:Q,queryActivityId:M.queryContext?.[r]}}function te(M,$,Q,G){const ee=M.versions[0],Z={manifest:F($,o.Manifest),readme:F($,o.Details),changelog:F($,o.Changelog),license:F($,o.License),repository:L($),download:N($),icon:F($,o.Icon),signature:F($,o.Signature),coreTranslations:D($)};return{identifier:{id:(0,v.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},name:M.extensionName,version:$.version,displayName:M.displayName,publisherId:M.publisher.publisherId,publisher:M.publisher.publisherName,publisherDisplayName:M.publisher.displayName,publisherDomain:M.publisher.domain?{link:M.publisher.domain,verified:!!M.publisher.isDomainVerified}:void 0,publisherSponsorLink:z(ee),description:M.shortDescription??"",installCount:b(M.statistics,"install"),rating:b(M.statistics,"averagerating"),ratingCount:b(M.statistics,"ratingcount"),categories:M.categories||[],tags:M.tags||[],releaseDate:Date.parse(M.releaseDate),lastUpdated:Date.parse(M.lastUpdated),allTargetPlatforms:Q,assets:Z,properties:{dependencies:x($,a.Dependency),extensionPack:x($,a.ExtensionPack),engine:X($),localizedLanguages:Y($),targetPlatform:q($),isPreReleaseVersion:B($)},hasPreReleaseVersion:B(ee),hasReleaseVersion:!0,preview:V(M.flags),isSigned:!!Z.signature,queryContext:G,supportLink:H(ee)}}let j=class{constructor($,Q,G,ee,Z,J,se,he){this.requestService=Q,this.logService=G,this.environmentService=ee,this.telemetryService=Z,this.fileService=J,this.productService=se,this.configurationService=he;const ge=se.extensionsGallery,de=ge?.servicePPEUrl&&he.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=de?ge.servicePPEUrl:ge?.serviceUrl,this.extensionsGallerySearchUrl=de?void 0:ge?.searchUrl,this.extensionsControlUrl=ge?.controlUrl,this.commonHeadersPromise=(0,h.resolveMarketplaceHeaders)(se.version,se,this.environmentService,this.configurationService,this.fileService,$,this.telemetryService)}api($=""){return`${this.extensionsGalleryUrl}${$}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions($,Q,G){const ee=U.CancellationToken.isCancellationToken(Q)?{}:Q,Z=U.CancellationToken.isCancellationToken(Q)?Q:G,J=[],se=[],he=[],ge=[];let de=!0;for(const we of $){we.uuid?se.push(we.uuid):J.push(we.id);const Pe=!!(we.version||we.preRelease);he.push({id:we.id,uuid:we.uuid,includePreRelease:Pe}),we.version&&ge.push({id:we.id,uuid:we.uuid,version:we.version}),de=de&&!!we.hasPreRelease&&!Pe}if(!se.length&&!J.length)return[];let me=new w().withPage(1,$.length);se.length&&(me=me.withFilter(i.ExtensionId,...se)),J.length&&(me=me.withFilter(i.ExtensionName,...J)),(ee.queryAllVersions||de)&&(me=me.withFlags(me.flags,n.IncludeVersions)),ee.source&&(me=me.withSource(ee.source));const{extensions:Ee}=await this.queryGalleryExtensions(me,{targetPlatform:ee.targetPlatform??t,includePreRelease:he,versions:ge,compatible:!!ee.compatible,productVersion:ee.productVersion??{version:this.productService.version,date:this.productService.date}},Z);return ee.source&&Ee.forEach((we,Pe)=>ue(we,Pe,ee.source)),Ee}async getCompatibleExtension($,Q,G,ee={version:this.productService.version,date:this.productService.date}){if((0,E.isNotWebExtensionInWebTargetPlatform)($.allTargetPlatforms,G))return null;if(await this.isExtensionCompatible($,Q,G))return $;const Z=new w().withFlags(n.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,$.identifier.uuid),{extensions:J}=await this.queryGalleryExtensions(Z,{targetPlatform:G,compatible:!0,includePreRelease:Q,productVersion:ee},U.CancellationToken.None);return J[0]||null}async isExtensionCompatible($,Q,G,ee={version:this.productService.version,date:this.productService.date}){if(!(0,E.isTargetPlatformCompatible)($.properties.targetPlatform,$.allTargetPlatforms,G)||!Q&&$.properties.isPreReleaseVersion)return!1;let Z=$.properties.engine;if(!Z){const J=await this.getManifest($,U.CancellationToken.None);if(!J)throw new Error("Manifest was not found");Z=J.engines.vscode}return(0,l.isEngineValid)(Z,ee.version,ee.date)}async isValidVersion($,Q,G,ee,Z,J,se={version:this.productService.version,date:this.productService.date}){if(!(0,E.isTargetPlatformCompatible)(q(Q),Z,J)||G!=="any"&&B(Q)!==(G==="prerelease"))return!1;if(ee)try{const he=await this.getEngine($,Q);if(!(0,l.isEngineValid)(he,se.version,se.date))return!1}catch(he){return this.logService.error(`Error while getting the engine for the version ${Q.version}.`,(0,A.getErrorMessage)(he)),!1}return!0}async query($,Q){let G=$.text||"";const ee=$.pageSize??50;let Z=new w().withPage(1,ee);G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,me,Ee)=>(Z=Z.withFilter(i.Category,Ee||me),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,me,Ee)=>(Z=Z.withFilter(i.Tag,Ee||me),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(Z=Z.withFilter(i.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),Z=Z.withFilter(i.SearchText,G)),Z=Z.withSortBy(0)):$.ids?Z=Z.withFilter(i.ExtensionId,...$.ids):$.names?Z=Z.withFilter(i.ExtensionName,...$.names):Z=Z.withSortBy(4),typeof $.sortBy=="number"&&(Z=Z.withSortBy($.sortBy)),typeof $.sortOrder=="number"&&(Z=Z.withSortOrder($.sortOrder)),$.source&&(Z=Z.withSource($.source));const J=async(de,me)=>{const{extensions:Ee,total:we}=await this.queryGalleryExtensions(de,{targetPlatform:t,compatible:!1,includePreRelease:!!$.includePreRelease,productVersion:$.productVersion??{version:this.productService.version,date:this.productService.date}},me);return Ee.forEach((Pe,_e)=>ue(Pe,(de.pageNumber-1)*de.pageSize+_e,$.source)),{extensions:Ee,total:we}},{extensions:se,total:he}=await J(Z,Q),ge=async(de,me)=>{if(me.isCancellationRequested)throw new A.CancellationError;const{extensions:Ee}=await J(Z.withPage(de+1),me);return Ee};return{firstPage:se,total:he,pageSize:Z.pageSize,getPage:ge}}async queryGalleryExtensions($,Q,G){const ee=$.flags;$.flags&n.IncludeLatestVersionOnly&&$.flags&n.IncludeVersions&&($=$.withFlags($.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!($.flags&n.IncludeLatestVersionOnly)&&!($.flags&n.IncludeVersions)&&($=$.withFlags($.flags,n.IncludeLatestVersionOnly)),Q.versions?.length&&($=$.withFlags($.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),$=$.withFlags($.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:Z,total:J,context:se}=await this.queryRawGalleryExtensions($,G);if(!($.flags&n.IncludeLatestVersionOnly)){const me=[];for(const Ee of Z){const we=await this.toGalleryExtensionWithCriteria(Ee,Q,se);we&&me.push(we)}return{extensions:me,total:J}}const ge=[],de=new Map;for(let me=0;me<Z.length;me++){const Ee=Z[me],we={id:(0,v.getGalleryExtensionId)(Ee.publisher.publisherName,Ee.extensionName),uuid:Ee.extensionId},Pe=(0,R.isBoolean)(Q.includePreRelease)?Q.includePreRelease:!!Q.includePreRelease.find(le=>(0,v.areSameExtensions)(le,we))?.includePreRelease;if(Q.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(ie(Ee),Q.targetPlatform))continue;const _e=await this.toGalleryExtensionWithCriteria(Ee,Q,se);!_e||_e.properties.isPreReleaseVersion&&(!Pe||!_e.hasReleaseVersion)||!_e.properties.isPreReleaseVersion&&_e.properties.targetPlatform!==Q.targetPlatform&&_e.hasPreReleaseVersion?de.set(Ee.extensionId,me):ge.push([me,_e])}if(de.size){const me=new S.StopWatch,Ee=new w().withFlags(ee&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,de.size).withFilter(i.ExtensionId,...de.keys()),{extensions:we}=await this.queryGalleryExtensions(Ee,Q,G);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:de.size});for(const Pe of we){const _e=de.get(Pe.identifier.uuid);ge.push([_e,Pe])}}return{extensions:ge.sort((me,Ee)=>me[0]-Ee[0]).map(([,me])=>me),total:J}}async toGalleryExtensionWithCriteria($,Q,G){const ee={id:(0,v.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},Z=Q.versions?.find(ge=>(0,v.areSameExtensions)(ge,ee))?.version,J=(0,R.isBoolean)(Q.includePreRelease)?Q.includePreRelease:!!Q.includePreRelease.find(ge=>(0,v.areSameExtensions)(ge,ee))?.includePreRelease,se=ie($),he=re($.versions,Q.targetPlatform);if(Q.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(se,Q.targetPlatform))return null;for(let ge=0;ge<he.length;ge++){const de=he[ge];if(!(Z&&de.version!==Z)){if(await this.isValidVersion((0,v.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),de,J?"any":"release",Q.compatible,se,Q.targetPlatform,Q.productVersion))return te($,de,se,G);if(Z&&de.version===Z)return null}}return Z||Q.compatible?null:te($,$.versions[0],se)}async queryRawGalleryExtensions($,Q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");$=$.withFlags($.flags,n.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,s(n.Unpublished));const G=await this.commonHeadersPromise,ee=JSON.stringify($.raw),Z={...G,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},J=new S.StopWatch;let se,he,ge=0;try{if(se=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&$.criteria.some(me=>me.filterType===i.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:ee,headers:Z},Q),se.res.statusCode&&se.res.statusCode>=400&&se.res.statusCode<500)return{galleryExtensions:[],total:ge};const de=await(0,u.asJson)(se);if(de){const me=de.results[0],Ee=me.extensions,we=me.resultMetadata&&me.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return ge=we&&we.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:ge,context:{[r]:se.res.headers.activityid}}}return{galleryExtensions:[],total:ge}}catch(de){const me=(0,A.isCancellationError)(de)?E.ExtensionGalleryErrorCode.Cancelled:(0,A.getErrorMessage)(de).startsWith("XHR timeout")?E.ExtensionGalleryErrorCode.Timeout:E.ExtensionGalleryErrorCode.Failed;throw he=new E.ExtensionGalleryError((0,A.getErrorMessage)(de),me),he}finally{this.telemetryService.publicLog2("galleryService:query",{...$.telemetryData,requestBodySize:String(ee.length),duration:J.elapsed(),success:!!se&&(0,u.isSuccess)(se),responseBodySize:se?.res.headers["Content-Length"],statusCode:se?String(se.res.statusCode):void 0,errorCode:he?.code,count:String(ge)})}}async reportStatistic($,Q,G,ee){if(!this.isEnabled())return;const Z=O.isWeb?this.api(`/itemName/${$}.${Q}/version/${G}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${$}/extensions/${Q}/${G}/stats?statType=${ee}`),J=O.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",he={...await this.commonHeadersPromise,Accept:J};try{await this.requestService.request({type:"POST",url:Z,headers:he},U.CancellationToken.None)}catch{}}async download($,Q,G){this.logService.trace("ExtensionGalleryService#download",$.identifier.id);const ee=(0,v.getGalleryExtensionTelemetryData)($),Z=new Date().getTime(),J=me=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ee,duration:me}),se=G===2?"install":G===3?"update":"",he=se?{uri:`${$.assets.download.uri}${P.URI.parse($.assets.download.uri).query?"&":"?"}${se}=true`,fallbackUri:`${$.assets.download.fallbackUri}${P.URI.parse($.assets.download.fallbackUri).query?"&":"?"}${se}=true`}:$.assets.download,ge=$.queryContext?.[r]?{[r]:$.queryContext[r]}:void 0,de=await this.getAsset($.identifier.id,he,o.VSIX,ge?{headers:ge}:void 0);await this.fileService.writeFile(Q,de.stream),J(new Date().getTime()-Z)}async downloadSignatureArchive($,Q){if(!$.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",$.identifier.id);const G=await this.getAsset($.identifier.id,$.assets.signature,o.Signature);await this.fileService.writeFile(Q,G.stream)}async getReadme($,Q){if($.assets.readme){const G=await this.getAsset($.identifier.id,$.assets.readme,o.Details,{},Q);return await(0,u.asTextOrError)(G)||""}return""}async getManifest($,Q){if($.assets.manifest){const G=await this.getAsset($.identifier.id,$.assets.manifest,o.Manifest,{},Q),ee=await(0,u.asTextOrError)(G);return ee?JSON.parse(ee):null}return null}async getManifestFromRawExtensionVersion($,Q,G){const ee=F(Q,o.Manifest);if(!ee)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},J=await this.getAsset($,ee,o.Manifest,{headers:Z});return await(0,u.asJson)(J)}async getCoreTranslation($,Q){const G=$.assets.coreTranslations.filter(ee=>ee[0]===Q.toUpperCase())[0];if(G){const ee=await this.getAsset($.identifier.id,G[1],G[0]),Z=await(0,u.asTextOrError)(ee);return Z?JSON.parse(Z):null}return null}async getChangelog($,Q){if($.assets.changelog){const G=await this.getAsset($.identifier.id,$.assets.changelog,o.Changelog,{},Q);return await(0,u.asTextOrError)(G)||""}return""}async getAllCompatibleVersions($,Q,G){let ee=new w().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);$.identifier.uuid?ee=ee.withFilter(i.ExtensionId,$.identifier.uuid):ee=ee.withFilter(i.ExtensionName,$.identifier.id);const{galleryExtensions:Z}=await this.queryRawGalleryExtensions(ee,U.CancellationToken.None);if(!Z.length)return[];const J=ie(Z[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(J,G))return[];const se=[];await Promise.all(Z[0].versions.map(async de=>{try{await this.isValidVersion($.identifier.id,de,Q?"any":"release",!0,J,G)&&se.push(de)}catch{}}));const he=[],ge=new Set;for(const de of re(se,G))ge.has(de.version)||(ge.add(de.version),he.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:B(de)}));return he}async getAsset($,Q,G,ee={},Z=U.CancellationToken.None){const J=await this.commonHeadersPromise,se={type:"GET"},he={...J,...ee.headers||{}};ee={...ee,...se,headers:he};const ge=Q.uri,de=Q.fallbackUri,me={...ee,url:ge};try{const Ee=await this.requestService.request(me,Z);if(Ee.res.statusCode===200)return Ee;const we=await(0,u.asTextOrError)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${we}`)}catch(Ee){if((0,A.isCancellationError)(Ee))throw Ee;const we=(0,A.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{extension:$,assetType:G,message:we});const Pe={...ee,url:de};return this.requestService.request(Pe,Z)}}async getEngine($,Q){let G=X(Q);if(!G){this.telemetryService.publicLog2("galleryService:engineFallback",{extension:$,version:Q.version});const ee=await this.getManifestFromRawExtensionVersion($,Q,U.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");G=ee.engines.vscode}return G}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{},search:[]};const $=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},U.CancellationToken.None);if($.res.statusCode!==200)throw new Error("Could not get extensions report.");const Q=await(0,u.asJson)($),G=[],ee={},Z=[];if(Q){for(const J of Q.malicious)G.push({id:J});if(Q.migrateToPreRelease)for(const[J,se]of Object.entries(Q.migrateToPreRelease))(!se.engine||(0,l.isEngineValid)(se.engine,this.productService.version,this.productService.date))&&(ee[J.toLowerCase()]={disallowInstall:!0,extension:{id:se.id,displayName:se.displayName,autoMigrate:{storage:!!se.migrateStorage},preRelease:!0}});if(Q.deprecated)for(const[J,se]of Object.entries(Q.deprecated))se&&(ee[J.toLowerCase()]=(0,R.isBoolean)(se)?{}:se);if(Q.search)for(const J of Q.search)Z.push(J)}return{malicious:G,deprecated:ee,search:Z}}};j=Ce([K(1,u.IRequestService),K(2,p.ILogService),K(3,C.IEnvironmentService),K(4,f.ITelemetryService),K(5,c.IFileService),K(6,g.IProductService),K(7,d.IConfigurationService)],j);let W=class extends j{constructor($,Q,G,ee,Z,J,se,he){super($,Q,G,ee,Z,J,se,he)}};e.ExtensionGalleryService=W,e.ExtensionGalleryService=W=Ce([K(0,m.IStorageService),K(1,u.IRequestService),K(2,p.ILogService),K(3,C.IEnvironmentService),K(4,f.ITelemetryService),K(5,c.IFileService),K(6,g.IProductService),K(7,d.IConfigurationService)],W);let T=class extends j{constructor($,Q,G,ee,Z,J,se){super(void 0,$,Q,G,ee,Z,J,se)}};e.ExtensionGalleryServiceWithNoStorageService=T,e.ExtensionGalleryServiceWithNoStorageService=T=Ce([K(0,u.IRequestService),K(1,p.ILogService),K(2,C.IEnvironmentService),K(3,f.ITelemetryService),K(4,c.IFileService),K(5,g.IProductService),K(6,d.IConfigurationService)],T)}),define(ae[82],ce([0,1,4,3,2,19,33,24,17,9,13]),function(ne,e,_,U,A,O,k,R,P,d,C){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,_.createDecorator)("IExtensionStorageService");const v=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let l=class extends A.Disposable{static{E=this}static{this.LARGE_STATE_WARNING_THRESHOLD=512*1024}static toKey(p){return`extensionKeys/${(0,k.adoptToGalleryExtensionId)(p.id)}@${p.version}`}static fromKey(p){const g=v.exec(p);if(g&&g[1])return{id:g[1],version:g[2]}}static async removeOutdatedExtensionVersions(p,g){const u=await p.getInstalled(),h=[];for(const[m,f]of E.readAllExtensionsWithKeysForSync(g)){const S=u.find(t=>(0,k.areSameExtensions)(t.identifier,{id:m}))?.manifest.version;for(const t of f)S!==t&&h.push(E.toKey({id:m,version:t}))}for(const m of h)g.remove(m,0)}static readAllExtensionsWithKeysForSync(p){const g=new Map,u=p.keys(0,1);for(const h of u){const m=E.fromKey(h);if(m){let f=g.get(m.id.toLowerCase());f||g.set(m.id.toLowerCase(),f=[]),f.push(m.version)}}return g}constructor(p,g,u){super(),this.storageService=p,this.productService=g,this.logService=u,this._onDidChangeExtensionStorageToSync=this._register(new U.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=E.readAllExtensionsWithKeysForSync(p),this._register(this.storageService.onDidChangeValue(0,void 0,this._register(new A.DisposableStore))(h=>this.onDidChangeStorageValue(h)))}onDidChangeStorageValue(p){if(this.extensionsWithKeysForSync.has(p.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const g=E.fromKey(p.key);if(g){if(this.storageService.get(p.key,0)===void 0)this.extensionsWithKeysForSync.delete(g.id.toLowerCase());else{let u=this.extensionsWithKeysForSync.get(g.id.toLowerCase());u||this.extensionsWithKeysForSync.set(g.id.toLowerCase(),u=[]),u.push(g.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(p){if((0,C.isString)(p))return p;const g=p.manifest?p.manifest.publisher:p.publisher,u=p.manifest?p.manifest.name:p.name;return(0,k.getExtensionId)(g,u)}getExtensionState(p,g){const u=this.getExtensionId(p),h=this.getExtensionStateRaw(p,g);if(h)try{return JSON.parse(h)}catch(m){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${u}, global: ${g}): ${m}`)}}getExtensionStateRaw(p,g){const u=this.getExtensionId(p),h=this.storageService.get(u,g?0:1);return h&&h?.length>E.LARGE_STATE_WARNING_THRESHOLD&&this.logService.warn(`[mainThreadStorage] large extension state detected (extensionId: ${u}, global: ${g}): ${h.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),h}setExtensionState(p,g,u){const h=this.getExtensionId(p);g===void 0?this.storageService.remove(h,u?0:1):this.storageService.store(h,JSON.stringify(g),u?0:1,1)}setKeysForSync(p,g){this.storageService.store(E.toKey(p),JSON.stringify(g),0,1)}getKeysForSync(p){const g=this.productService.extensionSyncedKeys?.[p.id.toLowerCase()],u=this.storageService.get(E.toKey(p),0),h=u?JSON.parse(u):void 0;return h&&g?(0,P.distinct)([...h,...g]):h||g}addToMigrationList(p,g){if(p!==g){const u=this.migrationList.filter(h=>!h.includes(p)&&!h.includes(g));u.push([p,g]),this.migrationList=u}}getSourceExtensionToMigrate(p){const g=this.migrationList.find(([,u])=>p===u);return g?g[0]:void 0}get migrationList(){const p=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const g=JSON.parse(p);if(Array.isArray(g))return g}catch{}return[]}set migrationList(p){p.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};e.ExtensionStorageService=l,e.ExtensionStorageService=l=E=Ce([K(0,O.IStorageService),K(1,R.IProductService),K(2,d.ILogService)],l)}),define(ae[255],ce([0,1,2,29,82,230,113,9,19]),function(ne,e,_,U,A,O,k,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let d=class extends _.Disposable{constructor(E,v,l,c,p,g){super(),E.cleanUp(),(0,O.migrateUnsupportedExtensions)(E,v,l,c,g),A.ExtensionStorageService.removeOutdatedExtensionVersions(E,p)}};e.ExtensionsContributions=d,e.ExtensionsContributions=d=Ce([K(0,k.INativeServerExtensionManagementService),K(1,U.IExtensionGalleryService),K(2,A.IExtensionStorageService),K(3,U.IGlobalExtensionEnablementService),K(4,P.IStorageService),K(5,R.ILogService)],d)}),define(ae[256],ce([0,1,29,12,24,16,96,57,19,22,229]),function(ne,e,_,U,A,O,k,R,P,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let E=class extends C.AbstractNativeExtensionTipsService{constructor(l,c,p,g,u,h,m,f){super(l.userHome,u,c,p,g,h,m,f)}};e.ExtensionTipsService=E,e.ExtensionTipsService=E=Ce([K(0,O.INativeEnvironmentService),K(1,d.ITelemetryService),K(2,_.IExtensionManagementService),K(3,P.IStorageService),K(4,R.INativeHostService),K(5,k.IExtensionRecommendationNotificationService),K(6,U.IFileService),K(7,A.IProductService)],E)}),define(ae[257],ce([0,1,104,3,22,16,2,9,14,67,24,5,6,99,21,170,37,19,13,132,20]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g,u,h,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const S=[_.CONFIGURATION_KEY_HOST_NAME,_.CONFIGURATION_KEY_PREVENT_SLEEP],t="remoteTunnelSession",r="remoteTunnelIsService";let n=class extends k.Disposable{constructor(a,y,I,w,b,D,L){super(),this.telemetryService=a,this.productService=y,this.environmentService=I,this.configurationService=D,this.storageService=L,this._onDidTokenFailedEmitter=new U.Emitter,this.onDidTokenFailed=this._onDidTokenFailedEmitter.event,this._onDidChangeTunnelStatusEmitter=new U.Emitter,this.onDidChangeTunnelStatus=this._onDidChangeTunnelStatusEmitter.event,this._onDidChangeModeEmitter=new U.Emitter,this.onDidChangeMode=this._onDidChangeModeEmitter.event,this._mode=_.INACTIVE_TUNNEL_MODE,this._initialized=!1,this.defaultOnOutput=(N,F)=>{F?this._logger.error(N):this._logger.info(N)},this._logger=this._register(w.createLogger((0,f.joinPath)(I.logsHome,`${_.LOG_ID}.log`),{id:_.LOG_ID,name:_.LOGGER_NAME})),this._startTunnelProcessDelayer=new v.Delayer(100),this._register(this._logger.onDidChangeLogLevel(N=>this._logger.info("Log level changed to "+(0,R.LogLevelToString)(N)))),this._register(b.onWillShutdown(()=>{this._tunnelProcess?.cancel(),this._tunnelProcess=void 0,this.dispose()})),this._register(D.onDidChangeConfiguration(N=>{S.some(F=>N.affectsConfiguration(F))&&this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())})),this._mode=this._restoreMode(),this._tunnelStatus=_.TunnelStates.uninitialized}async getTunnelStatus(){return this._tunnelStatus}setTunnelStatus(a){this._tunnelStatus=a,this._onDidChangeTunnelStatusEmitter.fire(a)}setMode(a){i(this._mode,a)||(this._mode=a,this._storeMode(a),this._onDidChangeModeEmitter.fire(this._mode),a.active?(this._logger.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this._logger.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this._logger.info("Session reset"))}getMode(){return Promise.resolve(this._mode)}async initialize(a){if(this._initialized)return this._tunnelStatus;this._initialized=!0,this.setMode(a);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(y){this._logger.error(y)}return this._tunnelStatus}getTunnelCommandLocation(){if(!this._tunnelCommand){let a;E.isMacintosh?a=this.environmentService.appRoot:a=(0,P.dirname)((0,P.dirname)(this.environmentService.appRoot)),this._tunnelCommand=(0,P.join)(a,"bin",`${this.productService.tunnelApplicationName}${E.isWindows?".exe":""}`)}return this._tunnelCommand}async startTunnel(a){if(i(this._mode,a)&&this._tunnelStatus.type!=="disconnected")return this._tunnelStatus;this.setMode(a);try{await this._startTunnelProcessDelayer.trigger(()=>this.updateTunnelProcess())}catch(y){this._logger.error(y)}return this._tunnelStatus}async stopTunnel(){if(this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0),this._mode.active){const a=this._mode.asService;this.setMode(_.INACTIVE_TUNNEL_MODE);try{a&&this.runCodeTunnelCommand("uninstallService",["service","uninstall"])}catch(y){this._logger.error(y)}}try{await this.runCodeTunnelCommand("stop",["kill"])}catch(a){this._logger.error(a)}this.setTunnelStatus(_.TunnelStates.disconnected())}async updateTunnelProcess(){this.telemetryService.publicLog2("remoteTunnel.enablement",{enabled:this._mode.active,service:this._mode.active&&this._mode.asService}),this._tunnelProcess&&(this._tunnelProcess.cancel(),this._tunnelProcess=void 0);let a="",y=!1;const I=(F,x)=>{x?this._logger.error(F):a+=F,!this.environmentService.isBuilt&&F.startsWith("   Compiling")&&this.setTunnelStatus(_.TunnelStates.connecting((0,p.localize)(0,null)))},w=this.runCodeTunnelCommand("status",["status"],I);this._tunnelProcess=w;try{if(await w,this._tunnelProcess!==w)return;let F;try{F=JSON.parse(a.trim().split(`
`).find(x=>x.startsWith("{")))}catch{this._logger.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.setTunnelStatus(_.TunnelStates.disconnected());return}if(y=F.service_installed,this._logger.info(F.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!F.tunnel&&!this._mode.active){this.setTunnelStatus(_.TunnelStates.disconnected());return}}catch(F){this._logger.error(F),this.setTunnelStatus(_.TunnelStates.disconnected());return}finally{this._tunnelProcess===w&&(this._tunnelProcess=void 0)}const b=this._mode.active?this._mode.session:void 0;if(b&&b.token){const F=b.token;this.setTunnelStatus(_.TunnelStates.connecting((0,p.localize)(1,null,b.accountLabel,b.providerId)));const x=(B,Y)=>{B=B.replaceAll(F,"*".repeat(4)),I(B,Y)},X=this.runCodeTunnelCommand("login",["user","login","--provider",b.providerId,"--access-token",F,"--log",(0,R.LogLevelToString)(this._logger.getLevel())],x);this._tunnelProcess=X;try{if(await X,this._tunnelProcess!==X)return}catch(B){this._logger.error(B),this._tunnelProcess=void 0,this._onDidTokenFailedEmitter.fire(b),this.setTunnelStatus(_.TunnelStates.disconnected(b));return}}const D=this._getTunnelName();D?this.setTunnelStatus(_.TunnelStates.connecting((0,p.localize)(2,null,D))):this.setTunnelStatus(_.TunnelStates.connecting((0,p.localize)(3,null)));const L=["--accept-server-license-terms","--log",(0,R.LogLevelToString)(this._logger.getLevel())];D?L.push("--name",D):L.push("--random-name");let N=!1;return this._mode.active&&this._mode.asService&&!y&&(N=await this.installTunnelService(L)===!1),this.serverOrAttachTunnel(b,L,N)}async installTunnelService(a){let y;try{y=await this.runCodeTunnelCommand("serviceInstall",["service","install",...a])}catch(I){this._logger.error(I),y=1}if(y!==0){const I=(0,p.localize)(4,null);return this._logger.warn(I),this.setTunnelStatus(_.TunnelStates.connecting(I)),!1}return!0}async serverOrAttachTunnel(a,y,I){y.push("--parent-process-id",String(process.pid)),this._preventSleep()&&y.push("--no-sleep");let w=!1;const b=this.runCodeTunnelCommand("tunnel",y,(D,L)=>{L?this._logger.error(D):this._logger.info(D),D.includes("Connected to an existing tunnel process")&&(w=!0);const N=D.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(N){const F={link:N[1],domain:N[2],tunnelName:N[4],isAttached:w};this.setTunnelStatus(_.TunnelStates.connected(F,I))}else D.match(/error refreshing token/)&&(b.cancel(),this._onDidTokenFailedEmitter.fire(a),this.setTunnelStatus(_.TunnelStates.disconnected(a)))});this._tunnelProcess=b,b.finally(()=>{b===this._tunnelProcess&&(this._logger.info("tunnel process terminated"),this._tunnelProcess=void 0,this._mode=_.INACTIVE_TUNNEL_MODE,this.setTunnelStatus(_.TunnelStates.disconnected()))})}runCodeTunnelCommand(a,y,I=this.defaultOnOutput){return(0,v.createCancelablePromise)(w=>new Promise((b,D)=>{w.isCancellationRequested&&b(-1);let L;const N=["ignore","pipe","pipe"];if(w.onCancellationRequested(()=>{L&&(this._logger.info(`${a} terminating(${L.pid})`),L.kill())}),!this.environmentService.isBuilt)I(`Building tunnel CLI from sources and run
`,!1),I(`${a} Spawning: cargo run -- tunnel ${y.join(" ")}
`,!1),L=(0,d.spawn)("cargo",["run","--","tunnel",...y],{cwd:(0,P.join)(this.environmentService.appRoot,"cli"),stdio:N});else{I(`Running tunnel CLI
`,!1);const F=this.getTunnelCommandLocation();I(`${a} Spawning: ${F} tunnel ${y.join(" ")}
`,!1),L=(0,d.spawn)(F,["tunnel",...y],{cwd:(0,g.homedir)(),stdio:N})}L.stdout.pipe(new m.StreamSplitter(`
`)).on("data",F=>{if(L){const x=F.toString();I(x,!1)}}),L.stderr.pipe(new m.StreamSplitter(`
`)).on("data",F=>{if(L){const x=F.toString();I(x,!0)}}),L.on("exit",F=>{L&&(I(`${a} exit(${L.pid}): + ${F} `,!1),L=void 0,b(F||0))}),L.on("error",F=>{L&&(I(`${a} error(${L.pid}): + ${F} `,!0),L=void 0,D())})}))}async getTunnelName(){return this._getTunnelName()}_preventSleep(){return!!this.configurationService.getValue(_.CONFIGURATION_KEY_PREVENT_SLEEP)}_getTunnelName(){let a=this.configurationService.getValue(_.CONFIGURATION_KEY_HOST_NAME)||(0,g.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}_restoreMode(){try{const a=this.storageService.get(t,-1),y=this.storageService.getBoolean(r,-1,!1);if(a){const I=JSON.parse(a);if(I&&(0,h.isString)(I.accountLabel)&&(0,h.isString)(I.sessionId)&&(0,h.isString)(I.providerId))return{active:!0,session:I,asService:y};this._logger.error("Problems restoring session from storage, invalid format",I)}}catch(a){this._logger.error("Problems restoring session from storage",a)}return _.INACTIVE_TUNNEL_MODE}_storeMode(a){if(a.active){const y={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.storageService.store(t,JSON.stringify(y),-1,1),this.storageService.store(r,a.asService,-1,1)}else this.storageService.remove(t,-1),this.storageService.remove(r,-1)}};e.RemoteTunnelService=n,e.RemoteTunnelService=n=Ce([K(0,A.ITelemetryService),K(1,C.IProductService),K(2,O.INativeEnvironmentService),K(3,R.ILoggerService),K(4,l.ISharedProcessLifecycleService),K(5,c.IConfigurationService),K(6,u.IStorageService)],n);function s(o,a){return o&&a?o.sessionId===a.sessionId&&o.providerId===a.providerId&&o.token===a.token:o===a}const i=(o,a)=>o.active!==a.active?!1:o.active&&a.active?o.asService===a.asService&&s(o.session,a.session):!0}),define(ae[258],ce([0,1,6,2,23,20,69,19,77,18]),function(ne,e,_,U,A,O,k,R,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class C extends R.AbstractStorageService{constructor(v,l,c,p){super(),this.initialWorkspace=v,this.initialProfiles=l,this.remoteService=c,this.environmentService=p,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new U.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new U.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const v=this._register(new P.ApplicationStorageDatabaseClient(this.remoteService.getChannel("storage"))),l=this._register(new k.Storage(v));return this._register(l.onDidChangeStorage(c=>this.emitDidChangeValue(-1,c))),l}createProfileStorage(v){this.profileStorageDisposables.clear(),this.profileStorageProfile=v;let l;if((0,R.isProfileUsingDefaultStorage)(v))l=this.applicationStorage;else{const c=this.profileStorageDisposables.add(new P.ProfileStorageDatabaseClient(this.remoteService.getChannel("storage"),v));l=this.profileStorageDisposables.add(new k.Storage(c))}return this.profileStorageDisposables.add(l.onDidChangeStorage(c=>this.emitDidChangeValue(0,c))),l}createWorkspaceStorage(v){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=v?.id;let l;if(v){const c=this.workspaceStorageDisposables.add(new P.WorkspaceStorageDatabaseClient(this.remoteService.getChannel("storage"),v));l=this.workspaceStorageDisposables.add(new k.Storage(c)),this.workspaceStorageDisposables.add(l.onDidChangeStorage(p=>this.emitDidChangeValue(1,p)))}return l}async doInitialize(){await _.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(v){switch(v){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(v){switch(v){case-1:return this.applicationStorageProfile.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;default:return this.workspaceStorageId?`${(0,O.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").with({scheme:A.Schemas.file}).fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(R.WillSaveStateReason.SHUTDOWN),await _.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(v){if(!this.canSwitchProfile(this.profileStorageProfile,v))return;const l=this.profileStorage,c=l.items;l!==this.applicationStorage&&await l.close(),this.profileStorage=this.createProfileStorage(v),await this.profileStorage.init(),this.switchData(c,this.profileStorage,0)}async switchToWorkspace(v,l){const c=this.workspaceStorage,p=c?.items??new Map;await c?.close(),this.workspaceStorage=this.createWorkspaceStorage(v),await this.workspaceStorage.init(),this.switchData(p,this.workspaceStorage,1)}hasScope(v){return(0,d.isUserDataProfile)(v)?this.profileStorageProfile.id===v.id:this.workspaceStorageId===v.id}}e.RemoteStorageService=C}),define(ae[259],ce([0,1,3,2,18,91]),function(ne,e,_,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class k{constructor(d,C){this.service=d,this.getUriTransformer=C}listen(d,C){const E=this.getUriTransformer(d);switch(C){case"onDidChangeProfiles":return _.Event.map(this.service.onDidChangeProfiles,v=>({all:v.all.map(l=>(0,O.transformOutgoingURIs)({...l},E)),added:v.added.map(l=>(0,O.transformOutgoingURIs)({...l},E)),removed:v.removed.map(l=>(0,O.transformOutgoingURIs)({...l},E)),updated:v.updated.map(l=>(0,O.transformOutgoingURIs)({...l},E))}))}throw new Error(`Invalid listen ${C}`)}async call(d,C,E){const v=this.getUriTransformer(d);switch(C){case"createProfile":{const l=await this.service.createProfile(E[0],E[1],E[2]);return(0,O.transformOutgoingURIs)({...l},v)}case"updateProfile":{let l=(0,A.reviveProfile)((0,O.transformIncomingURIs)(E[0],v),this.service.profilesHome.scheme);return l=await this.service.updateProfile(l,E[1]),(0,O.transformOutgoingURIs)({...l},v)}case"removeProfile":{const l=(0,A.reviveProfile)((0,O.transformIncomingURIs)(E[0],v),this.service.profilesHome.scheme);return this.service.removeProfile(l)}}throw new Error(`Invalid call ${C}`)}}e.RemoteUserDataProfilesServiceChannel=k;class R extends U.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}constructor(d,C,E){super(),this.profilesHome=C,this.channel=E,this._profiles=[],this._onDidChangeProfiles=this._register(new _.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.enabled=!0,this._profiles=d.map(v=>(0,A.reviveProfile)(v,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(v=>{const l=v.added.map(g=>(0,A.reviveProfile)(g,this.profilesHome.scheme)),c=v.removed.map(g=>(0,A.reviveProfile)(g,this.profilesHome.scheme)),p=v.updated.map(g=>(0,A.reviveProfile)(g,this.profilesHome.scheme));this._profiles=v.all.map(g=>(0,A.reviveProfile)(g,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:l,removed:c,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}setEnablement(d){this.enabled=d}isEnabled(){return this.enabled}async createNamedProfile(d,C,E){const v=await this.channel.call("createNamedProfile",[d,C,E]);return(0,A.reviveProfile)(v,this.profilesHome.scheme)}async createProfile(d,C,E,v){const l=await this.channel.call("createProfile",[d,C,E,v]);return(0,A.reviveProfile)(l,this.profilesHome.scheme)}async createTransientProfile(d){const C=await this.channel.call("createTransientProfile",[d]);return(0,A.reviveProfile)(C,this.profilesHome.scheme)}async setProfileForWorkspace(d,C){await this.channel.call("setProfileForWorkspace",[d,C])}removeProfile(d){return this.channel.call("removeProfile",[d])}async updateProfile(d,C){const E=await this.channel.call("updateProfile",[d,C]);return(0,A.reviveProfile)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}cleanUp(){return this.channel.call("cleanUp")}cleanUpTransientProfiles(){return this.channel.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=R}),define(ae[60],ce([0,1,2,69,4,19,3,77,18]),function(ne,e,_,U,A,O,k,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,A.createDecorator)("IUserDataProfileStorageService");let d=class extends _.Disposable{constructor(l){super(),this.storageService=l}async readStorageData(l){return this.withProfileScopedStorageService(l,async c=>this.getItems(c))}async updateStorageData(l,c,p){return this.withProfileScopedStorageService(l,async g=>this.writeItems(g,c,p))}async withProfileScopedStorageService(l,c){if(this.storageService.hasScope(l))return c(this.storageService);const p=await this.createStorageDatabase(l),g=new E(p);try{await g.initialize();const u=await c(g);return await g.flush(),u}finally{g.dispose(),await this.closeAndDispose(p)}}getItems(l){const c=new Map,p=g=>{for(const u of l.keys(0,g))c.set(u,{value:l.get(u,0),target:g})};return p(0),p(1),c}writeItems(l,c,p){l.storeAll(Array.from(c.entries()).map(([g,u])=>({key:g,value:u,scope:0,target:p})),!0)}async closeAndDispose(l){try{await l.close()}finally{(0,_.isDisposable)(l)&&l.dispose()}}};e.AbstractUserDataProfileStorageService=d,e.AbstractUserDataProfileStorageService=d=Ce([K(0,O.IStorageService)],d);class C extends d{constructor(l,c,p,g){super(p),this.remoteService=l;const u=l.getChannel("profileStorageListener"),h=this._register(new _.MutableDisposable);this._onDidChange=this._register(new k.Emitter({onWillAddFirstListener:()=>{h.value=u.listen("onDidChange")(m=>{g.trace("profile storage changes",m),this._onDidChange.fire({targetChanges:m.targetChanges.map(f=>(0,P.reviveProfile)(f,c.profilesHome.scheme)),valueChanges:m.valueChanges.map(f=>({...f,profile:(0,P.reviveProfile)(f.profile,c.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>h.value=void 0})),this.onDidChange=this._onDidChange.event}async createStorageDatabase(l){const c=this.remoteService.getChannel("storage");return(0,O.isProfileUsingDefaultStorage)(l)?new R.ApplicationStorageDatabaseClient(c):new R.ProfileStorageDatabaseClient(c,l)}}e.RemoteUserDataProfileStorageService=C;class E extends O.AbstractStorageService{constructor(l){super({flushInterval:100}),this.profileStorage=this._register(new U.Storage(l))}doInitialize(){return this.profileStorage.init()}getStorage(l){return l===0?this.profileStorage:void 0}getLogDetails(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(){return!1}}}),define(ae[260],ce([0,1,19,9,18,56,60]),function(ne,e,_,U,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let R=class extends k.RemoteUserDataProfileStorageService{constructor(d,C,E,v){super(d,C,E,v)}};e.NativeUserDataProfileStorageService=R,e.NativeUserDataProfileStorageService=R=Ce([K(0,O.IMainProcessService),K(1,A.IUserDataProfilesService),K(2,_.IStorageService),K(3,U.ILogService)],R)}),define(ae[39],ce([0,1,17,6,15,26,3,35,2,27,13,175,21,16,12,9,45,19,22,28,25,18]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g,u,h,m,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=void 0,e.isRemoteUserData=t,e.isSyncData=r,e.getSyncResourceLogLabel=n;function t(y){return!!(y&&y.ref!==void 0&&typeof y.ref=="string"&&y.ref!==""&&y.syncData!==void 0&&(y.syncData===null||r(y.syncData)))}function r(y){return!!(y&&y.version!==void 0&&typeof y.version=="number"&&y.content!==void 0&&typeof y.content=="string"&&(Object.keys(y).length===2||Object.keys(y).length===3&&y.machineId!==void 0&&typeof y.machineId=="string"))}function n(y,I){return`${(0,d.uppercaseFirstLetter)(y)}${I.isDefault?"":` (${I.name})`}`}let s=class extends P.Disposable{get status(){return this._status}get conflicts(){return{...this.syncResource,conflicts:this._conflicts}}constructor(I,w,b,D,L,N,F,x,X,B,Y,z){super(),this.syncResource=I,this.collection=w,this.fileService=b,this.environmentService=D,this.storageService=L,this.userDataSyncStoreService=N,this.userDataSyncLocalStoreService=F,this.userDataSyncEnablementService=x,this.telemetryService=X,this.logService=B,this.configurationService=Y,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=this._register(new U.ThrottledDelayer(50)),this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.lastSyncUserDataStateKey=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.resource=this.syncResource.syncResource,this.syncResourceLogLabel=n(I.syncResource,I.profile),this.extUri=z.extUri,this.syncFolder=this.extUri.joinPath(D.userDataSyncHome,...(0,f.getPathSegments)(I.profile.isDefault?void 0:I.profile.id,I.syncResource)),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,f.PREVIEW_DIR_NAME),this.lastSyncResource=(0,f.getLastSyncResourceUri)(I.profile.isDefault?void 0:I.profile.id,I.syncResource,D,this.extUri),this.currentMachineIdPromise=(0,g.getServiceMachineId)(D,b,L)}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const I=await this.syncPreviewPromise;this.syncPreviewPromise=null;const w=await this.performSync(I.remoteUserData,I.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(w)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const I=await this.getLastSyncUserData();(I?await this.hasRemoteChanged(I):!0)&&this._onDidChangeLocal.fire()}}setStatus(I){this._status!==I&&(this._status=I,this._onDidChangStatus.fire(I))}async sync(I,w={}){await this._sync(I,!0,this.getUserDataSyncConfiguration(),w)}async preview(I,w,b={}){return this._sync(I,!1,w,b)}async apply(I,w={}){try{this.syncHeaders={...w};const b=await this.doApply(I);return this.setStatus(b),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(I,w,b,D){try{if(this.syncHeaders={...D},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let L="idle";try{const N=await this.getLastSyncUserData(),F=await this.getLatestRemoteUserData(I,N);return L=await this.performSync(F,N,w,b),L==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):L==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(L)}}finally{this.syncHeaders={}}}async replace(I){const w=this.parseSyncData(I);if(!w)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const b=await this.getLastSyncUserData(),D=await this.getLatestRemoteUserData(null,b),L=await this.isRemoteDataFromCurrentMachine(D),N=await this.generateSyncPreview({ref:D.ref,syncData:w},b,L,this.getUserDataSyncConfiguration(),O.CancellationToken.None),F=[];for(const x of N){const X=await this.getAcceptResult(x,x.remoteResource,void 0,O.CancellationToken.None),{remoteChange:B}=await this.getAcceptResult(x,x.previewResource,x.remoteContent,O.CancellationToken.None);F.push([x,{...X,remoteChange:B!==0?B:2}])}await this.applyResult(D,b,F,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(I){const w=await this.currentMachineIdPromise;return!!I.syncData?.machineId&&I.syncData.machineId===w}async getLatestRemoteUserData(I,w){if(w){const b=I?I[this.resource]:void 0;if(w.ref===b||b===void 0&&w.syncData===null)return w}return this.getRemoteUserData(w)}async performSync(I,w,b,D){if(I.syncData&&I.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new f.UserDataSyncError((0,E.localize)(0,null,this.resource,this.version,I.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(I,w,b,D)}catch(L){if(L instanceof f.UserDataSyncError)switch(L.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(I,w,b,D);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),I=await this.getRemoteUserData(null),w=await this.getLastSyncUserData(),this.performSync(I,w,b,D)}throw L}}async doSync(I,w,b,D){try{const L=await this.isRemoteDataFromCurrentMachine(I),N=!L&&w===null&&this.getStoredLastSyncUserDataStateContent()!==void 0,F=b&&!N;this.syncPreviewPromise||(this.syncPreviewPromise=(0,U.createCancelablePromise)(X=>this.doGenerateSyncResourcePreview(I,w,L,F,D,X)));let x=await this.syncPreviewPromise;if(b&&N){this.logService.info(`${this.syncResourceLogLabel}: Accepting remote because it was synced before and the last sync data is not available.`);for(const X of x.resourcePreviews)x=await this.accept(X.remoteResource)||x}return this.updateConflicts(x.resourcePreviews),x.resourcePreviews.some(({mergeState:X})=>X==="conflict")?"hasConflicts":b?await this.doApply(!1):"syncing"}catch(L){throw this.syncPreviewPromise=null,L}}async merge(I){return await this.updateSyncResourcePreview(I,async w=>{const b=await this.getMergeResult(w,O.CancellationToken.None);await this.fileService.writeFile(w.previewResource,A.VSBuffer.fromString(b?.content||""));const D=b&&!b.hasConflicts?await this.getAcceptResult(w,w.previewResource,void 0,O.CancellationToken.None):void 0;return w.acceptResult=D,w.mergeState=b.hasConflicts?"conflict":D?"accepted":"preview",w.localChange=D?D.localChange:b.localChange,w.remoteChange=D?D.remoteChange:b.remoteChange,w}),this.syncPreviewPromise}async accept(I,w){return await this.updateSyncResourcePreview(I,async b=>{const D=await this.getAcceptResult(b,I,w,O.CancellationToken.None);return b.acceptResult=D,b.mergeState="accepted",b.localChange=D.localChange,b.remoteChange=D.remoteChange,b}),this.syncPreviewPromise}async discard(I){return await this.updateSyncResourcePreview(I,async w=>{const b=await this.getMergeResult(w,O.CancellationToken.None);return await this.fileService.writeFile(w.previewResource,A.VSBuffer.fromString(b.content||"")),w.acceptResult=void 0,w.mergeState="preview",w.localChange=b.localChange,w.remoteChange=b.remoteChange,w}),this.syncPreviewPromise}async updateSyncResourcePreview(I,w){if(!this.syncPreviewPromise)return;let b=await this.syncPreviewPromise;const D=b.resourcePreviews.findIndex(({localResource:L,remoteResource:N,previewResource:F})=>this.extUri.isEqual(L,I)||this.extUri.isEqual(N,I)||this.extUri.isEqual(F,I));D!==-1&&(this.syncPreviewPromise=(0,U.createCancelablePromise)(async L=>{const N=[...b.resourcePreviews];return N[D]=await w(N[D]),{...b,resourcePreviews:N}}),b=await this.syncPreviewPromise,this.updateConflicts(b.resourcePreviews),b.resourcePreviews.some(({mergeState:L})=>L==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(I){if(!this.syncPreviewPromise)return"idle";const w=await this.syncPreviewPromise;return w.resourcePreviews.some(({mergeState:b})=>b==="conflict")?"hasConflicts":w.resourcePreviews.some(({mergeState:b})=>b!=="accepted")?"syncing":(await this.applyResult(w.remoteUserData,w.lastSyncUserData,w.resourcePreviews.map(b=>[b,b.acceptResult]),I),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(I){const w=I.filter(({mergeState:b})=>b==="conflict");(0,_.equals)(this._conflicts,w,(b,D)=>this.extUri.isEqual(b.previewResource,D.previewResource))||(this._conflicts=w,this._onDidChangeConflicts.fire(this.conflicts))}async hasPreviouslySynced(){const I=await this.getLastSyncUserData();return!!I&&I.syncData!==null}async resolvePreviewContent(I){const w=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(w)for(const b of w.resourcePreviews){if(this.extUri.isEqual(b.acceptedResource,I))return b.acceptResult?b.acceptResult.content:null;if(this.extUri.isEqual(b.remoteResource,I))return b.remoteContent;if(this.extUri.isEqual(b.localResource,I))return b.localContent;if(this.extUri.isEqual(b.baseResource,I))return b.baseContent}return null}async resetLocal(){this.storageService.remove(this.lastSyncUserDataStateKey,-1);try{await this.fileService.del(this.lastSyncResource)}catch(I){(0,c.toFileOperationResult)(I)!==1&&this.logService.error(I)}}async doGenerateSyncResourcePreview(I,w,b,D,L,N){const F=await this.generateSyncPreview(I,w,b,L,N),x=[];for(const X of F){const B=X.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(X.localChange===0&&X.remoteChange===0)x.push({...X,acceptedResource:B,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Y=D?await this.getMergeResult(X,N):void 0;if(N.isCancellationRequested)break;await this.fileService.writeFile(X.previewResource,A.VSBuffer.fromString(Y?.content||""));const z=Y&&!Y.hasConflicts?await this.getAcceptResult(X,X.previewResource,void 0,N):void 0;x.push({...X,acceptResult:z,mergeState:Y?.hasConflicts?"conflict":z?"accepted":"preview",localChange:z?z.localChange:Y?Y.localChange:X.localChange,remoteChange:z?z.remoteChange:Y?Y.remoteChange:X.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:I,lastSyncUserData:w,resourcePreviews:x,isLastSyncFromCurrentMachine:b}}async getLastSyncUserData(){let I=this.getStoredLastSyncUserDataStateContent();if(I||(I=await this.migrateLastSyncUserData()),!I)return this.logService.info(`${this.syncResourceLogLabel}: Last sync data state does not exist.`),null;const w=JSON.parse(I),b=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=!!w.version&&!!b&&w.version!==b,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${w.version} is not compatible with current sync state version ${b}.`),await this.resetLocal(),null;let D,L=1;for(;D===void 0&&L++<6;)try{const N=await this.readLastSyncStoredRemoteUserData();N&&(N.ref===w.ref?D=N.syncData:this.logService.info(`${this.syncResourceLogLabel}: Last sync data stored locally is not same as the last sync state.`));break}catch(N){if(N instanceof c.FileOperationError&&N.fileOperationResult===1){this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist locally.`);break}else{if(N instanceof f.UserDataSyncError)throw N;this.logService.error(N,L)}}if(D===void 0)try{const N=await this.userDataSyncStoreService.resolveResourceContent(this.resource,w.ref,this.collection,this.syncHeaders);D=N===null?null:this.parseSyncData(N),await this.writeLastSyncStoredRemoteUserData({ref:w.ref,syncData:D})}catch(N){if(N instanceof f.UserDataSyncError&&N.code==="NotFound")this.logService.info(`${this.syncResourceLogLabel}: Last sync resource does not exist remotely.`);else throw N}return D===void 0?null:{...w,syncData:D}}async updateLastSyncUserData(I,w={}){if(w.ref||w.version)throw new Error("Cannot have core properties as additional");const b=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),D={ref:I.ref,version:b,...w};this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify(D),-1,1),await this.writeLastSyncStoredRemoteUserData(I)}getStoredLastSyncUserDataStateContent(){return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async readLastSyncStoredRemoteUserData(){const I=(await this.fileService.readFile(this.lastSyncResource)).value.toString();try{const w=I?JSON.parse(I):void 0;if(t(w))return w}catch(w){this.logService.error(w)}}async writeLastSyncStoredRemoteUserData(I){await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(I)))}async migrateLastSyncUserData(){try{const I=await this.fileService.readFile(this.lastSyncResource),w=JSON.parse(I.value.toString());await this.fileService.del(this.lastSyncResource),w.ref&&w.content!==void 0?(this.storageService.store(this.lastSyncUserDataStateKey,JSON.stringify({...w,content:void 0}),-1,1),await this.writeLastSyncStoredRemoteUserData({ref:w.ref,syncData:w.content===null?null:JSON.parse(w.content)})):this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Invalid data.`,w)}catch(I){I instanceof c.FileOperationError&&I.fileOperationResult===1?this.logService.info(`${this.syncResourceLogLabel}: Migrating last sync user data. Resource does not exist.`):this.logService.error(I)}return this.storageService.get(this.lastSyncUserDataStateKey,-1)}async getRemoteUserData(I){const{ref:w,content:b}=await this.getUserData(I);let D=null;return b!==null&&(D=this.parseSyncData(b)),{ref:w,syncData:D}}parseSyncData(I){try{const w=JSON.parse(I);if(r(w))return w}catch(w){this.logService.error(w)}throw new f.UserDataSyncError((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(I){const w=I?{ref:I.ref,content:I.syncData?JSON.stringify(I.syncData):null}:null;return this.userDataSyncStoreService.readResource(this.resource,w,this.collection,this.syncHeaders)}async updateRemoteUserData(I,w){const b=await this.currentMachineIdPromise,D={version:this.version,machineId:b,content:I};try{return w=await this.userDataSyncStoreService.writeResource(this.resource,JSON.stringify(D),w,this.collection,this.syncHeaders),{ref:w,syncData:D}}catch(L){throw L instanceof f.UserDataSyncError&&L.code==="TooLarge"&&(L=new f.UserDataSyncError(L.message,L.code,this.resource)),L}}async backupLocal(I){const w={version:this.version,content:I};return this.userDataSyncLocalStoreService.writeResource(this.resource,JSON.stringify(w),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(f.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};e.AbstractSynchroniser=s,e.AbstractSynchroniser=s=Ce([K(2,c.IFileService),K(3,l.IEnvironmentService),K(4,u.IStorageService),K(5,f.IUserDataSyncStoreService),K(6,f.IUserDataSyncLocalStoreService),K(7,f.IUserDataSyncEnablementService),K(8,h.ITelemetryService),K(9,f.IUserDataSyncLogService),K(10,v.IConfigurationService),K(11,m.IUriIdentityService)],s);let i=class extends s{constructor(I,w,b,D,L,N,F,x,X,B,Y,z,H){super(w,b,D,L,N,F,x,X,B,Y,z,H),this.file=I,this._register(this.fileService.watch(this.extUri.dirname(I))),this._register(this.fileService.onDidFilesChange(V=>this.onFileChanges(V)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(I,w,b){try{w?await this.fileService.writeFile(this.file,A.VSBuffer.fromString(I),b?void 0:w):await this.fileService.createFile(this.file,A.VSBuffer.fromString(I),{overwrite:b})}catch(D){throw D instanceof c.FileOperationError&&D.fileOperationResult===1||D instanceof c.FileOperationError&&D.fileOperationResult===3?new f.UserDataSyncError(D.message,"LocalPreconditionFailed"):D}}async deleteLocalFile(){try{await this.fileService.del(this.file)}catch(I){if(!(I instanceof c.FileOperationError&&I.fileOperationResult===1))throw I}}onFileChanges(I){I.contains(this.file)&&this.triggerLocalChange()}};e.AbstractFileSynchroniser=i,e.AbstractFileSynchroniser=i=Ce([K(3,c.IFileService),K(4,l.IEnvironmentService),K(5,u.IStorageService),K(6,f.IUserDataSyncStoreService),K(7,f.IUserDataSyncLocalStoreService),K(8,f.IUserDataSyncEnablementService),K(9,h.ITelemetryService),K(10,f.IUserDataSyncLogService),K(11,v.IConfigurationService),K(12,m.IUriIdentityService)],i);let o=class extends i{constructor(I,w,b,D,L,N,F,x,X,B,Y,z,H,V){super(I,w,b,D,L,N,F,x,X,B,Y,H,V),this.userDataSyncUtilService=z,this._formattingOptions=void 0}hasErrors(I,w){const b=[],D=(0,R.parse)(I,b,{allowEmptyContent:!0,allowTrailingComma:!0});return b.length>0||!(0,C.isUndefined)(D)&&w!==Array.isArray(D)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};e.AbstractJsonFileSynchroniser=o,e.AbstractJsonFileSynchroniser=o=Ce([K(3,c.IFileService),K(4,l.IEnvironmentService),K(5,u.IStorageService),K(6,f.IUserDataSyncStoreService),K(7,f.IUserDataSyncLocalStoreService),K(8,f.IUserDataSyncEnablementService),K(9,h.ITelemetryService),K(10,f.IUserDataSyncLogService),K(11,f.IUserDataSyncUtilService),K(12,v.IConfigurationService),K(13,m.IUriIdentityService)],o);let a=class{constructor(I,w,b,D,L,N,F){this.resource=I,this.userDataProfilesService=w,this.environmentService=b,this.logService=D,this.fileService=L,this.storageService=N,this.extUri=F.extUri,this.lastSyncResource=(0,f.getLastSyncResourceUri)(void 0,this.resource,b,this.extUri)}async initialize({ref:I,content:w}){if(!w){this.logService.info("Remote content does not exist.",this.resource);return}const b=this.parseSyncData(w);if(b)try{await this.doInitialize({ref:I,syncData:b})}catch(D){this.logService.error(D)}}parseSyncData(I){try{const w=JSON.parse(I);if(r(w))return w}catch(w){this.logService.error(w)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(I,w={}){if(w.ref||w.version)throw new Error("Cannot have core properties as additional");const b={ref:I.ref,version:void 0,...w};this.storageService.store(`${this.resource}.lastSyncUserData`,JSON.stringify(b),-1,1),await this.fileService.writeFile(this.lastSyncResource,A.VSBuffer.fromString(JSON.stringify(I)))}};e.AbstractInitializer=a,e.AbstractInitializer=a=Ce([K(1,S.IUserDataProfilesService),K(2,l.IEnvironmentService),K(3,p.ILogService),K(4,c.IFileService),K(5,u.IStorageService),K(6,m.IUriIdentityService)],a)}),define(ae[115],ce([0,1,6,26,7,3,44,2,27,21,16,114,29,33,82,48,12,4,74,9,19,22,28,18,39,241,111,25,60]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g,u,h,m,f,S,t,r,n,s,i,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=void 0,e.parseExtensions=I,e.stringify=w;async function y(N,F){const x=JSON.parse(N.content);if(N.version===1||N.version===2){const X=(await F.getInstalled(0)).filter(B=>B.isBuiltin);for(const B of x)N.version===1&&(B.enabled===!1&&(B.disabled=!0),delete B.enabled),N.version===2&&X.every(Y=>!(0,l.areSameExtensions)(Y.identifier,B.identifier))&&(B.installed=!0)}return x}function I(N){return JSON.parse(N.content)}function w(N,F){return N.sort((x,X)=>!x.identifier.uuid&&X.identifier.uuid?-1:x.identifier.uuid&&!X.identifier.uuid?1:(0,P.compare)(x.identifier.id,X.identifier.id)),F?(0,k.toFormattedString)(N,{}):JSON.stringify(N)}let b=class extends n.AbstractSynchroniser{constructor(F,x,X,B,Y,z,H,V,q,ie,re,ue,te,j,W,T,M){super({syncResource:"extensions",profile:F},x,B,X,Y,z,H,ue,te,ie,re,W),this.extensionManagementService=V,this.ignoredExtensionsManagementService=q,this.instantiationService=M,this.version=6,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:o.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localExtensionsProvider=this.instantiationService.createInstance(D),this._register(O.Event.any(O.Event.filter(this.extensionManagementService.onDidInstallExtensions,$=>$.some(({local:Q})=>!!Q)),O.Event.filter(this.extensionManagementService.onDidUninstallExtension,$=>!$.error),O.Event.filter(T.onDidChange,$=>$.valueChanges.some(({profile:Q,changes:G})=>this.syncResource.profile.id===Q.id&&G.some(ee=>ee.key===v.DISABLED_EXTENSIONS_STORAGE_PATH))),j.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(F,x){const X=F.syncData?await y(F.syncData,this.extensionManagementService):null,B=x?.skippedExtensions??[],Y=x?.builtinExtensions??null,z=x?.syncData?await y(x.syncData,this.extensionManagementService):null,{localExtensions:H,ignoredExtensions:V}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);X?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:q,remote:ie}=(0,s.merge)(H,X,z,B,V,Y),re={local:q,remote:ie,content:this.getPreviewContent(H,q.added,q.updated,q.removed),localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?2:0,remoteChange:ie!==null?2:0},ue=this.stringify(H,!1);return[{skippedExtensions:B,builtinExtensions:Y,baseResource:this.baseResource,baseContent:z?this.stringify(z,!1):ue,localResource:this.localResource,localContent:ue,localExtensions:H,remoteResource:this.remoteResource,remoteExtensions:X,remoteContent:X?this.stringify(X,!1):null,previewResource:this.previewResource,previewResult:re,localChange:re.localChange,remoteChange:re.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(F){const x=F.syncData?await y(F.syncData,this.extensionManagementService):null,{localExtensions:X,ignoredExtensions:B}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile),{remote:Y}=(0,s.merge)(X,x,x,F.skippedExtensions||[],B,F.builtinExtensions||[]);return Y!==null}getPreviewContent(F,x,X,B){const Y=[...x,...X],z=new Set,H=V=>{z.add(V.id.toLowerCase()),V.uuid&&z.add(V.uuid)};Y.forEach(({identifier:V})=>H(V)),B.forEach(H);for(const V of F)z.has(V.identifier.id.toLowerCase())||V.identifier.uuid&&z.has(V.identifier.uuid)||Y.push(V);return this.stringify(Y,!1)}async getMergeResult(F,x){return{...F.previewResult,hasConflicts:!1}}async getAcceptResult(F,x,X,B){if(this.extUri.isEqual(x,this.localResource))return this.acceptLocal(F);if(this.extUri.isEqual(x,this.remoteResource))return this.acceptRemote(F);if(this.extUri.isEqual(x,this.previewResource))return F.previewResult;throw new Error(`Invalid Resource: ${x.toString()}`)}async acceptLocal(F){const x=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),X=this.ignoredExtensionsManagementService.getIgnoredExtensions(x),B=(0,s.merge)(F.localExtensions,null,null,F.skippedExtensions,X,F.builtinExtensions),{local:Y,remote:z}=B;return{content:F.localContent,local:Y,remote:z,localChange:Y.added.length>0||Y.removed.length>0||Y.updated.length>0?2:0,remoteChange:z!==null?2:0}}async acceptRemote(F){const x=await this.extensionManagementService.getInstalled(void 0,this.syncResource.profile.extensionsResource),X=this.ignoredExtensionsManagementService.getIgnoredExtensions(x),B=F.remoteContent?JSON.parse(F.remoteContent):null;if(B!==null){const Y=(0,s.merge)(F.localExtensions,B,F.localExtensions,[],X,F.builtinExtensions),{local:z,remote:H}=Y;return{content:F.remoteContent,local:z,remote:H,localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:H!==null?2:0}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(F,x,X,B){let{skippedExtensions:Y,builtinExtensions:z,localExtensions:H}=X[0][0];const{local:V,remote:q,localChange:ie,remoteChange:re}=X[0][1];if(ie===0&&re===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),ie!==0&&(await this.backupLocal(JSON.stringify(H)),Y=await this.localExtensionsProvider.updateLocalExtensions(V.added,V.removed,V.updated,Y,this.syncResource.profile)),q){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const ue=JSON.stringify(q.all);F=await this.updateRemoteUserData(ue,B?null:F.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${q.added.length?` Added: ${JSON.stringify(q.added.map(te=>te.identifier.id))}.`:""}${q.updated.length?` Updated: ${JSON.stringify(q.updated.map(te=>te.identifier.id))}.`:""}${q.removed.length?` Removed: ${JSON.stringify(q.removed.map(te=>te.identifier.id))}.`:""}`)}x?.ref!==F.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),z=this.computeBuiltinExtensions(H,z),await this.updateLastSyncUserData(F,{skippedExtensions:Y,builtinExtensions:z}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${Y.length?` Skipped: ${JSON.stringify(Y.map(ue=>ue.identifier.id))}.`:""}`))}computeBuiltinExtensions(F,x){const X=new Set,B=[];for(const Y of F)X.add(Y.identifier.id.toLowerCase()),Y.installed||B.push(Y.identifier);if(x)for(const Y of x)X.has(Y.id.toLowerCase())||B.push(Y);return B}async resolveContent(F){if(this.extUri.isEqual(this.remoteResource,F)||this.extUri.isEqual(this.baseResource,F)||this.extUri.isEqual(this.localResource,F)||this.extUri.isEqual(this.acceptedResource,F)){const x=await this.resolvePreviewContent(F);return x&&this.stringify(JSON.parse(x),!0)}return null}stringify(F,x){return w(F,x)}async hasLocalData(){try{const{localExtensions:F}=await this.localExtensionsProvider.getLocalExtensions(this.syncResource.profile);if(F.some(x=>x.installed||x.disabled))return!0}catch{}return!1}};e.ExtensionsSynchroniser=b,e.ExtensionsSynchroniser=b=Ce([K(2,C.IEnvironmentService),K(3,g.IFileService),K(4,f.IStorageService),K(5,o.IUserDataSyncStoreService),K(6,o.IUserDataSyncLocalStoreService),K(7,v.IExtensionManagementService),K(8,i.IIgnoredExtensionsManagementService),K(9,o.IUserDataSyncLogService),K(10,d.IConfigurationService),K(11,o.IUserDataSyncEnablementService),K(12,S.ITelemetryService),K(13,c.IExtensionStorageService),K(14,t.IUriIdentityService),K(15,a.IUserDataProfileStorageService),K(16,u.IInstantiationService)],b);let D=class{constructor(F,x,X,B,Y,z){this.extensionManagementService=F,this.userDataProfileStorageService=x,this.extensionGalleryService=X,this.ignoredExtensionsManagementService=B,this.instantiationService=Y,this.logService=z}async getLocalExtensions(F){const x=await this.extensionManagementService.getInstalled(void 0,F.extensionsResource),X=this.ignoredExtensionsManagementService.getIgnoredExtensions(x);return{localExtensions:await this.withProfileScopedServices(F,async(Y,z)=>{const H=Y.getDisabledExtensions();return x.map(V=>{const{identifier:q,isBuiltin:ie,manifest:re,preRelease:ue,pinned:te,isApplicationScoped:j}=V,W={identifier:q,preRelease:ue,version:re.version,pinned:!!te};j&&!(0,p.isApplicationScopedExtension)(re)&&(W.isApplicationScoped=j),H.some(T=>(0,l.areSameExtensions)(T,q))&&(W.disabled=!0),ie||(W.installed=!0);try{const T=z.getKeysForSync({id:q.id,version:re.version});if(T){const M=z.getExtensionState(V,!0)||{};W.state=Object.keys(M).reduce(($,Q)=>(T.includes(Q)&&($[Q]=M[Q]),$),{})}}catch(T){this.logService.info(`${(0,n.getSyncResourceLogLabel)("extensions",F)}: Error while parsing extension state`,(0,A.getErrorMessage)(T))}return W})}),ignoredExtensions:X}}async updateLocalExtensions(F,x,X,B,Y){const z=(0,n.getSyncResourceLogLabel)("extensions",Y),H=[],V=new Map,q=[],ie=[],re=await this.extensionManagementService.getInstalled(void 0,Y.extensionsResource);if((F.length||X.length)&&await this.withProfileScopedServices(Y,async(j,W)=>{await _.Promises.settled([...F,...X].map(async T=>{const M=re.find(G=>(0,l.areSameExtensions)(G.identifier,T.identifier));if(M&&M.isBuiltin){T.state&&M.manifest.version===T.version&&this.updateExtensionState(T.state,M,M.manifest.version,W),j.getDisabledExtensions().some(ee=>(0,l.areSameExtensions)(ee,T.identifier))!==!!T.disabled&&(T.disabled?(this.logService.trace(`${z}: Disabling extension...`,T.identifier.id),await j.disableExtension(T.identifier),this.logService.info(`${z}: Disabled extension`,T.identifier.id)):(this.logService.trace(`${z}: Enabling extension...`,T.identifier.id),await j.enableExtension(T.identifier),this.logService.info(`${z}: Enabled extension`,T.identifier.id))),q.push(T.identifier);return}const $=T.pinned?T.version:void 0,Q=(await this.extensionGalleryService.getExtensions([{...T.identifier,version:$,preRelease:$?void 0:T.preRelease}],U.CancellationToken.None))[0];if(T.state&&(M?M.manifest.version===T.version:Q)&&this.updateExtensionState(T.state,M||Q,M?.manifest.version,W),Q)try{j.getDisabledExtensions().some(ee=>(0,l.areSameExtensions)(ee,T.identifier))!==!!T.disabled&&(T.disabled?(this.logService.trace(`${z}: Disabling extension...`,T.identifier.id,Q.version),await j.disableExtension(Q.identifier),this.logService.info(`${z}: Disabled extension`,T.identifier.id,Q.version)):(this.logService.trace(`${z}: Enabling extension...`,T.identifier.id,Q.version),await j.enableExtension(Q.identifier),this.logService.info(`${z}: Enabled extension`,T.identifier.id,Q.version))),(!M||M.preRelease!==T.preRelease||M.pinned!==T.pinned||$&&M.manifest.version!==$)&&(await this.extensionManagementService.canInstall(Q)?(H.push({extension:Q,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:T.pinned&&!!T.version,installPreReleaseVersion:T.preRelease,profileLocation:Y.extensionsResource,isApplicationScoped:T.isApplicationScoped,context:{[v.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[v.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}}),V.set(Q.identifier.id.toLowerCase(),T)):(this.logService.info(`${z}: Skipped synchronizing extension because it cannot be installed.`,Q.displayName||Q.identifier.id),ie.push(T)))}catch(G){ie.push(T),this.logService.error(G),this.logService.info(`${z}: Skipped synchronizing extension`,Q.displayName||Q.identifier.id)}else ie.push(T),this.logService.info(`${z}: Skipped synchronizing extension because the extension is not found.`,T.identifier.id)}))}),x.length){const j=re.filter(({identifier:W,isBuiltin:T})=>!T&&x.some(M=>(0,l.areSameExtensions)(W,M)));await _.Promises.settled(j.map(async W=>{this.logService.trace(`${z}: Uninstalling local extension...`,W.identifier.id),await this.extensionManagementService.uninstall(W,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Y.extensionsResource}),this.logService.info(`${z}: Uninstalled local extension.`,W.identifier.id),q.push(W.identifier)}))}const ue=await this.extensionManagementService.installGalleryExtensions(H);for(const{identifier:j,local:W,error:T,source:M}of ue){const $=M;if(W)this.logService.info(`${z}: Installed extension.`,j.id,$.version),q.push(j);else{const Q=V.get(j.id.toLowerCase());Q&&(ie.push(Q),this.logService.info(`${z}: Skipped synchronizing extension`,$.displayName||$.identifier.id)),T instanceof v.ExtensionManagementError&&[v.ExtensionManagementErrorCode.Incompatible,v.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(T.code)?this.logService.info(`${z}: Skipped synchronizing extension because the compatible extension is not found.`,$.displayName||$.identifier.id):T&&this.logService.error(T)}}const te=[];for(const j of B)q.some(W=>(0,l.areSameExtensions)(W,j.identifier))||te.push(j);for(const j of ie)te.some(W=>(0,l.areSameExtensions)(W.identifier,j.identifier))||te.push(j);return te}updateExtensionState(F,x,X,B){const Y=B.getExtensionState(x,!0)||{},z=X?B.getKeysForSync({id:x.identifier.id,version:X}):void 0;z?z.forEach(H=>{Y[H]=F[H]}):Object.keys(F).forEach(H=>Y[H]=F[H]),B.setExtensionState(x,Y,!0)}async withProfileScopedServices(F,x){return this.userDataProfileStorageService.withProfileScopedStorageService(F,async X=>{const B=new R.DisposableStore,Y=this.instantiationService.createChild(new h.ServiceCollection([f.IStorageService,X])),z=B.add(Y.createInstance(E.GlobalExtensionEnablementService)),H=B.add(Y.createInstance(c.ExtensionStorageService));try{return await x(z,H)}finally{B.dispose()}})}};e.LocalExtensionsProvider=D,e.LocalExtensionsProvider=D=Ce([K(0,v.IExtensionManagementService),K(1,a.IUserDataProfileStorageService),K(2,v.IExtensionGalleryService),K(3,i.IIgnoredExtensionsManagementService),K(4,u.IInstantiationService),K(5,o.IUserDataSyncLogService)],D);let L=class extends n.AbstractInitializer{constructor(F,x,X,B,Y,z,H,V){super("extensions",B,Y,z,X,H,V),this.extensionManagementService=F,this.ignoredExtensionsManagementService=x}async parseExtensions(F){return F.syncData?await y(F.syncData,this.extensionManagementService):null}generatePreview(F,x){const X=[],B=[],Y=[];for(const z of F){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(z.identifier.id))continue;const H=x.find(V=>(0,l.areSameExtensions)(V.identifier,z.identifier));H?(X.push(H),z.disabled&&Y.push(z.identifier)):z.installed&&(B.push({...z.identifier,preRelease:!!z.preRelease}),z.disabled&&Y.push(z.identifier))}return{installedExtensions:X,newExtensions:B,disabledExtensions:Y,remoteExtensions:F}}};e.AbstractExtensionsInitializer=L,e.AbstractExtensionsInitializer=L=Ce([K(0,v.IExtensionManagementService),K(1,i.IIgnoredExtensionsManagementService),K(2,g.IFileService),K(3,r.IUserDataProfilesService),K(4,C.IEnvironmentService),K(5,m.ILogService),K(6,f.IStorageService),K(7,t.IUriIdentityService)],L)}),define(ae[116],ce([0,1,15,7,3,35,44,5,32,21,16,12,9,45,19,22,28,39,79,245,25,18,60,4]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g,u,h,m,f,S,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=void 0,e.stringify=i;const n="globalState.argv.",s=["locale"];function i(b,D){const L=b.storage?Object.keys(b.storage).sort():[],N={};return L.forEach(F=>N[F]=b.storage[F]),b.storage=N,D?(0,k.toFormattedString)(b,{}):JSON.stringify(b)}const o=1;let a=class extends u.AbstractSynchroniser{constructor(D,L,N,F,x,X,B,Y,z,H,V,q,ie,re){super({syncResource:"globalState",profile:D},L,F,Y,q,x,X,z,H,B,V,ie),this.userDataProfileStorageService=N,this.version=o,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.localGlobalStateProvider=re.createInstance(y),this._register(F.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(A.Event.any(A.Event.filter(F.onDidFilesChange,ue=>ue.contains(this.environmentService.argvResource)),A.Event.filter(N.onDidChange,ue=>!!(ue.targetChanges.some(te=>this.syncResource.profile.id===te.id)||ue.valueChanges.some(({profile:te,changes:j})=>this.syncResource.profile.id===te.id&&j.some(W=>W.target===0)))))(()=>this.triggerLocalChange()))}async generateSyncPreview(D,L,N){const F=D.syncData?JSON.parse(D.syncData.content):null;L=L===null&&N?D:L;const x=L&&L.syncData?JSON.parse(L.syncData.content):null,X=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);F?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const B=await this.getStorageKeys(x),{local:Y,remote:z}=(0,m.merge)(X.storage,F?F.storage:null,x?x.storage:null,B,this.logService),H={content:null,local:Y,remote:z,localChange:Object.keys(Y.added).length>0||Object.keys(Y.updated).length>0||Y.removed.length>0?2:0,remoteChange:z.all!==null?2:0},V=i(X,!1);return[{baseResource:this.baseResource,baseContent:x?i(x,!1):V,localResource:this.localResource,localContent:V,localUserData:X,remoteResource:this.remoteResource,remoteContent:F?i(F,!1):null,previewResource:this.previewResource,previewResult:H,localChange:H.localChange,remoteChange:H.remoteChange,acceptedResource:this.acceptedResource,storageKeys:B}]}async hasRemoteChanged(D){const L=D.syncData?JSON.parse(D.syncData.content):null;if(L===null)return!0;const N=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile),F=await this.getStorageKeys(L),{remote:x}=(0,m.merge)(N.storage,L.storage,L.storage,F,this.logService);return x.all!==null}async getMergeResult(D,L){return{...D.previewResult,hasConflicts:!1}}async getAcceptResult(D,L,N,F){if(this.extUri.isEqual(L,this.localResource))return this.acceptLocal(D);if(this.extUri.isEqual(L,this.remoteResource))return this.acceptRemote(D);if(this.extUri.isEqual(L,this.previewResource))return D.previewResult;throw new Error(`Invalid Resource: ${L.toString()}`)}async acceptLocal(D){return{content:D.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(D.localUserData.storage),removed:[],updated:[],all:D.localUserData.storage},localChange:0,remoteChange:2}}async acceptRemote(D){if(D.remoteContent!==null){const L=JSON.parse(D.remoteContent),{local:N,remote:F}=(0,m.merge)(D.localUserData.storage,L.storage,null,D.storageKeys,this.logService);return{content:D.remoteContent,local:N,remote:F,localChange:Object.keys(N.added).length>0||Object.keys(N.updated).length>0||N.removed.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:D.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async applyResult(D,L,N,F){const{localUserData:x}=N[0][0],{local:X,remote:B,localChange:Y,remoteChange:z}=N[0][1];if(Y===0&&z===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),Y!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(x)),await this.localGlobalStateProvider.writeLocalGlobalState(X,this.syncResource.profile),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),z!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const H=JSON.stringify({storage:B.all});D=await this.updateRemoteUserData(H,F?null:D.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state.${B.added.length?` Added: ${B.added}.`:""}${B.updated.length?` Updated: ${B.updated}.`:""}${B.removed.length?` Removed: ${B.removed}.`:""}`)}L?.ref!==D.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(D),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async resolveContent(D){if(this.extUri.isEqual(this.remoteResource,D)||this.extUri.isEqual(this.baseResource,D)||this.extUri.isEqual(this.localResource,D)||this.extUri.isEqual(this.acceptedResource,D)){const L=await this.resolvePreviewContent(D);return L&&i(JSON.parse(L),!0)}return null}async hasLocalData(){try{const{storage:D}=await this.localGlobalStateProvider.getLocalGlobalState(this.syncResource.profile);if(Object.keys(D).length>1||D[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async getStorageKeys(D){const L=await this.userDataProfileStorageService.readStorageData(this.syncResource.profile),N=[],F=[];for(const[B,Y]of L)Y.target===0?N.push(B):Y.target===1&&F.push(B);const x=[...N,...F],X=D?.storage?Object.keys(D.storage).filter(B=>!B.startsWith(n)&&!x.includes(B)&&L.get(B)!==void 0):[];if(!R.isWeb){const B=[...f.ALL_SYNC_RESOURCES.map(Y=>(0,f.getEnablementKey)(Y)),f.SYNC_SERVICE_URL_TYPE];X.push(...B),F.push(...B)}return{user:N,machine:F,unregistered:X}}};e.GlobalStateSynchroniser=a,e.GlobalStateSynchroniser=a=Ce([K(2,t.IUserDataProfileStorageService),K(3,E.IFileService),K(4,f.IUserDataSyncStoreService),K(5,f.IUserDataSyncLocalStoreService),K(6,f.IUserDataSyncLogService),K(7,C.IEnvironmentService),K(8,f.IUserDataSyncEnablementService),K(9,p.ITelemetryService),K(10,d.IConfigurationService),K(11,c.IStorageService),K(12,g.IUriIdentityService),K(13,r.IInstantiationService)],a);let y=class{constructor(D,L,N,F){this.fileService=D,this.environmentService=L,this.userDataProfileStorageService=N,this.logService=F}async getLocalGlobalState(D){const L={};if(D.isDefault){const F=await this.getLocalArgvContent(),x=(0,O.parse)(F);for(const X of s)x[X]!==void 0&&(L[`${n}${X}`]={version:1,value:x[X]})}const N=await this.userDataProfileStorageService.readStorageData(D);for(const[F,x]of N)x.value&&x.target===0&&(L[F]={version:1,value:x.value});return{storage:L}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const D=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),D.value.toString()}catch(D){this.logService.debug((0,U.getErrorMessage)(D))}return"{}"}async writeLocalGlobalState({added:D,removed:L,updated:N},F){const x=(0,u.getSyncResourceLogLabel)("globalState",F),X={},B=new Map,Y=await this.userDataProfileStorageService.readStorageData(F),z=(H,V)=>{for(const q of H){if(q.startsWith(n)){X[q.substring(n.length)]=V?V[q].value:void 0;continue}if(V){const ie=V[q];ie.value!==Y.get(q)?.value&&B.set(q,ie.value)}else Y.get(q)!==void 0&&B.set(q,void 0)}};if(z(Object.keys(D),D),z(Object.keys(N),N),z(L),Object.keys(X).length){this.logService.trace(`${x}: Updating locale...`);const H=await this.getLocalArgvContent();let V=H;for(const q of Object.keys(X))V=(0,h.edit)(V,[q],X[q],{});H!==V&&(this.logService.trace(`${x}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,_.VSBuffer.fromString(V)),this.logService.info(`${x}: Updated locale.`)),this.logService.info(`${x}: Updated locale`)}B.size&&(this.logService.trace(`${x}: Updating global state...`),await this.userDataProfileStorageService.updateStorageData(F,B,0),this.logService.info(`${x}: Updated global state`,[...B.keys()]))}};e.LocalGlobalStateProvider=y,e.LocalGlobalStateProvider=y=Ce([K(0,E.IFileService),K(1,C.IEnvironmentService),K(2,t.IUserDataProfileStorageService),K(3,f.IUserDataSyncLogService)],y);let I=class extends u.AbstractInitializer{constructor(D,L,N,F,x,X){super("globalState",N,F,x,L,D,X)}async doInitialize(D){const L=D.syncData?JSON.parse(D.syncData.content):null;if(!L){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const N={},F={};for(const x of Object.keys(L.storage))x.startsWith(n)?N[x.substring(n.length)]=L.storage[x].value:this.storageService.get(x,0)===void 0&&(F[x]=L.storage[x].value);if(Object.keys(N).length){let x="{}";try{x=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const X of Object.keys(N))x=(0,h.edit)(x,[X],N[X],{});await this.fileService.writeFile(this.environmentService.argvResource,_.VSBuffer.fromString(x))}if(Object.keys(F).length){const x=[];for(const X of Object.keys(F))x.push({key:X,value:F[X],scope:0,target:0});this.storageService.storeAll(x,!0)}}};e.GlobalStateInitializer=I,e.GlobalStateInitializer=I=Ce([K(0,c.IStorageService),K(1,E.IFileService),K(2,S.IUserDataProfilesService),K(3,C.IEnvironmentService),K(4,f.IUserDataSyncLogService),K(5,g.IUriIdentityService)],I);let w=class{constructor(D,L,N,F,x){this.userDataSyncStoreClient=D,this.storageService=L,this.environmentService=N,this.fileService=F,this.logService=x}getSyncStoreType(D){return this.parseGlobalState(D)?.storage[f.SYNC_SERVICE_URL_TYPE]?.value}async sync(D){const L=(0,f.createSyncHeaders)((0,P.generateUuid)());try{return await this.doSync(D,L)}catch(N){if(N instanceof f.UserDataSyncError)switch(N.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(D,L)}throw N}}async doSync(D,L){const N=await this.userDataSyncStoreClient.readResource("globalState",null,void 0,L),F=this.parseGlobalState(N)||{storage:{}};F.storage[f.SYNC_SERVICE_URL_TYPE]={value:D,version:o};const x=await(0,l.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),X={version:o,machineId:x,content:i(F,!1)};await this.userDataSyncStoreClient.writeResource("globalState",JSON.stringify(X),N.ref,void 0,L)}parseGlobalState({content:D}){if(!D)return null;const L=JSON.parse(D);if((0,u.isSyncData)(L))return L?JSON.parse(L.content):null;throw new Error("Invalid remote data")}};e.UserDataSyncStoreTypeSynchronizer=w,e.UserDataSyncStoreTypeSynchronizer=w=Ce([K(1,c.IStorageService),K(2,C.IEnvironmentService),K(3,E.IFileService),K(4,v.ILogService)],w)}),define(ae[117],ce([0,1,17,15,3,35,5,13,176,21,16,12,19,22,28,18,39,242,25]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=void 0,e.getKeybindingsContentFromSyncContent=m;function m(t,r,n){try{const s=JSON.parse(t);if(!r)return(0,R.isUndefined)(s.all)?null:s.all;switch(k.OS){case 2:return(0,R.isUndefined)(s.mac)?null:s.mac;case 3:return(0,R.isUndefined)(s.linux)?null:s.linux;case 1:return(0,R.isUndefined)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}let f=class extends g.AbstractJsonFileSynchroniser{constructor(r,n,s,i,o,a,y,I,w,b,D,L,N){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},n,I,w,b,s,i,y,L,o,D,a,N),this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(A.Event.filter(a.onDidChangeConfiguration,F=>F.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,n,s,i){const o=r.syncData?m(r.syncData.content,i.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;n=n===null&&s?r:n;const a=n?this.getKeybindingsContentFromLastSyncUserData(n):null,y=await this.getLocalFileContent(),I=await this.getFormattingOptions();let w=null,b=!1,D=!1,L=!1;if(o){let x=y?y.value.toString():"[]";if(x=x||"[]",this.hasErrors(x,!0))throw new h.UserDataSyncError((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==x||a!==o){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const X=await(0,u.merge)(x,o,a,I,this.userDataSyncUtilService);X.hasChanges&&(w=X.mergeContent,L=X.hasConflicts,b=L||X.mergeContent!==x,D=L||X.mergeContent!==o)}}else y&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),w=y.value.toString(),D=!0);const N={content:L?a:w,localChange:b?y?2:1:0,remoteChange:D?2:0,hasConflicts:L},F=y?y.value.toString():null;return[{fileContent:y,baseResource:this.baseResource,baseContent:a,localResource:this.localResource,localContent:F,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:o,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const n=this.getKeybindingsContentFromLastSyncUserData(r);if(n===null)return!0;const s=await this.getLocalFileContent(),i=s?s.value.toString():"",o=await this.getFormattingOptions(),a=await(0,u.merge)(i||"[]",n,n,o,this.userDataSyncUtilService);return a.hasConflicts||a.mergeContent!==n}async getMergeResult(r,n){return r.previewResult}async getAcceptResult(r,n,s,i){if(this.extUri.isEqual(n,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return s===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(r,n,s,i){const{fileContent:o}=s[0][0];let{content:a,localChange:y,remoteChange:I}=s[0][1];if(y===0&&I===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a,!0)))throw new h.UserDataSyncError((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(y!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),o&&await this.backupLocal(this.toSyncContent(o.value.toString())),await this.updateLocalFileContent(a||"[]",o,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),I!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const w=this.toSyncContent(a||"[]",r.syncData?.content);r=await this.updateRemoteUserData(w,i?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}n?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const n=(0,O.parse)(r.value.toString());if((0,_.isNonEmptyArray)(n))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.baseResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r)?this.resolvePreviewContent(r):null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:m(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,n){let s={};try{s=JSON.parse(n||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete s.all:s.all=r,k.OS){case 2:s.mac=r;break;case 3:s.linux=r;break;case 1:s.windows=r;break}return JSON.stringify(s)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue(h.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};e.KeybindingsSynchroniser=f,e.KeybindingsSynchroniser=f=Ce([K(2,h.IUserDataSyncStoreService),K(3,h.IUserDataSyncLocalStoreService),K(4,h.IUserDataSyncLogService),K(5,d.IConfigurationService),K(6,h.IUserDataSyncEnablementService),K(7,E.IFileService),K(8,C.IEnvironmentService),K(9,v.IStorageService),K(10,h.IUserDataSyncUtilService),K(11,l.ITelemetryService),K(12,c.IUriIdentityService)],f);let S=class extends g.AbstractInitializer{constructor(r,n,s,i,o,a){super("keybindings",n,s,i,r,o,a)}async doInitialize(r){const n=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!n){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,U.VSBuffer.fromString(n)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),n=(0,O.parse)(r.value.toString());return!(0,_.isNonEmptyArray)(n)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return m(r,!0,this.logService)}catch(n){return this.logService.error(n),null}}};e.KeybindingsInitializer=S,e.KeybindingsInitializer=S=Ce([K(0,E.IFileService),K(1,p.IUserDataProfilesService),K(2,C.IEnvironmentService),K(3,h.IUserDataSyncLogService),K(4,v.IStorageService),K(5,c.IUriIdentityService)],S)}),define(ae[118],ce([0,1,15,3,177,21,76,16,29,12,19,22,28,18,39,246,25]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=void 0,e.parseSettingsSyncContent=h;function u(S){return S&&S.settings&&typeof S.settings=="string"&&Object.keys(S).length===1}function h(S){const t=JSON.parse(S);return u(t)?t:{settings:S}}let m=class extends c.AbstractJsonFileSynchroniser{constructor(t,r,n,s,i,o,a,y,I,w,b,D,L,N){super(t.settingsResource,{syncResource:"settings",profile:t},r,n,s,i,o,a,b,D,y,I,w,N),this.extensionManagementService=L,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(t){const r=await this.getLastSyncUserData(),n=await this.getLatestRemoteUserData(t,r),s=this.getSettingsSyncContent(n),i=new k.ConfigurationModelParser(g.USER_DATA_SYNC_CONFIGURATION_SCOPE,this.logService);return s?.settings&&i.parse(s.settings),i.configurationModel.getValue(g.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(t,r,n){const s=await this.getLocalFileContent(),i=await this.getFormattingOptions(),o=this.getSettingsSyncContent(t);r=r===null&&n?t:r;const a=r?this.getSettingsSyncContent(r):null,y=await this.getIgnoredSettings();let I=null,w=!1,b=!1,D=!1;if(o){let x=s?s.value.toString().trim():"{}";x=x||"{}",this.validateContent(x),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const X=(0,p.merge)(x,o.settings,a?a.settings:null,y,[],i);I=X.localContent||X.remoteContent,w=X.localContent!==null,b=X.remoteContent!==null,D=X.hasConflicts}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),I=s.value.toString().trim()||"{}",this.validateContent(I),b=!0);const L=s?s.value.toString():null,N=a?.settings??null,F={content:D?N:I,localChange:w?2:0,remoteChange:b?2:0,hasConflicts:D};return[{fileContent:s,baseResource:this.baseResource,baseContent:N,localResource:this.localResource,localContent:L,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(t){const r=this.getSettingsSyncContent(t);if(r===null)return!0;const n=await this.getLocalFileContent(),s=n?n.value.toString().trim():"",i=await this.getIgnoredSettings(),o=await this.getFormattingOptions();return(0,p.merge)(s||"{}",r.settings,r.settings,i,[],o).remoteContent!==null}async getMergeResult(t,r){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,p.updateIgnoredSettings)(t.previewResult.content,"{}",s,n):null}}async getAcceptResult(t,r,n,s){const i=await this.getFormattingOptions(),o=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?(0,p.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",o,i):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,p.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",o,i):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,p.updateIgnoredSettings)(n,t.fileContent?t.fileContent.value.toString():"{}",o,i):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,n,s){const{fileContent:i}=n[0][0];let{content:o,localChange:a,remoteChange:y}=n[0][1];if(a===0&&y===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.validateContent(o),a!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),i&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(i.value.toString()))),await this.updateLocalFileContent(o,i,s),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),y!==0){const I=await this.getFormattingOptions(),w=this.getSettingsSyncContent(t),b=await this.getIgnoredSettings(o);o=(0,p.updateIgnoredSettings)(o,w?w.settings:"{}",b,I),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(o)),s?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t)return!(0,p.isEmpty)(t.value.toString())}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async resolveContent(t){return this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t)||this.extUri.isEqual(this.baseResource,t)?this.resolvePreviewContent(t):null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const n=await this.getFormattingOptions(),s=await this.getIgnoredSettings();r=(0,p.updateIgnoredSettings)(r,"{}",s,n)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return h(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=this._register(U.Event.any(U.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:i})=>!!i)),U.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0}))}const r=await this._defaultIgnoredSettings;return(0,p.getIgnoredSettings)(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t,!1))throw new g.UserDataSyncError((0,A.localize)(0,null),"LocalInvalidContent",this.resource)}};e.SettingsSynchroniser=m,e.SettingsSynchroniser=m=Ce([K(2,d.IFileService),K(3,R.IEnvironmentService),K(4,C.IStorageService),K(5,g.IUserDataSyncStoreService),K(6,g.IUserDataSyncLocalStoreService),K(7,g.IUserDataSyncLogService),K(8,g.IUserDataSyncUtilService),K(9,O.IConfigurationService),K(10,g.IUserDataSyncEnablementService),K(11,E.ITelemetryService),K(12,P.IExtensionManagementService),K(13,v.IUriIdentityService)],m);let f=class extends c.AbstractInitializer{constructor(t,r,n,s,i,o){super("settings",r,n,s,t,i,o)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,_.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,p.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return h(t)}catch(r){this.logService.error(r)}return null}};e.SettingsInitializer=f,e.SettingsInitializer=f=Ce([K(0,d.IFileService),K(1,l.IUserDataProfilesService),K(2,R.IEnvironmentService),K(3,g.IUserDataSyncLogService),K(4,C.IStorageService),K(5,v.IUriIdentityService)],f)}),define(ae[119],ce([0,1,15,3,30,21,16,12,19,22,28,18,39,243,25]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0,e.parseSnippets=p;function p(h){return JSON.parse(h.content)}let g=class extends v.AbstractSynchroniser{constructor(m,f,S,t,r,n,s,i,o,a,y,I){super({syncResource:"snippets",profile:m},f,t,S,r,n,s,a,y,i,o,I),this.version=1,this.snippetsFolder=m.snippetsHome,this._register(this.fileService.watch(S.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(U.Event.filter(this.fileService.onDidFilesChange,w=>w.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,f,S){const t=await this.getSnippetsFileContents(),r=this.toSnippetsContents(t),n=m.syncData?this.parseSnippets(m.syncData):null;f=f===null&&S?m:f;const s=f&&f.syncData?this.parseSnippets(f.syncData):null;n?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,l.merge)(r,n,s);return this.getResourcePreviews(i,t,n||{},s||{})}async hasRemoteChanged(m){const f=m.syncData?this.parseSnippets(m.syncData):null;if(f===null)return!0;const S=await this.getSnippetsFileContents(),t=this.toSnippetsContents(S),r=(0,l.merge)(t,f,f);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async getMergeResult(m,f){return m.previewResult}async getAcceptResult(m,f,S,t){if(this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(f,this.syncPreviewFolder.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(f,this.syncPreviewFolder))return S===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:S,localChange:S===null?m.fileContent!==null?3:0:2,remoteChange:S===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${f.toString()}`)}async applyResult(m,f,S,t){const r=S.map(([n,s])=>({...n,acceptResult:s}));r.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),r.some(({localChange:n})=>n!==0)&&(await this.updateLocalBackup(r),await this.updateLocalSnippets(r,t)),r.some(({remoteChange:n})=>n!==0)&&(m=await this.updateRemoteSnippets(r,m,t)),f?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:n}of r)try{await this.fileService.del(n)}catch{}}getResourcePreviews(m,f,S,t){const r=new Map;for(const n of Object.keys(m.local.added)){const s={content:m.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:S[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(m.local.updated)){const s={content:m.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},i=f[n]?f[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:f[n],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:S[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of m.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=f[n]?f[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:f[n],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(m.remote.added)){const s={content:m.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},i=f[n]?f[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:f[n],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(m.remote.updated)){const s={content:m.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},i=f[n]?f[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:f[n],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:S[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of m.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:S[n],previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of m.conflicts){const s={content:t[n]??null,hasConflicts:!0,localChange:f[n]?2:1,remoteChange:S[n]?2:1},i=f[n]?f[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:f[n]||null,localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:S[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const n of Object.keys(f))if(!r.has(n)){const s={content:f[n]?f[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=f[n]?f[n].value.toString():null;r.set(n,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:t[n]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:f[n]||null,localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:S[n]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...r.values()]}async resolveContent(m){return this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.resolvePreviewContent(m):null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch{}return!1}async updateLocalBackup(m){const f={};for(const S of m)S.fileContent&&(f[this.extUri.basename(S.localResource)]=S.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(f)))}async updateLocalSnippets(m,f){for(const{fileContent:S,acceptResult:t,localResource:r,remoteResource:n,localChange:s}of m)if(s!==0){const i=n?this.extUri.basename(n):this.extUri.basename(r),o=this.extUri.joinPath(this.snippetsFolder,i);s===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(o)),await this.fileService.del(o),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(o))):s===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(o)),await this.fileService.createFile(o,_.VSBuffer.fromString(t.content),{overwrite:f}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(o))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(o)),await this.fileService.writeFile(o,_.VSBuffer.fromString(t.content),f?void 0:S),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(o)))}}async updateRemoteSnippets(m,f,S){const t=f.syncData?this.parseSnippets(f.syncData):{},r=(0,A.deepClone)(t);for(const{acceptResult:n,localResource:s,remoteResource:i,remoteChange:o}of m)if(o!==0){const a=s?this.extUri.basename(s):this.extUri.basename(i);o===3?delete r[a]:r[a]=n.content}return(0,l.areSame)(t,r)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),f=await this.updateRemoteUserData(JSON.stringify(r),S?null:f.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),f}parseSnippets(m){return p(m)}toSnippetsContents(m){const f={};for(const S of Object.keys(m))f[S]=m[S].value.toString();return f}async getSnippetsFileContents(){const m={};let f;try{f=await this.fileService.resolve(this.snippetsFolder)}catch(S){if(S instanceof R.FileOperationError&&S.fileOperationResult===1)return m;throw S}for(const S of f.children||[]){const t=S.resource,r=this.extUri.extname(t);if(r===".json"||r===".code-snippets"){const n=this.extUri.relativePath(this.snippetsFolder,t),s=await this.fileService.readFile(t);m[n]=s}}return m}};e.SnippetsSynchroniser=g,e.SnippetsSynchroniser=g=Ce([K(2,k.IEnvironmentService),K(3,R.IFileService),K(4,P.IStorageService),K(5,c.IUserDataSyncStoreService),K(6,c.IUserDataSyncLocalStoreService),K(7,c.IUserDataSyncLogService),K(8,O.IConfigurationService),K(9,c.IUserDataSyncEnablementService),K(10,d.ITelemetryService),K(11,C.IUriIdentityService)],g);let u=class extends v.AbstractInitializer{constructor(m,f,S,t,r,n){super("snippets",f,S,t,m,r,n)}async doInitialize(m){const f=m.syncData?JSON.parse(m.syncData.content):null;if(!f){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(f)){const r=f[t];if(r){const n=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,t);await this.fileService.createFile(n,_.VSBuffer.fromString(r)),this.logService.info("Created snippet",this.extUri.basename(n))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};e.SnippetsInitializer=u,e.SnippetsInitializer=u=Ce([K(0,R.IFileService),K(1,E.IUserDataProfilesService),K(2,k.IEnvironmentService),K(3,c.IUserDataSyncLogService),K(4,P.IStorageService),K(5,C.IUriIdentityService)],u)}),define(ae[120],ce([0,1,15,21,16,12,19,22,28,18,39,25]),function(ne,e,_,U,A,O,k,R,P,d,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=void 0,e.getTasksContentFromSyncContent=v;function v(g,u){try{return JSON.parse(g).tasks??null}catch(h){return u.error(h),null}}let l=class extends C.AbstractFileSynchroniser{constructor(u,h,m,f,S,t,r,n,s,i,o,a){super(u.tasksResource,{syncResource:"tasks",profile:u},h,n,s,i,m,f,r,o,S,t,a),this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:E.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(u,h,m,f){const S=u.syncData?v(u.syncData.content,this.logService):null;h=h===null&&m?u:h;const t=h?.syncData?v(h.syncData.content,this.logService):null,r=await this.getLocalFileContent();let n=null,s=!1,i=!1,o=!1;if(u.syncData){const I=r?r.value.toString():null;if(!t||t!==I||t!==S){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const w=p(I,S,t);n=w.content,o=w.hasConflicts,s=w.hasLocalChanged,i=w.hasRemoteChanged}}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=r.value.toString(),i=!0);const a={content:o?t:n,localChange:s?r?2:1:0,remoteChange:i?2:0,hasConflicts:o},y=r?r.value.toString():null;return[{fileContent:r,baseResource:this.baseResource,baseContent:t,localResource:this.localResource,localContent:y,localChange:a.localChange,remoteResource:this.remoteResource,remoteContent:S,remoteChange:a.remoteChange,previewResource:this.previewResource,previewResult:a,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const h=u?.syncData?v(u.syncData.content,this.logService):null;if(h===null)return!0;const m=await this.getLocalFileContent(),f=m?m.value.toString():null,S=p(f,h,h);return S.hasLocalChanged||S.hasRemoteChanged}async getMergeResult(u,h){return u.previewResult}async getAcceptResult(u,h,m,f){if(this.extUri.isEqual(h,this.localResource))return{content:u.fileContent?u.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(h,this.remoteResource))return{content:u.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(h,this.previewResource))return m===void 0?{content:u.previewResult.content,localChange:u.previewResult.localChange,remoteChange:u.previewResult.remoteChange}:{content:m,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${h.toString()}`)}async applyResult(u,h,m,f){const{fileContent:S}=m[0][0],{content:t,localChange:r,remoteChange:n}=m[0][1];if(r===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),r!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),S&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(S.value.toString()))),t?await this.updateLocalFileContent(t,S,f):await this.deleteLocalFile(),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),n!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const s=JSON.stringify(this.toTasksSyncContent(t));u=await this.updateRemoteUserData(s,f?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}h?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async resolveContent(u){return this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)?this.resolvePreviewContent(u):null}toTasksSyncContent(u){return u?{tasks:u}:{}}};e.TasksSynchroniser=l,e.TasksSynchroniser=l=Ce([K(2,E.IUserDataSyncStoreService),K(3,E.IUserDataSyncLocalStoreService),K(4,E.IUserDataSyncLogService),K(5,U.IConfigurationService),K(6,E.IUserDataSyncEnablementService),K(7,O.IFileService),K(8,A.IEnvironmentService),K(9,k.IStorageService),K(10,R.ITelemetryService),K(11,P.IUriIdentityService)],l);let c=class extends C.AbstractInitializer{constructor(u,h,m,f,S,t){super("tasks",h,m,f,u,S,t),this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(u){const h=u.syncData?v(u.syncData.content,this.logService):null;if(!h){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,_.VSBuffer.fromString(h)),await this.updateLastSyncUserData(u)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};e.TasksInitializer=c,e.TasksInitializer=c=Ce([K(0,O.IFileService),K(1,d.IUserDataProfilesService),K(2,A.IEnvironmentService),K(3,E.IUserDataSyncLogService),K(4,k.IStorageService),K(5,P.IUriIdentityService)],c);function p(g,u,h){if(g===null&&u===null&&h===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(g===u)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const m=h!==g,f=h!==u;return!m&&!f?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:m&&!f?{content:g,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:f&&!m?{content:u,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:g,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ae[121],ce([0,1,44,21,16,12,19,22,28,18,39,244,25]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesManifestSynchroniser=void 0,e.stringifyLocalProfiles=c,e.parseUserDataProfilesManifest=p;let l=class extends C.AbstractSynchroniser{constructor(u,h,m,f,S,t,r,n,s,i,o,a,y){super({syncResource:"profiles",profile:u},h,f,S,t,r,n,o,a,s,i,y),this.userDataProfilesService=m,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"profiles.json"),this.baseResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(m.onDidChangeProfiles(()=>this.triggerLocalChange()))}async getLastSyncedProfiles(){const u=await this.getLastSyncUserData();return u?.syncData?p(u.syncData):null}async getRemoteSyncedProfiles(u){const h=await this.getLastSyncUserData(),m=await this.getLatestRemoteUserData(u,h);return m?.syncData?p(m.syncData):null}async generateSyncPreview(u,h,m){if(!this.userDataProfilesService.isEnabled())throw new v.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const f=u.syncData?p(u.syncData):null,S=h?.syncData?p(h.syncData):null,t=this.getLocalUserDataProfiles(),{local:r,remote:n}=(0,E.merge)(t,f,S,[]),s={local:r,remote:n,content:S?this.stringifyRemoteProfiles(S):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:n!==null?2:0},i=c(t,!1);return[{baseResource:this.baseResource,baseContent:S?this.stringifyRemoteProfiles(S):null,localResource:this.localResource,localContent:i,remoteResource:this.remoteResource,remoteContent:f?this.stringifyRemoteProfiles(f):null,remoteProfiles:f,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(u){const h=u?.syncData?p(u.syncData):null,m=this.getLocalUserDataProfiles(),{remote:f}=(0,E.merge)(m,h,h,[]);return!!f?.added.length||!!f?.removed.length||!!f?.updated.length}async getMergeResult(u,h){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,h,m,f){if(this.extUri.isEqual(h,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(h,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(h,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${h.toString()}`)}async acceptLocal(u){const h=this.getLocalUserDataProfiles(),m=(0,E.merge)(h,null,null,[]),{local:f,remote:S}=m;return{content:u.localContent,local:f,remote:S,localChange:f.added.length>0||f.removed.length>0||f.updated.length>0?2:0,remoteChange:S!==null?2:0}}async acceptRemote(u){const h=u.remoteContent?JSON.parse(u.remoteContent):null,m=[],f=[];for(const S of this.getLocalUserDataProfiles()){const t=h?.find(r=>r.id===S.id);t&&(m.push({id:S.id,name:S.name,collection:t.collection}),f.push(S))}if(h!==null){const S=(0,E.merge)(f,h,m,[]),{local:t,remote:r}=S;return{content:u.remoteContent,local:t,remote:r,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,h,m,f){const{local:S,remote:t,localChange:r,remoteChange:n}=m[0][1];r===0&&n===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing profiles.`);const s=m[0][0].remoteProfiles||[];if(s.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new v.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(r!==0&&(await this.backupLocal(c(this.getLocalUserDataProfiles(),!1)),await Promise.all(S.removed.map(async i=>{this.logService.trace(`${this.syncResourceLogLabel}: Removing '${i.name}' profile...`),await this.userDataProfilesService.removeProfile(i),this.logService.info(`${this.syncResourceLogLabel}: Removed profile '${i.name}'.`)})),await Promise.all(S.added.map(async i=>{this.logService.trace(`${this.syncResourceLogLabel}: Creating '${i.name}' profile...`),await this.userDataProfilesService.createProfile(i.id,i.name,{shortName:i.shortName,icon:i.icon,useDefaultFlags:i.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Created profile '${i.name}'.`)})),await Promise.all(S.updated.map(async i=>{const o=this.userDataProfilesService.profiles.find(a=>a.id===i.id);o?(this.logService.trace(`${this.syncResourceLogLabel}: Updating '${i.name}' profile...`),await this.userDataProfilesService.updateProfile(o,{name:i.name,shortName:i.shortName,icon:i.icon,useDefaultFlags:i.useDefaultFlags}),this.logService.info(`${this.syncResourceLogLabel}: Updated profile '${i.name}'.`)):this.logService.info(`${this.syncResourceLogLabel}: Could not find profile with id '${i.id}' to update.`)}))),n!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote profiles...`);const i=[],o=s.length+(t?.added.length??0)<=20;if(o)for(const a of t?.added||[]){const y=await this.userDataSyncStoreService.createCollection(this.syncHeaders);i.push(y),s.push({id:a.id,name:a.name,collection:y,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.logService.info(`${this.syncResourceLogLabel}: Could not create remote profiles as there are too many profiles.`);for(const a of t?.removed||[])s.splice(s.findIndex(({id:y})=>a.id===y),1);for(const a of t?.updated||[]){const y=s.find(({id:I})=>a.id===I);y&&s.splice(s.indexOf(y),1,{...y,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{u=await this.updateRemoteProfiles(s,f?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote profiles.${o&&t?.added.length?` Added: ${JSON.stringify(t.added.map(a=>a.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(a=>a.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(a=>a.name))}.`:""}`)}catch(a){if(i.length){this.logService.info(`${this.syncResourceLogLabel}: Failed to update remote profiles. Cleaning up added collections...`);for(const y of i)await this.userDataSyncStoreService.deleteCollection(y,this.syncHeaders)}throw a}for(const a of t?.removed||[])await this.userDataSyncStoreService.deleteCollection(a.collection,this.syncHeaders)}h?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized profiles...`),await this.updateLastSyncUserData(u),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized profiles.`))}async updateRemoteProfiles(u,h){return this.updateRemoteUserData(this.stringifyRemoteProfiles(u),h)}async hasLocalData(){return this.getLocalUserDataProfiles().length>0}async resolveContent(u){if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.baseResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u)){const h=await this.resolvePreviewContent(u);return h&&(0,_.toFormattedString)(JSON.parse(h),{})}return null}getLocalUserDataProfiles(){return this.userDataProfilesService.profiles.filter(u=>!u.isDefault&&!u.isTransient)}stringifyRemoteProfiles(u){return JSON.stringify([...u].sort((h,m)=>h.name.localeCompare(m.name)))}};e.UserDataProfilesManifestSynchroniser=l,e.UserDataProfilesManifestSynchroniser=l=Ce([K(2,d.IUserDataProfilesService),K(3,O.IFileService),K(4,A.IEnvironmentService),K(5,k.IStorageService),K(6,v.IUserDataSyncStoreService),K(7,v.IUserDataSyncLocalStoreService),K(8,v.IUserDataSyncLogService),K(9,U.IConfigurationService),K(10,v.IUserDataSyncEnablementService),K(11,R.ITelemetryService),K(12,P.IUriIdentityService)],l);function c(g,u){const h=[...g].sort((m,f)=>m.name.localeCompare(f.name)).map(m=>({id:m.id,name:m.name}));return u?(0,_.toFormattedString)(h,{}):JSON.stringify(h)}function p(g){return JSON.parse(g.content)}}),define(ae[261],ce([0,1,3,2,5,16,19,22,25]),function(ne,e,_,U,A,O,k,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const d="sync.enable";let C=class extends U.Disposable{constructor(v,l,c,p){super(),this.storageService=v,this.telemetryService=l,this.environmentService=c,this.userDataSyncStoreManagementService=p,this._onDidChangeEnablement=new _.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new _.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(v.onDidChangeValue(-1,void 0,this._register(new U.DisposableStore))(g=>this.onDidStorageChange(g)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(d,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(v){v&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(d,{enabled:v}),this.storageService.store(d,v,-1,1))}isResourceEnabled(v){return this.storageService.getBoolean((0,P.getEnablementKey)(v),-1,!0)}setResourceEnablement(v,l){if(this.isResourceEnabled(v)!==l){const c=(0,P.getEnablementKey)(v);this.storeResourceEnablement(c,l)}}getResourceSyncStateVersion(v){}storeResourceEnablement(v,l){this.storageService.store(v,l,-1,A.isWeb?0:1)}onDidStorageChange(v){if(d===v.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const l=P.ALL_SYNC_RESOURCES.filter(c=>(0,P.getEnablementKey)(c)===v.key)[0];if(l){this._onDidChangeResourceEnablement.fire([l,this.isResourceEnabled(l)]);return}}};e.UserDataSyncEnablementService=C,e.UserDataSyncEnablementService=C=Ce([K(0,k.IStorageService),K(1,R.ITelemetryService),K(2,O.IEnvironmentService),K(3,P.IUserDataSyncStoreManagementService)],C)}),define(ae[262],ce([0,1,6,15,65,2,20,21,16,12,18,25]),function(ne,e,_,U,A,O,k,R,P,d,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLocalStoreService=void 0;let v=class extends O.Disposable{constructor(c,p,g,u,h){super(),this.environmentService=c,this.fileService=p,this.configurationService=g,this.logService=u,this.userDataProfilesService=h,this.cleanUp()}async cleanUp(){for(const p of this.userDataProfilesService.profiles)for(const g of E.ALL_SYNC_RESOURCES)try{await this.cleanUpBackup(this.getResourceBackupHome(g,p.isDefault?void 0:p.id))}catch(u){this.logService.error(u)}let c;try{c=await this.fileService.resolve(this.environmentService.userDataSyncHome)}catch(p){(0,d.toFileOperationResult)(p)!==1&&this.logService.error(p);return}if(c.children){for(const p of c.children)if(p.isDirectory&&!this.userDataProfilesService.profiles.some(g=>g.id===p.name))try{this.logService.info("Deleting non existing profile from backup",p.resource.path),await this.fileService.del(p.resource,{recursive:!0})}catch(g){this.logService.error(g)}}}async getAllResourceRefs(c,p,g){const u=this.getResourceBackupHome(c,p,g);try{const h=await this.fileService.resolve(u);if(h.children)return h.children.filter(f=>f.isFile&&!f.name.startsWith("lastSync")).sort().reverse().map(f=>({ref:f.name,created:this.getCreationTime(f)}))}catch(h){if((0,d.toFileOperationResult)(h)!==1)throw h}return[]}async resolveResourceContent(c,p,g,u){const h=this.getResourceBackupHome(c,g,u),m=(0,k.joinPath)(h,p);try{return(await this.fileService.readFile(m)).value.toString()}catch(f){return this.logService.error(f),null}}async writeResource(c,p,g,u,h){const m=this.getResourceBackupHome(c,u,h),f=(0,k.joinPath)(m,`${(0,A.toLocalISOString)(g).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(f,U.VSBuffer.fromString(p))}catch(S){this.logService.error(S)}}getResourceBackupHome(c,p,g=this.environmentService.userDataSyncHome){return(0,k.joinPath)(g,...p?[p,c]:[c])}async cleanUpBackup(c){try{try{if(!await this.fileService.exists(c))return}catch{return}const p=await this.fileService.resolve(c);if(p.children){const g=p.children.filter(f=>f.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(f.name)).sort(),u=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let h=g.filter(f=>Date.now()-this.getCreationTime(f)>u);const m=g.length-h.length;m<10&&(h=h.slice(10-m)),await _.Promises.settled(h.map(async f=>{this.logService.info("Deleting from backup",f.resource.path),await this.fileService.del(f.resource)}))}}catch(p){this.logService.error(p)}}getCreationTime(c){return new Date(parseInt(c.name.substring(0,4)),parseInt(c.name.substring(4,6))-1,parseInt(c.name.substring(6,8)),parseInt(c.name.substring(9,11)),parseInt(c.name.substring(11,13)),parseInt(c.name.substring(13,15))).getTime()}};e.UserDataSyncLocalStoreService=v,e.UserDataSyncLocalStoreService=v=Ce([K(0,P.IEnvironmentService),K(1,d.IFileService),K(2,R.IConfigurationService),K(3,E.IUserDataSyncLogService),K(4,C.IUserDataProfilesService)],v)}),define(ae[83],ce([0,1,3,2,5,27,181,16,12,4,24,45,19,25]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.isWebPlatform=S,e.IUserDataSyncMachinesService=(0,d.createDecorator)("IUserDataSyncMachinesService");const p="sync.currentMachineName",g="Safari",u="Chrome",h="Edge",m="Firefox",f="Android";function S(n){switch(n){case g:case u:case h:case m:case f:case(0,A.PlatformToString)(0):return!0}return!1}function t(){return A.isSafari?g:A.isChrome?u:A.isEdge?h:A.isFirefox?m:A.isAndroid?f:(0,A.PlatformToString)(A.isWeb?0:A.platform)}let r=class extends U.Disposable{static{c=this}static{this.VERSION=1}static{this.RESOURCE="machines"}constructor(s,i,o,a,y,I){super(),this.storageService=o,this.userDataSyncStoreService=a,this.logService=y,this.productService=I,this._onDidChange=this._register(new _.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,E.getServiceMachineId)(s,i,o)}async getMachines(s){const i=await this.currentMachineIdPromise;return(await this.readMachinesData(s)).machines.map(a=>({...a,isCurrent:a.id===i}))}async addCurrentMachine(s){const i=await this.currentMachineIdPromise,o=await this.readMachinesData(s);o.machines.some(({id:a})=>a===i)||(o.machines.push({id:i,name:this.computeCurrentMachineName(o.machines),platform:t()}),await this.writeMachinesData(o))}async removeCurrentMachine(s){const i=await this.currentMachineIdPromise,o=await this.readMachinesData(s),a=o.machines.filter(({id:y})=>y!==i);a.length!==o.machines.length&&(o.machines=a,await this.writeMachinesData(o))}async renameMachine(s,i,o){const a=await this.readMachinesData(o),y=a.machines.find(({id:I})=>I===s);if(y){y.name=i,await this.writeMachinesData(a);const I=await this.currentMachineIdPromise;s===I&&this.storageService.store(p,i,-1,1)}}async setEnablements(s){const i=await this.readMachinesData();for(const[o,a]of s){const y=i.machines.find(I=>I.id===o);y&&(y.disabled=a?void 0:!0)}await this.writeMachinesData(i)}computeCurrentMachineName(s){const i=this.storageService.get(p,-1);if(i)return i;const o=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${t()} (${this.productService.nameShort})`,a=new RegExp(`${(0,O.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let y=0;for(const I of s){const w=a.exec(I.name),b=w?parseInt(w[1]):0;y=b>y?b:y}return`${o} #${y+1}`}async readMachinesData(s){this.userData=await this.readUserData(s);const i=this.parse(this.userData);if(i.version!==c.VERSION)throw new Error((0,k.localize)(0,null,this.productService.nameLong));return i}async writeMachinesData(s){const i=JSON.stringify(s),o=await this.userDataSyncStoreService.writeResource(c.RESOURCE,i,this.userData?.ref||null);this.userData={ref:o,content:i},this._onDidChange.fire()}async readUserData(s){if(this.userData){const i=s&&s.latest?s.latest[c.RESOURCE]:void 0;if(this.userData.ref===i)return this.userData;if(i===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.readResource(c.RESOURCE,this.userData)}parse(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(i){this.logService.error(i)}return{version:c.VERSION,machines:[]}}};e.UserDataSyncMachinesService=r,e.UserDataSyncMachinesService=r=c=Ce([K(0,R.IEnvironmentService),K(1,P.IFileService),K(2,v.IStorageService),K(3,l.IUserDataSyncStoreService),K(4,l.IUserDataSyncLogService),K(5,C.IProductService)],r)}),define(ae[263],ce([0,1,6,65,38,7,3,2,5,20,8,178,24,19,22,25,80,83]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const h="sync.disableMachineEventually",m="sync.sessionId",f="sync.storeUrl",S="sync.productQuality";let t=class extends R.Disposable{get syncUrl(){const s=this.storageService.get(f,-1);return s?C.URI.parse(s):void 0}set syncUrl(s){s?this.storageService.store(f,s.toString(),-1,1):this.storageService.remove(f,-1)}get productQuality(){return this.storageService.get(S,-1)}set productQuality(s){s?this.storageService.store(S,s,-1,1):this.storageService.remove(S,-1)}constructor(s,i,o,a,y,I,w,b,D,L){super(),this.userDataSyncStoreManagementService=i,this.userDataSyncStoreService=o,this.userDataSyncEnablementService=a,this.userDataSyncService=y,this.logService=I,this.userDataSyncAccountService=w,this.telemetryService=b,this.userDataSyncMachinesService=D,this.storageService=L,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new _.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=i.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=s.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(i.onDidChangeUserDataSyncStore(()=>{(0,d.isEqual)(this.syncUrl,i.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=i.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(w.onDidChangeAccount(()=>this.updateAutoSync())),this._register(o.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(y.onDidChangeLocal(N=>this.triggerSync([N],!1,!1))),this._register(k.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,N])=>N)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}updateAutoSync(){const{enabled:s,message:i}=this.isAutoSyncEnabled();s?this.autoSync.value===void 0&&(this.autoSync.value=new r(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.telemetryService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(o=>this.onDidFinishSync(o))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(i&&this.logService.info(i),this.autoSync.clear()):i&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(i))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,U.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(s,i,o){try{this.userDataSyncAccountService.account&&!o&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(m,-1),s?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(this.logService.error(a),i)this.updateEnablement(!1);else throw a}}updateEnablement(s){this.userDataSyncEnablementService.isEnabled()!==s&&(this.userDataSyncEnablementService.setEnablement(s),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(s){if(!s){this.successiveFailures=0;return}const i=p.UserDataSyncError.toUserDataSyncError(s);i instanceof p.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:i.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),i.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):i.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):i.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):i.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):i.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):i.code==="UpgradeRequired"||i.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):i.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${i.resource} content with newer version than of client. Requires client upgrade.`)):i.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${i.resource} content with older version than of client. Requires server reset.`)):i.code==="ServiceChanged"||i.code==="DefaultServiceChanged"?P.isWeb&&i.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(i),this.successiveFailures++),this._onError.fire(i)}async disableMachineEventually(){this.storageService.store(h,!0,-1,1),await(0,_.timeout)(1e3*60*10),this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(h,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(h,-1)}async triggerSync(s,i,o){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(i&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...s),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources);const a=this.userDataSyncAccountService.account?.authenticationProviderId||"";this.telemetryService.publicLog2("sync/triggered",{sources:this.sources,providerId:a}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",o)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};e.UserDataAutoSyncService=t,e.UserDataAutoSyncService=t=Ce([K(0,v.IProductService),K(1,p.IUserDataSyncStoreManagementService),K(2,p.IUserDataSyncStoreService),K(3,p.IUserDataSyncEnablementService),K(4,p.IUserDataSyncService),K(5,p.IUserDataSyncLogService),K(6,g.IUserDataSyncAccountService),K(7,c.ITelemetryService),K(8,u.IUserDataSyncMachinesService),K(9,l.IStorageService)],t);class r extends R.Disposable{static{this.INTERVAL_SYNCING="Interval"}constructor(s,i,o,a,y,I,w,b,D){super(),this.lastSyncUrl=s,this.interval=i,this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=a,this.userDataSyncService=y,this.userDataSyncMachinesService=I,this.logService=w,this.telemetryService=b,this.storageService=D,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.sync(r.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,_.disposableTimeout)(()=>{this.sync(r.INTERVAL_SYNCING,!1),this.intervalHandler.value=void 0},this.interval)}sync(s,i){const o=(0,_.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(y){if((0,O.isCancellationError)(y))return}return this.doSync(s,i,a)});return this.syncPromise=o,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,d.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const s=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),i=this.userDataSyncStoreManagementService.userDataSyncStore;return!!i&&!!s&&(!(0,d.isEqual)(i.defaultUrl,s.defaultUrl)||!(0,d.isEqual)(i.insidersUrl,s.insidersUrl)||!(0,d.isEqual)(i.stableUrl,s.stableUrl))}async doSync(s,i,o){this.logService.info(`Auto Sync: Triggered by ${s}`),this._onDidStartSync.fire();let a;try{await this.createAndRunSyncTask(i,o)}catch(y){if(this.logService.error(y),a=y,p.UserDataSyncError.toUserDataSyncError(y).code==="MethodNotFound")try{this.logService.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.userDataSyncService.cleanUpRemoteData(),this.logService.info("Auto Sync: Retrying sync..."),await this.createAndRunSyncTask(i,o),a=void 0}catch(I){this.logService.error(I),a=I}}this._onDidFinishSync.fire(a)}async createAndRunSyncTask(s,i){if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),i.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new p.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const o=this.storageService.get(m,-1);if(o&&this.manifest&&o!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new p.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new p.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new p.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const a=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(i.isCancellationRequested)return;const y=a.find(w=>w.isCurrent);if(y?.disabled)throw new p.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");const I=new Date().getTime();if(await this.syncTask.run(),this.telemetryService.publicLog2("settingsSync:sync",{duration:new Date().getTime()-I}),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(w){throw new p.UserDataAutoSyncError((0,A.toErrorMessage)(w),w instanceof p.UserDataSyncError?w.code:"Unknown")}this.manifest&&this.manifest.session!==o&&this.storageService.store(m,this.manifest.session,-1,1),!i.isCancellationRequested&&(y||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0))}register(s){return super._register(s)}}}),define(ae[264],ce([0,1,8,182,16,12,45,19,28,25,18,39,119,118,117,21,120,115,116,4,121,44,27]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g,u,h,m,f,S,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=class{static{r=this}static{this.NOT_EXISTING_RESOURCE="not-existing-resource"}static{this.REMOTE_BACKUP_AUTHORITY="remote-backup"}static{this.LOCAL_BACKUP_AUTHORITY="local-backup"}constructor(i,o,a,y,I,w,b,D,L,N){this.userDataSyncStoreService=i,this.userDataSyncLocalStoreService=o,this.logService=a,this.environmentService=I,this.storageService=w,this.fileService=b,this.userDataProfilesService=D,this.configurationService=L,this.instantiationService=N,this.extUri=y.extUri}async getRemoteSyncedProfiles(){const i=await this.userDataSyncStoreService.readResource("profiles",null,void 0);if(i.content){const o=this.parseSyncData(i.content,"profiles");return(0,f.parseUserDataProfilesManifest)(o)}return[]}async getLocalSyncedProfiles(i){const o=await this.userDataSyncLocalStoreService.getAllResourceRefs("profiles",void 0,i);if(o.length){const a=await this.userDataSyncLocalStoreService.resolveResourceContent("profiles",o[0].ref,void 0,i);if(a){const y=this.parseSyncData(a,"profiles");return(0,f.parseUserDataProfilesManifest)(y)}}return[]}async getLocalSyncedMachines(i){const o=await this.userDataSyncLocalStoreService.getAllResourceRefs("machines",void 0,i);if(o.length){const a=await this.userDataSyncLocalStoreService.resolveResourceContent("machines",o[0].ref,void 0,i);if(a)return JSON.parse(a).machines.map(I=>({...I,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(i,o){return(await this.userDataSyncStoreService.getAllResourceRefs(i,o?.collection)).map(({created:y,ref:I})=>({created:y,uri:this.toUri({remote:!0,syncResource:i,profile:o?.id??this.userDataProfilesService.defaultProfile.id,location:void 0,collection:o?.collection,ref:I,node:void 0})}))}async getLocalSyncResourceHandles(i,o,a){return(await this.userDataSyncLocalStoreService.getAllResourceRefs(i,o?.collection,a)).map(({created:I,ref:w})=>({created:I,uri:this.toUri({remote:!1,syncResource:i,profile:o?.id??this.userDataProfilesService.defaultProfile.id,collection:o?.collection,ref:w,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:i}){const o=this.resolveUri(i),a=o?this.userDataProfilesService.profiles.find(y=>y.id===o.profile):void 0;return o&&a?{profile:a,syncResource:o?.syncResource}:void 0}async getAssociatedResources({uri:i}){const o=this.resolveUri(i);if(!o)return[];const a=this.userDataProfilesService.profiles.find(y=>y.id===o.profile);switch(o.syncResource){case"settings":return this.getSettingsAssociatedResources(i,a);case"keybindings":return this.getKeybindingsAssociatedResources(i,a);case"tasks":return this.getTasksAssociatedResources(i,a);case"snippets":return this.getSnippetsAssociatedResources(i,a);case"globalState":return this.getGlobalStateAssociatedResources(i,a);case"extensions":return this.getExtensionsAssociatedResources(i,a);case"profiles":return this.getProfilesAssociatedResources(i,a);case"workspaceState":return[]}}async getMachineId({uri:i}){const o=this.resolveUri(i);if(o){if(o.remote){if(o.ref){const{content:a}=await this.getUserData(o.syncResource,o.ref,o.collection);if(a)return this.parseSyncData(a,o.syncResource)?.machineId}return}if(o.location){if(o.ref){const a=await this.userDataSyncLocalStoreService.resolveResourceContent(o.syncResource,o.ref,o.collection,o.location);if(a)return this.parseSyncData(a,o.syncResource)?.machineId}return}return(0,k.getServiceMachineId)(this.environmentService,this.fileService,this.storageService)}}async resolveContent(i){const o=this.resolveUri(i);if(!o||o.node===r.NOT_EXISTING_RESOURCE)return null;if(o.ref){const a=await this.getContentFromStore(o.remote,o.syncResource,o.collection,o.ref,o.location);return o.node&&a?this.resolveNodeContent(o.syncResource,a,o.node):a}return!o.remote&&!o.node?this.resolveLatestContent(o.syncResource,o.profile):null}async getContentFromStore(i,o,a,y,I){if(i){const{content:w}=await this.getUserData(o,y,a);return w}return this.userDataSyncLocalStoreService.resolveResourceContent(o,y,a,I)}resolveNodeContent(i,o,a){const y=this.parseSyncData(o,i);switch(i){case"settings":return this.resolveSettingsNodeContent(y,a);case"keybindings":return this.resolveKeybindingsNodeContent(y,a);case"tasks":return this.resolveTasksNodeContent(y,a);case"snippets":return this.resolveSnippetsNodeContent(y,a);case"globalState":return this.resolveGlobalStateNodeContent(y,a);case"extensions":return this.resolveExtensionsNodeContent(y,a);case"profiles":return this.resolveProfileNodeContent(y,a);case"workspaceState":return null}}async resolveLatestContent(i,o){const a=this.userDataProfilesService.profiles.find(y=>y.id===o);if(!a)return null;switch(i){case"globalState":return this.resolveLatestGlobalStateContent(a);case"extensions":return this.resolveLatestExtensionsContent(a);case"profiles":return this.resolveLatestProfilesContent(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}getSettingsAssociatedResources(i,o){const a=this.extUri.joinPath(i,"settings.json"),y=o?o.settingsResource:this.extUri.joinPath(i,r.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:y}]}resolveSettingsNodeContent(i,o){switch(o){case"settings.json":return(0,l.parseSettingsSyncContent)(i.content).settings}return null}getKeybindingsAssociatedResources(i,o){const a=this.extUri.joinPath(i,"keybindings.json"),y=o?o.keybindingsResource:this.extUri.joinPath(i,r.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:y}]}resolveKeybindingsNodeContent(i,o){switch(o){case"keybindings.json":return(0,c.getKeybindingsContentFromSyncContent)(i.content,!!this.configurationService.getValue(d.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.logService)}return null}getTasksAssociatedResources(i,o){const a=this.extUri.joinPath(i,"tasks.json"),y=o?o.tasksResource:this.extUri.joinPath(i,r.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:y}]}resolveTasksNodeContent(i,o){switch(o){case"tasks.json":return(0,g.getTasksContentFromSyncContent)(i.content,this.logService)}return null}async getSnippetsAssociatedResources(i,o){const a=await this.resolveContent(i);if(a){const y=this.parseSyncData(a,"snippets");if(y){const I=(0,v.parseSnippets)(y),w=[];for(const b of Object.keys(I)){const D=this.extUri.joinPath(i,b),L=o?this.extUri.joinPath(o.snippetsHome,b):this.extUri.joinPath(i,r.NOT_EXISTING_RESOURCE);w.push({resource:D,comparableResource:L})}return w}}return[]}resolveSnippetsNodeContent(i,o){return(0,v.parseSnippets)(i)[o]||null}getExtensionsAssociatedResources(i,o){const a=this.extUri.joinPath(i,"extensions.json"),y=o?this.toUri({remote:!1,syncResource:"extensions",profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(i,r.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:y}]}resolveExtensionsNodeContent(i,o){switch(o){case"extensions.json":return(0,u.stringify)((0,u.parseExtensions)(i),!0)}return null}async resolveLatestExtensionsContent(i){const{localExtensions:o}=await this.instantiationService.createInstance(u.LocalExtensionsProvider).getLocalExtensions(i);return(0,u.stringify)(o,!0)}getGlobalStateAssociatedResources(i,o){const a=this.extUri.joinPath(i,"globalState.json"),y=o?this.toUri({remote:!1,syncResource:"globalState",profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.extUri.joinPath(i,r.NOT_EXISTING_RESOURCE);return[{resource:a,comparableResource:y}]}resolveGlobalStateNodeContent(i,o){switch(o){case"globalState.json":return(0,h.stringify)(JSON.parse(i.content),!0)}return null}async resolveLatestGlobalStateContent(i){const o=await this.instantiationService.createInstance(h.LocalGlobalStateProvider).getLocalGlobalState(i);return(0,h.stringify)(o,!0)}getProfilesAssociatedResources(i,o){const a=this.extUri.joinPath(i,"profiles.json"),y=this.toUri({remote:!1,syncResource:"profiles",profile:this.userDataProfilesService.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:y}]}resolveProfileNodeContent(i,o){switch(o){case"profiles.json":return(0,S.toFormattedString)(JSON.parse(i.content),{})}return null}async resolveLatestProfilesContent(i){return(0,f.stringifyLocalProfiles)(this.userDataProfilesService.profiles.filter(o=>!o.isDefault&&!o.isTransient),!0)}toUri(i){const o=i.remote?r.REMOTE_BACKUP_AUTHORITY:r.LOCAL_BACKUP_AUTHORITY,a=[];return i.location&&(a.push(`scheme:${i.location.scheme}`),a.push(`authority:${i.location.authority}`),a.push((0,t.trim)(i.location.path,"/"))),a.push(`syncResource:${i.syncResource}`),a.push(`profile:${i.profile}`),i.collection&&a.push(`collection:${i.collection}`),i.ref&&a.push(`ref:${i.ref}`),i.node&&a.push(i.node),this.extUri.joinPath(_.URI.from({scheme:d.USER_DATA_SYNC_SCHEME,authority:o,path:"/",query:i.location?.query,fragment:i.location?.fragment}),...a)}resolveUri(i){if(i.scheme!==d.USER_DATA_SYNC_SCHEME)return;const o=[];for(;i.path!=="/";)o.unshift(this.extUri.basename(i)),i=this.extUri.dirname(i);if(o.length<2)return;const a=i.authority===r.REMOTE_BACKUP_AUTHORITY;let y,I;const w=[];let b,D,L,N,F;for(;o.length;){const x=o.shift();x.startsWith("scheme:")?y=x.substring(7):x.startsWith("authority:")?I=x.substring(10):x.startsWith("syncResource:")?b=x.substring(13):x.startsWith("profile:")?D=x.substring(8):x.startsWith("collection:")?L=x.substring(11):x.startsWith("ref:")?N=x.substring(4):b?F=x:w.push(x)}return{remote:a,syncResource:b,profile:D,collection:L,ref:N,node:F,location:y&&I!==void 0?this.extUri.joinPath(_.URI.from({scheme:y,authority:I,query:i.query,fragment:i.fragment,path:"/"}),...w):void 0}}parseSyncData(i,o){try{const a=JSON.parse(i);if((0,E.isSyncData)(a))return a}catch(a){this.logService.error(a)}throw new d.UserDataSyncError((0,U.localize)(0,null),"IncompatibleRemoteContent",o)}async getUserData(i,o,a){const y=await this.userDataSyncStoreService.resolveResourceContent(i,o,a);return{ref:o,content:y}}};e.UserDataSyncResourceProviderService=n,e.UserDataSyncResourceProviderService=n=r=Ce([K(0,d.IUserDataSyncStoreService),K(1,d.IUserDataSyncLocalStoreService),K(2,d.IUserDataSyncLogService),K(3,P.IUriIdentityService),K(4,A.IEnvironmentService),K(5,R.IStorageService),K(6,O.IFileService),K(7,C.IUserDataProfilesService),K(8,p.IConfigurationService),K(9,m.IInstantiationService)],n)}),define(ae[265],ce([0,1,17,6,26,38,3,2,20,13,32,21,29,12,4,19,22,18,115,116,117,118,119,120,121,25]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g,u,h,m,f,S,t,r,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const i="sync.lastSyncTime";let o=class extends R.Disposable{get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}constructor(b,D,L,N,F,x,X,B,Y,z,H){super(),this.fileService=b,this.userDataSyncStoreService=D,this.userDataSyncStoreManagementService=L,this.instantiationService=N,this.logService=F,this.telemetryService=x,this.storageService=X,this.userDataSyncEnablementService=B,this.userDataProfilesService=Y,this.userDataSyncResourceProviderService=z,this.userDataSyncLocalStoreService=H,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.activeProfileSynchronizers=new Map,this._status=L.userDataSyncStore?"idle":"uninitialized",this._lastSyncTime=this.storageService.getNumber(i,-1,void 0),this._register((0,R.toDisposable)(()=>this.clearActiveProfileSynchronizers()))}async createSyncTask(b,D){this.checkEnablement(),this.logService.info("Sync started.");const L=new Date().getTime(),N=(0,C.generateUuid)();try{const B=(0,s.createSyncHeaders)(N);D&&(B["Cache-Control"]="no-cache"),b=await this.userDataSyncStoreService.manifest(b,B)}catch(B){const Y=s.UserDataSyncError.toUserDataSyncError(B);throw I(Y,N,this.userDataSyncStoreManagementService,this.telemetryService),Y}const F=!1,x=this;let X;return{manifest:b,async run(){if(F)throw new Error("Can run a task only once");X=(0,U.createCancelablePromise)(B=>x.sync(b,!1,N,B)),await X.finally(()=>X=void 0),x.logService.info(`Sync done. Took ${new Date().getTime()-L}ms`),x.updateLastSyncTime()},stop(){return X?.cancel(),x.stop()}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new s.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.logService.info("Sync started.");const b=new Date().getTime(),D=(0,C.generateUuid)(),L=(0,s.createSyncHeaders)(D);let N;try{N=await this.userDataSyncStoreService.manifest(null,L)}catch(X){const B=s.UserDataSyncError.toUserDataSyncError(X);throw I(B,D,this.userDataSyncStoreManagementService,this.telemetryService),B}await this.resetLocal();const F=this,x=new A.CancellationTokenSource;return{id:D,async merge(){return F.sync(N,!0,D,x.token)},async apply(){try{try{await F.applyManualSync(N,D,x.token)}catch(X){if(s.UserDataSyncError.toUserDataSyncError(X).code==="MethodNotFound")F.logService.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.logService.info("Applying manual sync again..."),await F.applyManualSync(N,D,x.token);else throw X}}catch(X){throw F.logService.error(X),X}F.logService.info(`Sync done. Took ${new Date().getTime()-b}ms`),F.updateLastSyncTime()},async stop(){x.cancel(),await F.stop(),await F.resetLocal()}}}async sync(b,D,L,N){this._syncErrors=[];try{this.status!=="hasConflicts"&&this.setStatus("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.userDataProfilesService.defaultProfile,void 0);this._syncErrors.push(...await this.syncProfile(F,b,D,L,N));const x=F.enabled.find(X=>X.resource==="profiles");if(x){const X=await x.getLastSyncedProfiles()||[];if(N.isCancellationRequested)return;await this.syncRemoteProfiles(X,b,D,L,N)}}finally{this.status!=="hasConflicts"&&this.setStatus("idle"),this._onSyncErrors.fire(this._syncErrors)}}async syncRemoteProfiles(b,D,L,N,F){for(const x of b){if(F.isCancellationRequested)return;const X=this.userDataProfilesService.profiles.find(Y=>Y.id===x.id);if(!X){this.logService.error(`Profile with id:${x.id} and name: ${x.name} does not exist locally to sync.`);continue}this.logService.info("Syncing profile.",x.name);const B=this.getOrCreateActiveProfileSynchronizer(X,x);this._syncErrors.push(...await this.syncProfile(B,D,L,N,F))}for(const[x,X]of this.activeProfileSynchronizers.entries())this.userDataProfilesService.profiles.some(B=>B.id===X[0].profile.id)||(X[1].dispose(),this.activeProfileSynchronizers.delete(x))}async applyManualSync(b,D,L){const N=this.getActiveProfileSynchronizers();for(const Y of N){if(L.isCancellationRequested)return;await Y.apply(D,L)}const F=N.find(Y=>Y.profile.isDefault);if(!F)return;const x=F.enabled.find(Y=>Y.resource==="profiles");if(!x)return;const B=(await x.getRemoteSyncedProfiles(b?.latest??null)||[]).filter(Y=>N.every(z=>z.profile.id!==Y.id));B.length&&await this.syncRemoteProfiles(B,b,!1,D,L)}async syncProfile(b,D,L,N,F){return(await b.sync(D,L,N,F)).map(([X,B])=>({profile:b.profile,syncResource:X,error:B}))}async stop(){this.status!=="idle"&&await Promise.allSettled(this.getActiveProfileSynchronizers().map(b=>b.stop()))}async resolveContent(b){const D=await this.userDataSyncResourceProviderService.resolveContent(b);if(D)return D;for(const L of this.getActiveProfileSynchronizers())for(const N of L.enabled){const F=await N.resolveContent(b);if(F)return F}return null}async replace(b){this.checkEnablement();const D=this.userDataSyncResourceProviderService.resolveUserDataSyncResource(b);if(!D)return;const L=await this.resolveContent(b.uri);L&&await this.performAction(D.profile,async N=>{if(D.syncResource===N.resource)return await N.replace(L),!0})}async accept(b,D,L,N){this.checkEnablement(),await this.performAction(b.profile,async F=>{if(b.syncResource===F.resource)return await F.accept(D,L),N&&await F.apply((0,d.isBoolean)(N)?!1:N.force,(0,s.createSyncHeaders)((0,C.generateUuid)())),!0})}async hasLocalData(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async D=>{if(D.resource!=="globalState"&&await D.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performAction(this.userDataProfilesService.defaultProfile,async D=>{if(await D.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(b){this.logService.error(b)}this._onDidResetRemote.fire()}async resetLocal(){this.checkEnablement(),this._lastSyncTime=void 0,this.storageService.remove(i,-1);for(const[b]of this.activeProfileSynchronizers.values())try{await b.resetLocal()}catch(D){this.logService.error(D)}this.clearActiveProfileSynchronizers(),this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async cleanUpRemoteData(){const b=await this.userDataSyncResourceProviderService.getRemoteSyncedProfiles(),D=b.map(x=>x.collection),L=await this.userDataSyncStoreService.getAllCollections(),N=L.filter(x=>!D.includes(x));N.length&&(this.logService.info(`Deleting ${N.length} redundant collections on server`),await Promise.allSettled(N.map(x=>this.userDataSyncStoreService.deleteCollection(x))),this.logService.info("Deleted redundant collections on server"));const F=b.filter(x=>L.includes(x.collection));if(F.length!==b.length){const x=this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,this.userDataProfilesService.defaultProfile,void 0);try{this.logService.info("Resetting the last synced state of profiles"),await x.resetLocal(),this.logService.info("Did reset the last synced state of profiles"),this.logService.info("Updating remote profiles with invalid collections on server"),await x.updateRemoteProfiles(F,null),this.logService.info("Updated remote profiles on server")}finally{x.dispose()}}}async saveRemoteActivityData(b){this.checkEnablement();const D=await this.userDataSyncStoreService.getActivityData();await this.fileService.writeFile(b,D)}async extractActivityData(b,D){const L=(await this.fileService.readFile(b)).value.toString(),N=JSON.parse(L);if(N.resources)for(const F in N.resources)for(const x of N.resources[F])await this.userDataSyncLocalStoreService.writeResource(F,x.content,new Date(x.created*1e3),void 0,D);if(N.collections)for(const F in N.collections)for(const x in N.collections[F].resources)for(const X of N.collections[F].resources?.[x]??[])await this.userDataSyncLocalStoreService.writeResource(x,X.content,new Date(X.created*1e3),F,D)}async performAction(b,D){const L=new R.DisposableStore;try{const N=this.activeProfileSynchronizers.get(b.id);if(N){const Y=await this.performActionWithProfileSynchronizer(N[0],D,L);return(0,d.isUndefined)(Y)?null:Y}if(b.isDefault){const Y=L.add(this.instantiationService.createInstance(a,b,void 0)),z=await this.performActionWithProfileSynchronizer(Y,D,L);return(0,d.isUndefined)(z)?null:z}if(this.userDataProfilesService.isEnabled())return null;const F=L.add(this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,b,void 0)),x=await this.userDataSyncStoreService.manifest(null),B=(await F.getRemoteSyncedProfiles(x?.latest??null)||[]).find(Y=>Y.id===b.id);if(B){const Y=L.add(this.instantiationService.createInstance(a,b,B.collection)),z=await this.performActionWithProfileSynchronizer(Y,D,L);return(0,d.isUndefined)(z)?null:z}return null}finally{L.dispose()}}async performActionWithProfileSynchronizer(b,D,L){const N=[...b.enabled,...b.disabled.reduce((F,x)=>(x!=="workspaceState"&&F.push(L.add(b.createSynchronizer(x))),F),[])];for(const F of N){const x=await D(F);if(!(0,d.isUndefined)(x))return x}}setStatus(b){const D=this._status;this._status!==b&&(this._status=b,this._onDidChangeStatus.fire(b),D==="hasConflicts"&&this.updateLastSyncTime())}updateConflicts(){const b=this.getActiveProfileSynchronizers().map(D=>D.conflicts).flat();(0,_.equals)(this._conflicts,b,(D,L)=>D.profile.id===L.profile.id&&D.syncResource===L.syncResource&&(0,_.equals)(D.conflicts,L.conflicts,(N,F)=>(0,P.isEqual)(N.previewResource,F.previewResource)))||(this._conflicts=b,this._onDidChangeConflicts.fire(b))}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(i,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}getOrCreateActiveProfileSynchronizer(b,D){let L=this.activeProfileSynchronizers.get(b.id);if(L&&L[0].collection!==D?.collection&&(this.logService.error("Profile synchronizer collection does not match with the remote sync profile collection"),L[1].dispose(),L=void 0,this.activeProfileSynchronizers.delete(b.id)),!L){const N=new R.DisposableStore,F=N.add(this.instantiationService.createInstance(a,b,D?.collection));N.add(F.onDidChangeStatus(x=>this.setStatus(x))),N.add(F.onDidChangeConflicts(x=>this.updateConflicts())),N.add(F.onDidChangeLocal(x=>this._onDidChangeLocal.fire(x))),this.activeProfileSynchronizers.set(b.id,L=[F,N])}return L[0]}getActiveProfileSynchronizers(){const b=[];for(const[D]of this.activeProfileSynchronizers.values())b.push(D);return b}clearActiveProfileSynchronizers(){this.activeProfileSynchronizers.forEach(([,b])=>b.dispose()),this.activeProfileSynchronizers.clear()}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};e.UserDataSyncService=o,e.UserDataSyncService=o=Ce([K(0,l.IFileService),K(1,s.IUserDataSyncStoreService),K(2,s.IUserDataSyncStoreManagementService),K(3,c.IInstantiationService),K(4,s.IUserDataSyncLogService),K(5,g.ITelemetryService),K(6,p.IStorageService),K(7,s.IUserDataSyncEnablementService),K(8,u.IUserDataProfilesService),K(9,s.IUserDataSyncResourceProviderService),K(10,s.IUserDataSyncLocalStoreService)],o);let a=class extends R.Disposable{get enabled(){return this._enabled.sort((b,D)=>b[1]-D[1]).map(([b])=>b)}get disabled(){return s.ALL_SYNC_RESOURCES.filter(b=>!this.userDataSyncEnablementService.isResourceEnabled(b))}get status(){return this._status}get conflicts(){return this._conflicts}constructor(b,D,L,N,F,x,X,B,Y,z){super(),this.profile=b,this.collection=D,this.userDataSyncEnablementService=L,this.instantiationService=N,this.extensionGalleryService=F,this.userDataSyncStoreManagementService=x,this.telemetryService=X,this.logService=B,this.userDataProfilesService=Y,this.configurationService=z,this._enabled=[],this._status="idle",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._register(L.onDidChangeResourceEnablement(([H,V])=>this.onDidChangeResourceEnablement(H,V))),this._register((0,R.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,H])=>H.dispose())));for(const H of s.ALL_SYNC_RESOURCES)L.isResourceEnabled(H)&&this.registerSynchronizer(H)}onDidChangeResourceEnablement(b,D){D?this.registerSynchronizer(b):this.deRegisterSynchronizer(b)}registerSynchronizer(b){if(this._enabled.some(([F])=>F.resource===b))return;if(b==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}if(b==="profiles"&&(!this.profile.isDefault||!this.userDataProfilesService.isEnabled())||b==="workspaceState")return;if(b!=="profiles"&&this.profile.useDefaultFlags?.[b]){this.logService.debug(`Skipping syncing ${b} in ${this.profile.name} because it is already synced by default profile`);return}const D=new R.DisposableStore,L=D.add(this.createSynchronizer(b));D.add(L.onDidChangeStatus(()=>this.updateStatus())),D.add(L.onDidChangeConflicts(()=>this.updateConflicts())),D.add(L.onDidChangeLocal(()=>this._onDidChangeLocal.fire(b)));const N=this.getOrder(b);this._enabled.push([L,N,D])}deRegisterSynchronizer(b){const D=this._enabled.findIndex(([L])=>L.resource===b);if(D!==-1){const[[L,,N]]=this._enabled.splice(D,1);N.dispose(),this.updateStatus(),Promise.allSettled([L.stop(),L.resetLocal()]).then(null,F=>this.logService.error(F))}}createSynchronizer(b){switch(b){case"settings":return this.instantiationService.createInstance(S.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.instantiationService.createInstance(f.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.instantiationService.createInstance(t.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.instantiationService.createInstance(r.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.instantiationService.createInstance(m.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.instantiationService.createInstance(h.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.instantiationService.createInstance(n.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(b,D,L,N){if(N.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const x=[],X=(0,s.createSyncHeaders)(L),B=(this.collection?b?.collections?.[this.collection]?.latest:b?.latest)??null,Y=D?await this.getUserDataSyncConfiguration(B):{};for(const z of F){if(N.isCancellationRequested)return[];if(!this.userDataSyncEnablementService.isResourceEnabled(z.resource))return[];try{if(D){const H=await z.preview(B,Y,X);if(H)for(const V of H.resourcePreviews)(V.localChange!==0||V.remoteChange!==0)&&V.mergeState==="preview"&&await z.merge(V.previewResource)}else await z.sync(B,X)}catch(H){const V=s.UserDataSyncError.toUserDataSyncError(H);if(I(V,L,this.userDataSyncStoreManagementService,this.telemetryService),y(H))throw V;this.logService.error(H),this.logService.error(`${z.resource}: ${(0,O.toErrorMessage)(H)}`),x.push([z.resource,V])}}return x}finally{this.updateStatus()}}async apply(b,D){const L=(0,s.createSyncHeaders)(b);for(const N of this.enabled){if(D.isCancellationRequested)return;try{await N.apply(!1,L)}catch(F){const x=s.UserDataSyncError.toUserDataSyncError(F);if(I(x,b,this.userDataSyncStoreManagementService,this.telemetryService),y(F))throw x;this.logService.error(F),this.logService.error(`${N.resource}: ${(0,O.toErrorMessage)(F)}`)}}}async stop(){for(const b of this.enabled)try{b.status!=="idle"&&await b.stop()}catch(D){this.logService.error(D)}}async resetLocal(){for(const b of this.enabled)try{await b.resetLocal()}catch(D){this.logService.error(`${b.resource}: ${(0,O.toErrorMessage)(D)}`),this.logService.error(D)}}async getUserDataSyncConfiguration(b){if(!this.profile.isDefault)return{};const D=this.configurationService.getValue(s.USER_DATA_SYNC_CONFIGURATION_SCOPE),L=this.enabled.find(N=>N instanceof S.SettingsSynchroniser);if(L){const N=await L.getRemoteUserDataSyncConfiguration(b);return{...D,...N}}return D}setStatus(b){this._status!==b&&(this._status=b,this._onDidChangeStatus.fire(b))}updateStatus(){return this.updateConflicts(),this.enabled.some(b=>b.status==="hasConflicts")?this.setStatus("hasConflicts"):this.enabled.some(b=>b.status==="syncing")?this.setStatus("syncing"):this.setStatus("idle")}updateConflicts(){const b=this.enabled.filter(D=>D.status==="hasConflicts").filter(D=>D.conflicts.conflicts.length>0).map(D=>D.conflicts);(0,_.equals)(this._conflicts,b,(D,L)=>D.syncResource===L.syncResource&&(0,_.equals)(D.conflicts,L.conflicts,(N,F)=>(0,P.isEqual)(N.previewResource,F.previewResource)))||(this._conflicts=b,this._onDidChangeConflicts.fire(b))}getOrder(b){switch(b){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=Ce([K(2,s.IUserDataSyncEnablementService),K(3,c.IInstantiationService),K(4,v.IExtensionGalleryService),K(5,s.IUserDataSyncStoreManagementService),K(6,g.ITelemetryService),K(7,s.IUserDataSyncLogService),K(8,u.IUserDataProfilesService),K(9,E.IConfigurationService)],a);function y(w){if(w instanceof s.UserDataSyncError)switch(w.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function I(w,b,D,L){L.publicLog2("sync/error",{code:w.code,serverCode:w instanceof s.UserDataSyncStoreError?String(w.serverCode):void 0,url:w instanceof s.UserDataSyncStoreError?w.url:void 0,resource:w.resource,executionId:b,service:D.userDataSyncStore.url.toString()})}}),define(ae[266],ce([0,1,3,2,8,18,25]),function(ne,e,_,U,A,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncServiceChannelClient=e.UserDataSyncServiceChannel=void 0;function R(v,l){return{...v,profile:(0,O.reviveProfile)(v.profile,l.profilesHome.scheme)}}function P(v){return{created:v.created,uri:A.URI.revive(v.uri)}}class d{constructor(l,c,p){this.service=l,this.userDataProfilesService=c,this.logService=p,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new _.Emitter}listen(l,c){switch(c){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${c}`)}async call(l,c,p){try{return await this._call(l,c,p)}catch(g){throw this.logService.error(g),g}}async _call(l,c,p){switch(c){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"resolveContent":return this.service.resolveContent(A.URI.revive(p[0]));case"accept":return this.service.accept(R(p[0],this.userDataProfilesService),A.URI.revive(p[1]),p[2],p[3]);case"replace":return this.service.replace(P(p[0]));case"cleanUpRemoteData":return this.service.cleanUpRemoteData();case"getRemoteActivityData":return this.service.saveRemoteActivityData(A.URI.revive(p[0]));case"extractActivityData":return this.service.extractActivityData(A.URI.revive(p[0]),A.URI.revive(p[1]));case"createManualSyncTask":return this.createManualSyncTask()}if(c.startsWith("manualSync/")){const g=c.substring(11),u=p[0],h=this.getManualSyncTask(u);switch(p=p.slice(1),g){case"merge":return h.merge();case"apply":return h.apply().then(()=>this.manualSyncTasks.delete(this.createKey(h.id)));case"stop":return h.stop().finally(()=>this.manualSyncTasks.delete(this.createKey(h.id)))}}throw new Error("Invalid call")}getManualSyncTask(l){const c=this.manualSyncTasks.get(this.createKey(l));if(!c)throw new Error(`Manual sync taks not found: ${l}`);return c}async createManualSyncTask(){const l=await this.service.createManualSyncTask();return this.manualSyncTasks.set(this.createKey(l.id),l),l.id}createKey(l){return`manualSyncTask-${l}`}}e.UserDataSyncServiceChannel=d;let C=class extends U.Disposable{get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}constructor(l,c){super(),this.userDataProfilesService=c,this._status="uninitialized",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new _.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new _.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(p,g,u){return l.call(p,g,u).then(null,h=>{throw k.UserDataSyncError.toUserDataSyncError(h)})},listen(p,g){return l.listen(p,g)}},this.channel.call("_getInitialData").then(([p,g,u])=>{this.updateStatus(p),this.updateConflicts(g),u&&this.updateLastSyncTime(u),this._register(this.channel.listen("onDidChangeStatus")(h=>this.updateStatus(h))),this._register(this.channel.listen("onDidChangeLastSyncTime")(h=>this.updateLastSyncTime(h)))}),this._register(this.channel.listen("onDidChangeConflicts")(p=>this.updateConflicts(p))),this._register(this.channel.listen("onSyncErrors")(p=>this._onSyncErrors.fire(p.map(g=>({...g,error:k.UserDataSyncError.toUserDataSyncError(g.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const l=await this.channel.call("createManualSyncTask"),c=this;return new E(l,{async call(g,u,h){return c.channel.call(`manualSync/${g}`,[l,...Array.isArray(u)?u:[u]],h)},listen(){throw new Error("not supported")}})}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(l,c,p,g){return this.channel.call("accept",[l,c,p,g])}resolveContent(l){return this.channel.call("resolveContent",[l])}cleanUpRemoteData(){return this.channel.call("cleanUpRemoteData")}replace(l){return this.channel.call("replace",[l])}saveRemoteActivityData(l){return this.channel.call("getRemoteActivityData",[l])}extractActivityData(l,c){return this.channel.call("extractActivityData",[l,c])}async updateStatus(l){this._status=l,this._onDidChangeStatus.fire(l)}async updateConflicts(l){this._conflicts=l.map(c=>({syncResource:c.syncResource,profile:(0,O.reviveProfile)(c.profile,this.userDataProfilesService.profilesHome.scheme),conflicts:c.conflicts.map(p=>({...p,baseResource:A.URI.revive(p.baseResource),localResource:A.URI.revive(p.localResource),remoteResource:A.URI.revive(p.remoteResource),previewResource:A.URI.revive(p.previewResource)}))})),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(l){this._lastSyncTime!==l&&(this._lastSyncTime=l,this._onDidChangeLastSyncTime.fire(l))}};e.UserDataSyncServiceChannelClient=C,e.UserDataSyncServiceChannelClient=C=Ce([K(1,O.IUserDataProfilesService)],C);class E extends U.Disposable{constructor(l,c){super(),this.id=l,this.channel=c}async merge(){return this.channel.call("merge")}async apply(){return this.channel.call("apply")}stop(){return this.channel.call("stop")}dispose(){this.channel.call("dispose"),super.dispose()}}}),define(ae[122],ce([0,1,6,26,7,3,2,141,5,20,13,8,32,21,16,12,24,59,45,19,25]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g,u,h,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const S="configurationSync.store",t="sync.previous.store",r="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",i=100,o=1e3*60*5;let a=class extends k.Disposable{get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(f.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(L){this.storageService.store(f.SYNC_SERVICE_URL_TYPE,L,-1,P.isWeb?0:1)}constructor(L,N,F){super(),this.productService=L,this.configurationService=N,this.storageService=F,this._onDidChangeUserDataSyncStore=this._register(new O.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore();const x=this._register(new k.DisposableStore);this._register(O.Event.filter(F.onDidChangeValue(-1,f.SYNC_SERVICE_URL_TYPE,x),()=>this.userDataSyncStoreType!==this.userDataSyncStore?.type,x)(()=>this.updateUserDataSyncStore()))}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[S]),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(L){if(L&&(L=P.isWeb&&L.web?{...L,...L.web}:L,(0,C.isString)(L.url)&&(0,C.isObject)(L.authenticationProviders)&&Object.keys(L.authenticationProviders).every(N=>Array.isArray(L.authenticationProviders[N].scopes)))){const N=L,F=!!N.canSwitch,x=N.url===N.insidersUrl?"insiders":"stable",X=(F?this.userDataSyncStoreType:void 0)||x,B=X==="insiders"?N.insidersUrl:X==="stable"?N.stableUrl:N.url;return{url:E.URI.parse(B),type:X,defaultType:x,defaultUrl:E.URI.parse(N.url),stableUrl:E.URI.parse(N.stableUrl),insidersUrl:E.URI.parse(N.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(N.authenticationProviders).reduce((Y,z)=>(Y.push({id:z,scopes:N.authenticationProviders[z].scopes}),Y),[])}}}};e.AbstractUserDataSyncStoreManagementService=a,e.AbstractUserDataSyncStoreManagementService=a=Ce([K(0,g.IProductService),K(1,l.IConfigurationService),K(2,m.IStorageService)],a);let y=class extends a{constructor(L,N,F){super(L,N,F);const x=this.storageService.get(t,-1);x&&(this.previousConfigurationSyncStore=JSON.parse(x));const X=this.productService[S];X?this.storageService.store(t,JSON.stringify(X),-1,1):this.storageService.remove(t,-1)}async switch(L){L!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=L,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};e.UserDataSyncStoreManagementService=y,e.UserDataSyncStoreManagementService=y=Ce([K(0,g.IProductService),K(1,l.IConfigurationService),K(2,m.IStorageService)],y);let I=class extends k.Disposable{get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}constructor(L,N,F,x,X,B,Y){super(),this.requestService=F,this.logService=x,this.storageService=Y,this._onTokenFailed=this._register(new O.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new O.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new O.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(L),this.commonHeadersPromise=(0,h.getServiceMachineId)(X,B,Y).then(z=>{const H={"X-Client-Name":`${N.applicationName}${P.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(H["X-Client-Commit"]=N.commit),H}),this.session=new b(i,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,k.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}setAuthToken(L,N){this.authToken={token:L,type:N}}updateUserDataSyncStoreUrl(L){this.userDataSyncStoreUrl=L?(0,d.joinPath)(L,"v1"):void 0}initDonotMakeRequestsUntil(){const L=this.storageService.getNumber(r,-1);L&&Date.now()<L&&this.setDonotMakeRequestsUntil(new Date(L))}setDonotMakeRequestsUntil(L){this._donotMakeRequestsUntil?.getTime()!==L?.getTime()&&(this._donotMakeRequestsUntil=L,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,_.createCancelablePromise)(N=>(0,_.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(r,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllCollections(L={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,d.joinPath)(this.userDataSyncStoreUrl,"collection").toString();L={...L},L["Content-Type"]="application/json";const F=await this.request(N,{type:"GET",headers:L},[],U.CancellationToken.None);return(await(0,u.asJson)(F))?.map(({id:x})=>x)||[]}async createCollection(L={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,d.joinPath)(this.userDataSyncStoreUrl,"collection").toString();L={...L},L["Content-Type"]=R.Mimes.text;const F=await this.request(N,{type:"POST",headers:L},[],U.CancellationToken.None),x=await(0,u.asTextOrError)(F);if(!x)throw new f.UserDataSyncStoreError("Server did not return the collection id",N,"NoCollection",F.res.statusCode,F.res.headers[f.HEADER_OPERATION_ID]);return x}async deleteCollection(L,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=L?(0,d.joinPath)(this.userDataSyncStoreUrl,"collection",L).toString():(0,d.joinPath)(this.userDataSyncStoreUrl,"collection").toString();N={...N},await this.request(F,{type:"DELETE",headers:N},[],U.CancellationToken.None)}async getAllResourceRefs(L,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=this.getResourceUrl(this.userDataSyncStoreUrl,N,L),x={},X=await this.request(F.toString(),{type:"GET",headers:x},[],U.CancellationToken.None);return(await(0,u.asJson)(X)||[]).map(({url:Y,created:z})=>({ref:(0,d.relativePath)(F,F.with({path:Y})),created:z*1e3}))}async resolveResourceContent(L,N,F,x={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const X=(0,d.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,F,L),N).toString();x={...x},x["Cache-Control"]="no-cache";const B=await this.request(X,{type:"GET",headers:x},[],U.CancellationToken.None);return await(0,u.asTextOrError)(B)}async deleteResource(L,N,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=N!==null?(0,d.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,F,L),N).toString():this.getResourceUrl(this.userDataSyncStoreUrl,F,L).toString(),X={};await this.request(x,{type:"DELETE",headers:X},[],U.CancellationToken.None)}async deleteResources(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const L=(0,d.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":R.Mimes.text};await this.request(L,{type:"DELETE",headers:N},[],U.CancellationToken.None)}async readResource(L,N,F,x={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const X=(0,d.joinPath)(this.getResourceUrl(this.userDataSyncStoreUrl,F,L),"latest").toString();x={...x},x["Cache-Control"]="no-cache",N&&(x["If-None-Match"]=N.ref);const B=await this.request(X,{type:"GET",headers:x},[304],U.CancellationToken.None);let Y=null;if(B.res.statusCode===304&&(Y=N),Y===null){const z=B.res.headers.etag;if(!z)throw new f.UserDataSyncStoreError("Server did not return the ref",X,"NoRef",B.res.statusCode,B.res.headers[f.HEADER_OPERATION_ID]);const H=await(0,u.asTextOrError)(B);if(!H&&B.res.statusCode===304)throw new f.UserDataSyncStoreError("Empty response",X,"EmptyResponse",B.res.statusCode,B.res.headers[f.HEADER_OPERATION_ID]);Y={ref:z,content:H}}return Y}async writeResource(L,N,F,x,X={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const B=this.getResourceUrl(this.userDataSyncStoreUrl,x,L).toString();X={...X},X["Content-Type"]=R.Mimes.text,F&&(X["If-Match"]=F);const Y=await this.request(B,{type:"POST",data:N,headers:X},[],U.CancellationToken.None),z=Y.res.headers.etag;if(!z)throw new f.UserDataSyncStoreError("Server did not return the ref",B,"NoRef",Y.res.statusCode,Y.res.headers[f.HEADER_OPERATION_ID]);return z}async manifest(L,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,d.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",L&&(N["If-None-Match"]=L.ref);const x=await this.request(F,{type:"GET",headers:N},[304],U.CancellationToken.None);let X=null;if(x.res.statusCode===304&&(X=L),!X){const Y=x.res.headers.etag;if(!Y)throw new f.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",x.res.statusCode,x.res.headers[f.HEADER_OPERATION_ID]);const z=await(0,u.asTextOrError)(x);if(!z&&x.res.statusCode===304)throw new f.UserDataSyncStoreError("Empty response",F,"EmptyResponse",x.res.statusCode,x.res.headers[f.HEADER_OPERATION_ID]);z&&(X={...JSON.parse(z),ref:Y})}const B=this.storageService.get(n,-1);return B&&X&&B!==X.session&&this.clearSession(),X===null&&B&&this.clearSession(),X&&this.storageService.store(n,X.session,-1,1),X}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.clearSession()}async getActivityData(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const L=(0,d.joinPath)(this.userDataSyncStoreUrl,"download").toString(),N={},F=await this.request(L,{type:"GET",headers:N},[],U.CancellationToken.None);if(!(0,u.isSuccess)(F))throw new f.UserDataSyncStoreError("Server returned "+F.res.statusCode,L,"EmptyResponse",F.res.statusCode,F.res.headers[f.HEADER_OPERATION_ID]);if((0,u.hasNoContent)(F))throw new f.UserDataSyncStoreError("Empty response",L,"EmptyResponse",F.res.statusCode,F.res.headers[f.HEADER_OPERATION_ID]);return F.stream}getResourceUrl(L,N,F){return N?(0,d.joinPath)(L,"collection",N,"resource",F):(0,d.joinPath)(L,"resource",F)}clearSession(){this.storageService.remove(n,-1),this.storageService.remove(s,-1)}async request(L,N,F,x){if(!this.authToken)throw new f.UserDataSyncStoreError("No Auth Token Available",L,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new f.UserDataSyncStoreError(`${N.type} request '${L}' failed because of too many requests (429).`,L,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const X=await this.commonHeadersPromise;N.headers={...N.headers||{},...X,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:L,type:N.type,headers:{...N.headers,authorization:void 0}});let B;try{B=await this.session.request(L,N,x)}catch(q){if(!(q instanceof f.UserDataSyncStoreError)){let ie="RequestFailed";const re=(0,A.getErrorMessage)(q).toLowerCase();re.includes("xhr timeout")?ie="RequestTimeout":re.includes("protocol")&&re.includes("not supported")?ie="RequestProtocolNotSupported":re.includes("request path contains unescaped characters")?ie="RequestPathNotEscaped":re.includes("headers must be an object")?ie="RequestHeadersNotObject":(0,A.isCancellationError)(q)&&(ie="RequestCanceled"),q=new f.UserDataSyncStoreError(`Connection refused for the request '${L}'.`,L,ie,void 0,void 0)}throw this.logService.info("Request failed",L),q}const Y=B.res.headers[f.HEADER_OPERATION_ID],z={url:L,status:B.res.statusCode,"execution-id":N.headers[f.HEADER_EXECUTION_ID],"operation-id":Y},H=(0,u.isSuccess)(B)||B.res.statusCode&&F.includes(B.res.statusCode);let V="";if(H?this.logService.trace("Request succeeded",z):(V=await(0,u.asText)(B)||"",this.logService.info("Request failed",z,V)),B.res.statusCode===401||B.res.statusCode===403){if(this.authToken=void 0,B.res.statusCode===401)throw this._onTokenFailed.fire("Unauthorized"),new f.UserDataSyncStoreError(`${N.type} request '${L}' failed because of Unauthorized (401).`,L,"Unauthorized",B.res.statusCode,Y);if(B.res.statusCode===403)throw this._onTokenFailed.fire("Forbidden"),new f.UserDataSyncStoreError(`${N.type} request '${L}' failed because the access is forbidden (403).`,L,"Forbidden",B.res.statusCode,Y)}if(this._onTokenSucceed.fire(),B.res.statusCode===404)throw new f.UserDataSyncStoreError(`${N.type} request '${L}' failed because the requested resource is not found (404).`,L,"NotFound",B.res.statusCode,Y);if(B.res.statusCode===405)throw new f.UserDataSyncStoreError(`${N.type} request '${L}' failed because the requested endpoint is not found (405). ${V}`,L,"MethodNotFound",B.res.statusCode,Y);if(B.res.statusCode===409)throw new f.UserDataSyncStoreError(`${N.type} request '${L}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,L,"Conflict",B.res.statusCode,Y);if(B.res.statusCode===410)throw new f.UserDataSyncStoreError(`${N.type} request '${L}' failed because the requested resource is not longer available (410).`,L,"Gone",B.res.statusCode,Y);if(B.res.statusCode===412)throw new f.UserDataSyncStoreError(`${N.type} request '${L}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,L,"PreconditionFailed",B.res.statusCode,Y);if(B.res.statusCode===413)throw new f.UserDataSyncStoreError(`${N.type} request '${L}' failed because of too large payload (413).`,L,"TooLarge",B.res.statusCode,Y);if(B.res.statusCode===426)throw new f.UserDataSyncStoreError(`${N.type} request '${L}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,L,"UpgradeRequired",B.res.statusCode,Y);if(B.res.statusCode===429){const q=B.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new f.UserDataSyncStoreError(`${N.type} request '${L}' failed because of too many requests (429).`,L,"TooManyRequestsAndRetryAfter",B.res.statusCode,Y)):new f.UserDataSyncStoreError(`${N.type} request '${L}' failed because of too many requests (429).`,L,"RemoteTooManyRequests",B.res.statusCode,Y)}if(!H)throw new f.UserDataSyncStoreError("Server returned "+B.res.statusCode,L,"Unknown",B.res.statusCode,Y);return B}addSessionHeaders(L){let N=this.storageService.get(s,-1);N===void 0&&(N=(0,v.generateUuid)(),this.storageService.store(s,N,-1,1)),L["X-Machine-Session-Id"]=N;const F=this.storageService.get(n,-1);F!==void 0&&(L["X-User-Session-Id"]=F)}};e.UserDataSyncStoreClient=I,e.UserDataSyncStoreClient=I=Ce([K(1,g.IProductService),K(2,u.IRequestService),K(3,f.IUserDataSyncLogService),K(4,c.IEnvironmentService),K(5,p.IFileService),K(6,m.IStorageService)],I);let w=class extends I{constructor(L,N,F,x,X,B,Y){super(L.userDataSyncStore?.url,N,F,x,X,B,Y),this._register(L.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(L.userDataSyncStore?.url)))}};e.UserDataSyncStoreService=w,e.UserDataSyncStoreService=w=Ce([K(0,f.IUserDataSyncStoreManagementService),K(1,g.IProductService),K(2,u.IRequestService),K(3,f.IUserDataSyncLogService),K(4,c.IEnvironmentService),K(5,p.IFileService),K(6,m.IStorageService)],w);class b{constructor(L,N,F,x){this.limit=L,this.interval=N,this.requestService=F,this.logService=x,this.requests=[],this.startTime=void 0}request(L,N,F){if(this.isExpired()&&this.reset(),N.url=L,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new f.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,L,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(L),this.requestService.request(N,F)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=b}),define(ae[267],ce([0,1,3,2,8,21,24,19,122]),function(ne,e,_,U,A,O,k,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannelClient=e.UserDataSyncAccountServiceChannel=void 0;class d{constructor(c){this.service=c}listen(c,p){switch(p){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${p}`)}call(c,p,g){switch(p){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(g)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=d;class C extends U.Disposable{get account(){return this._account}get onTokenFailed(){return this.channel.listen("onTokenFailed")}constructor(c){super(),this.channel=c,this._onDidChangeAccount=this._register(new _.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this.channel.call("_getInitialData").then(p=>{this._account=p,this._register(this.channel.listen("onDidChangeAccount")(g=>{this._account=g,this._onDidChangeAccount.fire(g)}))})}updateAccount(c){return this.channel.call("updateAccount",c)}}e.UserDataSyncAccountServiceChannelClient=C;class E{constructor(c){this.service=c}listen(c,p){switch(p){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${p}`)}call(c,p,g){switch(p){case"switch":return this.service.switch(g[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;let v=class extends P.AbstractUserDataSyncStoreManagementService{constructor(c,p,g,u){super(p,g,u),this.channel=c,this._register(this.channel.listen("onDidChangeUserDataSyncStore")(()=>this.updateUserDataSyncStore()))}async switch(c){return this.channel.call("switch",[c])}async getPreviousUserDataSyncStore(){const c=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(c)}revive(c){return{url:A.URI.revive(c.url),type:c.type,defaultUrl:A.URI.revive(c.defaultUrl),insidersUrl:A.URI.revive(c.insidersUrl),stableUrl:A.URI.revive(c.stableUrl),canSwitch:c.canSwitch,authenticationProviders:c.authenticationProviders}}};e.UserDataSyncStoreManagementServiceChannelClient=v,e.UserDataSyncStoreManagementServiceChannelClient=v=Ce([K(1,k.IProductService),K(2,O.IConfigurationService),K(3,R.IStorageService)],v)}),define(ae[268],ce([0,1,3,57,24,19,22,263,25,80,83]),function(ne,e,_,U,A,O,k,R,P,d,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends R.UserDataAutoSyncService{constructor(l,c,p,g,u,h,m,f,S,t,r){super(l,c,p,g,u,m,f,S,t,r),this._register(_.Event.debounce(_.Event.any(_.Event.map(h.onDidFocusMainWindow,()=>"windowFocus"),_.Event.map(h.onDidOpenMainWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.UserDataAutoSyncService=E,e.UserDataAutoSyncService=E=Ce([K(0,A.IProductService),K(1,P.IUserDataSyncStoreManagementService),K(2,P.IUserDataSyncStoreService),K(3,P.IUserDataSyncEnablementService),K(4,P.IUserDataSyncService),K(5,U.INativeHostService),K(6,P.IUserDataSyncLogService),K(7,d.IUserDataSyncAccountService),K(8,k.ITelemetryService),K(9,C.IUserDataSyncMachinesService),K(10,O.IStorageService)],E)}),define(ae[269],ce([0,1,73,23,5,20]),function(ne,e,_,U,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.getWorkspaceIdentifier=k,e.getSingleFolderWorkspaceIdentifier=R,e.createEmptyWorkspaceIdentifier=P,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function k(d){function C(){let E=d.scheme===U.Schemas.file?(0,O.originalFSPath)(d):d.toString();return A.isLinux||(E=E.toLowerCase()),(0,_.createHash)("md5").update(E).digest("hex")}return{id:C(),configPath:d}}function R(d,C){function E(){if(d.scheme!==U.Schemas.file)return(0,_.createHash)("md5").update(d.toString()).digest("hex");if(!C)return;let l;return A.isLinux?l=C.ino:A.isMacintosh?l=C.birthtime.getTime():A.isWindows&&(typeof C.birthtimeMs=="number"?l=Math.floor(C.birthtimeMs):l=C.birthtime.getTime()),(0,_.createHash)("md5").update(d.fsPath).update(l?String(l):"").digest("hex")}const v=E();if(typeof v=="string")return{id:v,uri:d}}function P(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ae[270],ce([0,1,6,7,2,14,31,16,9,77,112,269,57,56,23]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let p=class extends A.Disposable{constructor(u,h,m,f){super(),this.environmentService=u,this.logService=h,this.nativeHostService=m,this.mainProcessService=f,this._register(new _.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const u=this.environmentService.workspaceStorageHome.with({scheme:c.Schemas.file}).fsPath,h=await k.Promises.readdir(u),m=new d.StorageClient(this.mainProcessService.getChannel("storage"));await Promise.all(h.map(async f=>{const S=(0,O.join)(u,f);f.length===E.NON_EMPTY_WORKSPACE_ID_LENGTH||f===C.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.nativeHostService.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===f)||await m.isUsed(S)||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${f} as it seems to be an unused empty workspace.`),await k.Promises.rm(S))}))}catch(u){(0,U.onUnexpectedError)(u)}}};e.UnusedWorkspaceStorageDataCleaner=p,e.UnusedWorkspaceStorageDataCleaner=p=Ce([K(0,R.INativeEnvironmentService),K(1,P.ILogService),K(2,v.INativeHostService),K(3,l.IMainProcessService)],p)}),define(ae[123],ce([0,1,73,64,37,279,15,7,3,2,14,5,32,42,68]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0,e.createRandomIPCHandle=n,e.createStaticIPCHandle=s,e.serve=a,e.connect=y;class p{traceSocketEvent(w,b){c.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,w,b)}constructor(w,b=""){this._canWrite=!0,this.debugLabel=b,this.socket=w,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,R.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener),this._closeListener=D=>{this.traceSocketEvent("close",{hadError:D}),this._canWrite=!1},this.socket.on("close",this._closeListener),this._endListener=()=>{this.traceSocketEvent("nodeEndReceived"),this._canWrite=!1},this.socket.on("end",this._endListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.off("close",this._closeListener),this.socket.off("end",this._endListener),this.socket.destroy()}onData(w){const b=D=>{this.traceSocketEvent("read",D),w(k.VSBuffer.wrap(D))};return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(w){const b=D=>{w({type:0,hadError:D,error:void 0})};return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(w){const b=()=>{w()};return this.socket.on("end",b),{dispose:()=>this.socket.off("end",b)}}write(w){if(!(this.socket.destroyed||!this._canWrite))try{this.traceSocketEvent("write",w),this.socket.write(w.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,R.onUnexpectedError)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,R.onUnexpectedError)(b)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((w,b)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),w();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),w()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=p;var g;(function(I){I[I.MinHeaderByteSize=2]="MinHeaderByteSize",I[I.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var u;(function(I){I[I.PeekHeader=1]="PeekHeader",I[I.ReadHeader=2]="ReadHeader",I[I.ReadBody=3]="ReadBody",I[I.Fin=4]="Fin"})(u||(u={}));class h extends d.Disposable{get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(w,b){this.socket.traceSocketEvent(w,b)}constructor(w,b,D,L){super(),this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=w,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:b,inflateBytesLength:D?.byteLength||0,recordInflateBytes:L}),this._flowManager=this._register(new m(this,b,D,L,this._onData,(N,F)=>this._write(N,F))),this._register(this._flowManager.onError(N=>{console.error(N),(0,R.onUnexpectedError)(N),this._onClose.fire({type:0,hadError:!0,error:N})})),this._incomingData=new c.ChunkStream,this._register(this.socket.onData(N=>this._acceptChunk(N))),this._register(this.socket.onClose(async N=>{this._flowManager.isProcessingReadQueue()&&await P.Event.toPromise(this._flowManager.onDidFinishProcessingReadQueue),this._onClose.fire(N)}))}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(w){return this._onData.event(w)}onClose(w){return this._onClose.event(w)}onEnd(w){return this.socket.onEnd(w)}write(w){let b=0;for(;b<w.byteLength;)this._flowManager.writeMessage(w.slice(b,Math.min(b+262144,w.byteLength)),{compressed:!0,opcode:2}),b+=262144}_write(w,{compressed:b,opcode:D}){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",w);let L=2;w.byteLength<126?L+=0:w.byteLength<2**16?L+=2:L+=8;const N=k.VSBuffer.alloc(L),F=b?64:0,x=D&15;if(N.writeUInt8(128|F|x,0),w.byteLength<126)N.writeUInt8(w.byteLength,1);else if(w.byteLength<2**16){N.writeUInt8(126,1);let X=1;N.writeUInt8(w.byteLength>>>8&255,++X),N.writeUInt8(w.byteLength>>>0&255,++X)}else{N.writeUInt8(127,1);let X=1;N.writeUInt8(0,++X),N.writeUInt8(0,++X),N.writeUInt8(0,++X),N.writeUInt8(0,++X),N.writeUInt8(w.byteLength>>>24&255,++X),N.writeUInt8(w.byteLength>>>16&255,++X),N.writeUInt8(w.byteLength>>>8&255,++X),N.writeUInt8(w.byteLength>>>0&255,++X)}this.socket.write(k.VSBuffer.concat([N,w]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(w){if(w.byteLength!==0){for(this._incomingData.acceptChunk(w);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const b=this._incomingData.peek(this._state.readLen),D=b.readUInt8(0),L=(D&128)>>>7,N=(D&64)>>>6,F=D&15,x=b.readUInt8(1),X=(x&128)>>>7,B=x&127;this._state.state=2,this._state.readLen=2+(X?4:0)+(B===126?2:0)+(B===127?8:0),this._state.fin=L,this._state.firstFrameOfMessage&&(this._state.compressed=!!N),this._state.firstFrameOfMessage=!!L,this._state.mask=0,this._state.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,opcode:this._state.opcode})}else if(this._state.state===2){const b=this._incomingData.read(this._state.readLen),D=b.readUInt8(1),L=(D&128)>>>7;let N=D&127,F=1;N===126?N=b.readUInt8(++F)*2**8+b.readUInt8(++F):N===127&&(N=b.readUInt8(++F)*0+b.readUInt8(++F)*0+b.readUInt8(++F)*0+b.readUInt8(++F)*0+b.readUInt8(++F)*2**24+b.readUInt8(++F)*2**16+b.readUInt8(++F)*2**8+b.readUInt8(++F));let x=0;L&&(x=b.readUInt8(++F)*2**24+b.readUInt8(++F)*2**16+b.readUInt8(++F)*2**8+b.readUInt8(++F)),this._state.state=3,this._state.readLen=N,this._state.mask=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask,opcode:this._state.opcode})}else if(this._state.state===3){const b=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",b),t(b,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",b),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._state.opcode<=2?this._flowManager.acceptFrame(b,this._state.compressed,!!this._state.fin):this._state.opcode===9&&this._flowManager.writeMessage(b,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await P.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=h;class m extends d.Disposable{get permessageDeflate(){return!!(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:k.VSBuffer.alloc(0)}constructor(w,b,D,L,N,F){super(),this._tracer=w,this._onData=N,this._writeFn=F,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingReadQueue=this._register(new P.Emitter),this.onDidFinishProcessingReadQueue=this._onDidFinishProcessingReadQueue.event,this._onDidFinishProcessingWriteQueue=this._register(new P.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,b?(this._zlibInflateStream=this._register(new f(this._tracer,L,D,{windowBits:15})),this._zlibDeflateStream=this._register(new S(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(x=>this._onError.fire(x))),this._register(this._zlibDeflateStream.onError(x=>this._onError.fire(x)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}writeMessage(w,b){this._writeQueue.push({data:w,options:b}),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const{data:w,options:b}=this._writeQueue.shift();if(this._zlibDeflateStream&&b.compressed){const D=await this._deflateMessage(this._zlibDeflateStream,w);this._writeFn(D,b)}else this._writeFn(w,{...b,compressed:!1})}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(w,b){return new Promise((D,L)=>{w.write(b),w.flush(N=>D(N))})}acceptFrame(w,b,D){this._readQueue.push({data:w,isCompressed:b,isLastFrameOfMessage:D}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const w=this._readQueue.shift();if(this._zlibInflateStream&&w.isCompressed){const b=await this._inflateFrame(this._zlibInflateStream,w.data,w.isLastFrameOfMessage);this._onData.fire(b)}else this._onData.fire(w.data)}this._isProcessingReadQueue=!1,this._onDidFinishProcessingReadQueue.fire()}}isProcessingReadQueue(){return this._isProcessingReadQueue}_inflateFrame(w,b,D){return new Promise((L,N)=>{w.write(b),D&&w.write(k.VSBuffer.fromByteArray([0,0,255,255])),w.flush(F=>L(F))})}}class f extends d.Disposable{get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.concat(this._recordedInflateBytes):k.VSBuffer.alloc(0)}constructor(w,b,D,L){super(),this._tracer=w,this._recordInflateBytes=b,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=(0,O.createInflateRaw)(L),this._zlibInflate.on("error",N=>{this._tracer.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this._onError.fire(N)}),this._zlibInflate.on("data",N=>{this._tracer.traceSocketEvent("zlibInflateData",N),this._pendingInflateData.push(k.VSBuffer.wrap(N))}),D&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this._zlibInflate.write(D.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}write(w){this._recordInflateBytes&&this._recordedInflateBytes.push(w.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",w),this._zlibInflate.write(w.buffer)}flush(w){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const b=k.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,w(b)})}}class S extends d.Disposable{constructor(w,b){super(),this._tracer=w,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=(0,O.createDeflateRaw)({windowBits:15}),this._zlibDeflate.on("error",D=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this._onError.fire(D)}),this._zlibDeflate.on("data",D=>{this._tracer.traceSocketEvent("zlibDeflateData",D),this._pendingDeflateData.push(k.VSBuffer.wrap(D))})}write(w){this._tracer.traceSocketEvent("zlibDeflateWrite",w.buffer),this._zlibDeflate.write(w.buffer)}flush(w){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let b=k.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,b=b.slice(0,b.byteLength-4),w(b)})}}function t(I,w){if(w===0)return;const b=I.byteLength>>>2;for(let X=0;X<b;X++){const B=I.readUInt32BE(X*4);I.writeUInt32BE(B^w,X*4)}const D=b*4,L=I.byteLength-D,N=w>>>24&255,F=w>>>16&255,x=w>>>8&255;L>=1&&I.writeUInt8(I.readUInt8(D)^N,D),L>=2&&I.writeUInt8(I.readUInt8(D+1)^F,D+1),L>=3&&I.writeUInt8(I.readUInt8(D+2)^x,D+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const r={2:107,1:103};function n(){const I=(0,v.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${I}-sock`;const w=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,A.tmpdir)(),b=(0,C.join)(w,`vscode-ipc-${I}.sock`);return i(b),b}function s(I,w,b){const L=(0,_.createHash)("sha256").update(I).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${b}-${w}-sock`;const N=b.substr(0,4),F=w.substr(0,6);let x;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?x=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${L}-${N}-${F}.sock`):x=(0,C.join)(I,`${N}-${F}.sock`),i(x),x}function i(I){const w=r[E.platform];typeof w=="number"&&I.length>=w&&console.warn(`WARNING: IPC handle "${I}" is longer than ${w} chars, try a shorter --user-data-dir`)}class o extends l.IPCServer{static toClientConnectionEvent(w){const b=P.Event.fromNodeEventEmitter(w,"connection");return P.Event.map(b,D=>({protocol:new c.Protocol(new p(D,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(D,"close"))}))}constructor(w){super(o.toClientConnectionEvent(w)),this.server=w}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function a(I){return new Promise((w,b)=>{const D=(0,U.createServer)();D.on("error",b),D.listen(I,()=>{D.removeListener("error",b),w(new o(D))})})}function y(I,w){return new Promise((b,D)=>{const L=(0,U.createConnection)(I,()=>{L.removeListener("error",D),b(c.Client.fromSocket(new p(L,`ipc-client${w}`),w))});L.once("error",D)})}}),define(ae[271],ce([0,1,64,123,218]),function(ne,e,_,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{supports(O){return!0}connect({host:O,port:k},R,P,d){return new Promise((C,E)=>{const v=_.createConnection({host:O,port:k},()=>{v.removeListener("error",E),v.write((0,A.makeRawSocketHeaders)(R,P,d));const l=c=>{c.toString().indexOf(`\r
\r
`)>=0&&(v.off("data",l),C(new U.NodeSocket(v,d)))};v.on("data",l)});v.setNoDelay(!0),v.once("error",E)})}}}),define(ae[272],ce([0,1,64,37,133,123,6,2,5,21,9,24,220,103,105,78,15]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=e.NodeRemoteTunnel=void 0;async function u(t,r,n,s,i){let o;for(let a=3;a&&(o?.dispose(),o=await new h(t,r,n,s,i).waitForReady(),!(i&&A.BROWSER_RESTRICTED_PORTS[i]||!A.BROWSER_RESTRICTED_PORTS[o.tunnelLocalPort]));a--);return o}class h extends R.Disposable{constructor(r,n,s,i,o){super(),this.defaultTunnelHost=n,this.suggestedLocalPort=o,this.privacy=p.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=r,this._server=_.createServer(),this._barrier=new k.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=a=>this._onConnection(a),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(n=>{n()})}async waitForReady(){const r=this.suggestedLocalPort??this.tunnelRemotePort,n=(0,p.isAllInterfaces)(this.defaultTunnelHost)?"0.0.0.0":"127.0.0.1";let s=await(0,A.findFreePortFaster)(r,2,1e3,n),i=null;return this._server.listen(s,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address(),i||(s=0,this._server.listen(s,this.defaultTunnelHost),await this._barrier.wait(),i=this._server.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async _onConnection(r){r.pause();const n=(0,p.isLocalhost)(this.tunnelRemoteHost)||(0,p.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,v.connectRemoteAgentTunnel)(this._options,n,this.tunnelRemotePort),i=s.getSocket(),o=s.readEntireBuffer();s.dispose(),o.byteLength>0&&r.write(o.buffer),r.on("end",()=>{r.localAddress&&this._socketsDispose.delete(r.localAddress),i.end()}),r.on("close",()=>i.end()),r.on("error",()=>{r.localAddress&&this._socketsDispose.delete(r.localAddress),i instanceof O.NodeSocket?i.socket.destroy():i.end()}),i instanceof O.NodeSocket?this._mirrorNodeSocket(r,i):this._mirrorGenericSocket(r,i),r.localAddress&&this._socketsDispose.set(r.localAddress,()=>{r.end(),i.end()})}_mirrorGenericSocket(r,n){n.onClose(()=>r.destroy()),n.onEnd(()=>r.end()),n.onData(s=>r.write(s.buffer)),r.on("data",s=>n.write(g.VSBuffer.wrap(s))),r.resume()}_mirrorNodeSocket(r,n){const s=n.socket;s.on("end",()=>r.end()),s.on("close",()=>r.end()),s.on("error",()=>{r.destroy()}),s.pipe(r),r.pipe(s)}}e.NodeRemoteTunnel=h;let m=class extends p.AbstractTunnelService{constructor(r,n,s,i,o){super(n,o),this.remoteSocketFactoryService=r,this.signService=s,this.productService=i}isPortPrivileged(r){return(0,p.isPortPrivileged)(r,this.defaultTunnelHost,P.OS,U.release())}retainOrCreateTunnel(r,n,s,i,o,a,y,I){const w=this.getTunnelFromMap(n,s);if(w)return++w.refcount,w.value;if((0,p.isTunnelProvider)(r))return this.createWithProvider(r,n,s,o,a,y,I);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${o}.`);const b={commit:this.productService.commit,quality:this.productService.quality,addressProvider:r,remoteSocketFactoryService:this.remoteSocketFactoryService,signService:this.signService,logService:this.logService,ipcLogger:null},D=u(b,i,n,s,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(n,s,D),D}}};e.BaseTunnelService=m,e.BaseTunnelService=m=Ce([K(0,l.IRemoteSocketFactoryService),K(1,C.ILogService),K(2,c.ISignService),K(3,E.IProductService),K(4,d.IConfigurationService)],m);let f=class extends m{constructor(r,n,s,i,o){super(r,n,s,i,o)}};e.TunnelService=f,e.TunnelService=f=Ce([K(0,l.IRemoteSocketFactoryService),K(1,C.ILogService),K(2,c.ISignService),K(3,E.IProductService),K(4,d.IConfigurationService)],f);let S=class extends R.Disposable{constructor(r,n,s,i,o){super(),this.remoteSocketFactoryService=r,this.logService=n,this.productService=s,this.signService=i,this.configurationService=o,this._tunnelServices=new Map}async openTunnel(r,n,s,i,o,a,y,I,w){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${i} on local port ${a}.`),!this._tunnelServices.has(r)){const b=new f(this.remoteSocketFactoryService,this.logService,this.signService,this.productService,this.configurationService);this._register(b),this._tunnelServices.set(r,b),b.onTunnelClosed(async()=>{(await b.tunnels).length===0&&(b.dispose(),this._tunnelServices.delete(r))})}return this._tunnelServices.get(r).openTunnel(n,s,i,o,a,y,I,w)}};e.SharedTunnelsService=S,e.SharedTunnelsService=S=Ce([K(0,l.IRemoteSocketFactoryService),K(1,C.ILogService),K(2,E.IProductService),K(3,c.ISignService),K(4,d.IConfigurationService)],S)}),define(ae[280],ce([0,1,37,38,7,2,23,8,17,3,42,151,212,213,203,204,270,193,195,21,217,94,228,95,223,16,114,254,29,107,194,113,96,12,206,207,72,4,202,74,75,234,9,208,100,24,59,19,106,22,108,109,110,49,237,82,111,25,80,262,267,247,83,261,265,266,122,60,260,248,105,227,78,272,222,238,28,239,5,240,196,215,214,81,253,18,52,211,58,259,236,249,104,264,255,10,209,99,257,252,224,190,57,210,268,256,56,258,103,271,187,225,147,140,145]),function(ne,e,_,U,A,O,k,R,P,d,C,E,v,l,c,p,g,u,h,m,f,S,t,r,n,s,i,o,a,y,I,w,b,D,L,N,F,x,X,B,Y,z,H,V,q,ie,re,ue,te,j,W,T,M,$,Q,G,ee,Z,J,se,he,ge,de,me,Ee,we,Pe,_e,le,Se,ve,De,Le,Ne,Te,xe,Me,$e,We,Oe,oe,fe,pe,ye,Ie,Re,ke,Ue,ze,qe,Fe,Ke,Be,Ze,tt,It,bt,gt,Pt,Dt,Rt,Lt,_t,kt,Tt,At,mt,Ot,St,Ut,Nt,st,Mt,Ft,vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=pt;class xt extends O.Disposable{constructor(be){super(),this.configuration=be,this.server=this._register(new E.Server(this)),this.lifecycleService=void 0,this.onDidWindowConnectRaw=this._register(new d.Emitter),this.registerListeners()}registerListeners(){let be=!1;const Ae=()=>{be||(be=!0,this.lifecycleService?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ae),(0,E.once)(process.parentPort,st.SharedProcessLifecycle.exit,Ae)}async init(){const be=await this.initServices();(0,Z.registerConfiguration)(),be.invokeFunction(Ae=>{const Ve=Ae.get(H.ILogService),je=Ae.get(j.ITelemetryService),Ye=Ae.get(Re.IUserDataProfilesService);Ve.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ae),this.registerErrorHandler(Ve),this.reportProfilesInfo(je,Ye),this._register(Ye.onDidChangeProfiles(()=>this.reportProfilesInfo(je,Ye))),this.reportClientOSInfo(je,Ve)}),this._register((0,O.combinedDisposable)(be.createInstance(v.CodeCacheCleaner,this.configuration.codeCachePath),be.createInstance(l.LanguagePackCachedDataCleaner),be.createInstance(g.UnusedWorkspaceStorageDataCleaner),be.createInstance(p.LogsDataCleaner),be.createInstance(c.LocalizationsUpdater),be.createInstance(tt.ExtensionsContributions),be.createInstance(Ke.UserDataProfilesCleaner)))}async initServices(){const be=new B.ServiceCollection,Ae={_serviceBrand:void 0,...q.default};be.set(ie.IProductService,Ae);const Ve=new C.StaticRouter(Ge=>Ge==="main"),je=new mt.MainProcessService(this.server,Ve);be.set(mt.IMainProcessService,je);const Ye=this.configuration.policiesData?new Ue.PolicyChannelClient(this.configuration.policiesData,je.getChannel("policy")):new ze.NullPolicyService;be.set(ze.IPolicyService,Ye);const He=new Nt.NativeEnvironmentService(this.configuration.args,Ae);be.set(s.INativeEnvironmentService,He);const et=new V.LoggerChannelClient(void 0,this.configuration.logLevel,He.logsHome,this.configuration.loggers.map(Ge=>({...Ge,resource:R.URI.revive(Ge.resource)})),je.getChannel("logger"));be.set(H.ILoggerService,et);const ot=this._register(et.createLogger("sharedprocess",{name:(0,It.localize)(0,null)})),ut=this._register(new H.ConsoleLogger(ot.getLevel())),Je=this._register(new bt.LogService(ot,[ut]));be.set(H.ILogService,Je),this.lifecycleService=this._register(new gt.SharedProcessLifecycleService(Je)),be.set(gt.ISharedProcessLifecycleService,this.lifecycleService);const Xe=this._register(new L.FileService(Je));be.set(D.IFileService,Xe);const ht=this._register(new N.DiskFileSystemProvider(Je));Xe.registerProvider(k.Schemas.file,ht);const at=new $e.UriIdentityService(Xe);be.set(Me.IUriIdentityService,at);const Qe=this._register(new qe.UserDataProfilesService(this.configuration.profiles.all,R.URI.revive(this.configuration.profiles.home).with({scheme:He.userRoamingDataHome.scheme}),je.getChannel("userDataProfiles")));be.set(Re.IUserDataProfilesService,Qe);const dt=this._register(new Oe.FileUserDataProvider(k.Schemas.file,this._register(new oe.DiskFileSystemProviderClient(je.getChannel(oe.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:We.isLinux})),k.Schemas.vscodeUserData,Qe,at,Je));Xe.registerProvider(k.Schemas.vscodeUserData,dt);const it=this._register(new f.ConfigurationService(Qe.defaultProfile.settingsResource,Xe,Ye,Je));be.set(m.IConfigurationService,it);const ft=new Ot.RemoteStorageService(void 0,{defaultProfile:Qe.defaultProfile,currentProfile:Qe.defaultProfile},je,He);be.set(ue.IStorageService,ft),this._register((0,O.toDisposable)(()=>ft.flush())),await Promise.all([it.initialize(),ft.initialize()]);const yt=new Rt.RequestChannelClient(je.getChannel("request"));be.set(re.IRequestService,yt),be.set(u.IChecksumService,new F.SyncDescriptor(h.ChecksumService,void 0,!1)),be.set(pe.IV8InspectProfilingService,new F.SyncDescriptor(fe.InspectProfilingService,void 0,!1));const Et=new kt.NativeHostService(-1,je);be.set(_t.INativeHostService,Et),be.set(r.IDownloadService,new F.SyncDescriptor(n.DownloadService,void 0,!0));const Wt=this._register(new Se.ActiveWindowManager(Et)),qt=new C.StaticRouter(Ge=>Wt.getActiveClientId().then(lt=>Ge===lt));be.set(b.IExtensionRecommendationNotificationService,new Lt.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",qt)));let ct;const nt=[],wt=(0,$.isInternalTelemetry)(Ae,it);if((0,$.supportsTelemetry)(Ae,He)){const Ge=new T.TelemetryLogAppender(Je,et,He,Ae);if(nt.push(Ge),!(0,$.isLoggingOnly)(Ae,He)&&Ae.aiConfig?.ariaKey){const lt=new Fe.OneDataSystemAppender(yt,wt,"monacoworkbench",null,Ae.aiConfig.ariaKey);this._register((0,O.toDisposable)(()=>lt.flush())),nt.push(lt)}ct=new M.TelemetryService({appenders:nt,commonProperties:(0,te.resolveCommonProperties)((0,_.release)(),(0,_.hostname)(),process.arch,Ae.commit,Ae.version,this.configuration.machineId,this.configuration.sqmId,wt),sendErrorTelemetry:!0,piiPaths:(0,$.getPiiPathsFromEnvironment)(He)},it,Ae)}else{ct=$.NullTelemetryService;const Ge=$.NullAppender;nt.push(Ge)}this.server.registerChannel("telemetryAppender",new W.TelemetryAppenderChannel(nt)),be.set(j.ITelemetryService,ct);const jt=new Q.CustomEndpointTelemetryService(it,ct,Je,et,He,Ae);be.set(j.ICustomEndpointTelemetryService,jt),be.set(ke.IExtensionsProfileScannerService,new F.SyncDescriptor(Dt.ExtensionsProfileScannerService,void 0,!0)),be.set(ye.IExtensionsScannerService,new F.SyncDescriptor(Ie.ExtensionsScannerService,void 0,!0)),be.set(y.IExtensionSignatureVerificationService,new F.SyncDescriptor(y.ExtensionSignatureVerificationService,void 0,!0)),be.set(w.INativeServerExtensionManagementService,new F.SyncDescriptor(w.ExtensionManagementService,void 0,!0)),be.set(a.IExtensionGalleryService,new F.SyncDescriptor(o.ExtensionGalleryService,void 0,!0)),be.set(a.IExtensionTipsService,new F.SyncDescriptor(At.ExtensionTipsService,void 0,!1)),be.set(Y.ILanguagePackService,new F.SyncDescriptor(z.NativeLanguagePackService,void 0,!1)),be.set(S.IDiagnosticsService,new F.SyncDescriptor(t.DiagnosticsService,void 0,!1)),be.set(J.IUserDataSyncAccountService,new F.SyncDescriptor(J.UserDataSyncAccountService,void 0,!0)),be.set(Z.IUserDataSyncLogService,new F.SyncDescriptor(ge.UserDataSyncLogService,void 0,!0)),be.set(Z.IUserDataSyncUtilService,C.ProxyChannel.toService(this.server.getChannel("userDataSyncUtil",Ge=>Ge.ctx!=="main"))),be.set(a.IGlobalExtensionEnablementService,new F.SyncDescriptor(i.GlobalExtensionEnablementService,void 0,!1)),be.set(ee.IIgnoredExtensionsManagementService,new F.SyncDescriptor(ee.IgnoredExtensionsManagementService,void 0,!0)),be.set(G.IExtensionStorageService,new F.SyncDescriptor(G.ExtensionStorageService)),be.set(Z.IUserDataSyncStoreManagementService,new F.SyncDescriptor(Pe.UserDataSyncStoreManagementService,void 0,!0)),be.set(Z.IUserDataSyncStoreService,new F.SyncDescriptor(Pe.UserDataSyncStoreService,void 0,!0)),be.set(de.IUserDataSyncMachinesService,new F.SyncDescriptor(de.UserDataSyncMachinesService,void 0,!0)),be.set(Z.IUserDataSyncLocalStoreService,new F.SyncDescriptor(se.UserDataSyncLocalStoreService,void 0,!1)),be.set(Z.IUserDataSyncEnablementService,new F.SyncDescriptor(me.UserDataSyncEnablementService,void 0,!0)),be.set(Z.IUserDataSyncService,new F.SyncDescriptor(Ee.UserDataSyncService,void 0,!1)),be.set(_e.IUserDataProfileStorageService,new F.SyncDescriptor(le.NativeUserDataProfileStorageService,void 0,!0)),be.set(Z.IUserDataSyncResourceProviderService,new F.SyncDescriptor(Ze.UserDataSyncResourceProviderService,void 0,!0)),be.set(ve.ISignService,new F.SyncDescriptor(De.SignService,void 0,!1));const Ct=new St.RemoteSocketFactoryService;return be.set(St.IRemoteSocketFactoryService,Ct),Ct.register(0,Ut.nodeSocketFactory),be.set(Le.ISharedTunnelsService,new F.SyncDescriptor(Ne.SharedTunnelsService)),be.set(Te.ISharedProcessTunnelService,new F.SyncDescriptor(xe.SharedProcessTunnelService)),be.set(Be.IRemoteTunnelService,new F.SyncDescriptor(Pt.RemoteTunnelService)),new X.InstantiationService(be)}initChannels(be){const Ae=new I.ExtensionManagementChannel(be.get(a.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ae);const Ve=C.ProxyChannel.fromService(be.get(Y.ILanguagePackService),this._store);this.server.registerChannel("languagePacks",Ve);const je=C.ProxyChannel.fromService(be.get(S.IDiagnosticsService),this._store);this.server.registerChannel("diagnostics",je);const Ye=new I.ExtensionTipsChannel(be.get(a.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ye);const He=C.ProxyChannel.fromService(be.get(u.IChecksumService),this._store);this.server.registerChannel("checksum",He);const et=C.ProxyChannel.fromService(be.get(pe.IV8InspectProfilingService),this._store);this.server.registerChannel("v8InspectProfiling",et);const ot=C.ProxyChannel.fromService(be.get(de.IUserDataSyncMachinesService),this._store);this.server.registerChannel("userDataSyncMachines",ot);const ut=C.ProxyChannel.fromService(be.get(j.ICustomEndpointTelemetryService),this._store);this.server.registerChannel("customEndpointTelemetry",ut);const Je=new he.UserDataSyncAccountServiceChannel(be.get(J.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Je);const Xe=new he.UserDataSyncStoreManagementServiceChannel(be.get(Z.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Xe);const ht=new we.UserDataSyncServiceChannel(be.get(Z.IUserDataSyncService),be.get(Re.IUserDataProfilesService),be.get(H.ILogService));this.server.registerChannel("userDataSync",ht);const at=this._register(be.get(x.IInstantiationService).createInstance(Tt.UserDataAutoSyncService));this.server.registerChannel("userDataAutoSync",C.ProxyChannel.fromService(at,this._store)),this.server.registerChannel("IUserDataSyncResourceProviderService",C.ProxyChannel.fromService(be.get(Z.IUserDataSyncResourceProviderService),this._store));const Qe=C.ProxyChannel.fromService(be.get(Te.ISharedProcessTunnelService),this._store);this.server.registerChannel(Te.ipcSharedProcessTunnelChannelName,Qe);const dt=C.ProxyChannel.fromService(be.get(Be.IRemoteTunnelService),this._store);this.server.registerChannel("remoteTunnel",dt)}registerErrorHandler(be){process.on("uncaughtException",Ae=>(0,A.onUnexpectedError)(Ae)),process.on("unhandledRejection",Ae=>(0,A.onUnexpectedError)(Ae)),(0,A.setUnexpectedErrorHandler)(Ae=>{const Ve=(0,U.toErrorMessage)(Ae,!0);Ve&&be.error(`[uncaught exception in sharedProcess]: ${Ve}`)})}reportProfilesInfo(be,Ae){be.publicLog2("profilesInfo",{count:Ae.profiles.length})}async reportClientOSInfo(be,Ae){if(We.isLinux){const[Ve,je]=await Promise.all([(0,Mt.getOSReleaseInfo)(Ae.error.bind(Ae)),(0,vt.getDisplayProtocol)(Ae.error.bind(Ae))]),Ye=(0,Ft.getDesktopEnvironment)(),He=(0,vt.getCodeDisplayProtocol)(je,this.configuration.args["ozone-platform"]);Ve&&be.publicLog2("clientPlatformInfo",{platformId:Ve.id,platformVersionId:Ve.version_id,platformIdLike:Ve.id_like,desktopEnvironment:Ye,displayProtocol:je,codeDisplayProtocol:He})}}handledClientConnection(be){if(be.data!==st.SharedProcessRawConnection.response)return!1;const Ae=(0,P.firstOrDefault)(be.ports);return Ae?(this.onDidWindowConnectRaw.fire(Ae),!0):!1}}async function pt(rt){try{const be=new xt(rt);process.parentPort.postMessage(st.SharedProcessLifecycle.ipcReady),await be.init(),process.parentPort.postMessage(st.SharedProcessLifecycle.initDone)}catch(be){process.parentPort.postMessage({error:be.toString()})}}const $t=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",rt=>{clearTimeout($t),pt(rt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a045dcfceda27f896936bfd8cbf524f6a93a2f46/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
