/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var de=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/base/common/path","vs/base/common/uri","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/types","vs/nls!vs/platform/terminal/node/ptyHostMain","vs/base/common/async","vs/base/common/strings","vs/nls","vs/base/common/decorators","vs/base/common/process","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/network","os","vs/platform/instantiation/common/instantiation","vs/base/common/lazy","vs/base/common/resources","vs/base/node/pfs","vs/base/common/map","child_process","vs/base/parts/ipc/common/ipc","vs/platform/terminal/common/terminal","vs/base/common/functional","vs/base/common/objects","vs/base/parts/sandbox/node/electronTypes","vs/base/common/extpath","vs/base/common/processes","vs/base/node/processes","vs/platform/contextkey/common/contextkey","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/childProcessMonitor","vs/platform/terminal/node/terminalEnvironment","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/hash","vs/base/common/symbols","vs/base/common/ternarySearchTree","vs/base/common/uuid","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/terminal/node/ptyService","vs/nls!vs/platform/terminal/node/terminalProcess","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/files/common/files","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/registry/common/platform","vs/platform/terminal/common/capabilities/bufferMarkCapability","vs/platform/terminal/common/capabilities/commandDetection/promptInputModel","vs/platform/terminal/common/capabilities/commandDetection/terminalCommand","vs/platform/terminal/common/capabilities/commandDetectionCapability","vs/platform/terminal/common/capabilities/cwdDetectionCapability","vs/platform/terminal/common/capabilities/partialCommandDetectionCapability","vs/platform/terminal/common/capabilities/terminalCapabilityStore","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalAutoResponder","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/common/terminalProcess","vs/platform/terminal/common/terminalStrings","vs/platform/terminal/common/xterm/shellIntegrationAddon","vs/platform/terminal/node/heartbeatService","vs/platform/terminal/node/windowsShellHelper","vs/platform/terminal/node/terminalProcess","vs/platform/terminal/node/ptyService","fs","util","minimist","node-pty","@xterm/headless","vs/base/common/performance","vs/platform/terminal/node/ptyHostMain"],me=function(ae){for(var e=[],v=0,D=ae.length;v<D;v++)e[v]=de[ae[v]];return e};define(de[40],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MonotonousArray=void 0,e.findLast=v,e.findLastIdx=D,e.findLastMonotonous=E,e.findLastIdxMonotonous=A,e.findFirstMonotonous=T,e.findFirstIdxMonotonousOrArrLen=P,e.findFirstIdxMonotonous=h,e.findFirstMax=w,e.findLastMax=c,e.findFirstMin=b,e.findMaxIdx=o,e.mapFindFirst=a;function v(g,d){const n=D(g,d);if(n!==-1)return g[n]}function D(g,d,n=g.length-1){for(let r=n;r>=0;r--){const f=g[r];if(d(f))return r}return-1}function E(g,d){const n=A(g,d);return n===-1?void 0:g[n]}function A(g,d,n=0,r=g.length){let f=n,C=r;for(;f<C;){const i=Math.floor((f+C)/2);d(g[i])?f=i+1:C=i}return f-1}function T(g,d){const n=P(g,d);return n===g.length?void 0:g[n]}function P(g,d,n=0,r=g.length){let f=n,C=r;for(;f<C;){const i=Math.floor((f+C)/2);d(g[i])?C=i:f=i+1}return f}function h(g,d,n=0,r=g.length){const f=P(g,d,n,r);return f===g.length?-1:f}class s{static{this.assertInvariants=!1}constructor(d){this._array=d,this._findLastMonotonousLastIdx=0}findLastMonotonous(d){if(s.assertInvariants){if(this._prevFindLastPredicate){for(const r of this._array)if(this._prevFindLastPredicate(r)&&!d(r))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this._prevFindLastPredicate=d}const n=A(this._array,d,this._findLastMonotonousLastIdx);return this._findLastMonotonousLastIdx=n+1,n===-1?void 0:this._array[n]}}e.MonotonousArray=s;function w(g,d){if(g.length===0)return;let n=g[0];for(let r=1;r<g.length;r++){const f=g[r];d(f,n)>0&&(n=f)}return n}function c(g,d){if(g.length===0)return;let n=g[0];for(let r=1;r<g.length;r++){const f=g[r];d(f,n)>=0&&(n=f)}return n}function b(g,d){return w(g,(n,r)=>-d(n,r))}function o(g,d){if(g.length===0)return-1;let n=0;for(let r=1;r<g.length;r++){const f=g[r];d(f,g[n])>0&&(n=r)}return n}function a(g,d){for(const n of g){const r=d(n);if(r!==void 0)return r}}}),define(de[41],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.groupBy=v,e.diffSets=D,e.diffMaps=E,e.intersection=A;function v(T,P){const h=Object.create(null);for(const s of T){const w=P(s);let c=h[w];c||(c=h[w]=[]),c.push(s)}return h}function D(T,P){const h=[],s=[];for(const w of T)P.has(w)||h.push(w);for(const w of P)T.has(w)||s.push(w);return{removed:h,added:s}}function E(T,P){const h=[],s=[];for(const[w,c]of T)P.has(w)||h.push(c);for(const[w,c]of P)T.has(w)||s.push(c);return{removed:h,added:s}}function A(T,P){const h=new Set;for(const s of P)T.has(s)&&h.add(s);return h}}),define(de[14],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.memoize=D,e.debounce=E,e.throttle=A;function v(T){return(P,h,s)=>{let w=null,c=null;if(typeof s.value=="function"?(w="value",c=s.value):typeof s.get=="function"&&(w="get",c=s.get),!c)throw new Error("not supported");s[w]=T(c,h)}}function D(T,P,h){let s=null,w=null;if(typeof h.value=="function"?(s="value",w=h.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(s="get",w=h.get),!w)throw new Error("not supported");const c=`$memoize$${P}`;h[s]=function(...b){return this.hasOwnProperty(c)||Object.defineProperty(this,c,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,b)}),this[c]}}function E(T,P,h){return v((s,w)=>{const c=`$debounce$${w}`,b=`$debounce$result$${w}`;return function(...o){this[b]||(this[b]=h?h():void 0),clearTimeout(this[c]),P&&(this[b]=P(this[b],...o),o=[this[b]]),this[c]=setTimeout(()=>{s.apply(this,o),this[b]=h?h():void 0},T)}})}function A(T,P,h){return v((s,w)=>{const c=`$throttle$timer$${w}`,b=`$throttle$result$${w}`,o=`$throttle$lastRun$${w}`,a=`$throttle$pending$${w}`;return function(...g){if(this[b]||(this[b]=h?h():void 0),(this[o]===null||this[o]===void 0)&&(this[o]=-Number.MAX_VALUE),P&&(this[b]=P(this[b],...g)),this[a])return;const d=this[o]+T;d<=Date.now()?(this[o]=Date.now(),s.apply(this,[this[b]]),this[b]=h?h():void 0):(this[a]=!0,this[c]=setTimeout(()=>{this[a]=!1,this[o]=Date.now(),s.apply(this,[this[b]]),this[b]=h?h():void 0},d-Date.now()))}})}}),define(de[7],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.ReadonlyError=e.CancellationError=e.errorHandler=e.ErrorHandler=void 0,e.setUnexpectedErrorHandler=D,e.isSigPipeError=E,e.onUnexpectedError=A,e.onUnexpectedExternalError=T,e.transformErrorForSerialization=P,e.isCancellationError=s,e.canceled=c,e.illegalArgument=b,e.illegalState=o,e.getErrorMessage=g;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?f.isErrorNoTelemetry(t)?new f(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(l=>{l(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function D(i){e.errorHandler.setUnexpectedErrorHandler(i)}function E(i){if(!i||typeof i!="object")return!1;const t=i;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function A(i){s(i)||e.errorHandler.onUnexpectedError(i)}function T(i){s(i)||e.errorHandler.onUnexpectedExternalError(i)}function P(i){if(i instanceof Error){const{name:t,message:l}=i,L=i.stacktrace||i.stack;return{$isError:!0,name:t,message:l,stack:L,noTelemetry:f.isErrorNoTelemetry(i)}}return i}const h="Canceled";function s(i){return i instanceof w?!0:i instanceof Error&&i.name===h&&i.message===h}class w extends Error{constructor(){super(h),this.name=this.message}}e.CancellationError=w;function c(){const i=new Error(h);return i.name=i.message,i}function b(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function o(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class a extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.ReadonlyError=a;function g(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class d extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.NotImplementedError=d;class n extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.NotSupportedError=n;class r extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=r;class f extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof f)return t;const l=new f;return l.message=t.message,l.stack=t.stack,l}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.ErrorNoTelemetry=f;class C extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,C.prototype)}}e.BugIndicatingError=C}),define(de[16],me([0,1,7,40]),function(ae,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Permutation=e.CallbackIterable=e.ArrayQueue=e.booleanComparator=e.numberComparator=e.CompareResult=void 0,e.tail=E,e.tail2=A,e.equals=T,e.removeFastWithoutKeepingOrder=P,e.binarySearch=h,e.binarySearch2=s,e.quickSelect=w,e.groupBy=c,e.groupAdjacentBy=b,e.forEachAdjacent=o,e.forEachWithNeighbors=a,e.sortedDiff=g,e.delta=d,e.top=n,e.topAsync=r,e.coalesce=C,e.coalesceInPlace=i,e.move=t,e.isFalsyOrEmpty=l,e.isNonEmptyArray=L,e.distinct=p,e.uniqueFilter=k,e.firstOrDefault=S,e.lastOrDefault=y,e.commonPrefixLength=U,e.flatten=K,e.range=z,e.index=O,e.insert=m,e.remove=R,e.arrayInsert=_,e.shuffle=I,e.pushToStart=G,e.pushToEnd=te,e.pushMany=H,e.mapArrayOrNot=ee,e.asArray=le,e.getRandomElement=ue,e.insertInto=V,e.splice=$,e.compareBy=fe,e.tieBreakComparators=W,e.reverseOrder=u;function E(x,B=0){return x[x.length-(1+B)]}function A(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}function T(x,B,F=(M,j)=>M===j){if(x===B)return!0;if(!x||!B||x.length!==B.length)return!1;for(let M=0,j=x.length;M<j;M++)if(!F(x[M],B[M]))return!1;return!0}function P(x,B){const F=x.length-1;B<F&&(x[B]=x[F]),x.pop()}function h(x,B,F){return s(x.length,M=>F(x[M],B))}function s(x,B){let F=0,M=x-1;for(;F<=M;){const j=(F+M)/2|0,Z=B(j);if(Z<0)F=j+1;else if(Z>0)M=j-1;else return j}return-(F+1)}function w(x,B,F){if(x=x|0,x>=B.length)throw new TypeError("invalid index");const M=B[Math.floor(B.length*Math.random())],j=[],Z=[],re=[];for(const se of B){const he=F(se,M);he<0?j.push(se):he>0?Z.push(se):re.push(se)}return x<j.length?w(x,j,F):x<j.length+re.length?re[0]:w(x-(j.length+re.length),Z,F)}function c(x,B){const F=[];let M;for(const j of x.slice(0).sort(B))!M||B(M[0],j)!==0?(M=[j],F.push(M)):M.push(j);return F}function*b(x,B){let F,M;for(const j of x)M!==void 0&&B(M,j)?F.push(j):(F&&(yield F),F=[j]),M=j;F&&(yield F)}function o(x,B){for(let F=0;F<=x.length;F++)B(F===0?void 0:x[F-1],F===x.length?void 0:x[F])}function a(x,B){for(let F=0;F<x.length;F++)B(F===0?void 0:x[F-1],x[F],F+1===x.length?void 0:x[F+1])}function g(x,B,F){const M=[];function j(se,he,pe){if(he===0&&pe.length===0)return;const _e=M[M.length-1];_e&&_e.start+_e.deleteCount===se?(_e.deleteCount+=he,_e.toInsert.push(...pe)):M.push({start:se,deleteCount:he,toInsert:pe})}let Z=0,re=0;for(;;){if(Z===x.length){j(Z,0,B.slice(re));break}if(re===B.length){j(Z,x.length-Z,[]);break}const se=x[Z],he=B[re],pe=F(se,he);pe===0?(Z+=1,re+=1):pe<0?(j(Z,1,[]),Z+=1):pe>0&&(j(Z,0,[he]),re+=1)}return M}function d(x,B,F){const M=g(x,B,F),j=[],Z=[];for(const re of M)j.push(...x.slice(re.start,re.start+re.deleteCount)),Z.push(...re.toInsert);return{removed:j,added:Z}}function n(x,B,F){if(F===0)return[];const M=x.slice(0,F).sort(B);return f(x,B,M,F,x.length),M}function r(x,B,F,M,j){return F===0?Promise.resolve([]):new Promise((Z,re)=>{(async()=>{const se=x.length,he=x.slice(0,F).sort(B);for(let pe=F,_e=Math.min(F+M,se);pe<se;pe=_e,_e=Math.min(_e+M,se)){if(pe>F&&await new Promise(we=>setTimeout(we)),j&&j.isCancellationRequested)throw new v.CancellationError;f(x,B,he,pe,_e)}return he})().then(Z,re)})}function f(x,B,F,M,j){for(const Z=F.length;M<j;M++){const re=x[M];if(B(re,F[Z-1])<0){F.pop();const se=(0,D.findFirstIdxMonotonousOrArrLen)(F,he=>B(re,he)<0);F.splice(se,0,re)}}}function C(x){return x.filter(B=>!!B)}function i(x){let B=0;for(let F=0;F<x.length;F++)x[F]&&(x[B]=x[F],B+=1);x.length=B}function t(x,B,F){x.splice(F,0,x.splice(B,1)[0])}function l(x){return!Array.isArray(x)||x.length===0}function L(x){return Array.isArray(x)&&x.length>0}function p(x,B=F=>F){const F=new Set;return x.filter(M=>{const j=B(M);return F.has(j)?!1:(F.add(j),!0)})}function k(x){const B=new Set;return F=>{const M=x(F);return B.has(M)?!1:(B.add(M),!0)}}function S(x,B){return x.length>0?x[0]:B}function y(x,B){return x.length>0?x[x.length-1]:B}function U(x,B,F=(M,j)=>M===j){let M=0;for(let j=0,Z=Math.min(x.length,B.length);j<Z&&F(x[j],B[j]);j++)M++;return M}function K(x){return[].concat(...x)}function z(x,B){let F=typeof B=="number"?x:0;typeof B=="number"?F=x:(F=0,B=x);const M=[];if(F<=B)for(let j=F;j<B;j++)M.push(j);else for(let j=F;j>B;j--)M.push(j);return M}function O(x,B,F){return x.reduce((M,j)=>(M[B(j)]=F?F(j):j,M),Object.create(null))}function m(x,B){return x.push(B),()=>R(x,B)}function R(x,B){const F=x.indexOf(B);if(F>-1)return x.splice(F,1),B}function _(x,B,F){const M=x.slice(0,B),j=x.slice(B);return M.concat(F,j)}function I(x,B){let F;if(typeof B=="number"){let M=B;F=()=>{const j=Math.sin(M++)*179426549;return j-Math.floor(j)}}else F=Math.random;for(let M=x.length-1;M>0;M-=1){const j=Math.floor(F()*(M+1)),Z=x[M];x[M]=x[j],x[j]=Z}}function G(x,B){const F=x.indexOf(B);F>-1&&(x.splice(F,1),x.unshift(B))}function te(x,B){const F=x.indexOf(B);F>-1&&(x.splice(F,1),x.push(B))}function H(x,B){for(const F of B)x.push(F)}function ee(x,B){return Array.isArray(x)?x.map(B):B(x)}function le(x){return Array.isArray(x)?x:[x]}function ue(x){return x[Math.floor(Math.random()*x.length)]}function V(x,B,F){const M=Q(x,B),j=x.length,Z=F.length;x.length=j+Z;for(let re=j-1;re>=M;re--)x[re+Z]=x[re];for(let re=0;re<Z;re++)x[re+M]=F[re]}function $(x,B,F,M){const j=Q(x,B);let Z=x.splice(j,F);return Z===void 0&&(Z=[]),V(x,j,M),Z}function Q(x,B){return B<0?Math.max(B+x.length,0):Math.min(B,x.length)}var Y;(function(x){function B(Z){return Z<0}x.isLessThan=B;function F(Z){return Z<=0}x.isLessThanOrEqual=F;function M(Z){return Z>0}x.isGreaterThan=M;function j(Z){return Z===0}x.isNeitherLessOrGreaterThan=j,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(Y||(e.CompareResult=Y={}));function fe(x,B){return(F,M)=>B(x(F),x(M))}function W(...x){return(B,F)=>{for(const M of x){const j=M(B,F);if(!Y.isNeitherLessOrGreaterThan(j))return j}return Y.neitherLessOrGreaterThan}}const ce=(x,B)=>x-B;e.numberComparator=ce;const J=(x,B)=>(0,e.numberComparator)(x?1:0,B?1:0);e.booleanComparator=J;function u(x){return(B,F)=>-x(B,F)}class N{constructor(B){this.items=B,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(B){let F=this.firstIdx;for(;F<this.items.length&&B(this.items[F]);)F++;const M=F===this.firstIdx?null:this.items.slice(this.firstIdx,F);return this.firstIdx=F,M}takeFromEndWhile(B){let F=this.lastIdx;for(;F>=0&&B(this.items[F]);)F--;const M=F===this.lastIdx?null:this.items.slice(F+1,this.lastIdx+1);return this.lastIdx=F,M}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const B=this.items[this.firstIdx];return this.firstIdx++,B}removeLast(){const B=this.items[this.lastIdx];return this.lastIdx--,B}takeCount(B){const F=this.items.slice(this.firstIdx,this.firstIdx+B);return this.firstIdx+=B,F}}e.ArrayQueue=N;class ie{static{this.empty=new ie(B=>{})}constructor(B){this.iterate=B}forEach(B){this.iterate(F=>(B(F),!0))}toArray(){const B=[];return this.iterate(F=>(B.push(F),!0)),B}filter(B){return new ie(F=>this.iterate(M=>B(M)?F(M):!0))}map(B){return new ie(F=>this.iterate(M=>F(B(M))))}some(B){let F=!1;return this.iterate(M=>(F=B(M),!F)),F}findFirst(B){let F;return this.iterate(M=>B(M)?(F=M,!1):!0),F}findLast(B){let F;return this.iterate(M=>(B(M)&&(F=M),!0)),F}findLastMaxBy(B){let F,M=!0;return this.iterate(j=>((M||Y.isGreaterThan(B(j,F)))&&(M=!1,F=j),!0)),F}}e.CallbackIterable=ie;class ne{constructor(B){this._indexMap=B}static createSortPermutation(B,F){const M=Array.from(B.keys()).sort((j,Z)=>F(B[j],B[Z]));return new ne(M)}apply(B){return B.map((F,M)=>B[this._indexMap[M]])}inverse(){const B=this._indexMap.slice();for(let F=0;F<this._indexMap.length;F++)B[this._indexMap[F]]=F;return new ne(B)}}e.Permutation=ne}),define(de[42],me([0,1,7]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=D,e.assertNever=E,e.assert=A,e.softAssert=T,e.assertFn=P,e.checkAdjacentItems=h;function D(s,w){if(!s)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}function E(s,w="Unreachable"){throw new Error(w)}function A(s){if(!s)throw new v.BugIndicatingError("Assertion Failed")}function T(s){s||(0,v.onUnexpectedError)(new v.BugIndicatingError("Soft Assertion Failed"))}function P(s){if(!s()){debugger;s(),(0,v.onUnexpectedError)(new v.BugIndicatingError("Assertion Failed"))}}function h(s,w){let c=0;for(;c<s.length-1;){const b=s[c],o=s[c+1];if(!w(b,o))return!1;c++}return!0}}),define(de[29],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSingleCallFunction=v;function v(D,E){const A=this;let T=!1,P;return function(){if(T)return P;if(T=!0,E)try{P=D.apply(A,arguments)}finally{E()}else P=D.apply(A,arguments);return P}}}),define(de[43],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(D){function E(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}D.is=E;const A=Object.freeze([]);function T(){return A}D.empty=T;function*P(t){yield t}D.single=P;function h(t){return E(t)?t:P(t)}D.wrap=h;function s(t){return t||A}D.from=s;function*w(t){for(let l=t.length-1;l>=0;l--)yield t[l]}D.reverse=w;function c(t){return!t||t[Symbol.iterator]().next().done===!0}D.isEmpty=c;function b(t){return t[Symbol.iterator]().next().value}D.first=b;function o(t,l){for(const L of t)if(l(L))return!0;return!1}D.some=o;function a(t,l){for(const L of t)if(l(L))return L}D.find=a;function*g(t,l){for(const L of t)l(L)&&(yield L)}D.filter=g;function*d(t,l){let L=0;for(const p of t)yield l(p,L++)}D.map=d;function*n(...t){for(const l of t)yield*l}D.concat=n;function r(t,l,L){let p=L;for(const k of t)p=l(p,k);return p}D.reduce=r;function*f(t,l,L=t.length){for(l<0&&(l+=t.length),L<0?L+=t.length:L>t.length&&(L=t.length);l<L;l++)yield t[l]}D.slice=f;function C(t,l=Number.POSITIVE_INFINITY){const L=[];if(l===0)return[L,t];const p=t[Symbol.iterator]();for(let k=0;k<l;k++){const S=p.next();if(S.done)return[L,D.empty()];L.push(S.value)}return[L,{[Symbol.iterator](){return p}}]}D.consume=C;async function i(t){const l=[];for await(const L of t)l.push(L);return Promise.resolve(l)}D.asyncToArray=i})(v||(e.Iterable=v={}))}),define(de[22],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class v{constructor(E){this.executor=E,this._didRun=!1}get hasValue(){return this._didRun}get value(){if(!this._didRun)try{this._value=this.executor()}catch(E){this._error=E}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}e.Lazy=v}),define(de[44],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{static{this.Undefined=new v(void 0)}constructor(A){this.element=A,this.next=v.Undefined,this.prev=v.Undefined}}class D{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let A=this._first;for(;A!==v.Undefined;){const T=A.next;A.prev=v.Undefined,A.next=v.Undefined,A=T}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,T){const P=new v(A);if(this._first===v.Undefined)this._first=P,this._last=P;else if(T){const s=this._last;this._last=P,P.prev=s,s.next=P}else{const s=this._first;this._first=P,P.next=s,s.prev=P}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(P))}}shift(){if(this._first!==v.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==v.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==v.Undefined&&A.next!==v.Undefined){const T=A.prev;T.next=A.next,A.next.prev=T}else A.prev===v.Undefined&&A.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):A.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):A.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==v.Undefined;)yield A.element,A=A.next}}e.LinkedList=D}),define(de[25],me([0,1]),function(ae,e){"use strict";var v,D,E;Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.BidirectionalMap=e.CounterSet=e.MRUCache=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=void 0,e.getOrSet=A,e.mapToString=T,e.setToString=P,e.mapsStrictEqualIgnoreOrder=C;function A(i,t,l){let L=i.get(t);return L===void 0&&(L=l,i.set(t,L)),L}function T(i){const t=[];return i.forEach((l,L)=>{t.push(`${L} => ${l}`)}),`Map(${i.size}) {${t.join(", ")}}`}function P(i){const t=[];return i.forEach(l=>{t.push(l)}),`Set(${i.size}) {${t.join(", ")}}`}class h{constructor(t,l){this.uri=t,this.value=l}}function s(i){return Array.isArray(i)}class w{static{this.defaultToKey=t=>t.toString()}constructor(t,l){if(this[v]="ResourceMap",t instanceof w)this.map=new Map(t.map),this.toKey=l??w.defaultToKey;else if(s(t)){this.map=new Map,this.toKey=l??w.defaultToKey;for(const[L,p]of t)this.set(L,p)}else this.map=new Map,this.toKey=t??w.defaultToKey}set(t,l){return this.map.set(this.toKey(t),new h(t,l)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,l){typeof l<"u"&&(t=t.bind(l));for(const[L,p]of this.map)t(p.value,p.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(v=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=w;class c{constructor(t,l){this[D]="ResourceSet",!t||typeof t=="function"?this._map=new w(t):(this._map=new w(l),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,l){this._map.forEach((L,p)=>t.call(l,p,p,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=c;var b;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class o{constructor(){this[E]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,l=0){const L=this._map.get(t);if(L)return l!==0&&this.touch(L,l),L.value}set(t,l,L=0){let p=this._map.get(t);if(p)p.value=l,L!==0&&this.touch(p,L);else{switch(p={key:t,value:l,next:void 0,previous:void 0},L){case 0:this.addItemLast(p);break;case 1:this.addItemFirst(p);break;case 2:this.addItemLast(p);break;default:this.addItemLast(p);break}this._map.set(t,p),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const l=this._map.get(t);if(l)return this._map.delete(t),this.removeItem(l),this._size--,l.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,l){const L=this._state;let p=this._head;for(;p;){if(l?t.bind(l)(p.value,p.key,this):t(p.value,p.key,this),this._state!==L)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const t=this,l=this._state;let L=this._head;const p={[Symbol.iterator](){return p},next(){if(t._state!==l)throw new Error("LinkedMap got modified during iteration.");if(L){const k={value:L.key,done:!1};return L=L.next,k}else return{value:void 0,done:!0}}};return p}values(){const t=this,l=this._state;let L=this._head;const p={[Symbol.iterator](){return p},next(){if(t._state!==l)throw new Error("LinkedMap got modified during iteration.");if(L){const k={value:L.value,done:!1};return L=L.next,k}else return{value:void 0,done:!0}}};return p}entries(){const t=this,l=this._state;let L=this._head;const p={[Symbol.iterator](){return p},next(){if(t._state!==l)throw new Error("LinkedMap got modified during iteration.");if(L){const k={value:[L.key,L.value],done:!1};return L=L.next,k}else return{value:void 0,done:!0}}};return p}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let l=this._head,L=this.size;for(;l&&L>t;)this._map.delete(l.key),l=l.next,L--;this._head=l,this._size=L,l&&(l.previous=void 0),this._state++}trimNew(t){if(t>=this.size)return;if(t===0){this.clear();return}let l=this._tail,L=this.size;for(;l&&L>t;)this._map.delete(l.key),l=l.previous,L--;this._tail=l,this._size=L,l&&(l.next=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const l=t.next,L=t.previous;if(!l||!L)throw new Error("Invalid list");l.previous=L,L.next=l}t.next=void 0,t.previous=void 0,this._state++}touch(t,l){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(t===this._head)return;const L=t.next,p=t.previous;t===this._tail?(p.next=void 0,this._tail=p):(L.previous=p,p.next=L),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(l===2){if(t===this._tail)return;const L=t.next,p=t.previous;t===this._head?(L.previous=void 0,this._head=L):(L.previous=p,p.next=L),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((l,L)=>{t.push([L,l])}),t}fromJSON(t){this.clear();for(const[l,L]of t)this.set(l,L)}}e.LinkedMap=o;class a extends o{constructor(t,l=1){super(),this._limit=t,this._ratio=Math.min(Math.max(0,l),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,l=2){return super.get(t,l)}peek(t){return super.get(t,0)}set(t,l){return super.set(t,l,2),this}checkTrim(){this.size>this._limit&&this.trim(Math.round(this._limit*this._ratio))}}class g extends a{constructor(t,l=1){super(t,l)}trim(t){this.trimOld(t)}set(t,l){return super.set(t,l),this.checkTrim(),this}}e.LRUCache=g;class d extends a{constructor(t,l=1){super(t,l)}trim(t){this.trimNew(t)}set(t,l){return this._limit<=this.size&&!this.has(t)&&this.trim(Math.round(this._limit*this._ratio)-1),super.set(t,l),this}}e.MRUCache=d;class n{constructor(){this.map=new Map}add(t){return this.map.set(t,(this.map.get(t)||0)+1),this}delete(t){let l=this.map.get(t)||0;return l===0?!1:(l--,l===0?this.map.delete(t):this.map.set(t,l),!0)}has(t){return this.map.has(t)}}e.CounterSet=n;class r{constructor(t){if(this._m1=new Map,this._m2=new Map,t)for(const[l,L]of t)this.set(l,L)}clear(){this._m1.clear(),this._m2.clear()}set(t,l){this._m1.set(t,l),this._m2.set(l,t)}get(t){return this._m1.get(t)}getKey(t){return this._m2.get(t)}delete(t){const l=this._m1.get(t);return l===void 0?!1:(this._m1.delete(t),this._m2.delete(l),!0)}forEach(t,l){this._m1.forEach((L,p)=>{t.call(l,L,p,this)})}keys(){return this._m1.keys()}values(){return this._m1.values()}}e.BidirectionalMap=r;class f{constructor(){this.map=new Map}add(t,l){let L=this.map.get(t);L||(L=new Set,this.map.set(t,L)),L.add(l)}delete(t,l){const L=this.map.get(t);L&&(L.delete(l),L.size===0&&this.map.delete(t))}forEach(t,l){const L=this.map.get(t);L&&L.forEach(l)}get(t){const l=this.map.get(t);return l||new Set}}e.SetMap=f;function C(i,t){if(i===t)return!0;if(i.size!==t.size)return!1;for(const[l,L]of i)if(!t.has(l)||t.get(l)!==L)return!1;for(const[l]of t)if(!i.has(l))return!1;return!0}}),define(de[2],me([0,1,16,41,25,29,43]),function(ae,e,v,D,E,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MandatoryMutableDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.DisposableTracker=void 0,e.setDisposableTracker=w,e.trackDisposable=c,e.markAsDisposed=b,e.markAsSingleton=g,e.isDisposable=d,e.dispose=n,e.disposeIfDisposable=r,e.combinedDisposable=f,e.toDisposable=C,e.disposeOnReturn=K;const P=!1;let h=null;class s{constructor(){this.livingDisposables=new Map}static{this.idx=0}getDisposableData(m){let R=this.livingDisposables.get(m);return R||(R={parent:null,source:null,isSingleton:!1,value:m,idx:s.idx++},this.livingDisposables.set(m,R)),R}trackDisposable(m){const R=this.getDisposableData(m);R.source||(R.source=new Error().stack)}setParent(m,R){const _=this.getDisposableData(m);_.parent=R}markAsDisposed(m){this.livingDisposables.delete(m)}markAsSingleton(m){this.getDisposableData(m).isSingleton=!0}getRootParent(m,R){const _=R.get(m);if(_)return _;const I=m.parent?this.getRootParent(this.getDisposableData(m.parent),R):m;return R.set(m,I),I}getTrackedDisposables(){const m=new Map;return[...this.livingDisposables.entries()].filter(([,_])=>_.source!==null&&!this.getRootParent(_,m).isSingleton).flatMap(([_])=>_)}computeLeakingDisposables(m=10,R){let _;if(R)_=R;else{const ee=new Map,le=[...this.livingDisposables.values()].filter(V=>V.source!==null&&!this.getRootParent(V,ee).isSingleton);if(le.length===0)return;const ue=new Set(le.map(V=>V.value));if(_=le.filter(V=>!(V.parent&&ue.has(V.parent))),_.length===0)throw new Error("There are cyclic diposable chains!")}if(!_)return;function I(ee){function le(V,$){for(;V.length>0&&$.some(Q=>typeof Q=="string"?Q===V[0]:V[0].match(Q));)V.shift()}const ue=ee.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return le(ue,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ue.reverse()}const G=new E.SetMap;for(const ee of _){const le=I(ee);for(let ue=0;ue<=le.length;ue++)G.add(le.slice(0,ue).join(`
`),ee)}_.sort((0,v.compareBy)(ee=>ee.idx,v.numberComparator));let te="",H=0;for(const ee of _.slice(0,m)){H++;const le=I(ee),ue=[];for(let V=0;V<le.length;V++){let $=le[V];$=`(shared with ${G.get(le.slice(0,V+1).join(`
`)).size}/${_.length} leaks) at ${$}`;const Y=G.get(le.slice(0,V).join(`
`)),fe=(0,D.groupBy)([...Y].map(W=>I(W)[V]),W=>W);delete fe[le[V]];for(const[W,ce]of Object.entries(fe))ue.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${W}`);ue.unshift($)}te+=`


==================== Leaking disposable ${H}/${_.length}: ${ee.value.constructor.name} ====================
${ue.join(`
`)}
============================================================

`}return _.length>m&&(te+=`


... and ${_.length-m} more leaking disposables

`),{leaks:_,details:te}}}e.DisposableTracker=s;function w(O){h=O}if(P){const O="__is_disposable_tracked__";w(new class{trackDisposable(m){const R=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[O]||console.log(R)},3e3)}setParent(m,R){if(m&&m!==t.None)try{m[O]=!0}catch{}}markAsDisposed(m){if(m&&m!==t.None)try{m[O]=!0}catch{}}markAsSingleton(m){}})}function c(O){return h?.trackDisposable(O),O}function b(O){h?.markAsDisposed(O)}function o(O,m){h?.setParent(O,m)}function a(O,m){if(h)for(const R of O)h.setParent(R,m)}function g(O){return h?.markAsSingleton(O),O}function d(O){return typeof O=="object"&&O!==null&&typeof O.dispose=="function"&&O.dispose.length===0}function n(O){if(T.Iterable.is(O)){const m=[];for(const R of O)if(R)try{R.dispose()}catch(_){m.push(_)}if(m.length===1)throw m[0];if(m.length>1)throw new AggregateError(m,"Encountered errors while disposing of store");return Array.isArray(O)?[]:O}else if(O)return O.dispose(),O}function r(O){for(const m of O)d(m)&&m.dispose();return[]}function f(...O){const m=C(()=>n(O));return a(O,m),m}function C(O){const m=c({dispose:(0,A.createSingleCallFunction)(()=>{b(m),O()})});return m}class i{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this._toDispose=new Set,this._isDisposed=!1,c(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{n(this._toDispose)}finally{this._toDispose.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return o(m,this),this._isDisposed?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(m),m}delete(m){if(m){if(m===this)throw new Error("Cannot dispose a disposable on itself!");this._toDispose.delete(m),m.dispose()}}deleteAndLeak(m){m&&this._toDispose.has(m)&&(this._toDispose.delete(m),o(m,null))}}e.DisposableStore=i;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this._store=new i,c(this),o(this._store,this)}dispose(){b(this),this._store.dispose()}_register(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(m)}}e.Disposable=t;class l{constructor(){this._isDisposed=!1,c(this)}get value(){return this._isDisposed?void 0:this._value}set value(m){this._isDisposed||m===this._value||(this._value?.dispose(),m&&o(m,this),this._value=m)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const m=this._value;return this._value=void 0,m&&o(m,null),m}}e.MutableDisposable=l;class L{constructor(m){this._disposable=new l,this._isDisposed=!1,this._disposable.value=m}get value(){return this._disposable.value}set value(m){this._isDisposed||m===this._disposable.value||(this._disposable.value=m)}dispose(){this._isDisposed=!0,this._disposable.dispose()}}e.MandatoryMutableDisposable=L;class p{constructor(m){this._disposable=m,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}e.RefCountedDisposable=p;class k{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,c(this)}set(m){let R=m;return this.unset=()=>R=void 0,this.isset=()=>R!==void 0,this.dispose=()=>{R&&(R(),R=void 0,b(this))},this}}e.SafeDisposable=k;class S{constructor(){this.references=new Map}acquire(m,...R){let _=this.references.get(m);_||(_={counter:0,object:this.createReferencedObject(m,...R)},this.references.set(m,_));const{object:I}=_,G=(0,A.createSingleCallFunction)(()=>{--_.counter===0&&(this.destroyReferencedObject(m,_.object),this.references.delete(m))});return _.counter++,{object:I,dispose:G}}}e.ReferenceCollection=S;class y{constructor(m){this.referenceCollection=m}async acquire(m,...R){const _=this.referenceCollection.acquire(m,...R);try{return{object:await _.object,dispose:()=>_.dispose()}}catch(I){throw _.dispose(),I}}}e.AsyncReferenceCollection=y;class U{constructor(m){this.object=m}dispose(){}}e.ImmortalReference=U;function K(O){const m=new i;try{O(m)}finally{m.dispose()}}class z{constructor(){this._store=new Map,this._isDisposed=!1,c(this)}dispose(){b(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{n(this._store.values())}finally{this._store.clear()}}has(m){return this._store.has(m)}get size(){return this._store.size}get(m){return this._store.get(m)}set(m,R,_=!1){this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),_||this._store.get(m)?.dispose(),this._store.set(m,R)}deleteAndDispose(m){this._store.get(m)?.dispose(),this._store.delete(m)}keys(){return this._store.keys()}values(){return this._store.values()}[Symbol.iterator](){return this._store[Symbol.iterator]()}}e.DisposableMap=z}),define(de[45],me([0,1,25]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=void 0,e.normalizeNFC=E,e.normalizeNFD=T;const D=new v.LRUCache(1e4);function E(s){return h(s,"NFC",D)}const A=new v.LRUCache(1e4);function T(s){return h(s,"NFD",A)}const P=/[^\u0000-\u0080]/;function h(s,w,c){if(!s)return s;const b=c.get(s);if(b)return b;let o;return P.test(s)?o=s.normalize(w):o=s,c.set(s,o),o}e.removeAccents=function(){const s=/[\u0300-\u036f]/g;return function(w){return T(w).replace(s,"")}}()}),function(){function ae(E){const A=[];typeof E=="number"&&A.push("code/timeOrigin",E);function T(h){A.push(h,Date.now())}function P(){const h=[];for(let s=0;s<A.length;s+=2)h.push({name:A[s],startTime:A[s+1]});return h}return{mark:T,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ae():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(E+T.startTime)});return A}};if(typeof process=="object"){const E=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ae(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),ae()}function v(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=v(D))}(),define(de[46],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const v=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(A){return new D(A)}constructor(A){this._now=v&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}reset(){this._startTime=this._now(),this._stopTime=-1}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}e.StopWatch=D}),define(de[4],me([0,1,7,29,2,44,46]),function(ae,e,v,D,E,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ValueWithChangeEvent=e.Relay=e.EventBufferer=e.DynamicListEventMultiplexer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.createEventDeliveryQueue=e.Emitter=e.EventProfiling=e.Event=void 0,e.setGlobalLeakWarningThreshold=o;const P=!1,h=!1,s=!1;var w;(function(R){R.None=()=>E.Disposable.None;function _(se){if(s){const{onDidAddListener:he}=se,pe=g.create();let _e=0;se.onDidAddListener=()=>{++_e===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),pe.print()),he?.()}}}function I(se,he){return Y(se,()=>{},0,void 0,!0,void 0,he)}R.defer=I;function G(se){return(he,pe=null,_e)=>{let we=!1,Ce;return Ce=se(Ee=>{if(!we)return Ce?Ce.dispose():we=!0,he.call(pe,Ee)},null,_e),we&&Ce.dispose(),Ce}}R.once=G;function te(se,he,pe){return $((_e,we=null,Ce)=>se(Ee=>_e.call(we,he(Ee)),null,Ce),pe)}R.map=te;function H(se,he,pe){return $((_e,we=null,Ce)=>se(Ee=>{he(Ee),_e.call(we,Ee)},null,Ce),pe)}R.forEach=H;function ee(se,he,pe){return $((_e,we=null,Ce)=>se(Ee=>he(Ee)&&_e.call(we,Ee),null,Ce),pe)}R.filter=ee;function le(se){return se}R.signal=le;function ue(...se){return(he,pe=null,_e)=>{const we=(0,E.combinedDisposable)(...se.map(Ce=>Ce(Ee=>he.call(pe,Ee))));return Q(we,_e)}}R.any=ue;function V(se,he,pe,_e){let we=pe;return te(se,Ce=>(we=he(we,Ce),we),_e)}R.reduce=V;function $(se,he){let pe;const _e={onWillAddFirstListener(){pe=se(we.fire,we)},onDidRemoveLastListener(){pe?.dispose()}};he||_(_e);const we=new i(_e);return he?.add(we),we.event}function Q(se,he){return he instanceof Array?he.push(se):he&&he.add(se),se}function Y(se,he,pe=100,_e=!1,we=!1,Ce,Ee){let Se,Pe,Re,ke=0,Fe;const We={leakWarningThreshold:Ce,onWillAddFirstListener(){Se=se(je=>{ke++,Pe=he(Pe,je),_e&&!Re&&(Ue.fire(Pe),Pe=void 0),Fe=()=>{const $e=Pe;Pe=void 0,Re=void 0,(!_e||ke>1)&&Ue.fire($e),ke=0},typeof pe=="number"?(clearTimeout(Re),Re=setTimeout(Fe,pe)):Re===void 0&&(Re=0,queueMicrotask(Fe))})},onWillRemoveListener(){we&&ke>0&&Fe?.()},onDidRemoveLastListener(){Fe=void 0,Se.dispose()}};Ee||_(We);const Ue=new i(We);return Ee?.add(Ue),Ue.event}R.debounce=Y;function fe(se,he=0,pe){return R.debounce(se,(_e,we)=>_e?(_e.push(we),_e):[we],he,void 0,!0,void 0,pe)}R.accumulate=fe;function W(se,he=(_e,we)=>_e===we,pe){let _e=!0,we;return ee(se,Ce=>{const Ee=_e||!he(Ce,we);return _e=!1,we=Ce,Ee},pe)}R.latch=W;function ce(se,he,pe){return[R.filter(se,he,pe),R.filter(se,_e=>!he(_e),pe)]}R.split=ce;function J(se,he=!1,pe=[],_e){let we=pe.slice(),Ce=se(Pe=>{we?we.push(Pe):Se.fire(Pe)});_e&&_e.add(Ce);const Ee=()=>{we?.forEach(Pe=>Se.fire(Pe)),we=null},Se=new i({onWillAddFirstListener(){Ce||(Ce=se(Pe=>Se.fire(Pe)),_e&&_e.add(Ce))},onDidAddFirstListener(){we&&(he?setTimeout(Ee):Ee())},onDidRemoveLastListener(){Ce&&Ce.dispose(),Ce=null}});return _e&&_e.add(Se),Se.event}R.buffer=J;function u(se,he){return(_e,we,Ce)=>{const Ee=he(new ie);return se(function(Se){const Pe=Ee.evaluate(Se);Pe!==N&&_e.call(we,Pe)},void 0,Ce)}}R.chain=u;const N=Symbol("HaltChainable");class ie{constructor(){this.steps=[]}map(he){return this.steps.push(he),this}forEach(he){return this.steps.push(pe=>(he(pe),pe)),this}filter(he){return this.steps.push(pe=>he(pe)?pe:N),this}reduce(he,pe){let _e=pe;return this.steps.push(we=>(_e=he(_e,we),_e)),this}latch(he=(pe,_e)=>pe===_e){let pe=!0,_e;return this.steps.push(we=>{const Ce=pe||!he(we,_e);return pe=!1,_e=we,Ce?we:N}),this}evaluate(he){for(const pe of this.steps)if(he=pe(he),he===N)break;return he}}function ne(se,he,pe=_e=>_e){const _e=(...Se)=>Ee.fire(pe(...Se)),we=()=>se.on(he,_e),Ce=()=>se.removeListener(he,_e),Ee=new i({onWillAddFirstListener:we,onDidRemoveLastListener:Ce});return Ee.event}R.fromNodeEventEmitter=ne;function x(se,he,pe=_e=>_e){const _e=(...Se)=>Ee.fire(pe(...Se)),we=()=>se.addEventListener(he,_e),Ce=()=>se.removeEventListener(he,_e),Ee=new i({onWillAddFirstListener:we,onDidRemoveLastListener:Ce});return Ee.event}R.fromDOMEventEmitter=x;function B(se){return new Promise(he=>G(se)(he))}R.toPromise=B;function F(se){const he=new i;return se.then(pe=>{he.fire(pe)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}R.fromPromise=F;function M(se,he,pe){return he(pe),se(_e=>he(_e))}R.runAndSubscribe=M;class j{constructor(he,pe){this._observable=he,this._counter=0,this._hasChanged=!1;const _e={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};pe||_(_e),this.emitter=new i(_e),pe&&pe.add(this.emitter)}beginUpdate(he){this._counter++}handlePossibleChange(he){}handleChange(he,pe){this._hasChanged=!0}endUpdate(he){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function Z(se,he){return new j(se,he).emitter.event}R.fromObservable=Z;function re(se){return(he,pe,_e)=>{let we=0,Ce=!1;const Ee={beginUpdate(){we++},endUpdate(){we--,we===0&&(se.reportChanges(),Ce&&(Ce=!1,he.call(pe)))},handlePossibleChange(){},handleChange(){Ce=!0}};se.addObserver(Ee),se.reportChanges();const Se={dispose(){se.removeObserver(Ee)}};return _e instanceof E.DisposableStore?_e.add(Se):Array.isArray(_e)&&_e.push(Se),Se}}R.fromObservableLight=re})(w||(e.Event=w={}));class c{static{this.all=new Set}static{this._idPool=0}constructor(_){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${_}_${c._idPool++}`,c.all.add(this)}start(_){this._stopWatch=new T.StopWatch,this.listenerCount=_}stop(){if(this._stopWatch){const _=this._stopWatch.elapsed();this.durations.push(_),this.elapsedOverall+=_,this.invocationCount+=1,this._stopWatch=void 0}}}e.EventProfiling=c;let b=-1;function o(R){const _=b;return b=R,{dispose(){b=_}}}class a{constructor(_,I=Math.random().toString(18).slice(2,5)){this.threshold=_,this.name=I,this._warnCountdown=0}dispose(){this._stacks?.clear()}check(_,I){const G=this.threshold;if(G<=0||I<G)return;this._stacks||(this._stacks=new Map);const te=this._stacks.get(_.value)||0;if(this._stacks.set(_.value,te+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=G*.5;let H,ee=0;for(const[le,ue]of this._stacks)(!H||ee<ue)&&(H=le,ee=ue);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${ee}):`),console.warn(H)}return()=>{const H=this._stacks.get(_.value)||0;this._stacks.set(_.value,H-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(_){this.value=_}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let d=0;class n{constructor(_){this.value=_,this.id=d++}}const r=2,f=(R,_)=>{if(R instanceof n)_(R);else for(let I=0;I<R.length;I++){const G=R[I];G&&_(G)}},C=P?new FinalizationRegistry(R=>{typeof R=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(R))}):void 0;class i{constructor(_){this._size=0,this._options=_,this._leakageMon=b>0||this._options?.leakWarningThreshold?new a(this._options?.leakWarningThreshold??b):void 0,this._perfMon=this._options?._profName?new c(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._deliveryQueue?.current===this&&this._deliveryQueue.reset(),this._listeners){if(h){const _=this._listeners;queueMicrotask(()=>{f(_,I=>I.stack?.print())})}this._listeners=void 0,this._size=0}this._options?.onDidRemoveLastListener?.(),this._leakageMon?.dispose()}}get event(){return this._event??=(_,I,G)=>{if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),E.Disposable.None;if(this._disposed)return E.Disposable.None;I&&(_=_.bind(I));const te=new n(_);let H,ee;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(te.stack=g.create(),H=this._leakageMon.check(te.stack,this._size+1)),h&&(te.stack=ee??g.create()),this._listeners?this._listeners instanceof n?(this._deliveryQueue??=new l,this._listeners=[this._listeners,te]):this._listeners.push(te):(this._options?.onWillAddFirstListener?.(this),this._listeners=te,this._options?.onDidAddFirstListener?.(this)),this._size++;const le=(0,E.toDisposable)(()=>{C?.unregister(le),H?.(),this._removeListener(te)});if(G instanceof E.DisposableStore?G.add(le):Array.isArray(G)&&G.push(le),C){const ue=new Error().stack.split(`
`).slice(2).join(`
`).trim();C.register(le,ue,le)}return le},this._event}_removeListener(_){if(this._options?.onWillRemoveListener?.(this),!this._listeners)return;if(this._size===1){this._listeners=void 0,this._options?.onDidRemoveLastListener?.(this),this._size=0;return}const I=this._listeners,G=I.indexOf(_);if(G===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,I[G]=void 0;const te=this._deliveryQueue.current===this;if(this._size*r<=I.length){let H=0;for(let ee=0;ee<I.length;ee++)I[ee]?I[H++]=I[ee]:te&&(this._deliveryQueue.end--,H<this._deliveryQueue.i&&this._deliveryQueue.i--);I.length=H}}_deliver(_,I){if(!_)return;const G=this._options?.onListenerError||v.onUnexpectedError;if(!G){_.value(I);return}try{_.value(I)}catch(te){G(te)}}_deliverQueue(_){const I=_.current._listeners;for(;_.i<_.end;)this._deliver(I[_.i++],_.value);_.reset()}fire(_){if(this._deliveryQueue?.current&&(this._deliverQueue(this._deliveryQueue),this._perfMon?.stop()),this._perfMon?.start(this._size),this._listeners)if(this._listeners instanceof n)this._deliver(this._listeners,_);else{const I=this._deliveryQueue;I.enqueue(this,_,this._listeners.length),this._deliverQueue(I)}this._perfMon?.stop()}hasListeners(){return this._size>0}}e.Emitter=i;const t=()=>new l;e.createEventDeliveryQueue=t;class l{constructor(){this.i=-1,this.end=0}enqueue(_,I,G){this.i=0,this.end=G,this.current=_,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class L extends i{async fireAsync(_,I,G){if(this._listeners)for(this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList),f(this._listeners,te=>this._asyncDeliveryQueue.push([te.value,_]));this._asyncDeliveryQueue.size>0&&!I.isCancellationRequested;){const[te,H]=this._asyncDeliveryQueue.shift(),ee=[],le={...H,token:I,waitUntil:ue=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");G&&(ue=G(ue,te)),ee.push(ue)}};try{te(le)}catch(ue){(0,v.onUnexpectedError)(ue);continue}Object.freeze(ee),await Promise.allSettled(ee).then(ue=>{for(const V of ue)V.status==="rejected"&&(0,v.onUnexpectedError)(V.reason)})}}}e.AsyncEmitter=L;class p extends i{get isPaused(){return this._isPaused!==0}constructor(_){super(_),this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=_?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const _=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(_))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(_){this._size&&(this._isPaused!==0?this._eventQueue.push(_):super.fire(_))}}e.PauseableEmitter=p;class k extends p{constructor(_){super(_),this._delay=_.delay??100}fire(_){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(_)}}e.DebounceEmitter=k;class S extends i{constructor(_){super(_),this._queuedEvents=[],this._mergeFn=_?.merge}fire(_){this.hasListeners()&&(this._queuedEvents.push(_),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(I=>super.fire(I)),this._queuedEvents=[]}))}}e.MicrotaskEmitter=S;class y{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new i({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(_){const I={event:_,listener:null};this.events.push(I),this.hasListeners&&this.hook(I);const G=()=>{this.hasListeners&&this.unhook(I);const te=this.events.indexOf(I);this.events.splice(te,1)};return(0,E.toDisposable)((0,D.createSingleCallFunction)(G))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(_=>this.hook(_))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(_=>this.unhook(_))}hook(_){_.listener=_.event(I=>this.emitter.fire(I))}unhook(_){_.listener?.dispose(),_.listener=null}dispose(){this.emitter.dispose();for(const _ of this.events)_.listener?.dispose();this.events=[]}}e.EventMultiplexer=y;class U{constructor(_,I,G,te){this._store=new E.DisposableStore;const H=this._store.add(new y),ee=this._store.add(new E.DisposableMap);function le(ue){ee.set(ue,H.add(te(ue)))}for(const ue of _)le(ue);this._store.add(I(ue=>{le(ue)})),this._store.add(G(ue=>{ee.deleteAndDispose(ue)})),this.event=H.event}dispose(){this._store.dispose()}}e.DynamicListEventMultiplexer=U;class K{constructor(){this.buffers=[]}wrapEvent(_){return(I,G,te)=>_(H=>{const ee=this.buffers[this.buffers.length-1];ee?ee.push(()=>I.call(G,H)):I.call(G,H)},void 0,te)}bufferEvents(_){const I=[];this.buffers.push(I);const G=_();return this.buffers.pop(),I.forEach(te=>te()),G}}e.EventBufferer=K;class z{constructor(){this.listening=!1,this.inputEvent=w.None,this.inputEventListener=E.Disposable.None,this.emitter=new i({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(_){this.inputEvent=_,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=_(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=z;class O{static const(_){return new m(_)}constructor(_){this._value=_,this._onDidChange=new i,this.onDidChange=this._onDidChange.event}get value(){return this._value}set value(_){_!==this._value&&(this._value=_,this._onDidChange.fire(void 0))}}e.ValueWithChangeEvent=O;class m{constructor(_){this.value=_,this.onDidChange=w.None}}}),define(de[17],me([0,1,4]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0,e.cancelOnDispose=P;const D=Object.freeze(function(h,s){const w=setTimeout(h.bind(s),0);return{dispose(){clearTimeout(w)}}});var E;(function(h){function s(w){return w===h.None||w===h.Cancelled||w instanceof A?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}h.isCancellationToken=s,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(E||(e.CancellationToken=E={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(s){this._token=void 0,this._parentListener=void 0,this._parentListener=s&&s.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=E.Cancelled}dispose(s=!1){s&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=E.None}}e.CancellationTokenSource=T;function P(h){const s=new T;return h.add({dispose(){s.cancel()}}),s.token}}),define(de[47],me([0,1,17]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0,e.identity=E;class D{constructor(h){this.task=h,this.result=null}get(){if(this.result)return this.result;const h=new v.CancellationTokenSource,s=this.task(h.token);return this.result={promise:s,dispose:()=>{this.result=null,h.cancel(),h.dispose()}},this.result}}e.Cache=D;function E(P){return P}class A{constructor(h,s){this.lastCache=void 0,this.lastArgKey=void 0,typeof h=="function"?(this._fn=h,this._computeKey=E):(this._fn=s,this._computeKey=h.getCacheKey)}get(h){const s=this._computeKey(h);return this.lastArgKey!==s&&(this.lastArgKey=s,this.lastCache=this._fn(h)),this.lastCache}}e.LRUCachedFunction=A;class T{get cachedValues(){return this._map}constructor(h,s){this._map=new Map,this._map2=new Map,typeof h=="function"?(this._fn=h,this._computeKey=E):(this._fn=s,this._computeKey=h.getCacheKey)}get(h){const s=this._computeKey(h);if(this._map2.has(s))return this._map2.get(s);const w=this._fn(h);return this._map.set(h,w),this._map2.set(s,w),w}}e.CachedFunction=T}),define(de[48],me([0,1,7,2]),function(ae,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isReadable=E,e.isReadableStream=A,e.isReadableBufferedStream=T,e.newWriteableStream=P,e.consumeReadable=s,e.peekReadable=w,e.consumeStream=c,e.listenStream=b,e.peekStream=o,e.toStream=a,e.emptyStream=g,e.toReadable=d,e.transform=n,e.prefixedReadable=r,e.prefixedStream=f;function E(C){const i=C;return i?typeof i.read=="function":!1}function A(C){const i=C;return i?[i.on,i.pause,i.resume,i.destroy].every(t=>typeof t=="function"):!1}function T(C){const i=C;return i?A(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function P(C,i){return new h(C,i)}class h{constructor(i,t){this.reducer=i,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(i){if(!this.state.destroyed){if(this.state.flowing)this.emitData(i);else if(this.buffer.data.push(i),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(i){this.state.destroyed||(this.state.flowing?this.emitError(i):this.buffer.error.push(i))}end(i){this.state.destroyed||(typeof i<"u"&&this.write(i),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(i){this.listeners.data.slice(0).forEach(t=>t(i))}emitError(i){this.listeners.error.length===0?(0,v.onUnexpectedError)(i):this.listeners.error.slice(0).forEach(t=>t(i))}emitEnd(){this.listeners.end.slice(0).forEach(i=>i())}on(i,t){if(!this.state.destroyed)switch(i){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(i,t){if(this.state.destroyed)return;let l;switch(i){case"data":l=this.listeners.data;break;case"end":l=this.listeners.end;break;case"error":l=this.listeners.error;break}if(l){const L=l.indexOf(t);L>=0&&l.splice(L,1)}}flowData(){if(this.buffer.data.length>0){const i=this.reducer(this.buffer.data);this.emitData(i),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(l=>l())}}flowErrors(){if(this.listeners.error.length>0){for(const i of this.buffer.error)this.emitError(i);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function s(C,i){const t=[];let l;for(;(l=C.read())!==null;)t.push(l);return i(t)}function w(C,i,t){const l=[];let L;for(;(L=C.read())!==null&&l.length<t;)l.push(L);return L===null&&l.length>0?i(l):{read:()=>{if(l.length>0)return l.shift();if(typeof L<"u"){const p=L;return L=void 0,p}return C.read()}}}function c(C,i){return new Promise((t,l)=>{const L=[];b(C,{onData:p=>{i&&L.push(p)},onError:p=>{i?l(p):t(void 0)},onEnd:()=>{t(i?i(L):void 0)}})})}function b(C,i,t){C.on("error",l=>{t?.isCancellationRequested||i.onError(l)}),C.on("end",()=>{t?.isCancellationRequested||i.onEnd()}),C.on("data",l=>{t?.isCancellationRequested||i.onData(l)})}function o(C,i){return new Promise((t,l)=>{const L=new D.DisposableStore,p=[],k=U=>{if(p.push(U),p.length>i)return L.dispose(),C.pause(),t({stream:C,buffer:p,ended:!1})},S=U=>(L.dispose(),l(U)),y=()=>(L.dispose(),t({stream:C,buffer:p,ended:!0}));L.add((0,D.toDisposable)(()=>C.removeListener("error",S))),C.on("error",S),L.add((0,D.toDisposable)(()=>C.removeListener("end",y))),C.on("end",y),L.add((0,D.toDisposable)(()=>C.removeListener("data",k))),C.on("data",k)})}function a(C,i){const t=P(i);return t.end(C),t}function g(){const C=P(()=>{throw new Error("not supported")});return C.end(),C}function d(C){let i=!1;return{read:()=>i?null:(i=!0,C)}}function n(C,i,t){const l=P(t);return b(C,{onData:L=>l.write(i.data(L)),onError:L=>l.error(i.error?i.error(L):L),onEnd:()=>l.end()}),l}function r(C,i,t){let l=!1;return{read:()=>{const L=i.read();return l?L:(l=!0,L!==null?t([C,L]):C)}}}function f(C,i,t){let l=!1;const L=P(t);return b(i,{onData:p=>l?L.write(p):(l=!0,L.write(t([C,p]))),onError:p=>L.error(p),onEnd:()=>{l||(l=!0,L.write(C)),L.end()}}),L}}),define(de[18],me([0,1,22,48]),function(ae,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VSBuffer=void 0,e.binaryIndexOf=s,e.readUInt16LE=w,e.writeUInt16LE=c,e.readUInt32BE=b,e.writeUInt32BE=o,e.readUInt32LE=a,e.writeUInt32LE=g,e.readUInt8=d,e.writeUInt8=n,e.readableToBuffer=r,e.bufferToReadable=f,e.streamToBuffer=C,e.bufferedStreamToBuffer=i,e.bufferToStream=t,e.streamToBufferReadableStream=l,e.newWriteableBufferStream=L,e.prefixedBufferReadable=p,e.prefixedBufferStream=k,e.decodeBase64=S,e.encodeBase64=K;const E=typeof Buffer<"u",A=new v.Lazy(()=>new Uint8Array(256));let T,P;class h{static alloc(O){return E?new h(Buffer.allocUnsafe(O)):new h(new Uint8Array(O))}static wrap(O){return E&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new h(O)}static fromString(O,m){return!(m?.dontUseNodeBuffer||!1)&&E?new h(Buffer.from(O)):(T||(T=new TextEncoder),new h(T.encode(O)))}static fromByteArray(O){const m=h.alloc(O.length);for(let R=0,_=O.length;R<_;R++)m.buffer[R]=O[R];return m}static concat(O,m){if(typeof m>"u"){m=0;for(let I=0,G=O.length;I<G;I++)m+=O[I].byteLength}const R=h.alloc(m);let _=0;for(let I=0,G=O.length;I<G;I++){const te=O[I];R.set(te,_),_+=te.byteLength}return R}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=h.alloc(this.byteLength);return O.set(this),O}toString(){return E?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(O,m){return new h(this.buffer.subarray(O,m))}set(O,m){if(O instanceof h)this.buffer.set(O.buffer,m);else if(O instanceof Uint8Array)this.buffer.set(O,m);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),m);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),m);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return b(this.buffer,O)}writeUInt32BE(O,m){o(this.buffer,O,m)}readUInt32LE(O){return a(this.buffer,O)}writeUInt32LE(O,m){g(this.buffer,O,m)}readUInt8(O){return d(this.buffer,O)}writeUInt8(O,m){n(this.buffer,O,m)}indexOf(O,m=0){return s(this.buffer,O instanceof h?O.buffer:O,m)}}e.VSBuffer=h;function s(z,O,m=0){const R=O.byteLength,_=z.byteLength;if(R===0)return 0;if(R===1)return z.indexOf(O[0]);if(R>_-m)return-1;const I=A.value;I.fill(O.length);for(let ee=0;ee<O.length;ee++)I[O[ee]]=O.length-ee-1;let G=m+O.length-1,te=G,H=-1;for(;G<_;)if(z[G]===O[te]){if(te===0){H=G;break}G--,te--}else G+=Math.max(O.length-te,I[z[G]]),te=O.length-1;return H}function w(z,O){return z[O+0]<<0>>>0|z[O+1]<<8>>>0}function c(z,O,m){z[m+0]=O&255,O=O>>>8,z[m+1]=O&255}function b(z,O){return z[O]*2**24+z[O+1]*2**16+z[O+2]*2**8+z[O+3]}function o(z,O,m){z[m+3]=O,O=O>>>8,z[m+2]=O,O=O>>>8,z[m+1]=O,O=O>>>8,z[m]=O}function a(z,O){return z[O+0]<<0>>>0|z[O+1]<<8>>>0|z[O+2]<<16>>>0|z[O+3]<<24>>>0}function g(z,O,m){z[m+0]=O&255,O=O>>>8,z[m+1]=O&255,O=O>>>8,z[m+2]=O&255,O=O>>>8,z[m+3]=O&255}function d(z,O){return z[O]}function n(z,O,m){z[m]=O}function r(z){return D.consumeReadable(z,O=>h.concat(O))}function f(z){return D.toReadable(z)}function C(z){return D.consumeStream(z,O=>h.concat(O))}async function i(z){return z.ended?h.concat(z.buffer):h.concat([...z.buffer,await C(z.stream)])}function t(z){return D.toStream(z,O=>h.concat(O))}function l(z){return D.transform(z,{data:O=>typeof O=="string"?h.fromString(O):h.wrap(O)},O=>h.concat(O))}function L(z){return D.newWriteableStream(O=>h.concat(O),z)}function p(z,O){return D.prefixedReadable(z,O,m=>h.concat(m))}function k(z,O){return D.prefixedStream(z,O,m=>h.concat(m))}function S(z){let O=0,m=0,R=0;const _=new Uint8Array(Math.floor(z.length/4*3)),I=te=>{switch(m){case 3:_[R++]=O|te,m=0;break;case 2:_[R++]=O|te>>>2,O=te<<6,m=3;break;case 1:_[R++]=O|te>>>4,O=te<<4,m=2;break;default:O=te<<2,m=1}};for(let te=0;te<z.length;te++){const H=z.charCodeAt(te);if(H>=65&&H<=90)I(H-65);else if(H>=97&&H<=122)I(H-97+26);else if(H>=48&&H<=57)I(H-48+52);else if(H===43||H===45)I(62);else if(H===47||H===95)I(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${z[te]}`)}}const G=R;for(;m>0;)I(0);return h.wrap(_).slice(0,G)}const y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",U="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function K({buffer:z},O=!0,m=!1){const R=m?U:y;let _="";const I=z.byteLength%3;let G=0;for(;G<z.byteLength-I;G+=3){const te=z[G+0],H=z[G+1],ee=z[G+2];_+=R[te>>>2],_+=R[(te<<4|H>>>4)&63],_+=R[(H<<2|ee>>>6)&63],_+=R[ee&63]}if(I===1){const te=z[G+0];_+=R[te>>>2],_+=R[te<<4&63],O&&(_+="==")}else if(I===2){const te=z[G+0],H=z[G+1];_+=R[te>>>2],_+=R[(te<<4|H>>>4)&63],_+=R[H<<2&63],O&&(_+="=")}return _}}),define(de[12],me([0,1,47,22]),function(ae,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.GraphemeBreakType=e.UTF8_BOM_CHARACTER=e.UNUSUAL_LINE_TERMINATORS=e.GraphemeIterator=e.CodePointIterator=void 0,e.isFalsyOrWhitespace=E,e.format=T,e.format2=h,e.htmlAttributeEncodeValue=s,e.escape=w,e.escapeRegExpCharacters=c,e.count=b,e.truncate=o,e.truncateMiddle=a,e.trim=g,e.ltrim=d,e.rtrim=n,e.convertSimple2RegExpPattern=r,e.stripWildcards=f,e.createRegExp=C,e.regExpLeadsToEndlessLoop=i,e.splitLines=t,e.splitLinesIncludeSeparators=l,e.firstNonWhitespaceIndex=L,e.getLeadingWhitespace=p,e.lastNonWhitespaceIndex=k,e.replaceAsync=S,e.compare=y,e.compareSubstring=U,e.compareIgnoreCase=K,e.compareSubstringIgnoreCase=z,e.isAsciiDigit=O,e.isLowerAsciiLetter=m,e.isUpperAsciiLetter=R,e.equalsIgnoreCase=_,e.startsWithIgnoreCase=I,e.commonPrefixLength=G,e.commonSuffixLength=te,e.isHighSurrogate=H,e.isLowSurrogate=ee,e.computeCodePoint=le,e.getNextCodePoint=ue,e.nextCharLength=Y,e.prevCharLength=fe,e.getCharContainingOffset=W,e.charCount=ce,e.containsRTL=N,e.isBasicASCII=ne,e.containsUnusualLineTerminators=x,e.isFullWidthCharacter=B,e.isEmojiImprecise=F,e.lcut=M,e.forAnsiStringParts=Z,e.removeAnsiEscapeCodes=re,e.startsWithUTF8BOM=se,e.stripUTF8BOM=he,e.fuzzyContains=pe,e.containsUppercaseCharacter=_e,e.uppercaseFirstLetter=we,e.getNLines=Ce,e.singleLetterHash=Ee,e.getGraphemeBreakType=Se,e.getLeftDeleteOffset=We;function E(q){return!q||typeof q!="string"?!0:q.trim().length===0}const A=/{(\d+)}/g;function T(q,...X){return X.length===0?q:q.replace(A,function(oe,ge){const ve=parseInt(ge,10);return isNaN(ve)||ve<0||ve>=X.length?oe:X[ve]})}const P=/{([^}]+)}/g;function h(q,X){return Object.keys(X).length===0?q:q.replace(P,(oe,ge)=>X[ge]??oe)}function s(q){return q.replace(/[<>"'&]/g,X=>{switch(X){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return X})}function w(q){return q.replace(/[<>&]/g,function(X){switch(X){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return X}})}function c(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function b(q,X){let oe=0;const ge=X.charCodeAt(0);for(let ve=q.length-1;ve>=0;ve--)q.charCodeAt(ve)===ge&&oe++;return oe}function o(q,X,oe="\u2026"){return q.length<=X?q:`${q.substr(0,X)}${oe}`}function a(q,X,oe="\u2026"){if(q.length<=X)return q;const ge=Math.ceil(X/2)-oe.length/2,ve=Math.floor(X/2)-oe.length/2;return`${q.substr(0,ge)}${oe}${q.substr(q.length-ve)}`}function g(q,X=" "){const oe=d(q,X);return n(oe,X)}function d(q,X){if(!q||!X)return q;const oe=X.length;if(oe===0||q.length===0)return q;let ge=0;for(;q.indexOf(X,ge)===ge;)ge=ge+oe;return q.substring(ge)}function n(q,X){if(!q||!X)return q;const oe=X.length,ge=q.length;if(oe===0||ge===0)return q;let ve=ge,be=-1;for(;be=q.lastIndexOf(X,ve-1),!(be===-1||be+oe!==ve);){if(be===0)return"";ve=be}return q.substring(0,ve)}function r(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function f(q){return q.replace(/\*/g,"")}function C(q,X,oe={}){if(!q)throw new Error("Cannot create regex from empty string");X||(q=c(q)),oe.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let ge="";return oe.global&&(ge+="g"),oe.matchCase||(ge+="i"),oe.multiline&&(ge+="m"),oe.unicode&&(ge+="u"),new RegExp(q,ge)}function i(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}function t(q){return q.split(/\r\n|\r|\n/)}function l(q){const X=[],oe=q.split(/(\r\n|\r|\n)/);for(let ge=0;ge<Math.ceil(oe.length/2);ge++)X.push(oe[2*ge]+(oe[2*ge+1]??""));return X}function L(q){for(let X=0,oe=q.length;X<oe;X++){const ge=q.charCodeAt(X);if(ge!==32&&ge!==9)return X}return-1}function p(q,X=0,oe=q.length){for(let ge=X;ge<oe;ge++){const ve=q.charCodeAt(ge);if(ve!==32&&ve!==9)return q.substring(X,ge)}return q.substring(X,oe)}function k(q,X=q.length-1){for(let oe=X;oe>=0;oe--){const ge=q.charCodeAt(oe);if(ge!==32&&ge!==9)return oe}return-1}function S(q,X,oe){const ge=[];let ve=0;for(const be of q.matchAll(X)){if(ge.push(q.slice(ve,be.index)),be.index===void 0)throw new Error("match.index should be defined");ve=be.index+be[0].length,ge.push(oe(be[0],...be.slice(1),be.index,q,be.groups))}return ge.push(q.slice(ve)),Promise.all(ge).then(be=>be.join(""))}function y(q,X){return q<X?-1:q>X?1:0}function U(q,X,oe=0,ge=q.length,ve=0,be=X.length){for(;oe<ge&&ve<be;oe++,ve++){const Ie=q.charCodeAt(oe),Ae=X.charCodeAt(ve);if(Ie<Ae)return-1;if(Ie>Ae)return 1}const Le=ge-oe,Oe=be-ve;return Le<Oe?-1:Le>Oe?1:0}function K(q,X){return z(q,X,0,q.length,0,X.length)}function z(q,X,oe=0,ge=q.length,ve=0,be=X.length){for(;oe<ge&&ve<be;oe++,ve++){let Ie=q.charCodeAt(oe),Ae=X.charCodeAt(ve);if(Ie===Ae)continue;if(Ie>=128||Ae>=128)return U(q.toLowerCase(),X.toLowerCase(),oe,ge,ve,be);m(Ie)&&(Ie-=32),m(Ae)&&(Ae-=32);const De=Ie-Ae;if(De!==0)return De}const Le=ge-oe,Oe=be-ve;return Le<Oe?-1:Le>Oe?1:0}function O(q){return q>=48&&q<=57}function m(q){return q>=97&&q<=122}function R(q){return q>=65&&q<=90}function _(q,X){return q.length===X.length&&z(q,X)===0}function I(q,X){const oe=X.length;return X.length>q.length?!1:z(q,X,0,oe)===0}function G(q,X){const oe=Math.min(q.length,X.length);let ge;for(ge=0;ge<oe;ge++)if(q.charCodeAt(ge)!==X.charCodeAt(ge))return ge;return oe}function te(q,X){const oe=Math.min(q.length,X.length);let ge;const ve=q.length-1,be=X.length-1;for(ge=0;ge<oe;ge++)if(q.charCodeAt(ve-ge)!==X.charCodeAt(be-ge))return ge;return oe}function H(q){return 55296<=q&&q<=56319}function ee(q){return 56320<=q&&q<=57343}function le(q,X){return(q-55296<<10)+(X-56320)+65536}function ue(q,X,oe){const ge=q.charCodeAt(oe);if(H(ge)&&oe+1<X){const ve=q.charCodeAt(oe+1);if(ee(ve))return le(ge,ve)}return ge}function V(q,X){const oe=q.charCodeAt(X-1);if(ee(oe)&&X>1){const ge=q.charCodeAt(X-2);if(H(ge))return le(ge,oe)}return oe}class ${get offset(){return this._offset}constructor(X,oe=0){this._str=X,this._len=X.length,this._offset=oe}setOffset(X){this._offset=X}prevCodePoint(){const X=V(this._str,this._offset);return this._offset-=X>=65536?2:1,X}nextCodePoint(){const X=ue(this._str,this._len,this._offset);return this._offset+=X>=65536?2:1,X}eol(){return this._offset>=this._len}}e.CodePointIterator=$;class Q{get offset(){return this._iterator.offset}constructor(X,oe=0){this._iterator=new $(X,oe)}nextGraphemeLength(){const X=ke.getInstance(),oe=this._iterator,ge=oe.offset;let ve=X.getGraphemeBreakType(oe.nextCodePoint());for(;!oe.eol();){const be=oe.offset,Le=X.getGraphemeBreakType(oe.nextCodePoint());if(Pe(ve,Le)){oe.setOffset(be);break}ve=Le}return oe.offset-ge}prevGraphemeLength(){const X=ke.getInstance(),oe=this._iterator,ge=oe.offset;let ve=X.getGraphemeBreakType(oe.prevCodePoint());for(;oe.offset>0;){const be=oe.offset,Le=X.getGraphemeBreakType(oe.prevCodePoint());if(Pe(Le,ve)){oe.setOffset(be);break}ve=Le}return ge-oe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=Q;function Y(q,X){return new Q(q,X).nextGraphemeLength()}function fe(q,X){return new Q(q,X).prevGraphemeLength()}function W(q,X){X>0&&ee(q.charCodeAt(X))&&X--;const oe=X+Y(q,X);return[oe-fe(q,oe),oe]}function ce(q){const X=new Q(q);let oe=0;for(;!X.eol();)oe++,X.nextGraphemeLength();return oe}let J;function u(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(q){return J||(J=u()),J.test(q)}const ie=/^[\t\n\r\x20-\x7E]*$/;function ne(q){return ie.test(q)}e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function x(q){return e.UNUSUAL_LINE_TERMINATORS.test(q)}function B(q){return q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}function F(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129008||q>=129280&&q<=129535||q>=129648&&q<=129782}function M(q,X,oe=""){const ge=q.trimStart();if(ge.length<X)return ge;const ve=/\b/g;let be=0;for(;ve.test(ge)&&!(ge.length-ve.lastIndex<X);)be=ve.lastIndex,ve.lastIndex+=1;return be===0?ge:oe+ge.substring(be).trimStart()}const j=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Z(q){let X=0;for(const oe of q.matchAll(j))X!==oe.index&&(yield{isCode:!1,str:q.substring(X,oe.index)}),yield{isCode:!0,str:oe[0]},X=oe.index+oe[0].length;X!==q.length&&(yield{isCode:!1,str:q.substring(X)})}function re(q){return q&&(q=q.replace(j,"")),q}e.UTF8_BOM_CHARACTER="\uFEFF";function se(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}function he(q){return se(q)?q.substr(1):q}function pe(q,X){if(!q||!X||q.length<X.length)return!1;const oe=X.length,ge=q.toLowerCase();let ve=0,be=-1;for(;ve<oe;){const Le=ge.indexOf(X[ve],be+1);if(Le<0)return!1;be=Le,ve++}return!0}function _e(q,X=!1){return q?(X&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}function we(q){return q.charAt(0).toUpperCase()+q.slice(1)}function Ce(q,X=1){if(X===0)return"";let oe=-1;do oe=q.indexOf(`
`,oe+1),X--;while(X>0&&oe>=0);return oe===-1?q:(q[oe-1]==="\r"&&oe--,q.substr(0,oe))}function Ee(q){return q=q%(2*26),q<26?String.fromCharCode(97+q):String.fromCharCode(65+q-26)}function Se(q){return ke.getInstance().getGraphemeBreakType(q)}function Pe(q,X){return q===0?X!==5&&X!==7:q===2&&X===3?!1:q===4||q===2||q===3||X===4||X===2||X===3?!0:!(q===8&&(X===8||X===9||X===11||X===12)||(q===11||q===9)&&(X===9||X===10)||(q===12||q===10)&&X===10||X===5||X===13||X===7||q===1||q===13&&X===14||q===6&&X===6)}var Re;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(Re||(e.GraphemeBreakType=Re={}));class ke{static{this._INSTANCE=null}static getInstance(){return ke._INSTANCE||(ke._INSTANCE=new ke),ke._INSTANCE}constructor(){this._data=Fe()}getGraphemeBreakType(X){if(X<32)return X===10?3:X===13?2:4;if(X<127)return 0;const oe=this._data,ge=oe.length/3;let ve=1;for(;ve<=ge;)if(X<oe[3*ve])ve=2*ve;else if(X>oe[3*ve+1])ve=2*ve+1;else return oe[3*ve+2];return 0}}function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(q,X){if(q===0)return 0;const oe=Ue(q,X);if(oe!==void 0)return oe;const ge=new $(X,q);return ge.prevCodePoint(),ge.offset}function Ue(q,X){const oe=new $(X,q);let ge=oe.prevCodePoint();for(;je(ge)||ge===65039||ge===8419;){if(oe.offset===0)return;ge=oe.prevCodePoint()}if(!F(ge))return;let ve=oe.offset;return ve>0&&oe.prevCodePoint()===8205&&(ve=oe.offset),ve}function je(q){return 127995<=q&&q<=127999}var $e;(function(q){q[q.zwj=8205]="zwj",q[q.emojiVariantSelector=65039]="emojiVariantSelector",q[q.enclosingKeyCap=8419]="enclosingKeyCap"})($e||($e={})),e.noBreakWhitespace="\xA0";class ze{static{this.ambiguousCharacterData=new D.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.cache=new v.LRUCachedFunction({getCacheKey:JSON.stringify},X=>{function oe(De){const Te=new Map;for(let Me=0;Me<De.length;Me+=2)Te.set(De[Me],De[Me+1]);return Te}function ge(De,Te){const Me=new Map(De);for(const[Be,xe]of Te)Me.set(Be,xe);return Me}function ve(De,Te){if(!De)return Te;const Me=new Map;for(const[Be,xe]of De)Te.has(Be)&&Me.set(Be,xe);return Me}const be=this.ambiguousCharacterData.value;let Le=X.filter(De=>!De.startsWith("_")&&De in be);Le.length===0&&(Le=["_default"]);let Oe;for(const De of Le){const Te=oe(be[De]);Oe=ve(Oe,Te)}const Ie=oe(be._common),Ae=ge(Ie,Oe);return new ze(Ae)})}static getInstance(X){return ze.cache.get(Array.from(X))}static{this._locales=new D.Lazy(()=>Object.keys(ze.ambiguousCharacterData.value).filter(X=>!X.startsWith("_")))}static getLocales(){return ze._locales.value}constructor(X){this.confusableDictionary=X}isAmbiguous(X){return this.confusableDictionary.has(X)}getPrimaryConfusable(X){return this.confusableDictionary.get(X)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ze;class qe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this._data=void 0}static getData(){return this._data||(this._data=new Set(qe.getRawData())),this._data}static isInvisibleCharacter(X){return qe.getData().has(X)}static get codePoints(){return qe.getData()}}e.InvisibleCharacters=qe}),define(de[49],me([0,1,12]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.Hasher=void 0,e.hash=D,e.doHash=E,e.numberHash=A,e.stringHash=P,e.toHexString=g;function D(n){return E(n,0)}function E(n,r){switch(typeof n){case"object":return n===null?A(349,r):Array.isArray(n)?h(n,r):s(n,r);case"string":return P(n,r);case"boolean":return T(n,r);case"number":return A(n,r);case"undefined":return A(937,r);default:return A(617,r)}}function A(n,r){return(r<<5)-r+n|0}function T(n,r){return A(n?433:863,r)}function P(n,r){r=A(149417,r);for(let f=0,C=n.length;f<C;f++)r=A(n.charCodeAt(f),r);return r}function h(n,r){return r=A(104579,r),n.reduce((f,C)=>E(C,f),r)}function s(n,r){return r=A(181387,r),Object.keys(n).sort().reduce((f,C)=>(f=P(C,f),E(n[C],f)),r)}class w{constructor(){this._value=0}get value(){return this._value}hash(r){return this._value=E(r,this._value),this._value}}e.Hasher=w;var c;(function(n){n[n.BLOCK_SIZE=64]="BLOCK_SIZE",n[n.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(c||(c={}));function b(n,r,f=32){const C=f-r,i=~((1<<C)-1);return(n<<r|(i&n)>>>C)>>>0}function o(n,r=0,f=n.byteLength,C=0){for(let i=0;i<f;i++)n[r+i]=C}function a(n,r,f="0"){for(;n.length<r;)n=f+n;return n}function g(n,r=32){return n instanceof ArrayBuffer?Array.from(new Uint8Array(n)).map(f=>f.toString(16).padStart(2,"0")).join(""):a((n>>>0).toString(16),r/4)}class d{static{this._bigBlock32=new DataView(new ArrayBuffer(320))}constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(r){const f=r.length;if(f===0)return;const C=this._buff;let i=this._buffLen,t=this._leftoverHighSurrogate,l,L;for(t!==0?(l=t,L=-1,t=0):(l=r.charCodeAt(0),L=0);;){let p=l;if(v.isHighSurrogate(l))if(L+1<f){const k=r.charCodeAt(L+1);v.isLowSurrogate(k)?(L++,p=v.computeCodePoint(l,k)):p=65533}else{t=l;break}else v.isLowSurrogate(l)&&(p=65533);if(i=this._push(C,i,p),L++,L<f)l=r.charCodeAt(L);else break}this._buffLen=i,this._leftoverHighSurrogate=t}_push(r,f,C){return C<128?r[f++]=C:C<2048?(r[f++]=192|(C&1984)>>>6,r[f++]=128|(C&63)>>>0):C<65536?(r[f++]=224|(C&61440)>>>12,r[f++]=128|(C&4032)>>>6,r[f++]=128|(C&63)>>>0):(r[f++]=240|(C&1835008)>>>18,r[f++]=128|(C&258048)>>>12,r[f++]=128|(C&4032)>>>6,r[f++]=128|(C&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,r[0]=r[64],r[1]=r[65],r[2]=r[66]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,o(this._buff,this._buffLen),this._buffLen>56&&(this._step(),o(this._buff));const r=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(r/4294967296),!1),this._buffDV.setUint32(60,r%4294967296,!1),this._step()}_step(){const r=d._bigBlock32,f=this._buffDV;for(let y=0;y<64;y+=4)r.setUint32(y,f.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)r.setUint32(y,b(r.getUint32(y-12,!1)^r.getUint32(y-32,!1)^r.getUint32(y-56,!1)^r.getUint32(y-64,!1),1),!1);let C=this._h0,i=this._h1,t=this._h2,l=this._h3,L=this._h4,p,k,S;for(let y=0;y<80;y++)y<20?(p=i&t|~i&l,k=1518500249):y<40?(p=i^t^l,k=1859775393):y<60?(p=i&t|i&l|t&l,k=2400959708):(p=i^t^l,k=3395469782),S=b(C,5)+p+L+k+r.getUint32(y*4,!1)&4294967295,L=l,l=t,t=b(i,30),i=C,C=S;this._h0=this._h0+C&4294967295,this._h1=this._h1+i&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+L&4294967295}}e.StringSHA1=d}),define(de[50],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(de[51],me([0,1,16,12]),function(ae,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class E{constructor(){this._value="",this._pos=0}reset(o){return this._value=o,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(o){const a=o.charCodeAt(0),g=this._value.charCodeAt(this._pos);return a-g}value(){return this._value[this._pos]}}e.StringIterator=E;class A{constructor(o=!0){this._caseSensitive=o}reset(o){return this._value=o,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let o=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(o)this._from++;else break;else o=!1;return this}cmp(o){return this._caseSensitive?(0,D.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=A;class T{constructor(o=!0,a=!0){this._splitOnBackslash=o,this._caseSensitive=a}reset(o){this._from=0,this._to=0,this._value=o,this._valueLen=o.length;for(let a=o.length-1;a>=0;a--,this._valueLen--){const g=this._value.charCodeAt(a);if(!(g===47||this._splitOnBackslash&&g===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let o=!0;for(;this._to<this._valueLen;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(o)this._from++;else break;else o=!1}return this}cmp(o){return this._caseSensitive?(0,D.compareSubstring)(o,this._value,0,o.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(o,this._value,0,o.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=T;var P;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(P||(P={}));class h{constructor(o,a){this._ignorePathCasing=o,this._ignoreQueryAndFragment=a,this._states=[],this._stateIdx=0}reset(o){return this._value=o,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new T(!1,!this._ignorePathCasing(o)),this._pathIterator.reset(o.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(o)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(o){if(this._states[this._stateIdx]===1)return(0,D.compareIgnoreCase)(o,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,D.compareIgnoreCase)(o,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(o);if(this._states[this._stateIdx]===4)return(0,D.compare)(o,this._value.query);if(this._states[this._stateIdx]===5)return(0,D.compare)(o,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class s{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const o=this.right;return this.right=o.left,o.left=this,this.updateHeight(),o.updateHeight(),o}rotateRight(){const o=this.left;return this.left=o.right,o.right=this,this.updateHeight(),o.updateHeight(),o}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(w||(w={}));class c{static forUris(o=()=>!1,a=()=>!1){return new c(new h(o,a))}static forPaths(o=!1){return new c(new T(void 0,!o))}static forStrings(){return new c(new E)}static forConfigKeys(){return new c(new A)}constructor(o){this._iter=o}clear(){this._root=void 0}fill(o,a){if(a){const g=a.slice(0);(0,v.shuffle)(g);for(const d of g)this.set(d,o)}else{const g=o.slice(0);(0,v.shuffle)(g);for(const d of g)this.set(d[0],d[1])}}set(o,a){const g=this._iter.reset(o);let d;this._root||(this._root=new s,this._root.segment=g.value());const n=[];for(d=this._root;;){const f=g.cmp(d.segment);if(f>0)d.left||(d.left=new s,d.left.segment=g.value()),n.push([-1,d]),d=d.left;else if(f<0)d.right||(d.right=new s,d.right.segment=g.value()),n.push([1,d]),d=d.right;else if(g.hasNext())g.next(),d.mid||(d.mid=new s,d.mid.segment=g.value()),n.push([0,d]),d=d.mid;else break}const r=d.value;d.value=a,d.key=o;for(let f=n.length-1;f>=0;f--){const C=n[f][1];C.updateHeight();const i=C.balanceFactor();if(i<-1||i>1){const t=n[f][0],l=n[f+1][0];if(t===1&&l===1)n[f][1]=C.rotateLeft();else if(t===-1&&l===-1)n[f][1]=C.rotateRight();else if(t===1&&l===-1)C.right=n[f+1][1]=n[f+1][1].rotateRight(),n[f][1]=C.rotateLeft();else if(t===-1&&l===1)C.left=n[f+1][1]=n[f+1][1].rotateLeft(),n[f][1]=C.rotateRight();else throw new Error;if(f>0)switch(n[f-1][0]){case-1:n[f-1][1].left=n[f][1];break;case 1:n[f-1][1].right=n[f][1];break;case 0:n[f-1][1].mid=n[f][1];break}else this._root=n[0][1]}}return r}get(o){return this._getNode(o)?.value}_getNode(o){const a=this._iter.reset(o);let g=this._root;for(;g;){const d=a.cmp(g.segment);if(d>0)g=g.left;else if(d<0)g=g.right;else if(a.hasNext())a.next(),g=g.mid;else break}return g}has(o){const a=this._getNode(o);return!(a?.value===void 0&&a?.mid===void 0)}delete(o){return this._delete(o,!1)}deleteSuperstr(o){return this._delete(o,!0)}_delete(o,a){const g=this._iter.reset(o),d=[];let n=this._root;for(;n;){const r=g.cmp(n.segment);if(r>0)d.push([-1,n]),n=n.left;else if(r<0)d.push([1,n]),n=n.right;else if(g.hasNext())g.next(),d.push([0,n]),n=n.mid;else break}if(n){if(a?(n.left=void 0,n.mid=void 0,n.right=void 0,n.height=1):(n.key=void 0,n.value=void 0),!n.mid&&!n.value)if(n.left&&n.right){const r=this._min(n.right);if(r.key){const{key:f,value:C,segment:i}=r;this._delete(r.key,!1),n.key=f,n.value=C,n.segment=i}}else{const r=n.left??n.right;if(d.length>0){const[f,C]=d[d.length-1];switch(f){case-1:C.left=r;break;case 0:C.mid=r;break;case 1:C.right=r;break}}else this._root=r}for(let r=d.length-1;r>=0;r--){const f=d[r][1];f.updateHeight();const C=f.balanceFactor();if(C>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),d[r][1]=f.rotateLeft()):C<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),d[r][1]=f.rotateRight()),r>0)switch(d[r-1][0]){case-1:d[r-1][1].left=d[r][1];break;case 1:d[r-1][1].right=d[r][1];break;case 0:d[r-1][1].mid=d[r][1];break}else this._root=d[0][1]}}}_min(o){for(;o.left;)o=o.left;return o}findSubstr(o){const a=this._iter.reset(o);let g=this._root,d;for(;g;){const n=a.cmp(g.segment);if(n>0)g=g.left;else if(n<0)g=g.right;else if(a.hasNext())a.next(),d=g.value||d,g=g.mid;else break}return g&&g.value||d}findSuperstr(o){return this._findSuperstrOrElement(o,!1)}_findSuperstrOrElement(o,a){const g=this._iter.reset(o);let d=this._root;for(;d;){const n=g.cmp(d.segment);if(n>0)d=d.left;else if(n<0)d=d.right;else if(g.hasNext())g.next(),d=d.mid;else return d.mid?this._entries(d.mid):a?d.value:void 0}}hasElementOrSubtree(o){return this._findSuperstrOrElement(o,!0)!==void 0}forEach(o){for(const[a,g]of this)o(g,a)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(o){const a=[];return this._dfsEntries(o,a),a[Symbol.iterator]()}_dfsEntries(o,a){o&&(o.left&&this._dfsEntries(o.left,a),o.value&&a.push([o.key,o.value]),o.mid&&this._dfsEntries(o.mid,a),o.right&&this._dfsEntries(o.right,a))}_isBalanced(){const o=a=>{if(!a)return!0;const g=a.balanceFactor();return g<-1||g>1?!1:o(a.left)&&o(a.right)};return o(this._root)}}e.TernarySearchTree=c}),define(de[9],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isString=v,e.isStringArray=D,e.isObject=E,e.isTypedArray=A,e.isNumber=T,e.isIterable=P,e.isBoolean=h,e.isUndefined=s,e.isDefined=w,e.isUndefinedOrNull=c,e.assertType=b,e.assertIsDefined=o,e.assertAllDefined=a,e.isEmptyObject=d,e.isFunction=n,e.areFunctions=r,e.validateConstraints=f,e.validateConstraint=C;function v(i){return typeof i=="string"}function D(i){return Array.isArray(i)&&i.every(t=>v(t))}function E(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function A(i){const t=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof t}function T(i){return typeof i=="number"&&!isNaN(i)}function P(i){return!!i&&typeof i[Symbol.iterator]=="function"}function h(i){return i===!0||i===!1}function s(i){return typeof i>"u"}function w(i){return!c(i)}function c(i){return s(i)||i===null}function b(i,t){if(!i)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function o(i){if(c(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function a(...i){const t=[];for(let l=0;l<i.length;l++){const L=i[l];if(c(L))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);t.push(L)}return t}const g=Object.prototype.hasOwnProperty;function d(i){if(!E(i))return!1;for(const t in i)if(g.call(i,t))return!1;return!0}function n(i){return typeof i=="function"}function r(...i){return i.length>0&&i.every(n)}function f(i,t){const l=Math.min(i.length,t.length);for(let L=0;L<l;L++)C(i[L],t[L])}function C(i,t){if(v(t)){if(typeof i!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(n(t)){try{if(i instanceof t)return}catch{}if(!c(i)&&i.constructor===t||t.length===1&&t.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(de[30],me([0,1,9]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deepClone=D,e.deepFreeze=E,e.cloneAndChange=T,e.mixin=h,e.equals=s,e.safeStringify=w,e.distinct=c,e.getCaseInsensitive=b,e.filter=o,e.getAllPropertyNames=a,e.getAllMethodNames=g,e.createProxyObject=d;function D(n){if(!n||typeof n!="object"||n instanceof RegExp)return n;const r=Array.isArray(n)?[]:{};return Object.entries(n).forEach(([f,C])=>{r[f]=C&&typeof C=="object"?D(C):C}),r}function E(n){if(!n||typeof n!="object")return n;const r=[n];for(;r.length>0;){const f=r.shift();Object.freeze(f);for(const C in f)if(A.call(f,C)){const i=f[C];typeof i=="object"&&!Object.isFrozen(i)&&!(0,v.isTypedArray)(i)&&r.push(i)}}return n}const A=Object.prototype.hasOwnProperty;function T(n,r){return P(n,r,new Set)}function P(n,r,f){if((0,v.isUndefinedOrNull)(n))return n;const C=r(n);if(typeof C<"u")return C;if(Array.isArray(n)){const i=[];for(const t of n)i.push(P(t,r,f));return i}if((0,v.isObject)(n)){if(f.has(n))throw new Error("Cannot clone recursive data-structure");f.add(n);const i={};for(const t in n)A.call(n,t)&&(i[t]=P(n[t],r,f));return f.delete(n),i}return n}function h(n,r,f=!0){return(0,v.isObject)(n)?((0,v.isObject)(r)&&Object.keys(r).forEach(C=>{C in n?f&&((0,v.isObject)(n[C])&&(0,v.isObject)(r[C])?h(n[C],r[C],f):n[C]=r[C]):n[C]=r[C]}),n):r}function s(n,r){if(n===r)return!0;if(n==null||r===null||r===void 0||typeof n!=typeof r||typeof n!="object"||Array.isArray(n)!==Array.isArray(r))return!1;let f,C;if(Array.isArray(n)){if(n.length!==r.length)return!1;for(f=0;f<n.length;f++)if(!s(n[f],r[f]))return!1}else{const i=[];for(C in n)i.push(C);i.sort();const t=[];for(C in r)t.push(C);if(t.sort(),!s(i,t))return!1;for(f=0;f<i.length;f++)if(!s(n[i[f]],r[i[f]]))return!1}return!0}function w(n){const r=new Set;return JSON.stringify(n,(f,C)=>{if((0,v.isObject)(C)||Array.isArray(C)){if(r.has(C))return"[Circular]";r.add(C)}return typeof C=="bigint"?`[BigInt ${C.toString()}]`:C})}function c(n,r){const f=Object.create(null);return!n||!r||Object.keys(r).forEach(i=>{const t=n[i],l=r[i];s(t,l)||(f[i]=l)}),f}function b(n,r){const f=r.toLowerCase(),C=Object.keys(n).find(i=>i.toLowerCase()===f);return C?n[C]:n[r]}function o(n,r){const f=Object.create(null);for(const[C,i]of Object.entries(n))r(C,i)&&(f[C]=i);return f}function a(n){let r=[];for(;Object.prototype!==n;)r=r.concat(Object.getOwnPropertyNames(n)),n=Object.getPrototypeOf(n);return r}function g(n){const r=[];for(const f of a(n))typeof n[f]=="function"&&r.push(f);return r}function d(n,r){const f=i=>function(){const t=Array.prototype.slice.call(arguments,0);return r(i,t)},C={};for(const i of n)C[i]=f(i);return C}}),define(de[52],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=void 0,e.isUUID=D;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(E){return v.test(E)}e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(P){for(let h=0;h<P.length;h++)P[h]=Math.floor(Math.random()*256);return P};const A=new Uint8Array(16),T=[];for(let P=0;P<256;P++)T.push(P.toString(16).padStart(2,"0"));return function(){E(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let h=0,s="";return s+=T[A[h++]],s+=T[A[h++]],s+=T[A[h++]],s+=T[A[h++]],s+="-",s+=T[A[h++]],s+=T[A[h++]],s+="-",s+=T[A[h++]],s+=T[A[h++]],s+="-",s+=T[A[h++]],s+=T[A[h++]],s+="-",s+=T[A[h++]],s+=T[A[h++]],s+=T[A[h++]],s+=T[A[h++]],s+=T[A[h++]],s+=T[A[h++]],s}}()}),define(de[31],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=v;function v(D){return!!D.parentPort}}),define(de[53],me([13,10]),function(ae,e){return ae.create("vs/base/common/date",e)}),define(de[54],me([0,1,53]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fromNow=s,e.getDurationString=w,e.toLocalISOString=c;const D=60,E=D*60,A=E*24,T=A*7,P=A*30,h=A*365;function s(b,o,a,g){typeof b!="number"&&(b=b.getTime());const d=Math.round((new Date().getTime()-b)/1e3);if(d<-30)return(0,v.localize)(0,null,s(new Date().getTime()+d*1e3,!1));if(!g&&d<30)return(0,v.localize)(1,null);let n;return d<D?(n=d,o?n===1?a?(0,v.localize)(2,null,n):(0,v.localize)(3,null,n):a?(0,v.localize)(4,null,n):(0,v.localize)(5,null,n):n===1?a?(0,v.localize)(6,null,n):(0,v.localize)(7,null,n):a?(0,v.localize)(8,null,n):(0,v.localize)(9,null,n)):d<E?(n=Math.floor(d/D),o?n===1?a?(0,v.localize)(10,null,n):(0,v.localize)(11,null,n):a?(0,v.localize)(12,null,n):(0,v.localize)(13,null,n):n===1?a?(0,v.localize)(14,null,n):(0,v.localize)(15,null,n):a?(0,v.localize)(16,null,n):(0,v.localize)(17,null,n)):d<A?(n=Math.floor(d/E),o?n===1?a?(0,v.localize)(18,null,n):(0,v.localize)(19,null,n):a?(0,v.localize)(20,null,n):(0,v.localize)(21,null,n):n===1?a?(0,v.localize)(22,null,n):(0,v.localize)(23,null,n):a?(0,v.localize)(24,null,n):(0,v.localize)(25,null,n)):d<T?(n=Math.floor(d/A),o?n===1?(0,v.localize)(26,null,n):(0,v.localize)(27,null,n):n===1?(0,v.localize)(28,null,n):(0,v.localize)(29,null,n)):d<P?(n=Math.floor(d/T),o?n===1?a?(0,v.localize)(30,null,n):(0,v.localize)(31,null,n):a?(0,v.localize)(32,null,n):(0,v.localize)(33,null,n):n===1?a?(0,v.localize)(34,null,n):(0,v.localize)(35,null,n):a?(0,v.localize)(36,null,n):(0,v.localize)(37,null,n)):d<h?(n=Math.floor(d/P),o?n===1?a?(0,v.localize)(38,null,n):(0,v.localize)(39,null,n):a?(0,v.localize)(40,null,n):(0,v.localize)(41,null,n):n===1?a?(0,v.localize)(42,null,n):(0,v.localize)(43,null,n):a?(0,v.localize)(44,null,n):(0,v.localize)(45,null,n)):(n=Math.floor(d/h),o?n===1?a?(0,v.localize)(46,null,n):(0,v.localize)(47,null,n):a?(0,v.localize)(48,null,n):(0,v.localize)(49,null,n):n===1?a?(0,v.localize)(50,null,n):(0,v.localize)(51,null,n):a?(0,v.localize)(52,null,n):(0,v.localize)(53,null,n))}function w(b,o){const a=Math.abs(b/1e3);return a<1?o?(0,v.localize)(54,null,b):(0,v.localize)(55,null,b):a<D?o?(0,v.localize)(56,null,Math.round(b)/1e3):(0,v.localize)(57,null,Math.round(b)/1e3):a<E?o?(0,v.localize)(58,null,Math.round(b/(1e3*D))):(0,v.localize)(59,null,Math.round(b/(1e3*D))):a<A?o?(0,v.localize)(60,null,Math.round(b/(1e3*E))):(0,v.localize)(61,null,Math.round(b/(1e3*E))):(0,v.localize)(62,null,Math.round(b/(1e3*A)))}function c(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(de[55],me([13,10]),function(ae,e){return ae.create("vs/base/common/errorMessage",e)}),define(de[56],me([0,1,16,9,55]),function(ae,e,v,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=h,e.isErrorWithActions=s,e.createErrorWithActions=w;function A(c,b){return b&&(c.stack||c.stacktrace)?E.localize(0,null,P(c),T(c.stack)||T(c.stacktrace)):P(c)}function T(c){return Array.isArray(c)?c.join(`
`):c}function P(c){return c.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${c.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof c.code=="string"&&typeof c.errno=="number"&&typeof c.syscall=="string"?E.localize(1,null,c.message):c.message||E.localize(2,null)}function h(c=null,b=!1){if(!c)return E.localize(3,null);if(Array.isArray(c)){const o=v.coalesce(c),a=h(o[0],b);return o.length>1?E.localize(4,null,a,o.length):a}if(D.isString(c))return c;if(c.detail){const o=c.detail;if(o.error)return A(o.error,b);if(o.exception)return A(o.exception,b)}return c.stack?A(c,b):c.message?c.message:E.localize(5,null)}function s(c){const b=c;return b instanceof Error&&Array.isArray(b.actions)}function w(c,b){let o;return typeof c=="string"?o=new Error(c):o=c,o.actions=b,o}}),define(de[57],me([13,10]),function(ae,e){return ae.create("vs/base/common/platform",e)}),define(de[3],me([0,1,57]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.webWorkerOrigin=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.Platform=e.LANGUAGE_DEFAULT=void 0,e.PlatformToString=l,e.isLittleEndian=U,e.isBigSurOrNewer=K,e.LANGUAGE_DEFAULT="en";let D=!1,E=!1,A=!1,T=!1,P=!1,h=!1,s=!1,w=!1,c=!1,b=!1,o,a=e.LANGUAGE_DEFAULT,g=e.LANGUAGE_DEFAULT,d,n;const r=globalThis;let f;typeof r.vscode<"u"&&typeof r.vscode.process<"u"?f=r.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(f=process);const C=typeof f?.versions?.electron=="string",i=C&&f?.type==="renderer";if(typeof f=="object"){D=f.platform==="win32",E=f.platform==="darwin",A=f.platform==="linux",T=A&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,s=C,c=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,o=e.LANGUAGE_DEFAULT,a=e.LANGUAGE_DEFAULT;const z=f.env.VSCODE_NLS_CONFIG;if(z)try{const O=JSON.parse(z),m=O.availableLanguages["*"];o=O.locale,g=O.osLocale,a=m||e.LANGUAGE_DEFAULT,d=O._translationsConfigFile}catch{}P=!0}else typeof navigator=="object"&&!i?(n=navigator.userAgent,D=n.indexOf("Windows")>=0,E=n.indexOf("Macintosh")>=0,w=(n.indexOf("Macintosh")>=0||n.indexOf("iPad")>=0||n.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=n.indexOf("Linux")>=0,b=n?.indexOf("Mobi")>=0,h=!0,o=v.getConfiguredDefaultLocale(v.localize(0,null))||e.LANGUAGE_DEFAULT,a=o,g=navigator.language):console.error("Unable to resolve platform.");var t;(function(z){z[z.Web=0]="Web",z[z.Mac=1]="Mac",z[z.Linux=2]="Linux",z[z.Windows=3]="Windows"})(t||(e.Platform=t={}));function l(z){switch(z){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let L=0;E?L=1:D?L=3:A&&(L=2),e.isWindows=D,e.isMacintosh=E,e.isLinux=A,e.isLinuxSnap=T,e.isNative=P,e.isElectron=s,e.isWeb=h,e.isWebWorker=h&&typeof r.importScripts=="function",e.webWorkerOrigin=e.isWebWorker?r.origin:void 0,e.isIOS=w,e.isMobile=b,e.isCI=c,e.platform=L,e.userAgent=n,e.language=a;var p;(function(z){function O(){return e.language}z.value=O;function m(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}z.isDefaultVariant=m;function R(){return e.language==="en"}z.isDefault=R})(p||(e.Language=p={})),e.locale=o,e.platformLocale=g,e.translationsConfigFile=d,e.setTimeout0IsFaster=typeof r.postMessage=="function"&&!r.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const z=[];r.addEventListener("message",m=>{if(m.data&&m.data.vscodeScheduleAsyncWork)for(let R=0,_=z.length;R<_;R++){const I=z[R];if(I.id===m.data.vscodeScheduleAsyncWork){z.splice(R,1),I.callback();return}}});let O=0;return m=>{const R=++O;z.push({id:R,callback:m}),r.postMessage({vscodeScheduleAsyncWork:R},"*")}}return z=>setTimeout(z)})();var k;(function(z){z[z.Windows=1]="Windows",z[z.Macintosh=2]="Macintosh",z[z.Linux=3]="Linux"})(k||(e.OperatingSystem=k={})),e.OS=E||w?2:D?1:3;let S=!0,y=!1;function U(){if(!y){y=!0;const z=new Uint8Array(2);z[0]=1,z[1]=2,S=new Uint16Array(z.buffer)[0]===513}return S}e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0);function K(z){return parseFloat(z)>=20}}),define(de[15],me([0,1,3]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let D;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.process<"u"){const A=E.process;D={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=D.cwd,e.env=D.env,e.platform=D.platform,e.arch=D.arch}),define(de[5],me([0,1,15]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const D=65,E=97,A=90,T=122,P=46,h=47,s=92,w=58,c=63;class b extends Error{constructor(l,L,p){let k;typeof L=="string"&&L.indexOf("not ")===0?(k="must not be",L=L.replace(/^not /,"")):k="must be";const S=l.indexOf(".")!==-1?"property":"argument";let y=`The "${l}" ${S} ${k} of type ${L}`;y+=`. Received type ${typeof p}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function o(t,l){if(t===null||typeof t!="object")throw new b(l,"Object",t)}function a(t,l){if(typeof t!="string")throw new b(l,"string",t)}const g=v.platform==="win32";function d(t){return t===h||t===s}function n(t){return t===h}function r(t){return t>=D&&t<=A||t>=E&&t<=T}function f(t,l,L,p){let k="",S=0,y=-1,U=0,K=0;for(let z=0;z<=t.length;++z){if(z<t.length)K=t.charCodeAt(z);else{if(p(K))break;K=h}if(p(K)){if(!(y===z-1||U===1))if(U===2){if(k.length<2||S!==2||k.charCodeAt(k.length-1)!==P||k.charCodeAt(k.length-2)!==P){if(k.length>2){const O=k.lastIndexOf(L);O===-1?(k="",S=0):(k=k.slice(0,O),S=k.length-1-k.lastIndexOf(L)),y=z,U=0;continue}else if(k.length!==0){k="",S=0,y=z,U=0;continue}}l&&(k+=k.length>0?`${L}..`:"..",S=2)}else k.length>0?k+=`${L}${t.slice(y+1,z)}`:k=t.slice(y+1,z),S=z-y-1;y=z,U=0}else K===P&&U!==-1?++U:U=-1}return k}function C(t,l){o(l,"pathObject");const L=l.dir||l.root,p=l.base||`${l.name||""}${l.ext||""}`;return L?L===l.root?`${L}${p}`:`${L}${t}${p}`:p}e.win32={resolve(...t){let l="",L="",p=!1;for(let k=t.length-1;k>=-1;k--){let S;if(k>=0){if(S=t[k],a(S,"path"),S.length===0)continue}else l.length===0?S=v.cwd():(S=v.env[`=${l}`]||v.cwd(),(S===void 0||S.slice(0,2).toLowerCase()!==l.toLowerCase()&&S.charCodeAt(2)===s)&&(S=`${l}\\`));const y=S.length;let U=0,K="",z=!1;const O=S.charCodeAt(0);if(y===1)d(O)&&(U=1,z=!0);else if(d(O))if(z=!0,d(S.charCodeAt(1))){let m=2,R=m;for(;m<y&&!d(S.charCodeAt(m));)m++;if(m<y&&m!==R){const _=S.slice(R,m);for(R=m;m<y&&d(S.charCodeAt(m));)m++;if(m<y&&m!==R){for(R=m;m<y&&!d(S.charCodeAt(m));)m++;(m===y||m!==R)&&(K=`\\\\${_}\\${S.slice(R,m)}`,U=m)}}}else U=1;else r(O)&&S.charCodeAt(1)===w&&(K=S.slice(0,2),U=2,y>2&&d(S.charCodeAt(2))&&(z=!0,U=3));if(K.length>0)if(l.length>0){if(K.toLowerCase()!==l.toLowerCase())continue}else l=K;if(p){if(l.length>0)break}else if(L=`${S.slice(U)}\\${L}`,p=z,z&&l.length>0)break}return L=f(L,!p,"\\",d),p?`${l}\\${L}`:`${l}${L}`||"."},normalize(t){a(t,"path");const l=t.length;if(l===0)return".";let L=0,p,k=!1;const S=t.charCodeAt(0);if(l===1)return n(S)?"\\":t;if(d(S))if(k=!0,d(t.charCodeAt(1))){let U=2,K=U;for(;U<l&&!d(t.charCodeAt(U));)U++;if(U<l&&U!==K){const z=t.slice(K,U);for(K=U;U<l&&d(t.charCodeAt(U));)U++;if(U<l&&U!==K){for(K=U;U<l&&!d(t.charCodeAt(U));)U++;if(U===l)return`\\\\${z}\\${t.slice(K)}\\`;U!==K&&(p=`\\\\${z}\\${t.slice(K,U)}`,L=U)}}}else L=1;else r(S)&&t.charCodeAt(1)===w&&(p=t.slice(0,2),L=2,l>2&&d(t.charCodeAt(2))&&(k=!0,L=3));let y=L<l?f(t.slice(L),!k,"\\",d):"";return y.length===0&&!k&&(y="."),y.length>0&&d(t.charCodeAt(l-1))&&(y+="\\"),p===void 0?k?`\\${y}`:y:k?`${p}\\${y}`:`${p}${y}`},isAbsolute(t){a(t,"path");const l=t.length;if(l===0)return!1;const L=t.charCodeAt(0);return d(L)||l>2&&r(L)&&t.charCodeAt(1)===w&&d(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let l,L;for(let S=0;S<t.length;++S){const y=t[S];a(y,"path"),y.length>0&&(l===void 0?l=L=y:l+=`\\${y}`)}if(l===void 0)return".";let p=!0,k=0;if(typeof L=="string"&&d(L.charCodeAt(0))){++k;const S=L.length;S>1&&d(L.charCodeAt(1))&&(++k,S>2&&(d(L.charCodeAt(2))?++k:p=!1))}if(p){for(;k<l.length&&d(l.charCodeAt(k));)k++;k>=2&&(l=`\\${l.slice(k)}`)}return e.win32.normalize(l)},relative(t,l){if(a(t,"from"),a(l,"to"),t===l)return"";const L=e.win32.resolve(t),p=e.win32.resolve(l);if(L===p||(t=L.toLowerCase(),l=p.toLowerCase(),t===l))return"";let k=0;for(;k<t.length&&t.charCodeAt(k)===s;)k++;let S=t.length;for(;S-1>k&&t.charCodeAt(S-1)===s;)S--;const y=S-k;let U=0;for(;U<l.length&&l.charCodeAt(U)===s;)U++;let K=l.length;for(;K-1>U&&l.charCodeAt(K-1)===s;)K--;const z=K-U,O=y<z?y:z;let m=-1,R=0;for(;R<O;R++){const I=t.charCodeAt(k+R);if(I!==l.charCodeAt(U+R))break;I===s&&(m=R)}if(R!==O){if(m===-1)return p}else{if(z>O){if(l.charCodeAt(U+R)===s)return p.slice(U+R+1);if(R===2)return p.slice(U+R)}y>O&&(t.charCodeAt(k+R)===s?m=R:R===2&&(m=3)),m===-1&&(m=0)}let _="";for(R=k+m+1;R<=S;++R)(R===S||t.charCodeAt(R)===s)&&(_+=_.length===0?"..":"\\..");return U+=m,_.length>0?`${_}${p.slice(U,K)}`:(p.charCodeAt(U)===s&&++U,p.slice(U,K))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const l=e.win32.resolve(t);if(l.length<=2)return t;if(l.charCodeAt(0)===s){if(l.charCodeAt(1)===s){const L=l.charCodeAt(2);if(L!==c&&L!==P)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(r(l.charCodeAt(0))&&l.charCodeAt(1)===w&&l.charCodeAt(2)===s)return`\\\\?\\${l}`;return t},dirname(t){a(t,"path");const l=t.length;if(l===0)return".";let L=-1,p=0;const k=t.charCodeAt(0);if(l===1)return d(k)?t:".";if(d(k)){if(L=p=1,d(t.charCodeAt(1))){let U=2,K=U;for(;U<l&&!d(t.charCodeAt(U));)U++;if(U<l&&U!==K){for(K=U;U<l&&d(t.charCodeAt(U));)U++;if(U<l&&U!==K){for(K=U;U<l&&!d(t.charCodeAt(U));)U++;if(U===l)return t;U!==K&&(L=p=U+1)}}}}else r(k)&&t.charCodeAt(1)===w&&(L=l>2&&d(t.charCodeAt(2))?3:2,p=L);let S=-1,y=!0;for(let U=l-1;U>=p;--U)if(d(t.charCodeAt(U))){if(!y){S=U;break}}else y=!1;if(S===-1){if(L===-1)return".";S=L}return t.slice(0,S)},basename(t,l){l!==void 0&&a(l,"ext"),a(t,"path");let L=0,p=-1,k=!0,S;if(t.length>=2&&r(t.charCodeAt(0))&&t.charCodeAt(1)===w&&(L=2),l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let y=l.length-1,U=-1;for(S=t.length-1;S>=L;--S){const K=t.charCodeAt(S);if(d(K)){if(!k){L=S+1;break}}else U===-1&&(k=!1,U=S+1),y>=0&&(K===l.charCodeAt(y)?--y===-1&&(p=S):(y=-1,p=U))}return L===p?p=U:p===-1&&(p=t.length),t.slice(L,p)}for(S=t.length-1;S>=L;--S)if(d(t.charCodeAt(S))){if(!k){L=S+1;break}}else p===-1&&(k=!1,p=S+1);return p===-1?"":t.slice(L,p)},extname(t){a(t,"path");let l=0,L=-1,p=0,k=-1,S=!0,y=0;t.length>=2&&t.charCodeAt(1)===w&&r(t.charCodeAt(0))&&(l=p=2);for(let U=t.length-1;U>=l;--U){const K=t.charCodeAt(U);if(d(K)){if(!S){p=U+1;break}continue}k===-1&&(S=!1,k=U+1),K===P?L===-1?L=U:y!==1&&(y=1):L!==-1&&(y=-1)}return L===-1||k===-1||y===0||y===1&&L===k-1&&L===p+1?"":t.slice(L,k)},format:C.bind(null,"\\"),parse(t){a(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const L=t.length;let p=0,k=t.charCodeAt(0);if(L===1)return d(k)?(l.root=l.dir=t,l):(l.base=l.name=t,l);if(d(k)){if(p=1,d(t.charCodeAt(1))){let m=2,R=m;for(;m<L&&!d(t.charCodeAt(m));)m++;if(m<L&&m!==R){for(R=m;m<L&&d(t.charCodeAt(m));)m++;if(m<L&&m!==R){for(R=m;m<L&&!d(t.charCodeAt(m));)m++;m===L?p=m:m!==R&&(p=m+1)}}}}else if(r(k)&&t.charCodeAt(1)===w){if(L<=2)return l.root=l.dir=t,l;if(p=2,d(t.charCodeAt(2))){if(L===3)return l.root=l.dir=t,l;p=3}}p>0&&(l.root=t.slice(0,p));let S=-1,y=p,U=-1,K=!0,z=t.length-1,O=0;for(;z>=p;--z){if(k=t.charCodeAt(z),d(k)){if(!K){y=z+1;break}continue}U===-1&&(K=!1,U=z+1),k===P?S===-1?S=z:O!==1&&(O=1):S!==-1&&(O=-1)}return U!==-1&&(S===-1||O===0||O===1&&S===U-1&&S===y+1?l.base=l.name=t.slice(y,U):(l.name=t.slice(y,S),l.base=t.slice(y,U),l.ext=t.slice(S,U))),y>0&&y!==p?l.dir=t.slice(0,y-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(g){const t=/\\/g;return()=>{const l=v.cwd().replace(t,"/");return l.slice(l.indexOf("/"))}}return()=>v.cwd()})();e.posix={resolve(...t){let l="",L=!1;for(let p=t.length-1;p>=-1&&!L;p--){const k=p>=0?t[p]:i();a(k,"path"),k.length!==0&&(l=`${k}/${l}`,L=k.charCodeAt(0)===h)}return l=f(l,!L,"/",n),L?`/${l}`:l.length>0?l:"."},normalize(t){if(a(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===h,L=t.charCodeAt(t.length-1)===h;return t=f(t,!l,"/",n),t.length===0?l?"/":L?"./":".":(L&&(t+="/"),l?`/${t}`:t)},isAbsolute(t){return a(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let l;for(let L=0;L<t.length;++L){const p=t[L];a(p,"path"),p.length>0&&(l===void 0?l=p:l+=`/${p}`)}return l===void 0?".":e.posix.normalize(l)},relative(t,l){if(a(t,"from"),a(l,"to"),t===l||(t=e.posix.resolve(t),l=e.posix.resolve(l),t===l))return"";const L=1,p=t.length,k=p-L,S=1,y=l.length-S,U=k<y?k:y;let K=-1,z=0;for(;z<U;z++){const m=t.charCodeAt(L+z);if(m!==l.charCodeAt(S+z))break;m===h&&(K=z)}if(z===U)if(y>U){if(l.charCodeAt(S+z)===h)return l.slice(S+z+1);if(z===0)return l.slice(S+z)}else k>U&&(t.charCodeAt(L+z)===h?K=z:z===0&&(K=0));let O="";for(z=L+K+1;z<=p;++z)(z===p||t.charCodeAt(z)===h)&&(O+=O.length===0?"..":"/..");return`${O}${l.slice(S+K)}`},toNamespacedPath(t){return t},dirname(t){if(a(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===h;let L=-1,p=!0;for(let k=t.length-1;k>=1;--k)if(t.charCodeAt(k)===h){if(!p){L=k;break}}else p=!1;return L===-1?l?"/":".":l&&L===1?"//":t.slice(0,L)},basename(t,l){l!==void 0&&a(l,"ext"),a(t,"path");let L=0,p=-1,k=!0,S;if(l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let y=l.length-1,U=-1;for(S=t.length-1;S>=0;--S){const K=t.charCodeAt(S);if(K===h){if(!k){L=S+1;break}}else U===-1&&(k=!1,U=S+1),y>=0&&(K===l.charCodeAt(y)?--y===-1&&(p=S):(y=-1,p=U))}return L===p?p=U:p===-1&&(p=t.length),t.slice(L,p)}for(S=t.length-1;S>=0;--S)if(t.charCodeAt(S)===h){if(!k){L=S+1;break}}else p===-1&&(k=!1,p=S+1);return p===-1?"":t.slice(L,p)},extname(t){a(t,"path");let l=-1,L=0,p=-1,k=!0,S=0;for(let y=t.length-1;y>=0;--y){const U=t.charCodeAt(y);if(U===h){if(!k){L=y+1;break}continue}p===-1&&(k=!1,p=y+1),U===P?l===-1?l=y:S!==1&&(S=1):l!==-1&&(S=-1)}return l===-1||p===-1||S===0||S===1&&l===p-1&&l===L+1?"":t.slice(l,p)},format:C.bind(null,"/"),parse(t){a(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const L=t.charCodeAt(0)===h;let p;L?(l.root="/",p=1):p=0;let k=-1,S=0,y=-1,U=!0,K=t.length-1,z=0;for(;K>=p;--K){const O=t.charCodeAt(K);if(O===h){if(!U){S=K+1;break}continue}y===-1&&(U=!1,y=K+1),O===P?k===-1?k=K:z!==1&&(z=1):k!==-1&&(z=-1)}if(y!==-1){const O=S===0&&L?1:S;k===-1||z===0||z===1&&k===y-1&&k===S+1?l.base=l.name=t.slice(O,y):(l.name=t.slice(O,k),l.base=t.slice(O,y),l.ext=t.slice(k,y))}return S>0?l.dir=t.slice(0,S-1):L&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g?e.win32.normalize:e.posix.normalize,e.isAbsolute=g?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g?e.win32.join:e.posix.join,e.resolve=g?e.win32.resolve:e.posix.resolve,e.relative=g?e.win32.relative:e.posix.relative,e.dirname=g?e.win32.dirname:e.posix.dirname,e.basename=g?e.win32.basename:e.posix.basename,e.extname=g?e.win32.extname:e.posix.extname,e.format=g?e.win32.format:e.posix.format,e.parse=g?e.win32.parse:e.posix.parse,e.toNamespacedPath=g?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g?e.win32.sep:e.posix.sep,e.delimiter=g?e.win32.delimiter:e.posix.delimiter}),define(de[32],me([0,1,5,3,12,9]),function(ae,e,v,D,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPathSeparator=T,e.toSlashes=P,e.toPosixPath=h,e.getRoot=s,e.isUNC=w,e.isValidBasename=a,e.isEqual=g,e.isEqualOrParent=d,e.isWindowsDriveLetter=n,e.sanitizeFilePath=r,e.removeTrailingPathSeparator=f,e.isRootOrDriveLetter=C,e.hasDriveLetter=i,e.getDriveLetter=t,e.indexOfPath=l,e.parseLineAndColumnAware=L,e.randomPath=S;function T(y){return y===47||y===92}function P(y){return y.replace(/[\\/]/g,v.posix.sep)}function h(y){return y.indexOf("/")===-1&&(y=P(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function s(y,U=v.posix.sep){if(!y)return"";const K=y.length,z=y.charCodeAt(0);if(T(z)){if(T(y.charCodeAt(1))&&!T(y.charCodeAt(2))){let m=3;const R=m;for(;m<K&&!T(y.charCodeAt(m));m++);if(R!==m&&!T(y.charCodeAt(m+1))){for(m+=1;m<K;m++)if(T(y.charCodeAt(m)))return y.slice(0,m+1).replace(/[\\/]/g,U)}}return U}else if(n(z)&&y.charCodeAt(1)===58)return T(y.charCodeAt(2))?y.slice(0,2)+U:y.slice(0,2);let O=y.indexOf("://");if(O!==-1){for(O+=3;O<K;O++)if(T(y.charCodeAt(O)))return y.slice(0,O+1)}return""}function w(y){if(!D.isWindows||!y||y.length<5)return!1;let U=y.charCodeAt(0);if(U!==92||(U=y.charCodeAt(1),U!==92))return!1;let K=2;const z=K;for(;K<y.length&&(U=y.charCodeAt(K),U!==92);K++);return!(z===K||(U=y.charCodeAt(K+1),isNaN(U)||U===92))}const c=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,o=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(y,U=D.isWindows){const K=U?c:b;return!(!y||y.length===0||/^\s+$/.test(y)||(K.lastIndex=0,K.test(y))||U&&o.test(y)||y==="."||y===".."||U&&y[y.length-1]==="."||U&&y.length!==y.trim().length||y.length>255)}function g(y,U,K){const z=y===U;return!K||z?z:!y||!U?!1:(0,E.equalsIgnoreCase)(y,U)}function d(y,U,K,z=v.sep){if(y===U)return!0;if(!y||!U||U.length>y.length)return!1;if(K){if(!(0,E.startsWithIgnoreCase)(y,U))return!1;if(U.length===y.length)return!0;let m=U.length;return U.charAt(U.length-1)===z&&m--,y.charAt(m)===z}return U.charAt(U.length-1)!==z&&(U+=z),y.indexOf(U)===0}function n(y){return y>=65&&y<=90||y>=97&&y<=122}function r(y,U){return D.isWindows&&y.endsWith(":")&&(y+=v.sep),(0,v.isAbsolute)(y)||(y=(0,v.join)(U,y)),y=(0,v.normalize)(y),f(y)}function f(y){return D.isWindows?(y=(0,E.rtrim)(y,v.sep),y.endsWith(":")&&(y+=v.sep)):(y=(0,E.rtrim)(y,v.sep),y||(y=v.sep)),y}function C(y){const U=(0,v.normalize)(y);return D.isWindows?y.length>3?!1:i(U)&&(y.length===2||U.charCodeAt(2)===92):U===v.posix.sep}function i(y,U=D.isWindows){return U?n(y.charCodeAt(0))&&y.charCodeAt(1)===58:!1}function t(y,U=D.isWindows){return i(y,U)?y[0]:void 0}function l(y,U,K){return U.length>y.length?-1:y===U?0:(K&&(y=y.toLowerCase(),U=U.toLowerCase()),y.indexOf(U))}function L(y){const U=y.split(":");let K,z,O;for(const m of U){const R=Number(m);(0,A.isNumber)(R)?z===void 0?z=R:O===void 0&&(O=R):K=K?[K,m].join(":"):m}if(!K)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:K,line:z!==void 0?z:void 0,column:O!==void 0?O:z!==void 0?1:void 0}}const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",k="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(y,U,K=8){let z="";for(let m=0;m<K;m++){let R;m===0&&D.isWindows&&!U&&(K===3||K===4)?R=k:R=p,z+=R.charAt(Math.floor(Math.random()*R.length))}let O;return U?O=`${U}-${z}`:O=z,y?(0,v.join)(y,O):O}}),define(de[33],me([0,1,3]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.sanitizeProcessEnvironment=A,e.removeDangerousEnvVariables=T;var D;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(D||(e.Source=D={}));var E;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(E||(e.TerminateResponseCode=E={}));function A(P,...h){const s=h.reduce((b,o)=>(b[o]=!0,b),{}),w=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(b=>!s[b]).forEach(b=>{for(let o=0;o<w.length;o++)if(b.search(w[o])!==-1){delete P[b];break}})}function T(P){P&&(delete P.DEBUG,v.isMacintosh&&delete P.DYLD_LIBRARY_PATH,v.isLinux&&delete P.LD_PRELOAD)}}),define(de[6],me([0,1,5,3]),function(ae,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.isUriComponents=a,e.uriToFsPath=C;const E=/^\w[\w\d+.-]*$/,A=/^\//,T=/^\/\//;function P(p,k){if(!p.scheme&&k)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${p.authority}", path: "${p.path}", query: "${p.query}", fragment: "${p.fragment}"}`);if(p.scheme&&!E.test(p.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(p.path){if(p.authority){if(!A.test(p.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(p.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(p,k){return!p&&!k?"file":p}function s(p,k){switch(p){case"https":case"http":case"file":k?k[0]!==c&&(k=c+k):k=c;break}return k}const w="",c="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class o{static isUri(k){return k instanceof o?!0:k?typeof k.authority=="string"&&typeof k.fragment=="string"&&typeof k.path=="string"&&typeof k.query=="string"&&typeof k.scheme=="string"&&typeof k.fsPath=="string"&&typeof k.with=="function"&&typeof k.toString=="function":!1}constructor(k,S,y,U,K,z=!1){typeof k=="object"?(this.scheme=k.scheme||w,this.authority=k.authority||w,this.path=k.path||w,this.query=k.query||w,this.fragment=k.fragment||w):(this.scheme=h(k,z),this.authority=S||w,this.path=s(this.scheme,y||w),this.query=U||w,this.fragment=K||w,P(this,z))}get fsPath(){return C(this,!1)}with(k){if(!k)return this;let{scheme:S,authority:y,path:U,query:K,fragment:z}=k;return S===void 0?S=this.scheme:S===null&&(S=w),y===void 0?y=this.authority:y===null&&(y=w),U===void 0?U=this.path:U===null&&(U=w),K===void 0?K=this.query:K===null&&(K=w),z===void 0?z=this.fragment:z===null&&(z=w),S===this.scheme&&y===this.authority&&U===this.path&&K===this.query&&z===this.fragment?this:new d(S,y,U,K,z)}static parse(k,S=!1){const y=b.exec(k);return y?new d(y[2]||w,L(y[4]||w),L(y[5]||w),L(y[7]||w),L(y[9]||w),S):new d(w,w,w,w,w)}static file(k){let S=w;if(D.isWindows&&(k=k.replace(/\\/g,c)),k[0]===c&&k[1]===c){const y=k.indexOf(c,2);y===-1?(S=k.substring(2),k=c):(S=k.substring(2,y),k=k.substring(y)||c)}return new d("file",S,k,w,w)}static from(k,S){return new d(k.scheme,k.authority,k.path,k.query,k.fragment,S)}static joinPath(k,...S){if(!k.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return D.isWindows&&k.scheme==="file"?y=o.file(v.win32.join(C(k,!0),...S)).path:y=v.posix.join(k.path,...S),k.with({path:y})}toString(k=!1){return i(this,k)}toJSON(){return this}static revive(k){if(k){if(k instanceof o)return k;{const S=new d(k);return S._formatted=k.external??null,S._fsPath=k._sep===g?k.fsPath??null:null,S}}else return k}}e.URI=o;function a(p){return!p||typeof p!="object"?!1:typeof p.scheme=="string"&&(typeof p.authority=="string"||typeof p.authority>"u")&&(typeof p.path=="string"||typeof p.path>"u")&&(typeof p.query=="string"||typeof p.query>"u")&&(typeof p.fragment=="string"||typeof p.fragment>"u")}const g=D.isWindows?1:void 0;class d extends o{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=C(this,!1)),this._fsPath}toString(k=!1){return k?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const k={$mid:1};return this._fsPath&&(k.fsPath=this._fsPath,k._sep=g),this._formatted&&(k.external=this._formatted),this.path&&(k.path=this.path),this.scheme&&(k.scheme=this.scheme),this.authority&&(k.authority=this.authority),this.query&&(k.query=this.query),this.fragment&&(k.fragment=this.fragment),k}}const n={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function r(p,k,S){let y,U=-1;for(let K=0;K<p.length;K++){const z=p.charCodeAt(K);if(z>=97&&z<=122||z>=65&&z<=90||z>=48&&z<=57||z===45||z===46||z===95||z===126||k&&z===47||S&&z===91||S&&z===93||S&&z===58)U!==-1&&(y+=encodeURIComponent(p.substring(U,K)),U=-1),y!==void 0&&(y+=p.charAt(K));else{y===void 0&&(y=p.substr(0,K));const O=n[z];O!==void 0?(U!==-1&&(y+=encodeURIComponent(p.substring(U,K)),U=-1),y+=O):U===-1&&(U=K)}}return U!==-1&&(y+=encodeURIComponent(p.substring(U))),y!==void 0?y:p}function f(p){let k;for(let S=0;S<p.length;S++){const y=p.charCodeAt(S);y===35||y===63?(k===void 0&&(k=p.substr(0,S)),k+=n[y]):k!==void 0&&(k+=p[S])}return k!==void 0?k:p}function C(p,k){let S;return p.authority&&p.path.length>1&&p.scheme==="file"?S=`//${p.authority}${p.path}`:p.path.charCodeAt(0)===47&&(p.path.charCodeAt(1)>=65&&p.path.charCodeAt(1)<=90||p.path.charCodeAt(1)>=97&&p.path.charCodeAt(1)<=122)&&p.path.charCodeAt(2)===58?k?S=p.path.substr(1):S=p.path[1].toLowerCase()+p.path.substr(2):S=p.path,D.isWindows&&(S=S.replace(/\//g,"\\")),S}function i(p,k){const S=k?f:r;let y="",{scheme:U,authority:K,path:z,query:O,fragment:m}=p;if(U&&(y+=U,y+=":"),(K||U==="file")&&(y+=c,y+=c),K){let R=K.indexOf("@");if(R!==-1){const _=K.substr(0,R);K=K.substr(R+1),R=_.lastIndexOf(":"),R===-1?y+=S(_,!1,!1):(y+=S(_.substr(0,R),!1,!1),y+=":",y+=S(_.substr(R+1),!1,!0)),y+="@"}K=K.toLowerCase(),R=K.lastIndexOf(":"),R===-1?y+=S(K,!1,!0):(y+=S(K.substr(0,R),!1,!0),y+=K.substr(R))}if(z){if(z.length>=3&&z.charCodeAt(0)===47&&z.charCodeAt(2)===58){const R=z.charCodeAt(1);R>=65&&R<=90&&(z=`/${String.fromCharCode(R+32)}:${z.substr(3)}`)}else if(z.length>=2&&z.charCodeAt(1)===58){const R=z.charCodeAt(0);R>=65&&R<=90&&(z=`${String.fromCharCode(R+32)}:${z.substr(2)}`)}y+=S(z,!0,!1)}return O&&(y+="?",y+=S(O,!1,!1)),m&&(y+="#",y+=k?m:r(m,!1,!1)),y}function t(p){try{return decodeURIComponent(p)}catch{return p.length>3?p.substr(0,3)+t(p.substr(3)):p}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function L(p){return p.match(l)?p.replace(l,k=>t(k)):p}}),define(de[58],me([0,1,6]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteConsoleLog=D,e.parse=E,e.getFirstFrame=A,e.log=P;function D(s){const w=s;return w&&typeof w.type=="string"&&typeof w.severity=="string"}function E(s){const w=[];let c;try{const b=JSON.parse(s.arguments),o=b[b.length-1];o&&o.__$stack&&(b.pop(),c=o.__$stack),w.push(...b)}catch{w.push("Unable to log remote console arguments",s.arguments)}return{args:w,stack:c}}function A(s){if(typeof s!="string")return A(E(s).stack);const w=s;if(w){const c=T(w),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(c||"");if(b&&b.length===4)return{uri:v.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}function T(s){if(!s)return s;const w=s.indexOf(`
`);return w===-1?s:s.substring(0,w)}function P(s,w){const{args:c,stack:b}=E(s),o=typeof c[0]=="string"&&c.length===1;let a=T(b);a&&(a=`(${a.trim()})`);let g=[];if(typeof c[0]=="string"?a&&o?g=[`%c[${w}] %c${c[0]} %c${a}`,h("blue"),h(""),h("grey")]:g=[`%c[${w}] %c${c[0]}`,h("blue"),h(""),...c.slice(1)]:g=[`%c[${w}]%`,h("blue"),...c],a&&!o&&g.push(a),typeof console[s.severity]!="function")throw new Error("Unknown console method");console[s.severity].apply(console,g)}function h(s){return`color: ${s}`}}),define(de[59],me([0,1,18,6]),function(ae,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.stringify=E,e.parse=A,e.revive=P;function E(h){return JSON.stringify(h,T)}function A(h){let s=JSON.parse(h);return s=P(s),s}function T(h,s){return s instanceof RegExp?{$mid:2,source:s.source,flags:s.flags}:s}function P(h,s=0){if(!h||s>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return D.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof v.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let w=0;w<h.length;++w)h[w]=P(h[w],s+1);else for(const w in h)Object.hasOwnProperty.call(h,w)&&(h[w]=P(h[w],s+1))}return h}}),define(de[19],me([0,1,7,3,12,6,5]),function(ae,e,v,D,E,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.VSCODE_AUTHORITY=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0,e.matchesScheme=h,e.matchesSomeScheme=s,e.getServerRootPath=c;var P;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatCodeBlock="vscode-chat-code-block",a.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm",a.commentsInput="comment",a.codeSetting="code-setting"})(P||(e.Schemas=P={}));function h(a,g){return A.URI.isUri(a)?(0,E.equalsIgnoreCase)(a.scheme,g):(0,E.startsWithIgnoreCase)(a,g+":")}function s(a,...g){return g.some(d=>h(a,d))}e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class w{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._serverRootPath="/"}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}setServerRootPath(g,d){this._serverRootPath=c(g,d)}getServerRootPath(){return this._serverRootPath}get _remoteResourcesPath(){return T.posix.join(this._serverRootPath,P.vscodeRemoteResource)}set(g,d,n){this._hosts[g]=d,this._ports[g]=n}setConnectionToken(g,d){this._connectionTokens[g]=d}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(g){if(this._delegate)try{return this._delegate(g)}catch(i){return v.onUnexpectedError(i),g}const d=g.authority;let n=this._hosts[d];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const r=this._ports[d],f=this._connectionTokens[d];let C=`path=${encodeURIComponent(g.path)}`;return typeof f=="string"&&(C+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),A.URI.from({scheme:D.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${n}:${r}`,path:this._remoteResourcesPath,query:C})}}e.RemoteAuthorities=new w;function c(a,g){return T.posix.join(g??"/",`${a.quality??"oss"}-${a.commit??"dev"}`)}e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked",e.VSCODE_AUTHORITY="vscode-app";class b{static{this.FALLBACK_AUTHORITY=e.VSCODE_AUTHORITY}asBrowserUri(g){const d=this.toUri(g,ae);return this.uriToBrowserUri(d)}uriToBrowserUri(g){return g.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(g):g.scheme===P.file&&(D.isNative||D.webWorkerOrigin===`${P.vscodeFileResource}://${b.FALLBACK_AUTHORITY}`)?g.with({scheme:P.vscodeFileResource,authority:g.authority||b.FALLBACK_AUTHORITY,query:null,fragment:null}):g}asFileUri(g){const d=this.toUri(g,ae);return this.uriToFileUri(d)}uriToFileUri(g){return g.scheme===P.vscodeFileResource?g.with({scheme:P.file,authority:g.authority!==b.FALLBACK_AUTHORITY?g.authority:null,query:null,fragment:null}):g}toUri(g,d){return A.URI.isUri(g)?g:A.URI.parse(d.toUrl(g))}}e.FileAccess=new b;var o;(function(a){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(g.get("3"));const d="vscode-coi";function n(f){let C;typeof f=="string"?C=new URL(f).searchParams:f instanceof URL?C=f.searchParams:A.URI.isUri(f)&&(C=new URL(f.toString(!0)).searchParams);const i=C?.get(d);if(i)return g.get(i)}a.getHeadersFromQuery=n;function r(f,C,i){if(!globalThis.crossOriginIsolated)return;const t=C&&i?"3":i?"2":"1";f instanceof URLSearchParams?f.set(d,t):f[d]=t}a.addSearchParam=r})(o||(e.COI=o={}))}),define(de[23],me([0,1,32,19,5,3,12,6]),function(ae,e,v,D,E,A,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=void 0,e.originalFSPath=h,e.distinctParents=w,e.toLocalResource=b;function h(o){return(0,P.uriToFsPath)(o,!0)}class s{constructor(a){this._ignorePathCasing=a}compare(a,g,d=!1){return a===g?0:(0,T.compare)(this.getComparisonKey(a,d),this.getComparisonKey(g,d))}isEqual(a,g,d=!1){return a===g?!0:!a||!g?!1:this.getComparisonKey(a,d)===this.getComparisonKey(g,d)}getComparisonKey(a,g=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,g,d=!1){if(a.scheme===g.scheme){if(a.scheme===D.Schemas.file)return v.isEqualOrParent(h(a),h(g),this._ignorePathCasing(a))&&a.query===g.query&&(d||a.fragment===g.fragment);if((0,e.isEqualAuthority)(a.authority,g.authority))return v.isEqualOrParent(a.path,g.path,this._ignorePathCasing(a),"/")&&a.query===g.query&&(d||a.fragment===g.fragment)}return!1}joinPath(a,...g){return P.URI.joinPath(a,...g)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return E.posix.basename(a.path)}extname(a){return E.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let g;return a.scheme===D.Schemas.file?g=P.URI.file(E.dirname(h(a))).path:(g=E.posix.dirname(a.path),a.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),g="/")),a.with({path:g})}normalizePath(a){if(!a.path.length)return a;let g;return a.scheme===D.Schemas.file?g=P.URI.file(E.normalize(h(a))).path:g=E.posix.normalize(a.path),a.with({path:g})}relativePath(a,g){if(a.scheme!==g.scheme||!(0,e.isEqualAuthority)(a.authority,g.authority))return;if(a.scheme===D.Schemas.file){const r=E.relative(h(a),h(g));return A.isWindows?v.toSlashes(r):r}let d=a.path||"/";const n=g.path||"/";if(this._ignorePathCasing(a)){let r=0;for(const f=Math.min(d.length,n.length);r<f&&!(d.charCodeAt(r)!==n.charCodeAt(r)&&d.charAt(r).toLowerCase()!==n.charAt(r).toLowerCase());r++);d=n.substr(0,r)+d.substr(r)}return E.posix.relative(d,n)}resolvePath(a,g){if(a.scheme===D.Schemas.file){const d=P.URI.file(E.resolve(h(a),g));return a.with({authority:d.authority,path:d.path})}return g=v.toPosixPath(g),a.with({path:E.posix.resolve(a.path,g)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,g){return a===g||a!==void 0&&g!==void 0&&(0,T.equalsIgnoreCase)(a,g)}hasTrailingPathSeparator(a,g=E.sep){if(a.scheme===D.Schemas.file){const d=h(a);return d.length>v.getRoot(d).length&&d[d.length-1]===g}else{const d=a.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,g=E.sep){return(0,e.hasTrailingPathSeparator)(a,g)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,g=E.sep){let d=!1;if(a.scheme===D.Schemas.file){const n=h(a);d=n!==void 0&&n.length===v.getRoot(n).length&&n[n.length-1]===g}else{g="/";const n=a.path;d=n.length===1&&n.charCodeAt(n.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(a,g)?a.with({path:a.path+"/"}):a}}e.ExtUri=s,e.extUri=new s(()=>!1),e.extUriBiasedIgnorePathCase=new s(o=>o.scheme===D.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new s(o=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function w(o,a){const g=[];for(let d=0;d<o.length;d++){const n=a(o[d]);o.some((r,f)=>f===d?!1:(0,e.isEqualOrParent)(n,a(r)))||g.push(o[d])}return g}var c;(function(o){o.META_DATA_LABEL="label",o.META_DATA_DESCRIPTION="description",o.META_DATA_SIZE="size",o.META_DATA_MIME="mime";function a(g){const d=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(f=>{const[C,i]=f.split(":");C&&i&&d.set(C,i)});const r=g.path.substring(0,g.path.indexOf(";"));return r&&d.set(o.META_DATA_MIME,r),d}o.parseMetaData=a})(c||(e.DataUri=c={}));function b(o,a,g){if(a){let d=o.path;return d&&d[0]!==E.posix.sep&&(d=E.posix.sep+d),o.with({scheme:g,authority:a,path:d})}return o.with({scheme:g})}}),define(de[11],me([0,1,17,7,4,2,23,3,50,22]),function(ae,e,v,D,E,A,T,P,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AsyncIterableSource=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.LazyStatefulPromise=e.StatefulPromise=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.GlobalIdleValue=e.AbstractIdleValue=e._runWhenIdle=e.runWhenGlobalIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.LimitedQueue=e.Queue=e.Limiter=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=void 0,e.isThenable=w,e.createCancelablePromise=c,e.raceCancellation=b,e.raceCancellationError=o,e.raceCancellablePromises=a,e.raceTimeout=g,e.asPromise=d,e.promiseWithResolvers=n,e.timeout=S,e.disposableTimeout=y,e.sequence=U,e.first=K,e.firstParallel=z,e.retry=$,e.createCancelableAsyncIterable=x;function w(F){return!!F&&typeof F.then=="function"}function c(F){const M=new v.CancellationTokenSource,j=F(M.token),Z=new Promise((re,se)=>{const he=M.token.onCancellationRequested(()=>{he.dispose(),se(new D.CancellationError)});Promise.resolve(j).then(pe=>{he.dispose(),M.dispose(),re(pe)},pe=>{he.dispose(),M.dispose(),se(pe)})});return new class{cancel(){M.cancel(),M.dispose()}then(re,se){return Z.then(re,se)}catch(re){return this.then(void 0,re)}finally(re){return Z.finally(re)}}}function b(F,M,j){return new Promise((Z,re)=>{const se=M.onCancellationRequested(()=>{se.dispose(),Z(j)});F.then(Z,re).finally(()=>se.dispose())})}function o(F,M){return new Promise((j,Z)=>{const re=M.onCancellationRequested(()=>{re.dispose(),Z(new D.CancellationError)});F.then(j,Z).finally(()=>re.dispose())})}async function a(F){let M=-1;const j=F.map((Z,re)=>Z.then(se=>(M=re,se)));try{return await Promise.race(j)}finally{F.forEach((Z,re)=>{re!==M&&Z.cancel()})}}function g(F,M,j){let Z;const re=setTimeout(()=>{Z?.(void 0),j?.()},M);return Promise.race([F.finally(()=>clearTimeout(re)),new Promise(se=>Z=se)])}function d(F){return new Promise((M,j)=>{const Z=F();w(Z)?Z.then(M,j):M(Z)})}function n(){let F,M;return{promise:new Promise((Z,re)=>{F=Z,M=re}),resolve:F,reject:M}}class r{constructor(){this.isDisposed=!1,this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.isDisposed)return Promise.reject(new Error("Throttler is disposed"));if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const j=()=>{if(this.queuedPromise=null,this.isDisposed)return;const Z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Z};this.queuedPromise=new Promise(Z=>{this.activePromise.then(j,j).then(Z)})}return new Promise((j,Z)=>{this.queuedPromise.then(j,Z)})}return this.activePromise=M(),new Promise((j,Z)=>{this.activePromise.then(re=>{this.activePromise=null,j(re)},re=>{this.activePromise=null,Z(re)})})}dispose(){this.isDisposed=!0}}e.Throttler=r;class f{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=f;class C{constructor(){this.promiseMap=new Map}queue(M,j){const re=(this.promiseMap.get(M)??Promise.resolve()).catch(()=>{}).then(j).finally(()=>{this.promiseMap.get(M)===re&&this.promiseMap.delete(M)});return this.promiseMap.set(M,re),re}}e.SequencerByKey=C;const i=(F,M)=>{let j=!0;const Z=setTimeout(()=>{j=!1,M()},F);return{isTriggered:()=>j,dispose:()=>{clearTimeout(Z),j=!1}}},t=F=>{let M=!0;return queueMicrotask(()=>{M&&(M=!1,F())}),{isTriggered:()=>M,dispose:()=>{M=!1}}};class l{constructor(M){this.defaultDelay=M,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,j=this.defaultDelay){this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((re,se)=>{this.doResolve=re,this.doReject=se}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const re=this.task;return this.task=null,re()}}));const Z=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=j===h.MicrotaskDelay?t(Z):i(j,Z),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new D.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class L{constructor(M){this.delayer=new l(M),this.throttler=new r}trigger(M,j){return this.delayer.trigger(()=>this.throttler.queue(M),j)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose(),this.throttler.dispose()}}e.ThrottledDelayer=L;class p{constructor(){this._isOpen=!1,this._promise=new Promise((M,j)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=p;class k extends p{constructor(M){super(),this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=k;function S(F,M){return M?new Promise((j,Z)=>{const re=setTimeout(()=>{se.dispose(),j()},F),se=M.onCancellationRequested(()=>{clearTimeout(re),se.dispose(),Z(new D.CancellationError)})}):c(j=>S(F,j))}function y(F,M=0,j){const Z=setTimeout(()=>{F(),j&&re.dispose()},M),re=(0,A.toDisposable)(()=>{clearTimeout(Z),j?.deleteAndLeak(re)});return j?.add(re),re}function U(F){const M=[];let j=0;const Z=F.length;function re(){return j<Z?F[j++]():null}function se(he){he!=null&&M.push(he);const pe=re();return pe?pe.then(se):Promise.resolve(M)}return Promise.resolve(null).then(se)}function K(F,M=Z=>!!Z,j=null){let Z=0;const re=F.length,se=()=>{if(Z>=re)return Promise.resolve(j);const he=F[Z++];return Promise.resolve(he()).then(_e=>M(_e)?Promise.resolve(_e):se())};return se()}function z(F,M=Z=>!!Z,j=null){if(F.length===0)return Promise.resolve(j);let Z=F.length;const re=()=>{Z=-1;for(const se of F)se.cancel?.()};return new Promise((se,he)=>{for(const pe of F)pe.then(_e=>{--Z>=0&&M(_e)?(re(),se(_e)):Z===0&&se(j)}).catch(_e=>{--Z>=0&&(re(),he(_e))})})}class O{constructor(M){this._size=0,this._isDisposed=!1,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new E.Emitter}whenIdle(){return this.size>0?E.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(M){if(this._isDisposed)throw new Error("Object has been disposed");return this._size++,new Promise((j,Z)=>{this.outstandingPromises.push({factory:M,c:j,e:Z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const j=M.factory();j.then(M.c,M.e),j.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._isDisposed||(this.runningPromises--,--this._size===0&&this._onDrained.fire(),this.outstandingPromises.length>0&&this.consume())}clear(){if(this._isDisposed)throw new Error("Object has been disposed");this.outstandingPromises.length=0,this._size=this.runningPromises}dispose(){this._isDisposed=!0,this.outstandingPromises.length=0,this._size=0,this._onDrained.dispose()}}e.Limiter=O;class m extends O{constructor(){super(1)}}e.Queue=m;class R{constructor(){this.sequentializer=new Q,this.tasks=0}queue(M){return this.sequentializer.isRunning()?this.sequentializer.queue(()=>this.sequentializer.run(this.tasks++,M())):this.sequentializer.run(this.tasks++,M())}}e.LimitedQueue=R;class _{constructor(){this.queues=new Map,this.drainers=new Set,this.drainListeners=void 0,this.drainListenerCount=0}async whenDrained(){if(this.isDrained())return;const M=new W;return this.drainers.add(M),M.p}isDrained(){for(const[,M]of this.queues)if(M.size>0)return!1;return!0}queueSize(M,j=T.extUri){const Z=j.getComparisonKey(M);return this.queues.get(Z)?.size??0}queueFor(M,j,Z=T.extUri){const re=Z.getComparisonKey(M);let se=this.queues.get(re);if(!se){se=new m;const he=this.drainListenerCount++,pe=E.Event.once(se.onDrained)(()=>{se?.dispose(),this.queues.delete(re),this.onDidQueueDrain(),this.drainListeners?.deleteAndDispose(he),this.drainListeners?.size===0&&(this.drainListeners.dispose(),this.drainListeners=void 0)});this.drainListeners||(this.drainListeners=new A.DisposableMap),this.drainListeners.set(he,pe),this.queues.set(re,se)}return se.queue(j)}onDidQueueDrain(){this.isDrained()&&this.releaseDrainers()}releaseDrainers(){for(const M of this.drainers)M.complete();this.drainers.clear()}dispose(){for(const[,M]of this.queues)M.dispose();this.queues.clear(),this.releaseDrainers(),this.drainListeners?.dispose()}}e.ResourceQueue=_;class I{constructor(M,j){this._token=-1,typeof M=="function"&&typeof j=="number"&&this.setIfNotSet(M,j)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,j){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},j)}setIfNotSet(M,j){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},j))}}e.TimeoutTimer=I;class G{constructor(){this.disposable=void 0}cancel(){this.disposable?.dispose(),this.disposable=void 0}cancelAndSet(M,j,Z=globalThis){this.cancel();const re=Z.setInterval(()=>{M()},j);this.disposable=(0,A.toDisposable)(()=>{Z.clearInterval(re),this.disposable=void 0})}dispose(){this.cancel()}}e.IntervalTimer=G;class te{constructor(M,j){this.timeoutToken=-1,this.runner=M,this.timeout=j,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}flush(){this.isScheduled()&&(this.cancel(),this.doRun())}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=te;class H{constructor(M,j){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.runner=M,this.timeout=j,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(M=this.timeout){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(M/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=H;class ee extends te{constructor(M,j){super(M,j),this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner?.(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=ee;class le extends A.Disposable{constructor(M,j){super(),this.options=M,this.handler=j,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(M){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+M.length>this.options.maxBufferedWork)return!1}else if(this.pending+M.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}for(const j of M)this.pendingWork.push(j);return this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new te(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=le,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e._runWhenIdle=(F,M)=>{(0,P.setTimeout0)(()=>{if(j)return;const Z=Date.now()+15;M(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Z-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0)}}}:e._runWhenIdle=(F,M,j)=>{const Z=F.requestIdleCallback(M,typeof j=="number"?{timeout:j}:void 0);let re=!1;return{dispose(){re||(re=!0,F.cancelIdleCallback(Z))}}},e.runWhenGlobalIdle=F=>(0,e._runWhenIdle)(globalThis,F)}();class ue{constructor(M,j){this._didRun=!1,this._executor=()=>{try{this._value=j()}catch(Z){this._error=Z}finally{this._didRun=!0}},this._handle=(0,e._runWhenIdle)(M,()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.AbstractIdleValue=ue;class V extends ue{constructor(M){super(globalThis,M)}}e.GlobalIdleValue=V;async function $(F,M,j){let Z;for(let re=0;re<j;re++)try{return await F()}catch(se){Z=se,await S(M)}throw Z}class Q{isRunning(M){return typeof M=="number"?this._running?.taskId===M:!!this._running}get running(){return this._running?.promise}cancelRunning(){this._running?.cancel()}run(M,j,Z){return this._running={taskId:M,cancel:()=>Z?.(),promise:j},j.then(()=>this.doneRunning(M),()=>this.doneRunning(M)),j}doneRunning(M){this._running&&M===this._running.taskId&&(this._running=void 0,this.runQueued())}runQueued(){if(this._queued){const M=this._queued;this._queued=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}queue(M){if(this._queued)this._queued.run=M;else{const{promise:j,resolve:Z,reject:re}=n();this._queued={run:M,promise:j,promiseResolve:Z,promiseReject:re}}return this._queued.promise}hasQueued(){return!!this._queued}async join(){return this._queued?.promise??this._running?.promise}}e.TaskSequentializer=Q;class Y{constructor(M,j=()=>Date.now()){this.interval=M,this.nowFn=j,this.lastIncrementTime=0,this.value=0}increment(){const M=this.nowFn();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=Y;var fe;(function(F){F[F.Resolved=0]="Resolved",F[F.Rejected=1]="Rejected"})(fe||(fe={}));class W{get isRejected(){return this.outcome?.outcome===1}get isResolved(){return this.outcome?.outcome===0}get isSettled(){return!!this.outcome}get value(){return this.outcome?.outcome===0?this.outcome?.value:void 0}constructor(){this.p=new Promise((M,j)=>{this.completeCallback=M,this.errorCallback=j})}complete(M){return new Promise(j=>{this.completeCallback(M),this.outcome={outcome:0,value:M},j()})}error(M){return new Promise(j=>{this.errorCallback(M),this.outcome={outcome:1,value:M},j()})}cancel(){return this.error(new D.CancellationError)}}e.DeferredPromise=W;var ce;(function(F){async function M(Z){let re;const se=await Promise.all(Z.map(he=>he.then(pe=>pe,pe=>{re||(re=pe)})));if(typeof re<"u")throw re;return se}F.settled=M;function j(Z){return new Promise(async(re,se)=>{try{await Z(re,se)}catch(he){se(he)}})}F.withAsyncBody=j})(ce||(e.Promises=ce={}));class J{get value(){return this._value}get error(){return this._error}get isResolved(){return this._isResolved}constructor(M){this._value=void 0,this._error=void 0,this._isResolved=!1,this.promise=M.then(j=>(this._value=j,this._isResolved=!0,j),j=>{throw this._error=j,this._isResolved=!0,j})}requireValue(){if(!this._isResolved)throw new D.BugIndicatingError("Promise is not resolved yet");if(this._error)throw this._error;return this._value}}e.StatefulPromise=J;class u{constructor(M){this._compute=M,this._promise=new s.Lazy(()=>new J(this._compute()))}requireValue(){return this._promise.value.requireValue()}getPromise(){return this._promise.value.promise}get currentValue(){return this._promise.rawValue?.value}}e.LazyStatefulPromise=u;var N;(function(F){F[F.Initial=0]="Initial",F[F.DoneOK=1]="DoneOK",F[F.DoneError=2]="DoneError"})(N||(N={}));class ie{static fromArray(M){return new ie(j=>{j.emitMany(M)})}static fromPromise(M){return new ie(async j=>{j.emitMany(await M)})}static fromPromises(M){return new ie(async j=>{await Promise.all(M.map(async Z=>j.emitOne(await Z)))})}static merge(M){return new ie(async j=>{await Promise.all(M.map(async Z=>{for await(const re of Z)j.emitOne(re)}))})}static{this.EMPTY=ie.fromArray([])}constructor(M,j){this._state=0,this._results=[],this._error=null,this._onReturn=j,this._onStateChanged=new E.Emitter,queueMicrotask(async()=>{const Z={emitOne:re=>this.emitOne(re),emitMany:re=>this.emitMany(re),reject:re=>this.reject(re)};try{await Promise.resolve(M(Z)),this.resolve()}catch(re){this.reject(re)}finally{Z.emitOne=void 0,Z.emitMany=void 0,Z.reject=void 0}})}[Symbol.asyncIterator](){let M=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(M<this._results.length)return{done:!1,value:this._results[M++]};if(this._state===1)return{done:!0,value:void 0};await E.Event.toPromise(this._onStateChanged.event)}while(!0)},return:async()=>(this._onReturn?.(),{done:!0,value:void 0})}}static map(M,j){return new ie(async Z=>{for await(const re of M)Z.emitOne(j(re))})}map(M){return ie.map(this,M)}static filter(M,j){return new ie(async Z=>{for await(const re of M)j(re)&&Z.emitOne(re)})}filter(M){return ie.filter(this,M)}static coalesce(M){return ie.filter(M,j=>!!j)}coalesce(){return ie.coalesce(this)}static async toPromise(M){const j=[];for await(const Z of M)j.push(Z);return j}toPromise(){return ie.toPromise(this)}emitOne(M){this._state===0&&(this._results.push(M),this._onStateChanged.fire())}emitMany(M){this._state===0&&(this._results=this._results.concat(M),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(M){this._state===0&&(this._state=2,this._error=M,this._onStateChanged.fire())}}e.AsyncIterableObject=ie;class ne extends ie{constructor(M,j){super(j),this._source=M}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ne;function x(F){const M=new v.CancellationTokenSource,j=F(M.token);return new ne(M,async Z=>{const re=M.token.onCancellationRequested(()=>{re.dispose(),M.dispose(),Z.reject(new D.CancellationError)});try{for await(const se of j){if(M.token.isCancellationRequested)return;Z.emitOne(se)}re.dispose(),M.dispose()}catch(se){re.dispose(),M.dispose(),Z.reject(se)}})}class B{constructor(M){this._deferred=new W,this._asyncIterable=new ie(re=>{if(j){re.reject(j);return}return Z&&re.emitMany(Z),this._errorFn=se=>re.reject(se),this._emitFn=se=>re.emitOne(se),this._deferred.p},M);let j,Z;this._emitFn=re=>{Z||(Z=[]),Z.push(re)},this._errorFn=re=>{j||(j=re)}}get asyncIterable(){return this._asyncIterable}resolve(){this._deferred.complete()}reject(M){this._errorFn(M),this._deferred.complete()}emitOne(M){this._emitFn(M)}}e.AsyncIterableSource=B}),define(de[60],me([0,1,18,6]),function(ae,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultURITransformer=e.URITransformer=void 0,e.transformOutgoingURIs=P,e.transformIncomingURIs=s,e.transformAndReviveIncomingURIs=w;function E(c){return c.toJSON()}class A{constructor(b){this._uriTransformer=b}transformIncoming(b){const o=this._uriTransformer.transformIncoming(b);return o===b?b:E(D.URI.from(o))}transformOutgoing(b){const o=this._uriTransformer.transformOutgoing(b);return o===b?b:E(D.URI.from(o))}transformOutgoingURI(b){const o=this._uriTransformer.transformOutgoing(b);return o===b?b:D.URI.from(o)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(c){return c}transformOutgoing(c){return c}transformOutgoingURI(c){return c}transformOutgoingScheme(c){return c}};function T(c,b,o){if(!c||o>200)return null;if(typeof c=="object"){if(c instanceof D.URI)return b.transformOutgoing(c);for(const a in c)if(Object.hasOwnProperty.call(c,a)){const g=T(c[a],b,o+1);g!==null&&(c[a]=g)}}return null}function P(c,b){const o=T(c,b,0);return o===null?c:o}function h(c,b,o,a){if(!c||a>200)return null;if(typeof c=="object"){if(c.$mid===1)return o?D.URI.revive(b.transformIncoming(c)):b.transformIncoming(c);if(c instanceof v.VSBuffer)return null;for(const g in c)if(Object.hasOwnProperty.call(c,g)){const d=h(c[g],b,o,a+1);d!==null&&(c[g]=d)}}return null}function s(c,b){const o=h(c,b,!1,0);return o===null?c:o}function w(c,b){const o=h(c,b,!0,0);return o===null?c:o}}),define(de[24],me([0,1,106,20,107,11,32,45,5,3,23,6]),function(ae,e,v,D,E,A,T,P,h,s,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=d,e.readdirSync=f,e.whenDeleted=t,e.configureFlushOnWrite=S,e.writeFileSync=U;var b;(function(H){H[H.UNLINK=0]="UNLINK",H[H.MOVE=1]="MOVE"})(b||(e.RimRafMode=b={}));async function o(H,ee=b.UNLINK,le){if((0,T.isRootOrDriveLetter)(H))throw new Error("rimraf - will refuse to recursively delete root");return ee===b.UNLINK?g(H):a(H,le)}async function a(H,ee=(0,T.randomPath)((0,D.tmpdir)())){try{try{await v.promises.rename(H,ee)}catch(le){return le.code==="ENOENT"?void 0:g(H)}g(ee).catch(le=>{})}catch(le){if(le.code!=="ENOENT")throw le}}async function g(H){return(0,E.promisify)(v.rm)(H,{recursive:!0,force:!0,maxRetries:3})}function d(H){if((0,T.isRootOrDriveLetter)(H))throw new Error("rimraf - will refuse to recursively delete root");v.rmSync(H,{recursive:!0,force:!0,maxRetries:3})}async function n(H,ee){return C(await(ee?r(H):(0,E.promisify)(v.readdir)(H)))}async function r(H){try{return await(0,E.promisify)(v.readdir)(H,{withFileTypes:!0})}catch(ue){console.warn("[node.js fs] readdir with filetypes failed with error: ",ue)}const ee=[],le=await n(H);for(const ue of le){let V=!1,$=!1,Q=!1;try{const Y=await e.Promises.lstat((0,h.join)(H,ue));V=Y.isFile(),$=Y.isDirectory(),Q=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}ee.push({name:ue,isFile:()=>V,isDirectory:()=>$,isSymbolicLink:()=>Q})}return ee}function f(H){return C(v.readdirSync(H))}function C(H){return H.map(ee=>typeof ee=="string"?s.isMacintosh?(0,P.normalizeNFC)(ee):ee:(ee.name=s.isMacintosh?(0,P.normalizeNFC)(ee.name):ee.name,ee))}async function i(H){const ee=await n(H),le=[];for(const ue of ee)await l.existsDirectory((0,h.join)(H,ue))&&le.push(ue);return le}function t(H,ee=1e3){return new Promise(le=>{let ue=!1;const V=setInterval(()=>{ue||(ue=!0,v.access(H,$=>{ue=!1,$&&(clearInterval(V),le(void 0))}))},ee)})}var l;(function(H){async function ee(V){let $;try{if($=await e.Promises.lstat(V),!$.isSymbolicLink())return{stat:$}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:$?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};if(s.isWindows&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&$)return{stat:$,symbolicLink:{dangling:!0}};throw Y}throw Q}}H.stat=ee;async function le(V){try{const{stat:$,symbolicLink:Q}=await H.stat(V);return $.isFile()&&Q?.dangling!==!0}catch{}return!1}H.existsFile=le;async function ue(V){try{const{stat:$,symbolicLink:Q}=await H.stat(V);return $.isDirectory()&&Q?.dangling!==!0}catch{}return!1}H.existsDirectory=ue})(l||(e.SymlinkSupport=l={}));const L=new A.ResourceQueue;function p(H,ee,le){return L.queueFor(c.URI.file(H),()=>{const ue=K(le);return new Promise((V,$)=>y(H,ee,ue,Q=>Q?$(Q):V()))},w.extUriBiasedIgnorePathCase)}let k=!0;function S(H){k=H}function y(H,ee,le,ue){if(!k)return v.writeFile(H,ee,{mode:le.mode,flag:le.flag},ue);v.open(H,le.flag,le.mode,(V,$)=>{if(V)return ue(V);v.writeFile($,ee,Q=>{if(Q)return v.close($,()=>ue(Q));v.fdatasync($,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),S(!1)),v.close($,fe=>ue(fe))))})})}function U(H,ee,le){const ue=K(le);if(!k)return v.writeFileSync(H,ee,{mode:ue.mode,flag:ue.flag});const V=v.openSync(H,ue.flag,ue.mode);try{v.writeFileSync(V,ee);try{v.fdatasyncSync(V)}catch($){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",$),S(!1)}}finally{v.closeSync(V)}}function K(H){return H?{mode:typeof H.mode=="number"?H.mode:438,flag:typeof H.flag=="string"?H.flag:"w"}:{mode:438,flag:"w"}}async function z(H,ee,le=6e4){if(H!==ee)try{s.isWindows&&typeof le=="number"?await O(H,ee,Date.now(),le):await(0,E.promisify)(v.rename)(H,ee)}catch(ue){if(H.toLowerCase()!==ee.toLowerCase()&&ue.code==="EXDEV"||H.endsWith("."))await m(H,ee,{preserveSymlinks:!1}),await o(H,b.MOVE);else throw ue}}async function O(H,ee,le,ue,V=0){try{return await(0,E.promisify)(v.rename)(H,ee)}catch($){if($.code!=="EACCES"&&$.code!=="EPERM"&&$.code!=="EBUSY")throw $;if(Date.now()-le>=ue)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${$}`),$;if(V===0){let Q=!1;try{const{stat:Y}=await l.stat(ee);Y.isFile()||(Q=!0)}catch{}if(Q)throw $}return await(0,A.timeout)(Math.min(100,V*10)),O(H,ee,le,ue,V+1)}}async function m(H,ee,le){return _(H,ee,{root:{source:H,target:ee},options:le,handledSourcePaths:new Set})}const R=511;async function _(H,ee,le){if(le.handledSourcePaths.has(H))return;le.handledSourcePaths.add(H);const{stat:ue,symbolicLink:V}=await l.stat(H);if(V){if(le.options.preserveSymlinks)try{return await te(H,ee,le)}catch{}if(V.dangling)return}return ue.isDirectory()?I(H,ee,ue.mode&R,le):G(H,ee,ue.mode&R)}async function I(H,ee,le,ue){await e.Promises.mkdir(ee,{recursive:!0,mode:le});const V=await n(H);for(const $ of V)await _((0,h.join)(H,$),(0,h.join)(ee,$),ue)}async function G(H,ee,le){await e.Promises.copyFile(H,ee),await e.Promises.chmod(ee,le)}async function te(H,ee,le){let ue=await e.Promises.readlink(H);(0,T.isEqualOrParent)(ue,le.root.source,!s.isLinux)&&(ue=(0,h.join)(le.root.target,ue.substr(le.root.source.length+1))),await e.Promises.symlink(ue,ee)}e.Promises=new class{get access(){return(0,E.promisify)(v.access)}get stat(){return(0,E.promisify)(v.stat)}get lstat(){return(0,E.promisify)(v.lstat)}get utimes(){return(0,E.promisify)(v.utimes)}get read(){return(H,ee,le,ue,V)=>new Promise(($,Q)=>{v.read(H,ee,le,ue,V,(Y,fe,W)=>Y?Q(Y):$({bytesRead:fe,buffer:W}))})}get readFile(){return(0,E.promisify)(v.readFile)}get write(){return(H,ee,le,ue,V)=>new Promise(($,Q)=>{v.write(H,ee,le,ue,V,(Y,fe,W)=>Y?Q(Y):$({bytesWritten:fe,buffer:W}))})}get appendFile(){return(0,E.promisify)(v.appendFile)}get fdatasync(){return(0,E.promisify)(v.fdatasync)}get truncate(){return(0,E.promisify)(v.truncate)}get copyFile(){return(0,E.promisify)(v.copyFile)}get open(){return(0,E.promisify)(v.open)}get close(){return(0,E.promisify)(v.close)}get symlink(){return(0,E.promisify)(v.symlink)}get readlink(){return(0,E.promisify)(v.readlink)}get chmod(){return(0,E.promisify)(v.chmod)}get mkdir(){return(0,E.promisify)(v.mkdir)}get unlink(){return(0,E.promisify)(v.unlink)}get rmdir(){return(0,E.promisify)(v.rmdir)}get realpath(){return(0,E.promisify)(v.realpath)}async exists(H){try{return await e.Promises.access(H),!0}catch{return!1}}get readdir(){return n}get readDirsInDir(){return i}get writeFile(){return p}get rm(){return o}get rename(){return z}get copy(){return m}}}),define(de[61],me([0,1,20,5,24]),function(ae,e,v,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.enumeratePowerShellInstallations=r,e.getFirstAvailablePowerShellInstallation=f;const A=/^\d+$/,T=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var h;(function(C){C[C.x64=0]="x64",C[C.x86=1]="x86",C[C.ARM=2]="ARM"})(h||(h={}));let s;switch(process.arch){case"ia32":s=1;break;case"arm":case"arm64":s=2;break;default:s=0;break}let w;process.env.PROCESSOR_ARCHITEW6432?w=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?w=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?w=1:w=0;class c{constructor(i,t,l){this.exePath=i,this.displayName=t,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await E.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function b({useAlternateBitness:C=!1}={}){return C?s===0?process.env["ProgramFiles(x86)"]||null:w===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function o({useAlternateBitness:C=!1,findPreview:i=!1}={}){const t=b({useAlternateBitness:C});if(!t)return null;const l=D.join(t,"PowerShell");if(!await E.SymlinkSupport.existsDirectory(l))return null;let L=-1,p=null;for(const y of await E.Promises.readdir(l)){let U=-1;if(i){const z=y.indexOf("-");if(z<0)continue;const O=y.substring(0,z);if(!A.test(O)||y.substring(z+1)!=="preview")continue;U=parseInt(O,10)}else{if(!A.test(y))continue;U=parseInt(y,10)}if(U<=L)continue;const K=D.join(l,y,"pwsh.exe");await E.SymlinkSupport.existsFile(K)&&(p=K,L=U)}if(!p)return null;const k=t.includes("x86")?" (x86)":"",S=i?" Preview":"";return new c(p,`PowerShell${S}${k}`,!0)}async function a({findPreview:C}={}){if(!process.env.LOCALAPPDATA)return null;const i=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await E.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:t,pwshMsixName:l}=C?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const L of await E.Promises.readdir(i))if(t.test(L)){const p=D.join(i,L,"pwsh.exe");return new c(p,l)}return null}function g(){const C=D.join(v.homedir(),".dotnet","tools","pwsh.exe");return new c(C,".NET Core PowerShell Global Tool")}function d(){const C=D.join(process.env.windir,s===1&&w!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new c(C,"Windows PowerShell",!0)}async function*n(){let C=await o();C&&(yield C),C=await o({useAlternateBitness:!0}),C&&(yield C),C=await a(),C&&(yield C),C=g(),C&&(yield C),C=await o({findPreview:!0}),C&&(yield C),C=await a({findPreview:!0}),C&&(yield C),C=await o({useAlternateBitness:!0,findPreview:!0}),C&&(yield C),C=d(),C&&(yield C)}async function*r(){for await(const C of n())await C.exists()&&(yield C)}async function f(){for await(const C of r())return C;return null}}),define(de[34],me([0,1,5,3,15,33,9,24]),function(ae,e,v,D,E,A,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.getWindowsShell=h,e.createQueuedSender=s,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function h(c=E.env){return c.comspec||"cmd.exe"}function s(c){let b=[],o=!1;const a=function(g){if(o){b.push(g);return}(!c.send(g,n=>{if(n&&console.error(n),o=!1,b.length>0){const r=b.slice(0);b=[],r.forEach(f=>a(f))}})||D.isWindows)&&(o=!0)};return{send:a}}var w;(function(c){async function b(o,a,g){if(v.isAbsolute(o))return o;if(a===void 0&&(a=E.cwd()),v.dirname(o)!=="."||(g===void 0&&T.isString(E.env.PATH)&&(g=E.env.PATH.split(v.delimiter)),g===void 0||g.length===0))return v.join(a,o);async function n(r){if(await P.Promises.exists(r)){let f;try{f=await P.Promises.stat(r)}catch(C){C.message.startsWith("EACCES")&&(f=await P.Promises.lstat(r))}return f?!f.isDirectory():!1}return!1}for(const r of g){let f;if(v.isAbsolute(r)?f=v.join(r,o):f=v.join(a,r,o),await n(f))return f;let C=f+".com";if(await n(C)||(C=f+".exe",await n(C)))return C}return v.join(a,o)}c.findExecutable=b})(w||(e.win32=w={}))}),define(de[62],me([0,1,26,19]),function(ae,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=E;function E(T){return new Promise((P,h)=>{let s;const w=new Map;function c(o,a,g,d,n){const r=w.get(a);if(o===T||r){const f={name:b(g),cmd:g,pid:o,ppid:a,load:d,mem:n};w.set(o,f),o===T&&(s=f),r&&(r.children||(r.children=[]),r.children.push(f),r.children.length>1&&(r.children=r.children.sort((C,i)=>C.pid-i.pid)))}}function b(o){const a=/--utility-sub-type=network/i,g=/--crashes-directory/i,d=/\\pipe\\winpty-control/i,n=/conhost\.exe.+--headless/i,r=/--type=([a-zA-Z-]+)/;if(g.exec(o))return"electron-crash-reporter";if(d.exec(o))return"winpty-agent";if(n.exec(o))return"conpty-agent";let f=r.exec(o);if(f&&f.length===2)return f[1]==="renderer"?"window":f[1]==="utility"?a.exec(o)?"utility-network-service":"utility-process":f[1]==="extensionHost"?"extension-host":f[1];const C=/[a-zA-Z-]+\.js/g;let i="";do f=C.exec(o),f&&(i+=f+" ");while(f);return i&&o.indexOf("node ")<0&&o.indexOf("node.exe")<0?`electron-nodejs (${i})`:o}if(process.platform==="win32"){const o=a=>a.indexOf("\\\\?\\")===0||a.indexOf("\\??\\")===0?a.substring(4):a.indexOf('"\\\\?\\')===0||a.indexOf('"\\??\\')===0?'"'+a.substring(5):a;new Promise((a,g)=>{ae(["@vscode/windows-process-tree"],a,g)}).then(a=>{a.getProcessList(T,g=>{if(!g){h(new Error(`Root process ${T} not found`));return}a.getProcessCpuUsage(g,d=>{const n=new Map;d.forEach(r=>{const f=o(r.commandLine||"");n.set(r.pid,{name:b(f),cmd:f,pid:r.pid,ppid:r.ppid,load:r.cpu||0,mem:r.memory||0})}),s=n.get(T),s?(n.forEach(r=>{const f=n.get(r.ppid);f&&(f.children||(f.children=[]),f.children.push(r))}),n.forEach(r=>{r.children&&(r.children=r.children.sort((f,C)=>f.pid-C.pid))}),P(s)):h(new Error(`Root process ${T} not found`))})},a.ProcessDataFlag.CommandLine|a.ProcessDataFlag.Memory)})}else{let o=function(){let a=[s];const g=[];for(;a.length;){const n=a.shift();n&&(g.push(n.pid),n.children&&(a=a.concat(n.children)))}let d=JSON.stringify(D.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);d+=" "+g.join(" "),(0,v.exec)(d,{},(n,r,f)=>{if(n||f)h(n||new Error(f.toString()));else{const C=r.toString().split(`
`);for(let i=0;i<g.length;i++){const t=w.get(g[i]);t.load=parseFloat(C[i])}if(!s){h(new Error(`Root process ${T} not found`));return}P(s)}})};(0,v.exec)("which ps",{},(a,g,d)=>{if(a||d)if(process.platform!=="linux")h(a||new Error(d.toString()));else{const n=JSON.stringify(D.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,v.exec)(n,{},(r,f,C)=>{r||C?h(r||new Error(C.toString())):(A(f,c),o())})}else{const n=g.toString().trim();(0,v.exec)(`${n} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,C,i)=>{f||i&&!i.includes("screen size is bogus")?h(f||new Error(i.toString())):(A(C,c),process.platform==="linux"?o():s?P(s):h(new Error(`Root process ${T} not found`)))})}})}})}function A(T,P){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,s=T.toString().split(`
`);for(const w of s){const c=h.exec(w.trim());c&&c.length===6&&P(parseInt(c[1]),parseInt(c[2]),c[5],parseFloat(c[3]),parseFloat(c[4]))}}}),define(de[63],me([0,1,20,3,61,34]),function(ae,e,v,D,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=T;async function T(c,b){return c===1?D.isWindows?w():A.getWindowsShell(b):h(c,b)}let P=null;function h(c,b){if(D.isLinux&&c===2||D.isMacintosh&&c===3)return"/bin/bash";if(!P){let o;if(D.isWindows)o="/bin/bash";else{if(o=b.SHELL,!o)try{o=(0,v.userInfo)().shell}catch{}o||(o="sh"),o==="/bin/false"&&(o="/bin/bash")}P=o}return P}let s=null;async function w(){return s||(s=(await(0,E.getFirstAvailablePowerShellInstallation)()).exePath),s}});var ye=this&&this.__decorate||function(ae,e,v,D){var E=arguments.length,A=E<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,v):D,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ae,e,v,D);else for(var P=ae.length-1;P>=0;P--)(T=ae[P])&&(A=(E<3?T(A):E>3?T(e,v,A):T(e,v))||A);return E>3&&A&&Object.defineProperty(e,v,A),A};define(de[27],me([0,1,16,11,18,17,14,7,4,2,59,12,9]),function(ae,e,v,D,E,A,T,P,h,s,w,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.BufferWriter=e.BufferReader=void 0,e.serialize=S,e.deserialize=y,e.getDelayedChannel=R,e.getNextTickChannel=_;var o;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(o||(o={}));function a(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(g||(g={}));function d(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var n;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(n||(n={}));function r(V){let $=0;for(let Q=0;;Q+=7){const Y=V.read(1);if($|=(Y.buffer[0]&127)<<Q,!(Y.buffer[0]&128))return $}}const f=L(0);function C(V,$){if($===0){V.write(f);return}let Q=0;for(let fe=$;fe!==0;fe=fe>>>7)Q++;const Y=E.VSBuffer.alloc(Q);for(let fe=0;$!==0;fe++)Y.buffer[fe]=$&127,$=$>>>7,$>0&&(Y.buffer[fe]|=128);V.write(Y)}class i{constructor($){this.buffer=$,this.pos=0}read($){const Q=this.buffer.slice(this.pos,this.pos+$);return this.pos+=Q.byteLength,Q}}e.BufferReader=i;class t{constructor(){this.buffers=[]}get buffer(){return E.VSBuffer.concat(this.buffers)}write($){this.buffers.push($)}}e.BufferWriter=t;var l;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(l||(l={}));function L(V){const $=E.VSBuffer.alloc(1);return $.writeUInt8(V,0),$}const p={Undefined:L(l.Undefined),String:L(l.String),Buffer:L(l.Buffer),VSBuffer:L(l.VSBuffer),Array:L(l.Array),Object:L(l.Object),Uint:L(l.Int)},k=typeof Buffer<"u";function S(V,$){if(typeof $>"u")V.write(p.Undefined);else if(typeof $=="string"){const Q=E.VSBuffer.fromString($);V.write(p.String),C(V,Q.byteLength),V.write(Q)}else if(k&&Buffer.isBuffer($)){const Q=E.VSBuffer.wrap($);V.write(p.Buffer),C(V,Q.byteLength),V.write(Q)}else if($ instanceof E.VSBuffer)V.write(p.VSBuffer),C(V,$.byteLength),V.write($);else if(Array.isArray($)){V.write(p.Array),C(V,$.length);for(const Q of $)S(V,Q)}else if(typeof $=="number"&&($|0)===$)V.write(p.Uint),C(V,$);else{const Q=E.VSBuffer.fromString(JSON.stringify($));V.write(p.Object),C(V,Q.byteLength),V.write(Q)}}function y(V){switch(V.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return V.read(r(V)).toString();case l.Buffer:return V.read(r(V)).buffer;case l.VSBuffer:return V.read(r(V));case l.Array:{const Q=r(V),Y=[];for(let fe=0;fe<Q;fe++)Y.push(y(V));return Y}case l.Object:return JSON.parse(V.read(r(V)).toString());case l.Int:return r(V)}}class U{constructor($,Q,Y=null,fe=1e3){this.protocol=$,this.ctx=Q,this.logger=Y,this.timeoutDelay=fe,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel($,Q){this.channels.set($,Q),setTimeout(()=>this.flushPendingRequests($),0)}sendResponse($){switch($.type){case 200:{const Q=this.send([$.type]);this.logger?.logOutgoing(Q,0,1,d($.type));return}case 201:case 202:case 204:case 203:{const Q=this.send([$.type,$.id],$.data);this.logger?.logOutgoing(Q,$.id,1,d($.type),$.data);return}}}send($,Q=void 0){const Y=new t;return S(Y,$),S(Y,Q),this.sendBuffer(Y.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onRawMessage($){const Q=new i($),Y=y(Q),fe=y(Q),W=Y[0];switch(W){case 100:return this.logger?.logIncoming($.byteLength,Y[1],1,`${a(W)}: ${Y[2]}.${Y[3]}`,fe),this.onPromise({type:W,id:Y[1],channelName:Y[2],name:Y[3],arg:fe});case 102:return this.logger?.logIncoming($.byteLength,Y[1],1,`${a(W)}: ${Y[2]}.${Y[3]}`,fe),this.onEventListen({type:W,id:Y[1],channelName:Y[2],name:Y[3],arg:fe});case 101:return this.logger?.logIncoming($.byteLength,Y[1],1,`${a(W)}`),this.disposeActiveRequest({type:W,id:Y[1]});case 103:return this.logger?.logIncoming($.byteLength,Y[1],1,`${a(W)}`),this.disposeActiveRequest({type:W,id:Y[1]})}}onPromise($){const Q=this.channels.get($.channelName);if(!Q){this.collectPendingRequest($);return}const Y=new A.CancellationTokenSource;let fe;try{fe=Q.call(this.ctx,$.name,$.arg,Y.token)}catch(J){fe=Promise.reject(J)}const W=$.id;fe.then(J=>{this.sendResponse({id:W,data:J,type:201})},J=>{J instanceof Error?this.sendResponse({id:W,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.sendResponse({id:W,data:J,type:203})}).finally(()=>{ce.dispose(),this.activeRequests.delete($.id)});const ce=(0,s.toDisposable)(()=>Y.cancel());this.activeRequests.set($.id,ce)}onEventListen($){const Q=this.channels.get($.channelName);if(!Q){this.collectPendingRequest($);return}const Y=$.id,W=Q.listen(this.ctx,$.name,$.arg)(ce=>this.sendResponse({id:Y,data:ce,type:204}));this.activeRequests.set($.id,W)}disposeActiveRequest($){const Q=this.activeRequests.get($.id);Q&&(Q.dispose(),this.activeRequests.delete($.id))}collectPendingRequest($){let Q=this.pendingRequests.get($.channelName);Q||(Q=[],this.pendingRequests.set($.channelName,Q));const Y=setTimeout(()=>{console.error(`Unknown channel: ${$.channelName}`),$.type===100&&this.sendResponse({id:$.id,data:{name:"Unknown channel",message:`Channel name '${$.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Q.push({request:$,timeoutTimer:Y})}flushPendingRequests($){const Q=this.pendingRequests.get($);if(Q){for(const Y of Q)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.onPromise(Y.request);break;case 102:this.onEventListen(Y.request);break}this.pendingRequests.delete($)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,s.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=U;var K;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(K||(e.RequestInitiator=K={}));class z{constructor($,Q=null){this.protocol=$,this.isDisposed=!1,this.state=n.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(Y=>this.onBuffer(Y)),this.logger=Q}getChannel($){const Q=this;return{call(Y,fe,W){return Q.isDisposed?Promise.reject(new P.CancellationError):Q.requestPromise($,Y,fe,W)},listen(Y,fe){return Q.isDisposed?h.Event.None:Q.requestEvent($,Y,fe)}}}requestPromise($,Q,Y,fe=A.CancellationToken.None){const W=this.lastRequestId++,J={id:W,type:100,channelName:$,name:Q,arg:Y};if(fe.isCancellationRequested)return Promise.reject(new P.CancellationError);let u;return new Promise((ie,ne)=>{if(fe.isCancellationRequested)return ne(new P.CancellationError);const x=()=>{const j=Z=>{switch(Z.type){case 201:this.handlers.delete(W),ie(Z.data);break;case 202:{this.handlers.delete(W);const re=new Error(Z.data.message);re.stack=Array.isArray(Z.data.stack)?Z.data.stack.join(`
`):Z.data.stack,re.name=Z.data.name,ne(re);break}case 203:this.handlers.delete(W),ne(Z.data);break}};this.handlers.set(W,j),this.sendRequest(J)};let B=null;this.state===n.Idle?x():(B=(0,D.createCancelablePromise)(j=>this.whenInitialized()),B.then(()=>{B=null,x()}));const F=()=>{B?(B.cancel(),B=null):this.sendRequest({id:W,type:101}),ne(new P.CancellationError)},M=fe.onCancellationRequested(F);u=(0,s.combinedDisposable)((0,s.toDisposable)(F),M),this.activeRequests.add(u)}).finally(()=>{u.dispose(),this.activeRequests.delete(u)})}requestEvent($,Q,Y){const fe=this.lastRequestId++,ce={id:fe,type:102,channelName:$,name:Q,arg:Y};let J=null;const u=new h.Emitter({onWillAddFirstListener:()=>{J=(0,D.createCancelablePromise)(ie=>this.whenInitialized()),J.then(()=>{J=null,this.activeRequests.add(u),this.sendRequest(ce)})},onDidRemoveLastListener:()=>{J?(J.cancel(),J=null):(this.activeRequests.delete(u),this.sendRequest({id:fe,type:103}))}}),N=ie=>u.fire(ie.data);return this.handlers.set(fe,N),u.event}sendRequest($){switch($.type){case 100:case 102:{const Q=this.send([$.type,$.id,$.channelName,$.name],$.arg);this.logger?.logOutgoing(Q,$.id,0,`${a($.type)}: ${$.channelName}.${$.name}`,$.arg);return}case 101:case 103:{const Q=this.send([$.type,$.id]);this.logger?.logOutgoing(Q,$.id,0,a($.type));return}}}send($,Q=void 0){const Y=new t;return S(Y,$),S(Y,Q),this.sendBuffer(Y.buffer)}sendBuffer($){try{return this.protocol.send($),$.byteLength}catch{return 0}}onBuffer($){const Q=new i($),Y=y(Q),fe=y(Q),W=Y[0];switch(W){case 200:return this.logger?.logIncoming($.byteLength,0,0,d(W)),this.onResponse({type:Y[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming($.byteLength,Y[1],0,d(W),fe),this.onResponse({type:Y[0],id:Y[1],data:fe})}}onResponse($){if($.type===200){this.state=n.Idle,this._onDidInitialize.fire();return}this.handlers.get($.id)?.($)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===n.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,s.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelClient=z,ye([T.memoize],z.prototype,"onDidInitializePromise",null);class O{get connections(){const $=[];return this._connections.forEach(Q=>$.push(Q)),$}constructor($,Q,Y){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,this.disposables=new s.DisposableStore,this.disposables.add($(({protocol:fe,onDidClientDisconnect:W})=>{const ce=h.Event.once(fe.onMessage);this.disposables.add(ce(J=>{const u=new i(J),N=y(u),ie=new U(fe,N,Q,Y),ne=new z(fe,Q);this.channels.forEach((B,F)=>ie.registerChannel(F,B));const x={channelServer:ie,channelClient:ne,ctx:N};this._connections.add(x),this._onDidAddConnection.fire(x),this.disposables.add(W(()=>{ie.dispose(),ne.dispose(),this._connections.delete(x),this._onDidRemoveConnection.fire(x)}))}))}))}getChannel($,Q){const Y=this;return{call(fe,W,ce){let J;if((0,b.isFunction)(Q)){const N=(0,v.getRandomElement)(Y.connections.filter(Q));J=N?Promise.resolve(N):h.Event.toPromise(h.Event.filter(Y.onDidAddConnection,Q))}else J=Q.routeCall(Y,fe,W);const u=J.then(N=>N.channelClient.getChannel($));return R(u).call(fe,W,ce)},listen(fe,W){if((0,b.isFunction)(Q))return Y.getMulticastEvent($,Q,fe,W);const ce=Q.routeEvent(Y,fe,W).then(J=>J.channelClient.getChannel($));return R(ce).listen(fe,W)}}}getMulticastEvent($,Q,Y,fe){const W=this;let ce;const J=new h.Emitter({onWillAddFirstListener:()=>{ce=new s.DisposableStore;const u=new h.EventMultiplexer,N=new Map,ie=x=>{const F=x.channelClient.getChannel($).listen(Y,fe),M=u.add(F);N.set(x,M)},ne=x=>{const B=N.get(x);B&&(B.dispose(),N.delete(x))};W.connections.filter(Q).forEach(ie),h.Event.filter(W.onDidAddConnection,Q)(ie,void 0,ce),W.onDidRemoveConnection(ne,void 0,ce),u.event(J.fire,J,ce),ce.add(u)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return J.event}registerChannel($,Q){this.channels.set($,Q);for(const Y of this._connections)Y.channelServer.registerChannel($,Q)}dispose(){this.disposables.dispose();for(const $ of this._connections)$.channelClient.dispose(),$.channelServer.dispose();this._connections.clear(),this.channels.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=O;class m{constructor($,Q,Y=null){const fe=new t;S(fe,Q),$.send(fe.buffer),this.channelClient=new z($,Y),this.channelServer=new U($,Q,Y)}getChannel($){return this.channelClient.getChannel($)}registerChannel($,Q){this.channelServer.registerChannel($,Q)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=m;function R(V){return{call($,Q,Y){return V.then(fe=>fe.call($,Q,Y))},listen($,Q){const Y=new h.Relay;return V.then(fe=>Y.input=fe.listen($,Q)),Y.event}}}function _(V){let $=!1;return{call(Q,Y,fe){return $?V.call(Q,Y,fe):(0,D.timeout)(0).then(()=>$=!0).then(()=>V.call(Q,Y,fe))},listen(Q,Y){if($)return V.listen(Q,Y);const fe=new h.Relay;return(0,D.timeout)(0).then(()=>$=!0).then(()=>fe.input=V.listen(Q,Y)),fe.event}}}class I{constructor($){this.fn=$}routeCall($){return this.route($)}routeEvent($){return this.route($)}async route($){for(const Q of $.connections)if(await Promise.resolve(this.fn(Q.ctx)))return Promise.resolve(Q);return await h.Event.toPromise($.onDidAddConnection),await this.route($)}}e.StaticRouter=I;var G;(function(V){function $(W,ce,J){const u=W,N=J&&J.disableMarshalling,ie=new Map;for(const ne in u)Y(ne)&&ie.set(ne,h.Event.buffer(u[ne],!0,void 0,ce));return new class{listen(ne,x,B){const F=ie.get(x);if(F)return F;const M=u[x];if(typeof M=="function"){if(fe(x))return M.call(u,B);if(Y(x))return ie.set(x,h.Event.buffer(u[x],!0,void 0,ce)),ie.get(x)}throw new P.ErrorNoTelemetry(`Event not found: ${x}`)}call(ne,x,B){const F=u[x];if(typeof F=="function"){if(!N&&Array.isArray(B))for(let j=0;j<B.length;j++)B[j]=(0,w.revive)(B[j]);let M=F.apply(u,B);return M instanceof Promise||(M=Promise.resolve(M)),M}throw new P.ErrorNoTelemetry(`Method not found: ${x}`)}}}V.fromService=$;function Q(W,ce){const J=ce&&ce.disableMarshalling;return new Proxy({},{get(u,N){if(typeof N=="string")return ce?.properties?.has(N)?ce.properties.get(N):fe(N)?function(ie){return W.listen(N,ie)}:Y(N)?W.listen(N):async function(...ie){let ne;ce&&!(0,b.isUndefinedOrNull)(ce.context)?ne=[ce.context,...ie]:ne=ie;const x=await W.call(N,ne);return J?x:(0,w.revive)(x)};throw new P.ErrorNoTelemetry(`Property not found: ${String(N)}`)}})}V.toService=Q;function Y(W){return W[0]==="o"&&W[1]==="n"&&c.isUpperAsciiLetter(W.charCodeAt(2))}function fe(W){return/^onDynamic/.test(W)&&c.isUpperAsciiLetter(W.charCodeAt(9))}})(G||(e.ProxyChannel=G={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function H(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const $=V.toString();if($!=="[object Object]")return $}return V}function ee(V){return Array.isArray(V)?V.map(H):H(V)}function le(V,$,Q,Y,fe,W,ce){ce=ee(ce);const J=te[fe],u=J[Y%J.length];let N=[`%c[${V}]%c[${String($).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${u}`];/\($/.test(W)?(N=N.concat(ce),N.push(")")):N.push(ce),console.log.apply(console,N)}class ue{constructor($,Q){this._outgoingPrefix=$,this._incomingPrefix=Q,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing($,Q,Y,fe,W){this._totalOutgoing+=$,le(this._outgoingPrefix,this._totalOutgoing,$,Q,Y,fe,W)}logIncoming($,Q,Y,fe,W){this._totalIncoming+=$,le(this._incomingPrefix,this._totalIncoming,$,Q,Y,fe,W)}}e.IPCLogger=ue}),define(de[64],me([0,1,26,11,18,17,58,7,4,2,30,34,33,27]),function(ae,e,v,D,E,A,T,P,h,s,w,c,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class a extends o.ChannelServer{constructor(n){super({send:r=>{try{process.send?.(r.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",r=>E.VSBuffer.wrap(Buffer.from(r,"base64")))},n),process.once("disconnect",()=>this.dispose())}}e.Server=a;class g{constructor(n,r){this.modulePath=n,this.options=r,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=r&&r.timeout?r.timeout:6e4;this.disposeDelayer=new D.Delayer(f),this.child=null,this._client=null}getChannel(n){const r=this;return{call(f,C,i){return r.requestPromise(n,f,C,i)},listen(f,C){return r.requestEvent(n,f,C)}}}requestPromise(n,r,f,C=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(C.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const i=this.getCachedChannel(n),t=(0,D.createCancelablePromise)(p=>i.call(r,f,p)),l=C.onCancellationRequested(()=>t.cancel()),L=(0,s.toDisposable)(()=>t.cancel());return this.activeRequests.add(L),t.finally(()=>{l.dispose(),this.activeRequests.delete(L),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(n,r,f){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let C;const i=new h.Emitter({onWillAddFirstListener:()=>{C=this.getCachedChannel(n).listen(r,f)(i.fire,i),this.activeRequests.add(C)},onDidRemoveLastListener:()=>{this.activeRequests.delete(C),C.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return i.event}get client(){if(!this._client){const n=this.options&&this.options.args?this.options.args:[],r=Object.create(null);r.env={...(0,w.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(r.env={...r.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(r.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(r.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(r.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),r.execArgv===void 0&&(r.execArgv=process.execArgv.filter(S=>!/^--inspect(-brk)?=/.test(S)).filter(S=>!S.startsWith("--vscode-"))),(0,b.removeDangerousEnvVariables)(r.env),this.child=(0,v.fork)(this.modulePath,n,r);const f=new h.Emitter,i=h.Event.fromNodeEventEmitter(this.child,"message",S=>S)(S=>{if((0,T.isRemoteConsoleLog)(S)){(0,T.log)(S,`IPC Library: ${this.options.serverName}`);return}f.fire(E.VSBuffer.wrap(Buffer.from(S,"base64")))}),t=this.options.useQueue?(0,c.createQueuedSender)(this.child):this.child,l=S=>this.child&&this.child.connected&&t.send(S.buffer.toString("base64")),L=f.event,p={send:l,onMessage:L};this._client=new o.ChannelClient(p);const k=()=>this.disposeClient();process.once("exit",k),this.child.on("error",S=>console.warn('IPC "'+this.options.serverName+'" errored with '+S)),this.child.on("exit",(S,y)=>{process.removeListener("exit",k),i.dispose(),this.activeRequests.forEach(U=>(0,s.dispose)(U)),this.activeRequests.clear(),S!==0&&y!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+S+" and signal "+y),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:S,signal:y})})}return this._client}getCachedChannel(n){let r=this.channels.get(n);return r||(r=this.client.getChannel(n),this.channels.set(n,r)),r}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(de[65],me([0,1,31,18,27,4,9,16]),function(ae,e,v,D,E,A,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0,e.once=w;class h{constructor(b){this.port=b,this.onMessage=A.Event.fromNodeEventEmitter(this.port,"message",o=>o.data?D.VSBuffer.wrap(o.data):D.VSBuffer.alloc(0)),b.start()}send(b){this.port.postMessage(b.buffer)}disconnect(){this.port.close()}}class s extends E.IPCServer{static getOnDidClientConnect(b){(0,T.assertType)((0,v.isUtilityProcess)(process),"Electron Utility Process");const o=new A.Emitter;return process.parentPort.on("message",a=>{if(b?.handledClientConnection(a))return;const g=(0,P.firstOrDefault)(a.ports);g&&o.fire(g)}),A.Event.map(o.event,a=>({protocol:new h(a),onDidClientDisconnect:A.Event.fromNodeEventEmitter(a,"close")}))}constructor(b){super(s.getOnDidClientConnect(b))}}e.Server=s;function w(c,b,o){const a=g=>{g.data===b&&(c.removeListener("message",a),o())};c.on("message",a)}}),define(de[66],me([13,10]),function(ae,e){return ae.create("vs/platform/contextkey/common/contextkey",e)}),define(de[67],me([13,10]),function(ae,e){return ae.create("vs/platform/contextkey/common/scanner",e)}),define(de[68],me([13,10]),function(ae,e){return ae.create("vs/platform/environment/node/argv",e)}),define(de[69],me([13,10]),function(ae,e){return ae.create("vs/platform/files/common/files",e)}),define(de[70],me([13,10]),function(ae,e){return ae.create("vs/platform/log/common/log",e)}),define(de[71],me([13,10]),function(ae,e){return ae.create("vs/platform/terminal/node/ptyService",e)}),define(de[72],me([13,10]),function(ae,e){return ae.create("vs/platform/terminal/node/terminalProcess",e)}),define(de[73],me([0,1,7,67]),function(ae,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var E;(function(s){s[s.LParen=0]="LParen",s[s.RParen=1]="RParen",s[s.Neg=2]="Neg",s[s.Eq=3]="Eq",s[s.NotEq=4]="NotEq",s[s.Lt=5]="Lt",s[s.LtEq=6]="LtEq",s[s.Gt=7]="Gt",s[s.GtEq=8]="GtEq",s[s.RegexOp=9]="RegexOp",s[s.RegexStr=10]="RegexStr",s[s.True=11]="True",s[s.False=12]="False",s[s.In=13]="In",s[s.Not=14]="Not",s[s.And=15]="And",s[s.Or=16]="Or",s[s.Str=17]="Str",s[s.QuotedStr=18]="QuotedStr",s[s.Error=19]="Error",s[s.EOF=20]="EOF"})(E||(e.TokenType=E={}));function A(...s){switch(s.length){case 1:return(0,D.localize)(0,null,s[0]);case 2:return(0,D.localize)(1,null,s[0],s[1]);case 3:return(0,D.localize)(2,null,s[0],s[1],s[2]);default:return}}const T=(0,D.localize)(3,null),P=(0,D.localize)(4,null);class h{constructor(){this._input="",this._start=0,this._current=0,this._tokens=[],this._errors=[],this.stringRe=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(w){switch(w.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return w.isTripleEq?"===":"==";case 4:return w.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return w.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return w.lexeme;case 18:return w.lexeme;case 19:return w.lexeme;case 20:return"EOF";default:throw(0,v.illegalState)(`unhandled token type: ${JSON.stringify(w)}; have you forgotten to add a case?`)}}static{this._regexFlags=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0)))}static{this._keywords=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this._errors}reset(w){return this._input=w,this._start=0,this._current=0,this._tokens=[],this._errors=[],this}scan(){for(;!this._isAtEnd();)switch(this._start=this._current,this._advance()){case 40:this._addToken(0);break;case 41:this._addToken(1);break;case 33:if(this._match(61)){const c=this._match(61);this._tokens.push({type:4,offset:this._start,isTripleEq:c})}else this._addToken(2);break;case 39:this._quotedString();break;case 47:this._regex();break;case 61:if(this._match(61)){const c=this._match(61);this._tokens.push({type:3,offset:this._start,isTripleEq:c})}else this._match(126)?this._addToken(9):this._error(A("==","=~"));break;case 60:this._addToken(this._match(61)?6:5);break;case 62:this._addToken(this._match(61)?8:7);break;case 38:this._match(38)?this._addToken(15):this._error(A("&&"));break;case 124:this._match(124)?this._addToken(16):this._error(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this._string()}return this._start=this._current,this._addToken(20),Array.from(this._tokens)}_match(w){return this._isAtEnd()||this._input.charCodeAt(this._current)!==w?!1:(this._current++,!0)}_advance(){return this._input.charCodeAt(this._current++)}_peek(){return this._isAtEnd()?0:this._input.charCodeAt(this._current)}_addToken(w){this._tokens.push({type:w,offset:this._start})}_error(w){const c=this._start,b=this._input.substring(this._start,this._current),o={type:19,offset:this._start,lexeme:b};this._errors.push({offset:c,lexeme:b,additionalInfo:w}),this._tokens.push(o)}_string(){this.stringRe.lastIndex=this._start;const w=this.stringRe.exec(this._input);if(w){this._current=this._start+w[0].length;const c=this._input.substring(this._start,this._current),b=h._keywords.get(c);b?this._addToken(b):this._tokens.push({type:17,lexeme:c,offset:this._start})}}_quotedString(){for(;this._peek()!==39&&!this._isAtEnd();)this._advance();if(this._isAtEnd()){this._error(T);return}this._advance(),this._tokens.push({type:18,lexeme:this._input.substring(this._start+1,this._current-1),offset:this._start+1})}_regex(){let w=this._current,c=!1,b=!1;for(;;){if(w>=this._input.length){this._current=w,this._error(P);return}const a=this._input.charCodeAt(w);if(c)c=!1;else if(a===47&&!b){w++;break}else a===91?b=!0:a===92?c=!0:a===93&&(b=!1);w++}for(;w<this._input.length&&h._regexFlags.has(this._input.charCodeAt(w));)w++;this._current=w;const o=this._input.substring(this._start,this._current);this._tokens.push({type:10,lexeme:o,offset:this._start})}_isAtEnd(){return this._current>=this._input.length}}e.Scanner=h}),define(de[74],me([0,1,54,14,19,5,15,23,6]),function(ae,e,v,D,E,A,T,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.parseExtensionHostDebugPort=w,e.parseDebugParams=c,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+)[:=](.+)$/;class s{get appRoot(){return(0,A.dirname)(E.FileAccess.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:E.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.joinPath)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const o=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",o)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(h.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const o=T.env.VSCODE_PORTABLE;return o?h.URI.file((0,A.join)(o,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const o=this.args["builtin-extensions-dir"];return o?(0,A.resolve)(o):(0,A.normalize)((0,A.join)(E.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const o=this.args["extensions-download-dir"];return o?h.URI.file((0,A.resolve)(o)):h.URI.file((0,A.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const o=this.args["extensions-dir"];if(o)return(0,A.resolve)(o);const a=T.env.VSCODE_EXTENSIONS;if(a)return a;const g=T.env.VSCODE_PORTABLE;return g?(0,A.join)(g,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const o=this.args.extensionDevelopmentPath;if(Array.isArray(o))return o.map(a=>/^[^:/?#]+?:\/\//.test(a)?h.URI.parse(a):h.URI.file((0,A.normalize)(a)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(o=>o==="ui"||o==="workspace"||o==="web"?o:"workspace")}get extensionTestsLocationURI(){const o=this.args.extensionTestsPath;if(o)return/^[^:/?#]+?:\/\//.test(o)?h.URI.parse(o):h.URI.file((0,A.normalize)(o))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const o=this.args["disable-extension"];if(o){if(typeof o=="string")return[o];if(Array.isArray(o)&&o.length>0)return o}return!1}get debugExtensionHost(){return w(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(o=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(o))}get extensionLogLevel(){const o=[];for(const a of this.args.log||[]){const g=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(a);g&&g[1]&&g[2]&&o.push([g[1],g[2]])}return o.length?o:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const o=T.env.VSCODE_PORTABLE;return o?h.URI.file((0,A.join)(o,"policy.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(o){this.args.continueOn=o}get args(){return this._args}constructor(o,a,g){this._args=o,this.paths=a,this.productService=g,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=s,ye([D.memoize],s.prototype,"appRoot",null),ye([D.memoize],s.prototype,"userHome",null),ye([D.memoize],s.prototype,"userDataPath",null),ye([D.memoize],s.prototype,"appSettingsHome",null),ye([D.memoize],s.prototype,"tmpDir",null),ye([D.memoize],s.prototype,"cacheHome",null),ye([D.memoize],s.prototype,"stateResource",null),ye([D.memoize],s.prototype,"userRoamingDataHome",null),ye([D.memoize],s.prototype,"userDataSyncHome",null),ye([D.memoize],s.prototype,"sync",null),ye([D.memoize],s.prototype,"machineSettingsResource",null),ye([D.memoize],s.prototype,"workspaceStorageHome",null),ye([D.memoize],s.prototype,"localHistoryHome",null),ye([D.memoize],s.prototype,"keyboardLayoutResource",null),ye([D.memoize],s.prototype,"argvResource",null),ye([D.memoize],s.prototype,"isExtensionDevelopment",null),ye([D.memoize],s.prototype,"untitledWorkspacesHome",null),ye([D.memoize],s.prototype,"builtinExtensionsPath",null),ye([D.memoize],s.prototype,"extensionsPath",null),ye([D.memoize],s.prototype,"extensionDevelopmentLocationURI",null),ye([D.memoize],s.prototype,"extensionDevelopmentKind",null),ye([D.memoize],s.prototype,"extensionTestsLocationURI",null),ye([D.memoize],s.prototype,"debugExtensionHost",null),ye([D.memoize],s.prototype,"logLevel",null),ye([D.memoize],s.prototype,"extensionLogLevel",null),ye([D.memoize],s.prototype,"serviceMachineIdResource",null),ye([D.memoize],s.prototype,"disableTelemetry",null),ye([D.memoize],s.prototype,"disableWorkspaceTrust",null),ye([D.memoize],s.prototype,"useInMemorySecretStorage",null),ye([D.memoize],s.prototype,"policyFile",null);function w(b,o){return c(b["inspect-extensions"],b["inspect-brk-extensions"],5870,o,b.debugId,b.extensionEnvironment)}function c(b,o,a,g,d,n){const f=Number(o||b)||(g?null:a),C=f?!!o:!1;let i;if(n)try{i=JSON.parse(n)}catch{}return{port:f,break:C,debugId:d,env:i}}}),define(de[75],me([0,1,108,3,68]),function(ae,e,v,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OPTIONS=e.NATIVE_CLI_COMMANDS=void 0,e.parseArgs=P,e.formatOptions=s,e.buildHelpMessage=o,e.buildVersionMessage=a;const A={o:(0,E.localize)(0,null),e:(0,E.localize)(1,null),t:(0,E.localize)(2,null)};e.NATIVE_CLI_COMMANDS=["tunnel","serve-web"],e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,E.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,E.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,E.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,E.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,E.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,E.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,E.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,E.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,E.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,E.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,E.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,E.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,E.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,E.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,E.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,E.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,E.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,E.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,E.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,E.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,E.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,E.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,E.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,E.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,E.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,E.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,E.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,E.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,E.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,E.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,E.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(g,d,n=T){const r=g.find(S=>S.length>0&&S[0]!=="-"),f={},C=["_"],i=[],t={};let l;for(const S in d){const y=d[S];y.type==="subcommand"?S===r&&(l=y):(y.alias&&(f[S]=y.alias),y.type==="string"||y.type==="string[]"?(C.push(S),y.deprecates&&C.push(...y.deprecates)):y.type==="boolean"&&(i.push(S),y.deprecates&&i.push(...y.deprecates)),y.global&&(t[S]=y))}if(l&&r){const S=t;for(const z in l.options)S[z]=l.options[z];const y=g.filter(z=>z!==r),U=n.getSubcommandReporter?n.getSubcommandReporter(r):void 0,K=P(y,S,U);return{[r]:K,_:[]}}const L=v(g,{string:C,boolean:i,alias:f}),p={},k=L;p._=L._.map(S=>String(S)).filter(S=>S.length>0),delete k._;for(const S in d){const y=d[S];if(y.type==="subcommand")continue;y.alias&&delete k[y.alias];let U=k[S];if(y.deprecates)for(const K of y.deprecates)k.hasOwnProperty(K)&&(U||(U=k[K],U&&n.onDeprecatedOption(K,y.deprecationMessage||(0,E.localize)(38,null,S))),delete k[K]);if(typeof U<"u"){if(y.type==="string[]"){if(Array.isArray(U)||(U=[U]),!y.allowEmptyValue){const K=U.filter(z=>z.length>0);K.length!==U.length&&(n.onEmptyValue(S),U=K.length>0?K:void 0)}}else y.type==="string"&&(Array.isArray(U)?(U=U.pop(),n.onMultipleValues(S,U)):!U&&!y.allowEmptyValue&&(n.onEmptyValue(S),U=void 0));p[S]=U,y.deprecationMessage&&n.onDeprecatedOption(S,y.deprecationMessage)}delete k[S]}for(const S in k)n.onUnknownOption(S);return p}function h(g,d){let n="";return d.args&&(Array.isArray(d.args)?n=` <${d.args.join("> <")}>`:n=` <${d.args}>`),d.alias?`-${d.alias} --${g}${n}`:`--${g}${n}`}function s(g,d){const n=[];for(const r in g){const f=g[r],C=h(r,f);n.push([C,f.description])}return w(n,d)}function w(g,d){const r=g.reduce((i,t)=>Math.max(i,t[0].length),12)+2+1;if(d-r<25)return g.reduce((i,t)=>i.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const f=d-r-1,C=[];for(const i of g){const t=i[0],l=b(i[1],f),L=c(r-t.length-2);C.push("  "+t+L+l[0]);for(let p=1;p<l.length;p++)C.push(c(r)+l[p])}return C}function c(g){return" ".repeat(g)}function b(g,d){const n=[];for(;g.length;){const r=g.length<d?g.length:g.lastIndexOf(" ",d),f=g.slice(0,r).trim();g=g.slice(r),n.push(f)}return n}function o(g,d,n,r,f){const C=process.stdout.isTTY&&process.stdout.columns||80,i=f?.noInputFiles!==!0?`[${(0,E.localize)(39,null)}...]`:"",t=[`${g} ${n}`];t.push(""),t.push(`${(0,E.localize)(40,null)}: ${d} [${(0,E.localize)(41,null)}]${i}`),t.push(""),f?.noPipe!==!0&&(D.isWindows?t.push((0,E.localize)(42,null,d)):t.push((0,E.localize)(43,null,d)),t.push(""));const l={},L=[];for(const p in r){const k=r[p];if(k.type==="subcommand")k.description&&L.push({command:p,description:k.description});else if(k.description&&k.cat){let S=l[k.cat];S||(l[k.cat]=S={}),S[p]=k}}for(const p in l){const k=p,S=l[k];S&&(t.push(A[k]),t.push(...s(S,C)),t.push(""))}return L.length&&(t.push((0,E.localize)(44,null)),t.push(...w(L.map(p=>[p.command,p.description]),C)),t.push("")),t.join(`
`)}function a(g,d){return`${g||(0,E.localize)(45,null)}
${d||(0,E.localize)(46,null)}
${process.arch}`}}),function(){"use strict";function ae(e,v,D){function E(T,P){const h=A(T,P),s=[h];return e.isAbsolute(h)||s.unshift(D),e.resolve(...s)}function A(T,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let s=process.env.VSCODE_APPDATA;if(s)return e.join(s,P);const w=T["user-data-dir"];if(w)return w;switch(process.platform){case"win32":if(s=process.env.APPDATA,!s){const c=process.env.USERPROFILE;if(typeof c!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");s=e.join(c,"AppData","Roaming")}break;case"darwin":s=e.join(v.homedir(),"Library","Application Support");break;case"linux":s=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(s,P)}return{getUserDataPath:E}}if(typeof define=="function")define(de[76],me([77,20,15]),function(e,v,D){return ae(e,v,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),v=require("os");module.exports=ae(e,v,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(de[78],me([0,1,20,74,76]),function(ae,e,v,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0,e.parsePtyHostDebugPort=T,e.parseSharedProcessDebugPort=P;class A extends D.AbstractNativeEnvironmentService{constructor(s,w){super(s,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,E.getUserDataPath)(s,w.nameShort)},w)}}e.NativeEnvironmentService=A;function T(h,s){return(0,D.parseDebugParams)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,s,h.extensionEnvironment)}function P(h,s){return(0,D.parseDebugParams)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,s,h.extensionEnvironment)}}),define(de[21],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IInstantiationService=e._util=void 0,e.createDecorator=E,e.refineServiceDecorator=A;var v;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function P(h){return h[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=P})(v||(e._util=v={})),e.IInstantiationService=E("instantiationService");function D(T,P,h){P[v.DI_TARGET]===P?P[v.DI_DEPENDENCIES].push({id:T,index:h}):(P[v.DI_DEPENDENCIES]=[{id:T,index:h}],P[v.DI_TARGET]=P)}function E(T){if(v.serviceIds.has(T))return v.serviceIds.get(T);const P=function(h,s,w){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(P,h,w)};return P.toString=()=>T,v.serviceIds.set(T,P),P}function A(T){return T}}),define(de[35],me([0,1,3,12,73,21,66,7]),function(ae,e,v,D,E,A,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=void 0,e.setConstant=s,e.validateWhenClauses=l,e.expressionsAreEqualWithConstantSubstitution=L,e.implies=fe;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",v.isMacintosh),h.set("isLinux",v.isLinux),h.set("isWindows",v.isWindows),h.set("isWeb",v.isWeb),h.set("isMacNative",v.isMacintosh&&!v.isWeb),h.set("isEdge",v.isEdge),h.set("isFirefox",v.isFirefox),h.set("isChrome",v.isChrome),h.set("isSafari",v.isSafari);function s(J,u){if(h.get(J)!==void 0)throw(0,P.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(J,u)}const w=Object.prototype.hasOwnProperty;var c;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(c||(e.ContextKeyExprType=c={}));const b={regexParsingWithErrorRecovery:!0},o=(0,T.localize)(0,null),a=(0,T.localize)(1,null),g=(0,T.localize)(2,null),d=(0,T.localize)(3,null),n=(0,T.localize)(4,null),r=(0,T.localize)(5,null),f=(0,T.localize)(6,null),C=(0,T.localize)(7,null);class i{static{this._parseError=new Error}get lexingErrors(){return this._scanner.errors}get parsingErrors(){return this._parsingErrors}constructor(u=b){this._config=u,this._scanner=new E.Scanner,this._tokens=[],this._current=0,this._parsingErrors=[],this._flagsGYRe=/g|y/g}parse(u){if(u===""){this._parsingErrors.push({message:o,offset:0,lexeme:"",additionalInfo:a});return}this._tokens=this._scanner.reset(u).scan(),this._current=0,this._parsingErrors=[];try{const N=this._expr();if(!this._isAtEnd()){const ie=this._peek(),ne=ie.type===17?r:void 0;throw this._parsingErrors.push({message:n,offset:ie.offset,lexeme:E.Scanner.getLexeme(ie),additionalInfo:ne}),i._parseError}return N}catch(N){if(N!==i._parseError)throw N;return}}_expr(){return this._or()}_or(){const u=[this._and()];for(;this._matchOne(16);){const N=this._and();u.push(N)}return u.length===1?u[0]:t.or(...u)}_and(){const u=[this._term()];for(;this._matchOne(15);){const N=this._term();u.push(N)}return u.length===1?u[0]:t.and(...u)}_term(){if(this._matchOne(2)){const u=this._peek();switch(u.type){case 11:return this._advance(),k.INSTANCE;case 12:return this._advance(),S.INSTANCE;case 0:{this._advance();const N=this._expr();return this._consume(1,d),N?.negate()}case 17:return this._advance(),m.create(u.lexeme);default:throw this._errExpectedButGot("KEY | true | false | '(' expression ')'",u)}}return this._primary()}_primary(){const u=this._peek();switch(u.type){case 11:return this._advance(),t.true();case 12:return this._advance(),t.false();case 0:{this._advance();const N=this._expr();return this._consume(1,d),N}case 17:{const N=u.lexeme;if(this._advance(),this._matchOne(9)){const ne=this._peek();if(!this._config.regexParsingWithErrorRecovery){if(this._advance(),ne.type!==10)throw this._errExpectedButGot("REGEX",ne);const x=ne.lexeme,B=x.lastIndexOf("/"),F=B===x.length-1?void 0:this._removeFlagsGY(x.substring(B+1));let M;try{M=new RegExp(x.substring(1,B),F)}catch{throw this._errExpectedButGot("REGEX",ne)}return H.create(N,M)}switch(ne.type){case 10:case 19:{const x=[ne.lexeme];this._advance();let B=this._peek(),F=0;for(let se=0;se<ne.lexeme.length;se++)ne.lexeme.charCodeAt(se)===40?F++:ne.lexeme.charCodeAt(se)===41&&F--;for(;!this._isAtEnd()&&B.type!==15&&B.type!==16;){switch(B.type){case 0:F++;break;case 1:F--;break;case 10:case 18:for(let se=0;se<B.lexeme.length;se++)B.lexeme.charCodeAt(se)===40?F++:ne.lexeme.charCodeAt(se)===41&&F--}if(F<0)break;x.push(E.Scanner.getLexeme(B)),this._advance(),B=this._peek()}const M=x.join(""),j=M.lastIndexOf("/"),Z=j===M.length-1?void 0:this._removeFlagsGY(M.substring(j+1));let re;try{re=new RegExp(M.substring(1,j),Z)}catch{throw this._errExpectedButGot("REGEX",ne)}return t.regex(N,re)}case 18:{const x=ne.lexeme;this._advance();let B=null;if(!(0,D.isFalsyOrWhitespace)(x)){const F=x.indexOf("/"),M=x.lastIndexOf("/");if(F!==M&&F>=0){const j=x.slice(F+1,M),Z=x[M+1]==="i"?"i":"";try{B=new RegExp(j,Z)}catch{throw this._errExpectedButGot("REGEX",ne)}}}if(B===null)throw this._errExpectedButGot("REGEX",ne);return H.create(N,B)}default:throw this._errExpectedButGot("REGEX",this._peek())}}if(this._matchOne(14)){this._consume(13,g);const ne=this._value();return t.notIn(N,ne)}switch(this._peek().type){case 3:{this._advance();const ne=this._value();if(this._previous().type===18)return t.equals(N,ne);switch(ne){case"true":return t.has(N);case"false":return t.not(N);default:return t.equals(N,ne)}}case 4:{this._advance();const ne=this._value();if(this._previous().type===18)return t.notEquals(N,ne);switch(ne){case"true":return t.not(N);case"false":return t.has(N);default:return t.notEquals(N,ne)}}case 5:return this._advance(),G.create(N,this._value());case 6:return this._advance(),te.create(N,this._value());case 7:return this._advance(),_.create(N,this._value());case 8:return this._advance(),I.create(N,this._value());case 13:return this._advance(),t.in(N,this._value());default:return t.has(N)}}case 20:throw this._parsingErrors.push({message:f,offset:u.offset,lexeme:"",additionalInfo:C}),i._parseError;default:throw this._errExpectedButGot(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this._peek())}}_value(){const u=this._peek();switch(u.type){case 17:case 18:return this._advance(),u.lexeme;case 11:return this._advance(),"true";case 12:return this._advance(),"false";case 13:return this._advance(),"in";default:return""}}_removeFlagsGY(u){return u.replaceAll(this._flagsGYRe,"")}_previous(){return this._tokens[this._current-1]}_matchOne(u){return this._check(u)?(this._advance(),!0):!1}_advance(){return this._isAtEnd()||this._current++,this._previous()}_consume(u,N){if(this._check(u))return this._advance();throw this._errExpectedButGot(N,this._peek())}_errExpectedButGot(u,N,ie){const ne=(0,T.localize)(8,null,u,E.Scanner.getLexeme(N)),x=N.offset,B=E.Scanner.getLexeme(N);return this._parsingErrors.push({message:ne,offset:x,lexeme:B,additionalInfo:ie}),i._parseError}_check(u){return this._peek().type===u}_peek(){return this._tokens[this._current]}_isAtEnd(){return this._peek().type===20}}e.Parser=i;class t{static false(){return k.INSTANCE}static true(){return S.INSTANCE}static has(u){return y.create(u)}static equals(u,N){return U.create(u,N)}static notEquals(u,N){return O.create(u,N)}static regex(u,N){return H.create(u,N)}static in(u,N){return K.create(u,N)}static notIn(u,N){return z.create(u,N)}static not(u){return m.create(u)}static and(...u){return ue.create(u,null,!0)}static or(...u){return V.create(u,null,!0)}static greater(u,N){return _.create(u,N)}static greaterEquals(u,N){return I.create(u,N)}static smaller(u,N){return G.create(u,N)}static smallerEquals(u,N){return te.create(u,N)}static{this._parser=new i({regexParsingWithErrorRecovery:!1})}static deserialize(u){return u==null?void 0:this._parser.parse(u)}}e.ContextKeyExpr=t;function l(J){const u=new i({regexParsingWithErrorRecovery:!1});return J.map(N=>(u.parse(N),u.lexingErrors.length>0?u.lexingErrors.map(ie=>({errorMessage:ie.additionalInfo?(0,T.localize)(9,null,ie.additionalInfo):(0,T.localize)(10,null),offset:ie.offset,length:ie.lexeme.length})):u.parsingErrors.length>0?u.parsingErrors.map(ie=>({errorMessage:ie.additionalInfo?`${ie.message}. ${ie.additionalInfo}`:ie.message,offset:ie.offset,length:ie.lexeme.length})):[]))}function L(J,u){const N=J?J.substituteConstants():void 0,ie=u?u.substituteConstants():void 0;return!N&&!ie?!0:!N||!ie?!1:N.equals(ie)}function p(J,u){return J.cmp(u)}class k{static{this.INSTANCE=new k}constructor(){this.type=0}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}substituteConstants(){return this}evaluate(u){return!1}serialize(){return"false"}keys(){return[]}map(u){return this}negate(){return S.INSTANCE}}e.ContextKeyFalseExpr=k;class S{static{this.INSTANCE=new S}constructor(){this.type=1}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}substituteConstants(){return this}evaluate(u){return!0}serialize(){return"true"}keys(){return[]}map(u){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=S;class y{static create(u,N=null){const ie=h.get(u);return typeof ie=="boolean"?ie?S.INSTANCE:k.INSTANCE:new y(u,N)}constructor(u,N){this.key=u,this.negated=N,this.type=2}cmp(u){return u.type!==this.type?this.type-u.type:Q(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}substituteConstants(){const u=h.get(this.key);return typeof u=="boolean"?u?S.INSTANCE:k.INSTANCE:this}evaluate(u){return!!u.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(u){return u.mapDefined(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=y;class U{static create(u,N,ie=null){if(typeof N=="boolean")return N?y.create(u,ie):m.create(u,ie);const ne=h.get(u);return typeof ne=="boolean"?N===(ne?"true":"false")?S.INSTANCE:k.INSTANCE:new U(u,N,ie)}constructor(u,N,ie){this.key=u,this.value=N,this.negated=ie,this.type=4}cmp(u){return u.type!==this.type?this.type-u.type:Y(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}substituteConstants(){const u=h.get(this.key);if(typeof u=="boolean"){const N=u?"true":"false";return this.value===N?S.INSTANCE:k.INSTANCE}return this}evaluate(u){return u.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(u){return u.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=O.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=U;class K{static create(u,N){return new K(u,N)}constructor(u,N){this.key=u,this.valueKey=N,this.type=10,this.negated=null}cmp(u){return u.type!==this.type?this.type-u.type:Y(this.key,this.valueKey,u.key,u.valueKey)}equals(u){return u.type===this.type?this.key===u.key&&this.valueKey===u.valueKey:!1}substituteConstants(){return this}evaluate(u){const N=u.getValue(this.valueKey),ie=u.getValue(this.key);return Array.isArray(N)?N.includes(ie):typeof ie=="string"&&typeof N=="object"&&N!==null?w.call(N,ie):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(u){return u.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=z.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=K;class z{static create(u,N){return new z(u,N)}constructor(u,N){this.key=u,this.valueKey=N,this.type=11,this._negated=K.create(u,N)}cmp(u){return u.type!==this.type?this.type-u.type:this._negated.cmp(u._negated)}equals(u){return u.type===this.type?this._negated.equals(u._negated):!1}substituteConstants(){return this}evaluate(u){return!this._negated.evaluate(u)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(u){return u.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=z;class O{static create(u,N,ie=null){if(typeof N=="boolean")return N?m.create(u,ie):y.create(u,ie);const ne=h.get(u);return typeof ne=="boolean"?N===(ne?"true":"false")?k.INSTANCE:S.INSTANCE:new O(u,N,ie)}constructor(u,N,ie){this.key=u,this.value=N,this.negated=ie,this.type=5}cmp(u){return u.type!==this.type?this.type-u.type:Y(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}substituteConstants(){const u=h.get(this.key);if(typeof u=="boolean"){const N=u?"true":"false";return this.value===N?k.INSTANCE:S.INSTANCE}return this}evaluate(u){return u.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(u){return u.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=U.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=O;class m{static create(u,N=null){const ie=h.get(u);return typeof ie=="boolean"?ie?k.INSTANCE:S.INSTANCE:new m(u,N)}constructor(u,N){this.key=u,this.negated=N,this.type=3}cmp(u){return u.type!==this.type?this.type-u.type:Q(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}substituteConstants(){const u=h.get(this.key);return typeof u=="boolean"?u?k.INSTANCE:S.INSTANCE:this}evaluate(u){return!u.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(u){return u.mapNot(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=m;function R(J,u){if(typeof J=="string"){const N=parseFloat(J);isNaN(N)||(J=N)}return typeof J=="string"||typeof J=="number"?u(J):k.INSTANCE}class _{static create(u,N,ie=null){return R(N,ne=>new _(u,ne,ie))}constructor(u,N,ie){this.key=u,this.value=N,this.negated=ie,this.type=12}cmp(u){return u.type!==this.type?this.type-u.type:Y(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}substituteConstants(){return this}evaluate(u){return typeof this.value=="string"?!1:parseFloat(u.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=te.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=_;class I{static create(u,N,ie=null){return R(N,ne=>new I(u,ne,ie))}constructor(u,N,ie){this.key=u,this.value=N,this.negated=ie,this.type=13}cmp(u){return u.type!==this.type?this.type-u.type:Y(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}substituteConstants(){return this}evaluate(u){return typeof this.value=="string"?!1:parseFloat(u.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(u){return u.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=G.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=I;class G{static create(u,N,ie=null){return R(N,ne=>new G(u,ne,ie))}constructor(u,N,ie){this.key=u,this.value=N,this.negated=ie,this.type=14}cmp(u){return u.type!==this.type?this.type-u.type:Y(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}substituteConstants(){return this}evaluate(u){return typeof this.value=="string"?!1:parseFloat(u.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=I.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=G;class te{static create(u,N,ie=null){return R(N,ne=>new te(u,ne,ie))}constructor(u,N,ie){this.key=u,this.value=N,this.negated=ie,this.type=15}cmp(u){return u.type!==this.type?this.type-u.type:Y(this.key,this.value,u.key,u.value)}equals(u){return u.type===this.type?this.key===u.key&&this.value===u.value:!1}substituteConstants(){return this}evaluate(u){return typeof this.value=="string"?!1:parseFloat(u.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(u){return u.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=te;class H{static create(u,N){return new H(u,N)}constructor(u,N){this.key=u,this.regexp=N,this.type=7,this.negated=null}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.key<u.key)return-1;if(this.key>u.key)return 1;const N=this.regexp?this.regexp.source:"",ie=u.regexp?u.regexp.source:"";return N<ie?-1:N>ie?1:0}equals(u){if(u.type===this.type){const N=this.regexp?this.regexp.source:"",ie=u.regexp?u.regexp.source:"";return this.key===u.key&&N===ie}return!1}substituteConstants(){return this}evaluate(u){const N=u.getValue(this.key);return this.regexp?this.regexp.test(N):!1}serialize(){const u=this.regexp?`/${this.regexp.source}/${this.regexp.flags}`:"/invalid/";return`${this.key} =~ ${u}`}keys(){return[this.key]}map(u){return u.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=ee.create(this)),this.negated}}e.ContextKeyRegexExpr=H;class ee{static create(u){return new ee(u)}constructor(u){this._actual=u,this.type=8}cmp(u){return u.type!==this.type?this.type-u.type:this._actual.cmp(u._actual)}equals(u){return u.type===this.type?this._actual.equals(u._actual):!1}substituteConstants(){return this}evaluate(u){return!this._actual.evaluate(u)}serialize(){return`!(${this._actual.serialize()})`}keys(){return this._actual.keys()}map(u){return new ee(this._actual.map(u))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=ee;function le(J){let u=null;for(let N=0,ie=J.length;N<ie;N++){const ne=J[N].substituteConstants();if(J[N]!==ne&&u===null){u=[];for(let x=0;x<N;x++)u[x]=J[x]}u!==null&&(u[N]=ne)}return u===null?J:u}class ue{static create(u,N,ie){return ue._normalizeArr(u,N,ie)}constructor(u,N){this.expr=u,this.negated=N,this.type=6}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let N=0,ie=this.expr.length;N<ie;N++){const ne=p(this.expr[N],u.expr[N]);if(ne!==0)return ne}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let N=0,ie=this.expr.length;N<ie;N++)if(!this.expr[N].equals(u.expr[N]))return!1;return!0}return!1}substituteConstants(){const u=le(this.expr);return u===this.expr?this:ue.create(u,this.negated,!1)}evaluate(u){for(let N=0,ie=this.expr.length;N<ie;N++)if(!this.expr[N].evaluate(u))return!1;return!0}static _normalizeArr(u,N,ie){const ne=[];let x=!1;for(const B of u)if(B){if(B.type===1){x=!0;continue}if(B.type===0)return k.INSTANCE;if(B.type===6){ne.push(...B.expr);continue}ne.push(B)}if(ne.length===0&&x)return S.INSTANCE;if(ne.length!==0){if(ne.length===1)return ne[0];ne.sort(p);for(let B=1;B<ne.length;B++)ne[B-1].equals(ne[B])&&(ne.splice(B,1),B--);if(ne.length===1)return ne[0];for(;ne.length>1;){const B=ne[ne.length-1];if(B.type!==9)break;ne.pop();const F=ne.pop(),M=ne.length===0,j=V.create(B.expr.map(Z=>ue.create([Z,F],null,ie)),null,M);j&&(ne.push(j),ne.sort(p))}if(ne.length===1)return ne[0];if(ie){for(let B=0;B<ne.length;B++)for(let F=B+1;F<ne.length;F++)if(ne[B].negate().equals(ne[F]))return k.INSTANCE;if(ne.length===1)return ne[0]}return new ue(ne,N)}}serialize(){return this.expr.map(u=>u.serialize()).join(" && ")}keys(){const u=[];for(const N of this.expr)u.push(...N.keys());return u}map(u){return new ue(this.expr.map(N=>N.map(u)),null)}negate(){if(!this.negated){const u=[];for(const N of this.expr)u.push(N.negate());this.negated=V.create(u,this,!0)}return this.negated}}e.ContextKeyAndExpr=ue;class V{static create(u,N,ie){return V._normalizeArr(u,N,ie)}constructor(u,N){this.expr=u,this.negated=N,this.type=9}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let N=0,ie=this.expr.length;N<ie;N++){const ne=p(this.expr[N],u.expr[N]);if(ne!==0)return ne}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let N=0,ie=this.expr.length;N<ie;N++)if(!this.expr[N].equals(u.expr[N]))return!1;return!0}return!1}substituteConstants(){const u=le(this.expr);return u===this.expr?this:V.create(u,this.negated,!1)}evaluate(u){for(let N=0,ie=this.expr.length;N<ie;N++)if(this.expr[N].evaluate(u))return!0;return!1}static _normalizeArr(u,N,ie){let ne=[],x=!1;if(u){for(let B=0,F=u.length;B<F;B++){const M=u[B];if(M){if(M.type===0){x=!0;continue}if(M.type===1)return S.INSTANCE;if(M.type===9){ne=ne.concat(M.expr);continue}ne.push(M)}}if(ne.length===0&&x)return k.INSTANCE;ne.sort(p)}if(ne.length!==0){if(ne.length===1)return ne[0];for(let B=1;B<ne.length;B++)ne[B-1].equals(ne[B])&&(ne.splice(B,1),B--);if(ne.length===1)return ne[0];if(ie){for(let B=0;B<ne.length;B++)for(let F=B+1;F<ne.length;F++)if(ne[B].negate().equals(ne[F]))return S.INSTANCE;if(ne.length===1)return ne[0]}return new V(ne,N)}}serialize(){return this.expr.map(u=>u.serialize()).join(" || ")}keys(){const u=[];for(const N of this.expr)u.push(...N.keys());return u}map(u){return new V(this.expr.map(N=>N.map(u)),null)}negate(){if(!this.negated){const u=[];for(const N of this.expr)u.push(N.negate());for(;u.length>1;){const N=u.shift(),ie=u.shift(),ne=[];for(const x of ce(N))for(const B of ce(ie))ne.push(ue.create([x,B],null,!1));u.unshift(V.create(ne,null,!1))}this.negated=V.create(u,this,!0)}return this.negated}}e.ContextKeyOrExpr=V;class $ extends y{static{this._info=[]}static all(){return $._info.values()}constructor(u,N,ie){super(u,null),this._defaultValue=N,typeof ie=="object"?$._info.push({...ie,key:u}):ie!==!0&&$._info.push({key:u,description:ie,type:N!=null?typeof N:void 0})}bindTo(u){return u.createKey(this.key,this._defaultValue)}getValue(u){return u.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(u){return U.create(this.key,u)}notEqualsTo(u){return O.create(this.key,u)}}e.RawContextKey=$,e.IContextKeyService=(0,A.createDecorator)("contextKeyService");function Q(J,u){return J<u?-1:J>u?1:0}function Y(J,u,N,ie){return J<N?-1:J>N?1:u<ie?-1:u>ie?1:0}function fe(J,u){if(J.type===0||u.type===1)return!0;if(J.type===9)return u.type===9?W(J.expr,u.expr):!1;if(u.type===9){for(const N of u.expr)if(fe(J,N))return!0;return!1}if(J.type===6){if(u.type===6)return W(u.expr,J.expr);for(const N of J.expr)if(fe(N,u))return!0;return!1}return J.equals(u)}function W(J,u){let N=0,ie=0;for(;N<J.length&&ie<u.length;){const ne=J[N].cmp(u[ie]);if(ne<0)return!1;ne===0&&N++,ie++}return N===J.length}function ce(J){return J.type===9?J.expr:[J]}}),define(de[79],me([0,1,51,5,12,9,6,69,21,3,19,22]),function(ae,e,v,D,E,A,T,P,h,s,w,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ByteSize=e.ETAG_DISABLED=e.FileKind=e.FILES_READONLY_FROM_PERMISSIONS_CONFIG=e.FILES_READONLY_EXCLUDE_CONFIG=e.FILES_READONLY_INCLUDE_CONFIG=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.IFileService=void 0,e.isFileOpenForWriteOptions=b,e.isFileSystemWatcher=d,e.hasReadWriteCapability=r,e.hasFileFolderCopyCapability=f,e.hasFileCloneCapability=C,e.hasOpenReadWriteCloseCapability=i,e.hasFileReadStreamCapability=t,e.hasFileAtomicReadCapability=l,e.hasFileAtomicWriteCapability=L,e.hasFileAtomicDeleteCapability=p,e.hasReadonlyCapability=k,e.createFileSystemProviderError=U,e.ensureFileSystemProviderError=K,e.markAsFileSystemProviderError=z,e.toFileSystemProviderErrorCode=O,e.toFileOperationResult=m,e.isParent=te,e.etag=$,e.whenProviderRegistered=Q,e.getLargeFileConfirmationLimit=fe,e.IFileService=(0,h.createDecorator)("fileService");function b(W){return W.create===!0}var o;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(o||(e.FileType=o={}));var a;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(a||(e.FilePermission=a={}));var g;(function(W){W[W.UPDATED=2]="UPDATED",W[W.ADDED=4]="ADDED",W[W.DELETED=8]="DELETED"})(g||(e.FileChangeFilter=g={}));function d(W){const ce=W;return!!ce&&typeof ce.onDidChange=="function"}var n;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})(n||(e.FileSystemProviderCapabilities=n={}));function r(W){return!!(W.capabilities&2)}function f(W){return!!(W.capabilities&8)}function C(W){return!!(W.capabilities&131072)}function i(W){return!!(W.capabilities&4)}function t(W){return!!(W.capabilities&16)}function l(W){return r(W)?!!(W.capabilities&16384):!1}function L(W){return r(W)?!!(W.capabilities&32768):!1}function p(W){return!!(W.capabilities&65536)}function k(W){return!!(W.capabilities&2048)}var S;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(S||(e.FileSystemProviderErrorCode=S={}));class y extends Error{static create(ce,J){const u=new y(ce.toString(),J);return z(u,J),u}constructor(ce,J){super(ce),this.code=J}}e.FileSystemProviderError=y;function U(W,ce){return y.create(W,ce)}function K(W){return W||U((0,P.localize)(0,null),S.Unknown)}function z(W,ce){return W.name=ce?`${ce} (FileSystemError)`:"FileSystemError",W}function O(W){if(!W)return S.Unknown;if(W instanceof y)return W.code;const ce=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!ce)return S.Unknown;switch(ce[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}function m(W){if(W instanceof H)return W.fileOperationResult;switch(O(W)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 9;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileTooLarge:return 7;default:return 10}}var R;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(R||(e.FileOperation=R={}));class _{constructor(ce,J,u){this.resource=ce,this.operation=J,this.target=u}isOperation(ce){return this.operation===ce}}e.FileOperationEvent=_;var I;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(I||(e.FileChangeType=I={}));class G{static{this.MIXED_CORRELATION=null}constructor(ce,J){this.ignorePathCasing=J,this.correlationId=void 0,this.added=new c.Lazy(()=>{const u=v.TernarySearchTree.forUris(()=>this.ignorePathCasing);return u.fill(this.rawAdded.map(N=>[N,!0])),u}),this.updated=new c.Lazy(()=>{const u=v.TernarySearchTree.forUris(()=>this.ignorePathCasing);return u.fill(this.rawUpdated.map(N=>[N,!0])),u}),this.deleted=new c.Lazy(()=>{const u=v.TernarySearchTree.forUris(()=>this.ignorePathCasing);return u.fill(this.rawDeleted.map(N=>[N,!0])),u}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const u of ce){switch(u.type){case 1:this.rawAdded.push(u.resource);break;case 0:this.rawUpdated.push(u.resource);break;case 2:this.rawDeleted.push(u.resource);break}this.correlationId!==G.MIXED_CORRELATION&&(typeof u.cId=="number"?this.correlationId===void 0?this.correlationId=u.cId:this.correlationId!==u.cId&&(this.correlationId=G.MIXED_CORRELATION):this.correlationId!==void 0&&(this.correlationId=G.MIXED_CORRELATION))}}contains(ce,...J){return this.doContains(ce,{includeChildren:!1},...J)}affects(ce,...J){return this.doContains(ce,{includeChildren:!0},...J)}doContains(ce,J,...u){if(!ce)return!1;const N=u.length>0;return!!((!N||u.includes(1))&&(this.added.value.get(ce)||J.includeChildren&&this.added.value.findSuperstr(ce))||(!N||u.includes(0))&&(this.updated.value.get(ce)||J.includeChildren&&this.updated.value.findSuperstr(ce))||(!N||u.includes(2))&&(this.deleted.value.findSubstr(ce)||J.includeChildren&&this.deleted.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.correlationId===ce}hasCorrelation(){return typeof this.correlationId=="number"}}e.FileChangesEvent=G;function te(W,ce,J){return!W||!ce||W===ce||ce.length>W.length?!1:(ce.charAt(ce.length-1)!==D.sep&&(ce+=D.sep),J?(0,E.startsWithIgnoreCase)(W,ce):W.indexOf(ce)===0)}class H extends Error{constructor(ce,J,u){super(ce),this.fileOperationResult=J,this.options=u}}e.FileOperationError=H;class ee extends H{constructor(ce,J,u,N){super(ce,J,N),this.fileOperationResult=J,this.size=u}}e.TooLargeFileOperationError=ee;class le extends H{constructor(ce,J,u){super(ce,2,u),this.stat=J}}e.NotModifiedSinceFileOperationError=le;var ue;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ue||(e.FileOperationResult=ue={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude",e.FILES_READONLY_INCLUDE_CONFIG="files.readonlyInclude",e.FILES_READONLY_EXCLUDE_CONFIG="files.readonlyExclude",e.FILES_READONLY_FROM_PERMISSIONS_CONFIG="files.readonlyFromPermissions";var V;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(V||(e.FileKind=V={})),e.ETAG_DISABLED="";function $(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}async function Q(W,ce){if(!ce.hasProvider(T.URI.from({scheme:W.scheme})))return new Promise(J=>{const u=ce.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===W.scheme&&N.added&&(u.dispose(),J())})})}class Y{static{this.KB=1024}static{this.MB=Y.KB*Y.KB}static{this.GB=Y.MB*Y.KB}static{this.TB=Y.GB*Y.KB}static formatSize(ce){return(0,A.isNumber)(ce)||(ce=0),ce<Y.KB?(0,P.localize)(1,null,ce.toFixed(0)):ce<Y.MB?(0,P.localize)(2,null,(ce/Y.KB).toFixed(2)):ce<Y.GB?(0,P.localize)(3,null,(ce/Y.MB).toFixed(2)):ce<Y.TB?(0,P.localize)(4,null,(ce/Y.GB).toFixed(2)):(0,P.localize)(5,null,(ce/Y.TB).toFixed(2))}}e.ByteSize=Y;function fe(W){const ce=typeof W=="string"||W?.scheme===w.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===w.Schemas.file?1024*Y.MB:ce?10*Y.MB:s.isWeb?50*Y.MB:1024*Y.MB}}),define(de[8],me([0,1,70,56,4,49,2,25,3,23,9,6,35,21]),function(ae,e,v,D,E,A,T,P,h,s,w,c,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.isLogLevel=g,e.log=n,e.getLogLevel=y,e.LogLevelToString=U,e.LogLevelToLocalizedString=K,e.parseLogLevel=z,e.ILogService=(0,o.createDecorator)("logService"),e.ILoggerService=(0,o.createDecorator)("loggerService");function a(){return new Date().toISOString()}function g(O){return(0,w.isNumber)(O)}var d;(function(O){O[O.Off=0]="Off",O[O.Trace=1]="Trace",O[O.Debug=2]="Debug",O[O.Info=3]="Info",O[O.Warning=4]="Warning",O[O.Error=5]="Error"})(d||(e.LogLevel=d={})),e.DEFAULT_LOG_LEVEL=d.Info;function n(O,m,R){switch(m){case d.Trace:O.trace(R);break;case d.Debug:O.debug(R);break;case d.Info:O.info(R);break;case d.Warning:O.warn(R);break;case d.Error:O.error(R);break;case d.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function r(O,m=!1){let R="";for(let _=0;_<O.length;_++){let I=O[_];if(I instanceof Error&&(I=(0,D.toErrorMessage)(I,m)),typeof I=="object")try{I=JSON.stringify(I)}catch{}R+=(_>0?" ":"")+I}return R}class f extends T.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new E.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(m){this.level!==m&&(this.level=m,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}checkLogLevel(m){return this.level!==d.Off&&this.level<=m}}e.AbstractLogger=f;class C extends f{constructor(m){super(),this.logAlways=m}checkLogLevel(m){return this.logAlways||super.checkLogLevel(m)}trace(m,...R){this.checkLogLevel(d.Trace)&&this.log(d.Trace,r([m,...R],!0))}debug(m,...R){this.checkLogLevel(d.Debug)&&this.log(d.Debug,r([m,...R]))}info(m,...R){this.checkLogLevel(d.Info)&&this.log(d.Info,r([m,...R]))}warn(m,...R){this.checkLogLevel(d.Warning)&&this.log(d.Warning,r([m,...R]))}error(m,...R){if(this.checkLogLevel(d.Error))if(m instanceof Error){const _=Array.prototype.slice.call(arguments);_[0]=m.stack,this.log(d.Error,r(_))}else this.log(d.Error,r([m,...R]))}flush(){}}e.AbstractMessageLogger=C;class i extends f{constructor(m=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(m),this.useColors=!h.isWindows}trace(m,...R){this.checkLogLevel(d.Trace)&&(this.useColors?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,m,...R):console.log(`[main ${a()}]`,m,...R))}debug(m,...R){this.checkLogLevel(d.Debug)&&(this.useColors?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,m,...R):console.log(`[main ${a()}]`,m,...R))}info(m,...R){this.checkLogLevel(d.Info)&&(this.useColors?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,m,...R):console.log(`[main ${a()}]`,m,...R))}warn(m,...R){this.checkLogLevel(d.Warning)&&(this.useColors?console.warn(`\x1B[93m[main ${a()}]\x1B[0m`,m,...R):console.warn(`[main ${a()}]`,m,...R))}error(m,...R){this.checkLogLevel(d.Error)&&(this.useColors?console.error(`\x1B[91m[main ${a()}]\x1B[0m`,m,...R):console.error(`[main ${a()}]`,m,...R))}flush(){}}e.ConsoleMainLogger=i;class t extends f{constructor(m=e.DEFAULT_LOG_LEVEL,R=!0){super(),this.useColors=R,this.setLevel(m)}trace(m,...R){this.checkLogLevel(d.Trace)&&(this.useColors?console.log("%cTRACE","color: #888",m,...R):console.log(m,...R))}debug(m,...R){this.checkLogLevel(d.Debug)&&(this.useColors?console.log("%cDEBUG","background: #eee; color: #888",m,...R):console.log(m,...R))}info(m,...R){this.checkLogLevel(d.Info)&&(this.useColors?console.log("%c INFO","color: #33f",m,...R):console.log(m,...R))}warn(m,...R){this.checkLogLevel(d.Warning)&&(this.useColors?console.log("%c WARN","color: #993",m,...R):console.log(m,...R))}error(m,...R){this.checkLogLevel(d.Error)&&(this.useColors?console.log("%c  ERR","color: #f33",m,...R):console.error(m,...R))}flush(){}}e.ConsoleLogger=t;class l extends f{constructor(m,R=e.DEFAULT_LOG_LEVEL){super(),this.adapter=m,this.setLevel(R)}trace(m,...R){this.checkLogLevel(d.Trace)&&this.adapter.log(d.Trace,[this.extractMessage(m),...R])}debug(m,...R){this.checkLogLevel(d.Debug)&&this.adapter.log(d.Debug,[this.extractMessage(m),...R])}info(m,...R){this.checkLogLevel(d.Info)&&this.adapter.log(d.Info,[this.extractMessage(m),...R])}warn(m,...R){this.checkLogLevel(d.Warning)&&this.adapter.log(d.Warning,[this.extractMessage(m),...R])}error(m,...R){this.checkLogLevel(d.Error)&&this.adapter.log(d.Error,[this.extractMessage(m),...R])}extractMessage(m){return typeof m=="string"?m:(0,D.toErrorMessage)(m,this.checkLogLevel(d.Trace))}flush(){}}e.AdapterLogger=l;class L extends f{constructor(m){super(),this.loggers=m,m.length&&this.setLevel(m[0].getLevel())}setLevel(m){for(const R of this.loggers)R.setLevel(m);super.setLevel(m)}trace(m,...R){for(const _ of this.loggers)_.trace(m,...R)}debug(m,...R){for(const _ of this.loggers)_.debug(m,...R)}info(m,...R){for(const _ of this.loggers)_.info(m,...R)}warn(m,...R){for(const _ of this.loggers)_.warn(m,...R)}error(m,...R){for(const _ of this.loggers)_.error(m,...R)}flush(){for(const m of this.loggers)m.flush()}dispose(){for(const m of this.loggers)m.dispose();super.dispose()}}e.MultiplexLogger=L;class p extends T.Disposable{constructor(m,R,_){if(super(),this.logLevel=m,this.logsHome=R,this._loggers=new P.ResourceMap,this._onDidChangeLoggers=this._register(new E.Emitter),this.onDidChangeLoggers=this._onDidChangeLoggers.event,this._onDidChangeLogLevel=this._register(new E.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event,this._onDidChangeVisibility=this._register(new E.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,_)for(const I of _)this._loggers.set(I.resource,{logger:void 0,info:I})}getLoggerEntry(m){return(0,w.isString)(m)?[...this._loggers.values()].find(R=>R.info.id===m):this._loggers.get(m)}getLogger(m){return this.getLoggerEntry(m)?.logger}createLogger(m,R){const _=this.toResource(m),I=(0,w.isString)(m)?m:R?.id??(0,A.hash)(_.toString()).toString(16);let G=this._loggers.get(_)?.logger;const te=R?.logLevel==="always"?d.Trace:R?.logLevel;G||(G=this.doCreateLogger(_,te??this.getLogLevel(_)??this.logLevel,{...R,id:I}));const H={logger:G,info:{resource:_,id:I,logLevel:te,name:R?.name,hidden:R?.hidden,extensionId:R?.extensionId,when:R?.when}};return this.registerLogger(H.info),this._loggers.set(_,H),G}toResource(m){return(0,w.isString)(m)?(0,s.joinPath)(this.logsHome,`${m}.log`):m}setLogLevel(m,R){if(c.URI.isUri(m)){const _=m,I=R,G=this._loggers.get(_);G&&I!==G.info.logLevel&&(G.info.logLevel=I===this.logLevel?void 0:I,G.logger?.setLevel(I),this._loggers.set(G.info.resource,G),this._onDidChangeLogLevel.fire([_,I]))}else{this.logLevel=m;for(const[_,I]of this._loggers.entries())this._loggers.get(_)?.info.logLevel===void 0&&I.logger?.setLevel(this.logLevel);this._onDidChangeLogLevel.fire(this.logLevel)}}setVisibility(m,R){const _=this.getLoggerEntry(m);_&&R!==!_.info.hidden&&(_.info.hidden=!R,this._loggers.set(_.info.resource,_),this._onDidChangeVisibility.fire([_.info.resource,R]))}getLogLevel(m){let R;return m&&(R=this._loggers.get(m)?.info.logLevel),R??this.logLevel}registerLogger(m){const R=this._loggers.get(m.resource);R?R.info.hidden!==m.hidden&&this.setVisibility(m.resource,!m.hidden):(this._loggers.set(m.resource,{info:m,logger:void 0}),this._onDidChangeLoggers.fire({added:[m],removed:[]}))}deregisterLogger(m){const R=this._loggers.get(m);R&&(R.logger&&R.logger.dispose(),this._loggers.delete(m),this._onDidChangeLoggers.fire({added:[],removed:[R.info]}))}*getRegisteredLoggers(){for(const m of this._loggers.values())yield m.info}getRegisteredLogger(m){return this._loggers.get(m)?.info}dispose(){this._loggers.forEach(m=>m.logger?.dispose()),this._loggers.clear(),super.dispose()}}e.AbstractLoggerService=p;class k{constructor(){this.onDidChangeLogLevel=new E.Emitter().event}setLevel(m){}getLevel(){return d.Info}trace(m,...R){}debug(m,...R){}info(m,...R){}warn(m,...R){}error(m,...R){}critical(m,...R){}dispose(){}flush(){}}e.NullLogger=k;class S extends k{}e.NullLogService=S;function y(O){if(O.verbose)return d.Trace;if(typeof O.logLevel=="string"){const m=z(O.logLevel.toLowerCase());if(m!==void 0)return m}return e.DEFAULT_LOG_LEVEL}function U(O){switch(O){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}function K(O){switch(O){case d.Trace:return{original:"Trace",value:v.localize(0,null)};case d.Debug:return{original:"Debug",value:v.localize(1,null)};case d.Info:return{original:"Info",value:v.localize(2,null)};case d.Warning:return{original:"Warning",value:v.localize(3,null)};case d.Error:return{original:"Error",value:v.localize(4,null)};case d.Off:return{original:"Off",value:v.localize(5,null)}}}function z(O){switch(O){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.CONTEXT_LOG_LEVEL=new b.RawContextKey("logLevel",U(d.Info))}),define(de[80],me([0,1,6,4,8,2]),function(ae,e,v,D,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class T extends E.AbstractLoggerService{constructor(c,b,o,a,g){super(b,o,a),this.windowId=c,this.channel=g,this._register(g.listen("onDidChangeLogLevel",c)(d=>{(0,E.isLogLevel)(d)?super.setLogLevel(d):super.setLogLevel(v.URI.revive(d[0]),d[1])})),this._register(g.listen("onDidChangeVisibility",c)(([d,n])=>super.setVisibility(v.URI.revive(d),n))),this._register(g.listen("onDidChangeLoggers",c)(({added:d,removed:n})=>{for(const r of d)super.registerLogger({...r,resource:v.URI.revive(r.resource)});for(const r of n)super.deregisterLogger(r.resource)}))}createConsoleMainLogger(){return new E.AdapterLogger({log:(c,b)=>{this.channel.call("consoleLog",[c,b])}})}registerLogger(c){super.registerLogger(c),this.channel.call("registerLogger",[c,this.windowId])}deregisterLogger(c){super.deregisterLogger(c),this.channel.call("deregisterLogger",[c,this.windowId])}setLogLevel(c,b){super.setLogLevel(c,b),this.channel.call("setLogLevel",[c,b])}setVisibility(c,b){super.setVisibility(c,b),this.channel.call("setVisibility",[this.toResource(c),b])}doCreateLogger(c,b,o){return new P(this.channel,c,b,o,this.windowId)}static setLogLevel(c,b,o){return c.call("setLogLevel",[b,o])}}e.LoggerChannelClient=T;class P extends E.AbstractMessageLogger{constructor(c,b,o,a,g){super(a?.logLevel==="always"),this.channel=c,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(o),this.channel.call("createLogger",[b,a,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(c,b){const o=[[c,b]];this.isLoggerCreated?this.doLog(o):this.buffer.push(...o)}doLog(c){this.channel.call("log",[this.file,c])}}class h{constructor(c,b){this.loggerService=c,this.getUriTransformer=b}listen(c,b){const o=this.getUriTransformer(c);switch(b){case"onDidChangeLoggers":return D.Event.map(this.loggerService.onDidChangeLoggers,a=>({added:[...a.added].map(g=>this.transformLogger(g,o)),removed:[...a.removed].map(g=>this.transformLogger(g,o))}));case"onDidChangeVisibility":return D.Event.map(this.loggerService.onDidChangeVisibility,a=>[o.transformOutgoingURI(a[0]),a[1]]);case"onDidChangeLogLevel":return D.Event.map(this.loggerService.onDidChangeLogLevel,a=>(0,E.isLogLevel)(a)?a:[o.transformOutgoingURI(a[0]),a[1]])}throw new Error(`Event not found: ${b}`)}async call(c,b,o){const a=this.getUriTransformer(c);switch(b){case"setLogLevel":return(0,E.isLogLevel)(o[0])?this.loggerService.setLogLevel(o[0]):this.loggerService.setLogLevel(v.URI.revive(a.transformIncoming(o[0][0])),o[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.loggerService.getRegisteredLoggers()].map(g=>this.transformLogger(g,a)))}throw new Error(`Call not found: ${b}`)}transformLogger(c,b){return{...c,resource:b.transformOutgoingURI(c.resource)}}}e.LoggerChannel=h;class s extends A.Disposable{constructor(c,b){super(),b.call("setLogLevel",[c.getLogLevel()]),this._register(c.onDidChangeLogLevel(o=>b.call("setLogLevel",[o]))),b.call("getRegisteredLoggers").then(o=>{for(const a of o)c.registerLogger({...a,resource:v.URI.revive(a.resource)})}),this._register(b.listen("onDidChangeVisibility")(([o,a])=>c.setVisibility(v.URI.revive(o),a))),this._register(b.listen("onDidChangeLoggers")(({added:o,removed:a})=>{for(const g of o)c.registerLogger({...g,resource:v.URI.revive(g.resource)});for(const g of a)c.deregisterLogger(g.resource)}))}}e.RemoteLoggerChannelClient=s}),define(de[81],me([0,1,2,8]),function(ae,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class E extends v.Disposable{constructor(T,P=[]){super(),this.logger=new D.MultiplexLogger([T,...P]),this._register(T.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(T){this.logger.setLevel(T)}getLevel(){return this.logger.getLevel()}trace(T,...P){this.logger.trace(T,...P)}debug(T,...P){this.logger.debug(T,...P)}info(T,...P){this.logger.info(T,...P)}warn(T,...P){this.logger.warn(T,...P)}error(T,...P){this.logger.error(T,...P)}flush(){this.logger.flush()}}e.LogService=E}),define(de[82],me([0,1,79,8]),function(ae,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var E;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(E||(E={}));async function A(s,w,c,b,o){try{const a=await new Promise((d,n)=>{ae(["@vscode/spdlog"],d,n)});a.setFlushOn(E.Trace);const g=await a.createAsyncRotatingLogger(s,w,c,b);return o?g.clearFormatters():g.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),g}catch(a){console.error(a)}return null}function T(s,w,c){switch(w){case D.LogLevel.Trace:s.trace(c);break;case D.LogLevel.Debug:s.debug(c);break;case D.LogLevel.Info:s.info(c);break;case D.LogLevel.Warning:s.warn(c);break;case D.LogLevel.Error:s.error(c);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function P(s,w){switch(w){case D.LogLevel.Trace:s.setLevel(E.Trace);break;case D.LogLevel.Debug:s.setLevel(E.Debug);break;case D.LogLevel.Info:s.setLevel(E.Info);break;case D.LogLevel.Warning:s.setLevel(E.Warning);break;case D.LogLevel.Error:s.setLevel(E.Error);break;case D.LogLevel.Off:s.setLevel(E.Off);break;default:throw new Error(`Invalid log level ${w}`)}}class h extends D.AbstractMessageLogger{constructor(w,c,b,o,a){super(),this.buffer=[],this.setLevel(a),this._loggerCreationPromise=this._createSpdLogLogger(w,c,b,o),this._register(this.onDidChangeLogLevel(g=>{this._logger&&P(this._logger,g)}))}async _createSpdLogLogger(w,c,b,o){const a=b?6:1,g=30/a*v.ByteSize.MB,d=await A(w,c,g,a,o);if(d){this._logger=d,P(this._logger,this.getLevel());for(const{level:n,message:r}of this.buffer)T(this._logger,n,r);this.buffer=[]}}log(w,c){this._logger?T(this._logger,w,c):this.getLevel()<=w&&this.buffer.push({level:w,message:c})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger()),super.dispose()}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=h}),define(de[83],me([0,1,52,8,82]),function(ae,e,v,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class A extends D.AbstractLoggerService{doCreateLogger(P,h,s){return new E.SpdLogLogger((0,v.generateUuid)(),P.fsPath,!s?.donotRotate,!!s?.donotUseFormatters,h)}}e.LoggerService=A}),define(de[84],me([0,1,15]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.context<"u"){const A=E.context.configuration();if(A)D=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){D=globalThis._VSCODE_PRODUCT_JSON;const{serviceUrl:A,searchUrl:T,itemUrl:P,controlUrl:h}=D.extensionsGallery||{};Object.assign(D,{extensionsGallery:{serviceUrl:v.env.VSCODE_GALLERY_SERVICE_URL||A,searchUrl:v.env.VSCODE_GALLERY_SEARCH_URL||T,itemUrl:v.env.VSCODE_GALLERY_ITEM_URL||P,controlUrl:v.env.VSCODE_GALLERY_CONTROL_URL||h}});try{const s=(...c)=>c.reduce((b,o)=>(Object.keys(o).forEach(a=>{Array.isArray(b[a])&&Array.isArray(o[a])?b[a]=o[a]:typeof b[a]=="object"&&typeof o[a]=="object"?b[a]=s(b[a],o[a]):b[a]=o[a]}),b),{}),w=globalThis._VSCODE_USER_PRODUCT_JSON||{};D=s(D,w)}catch{}if(v.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const s=globalThis._VSCODE_PACKAGE_JSON;Object.assign(D,{version:s.version,release:s.release})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(de[85],me([0,1,21]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(de[86],me([0,1,42,9]),function(ae,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class E{constructor(){this.data=new Map}add(T,P){v.ok(D.isString(T)),v.ok(D.isObject(P)),v.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,P)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new E}),define(de[87],me([0,1,4,2]),function(ae,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferMarkCapability=void 0;class E extends D.Disposable{constructor(T){super(),this._terminal=T,this.type=4,this._idToMarkerMap=new Map,this._anonymousMarkers=new Map,this._onMarkAdded=this._register(new v.Emitter),this.onMarkAdded=this._onMarkAdded.event}*markers(){for(const T of this._idToMarkerMap.values())yield T;for(const T of this._anonymousMarkers.values())yield T}addMark(T){const P=T?.marker||this._terminal.registerMarker(),h=T?.id;P&&(h?(this._idToMarkerMap.set(h,P),P.onDispose(()=>this._idToMarkerMap.delete(h))):(this._anonymousMarkers.set(P.id,P),P.onDispose(()=>this._anonymousMarkers.delete(P.id))),this._onMarkAdded.fire({marker:P,id:h,hidden:T?.hidden,hoverMessage:T?.hoverMessage}))}getMark(T){return this._idToMarkerMap.get(T)}}e.BufferMarkCapability=E});var Ne=this&&this.__param||function(ae,e){return function(v,D){e(v,D,ae)}};define(de[88],me([0,1,4,2,8,14]),function(ae,e,v,D,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PromptInputModel=void 0;var T;(function(h){h[h.Unknown=0]="Unknown",h[h.Input=1]="Input",h[h.Execute=2]="Execute"})(T||(T={}));let P=class extends D.Disposable{get value(){return this._value}get cursorIndex(){return this._cursorIndex}get ghostTextIndex(){return this._ghostTextIndex}constructor(s,w,c,b){super(),this._xterm=s,this._logService=b,this._state=0,this._commandStartX=0,this._lastUserInput="",this._value="",this._cursorIndex=0,this._ghostTextIndex=-1,this._onDidStartInput=this._register(new v.Emitter),this.onDidStartInput=this._onDidStartInput.event,this._onDidChangeInput=this._register(new v.Emitter),this.onDidChangeInput=this._onDidChangeInput.event,this._onDidFinishInput=this._register(new v.Emitter),this.onDidFinishInput=this._onDidFinishInput.event,this._onDidInterrupt=this._register(new v.Emitter),this.onDidInterrupt=this._onDidInterrupt.event,this._register(v.Event.any(this._xterm.onCursorMove,this._xterm.onData,this._xterm.onWriteParsed)(()=>this._sync())),this._register(this._xterm.onData(o=>this._handleUserInput(o))),this._register(w(o=>this._handleCommandStart(o))),this._register(c(()=>this._handleCommandExecuted())),this._register(this.onDidStartInput(()=>this._logCombinedStringIfTrace("PromptInputModel#onDidStartInput"))),this._register(this.onDidChangeInput(()=>this._logCombinedStringIfTrace("PromptInputModel#onDidChangeInput"))),this._register(this.onDidFinishInput(()=>this._logCombinedStringIfTrace("PromptInputModel#onDidFinishInput"))),this._register(this.onDidInterrupt(()=>this._logCombinedStringIfTrace("PromptInputModel#onDidInterrupt")))}_logCombinedStringIfTrace(s){this._logService.getLevel()===E.LogLevel.Trace&&this._logService.trace(s,this.getCombinedString())}setContinuationPrompt(s){this._continuationPrompt=s}setConfidentCommandLine(s){this._value!==s&&(this._value=s,this._cursorIndex=-1,this._ghostTextIndex=-1,this._onDidChangeInput.fire(this._createStateObject()))}getCombinedString(){const s=this._value.replaceAll(`
`,"\u23CE");if(this._cursorIndex===-1)return s;let w=`${s.substring(0,this.cursorIndex)}|`;return this.ghostTextIndex!==-1?(w+=`${s.substring(this.cursorIndex,this.ghostTextIndex)}[`,w+=`${s.substring(this.ghostTextIndex)}]`):w+=s.substring(this.cursorIndex),w}_handleCommandStart(s){this._state!==1&&(this._state=1,this._commandStartMarker=s.marker,this._commandStartX=this._xterm.buffer.active.cursorX,this._value="",this._cursorIndex=0,this._onDidStartInput.fire(this._createStateObject()),this._onDidChangeInput.fire(this._createStateObject()))}_handleCommandExecuted(){if(this._state===2)return;this._cursorIndex=-1,this._ghostTextIndex!==-1&&(this._value=this._value.substring(0,this._ghostTextIndex),this._ghostTextIndex=-1);const s=this._createStateObject();this._lastUserInput===""&&this._onDidInterrupt.fire(s),this._state=2,this._onDidFinishInput.fire(s),this._onDidChangeInput.fire(s)}_sync(){if(this._state!==1)return;const s=this._commandStartMarker?.line;if(s===void 0)return;const w=this._xterm.buffer.active;let c=w.getLine(s);const b=c?.translateToString(!0,this._commandStartX);if(!c||b===void 0){this._logService.trace("PromptInputModel#_sync: no line");return}const o=w.baseY+w.cursorY;let a=b,g=o===s?this._getRelativeCursorIndex(this._commandStartX,w,c):b.length+1,d=-1;o===s&&w.cursorX>1&&(d=this._scanForGhostText(w,c,g));for(let n=s+1;n<=o;n++){c=w.getLine(n);let r=c?.translateToString(!0);if(r&&c)if(this._continuationPrompt===void 0||this._lineContainsContinuationPrompt(r))r=this._trimContinuationPrompt(r),a+=`
${r}`,g+=o===n?this._getRelativeCursorIndex(this._getContinuationPromptCellWidth(c,r),w,c):r.length+1;else break}for(let n=o+1;n<w.baseY+this._xterm.rows;n++){c=w.getLine(n);const r=c?.translateToString(!0);if(r&&c)if(this._continuationPrompt===void 0||this._lineContainsContinuationPrompt(r))a+=`
${this._trimContinuationPrompt(r)}`;else break;else break}this._logService.getLevel()===E.LogLevel.Trace&&this._logService.trace(`PromptInputModel#_sync: ${this.getCombinedString()}`),(this._value!==a||this._cursorIndex!==g||this._ghostTextIndex!==d)&&(this._value=a,this._cursorIndex=g,this._ghostTextIndex=d,this._onDidChangeInput.fire(this._createStateObject()))}_handleUserInput(s){this._lastUserInput=s}_scanForGhostText(s,w,c){let b=-1,o=!1,a=s.cursorX;for(;a>0;){const g=w.getCell(--a);if(!g)break;if(g.getChars().trim().length>0){o=!this._isCellStyledLikeGhostText(g);break}}if(o){let g=0,d=s.cursorX;for(;d<w.length;){const n=w.getCell(d++);if(!n||n.getCode()===0)break;if(this._isCellStyledLikeGhostText(n)){b=c+g;break}g+=n.getChars().length}}return b}_trimContinuationPrompt(s){return this._lineContainsContinuationPrompt(s)&&(s=s.substring(this._continuationPrompt.length)),s}_lineContainsContinuationPrompt(s){return!!(this._continuationPrompt&&s.startsWith(this._continuationPrompt))}_getContinuationPromptCellWidth(s,w){if(!this._continuationPrompt||!w.startsWith(this._continuationPrompt))return 0;let c="",b=0;for(;c!==this._continuationPrompt;)c+=s.getCell(b++).getChars();return b}_getRelativeCursorIndex(s,w,c){return c?.translateToString(!0,s,w.cursorX).length??0}_isCellStyledLikeGhostText(s){return!!(s.isItalic()||s.isDim())}_createStateObject(){return Object.freeze({value:this._value,cursorIndex:this._cursorIndex,ghostTextIndex:this._ghostTextIndex})}};e.PromptInputModel=P,ye([(0,A.throttle)(0)],P.prototype,"_sync",null),e.PromptInputModel=P=ye([Ne(3,E.ILogService)],P)}),define(de[89],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PartialTerminalCommand=e.TerminalCommand=void 0;class v{get command(){return this._properties.command}get commandLineConfidence(){return this._properties.commandLineConfidence}get isTrusted(){return this._properties.isTrusted}get timestamp(){return this._properties.timestamp}get duration(){return this._properties.duration}get promptStartMarker(){return this._properties.promptStartMarker}get marker(){return this._properties.marker}get endMarker(){return this._properties.endMarker}set endMarker(w){this._properties.endMarker=w}get executedMarker(){return this._properties.executedMarker}get aliases(){return this._properties.aliases}get wasReplayed(){return this._properties.wasReplayed}get cwd(){return this._properties.cwd}get exitCode(){return this._properties.exitCode}get commandStartLineContent(){return this._properties.commandStartLineContent}get markProperties(){return this._properties.markProperties}get executedX(){return this._properties.executedX}get startX(){return this._properties.startX}constructor(w,c){this._xterm=w,this._properties=c}static deserialize(w,c,b){const o=w.buffer.normal,a=c.startLine!==void 0?w.registerMarker(c.startLine-(o.baseY+o.cursorY)):void 0;if(!a)return;const g=c.promptStartLine!==void 0?w.registerMarker(c.promptStartLine-(o.baseY+o.cursorY)):void 0,d=c.endLine!==void 0?w.registerMarker(c.endLine-(o.baseY+o.cursorY)):void 0,n=c.executedLine!==void 0?w.registerMarker(c.executedLine-(o.baseY+o.cursorY)):void 0;return new v(w,{command:b?"":c.command,commandLineConfidence:c.commandLineConfidence??"low",isTrusted:c.isTrusted,promptStartMarker:g,marker:a,startX:c.startX,endMarker:d,executedMarker:n,executedX:c.executedX,timestamp:c.timestamp,duration:c.duration,cwd:c.cwd,commandStartLineContent:c.commandStartLineContent,exitCode:c.exitCode,markProperties:c.markProperties,aliases:void 0,wasReplayed:!0})}serialize(w){return{promptStartLine:this.promptStartMarker?.line,startLine:this.marker?.line,startX:void 0,endLine:this.endMarker?.line,executedLine:this.executedMarker?.line,executedX:this.executedX,command:w?"":this.command,commandLineConfidence:w?"low":this.commandLineConfidence,isTrusted:this.isTrusted,cwd:this.cwd,exitCode:this.exitCode,commandStartLineContent:this.commandStartLineContent,timestamp:this.timestamp,duration:this.duration,markProperties:this.markProperties}}extractCommandLine(){return E(this._xterm.buffer.active,this._xterm.cols,this.marker,this.startX,this.executedMarker,this.executedX)}getOutput(){if(!this.executedMarker||!this.endMarker)return;const w=this.executedMarker.line,c=this.endMarker.line;if(w===c)return;let b="",o;for(let a=w;a<c;a++)o=this._xterm.buffer.active.getLine(a),o&&(b+=o.translateToString(!o.isWrapped)+(o.isWrapped?"":`
`));return b===""?void 0:b}getOutputMatch(w){if(!this.executedMarker||!this.endMarker)return;const c=this.endMarker.line;if(c===-1)return;const b=this._xterm.buffer.active,o=Math.max(this.executedMarker.line,0),a=w.lineMatcher,g=typeof a=="string"?1:w.length||T(a),d=[];let n;if(w.anchor==="bottom")for(let r=c-(w.offset||0);r>=o;r--){let f=r;const C=r;for(;f>=o&&b.getLine(f)?.isWrapped;)f--;if(r=f,d.unshift(A(b,f,C,this._xterm.cols)),n||(n=d[0].match(a)),d.length>=g)break}else for(let r=o+(w.offset||0);r<c;r++){const f=r;let C=r;for(;C+1<c&&b.getLine(C+1)?.isWrapped;)C++;if(r=C,d.push(A(b,f,C,this._xterm.cols)),n||(n=d[d.length-1].match(a)),d.length>=g)break}return n?{regexMatch:n,outputLines:d}:void 0}hasOutput(){return!this.executedMarker?.isDisposed&&!this.endMarker?.isDisposed&&!!(this.executedMarker&&this.endMarker&&this.executedMarker.line<this.endMarker.line)}getPromptRowCount(){return P(this,this._xterm.buffer.active)}getCommandRowCount(){return h(this)}}e.TerminalCommand=v;class D{constructor(w){this._xterm=w}serialize(w){if(this.commandStartMarker)return{promptStartLine:this.promptStartMarker?.line,startLine:this.commandStartMarker.line,startX:this.commandStartX,endLine:void 0,executedLine:void 0,executedX:void 0,command:"",commandLineConfidence:"low",isTrusted:!0,cwd:w,exitCode:void 0,commandStartLineContent:void 0,timestamp:0,duration:0,markProperties:void 0}}promoteToFullCommand(w,c,b,o){if(c===void 0&&this.command===void 0&&(this.command=""),this.command!==void 0&&!this.command.startsWith("\\")||b)return new v(this._xterm,{command:b?"":this.command||"",commandLineConfidence:b?"low":this.commandLineConfidence||"low",isTrusted:!!this.isTrusted,promptStartMarker:this.promptStartMarker,marker:this.commandStartMarker,startX:this.commandStartX,endMarker:this.commandFinishedMarker,executedMarker:this.commandExecutedMarker,executedX:this.commandExecutedX,timestamp:Date.now(),duration:this.commandDuration||0,cwd:w,exitCode:c,commandStartLineContent:this.commandStartLineContent,markProperties:o})}markExecutedTime(){this.commandExecutedTimestamp===void 0&&(this.commandExecutedTimestamp=Date.now())}markFinishedTime(){this.commandDuration===void 0&&this.commandExecutedTimestamp!==void 0&&(this.commandDuration=Date.now()-this.commandExecutedTimestamp)}extractCommandLine(){return E(this._xterm.buffer.active,this._xterm.cols,this.commandStartMarker,this.commandStartX,this.commandExecutedMarker,this.commandExecutedX)}getPromptRowCount(){return P(this,this._xterm.buffer.active)}getCommandRowCount(){return h(this)}}e.PartialTerminalCommand=D;function E(s,w,c,b,o,a){if(!c||!o||b===void 0||a===void 0)return"";let g="";for(let d=c.line;d<=o.line;d++){const n=s.getLine(d);n&&(g+=n.translateToString(!0,d===c.line?b:0,d===o.line?a:w))}return g}function A(s,w,c,b){const o=Math.max(2048/b*2);c=Math.min(c,w+o);let a="";for(let g=w;g<=c;g++){const d=s.getLine(g);d&&(a+=d.translateToString(!0,0,b))}return a}function T(s){if(!s.multiline)return 1;const w=s.source;let c=1,b=w.indexOf("\\n");for(;b!==-1;)c++,b=w.indexOf("\\n",b+1);return c}function P(s,w){const c="hasOutput"in s?s.marker:s.commandStartMarker;if(!c||!s.promptStartMarker)return 1;let b=1,o=s.promptStartMarker.line;for(;o<c.line&&(w.getLine(o)?.translateToString(!0)??"").length===0;)o++;return b=c.line-o+1,b}function h(s){const w="hasOutput"in s?s.marker:s.commandStartMarker,c="hasOutput"in s?s.executedMarker:s.commandExecutedMarker;if(!w||!c)return 1;let o=Math.max(c.line,w.line)-w.line+1;return("hasOutput"in s?s.executedX:s.commandExecutedX)===0&&o--,o}}),define(de[90],me([0,1,11,14,4,2,8,89,88]),function(ae,e,v,D,E,A,T,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CommandDetectionCapability=void 0,e.getLinesForCommand=o;let s=class extends A.Disposable{get promptInputModel(){return this._promptInputModel}get commands(){return this._commands}get executingCommand(){return this._currentCommand.command}get executingCommandObject(){if(this._currentCommand.commandStartMarker)return{marker:this._currentCommand.commandStartMarker}}get currentCommand(){return this._currentCommand}get cwd(){return this._cwd}get _isInputting(){return!!(this._currentCommand.commandStartMarker&&!this._currentCommand.commandExecutedMarker)}get hasInput(){if(!(!this._isInputting||!this._currentCommand?.commandStartMarker)){if(this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY===this._currentCommand.commandStartMarker?.line){const n=this._terminal.buffer.active.getLine(this._terminal.buffer.active.cursorY)?.translateToString(!0,this._currentCommand.commandStartX);return n===void 0?void 0:n.length>0}return!0}}constructor(n,r){super(),this._terminal=n,this._logService=r,this.type=2,this._commands=[],this._currentCommand=new P.PartialTerminalCommand(this._terminal),this._commandMarkers=[],this.__isCommandStorageDisabled=!1,this._onCommandStarted=this._register(new E.Emitter),this.onCommandStarted=this._onCommandStarted.event,this._onBeforeCommandFinished=this._register(new E.Emitter),this.onBeforeCommandFinished=this._onBeforeCommandFinished.event,this._onCommandFinished=this._register(new E.Emitter),this.onCommandFinished=this._onCommandFinished.event,this._onCommandExecuted=this._register(new E.Emitter),this.onCommandExecuted=this._onCommandExecuted.event,this._onCommandInvalidated=this._register(new E.Emitter),this.onCommandInvalidated=this._onCommandInvalidated.event,this._onCurrentCommandInvalidated=this._register(new E.Emitter),this.onCurrentCommandInvalidated=this._onCurrentCommandInvalidated.event,this._promptInputModel=this._register(new h.PromptInputModel(this._terminal,this.onCommandStarted,this.onCommandExecuted,this._logService)),this._register(this.onCommandExecuted(C=>{if(C.commandLineConfidence!=="high"){const i=C;C.command=i.extractCommandLine(),C.commandLineConfidence="low","getOutput"in i?i.promptStartMarker&&i.marker&&i.executedMarker&&C.command.indexOf(`
`)===-1&&i.startX!==void 0&&i.startX>0&&(C.commandLineConfidence="medium"):i.promptStartMarker&&i.commandStartMarker&&i.commandExecutedMarker&&C.command.indexOf(`
`)===-1&&i.commandStartX!==void 0&&i.commandStartX>0&&(C.commandLineConfidence="medium")}}));const f=this;this._ptyHeuristicsHooks=new class{get onCurrentCommandInvalidatedEmitter(){return f._onCurrentCommandInvalidated}get onCommandStartedEmitter(){return f._onCommandStarted}get onCommandExecutedEmitter(){return f._onCommandExecuted}get dimensions(){return f._dimensions}get isCommandStorageDisabled(){return f.__isCommandStorageDisabled}get commandMarkers(){return f._commandMarkers}set commandMarkers(C){f._commandMarkers=C}get clearCommandsInViewport(){return f._clearCommandsInViewport.bind(f)}commitCommandFinished(){f._commitCommandFinished?.flush(),f._commitCommandFinished=void 0}},this._ptyHeuristics=this._register(new A.MandatoryMutableDisposable(new w(this._terminal,this,this._ptyHeuristicsHooks,this._logService))),this._dimensions={cols:this._terminal.cols,rows:this._terminal.rows},this._register(this._terminal.onResize(C=>this._handleResize(C))),this._register(this._terminal.onCursorMove(()=>this._handleCursorMove()))}_handleResize(n){this._ptyHeuristics.value.preHandleResize?.(n),this._dimensions.cols=n.cols,this._dimensions.rows=n.rows}_handleCursorMove(){this._terminal.buffer.active===this._terminal.buffer.normal&&this._currentCommand.commandStartMarker&&this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY<this._currentCommand.commandStartMarker.line&&(this._clearCommandsInViewport(),this._currentCommand.isInvalid=!0,this._onCurrentCommandInvalidated.fire({reason:"windows"}))}_clearCommandsInViewport(){let n=0;for(let r=this._commands.length-1;r>=0;r--){const f=this._commands[r].marker?.line;if(f&&f<this._terminal.buffer.active.baseY)break;n++}n>0&&this._onCommandInvalidated.fire(this._commands.splice(this._commands.length-n,n))}setContinuationPrompt(n){this._promptInputModel.setContinuationPrompt(n)}setCwd(n){this._cwd=n}setIsWindowsPty(n){if(n&&!(this._ptyHeuristics.value instanceof b)){const r=this;this._ptyHeuristics.value=new b(this._terminal,this,new class{get onCurrentCommandInvalidatedEmitter(){return r._onCurrentCommandInvalidated}get onCommandStartedEmitter(){return r._onCommandStarted}get onCommandExecutedEmitter(){return r._onCommandExecuted}get dimensions(){return r._dimensions}get isCommandStorageDisabled(){return r.__isCommandStorageDisabled}get commandMarkers(){return r._commandMarkers}set commandMarkers(f){r._commandMarkers=f}get clearCommandsInViewport(){return r._clearCommandsInViewport.bind(r)}commitCommandFinished(){r._commitCommandFinished?.flush(),r._commitCommandFinished=void 0}},this._logService)}else!n&&!(this._ptyHeuristics.value instanceof w)&&(this._ptyHeuristics.value=new w(this._terminal,this,this._ptyHeuristicsHooks,this._logService))}setIsCommandStorageDisabled(){this.__isCommandStorageDisabled=!0}getCommandForLine(n){if(this._currentCommand.promptStartMarker&&n>=this._currentCommand.promptStartMarker?.line)return this._currentCommand;if(this._commands.length!==0&&!((this._commands[0].promptStartMarker??this._commands[0].marker).line>n)){for(let r=this.commands.length-1;r>=0;r--)if((this.commands[r].promptStartMarker??this.commands[r].marker).line<=n)return this.commands[r]}}getCwdForLine(n){if(this._currentCommand.promptStartMarker&&n>=this._currentCommand.promptStartMarker?.line)return this._cwd;const r=this.getCommandForLine(n);if(r&&"cwd"in r)return r.cwd}handlePromptStart(n){const r=this.commands.at(-1);r?.endMarker&&r?.executedMarker&&r.endMarker.line===r.executedMarker.line&&(this._logService.debug("CommandDetectionCapability#handlePromptStart adjusted commandFinished",`${r.endMarker.line} -> ${r.executedMarker.line+1}`),r.endMarker=g(this._terminal,r.executedMarker,1)),this._currentCommand.promptStartMarker=n?.marker||(r?.endMarker?g(this._terminal,r.endMarker):this._terminal.registerMarker(0)),this._logService.debug("CommandDetectionCapability#handlePromptStart",this._terminal.buffer.active.cursorX,this._currentCommand.promptStartMarker?.line)}handleContinuationStart(){this._currentCommand.currentContinuationMarker=this._terminal.registerMarker(0),this._logService.debug("CommandDetectionCapability#handleContinuationStart",this._currentCommand.currentContinuationMarker)}handleContinuationEnd(){if(!this._currentCommand.currentContinuationMarker){this._logService.warn("CommandDetectionCapability#handleContinuationEnd Received continuation end without start");return}this._currentCommand.continuations||(this._currentCommand.continuations=[]),this._currentCommand.continuations.push({marker:this._currentCommand.currentContinuationMarker,end:this._terminal.buffer.active.cursorX}),this._currentCommand.currentContinuationMarker=void 0,this._logService.debug("CommandDetectionCapability#handleContinuationEnd",this._currentCommand.continuations[this._currentCommand.continuations.length-1])}handleRightPromptStart(){this._currentCommand.commandRightPromptStartX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleRightPromptStart",this._currentCommand.commandRightPromptStartX)}handleRightPromptEnd(){this._currentCommand.commandRightPromptEndX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleRightPromptEnd",this._currentCommand.commandRightPromptEndX)}handleCommandStart(n){if(this._handleCommandStartOptions=n,this._currentCommand.cwd=this._cwd,this._currentCommand.commandStartMarker=n?.marker||this._currentCommand.commandStartMarker,this._currentCommand.commandStartMarker?.line===this._terminal.buffer.active.cursorY){this._currentCommand.commandStartX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleCommandStart",this._currentCommand.commandStartX,this._currentCommand.commandStartMarker?.line);return}this._ptyHeuristics.value.handleCommandStart(n)}handleGenericCommand(n){n?.markProperties?.disableCommandStorage&&this.setIsCommandStorageDisabled(),this.handlePromptStart(n),this.handleCommandStart(n),this.handleCommandExecuted(n),this.handleCommandFinished(void 0,n)}handleCommandExecuted(n){this._ptyHeuristics.value.handleCommandExecuted(n),this._currentCommand.markExecutedTime()}handleCommandFinished(n,r){if(this._currentCommand.markFinishedTime(),this._ptyHeuristics.value.preHandleCommandFinished?.(),this._logService.debug("CommandDetectionCapability#handleCommandFinished",this._terminal.buffer.active.cursorX,r?.marker?.line,this._currentCommand.command,this._currentCommand),n===void 0){const C=this.commands.length>0?this.commands[this.commands.length-1]:void 0;this._currentCommand.command&&this._currentCommand.command.length>0&&C?.command===this._currentCommand.command&&(n=C.exitCode)}if(this._currentCommand.commandStartMarker===void 0||!this._terminal.buffer.active)return;this._currentCommand.commandFinishedMarker=r?.marker||this._terminal.registerMarker(0),this._ptyHeuristics.value.postHandleCommandFinished?.();const f=this._currentCommand.promoteToFullCommand(this._cwd,n,this._handleCommandStartOptions?.ignoreCommandLine??!1,r?.markProperties);f&&(this._commands.push(f),this._commitCommandFinished=new v.RunOnceScheduler(()=>{this._onBeforeCommandFinished.fire(f),this._currentCommand.isInvalid||(this._logService.debug("CommandDetectionCapability#onCommandFinished",f),this._onCommandFinished.fire(f))},50),this._commitCommandFinished.schedule()),this._currentCommand=new P.PartialTerminalCommand(this._terminal),this._handleCommandStartOptions=void 0}setCommandLine(n,r){this._logService.debug("CommandDetectionCapability#setCommandLine",n,r),this._currentCommand.command=n,this._currentCommand.commandLineConfidence="high",this._currentCommand.isTrusted=r,r&&this._promptInputModel.setConfidentCommandLine(n)}serialize(){const n=this.commands.map(f=>f.serialize(this.__isCommandStorageDisabled)),r=this._currentCommand.serialize(this._cwd);return r&&n.push(r),{isWindowsPty:this._ptyHeuristics.value instanceof b,commands:n}}deserialize(n){n.isWindowsPty&&this.setIsWindowsPty(n.isWindowsPty);const r=this._terminal.buffer.normal;for(const f of n.commands){if(!f.endLine){const i=f.startLine!==void 0?this._terminal.registerMarker(f.startLine-(r.baseY+r.cursorY)):void 0;if(!i)continue;this._currentCommand.commandStartMarker=f.startLine!==void 0?this._terminal.registerMarker(f.startLine-(r.baseY+r.cursorY)):void 0,this._currentCommand.commandStartX=f.startX,this._currentCommand.promptStartMarker=f.promptStartLine!==void 0?this._terminal.registerMarker(f.promptStartLine-(r.baseY+r.cursorY)):void 0,this._cwd=f.cwd,this._onCommandStarted.fire({marker:i});continue}const C=P.TerminalCommand.deserialize(this._terminal,f,this.__isCommandStorageDisabled);C&&(this._commands.push(C),this._logService.debug("CommandDetectionCapability#onCommandFinished",C),this._onCommandFinished.fire(C))}}};e.CommandDetectionCapability=s,ye([(0,D.debounce)(500)],s.prototype,"_handleCursorMove",null),e.CommandDetectionCapability=s=ye([Ne(1,T.ILogService)],s);class w extends A.Disposable{constructor(n,r,f,C){super(),this._terminal=n,this._capability=r,this._hooks=f,this._logService=C,this._register(n.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&f.clearCommandsInViewport(),!1)))}handleCommandStart(n){this._hooks.commitCommandFinished();const r=this._capability.currentCommand;r.commandStartX=this._terminal.buffer.active.cursorX,r.commandStartMarker=n?.marker||this._terminal.registerMarker(0),r.commandExecutedMarker?.dispose(),r.commandExecutedMarker=void 0,r.commandExecutedX=void 0;for(const f of this._hooks.commandMarkers)f.dispose();this._hooks.commandMarkers.length=0,this._hooks.onCommandStartedEmitter.fire({marker:n?.marker||r.commandStartMarker,markProperties:n?.markProperties}),this._logService.debug("CommandDetectionCapability#handleCommandStart",r.commandStartX,r.commandStartMarker?.line)}handleCommandExecuted(n){const r=this._capability.currentCommand;if(r.commandExecutedMarker=n?.marker||this._terminal.registerMarker(0),r.commandExecutedX=this._terminal.buffer.active.cursorX,this._logService.debug("CommandDetectionCapability#handleCommandExecuted",r.commandExecutedX,r.commandExecutedMarker?.line),!r.commandStartMarker||!r.commandExecutedMarker||r.commandStartX===void 0)return;r.command=this._hooks.isCommandStorageDisabled?"":this._terminal.buffer.active.getLine(r.commandStartMarker.line)?.translateToString(!0,r.commandStartX,r.commandRightPromptStartX).trim();let f=r.commandStartMarker.line+1;const C=r.commandExecutedMarker.line;for(;f<C;f++){const i=this._terminal.buffer.active.getLine(f);if(i){const t=r.continuations?.find(L=>L.marker.line===f);t&&(r.command+=`
`);const l=t?.end??0;r.command+=i.translateToString(!0,l)}}f===C&&(r.command+=this._terminal.buffer.active.getLine(C)?.translateToString(!0,void 0,r.commandExecutedX)||""),this._hooks.onCommandExecutedEmitter.fire(r)}}var c;(function(d){d[d.MaxCheckLineCount=10]="MaxCheckLineCount",d[d.Interval=20]="Interval",d[d.MaximumPollCount=10]="MaximumPollCount"})(c||(c={}));let b=class extends A.Disposable{constructor(n,r,f,C){super(),this._terminal=n,this._capability=r,this._hooks=f,this._logService=C,this._onCursorMoveListener=this._register(new A.MutableDisposable),this._tryAdjustCommandStartMarkerScannedLineCount=0,this._tryAdjustCommandStartMarkerPollCount=0,this._register(n.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&this._hooks.clearCommandsInViewport(),!1))),this._register(this._capability.onBeforeCommandFinished(i=>{(i.command.trim().toLowerCase()==="clear"||i.command.trim().toLowerCase()==="cls")&&(this._tryAdjustCommandStartMarkerScheduler?.cancel(),this._tryAdjustCommandStartMarkerScheduler=void 0,this._hooks.clearCommandsInViewport(),this._capability.currentCommand.isInvalid=!0,this._hooks.onCurrentCommandInvalidatedEmitter.fire({reason:"windows"}))}))}preHandleResize(n){const r=this._terminal.buffer.active.baseY,f=n.rows-this._hooks.dimensions.rows;f>0&&this._waitForCursorMove().then(()=>{const C=Math.min(f,r);for(let i=this._capability.commands.length-1;i>=0;i--){const t=this._capability.commands[i];if(!t.marker||t.marker.line<r||t.commandStartLineContent===void 0)break;const l=this._terminal.buffer.active.getLine(t.marker.line);if(!l||l.translateToString(!0)===t.commandStartLineContent)continue;const L=t.marker.line-C;this._terminal.buffer.active.getLine(L)?.translateToString(!0)===t.commandStartLineContent&&this._terminal._core._bufferService.buffer.lines.onDeleteEmitter.fire({index:this._terminal.buffer.active.baseY,amount:C})}})}handleCommandStart(){this._capability.currentCommand.commandStartX=this._terminal.buffer.active.cursorX,this._hooks.commandMarkers.length=0;const n=this._capability.currentCommand.commandStartMarker=this._capability.currentCommand.promptStartMarker?g(this._terminal,this._capability.currentCommand.promptStartMarker):this._terminal.registerMarker(0);this._capability.currentCommand.commandStartX=0,this._tryAdjustCommandStartMarkerScannedLineCount=0,this._tryAdjustCommandStartMarkerPollCount=0,this._tryAdjustCommandStartMarkerScheduler=new v.RunOnceScheduler(()=>this._tryAdjustCommandStartMarker(n),20),this._tryAdjustCommandStartMarkerScheduler.schedule()}_tryAdjustCommandStartMarker(n){if(this._store.isDisposed)return;const r=this._terminal.buffer.active;let f=this._tryAdjustCommandStartMarkerScannedLineCount;for(;f<10&&n.line+f<r.baseY+this._terminal.rows;){if(this._cursorOnNextLine()){const C=this._getWindowsPrompt(n.line+f);if(C){const i=typeof C=="string"?C:C.prompt;if(this._capability.currentCommand.commandStartMarker=this._terminal.registerMarker(0),typeof C=="object"&&C.likelySingleLine){this._logService.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted promptStart",`${this._capability.currentCommand.promptStartMarker?.line} -> ${this._capability.currentCommand.commandStartMarker.line}`),this._capability.currentCommand.promptStartMarker?.dispose(),this._capability.currentCommand.promptStartMarker=g(this._terminal,this._capability.currentCommand.commandStartMarker);const t=this._capability.commands.at(-1);t&&this._capability.currentCommand.commandStartMarker.line!==t.endMarker?.line&&(t.endMarker?.dispose(),t.endMarker=g(this._terminal,this._capability.currentCommand.commandStartMarker))}this._capability.currentCommand.commandStartX=i.length,this._logService.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted commandStart",`${n.line} -> ${this._capability.currentCommand.commandStartMarker.line}:${this._capability.currentCommand.commandStartX}`),this._flushPendingHandleCommandStartTask();return}}f++}f<10?(this._tryAdjustCommandStartMarkerScannedLineCount=f,++this._tryAdjustCommandStartMarkerPollCount<10?this._tryAdjustCommandStartMarkerScheduler?.schedule():this._flushPendingHandleCommandStartTask()):this._flushPendingHandleCommandStartTask()}_flushPendingHandleCommandStartTask(){if(this._tryAdjustCommandStartMarkerScheduler&&(this._tryAdjustCommandStartMarkerPollCount=10,this._tryAdjustCommandStartMarkerScheduler.flush(),this._tryAdjustCommandStartMarkerScheduler=void 0),this._hooks.commitCommandFinished(),this._capability.currentCommand.commandExecutedMarker||(this._onCursorMoveListener.value=this._terminal.onCursorMove(()=>{if(this._hooks.commandMarkers.length===0||this._hooks.commandMarkers[this._hooks.commandMarkers.length-1].line!==this._terminal.buffer.active.cursorY){const n=this._terminal.registerMarker(0);n&&this._hooks.commandMarkers.push(n)}})),this._capability.currentCommand.commandStartMarker){const n=this._terminal.buffer.active.getLine(this._capability.currentCommand.commandStartMarker.line);n&&(this._capability.currentCommand.commandStartLineContent=n.translateToString(!0))}this._hooks.onCommandStartedEmitter.fire({marker:this._capability.currentCommand.commandStartMarker}),this._logService.debug("CommandDetectionCapability#_handleCommandStartWindows",this._capability.currentCommand.commandStartX,this._capability.currentCommand.commandStartMarker?.line)}handleCommandExecuted(n){this._tryAdjustCommandStartMarkerScheduler&&this._flushPendingHandleCommandStartTask(),this._onCursorMoveListener.clear(),this._evaluateCommandMarkers(),this._capability.currentCommand.commandExecutedX=this._terminal.buffer.active.cursorX,this._hooks.onCommandExecutedEmitter.fire(this._capability.currentCommand),this._logService.debug("CommandDetectionCapability#handleCommandExecuted",this._capability.currentCommand.commandExecutedX,this._capability.currentCommand.commandExecutedMarker?.line)}preHandleCommandFinished(){this._capability.currentCommand.commandExecutedMarker||(this._hooks.commandMarkers.length===0&&(this._capability.currentCommand.commandStartMarker||(this._capability.currentCommand.commandStartMarker=this._terminal.registerMarker(0)),this._capability.currentCommand.commandStartMarker&&this._hooks.commandMarkers.push(this._capability.currentCommand.commandStartMarker)),this._evaluateCommandMarkers())}postHandleCommandFinished(){const n=this._capability.currentCommand,r=n.command,f=n.commandStartMarker?.line,C=n.commandExecutedMarker?.line;if(!r||r.length===0||f===void 0||f===-1||C===void 0||C===-1)return;let i=0,t=!1;for(let l=f;l<=C;l++){const L=this._terminal.buffer.active.getLine(l);if(!L)break;const p=L.translateToString(!0);for(let k=0;k<p.length;k++){for(;r.length<i&&r[i]===" ";)i++;if(p[k]===r[i]&&i++,i===r.length){const S=k>=this._terminal.cols-1;n.commandExecutedMarker=this._terminal.registerMarker(l-(this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY)+(S?1:0)),n.commandExecutedX=S?0:k+1,t=!0;break}}if(t)break}}_evaluateCommandMarkers(){if(this._hooks.commandMarkers.length!==0){if(this._hooks.commandMarkers=this._hooks.commandMarkers.sort((n,r)=>n.line-r.line),this._capability.currentCommand.commandStartMarker=this._hooks.commandMarkers[0],this._capability.currentCommand.commandStartMarker){const n=this._terminal.buffer.active.getLine(this._capability.currentCommand.commandStartMarker.line);n&&(this._capability.currentCommand.commandStartLineContent=n.translateToString(!0))}this._capability.currentCommand.commandExecutedMarker=this._hooks.commandMarkers[this._hooks.commandMarkers.length-1],this._hooks.onCommandExecutedEmitter.fire(this._capability.currentCommand)}}_cursorOnNextLine(){const n=this._capability.commands.at(-1);if(!n)return!0;const r=this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY,f=(n.endMarker?n.endMarker.line:n.marker?.line)??-1;return r>f}_waitForCursorMove(){const n=this._terminal.buffer.active.cursorX,r=this._terminal.buffer.active.cursorY;let f=0;return new Promise((C,i)=>{const t=setInterval(()=>{if(n!==this._terminal.buffer.active.cursorX||r!==this._terminal.buffer.active.cursorY){C(),clearInterval(t);return}f+=10,f>1e3&&(clearInterval(t),C())},10)})}_getWindowsPrompt(n=this._terminal.buffer.active.baseY+this._terminal.buffer.active.cursorY){const r=this._terminal.buffer.active.getLine(n);if(!r)return;const f=r.translateToString(!0);if(!f)return;const C=f.match(/(?<prompt>(\(.+\)\s)?(?:PS.+>\s?))/)?.groups?.prompt;if(C){const p=this._adjustPrompt(C,f,">");if(p)return{prompt:p,likelySingleLine:!0}}const i=f.match(/.*\u276f(?=[^\u276f]*$)/g)?.[0];if(i){const p=this._adjustPrompt(i,f,"\u276F");if(p)return p}const t=f.match(/^(?<prompt>\$)/)?.groups?.prompt;if(t){const p=this._adjustPrompt(t,f,"$");if(p)return p}const l=f.match(/^(?<prompt>>>> )/g)?.groups?.prompt;if(l)return{prompt:l,likelySingleLine:!0};const L=f.match(/^(?<prompt>(\(.+\)\s)?(?:[A-Z]:\\.*>))/);return L?.groups?.prompt?{prompt:L.groups.prompt,likelySingleLine:!0}:void 0}_adjustPrompt(n,r,f){if(n)return r===n&&n.endsWith(f)&&(n+=" "),n}};b=ye([Ne(3,T.ILogService)],b);function o(d,n,r,f){if(!f)return;const C=n.executedMarker,i=n.endMarker;if(!C||!i)return;const t=C.line,l=i.line,L=f.length,p=[];if(f.anchor==="bottom")for(let k=l-(f.offset||0);k>=t;k--){let S=k;const y=k;for(;S>=t&&d.getLine(S)?.isWrapped;)S--;k=S,p.unshift(a(d,S,y,r)),p.length>L&&p.pop()}else for(let k=t+(f.offset||0);k<l;k++){const S=k;let y=k;for(;y+1<l&&d.getLine(y+1)?.isWrapped;)y++;k=y,p.push(a(d,S,y,r)),p.length===L&&p.shift()}return p}function a(d,n,r,f){const C=Math.max(2048/f*2);r=Math.min(r,n+C);let i="";for(let t=n;t<=r;t++){const l=d.getLine(t);l&&(i+=l.translateToString(!0,0,f))}return i}function g(d,n,r=0){return d.registerMarker(n.line-(d.buffer.active.baseY+d.buffer.active.cursorY)+r)}}),define(de[91],me([0,1,4,2]),function(ae,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CwdDetectionCapability=void 0;class E extends D.Disposable{constructor(){super(...arguments),this.type=0,this._cwd="",this._cwds=new Map,this._onDidChangeCwd=this._register(new v.Emitter),this.onDidChangeCwd=this._onDidChangeCwd.event}get cwds(){return Array.from(this._cwds.keys())}getCwd(){return this._cwd}updateCwd(T){const P=this._cwd!==T;this._cwd=T;const h=this._cwds.get(this._cwd)||0;this._cwds.delete(this._cwd),this._cwds.set(this._cwd,h+1),P&&this._onDidChangeCwd.fire(T)}}e.CwdDetectionCapability=E}),define(de[92],me([0,1,4,2]),function(ae,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PartialCommandDetectionCapability=void 0;var E;(function(T){T[T.MinimumPromptLength=2]="MinimumPromptLength"})(E||(E={}));class A extends D.DisposableStore{get commands(){return this._commands}constructor(P){super(),this._terminal=P,this.type=3,this._commands=[],this._onCommandFinished=this.add(new v.Emitter),this.onCommandFinished=this._onCommandFinished.event,this.add(this._terminal.onData(h=>this._onData(h))),this.add(this._terminal.parser.registerCsiHandler({final:"J"},h=>(h.length>=1&&(h[0]===2||h[0]===3)&&this._clearCommandsInViewport(),!1)))}_onData(P){P==="\r"&&this._onEnter()}_onEnter(){if(this._terminal&&this._terminal.buffer.active.cursorX>=2){const P=this._terminal.registerMarker(0);P&&(this._commands.push(P),this._onCommandFinished.fire(P))}}_clearCommandsInViewport(){let P=0;for(let h=this._commands.length-1;h>=0&&!(this._commands[h].line<this._terminal.buffer.active.baseY);h--)P++;this._commands.splice(this._commands.length-P,P)}}e.PartialCommandDetectionCapability=A}),define(de[93],me([0,1,4,2]),function(ae,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalCapabilityStoreMultiplexer=e.TerminalCapabilityStore=void 0;class E extends D.Disposable{constructor(){super(...arguments),this._map=new Map,this._onDidRemoveCapabilityType=this._register(new v.Emitter),this.onDidRemoveCapabilityType=this._onDidRemoveCapabilityType.event,this._onDidAddCapabilityType=this._register(new v.Emitter),this.onDidAddCapabilityType=this._onDidAddCapabilityType.event,this._onDidRemoveCapability=this._register(new v.Emitter),this.onDidRemoveCapability=this._onDidRemoveCapability.event,this._onDidAddCapability=this._register(new v.Emitter),this.onDidAddCapability=this._onDidAddCapability.event}get items(){return this._map.keys()}add(P,h){this._map.set(P,h),this._onDidAddCapabilityType.fire(P),this._onDidAddCapability.fire({id:P,capability:h})}get(P){return this._map.get(P)}remove(P){const h=this._map.get(P);h&&(this._map.delete(P),this._onDidRemoveCapabilityType.fire(P),this._onDidAddCapability.fire({id:P,capability:h}))}has(P){return this._map.has(P)}}e.TerminalCapabilityStore=E;class A extends D.Disposable{constructor(){super(...arguments),this._stores=[],this._onDidRemoveCapabilityType=this._register(new v.Emitter),this.onDidRemoveCapabilityType=this._onDidRemoveCapabilityType.event,this._onDidAddCapabilityType=this._register(new v.Emitter),this.onDidAddCapabilityType=this._onDidAddCapabilityType.event,this._onDidRemoveCapability=this._register(new v.Emitter),this.onDidRemoveCapability=this._onDidRemoveCapability.event,this._onDidAddCapability=this._register(new v.Emitter),this.onDidAddCapability=this._onDidAddCapability.event}get items(){return this._items()}*_items(){for(const P of this._stores)for(const h of P.items)yield h}has(P){for(const h of this._stores)for(const s of h.items)if(s===P)return!0;return!1}get(P){for(const h of this._stores){const s=h.get(P);if(s)return s}}add(P){this._stores.push(P);for(const h of P.items)this._onDidAddCapabilityType.fire(h),this._onDidAddCapability.fire({id:h,capability:P.get(h)});this._register(P.onDidAddCapabilityType(h=>this._onDidAddCapabilityType.fire(h))),this._register(P.onDidAddCapability(h=>this._onDidAddCapability.fire(h))),this._register(P.onDidRemoveCapabilityType(h=>this._onDidRemoveCapabilityType.fire(h))),this._register(P.onDidRemoveCapability(h=>this._onDidRemoveCapability.fire(h)))}}e.TerminalCapabilityStoreMultiplexer=A}),define(de[36],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var v;(function(D){D[D.Replace=1]="Replace",D[D.Append=2]="Append",D[D.Prepend=3]="Prepend"})(v||(e.EnvironmentVariableMutatorType=v={}))}),define(de[94],me([0,1,3,36]),function(ae,e,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;const E=new Map([[D.EnvironmentVariableMutatorType.Append,"APPEND"],[D.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[D.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class A{constructor(w){this.collections=w,this.map=new Map,this.descriptionMap=new Map,w.forEach((c,b)=>{this.populateDescriptionMap(c,b);const o=c.map.entries();let a=o.next();for(;!a.done;){const g=a.value[1],d=a.value[0];let n=this.map.get(d);if(n||(n=[],this.map.set(d,n)),n.length>0&&n[0].type===D.EnvironmentVariableMutatorType.Replace){a=o.next();continue}const r={extensionIdentifier:b,value:g.value,type:g.type,scope:g.scope,variable:g.variable,options:g.options};r.scope||delete r.scope,n.unshift(r),a=o.next()}})}async applyToProcessEnvironment(w,c,b){let o;v.isWindows&&(o={},Object.keys(w).forEach(a=>o[a.toLowerCase()]=a));for(const[a,g]of this.getVariableMap(c)){const d=v.isWindows&&o[a.toLowerCase()]||a;for(const n of g){const r=b?await b(n.value):n.value;if(n.options?.applyAtProcessCreation??!0)switch(n.type){case D.EnvironmentVariableMutatorType.Append:w[d]=(w[d]||"")+r;break;case D.EnvironmentVariableMutatorType.Prepend:w[d]=r+(w[d]||"");break;case D.EnvironmentVariableMutatorType.Replace:w[d]=r;break}if(n.options?.applyAtShellIntegration??!1){const f=`VSCODE_ENV_${E.get(n.type)}`;w[f]=(w[f]?w[f]+":":"")+a+"="+this._encodeColons(r)}}}}_encodeColons(w){return w.replaceAll(":","\\x3a")}diff(w,c){const b=new Map,o=new Map,a=new Map;if(w.getVariableMap(c).forEach((g,d)=>{const n=this.getVariableMap(c).get(d),r=P(g,n);r&&b.set(d,r)}),this.getVariableMap(c).forEach((g,d)=>{const n=w.getVariableMap(c).get(d),r=P(g,n);r&&a.set(d,r)}),this.getVariableMap(c).forEach((g,d)=>{const n=w.getVariableMap(c).get(d),r=h(g,n);r&&o.set(d,r)}),!(b.size===0&&o.size===0&&a.size===0))return{added:b,changed:o,removed:a}}getVariableMap(w){const c=new Map;for(const b of this.map.values()){const o=b.filter(a=>T(a,w));o.length>0&&c.set(o[0].variable,o)}return c}getDescriptionMap(w){const c=new Map;for(const b of this.descriptionMap.values()){const o=b.filter(a=>T(a,w,!0));for(const a of o)c.set(a.extensionIdentifier,a.description)}return c}populateDescriptionMap(w,c){if(!w.descriptionMap)return;const b=w.descriptionMap.entries();let o=b.next();for(;!o.done;){const a=o.value[1],g=o.value[0];let d=this.descriptionMap.get(g);d||(d=[],this.descriptionMap.set(g,d));const n={extensionIdentifier:c,scope:a.scope,description:a.description};n.scope||delete n.scope,d.push(n),o=b.next()}}}e.MergedEnvironmentVariableCollection=A;function T(s,w,c=!1){return s.scope?!!(s.scope.workspaceFolder&&w?.workspaceFolder&&s.scope.workspaceFolder.index===w.workspaceFolder.index):c?w===s.scope:!0}function P(s,w){if(!w)return s;const c=new Set;w.forEach(o=>c.add(o.extensionIdentifier));const b=[];return s.forEach(o=>{c.has(o.extensionIdentifier)||b.push(o)}),b.length===0?void 0:b}function h(s,w){if(!w)return;const c=new Map;w.forEach(o=>c.set(o.extensionIdentifier,o));const b=[];return s.forEach(o=>{const a=c.get(o.extensionIdentifier);a&&(o.type!==a.type||o.value!==a.value||o.scope?.workspaceFolder?.index!==a.scope?.workspaceFolder?.index)&&b.push(a)}),b.length===0?void 0:b}}),define(de[95],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serializeEnvironmentVariableCollection=v,e.serializeEnvironmentDescriptionMap=D,e.deserializeEnvironmentVariableCollection=E,e.deserializeEnvironmentDescriptionMap=A,e.serializeEnvironmentVariableCollections=T,e.deserializeEnvironmentVariableCollections=P;function v(h){return[...h.entries()]}function D(h){return h?[...h.entries()]:[]}function E(h){return new Map(h)}function A(h){return new Map(h??[])}function T(h){return Array.from(h.entries()).map(s=>[s[0],v(s[1].map),D(s[1].descriptionMap)])}function P(h){return new Map(h.map(s=>[s[0],{map:E(s[1]),descriptionMap:A(s[2])}]))}}),define(de[96],me([0,1,11,17,4,2,8]),function(ae,e,v,D,E,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends A.Disposable{constructor(s,w){super(),this._logService=w,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new E.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=s===void 0?15e3:s,this._register((0,A.toDisposable)(()=>{for(const c of this._pendingRequestDisposables.values())(0,A.dispose)(c)}))}createRequest(s){return new Promise((w,c)=>{const b=++this._lastRequestId;this._pendingRequests.set(b,w),this._onCreateRequest.fire({requestId:b,...s});const o=new D.CancellationTokenSource;(0,v.timeout)(this._timeout,o.token).then(()=>c(`Request ${b} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(b,[(0,A.toDisposable)(()=>o.cancel())])})}acceptReply(s,w){const c=this._pendingRequests.get(s);c?(this._pendingRequests.delete(s),(0,A.dispose)(this._pendingRequestDisposables.get(s)||[]),this._pendingRequestDisposables.delete(s),c(w)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${s}`)}};e.RequestStore=P,e.RequestStore=P=ye([Ne(1,T.ILogService)],P)}),define(de[28],me([0,1,21,35,86]),function(ae,e,v,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ITerminalLogService=e.ILocalPtyService=e.TerminalExtensions=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusModeContextKey=void 0,e.terminalTabFocusModeContextKey=new D.RawContextKey("terminalTabFocusMode",!1,!0);var A;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(A||(e.TerminalSettingPrefix=A={}));var T;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",i.LocalEchoEnabled="terminal.integrated.localEchoEnabled",i.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",i.LocalEchoStyle="terminal.integrated.localEchoStyle",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",i.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",i.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",i.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",i.MouseWheelZoom="terminal.integrated.mouseWheelZoom",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(T||(e.TerminalSettingId=T={}));var P;(function(i){i.PowerShell="pwsh",i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh",i.Python="python"})(P||(e.PosixShellType=P={}));var h;(function(i){i.CommandPrompt="cmd",i.PowerShell="pwsh",i.Wsl="wsl",i.GitBash="gitbash",i.Python="python"})(h||(e.WindowsShellType=h={}));var s;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(s||(e.TitleEventSource=s={}));var w;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(w||(e.TerminalIpcChannels=w={}));var c;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(c||(e.ProcessPropertyType=c={})),e.IPtyService=(0,v.createDecorator)("ptyService");var b;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b||(e.HeartbeatConstants=b={}));var o;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(o||(e.TerminalLocation=o={}));var a;(function(i){i.TerminalView="view",i.Editor="editor"})(a||(e.TerminalLocationString=a={}));var g;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(g||(e.LocalReconnectConstants=g={}));var d;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(d||(e.FlowControlConstants=d={}));var n;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(n||(e.ProfileSource=n={}));var r;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})(r||(e.ShellIntegrationStatus=r={}));var f;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(f||(e.TerminalExitReason=f={})),e.TerminalExtensions={Backend:"workbench.contributions.terminal.processBackend"};class C{constructor(){this._backends=new Map}get backends(){return this._backends}registerTerminalBackend(t){const l=this._sanitizeRemoteAuthority(t.remoteAuthority);if(this._backends.has(l))throw new Error(`A terminal backend with remote authority '${l}' was already registered.`);this._backends.set(l,t)}getTerminalBackend(t){return this._backends.get(this._sanitizeRemoteAuthority(t))}_sanitizeRemoteAuthority(t){return t?.toLowerCase()??""}}E.Registry.add(e.TerminalExtensions.Backend,new C),e.ILocalPtyService=(0,v.createDecorator)("localPtyService"),e.ITerminalLogService=(0,v.createDecorator)("terminalLogService")}),define(de[97],me([0,1,11,2,3]),function(ae,e,v,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalAutoResponder=void 0;class A extends D.Disposable{constructor(P,h,s,w){super(),this._pointer=0,this._paused=!1,this._throttled=!1,this._register(P.onProcessData(c=>{if(this._paused||this._throttled)return;const b=typeof c=="string"?c:c.data;for(let o=0;o<b.length;o++)b[o]===h[this._pointer]?this._pointer++:this._reset(),this._pointer===h.length&&(w.debug(`Auto reply match: "${h}", response: "${s}"`),P.input(s),this._throttled=!0,(0,v.timeout)(1e3).then(()=>this._throttled=!1),this._reset())}))}_reset(){this._pointer=0}handleResize(){E.isWindows&&(this._paused=!0)}handleInput(){this._paused=!1}}e.TerminalAutoResponder=A}),define(de[98],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class v{constructor(E){this._callback=E,this._terminalBufferMap=new Map}dispose(){for(const E of this._terminalBufferMap.values())E.dispose()}startBuffering(E,A,T=5){const P=A(h=>{const s=typeof h=="string"?h:h.data;let w=this._terminalBufferMap.get(E);if(w){w.data.push(s);return}const c=setTimeout(()=>this.flushBuffer(E),T);w={data:[s],timeoutId:c,dispose:()=>{clearTimeout(c),this.flushBuffer(E),P.dispose()}},this._terminalBufferMap.set(E,w)});return P}stopBuffering(E){this._terminalBufferMap.get(E)?.dispose()}flushBuffer(E){const A=this._terminalBufferMap.get(E);A&&(this._terminalBufferMap.delete(E),this._callback(E,A.data.join("")))}}e.TerminalDataBufferer=v}),define(de[37],me([0,1,3]),function(ae,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.escapeNonWindowsPath=D,e.collapseTildePath=E,e.sanitizeCwd=A,e.shouldUseEnvironmentVariableCollection=T;function D(P){let h=P;h.includes("\\")&&(h=h.replace(/\\/g,"\\\\"));const s=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return h=h.replace(s,""),`'${h}'`}function E(P,h,s){if(!P)return"";if(!h)return P;h.match(/[\/\\]$/)&&(h=h.slice(0,h.length-1));const w=P.replace(/\\/g,"/").toLowerCase(),c=h.replace(/\\/g,"/").toLowerCase();return w.includes(c)?`~${s}${P.slice(h.length+1)}`:P}function A(P){return P.match(/^['"].*['"]$/)&&(P=P.substring(1,P.length-1)),v.OS===1&&P&&P[1]===":"?P[0].toUpperCase()+P.substring(1):P}function T(P){return!P.strictEnv}}),define(de[99],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.chunkInput=D;var v;(function(E){E[E.WriteMaxChunkSize=50]="WriteMaxChunkSize"})(v||(v={}));function D(E){const A=[];let T=0;for(let P=0;P<E.length-1;P++)(P-T+1>=50||E[P+1]==="\x1B")&&(A.push(E.substring(T,P+1)),T=P+1,P++);return T!==E.length&&A.push(E.substring(T)),A}}),define(de[100],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.formatMessageForTerminal=v;function v(D,E={}){let A="";return E.excludeLeadingNewLine||(A+=`\r
`),A+="\x1B[0m\x1B[7m * ",E.loudFormatting?A+="\x1B[0;104m":A+="\x1B[0m",A+=` ${D} \x1B[0m
\r`,A}}),define(de[101],me([0,1,2,93,90,91,92,4,87,6,37]),function(ae,e,v,D,E,A,T,P,h,s,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ShellIntegrationAddon=e.ShellIntegrationOscPs=void 0,e.deserializeMessage=g,e.parseKeyValueAssignment=d,e.parseMarkSequence=n;var c;(function(r){r[r.FinalTerm=133]="FinalTerm",r[r.VSCode=633]="VSCode",r[r.ITerm=1337]="ITerm",r[r.SetCwd=7]="SetCwd",r[r.SetWindowsFriendlyCwd=9]="SetWindowsFriendlyCwd"})(c||(e.ShellIntegrationOscPs=c={}));var b;(function(r){r.PromptStart="A",r.CommandStart="B",r.CommandExecuted="C",r.CommandFinished="D",r.CommandLine="E",r.ContinuationStart="F",r.ContinuationEnd="G",r.RightPromptStart="H",r.RightPromptEnd="I",r.Property="P",r.SetMark="SetMark"})(b||(b={}));var o;(function(r){r.SetMark="SetMark",r.CurrentDir="CurrentDir"})(o||(o={}));class a extends v.Disposable{get status(){return this._status}constructor(f,C,i,t){super(),this._nonce=f,this._disableTelemetry=C,this._telemetryService=i,this._logService=t,this.capabilities=this._register(new D.TerminalCapabilityStore),this._hasUpdatedTelemetry=!1,this._commonProtocolDisposables=[],this._status=0,this._onDidChangeStatus=new P.Emitter,this.onDidChangeStatus=this._onDidChangeStatus.event,this._register((0,v.toDisposable)(()=>{this._clearActivationTimeout(),this._disposeCommonProtocol()}))}_disposeCommonProtocol(){(0,v.dispose)(this._commonProtocolDisposables),this._commonProtocolDisposables.length=0}activate(f){this._terminal=f,this.capabilities.add(3,this._register(new T.PartialCommandDetectionCapability(this._terminal))),this._register(f.parser.registerOscHandler(633,C=>this._handleVSCodeSequence(C))),this._register(f.parser.registerOscHandler(1337,C=>this._doHandleITermSequence(C))),this._commonProtocolDisposables.push(f.parser.registerOscHandler(133,C=>this._handleFinalTermSequence(C))),this._register(f.parser.registerOscHandler(7,C=>this._doHandleSetCwd(C))),this._register(f.parser.registerOscHandler(9,C=>this._doHandleSetWindowsFriendlyCwd(C))),this._ensureCapabilitiesOrAddFailureTelemetry()}getMarkerId(f,C){this._createOrGetBufferMarkDetection(f).getMark(C)}_handleFinalTermSequence(f){const C=this._doHandleFinalTermSequence(f);return this._status===0&&(this._status=1,this._onDidChangeStatus.fire(this._status)),C}_doHandleFinalTermSequence(f){if(!this._terminal)return!1;const[C,...i]=f.split(";");switch(C){case"A":return this._createOrGetCommandDetection(this._terminal).handlePromptStart(),!0;case"B":return this._createOrGetCommandDetection(this._terminal).handleCommandStart({ignoreCommandLine:!0}),!0;case"C":return this._createOrGetCommandDetection(this._terminal).handleCommandExecuted(),!0;case"D":{const t=i.length===1?parseInt(i[0]):void 0;return this._createOrGetCommandDetection(this._terminal).handleCommandFinished(t),!0}}return!1}_handleVSCodeSequence(f){const C=this._doHandleVSCodeSequence(f);return!this._hasUpdatedTelemetry&&C&&(this._telemetryService?.publicLog2("terminal/shellIntegrationActivationSucceeded"),this._hasUpdatedTelemetry=!0,this._clearActivationTimeout()),this._status!==2&&(this._status=2,this._onDidChangeStatus.fire(this._status)),C}async _ensureCapabilitiesOrAddFailureTelemetry(){!this._telemetryService||this._disableTelemetry||(this._activationTimeout=setTimeout(()=>{!this.capabilities.get(2)&&!this.capabilities.get(0)&&(this._telemetryService?.publicLog2("terminal/shellIntegrationActivationTimeout"),this._logService.warn("Shell integration failed to add capabilities within 10 seconds")),this._hasUpdatedTelemetry=!0},1e4))}_clearActivationTimeout(){this._activationTimeout!==void 0&&(clearTimeout(this._activationTimeout),this._activationTimeout=void 0)}_doHandleVSCodeSequence(f){if(!this._terminal)return!1;const C=f.indexOf(";"),i=C===-1?f:f.substring(0,C),t=C===-1?[]:f.substring(C+1).split(";");switch(i){case"A":return this._createOrGetCommandDetection(this._terminal).handlePromptStart(),!0;case"B":return this._createOrGetCommandDetection(this._terminal).handleCommandStart(),!0;case"C":return this._createOrGetCommandDetection(this._terminal).handleCommandExecuted(),!0;case"D":{const l=t[0],L=l!==void 0?parseInt(l):void 0;return this._createOrGetCommandDetection(this._terminal).handleCommandFinished(L),!0}case"E":{const l=t[0],L=t[1];let p;return l!==void 0?p=g(l):p="",this._createOrGetCommandDetection(this._terminal).setCommandLine(p,L===this._nonce),!0}case"F":return this._createOrGetCommandDetection(this._terminal).handleContinuationStart(),!0;case"G":return this._createOrGetCommandDetection(this._terminal).handleContinuationEnd(),!0;case"H":return this._createOrGetCommandDetection(this._terminal).handleRightPromptStart(),!0;case"I":return this._createOrGetCommandDetection(this._terminal).handleRightPromptEnd(),!0;case"P":{const l=t[0],L=l!==void 0?g(l):"",{key:p,value:k}=d(L);if(k===void 0)return!0;switch(p){case"ContinuationPrompt":{const S=k.replace(/\x1b\[[0-9;]*m/g,"").replace(/\\\[.*?\\\]/g,"");return this._updateContinuationPrompt(S),!0}case"Cwd":return this._updateCwd(k),!0;case"IsWindows":return this._createOrGetCommandDetection(this._terminal).setIsWindowsPty(k==="True"),!0;case"Task":return this._createOrGetBufferMarkDetection(this._terminal),this.capabilities.get(2)?.setIsCommandStorageDisabled(),!0}}case"SetMark":return this._createOrGetBufferMarkDetection(this._terminal).addMark(n(t)),!0}return!1}_updateContinuationPrompt(f){this._terminal&&this._createOrGetCommandDetection(this._terminal).setContinuationPrompt(f)}_updateCwd(f){f=(0,w.sanitizeCwd)(f),this._createOrGetCwdDetection().updateCwd(f),this.capabilities.get(2)?.setCwd(f)}_doHandleITermSequence(f){if(!this._terminal)return!1;const[C]=f.split(";");switch(C){case"SetMark":this._createOrGetBufferMarkDetection(this._terminal).addMark();default:{const{key:i,value:t}=d(C);if(t===void 0)return!0;switch(i){case"CurrentDir":return this._updateCwd(t),!0}}}return!1}_doHandleSetWindowsFriendlyCwd(f){if(!this._terminal)return!1;const[C,...i]=f.split(";");switch(C){case"9":return i.length&&this._updateCwd(i[0]),!0}return!1}_doHandleSetCwd(f){if(!this._terminal)return!1;const[C]=f.split(";");if(C.match(/^file:\/\/.*\//)){const i=s.URI.parse(C);if(i.path&&i.path.length>0)return this._updateCwd(i.path),!0}return!1}serialize(){return!this._terminal||!this.capabilities.has(2)?{isWindowsPty:!1,commands:[]}:this._createOrGetCommandDetection(this._terminal).serialize()}deserialize(f){if(!this._terminal)throw new Error("Cannot restore commands before addon is activated");this._createOrGetCommandDetection(this._terminal).deserialize(f)}_createOrGetCwdDetection(){let f=this.capabilities.get(0);return f||(f=this._register(new A.CwdDetectionCapability),this.capabilities.add(0,f)),f}_createOrGetCommandDetection(f){let C=this.capabilities.get(2);return C||(C=this._register(new E.CommandDetectionCapability(f,this._logService)),this.capabilities.add(2,C)),C}_createOrGetBufferMarkDetection(f){let C=this.capabilities.get(4);return C||(C=this._register(new h.BufferMarkCapability(f)),this.capabilities.add(4,C)),C}}e.ShellIntegrationAddon=a;function g(r){return r.replaceAll(/\\(\\|x([0-9a-f]{2}))/gi,(f,C,i)=>i?String.fromCharCode(parseInt(i,16)):C)}function d(r){const f=r.indexOf("=");return f===-1?{key:r,value:void 0}:{key:r.substring(0,f),value:r.substring(1+f)}}function n(r){let f,C=!1;for(const i of r)i!==void 0&&(i==="Hidden"&&(C=!0),i.startsWith("Id=")&&(f=i.substring(3)));return{id:f,hidden:C}}}),define(de[38],me([0,1,5,14,4,2,62,8]),function(ae,e,v,D,E,A,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChildProcessMonitor=e.ignoreProcessNames=void 0;var h;(function(w){w[w.InactiveThrottleDuration=5e3]="InactiveThrottleDuration",w[w.ActiveDebounceDuration=1e3]="ActiveDebounceDuration"})(h||(h={})),e.ignoreProcessNames=[];let s=class extends A.Disposable{set hasChildProcesses(c){this._hasChildProcesses!==c&&(this._hasChildProcesses=c,this._logService.debug("ChildProcessMonitor: Has child processes changed",c),this._onDidChangeHasChildProcesses.fire(c))}get hasChildProcesses(){return this._hasChildProcesses}constructor(c,b){super(),this._pid=c,this._logService=b,this._hasChildProcesses=!1,this._onDidChangeHasChildProcesses=this._register(new E.Emitter),this.onDidChangeHasChildProcesses=this._onDidChangeHasChildProcesses.event}handleInput(){this._refreshActive()}handleOutput(){this._refreshInactive()}async _refreshActive(){if(!this._store.isDisposed)try{const c=await(0,T.listProcesses)(this._pid);this.hasChildProcesses=this._processContainsChildren(c)}catch(c){this._logService.debug("ChildProcessMonitor: Fetching process tree failed",c)}}_refreshInactive(){this._refreshActive()}_processContainsChildren(c){if(!c.children)return!1;if(c.children.length===1){const b=c.children[0];let o;if(b.cmd.startsWith('"'))o=b.cmd.substring(1,b.cmd.indexOf('"',1));else{const a=b.cmd.indexOf(" ");a===-1?o=b.cmd:o=b.cmd.substring(0,a)}return e.ignoreProcessNames.indexOf((0,v.parse)(o).name)===-1}return c.children.length>0}};e.ChildProcessMonitor=s,ye([(0,D.debounce)(1e3)],s.prototype,"_refreshActive",null),ye([(0,D.throttle)(5e3)],s.prototype,"_refreshInactive",null),e.ChildProcessMonitor=s=ye([Ne(1,P.ILogService)],s)}),define(de[102],me([0,1,4,2,28]),function(ae,e,v,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.HeartbeatService=void 0;class A extends D.Disposable{constructor(){super(),this._onBeat=this._register(new v.Emitter),this.onBeat=this._onBeat.event;const P=setInterval(()=>{this._onBeat.fire()},E.HeartbeatConstants.BeatInterval);this._register((0,D.toDisposable)(()=>clearInterval(P)))}}e.HeartbeatService=A}),define(de[39],me([0,1,20,19,30,5,3,15,12,9,24,36,95,94]),function(ae,e,v,D,E,A,T,P,h,s,w,c,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsBuildNumber=a,e.findExecutable=g,e.getShellIntegrationInjection=d;function a(){const S=/(\d+)\.(\d+)\.(\d+)/g.exec(v.release());let y=0;return S&&S.length===4&&(y=parseInt(S[3])),y}async function g(S,y,U,K=P.env,z=w.Promises.exists){if(A.isAbsolute(S))return await z(S)?S:void 0;if(y===void 0&&(y=P.cwd()),A.dirname(S)!=="."){const _=A.join(y,S);return await z(_)?_:void 0}const m=(0,E.getCaseInsensitive)(K,"PATH");if(U===void 0&&(0,s.isString)(m)&&(U=m.split(A.delimiter)),U===void 0||U.length===0){const _=A.join(y,S);return await z(_)?_:void 0}for(const _ of U){let I;if(A.isAbsolute(_)?I=A.join(_,S):I=A.join(y,_,S),await z(I))return I;if(T.isWindows){let G=I+".com";if(await z(G)||(G=I+".exe",await z(G)))return G}}const R=A.join(y,S);return await z(R)?R:void 0}function d(S,y,U,K,z){const O=T.isWindows&&(!y.windowsEnableConpty||a()<18309);if(!y.shellIntegration.enabled||!S.executable||S.isFeatureTerminal&&!S.forceShellIntegration||S.ignoreShellIntegration||O)return;const m=S.args,R=P.platform==="win32"?A.basename(S.executable).toLowerCase():A.basename(S.executable),_=A.dirname(D.FileAccess.asFileUri("").fsPath);let I;const G={VSCODE_INJECTION:"1"};if(y.shellIntegration.nonce&&(G.VSCODE_NONCE=y.shellIntegration.nonce),T.isWindows){if(R==="pwsh.exe"||R==="powershell.exe")return!m||p(m)?I=f.get(r.WindowsPwsh):L(m)&&(I=f.get(r.WindowsPwshLogin)),I?(I=[...I],I[I.length-1]=(0,h.format)(I[I.length-1],_,""),y.shellIntegration.suggestEnabled&&(G.VSCODE_SUGGEST="1"),{newArgs:I,envMixin:G}):void 0;if(R==="bash.exe")return!m||m.length===0?I=f.get(r.Bash):k(m)&&(G.VSCODE_SHELL_LOGIN="1",n(y,G),I=f.get(r.Bash)),I?(I=[...I],I[I.length-1]=(0,h.format)(I[I.length-1],_),{newArgs:I,envMixin:G}):void 0;K.warn(`Shell integration cannot be enabled for executable "${S.executable}" and args`,S.args);return}switch(R){case"bash":return!m||m.length===0?I=f.get(r.Bash):k(m)&&(G.VSCODE_SHELL_LOGIN="1",n(y,G),I=f.get(r.Bash)),I?(I=[...I],I[I.length-1]=(0,h.format)(I[I.length-1],_),{newArgs:I,envMixin:G}):void 0;case"fish":{const te=U?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",H=A.join(_,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return G.XDG_DATA_DIRS=`${te}:${H}`,n(y,G),{newArgs:void 0,envMixin:G}}case"pwsh":return!m||p(m)?I=f.get(r.Pwsh):L(m)&&(I=f.get(r.PwshLogin)),I?(y.shellIntegration.suggestEnabled&&(G.VSCODE_SUGGEST="1"),I=[...I],I[I.length-1]=(0,h.format)(I[I.length-1],_,""),{newArgs:I,envMixin:G}):void 0;case"zsh":{if(!m||m.length===0?I=f.get(r.Zsh):k(m)?(I=f.get(r.ZshLogin),n(y,G)):(m===f.get(r.Zsh)||m===f.get(r.ZshLogin))&&(I=m),!I)return;I=[...I],I[I.length-1]=(0,h.format)(I[I.length-1],_);let te;try{te=v.userInfo().username}catch{te="unknown"}const H=A.join(v.tmpdir(),`${te}-${z.applicationName}-zsh`);G.ZDOTDIR=H;const ee=U?.ZDOTDIR??v.homedir()??"~";G.USER_ZDOTDIR=ee;const le=[];return le.push({source:A.join(_,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.join(H,".zshrc")}),le.push({source:A.join(_,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.join(H,".zprofile")}),le.push({source:A.join(_,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.join(H,".zshenv")}),le.push({source:A.join(_,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.join(H,".zlogin")}),{newArgs:I,envMixin:G,filesToCopy:le}}}K.warn(`Shell integration cannot be enabled for executable "${S.executable}" and args`,S.args)}function n(S,y){if(T.isMacintosh&&S.environmentVariableCollections){const U=(0,b.deserializeEnvironmentVariableCollections)(S.environmentVariableCollections),z=new o.MergedEnvironmentVariableCollection(U).getVariableMap({workspaceFolder:S.workspaceFolder}).get("PATH"),O=[];if(z)for(const m of z)m.type===c.EnvironmentVariableMutatorType.Prepend&&O.push(m.value);O.length>0&&(y.VSCODE_PATH_PREFIX=O.join(""))}}var r;(function(S){S.WindowsPwsh="windows-pwsh",S.WindowsPwshLogin="windows-pwsh-login",S.Pwsh="pwsh",S.PwshLogin="pwsh-login",S.Zsh="zsh",S.ZshLogin="zsh-login",S.Bash="bash"})(r||(r={}));const f=new Map;f.set(r.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(r.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(r.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),f.set(r.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),f.set(r.Zsh,["-i"]),f.set(r.ZshLogin,["-il"]),f.set(r.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const C=["-login","-l"],i=["--login","-l"],t=["-i","--interactive"],l=["-nol","-nologo"];function L(S){return typeof S=="string"?C.includes(S.toLowerCase()):S.length===1&&C.includes(S[0].toLowerCase())||S.length===2&&(C.includes(S[0].toLowerCase())||C.includes(S[1].toLowerCase()))&&(l.includes(S[0].toLowerCase())||l.includes(S[1].toLowerCase()))}function p(S){return typeof S=="string"?l.includes(S.toLowerCase()):S.length===0||S?.length===1&&l.includes(S[0].toLowerCase())}function k(S){return typeof S!="string"&&(S=S.filter(y=>!t.includes(y.toLowerCase()))),S==="string"&&i.includes(S.toLowerCase())||typeof S!="string"&&S.length===1&&i.includes(S[0].toLowerCase())}}),define(de[103],me([0,1,11,14,4,2,3]),function(ae,e,v,D,E,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsShellHelper=void 0;const P=["cmd.exe","powershell.exe","pwsh.exe","bash.exe","wsl.exe","ubuntu.exe","ubuntu1804.exe","kali.exe","debian.exe","opensuse-42.exe","sles-12.exe"];let h;class s extends A.Disposable{get shellType(){return this._shellType}get shellTitle(){return this._shellTitle}get onShellNameChanged(){return this._onShellNameChanged.event}get onShellTypeChanged(){return this._onShellTypeChanged.event}constructor(c){if(super(),this._rootProcessId=c,this._shellTitle="",this._onShellNameChanged=new E.Emitter,this._onShellTypeChanged=new E.Emitter,!T.isWindows)throw new Error(`WindowsShellHelper cannot be instantiated on ${T.platform}`);this._startMonitoringShell()}async _startMonitoringShell(){this._store.isDisposed||this.checkShell()}async checkShell(){T.isWindows&&(await(0,v.timeout)(300),this.getShellName().then(c=>{const b=this.getShellType(c);b!==this._shellType&&(this._onShellTypeChanged.fire(b),this._onShellNameChanged.fire(c),this._shellType=b,this._shellTitle=c)}))}traverseTree(c){if(!c)return"";if(P.indexOf(c.name)===-1||!c.children||c.children.length===0)return c.name;let b=0;for(;b<c.children.length;b++){const o=c.children[b];if(!o.children||o.children.length===0||o.children[0].name!=="conhost.exe")break}return b>=c.children.length?c.name:this.traverseTree(c.children[b])}async getShellName(){return this._store.isDisposed?Promise.resolve(""):this._currentRequest?this._currentRequest:(h||(h=await new Promise((c,b)=>{ae(["@vscode/windows-process-tree"],c,b)})),this._currentRequest=new Promise(c=>{h.getProcessTree(this._rootProcessId,b=>{const o=this.traverseTree(b);this._currentRequest=void 0,c(o)})}),this._currentRequest)}getShellType(c){switch(c.toLowerCase()){case"cmd.exe":return"cmd";case"powershell.exe":case"pwsh.exe":return"pwsh";case"bash.exe":case"git-cmd.exe":return"gitbash";case"wsl.exe":case"ubuntu.exe":case"ubuntu1804.exe":case"kali.exe":case"debian.exe":case"opensuse-42.exe":case"sles-12.exe":return"wsl";default:return c.match(/python(\d(\.\d{0,2})?)?\.exe/)?"python":void 0}}}e.WindowsShellHelper=s,ye([(0,D.debounce)(500)],s.prototype,"checkShell",null)}),define(de[104],me([0,1,26,11,4,2,5,3,6,24,72,8,85,38,39,103,109,99]),function(ae,e,v,D,E,A,T,P,h,s,w,c,b,o,a,g,d,n){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalProcess=void 0;var f;(function(L){L[L.DataFlushTimeout=250]="DataFlushTimeout",L[L.MaximumShutdownTime=5e3]="MaximumShutdownTime"})(f||(f={}));var C;(function(L){L[L.KillSpawnThrottleInterval=250]="KillSpawnThrottleInterval",L[L.KillSpawnSpacingDuration=50]="KillSpawnSpacingDuration",L[L.WriteInterval=5]="WriteInterval"})(C||(C={}));const i=new Map([["bash","bash"],["csh","csh"],["fish","fish"],["ksh","ksh"],["sh","sh"],["pwsh","pwsh"],["python","python"],["zsh","zsh"]]);let t=class extends A.Disposable{static{r=this}static{this._lastKillOrStart=0}get exitMessage(){return this._exitMessage}get currentTitle(){return this._windowsShellHelper?.shellTitle||this._currentTitle}get shellType(){return P.isWindows?this._windowsShellHelper?.shellType:i.get(this._currentTitle)}get hasChildProcesses(){return this._childProcessMonitor?.hasChildProcesses||!1}constructor(p,k,S,y,U,K,z,O,m){super(),this.shellLaunchConfig=p,this._executableEnv=K,this._options=z,this._logService=O,this._productService=m,this.id=0,this.shouldPersist=!1,this._properties={cwd:"",initialCwd:"",fixedDimensions:{cols:void 0,rows:void 0},title:"",shellType:void 0,hasChildProcesses:!0,resolvedShellLaunchConfig:{},overrideDimensions:void 0,failedShellIntegrationActivation:!1,usedShellIntegrationInjection:void 0},this._currentTitle="",this._titleInterval=null,this._writeQueue=[],this._isPtyPaused=!1,this._unacknowledgedCharCount=0,this._onProcessData=this._register(new E.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new E.Emitter),this.onProcessReady=this._onProcessReady.event,this._onDidChangeProperty=this._register(new E.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new E.Emitter),this.onProcessExit=this._onProcessExit.event;let R;P.isWindows?R=T.basename(this.shellLaunchConfig.executable||""):R="xterm-256color",this._initialCwd=k,this._properties.initialCwd=this._initialCwd,this._properties.cwd=this._initialCwd;const _=this._options.windowsEnableConpty&&process.platform==="win32"&&(0,a.getWindowsBuildNumber)()>=18309;this._ptyOptions={name:R,cwd:k,env:U,cols:S,rows:y,useConpty:_,conptyInheritCursor:_&&!!p.initialText},P.isWindows&&(_&&S===0&&y===0&&this.shellLaunchConfig.executable?.endsWith("Git\\bin\\bash.exe")&&(this._delayedResizer=new l,this._register(this._delayedResizer.onTrigger(I=>{this._delayedResizer?.dispose(),this._delayedResizer=void 0,I.cols&&I.rows&&this.resize(I.cols,I.rows)}))),this.onProcessReady(I=>{this._windowsShellHelper=this._register(new g.WindowsShellHelper(I.pid)),this._register(this._windowsShellHelper.onShellTypeChanged(G=>this._onDidChangeProperty.fire({type:"shellType",value:G}))),this._register(this._windowsShellHelper.onShellNameChanged(G=>this._onDidChangeProperty.fire({type:"title",value:G})))})),this._register((0,A.toDisposable)(()=>{this._titleInterval&&(clearInterval(this._titleInterval),this._titleInterval=null)}))}async start(){const k=(await Promise.all([this._validateCwd(),this._validateExecutable()])).find(y=>y!==void 0);if(k)return k;let S;if(this._options.shellIntegration.enabled)if(S=(0,a.getShellIntegrationInjection)(this.shellLaunchConfig,this._options,this._ptyOptions.env,this._logService,this._productService),S){if(this._onDidChangeProperty.fire({type:"usedShellIntegrationInjection",value:!0}),S.envMixin)for(const[y,U]of Object.entries(S.envMixin))this._ptyOptions.env||={},this._ptyOptions.env[y]=U;if(S.filesToCopy)for(const y of S.filesToCopy){await s.Promises.mkdir(T.dirname(y.dest),{recursive:!0});try{await s.Promises.copyFile(y.source,y.dest)}catch{}}}else this._onDidChangeProperty.fire({type:"failedShellIntegrationActivation",value:!0});try{return await this.setupPtyProcess(this.shellLaunchConfig,this._ptyOptions,S),S?.newArgs?{injectedArgs:S.newArgs}:void 0}catch(y){return this._logService.trace("node-pty.node-pty.IPty#spawn native exception",y),{message:`A native exception occurred during launch (${y.message})`}}}async _validateCwd(){try{if(!(await s.Promises.stat(this._initialCwd)).isDirectory())return{message:(0,w.localize)(0,null,this._initialCwd.toString())}}catch(p){if(p?.code==="ENOENT")return{message:(0,w.localize)(1,null,this._initialCwd.toString())}}this._onDidChangeProperty.fire({type:"initialCwd",value:this._initialCwd})}async _validateExecutable(){const p=this.shellLaunchConfig;if(!p.executable)throw new Error("IShellLaunchConfig.executable not set");const k=p.cwd instanceof h.URI?p.cwd.path:p.cwd,S=p.env&&p.env.PATH?p.env.PATH.split(T.delimiter):void 0,y=await(0,a.findExecutable)(p.executable,k,S,this._executableEnv);if(!y)return{message:(0,w.localize)(2,null,p.executable)};try{const U=await s.Promises.stat(y);if(!U.isFile()&&!U.isSymbolicLink())return{message:(0,w.localize)(3,null,p.executable)};p.executable=y}catch(U){if(U?.code!=="EACCES")throw U}}async setupPtyProcess(p,k,S){const y=S?.newArgs||p.args||[];await this._throttleKillSpawn(),this._logService.trace("node-pty.IPty#spawn",p.executable,y,k);const U=(0,d.spawn)(p.executable,y,k);this._ptyProcess=U,this._childProcessMonitor=this._register(new o.ChildProcessMonitor(U.pid,this._logService)),this._childProcessMonitor.onDidChangeHasChildProcesses(K=>this._onDidChangeProperty.fire({type:"hasChildProcesses",value:K})),this._processStartupComplete=new Promise(K=>{this.onProcessReady(()=>K())}),U.onData(K=>{this._unacknowledgedCharCount+=K.length,!this._isPtyPaused&&this._unacknowledgedCharCount>1e5&&(this._logService.trace(`Flow control: Pause (${this._unacknowledgedCharCount} > 100000)`),this._isPtyPaused=!0,U.pause()),this._logService.trace("node-pty.IPty#onData",K),this._onProcessData.fire(K),this._closeTimeout&&this._queueProcessExit(),this._windowsShellHelper?.checkShell(),this._childProcessMonitor?.handleOutput()}),U.onExit(K=>{this._exitCode=K.exitCode,this._queueProcessExit()}),this._sendProcessId(U.pid),this._setupTitlePolling(U)}_setupTitlePolling(p){setTimeout(()=>this._sendProcessTitle(p)),P.isWindows||(this._titleInterval=setInterval(()=>{this._currentTitle!==p.process&&this._sendProcessTitle(p)},200))}_queueProcessExit(){this._logService.getLevel()===c.LogLevel.Trace&&this._logService.trace("TerminalProcess#_queueProcessExit",new Error().stack?.replace(/^Error/,"")),this._closeTimeout&&clearTimeout(this._closeTimeout),this._closeTimeout=setTimeout(()=>{this._closeTimeout=void 0,this._kill()},250)}async _kill(){if(await this._processStartupComplete,!this._store.isDisposed){try{this._ptyProcess&&(await this._throttleKillSpawn(),this._logService.trace("node-pty.IPty#kill"),this._ptyProcess.kill())}catch{}this._onProcessExit.fire(this._exitCode||0),this.dispose()}}async _throttleKillSpawn(){if(!(!P.isWindows||!("useConpty"in this._ptyOptions)||!this._ptyOptions.useConpty)){for(;Date.now()-r._lastKillOrStart<250;)this._logService.trace("Throttling kill/spawn call"),await(0,D.timeout)(250-(Date.now()-r._lastKillOrStart)+50);r._lastKillOrStart=Date.now()}}_sendProcessId(p){this._onProcessReady.fire({pid:p,cwd:this._initialCwd,windowsPty:this.getWindowsPty()})}_sendProcessTitle(p){if(this._store.isDisposed)return;this._currentTitle=p.process,this._onDidChangeProperty.fire({type:"title",value:this._currentTitle});const k=this.currentTitle.replace(/ \(figterm\)$/g,"");k.toLowerCase().startsWith("python")?this._onDidChangeProperty.fire({type:"shellType",value:"python"}):this._onDidChangeProperty.fire({type:"shellType",value:i.get(k)})}shutdown(p){this._logService.getLevel()===c.LogLevel.Trace&&this._logService.trace("TerminalProcess#shutdown",new Error().stack?.replace(/^Error/,"")),p&&!P.isWindows?this._kill():!this._closeTimeout&&!this._store.isDisposed&&(this._queueProcessExit(),setTimeout(()=>{this._closeTimeout&&!this._store.isDisposed&&(this._closeTimeout=void 0,this._kill())},5e3))}input(p,k=!1){this._store.isDisposed||!this._ptyProcess||(this._writeQueue.push(...(0,n.chunkInput)(p).map(S=>({isBinary:k,data:S}))),this._startWrite())}async processBinary(p){this.input(p,!0)}async refreshProperty(p){switch(p){case"cwd":{const k=await this.getCwd();return k!==this._properties.cwd&&(this._properties.cwd=k,this._onDidChangeProperty.fire({type:"cwd",value:this._properties.cwd})),k}case"initialCwd":{const k=await this.getInitialCwd();return k!==this._properties.initialCwd&&(this._properties.initialCwd=k,this._onDidChangeProperty.fire({type:"initialCwd",value:this._properties.initialCwd})),k}case"title":return this.currentTitle;default:return this.shellType}}async updateProperty(p,k){p==="fixedDimensions"&&(this._properties.fixedDimensions=k)}_startWrite(){if(!(this._writeTimeout!==void 0||this._writeQueue.length===0)){if(this._doWrite(),this._writeQueue.length===0){this._writeTimeout=void 0;return}this._writeTimeout=setTimeout(()=>{this._writeTimeout=void 0,this._startWrite()},5)}}_doWrite(){const p=this._writeQueue.shift();this._logService.trace("node-pty.IPty#write",p.data),p.isBinary?this._ptyProcess.write(Buffer.from(p.data,"binary")):this._ptyProcess.write(p.data),this._childProcessMonitor?.handleInput()}resize(p,k){if(!this._store.isDisposed&&!(typeof p!="number"||typeof k!="number"||isNaN(p)||isNaN(k))&&this._ptyProcess){if(p=Math.max(p,1),k=Math.max(k,1),this._delayedResizer){this._delayedResizer.cols=p,this._delayedResizer.rows=k;return}this._logService.trace("node-pty.IPty#resize",p,k);try{this._ptyProcess.resize(p,k)}catch(S){if(this._logService.trace("node-pty.IPty#resize exception "+S.message),this._exitCode!==void 0&&S.message!=="ioctl(2) failed, EBADF"&&S.message!=="Cannot resize a pty that has already exited")throw S}}}clearBuffer(){this._ptyProcess?.clear()}acknowledgeDataEvent(p){this._unacknowledgedCharCount=Math.max(this._unacknowledgedCharCount-p,0),this._logService.trace(`Flow control: Ack ${p} chars (unacknowledged: ${this._unacknowledgedCharCount})`),this._isPtyPaused&&this._unacknowledgedCharCount<5e3&&(this._logService.trace(`Flow control: Resume (${this._unacknowledgedCharCount} < 5000)`),this._ptyProcess?.resume(),this._isPtyPaused=!1)}clearUnacknowledgedChars(){this._unacknowledgedCharCount=0,this._logService.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this._isPtyPaused&&(this._ptyProcess?.resume(),this._isPtyPaused=!1)}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve(this._initialCwd)}async getCwd(){if(P.isMacintosh)return new Promise(p=>{if(!this._ptyProcess){p(this._initialCwd);return}this._logService.trace("node-pty.IPty#pid"),(0,v.exec)("lsof -OPln -p "+this._ptyProcess.pid+" | grep cwd",{env:{...process.env,LANG:"en_US.UTF-8"}},(k,S,y)=>{!k&&S!==""?p(S.substring(S.indexOf("/"),S.length-1)):(this._logService.error("lsof did not run successfully, it may not be on the $PATH?",k,S,y),p(this._initialCwd))})});if(P.isLinux){if(!this._ptyProcess)return this._initialCwd;this._logService.trace("node-pty.IPty#pid");try{return await s.Promises.readlink(`/proc/${this._ptyProcess.pid}/cwd`)}catch{return this._initialCwd}}return this._initialCwd}getWindowsPty(){return P.isWindows?{backend:"useConpty"in this._ptyOptions&&this._ptyOptions.useConpty?"conpty":"winpty",buildNumber:(0,a.getWindowsBuildNumber)()}:void 0}};e.TerminalProcess=t,e.TerminalProcess=t=r=ye([Ne(7,c.ILogService),Ne(8,b.IProductService)],t);class l extends A.Disposable{get onTrigger(){return this._onTrigger.event}constructor(){super(),this._onTrigger=this._register(new E.Emitter),this._timeout=setTimeout(()=>{this._onTrigger.fire({rows:this.rows,cols:this.cols})},1e3),this._register((0,A.toDisposable)(()=>clearTimeout(this._timeout)))}}}),define(de[105],me([0,1,26,11,4,2,3,63,8,96,28,98,37,110,39,104,71,38,97,7,101,100,77,14,111]),function(ae,e,v,D,E,A,T,P,h,s,w,c,b,o,a,g,d,n,r,f,C,i,t,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyService=void 0,e.traceRpc=p;function p(R,_,I){if(typeof I.value!="function")throw new Error("not supported");const G="value",te=I.value;I[G]=async function(...H){this.traceRpcArgs.logService.getLevel()===h.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Request] PtyService#${te.name}(${H.map(le=>JSON.stringify(le)).join(", ")})`),this.traceRpcArgs.simulatedLatency&&await(0,D.timeout)(this.traceRpcArgs.simulatedLatency);let ee;try{ee=await te.apply(this,H)}catch(le){throw this.traceRpcArgs.logService.error(`[RPC Response] PtyService#${te.name}`,le),le}return this.traceRpcArgs.logService.getLevel()===h.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Response] PtyService#${te.name}`,ee),ee}}let k,S;class y extends A.Disposable{_traceEvent(_,I){return I(G=>{this._logService.getLevel()===h.LogLevel.Trace&&this._logService.trace(`[RPC Event] PtyService#${_}.fire(${JSON.stringify(G)})`)}),I}get traceRpcArgs(){return{logService:this._logService,simulatedLatency:this._simulatedLatency}}constructor(_,I,G,te){super(),this._logService=_,this._productService=I,this._reconnectConstants=G,this._simulatedLatency=te,this._ptys=new Map,this._workspaceLayoutInfos=new Map,this._revivedPtyIdMap=new Map,this._autoReplies=new Map,this._lastPtyId=0,this._onHeartbeat=this._register(new E.Emitter),this.onHeartbeat=this._traceEvent("_onHeartbeat",this._onHeartbeat.event),this._onProcessData=this._register(new E.Emitter),this.onProcessData=this._traceEvent("_onProcessData",this._onProcessData.event),this._onProcessReplay=this._register(new E.Emitter),this.onProcessReplay=this._traceEvent("_onProcessReplay",this._onProcessReplay.event),this._onProcessReady=this._register(new E.Emitter),this.onProcessReady=this._traceEvent("_onProcessReady",this._onProcessReady.event),this._onProcessExit=this._register(new E.Emitter),this.onProcessExit=this._traceEvent("_onProcessExit",this._onProcessExit.event),this._onProcessOrphanQuestion=this._register(new E.Emitter),this.onProcessOrphanQuestion=this._traceEvent("_onProcessOrphanQuestion",this._onProcessOrphanQuestion.event),this._onDidRequestDetach=this._register(new E.Emitter),this.onDidRequestDetach=this._traceEvent("_onDidRequestDetach",this._onDidRequestDetach.event),this._onDidChangeProperty=this._register(new E.Emitter),this.onDidChangeProperty=this._traceEvent("_onDidChangeProperty",this._onDidChangeProperty.event),this._register((0,A.toDisposable)(()=>{for(const H of this._ptys.values())H.shutdown(!0);this._ptys.clear()})),this._detachInstanceRequestStore=this._register(new s.RequestStore(void 0,this._logService)),this._detachInstanceRequestStore.onCreateRequest(this._onDidRequestDetach.fire,this._onDidRequestDetach)}async refreshIgnoreProcessNames(_){n.ignoreProcessNames.length=0,n.ignoreProcessNames.push(..._)}async requestDetachInstance(_,I){return this._detachInstanceRequestStore.createRequest({workspaceId:_,instanceId:I})}async acceptDetachInstanceReply(_,I){let G;const te=this._ptys.get(I);te&&(G=await this._buildProcessDetails(I,te)),this._detachInstanceRequestStore.acceptReply(_,G)}async freePortKillProcess(_){const G=(await new Promise((te,H)=>{(0,v.exec)(T.isWindows?`netstat -ano | findstr "${_}"`:`lsof -nP -iTCP -sTCP:LISTEN | grep ${_}`,{},(ee,le)=>{if(ee)return H("Problem occurred when listing active processes");te(le)})})).split(/\r?\n/).filter(te=>!!te.trim());if(G.length>=1){const te=/\s+(\d+)(?:\s+|$)/,H=G[0].match(te)?.[1];if(H)try{process.kill(Number.parseInt(H))}catch{}else throw new Error(`Processes for port ${_} were not found`);return{port:_,processId:H}}throw new Error(`Could not kill process with port ${_}`)}async serializeTerminalState(_){const I=[];for(const[te,H]of this._ptys.entries())H.hasWrittenData&&_.indexOf(te)!==-1&&I.push(D.Promises.withAsyncBody(async ee=>{ee({id:te,shellLaunchConfig:H.shellLaunchConfig,processDetails:await this._buildProcessDetails(te,H),processLaunchConfig:H.processLaunchOptions,unicodeVersion:H.unicodeVersion,replayEvent:await H.serializeNormalBuffer(),timestamp:Date.now()})}));const G={version:1,state:await Promise.all(I)};return JSON.stringify(G)}async reviveTerminalProcesses(_,I,G){const te=[];for(const H of I)te.push(this._reviveTerminalProcess(_,H));await Promise.all(te)}async _reviveTerminalProcess(_,I){const G=(0,d.localize)(0,null),te=await this.createProcess({...I.shellLaunchConfig,cwd:I.processDetails.cwd,color:I.processDetails.color,icon:I.processDetails.icon,name:I.processDetails.titleSource===w.TitleEventSource.Api?I.processDetails.title:void 0,initialText:I.replayEvent.events[0].data+(0,i.formatMessageForTerminal)(G,{loudFormatting:!0})},I.processDetails.cwd,I.replayEvent.events[0].cols,I.replayEvent.events[0].rows,I.unicodeVersion,I.processLaunchConfig.env,I.processLaunchConfig.executableEnv,I.processLaunchConfig.options,!0,I.processDetails.workspaceId,I.processDetails.workspaceName,!0,I.replayEvent.events[0].data),H=this._getRevivingProcessId(_,I.id);this._revivedPtyIdMap.set(H,{newId:te,state:I}),this._logService.info(`Revived process, old id ${H} -> new id ${te}`)}async shutdownAll(){this.dispose()}async createProcess(_,I,G,te,H,ee,le,ue,V,$,Q,Y,fe){if(_.attachPersistentProcess)throw new Error("Attempt to create a process when attach object was provided");const W=++this._lastPtyId,ce=new g.TerminalProcess(_,I,G,te,ee,le,ue,this._logService,this._productService),J={env:ee,executableEnv:le,options:ue},u=new K(W,ce,$,Q,V,G,te,J,H,this._reconnectConstants,this._logService,Y&&typeof _.initialText=="string"?_.initialText:void 0,fe,_.icon,_.color,_.name,_.fixedDimensions);return ce.onProcessExit(N=>{u.dispose(),this._ptys.delete(W),this._onProcessExit.fire({id:W,event:N})}),u.onProcessData(N=>this._onProcessData.fire({id:W,event:N})),u.onProcessReplay(N=>this._onProcessReplay.fire({id:W,event:N})),u.onProcessReady(N=>this._onProcessReady.fire({id:W,event:N})),u.onProcessOrphanQuestion(()=>this._onProcessOrphanQuestion.fire({id:W})),u.onDidChangeProperty(N=>this._onDidChangeProperty.fire({id:W,property:N})),u.onPersistentProcessReady(()=>{for(const N of this._autoReplies.entries())u.installAutoReply(N[0],N[1])}),this._ptys.set(W,u),W}async attachToProcess(_){try{await this._throwIfNoPty(_).attach(),this._logService.info(`Persistent process reconnection "${_}"`)}catch(I){throw this._logService.warn(`Persistent process reconnection "${_}" failed`,I.message),I}}async updateTitle(_,I,G){this._throwIfNoPty(_).setTitle(I,G)}async updateIcon(_,I,G,te){this._throwIfNoPty(_).setIcon(I,G,te)}async clearBuffer(_){this._throwIfNoPty(_).clearBuffer()}async refreshProperty(_,I){return this._throwIfNoPty(_).refreshProperty(I)}async updateProperty(_,I,G){return this._throwIfNoPty(_).updateProperty(I,G)}async detachFromProcess(_,I){return this._throwIfNoPty(_).detach(I)}async reduceConnectionGraceTime(){for(const _ of this._ptys.values())_.reduceGraceTime()}async listProcesses(){const _=Array.from(this._ptys.entries()).filter(([te,H])=>H.shouldPersistTerminal);this._logService.info(`Listing ${_.length} persistent terminals, ${this._ptys.size} total terminals`);const I=_.map(async([te,H])=>this._buildProcessDetails(te,H));return(await Promise.all(I)).filter(te=>te.isOrphan)}async getPerformanceMarks(){return L.getMarks()}async start(_){const I=this._ptys.get(_);return I?I.start():{message:`Could not find pty with id "${_}"`}}async shutdown(_,I){return this._ptys.get(_)?.shutdown(I)}async input(_,I){return this._throwIfNoPty(_).input(I)}async processBinary(_,I){return this._throwIfNoPty(_).writeBinary(I)}async resize(_,I,G){return this._throwIfNoPty(_).resize(I,G)}async getInitialCwd(_){return this._throwIfNoPty(_).getInitialCwd()}async getCwd(_){return this._throwIfNoPty(_).getCwd()}async acknowledgeDataEvent(_,I){return this._throwIfNoPty(_).acknowledgeDataEvent(I)}async setUnicodeVersion(_,I){return this._throwIfNoPty(_).setUnicodeVersion(I)}async getLatency(){return[]}async orphanQuestionReply(_){return this._throwIfNoPty(_).orphanQuestionReply()}async installAutoReply(_,I){this._autoReplies.set(_,I);for(const G of this._ptys.values())G.installAutoReply(_,I)}async uninstallAllAutoReplies(){for(const _ of this._autoReplies.keys())for(const I of this._ptys.values())I.uninstallAutoReply(_)}async uninstallAutoReply(_){for(const I of this._ptys.values())I.uninstallAutoReply(_)}async getDefaultSystemShell(_=T.OS){return(0,P.getSystemShell)(_,process.env)}async getEnvironment(){return{...process.env}}async getWslPath(_,I){if(I==="win-to-unix"){if(!T.isWindows)return _;if((0,a.getWindowsBuildNumber)()<17063)return _.replace(/\\/g,"/");const G=this._getWSLExecutablePath();return G?new Promise(te=>{(0,v.execFile)(G,["-e","wslpath",_],{},(ee,le,ue)=>{te(ee?_:(0,b.escapeNonWindowsPath)(le.trim()))}).stdin.end()}):_}if(I==="unix-to-win"&&T.isWindows){if((0,a.getWindowsBuildNumber)()<17063)return _;const G=this._getWSLExecutablePath();return G?new Promise(te=>{(0,v.execFile)(G,["-e","wslpath","-w",_],{},(ee,le,ue)=>{te(ee?_:le.trim())}).stdin.end()}):_}return _}_getWSLExecutablePath(){const _=(0,a.getWindowsBuildNumber)()>=16299,I=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),G=process.env.SystemRoot;if(G)return(0,t.join)(G,I?"Sysnative":"System32",_?"wsl.exe":"bash.exe")}async getRevivedPtyNewId(_,I){try{return this._revivedPtyIdMap.get(this._getRevivingProcessId(_,I))?.newId}catch(G){this._logService.warn(`Couldn't find terminal ID ${_}-${I}`,G.message)}}async setTerminalLayoutInfo(_){this._workspaceLayoutInfos.set(_.workspaceId,_)}async getTerminalLayoutInfo(_){L.mark("code/willGetTerminalLayoutInfo");const I=this._workspaceLayoutInfos.get(_.workspaceId);if(I){const G=new Set,H=(await Promise.all(I.tabs.map(async ee=>this._expandTerminalTab(_.workspaceId,ee,G)))).filter(ee=>ee.terminals.length>0);return L.mark("code/didGetTerminalLayoutInfo"),{tabs:H}}L.mark("code/didGetTerminalLayoutInfo")}async _expandTerminalTab(_,I,G){const H=(await Promise.all(I.terminals.map(ee=>this._expandTerminalInstance(_,ee,G)))).filter(ee=>ee.terminal!==null);return{isActive:I.isActive,activePersistentProcessId:I.activePersistentProcessId,terminals:H}}async _expandTerminalInstance(_,I,G){try{const te=this._getRevivingProcessId(_,I.terminal),H=this._revivedPtyIdMap.get(te)?.newId;this._logService.info(`Expanding terminal instance, old id ${te} -> new id ${H}`),this._revivedPtyIdMap.delete(te);const ee=H??I.terminal;if(G.has(ee))throw new Error(`Terminal ${ee} has already been expanded`);G.add(ee);const le=this._throwIfNoPty(ee);return{terminal:{...le&&await this._buildProcessDetails(I.terminal,le,H!==void 0),id:ee},relativeSize:I.relativeSize}}catch(te){return this._logService.warn("Couldn't get layout info, a terminal was probably disconnected",te.message),this._logService.debug("Reattach to wrong terminal debug info - layout info by id",I),this._logService.debug("Reattach to wrong terminal debug info - _revivePtyIdMap",Array.from(this._revivedPtyIdMap.values())),this._logService.debug("Reattach to wrong terminal debug info - _ptys ids",Array.from(this._ptys.keys())),{terminal:null,relativeSize:I.relativeSize}}}_getRevivingProcessId(_,I){return`${_}-${I}`}async _buildProcessDetails(_,I,G=!1){L.mark(`code/willBuildProcessDetails/${_}`);const[te,H]=await Promise.all([I.getCwd(),G?!0:I.isOrphaned()]),ee={id:_,title:I.title,titleSource:I.titleSource,pid:I.pid,workspaceId:I.workspaceId,workspaceName:I.workspaceName,cwd:te,isOrphan:H,icon:I.icon,color:I.color,fixedDimensions:I.fixedDimensions,environmentVariableCollections:I.processLaunchOptions.options.environmentVariableCollections,reconnectionProperties:I.shellLaunchConfig.reconnectionProperties,waitOnExit:I.shellLaunchConfig.waitOnExit,hideFromUser:I.shellLaunchConfig.hideFromUser,isFeatureTerminal:I.shellLaunchConfig.isFeatureTerminal,type:I.shellLaunchConfig.type,hasChildProcesses:I.hasChildProcesses,shellIntegrationNonce:I.processLaunchOptions.options.shellIntegration.nonce};return L.mark(`code/didBuildProcessDetails/${_}`),ee}_throwIfNoPty(_){const I=this._ptys.get(_);if(!I)throw new f.ErrorNoTelemetry("Could not find pty on pty host");return I}}e.PtyService=y,ye([l.memoize],y.prototype,"traceRpcArgs",null),ye([p],y.prototype,"refreshIgnoreProcessNames",null),ye([p],y.prototype,"requestDetachInstance",null),ye([p],y.prototype,"acceptDetachInstanceReply",null),ye([p],y.prototype,"freePortKillProcess",null),ye([p],y.prototype,"serializeTerminalState",null),ye([p],y.prototype,"reviveTerminalProcesses",null),ye([p],y.prototype,"shutdownAll",null),ye([p],y.prototype,"createProcess",null),ye([p],y.prototype,"attachToProcess",null),ye([p],y.prototype,"updateTitle",null),ye([p],y.prototype,"updateIcon",null),ye([p],y.prototype,"clearBuffer",null),ye([p],y.prototype,"refreshProperty",null),ye([p],y.prototype,"updateProperty",null),ye([p],y.prototype,"detachFromProcess",null),ye([p],y.prototype,"reduceConnectionGraceTime",null),ye([p],y.prototype,"listProcesses",null),ye([p],y.prototype,"getPerformanceMarks",null),ye([p],y.prototype,"start",null),ye([p],y.prototype,"shutdown",null),ye([p],y.prototype,"input",null),ye([p],y.prototype,"processBinary",null),ye([p],y.prototype,"resize",null),ye([p],y.prototype,"getInitialCwd",null),ye([p],y.prototype,"getCwd",null),ye([p],y.prototype,"acknowledgeDataEvent",null),ye([p],y.prototype,"setUnicodeVersion",null),ye([p],y.prototype,"getLatency",null),ye([p],y.prototype,"orphanQuestionReply",null),ye([p],y.prototype,"installAutoReply",null),ye([p],y.prototype,"uninstallAllAutoReplies",null),ye([p],y.prototype,"uninstallAutoReply",null),ye([p],y.prototype,"getDefaultSystemShell",null),ye([p],y.prototype,"getEnvironment",null),ye([p],y.prototype,"getWslPath",null),ye([p],y.prototype,"getRevivedPtyNewId",null),ye([p],y.prototype,"setTerminalLayoutInfo",null),ye([p],y.prototype,"getTerminalLayoutInfo",null);var U;(function(R){R.None="None",R.ReplayOnly="ReplayOnly",R.Session="Session"})(U||(U={}));class K extends A.Disposable{get pid(){return this._pid}get shellLaunchConfig(){return this._terminalProcess.shellLaunchConfig}get hasWrittenData(){return this._interactionState.value!=="None"}get title(){return this._title||this._terminalProcess.currentTitle}get titleSource(){return this._titleSource}get icon(){return this._icon}get color(){return this._color}get fixedDimensions(){return this._fixedDimensions}get hasChildProcesses(){return this._terminalProcess.hasChildProcesses}setTitle(_,I){I===w.TitleEventSource.Api&&(this._interactionState.setValue("Session","setTitle"),this._serializer.freeRawReviveBuffer()),this._title=_,this._titleSource=I}setIcon(_,I,G){(!this._icon||"id"in I&&"id"in this._icon&&I.id!==this._icon.id||!this.color||G!==this._color)&&(this._serializer.freeRawReviveBuffer(),_&&this._interactionState.setValue("Session","setIcon")),this._icon=I,this._color=G}_setFixedDimensions(_){this._fixedDimensions=_}constructor(_,I,G,te,H,ee,le,ue,V,$,Q,Y,fe,W,ce,J,u){super(),this._persistentProcessId=_,this._terminalProcess=I,this.workspaceId=G,this.workspaceName=te,this.shouldPersistTerminal=H,this.processLaunchOptions=ue,this.unicodeVersion=V,this._logService=Q,this._icon=W,this._color=ce,this._autoReplies=new Map,this._pendingCommands=new Map,this._isStarted=!1,this._orphanRequestQueue=new D.Queue,this._onProcessReplay=this._register(new E.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessReady=this._register(new E.Emitter),this.onProcessReady=this._onProcessReady.event,this._onPersistentProcessReady=this._register(new E.Emitter),this.onPersistentProcessReady=this._onPersistentProcessReady.event,this._onProcessData=this._register(new E.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessOrphanQuestion=this._register(new E.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidChangeProperty=this._register(new E.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._inReplay=!1,this._pid=-1,this._cwd="",this._titleSource=w.TitleEventSource.Process,this._interactionState=new z(`Persistent process "${this._persistentProcessId}" interaction state`,"None",this._logService),this._wasRevived=Y!==void 0,this._serializer=new O(ee,le,$.scrollback,V,Y,ue.options.shellIntegration.nonce,H?fe:void 0,this._logService),J&&this.setTitle(J,w.TitleEventSource.Api),this._fixedDimensions=u,this._orphanQuestionBarrier=null,this._orphanQuestionReplyTime=0,this._disconnectRunner1=this._register(new D.ProcessTimeRunOnceScheduler(()=>{this._logService.info(`Persistent process "${this._persistentProcessId}": The reconnection grace time of ${m($.graceTime)} has expired, shutting down pid "${this._pid}"`),this.shutdown(!0)},$.graceTime)),this._disconnectRunner2=this._register(new D.ProcessTimeRunOnceScheduler(()=>{this._logService.info(`Persistent process "${this._persistentProcessId}": The short reconnection grace time of ${m($.shortGraceTime)} has expired, shutting down pid ${this._pid}`),this.shutdown(!0)},$.shortGraceTime)),this._register(this._terminalProcess.onProcessExit(()=>this._bufferer.stopBuffering(this._persistentProcessId))),this._register(this._terminalProcess.onProcessReady(N=>{this._pid=N.pid,this._cwd=N.cwd,this._onProcessReady.fire(N)})),this._register(this._terminalProcess.onDidChangeProperty(N=>{this._onDidChangeProperty.fire(N)})),this._bufferer=new c.TerminalDataBufferer((N,ie)=>this._onProcessData.fire(ie)),this._register(this._bufferer.startBuffering(this._persistentProcessId,this._terminalProcess.onProcessData)),this._register(this.onProcessData(N=>this._serializer.handleData(N))),this._register((0,A.toDisposable)(()=>{for(const N of this._autoReplies.values())N.dispose();this._autoReplies.clear()}))}async attach(){!this._disconnectRunner1.isScheduled()&&!this._disconnectRunner2.isScheduled()&&this._logService.warn(`Persistent process "${this._persistentProcessId}": Process had no disconnect runners but was an orphan`),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel()}async detach(_){this.shouldPersistTerminal&&(this._interactionState.value!=="None"||_)?this._disconnectRunner1.schedule():this.shutdown(!0)}serializeNormalBuffer(){return this._serializer.generateReplayEvent(!0,this._interactionState.value!=="Session")}async refreshProperty(_){return this._terminalProcess.refreshProperty(_)}async updateProperty(_,I){if(_==="fixedDimensions")return this._setFixedDimensions(I)}async start(){if(!this._isStarted){const _=await this._terminalProcess.start();return _&&"message"in _||(this._isStarted=!0,this._wasRevived?this.triggerReplay():this._onPersistentProcessReady.fire()),_}this._onProcessReady.fire({pid:this._pid,cwd:this._cwd,windowsPty:this._terminalProcess.getWindowsPty()}),this._onDidChangeProperty.fire({type:"title",value:this._terminalProcess.currentTitle}),this._onDidChangeProperty.fire({type:"shellType",value:this._terminalProcess.shellType}),this.triggerReplay()}shutdown(_){return this._terminalProcess.shutdown(_)}input(_){if(this._interactionState.setValue("Session","input"),this._serializer.freeRawReviveBuffer(),!this._inReplay){for(const I of this._autoReplies.values())I.handleInput();return this._terminalProcess.input(_)}}writeBinary(_){return this._terminalProcess.processBinary(_)}resize(_,I){if(!this._inReplay){this._serializer.handleResize(_,I),this._bufferer.flushBuffer(this._persistentProcessId);for(const G of this._autoReplies.values())G.handleResize();return this._terminalProcess.resize(_,I)}}async clearBuffer(){this._serializer.clearBuffer(),this._terminalProcess.clearBuffer()}setUnicodeVersion(_){this.unicodeVersion=_,this._serializer.setUnicodeVersion?.(_)}acknowledgeDataEvent(_){if(!this._inReplay)return this._terminalProcess.acknowledgeDataEvent(_)}getInitialCwd(){return this._terminalProcess.getInitialCwd()}getCwd(){return this._terminalProcess.getCwd()}async triggerReplay(){this._interactionState.value==="None"&&this._interactionState.setValue("ReplayOnly","triggerReplay");const _=await this._serializer.generateReplayEvent();let I=0;for(const G of _.events)I+=G.data.length;this._logService.info(`Persistent process "${this._persistentProcessId}": Replaying ${I} chars and ${_.events.length} size events`),this._onProcessReplay.fire(_),this._terminalProcess.clearUnacknowledgedChars(),this._onPersistentProcessReady.fire()}installAutoReply(_,I){this._autoReplies.get(_)?.dispose(),this._autoReplies.set(_,new r.TerminalAutoResponder(this._terminalProcess,_,I,this._logService))}uninstallAutoReply(_){this._autoReplies.get(_)?.dispose(),this._autoReplies.delete(_)}sendCommandResult(_,I,G){this._pendingCommands.get(_)&&this._pendingCommands.delete(_)}orphanQuestionReply(){if(this._orphanQuestionReplyTime=Date.now(),this._orphanQuestionBarrier){const _=this._orphanQuestionBarrier;this._orphanQuestionBarrier=null,_.open()}}reduceGraceTime(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&this._disconnectRunner2.schedule()}async isOrphaned(){return await this._orphanRequestQueue.queue(async()=>this._isOrphaned())}async _isOrphaned(){return this._disconnectRunner1.isScheduled()||this._disconnectRunner2.isScheduled()?!0:(this._orphanQuestionBarrier||(this._orphanQuestionBarrier=new D.AutoOpenBarrier(4e3),this._orphanQuestionReplyTime=0,this._onProcessOrphanQuestion.fire()),await this._orphanQuestionBarrier.wait(),Date.now()-this._orphanQuestionReplyTime>500)}}class z{get value(){return this._value}setValue(_,I){this._value!==_&&(this._value=_,this._log(I))}constructor(_,I,G){this._name=_,this._value=I,this._logService=G,this._log("initialized")}_log(_){this._logService.debug(`MutationLogger "${this._name}" set to "${this._value}", reason: ${_}`)}}class O{constructor(_,I,G,te,H,ee,le,ue){this._rawReviveBuffer=le,this._xterm=new o.Terminal({cols:_,rows:I,scrollback:G,allowProposedApi:!0}),H&&this._xterm.writeln(H),this.setUnicodeVersion(te),this._shellIntegrationAddon=new C.ShellIntegrationAddon(ee,!0,void 0,ue),this._xterm.loadAddon(this._shellIntegrationAddon)}freeRawReviveBuffer(){this._rawReviveBuffer=void 0}handleData(_){this._xterm.write(_)}handleResize(_,I){this._xterm.resize(_,I)}clearBuffer(){this._xterm.clear()}async generateReplayEvent(_,I){const G=new(await this._getSerializeConstructor());this._xterm.loadAddon(G);const te={scrollback:this._xterm.options.scrollback};_&&(te.excludeAltBuffer=!0,te.excludeModes=!0);let H;return I&&this._rawReviveBuffer?H=this._rawReviveBuffer:H=G.serialize(te),{events:[{cols:this._xterm.cols,rows:this._xterm.rows,data:H}],commands:this._shellIntegrationAddon.serialize()}}async setUnicodeVersion(_){this._xterm.unicode.activeVersion!==_&&(_==="11"?(this._unicodeAddon=new(await this._getUnicode11Constructor()),this._xterm.loadAddon(this._unicodeAddon)):(this._unicodeAddon?.dispose(),this._unicodeAddon=void 0),this._xterm.unicode.activeVersion=_)}async _getUnicode11Constructor(){return S||(S=(await new Promise((_,I)=>{ae(["@xterm/addon-unicode11"],_,I)})).Unicode11Addon),S}async _getSerializeConstructor(){return k||(k=(await new Promise((_,I)=>{ae(["@xterm/addon-serialize"],_,I)})).SerializeAddon),k}}function m(R){let _=0,I=0,G=0;R>=1e3&&(G=Math.floor(R/1e3),R-=G*1e3),G>=60&&(I=Math.floor(G/60),G-=I*60),I>=60&&(_=Math.floor(I/60),I-=_*60);const te=_?`${_}h`:"",H=I?`${I}m`:"",ee=G?`${G}s`:"",le=R?`${R}ms`:"";return`${te}${H}${ee}${le}`}}),define(de[112],me([0,1,60,27,64,65,10,75,78,8,80,81,83,84,28,102,105,31,11,2]),function(ae,e,v,D,E,A,T,P,h,s,w,c,b,o,a,g,d,n,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),C();async function C(){const i=parseInt(process.env.VSCODE_STARTUP_DELAY??"0"),t=parseInt(process.env.VSCODE_LATENCY??"0"),l={graceTime:parseInt(process.env.VSCODE_RECONNECT_GRACE_TIME||"0"),shortGraceTime:parseInt(process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME||"0"),scrollback:parseInt(process.env.VSCODE_RECONNECT_SCROLLBACK||"100")};delete process.env.VSCODE_RECONNECT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SCROLLBACK,delete process.env.VSCODE_LATENCY,delete process.env.VSCODE_STARTUP_DELAY,i&&await(0,r.timeout)(i);const L=(0,n.isUtilityProcess)(process);let p;L?p=new A.Server:p=new E.Server(a.TerminalIpcChannels.PtyHost);const k={_serviceBrand:void 0,...o.default},S=new h.NativeEnvironmentService((0,P.parseArgs)(process.argv,P.OPTIONS),k),y=new b.LoggerService((0,s.getLogLevel)(S),S.logsHome);p.registerChannel(a.TerminalIpcChannels.Logger,new w.LoggerChannel(y,()=>v.DefaultURITransformer));const U=y.createLogger("ptyhost",{name:(0,T.localize)(0,null)}),K=new c.LogService(U);i&&K.warn(`Pty Host startup is delayed ${i}ms`),t&&K.warn(`Pty host is simulating ${t}ms latency`);const z=new f.DisposableStore,O=new g.HeartbeatService;p.registerChannel(a.TerminalIpcChannels.Heartbeat,D.ProxyChannel.fromService(O,z));const m=new d.PtyService(K,k,l,t),R=D.ProxyChannel.fromService(m,z);p.registerChannel(a.TerminalIpcChannels.PtyHost,R),L&&p.registerChannel(a.TerminalIpcChannels.PtyHostWindow,R),process.once("exit",()=>{K.trace("Pty host exiting"),K.dispose(),O.dispose(),m.dispose()})}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a045dcfceda27f896936bfd8cbf524f6a93a2f46/core/vs/platform/terminal/node/ptyHostMain.js.map
